#ifndef BBTree__c_INCLUDED
#define BBTree__c_INCLUDED

#line 340 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/BBTree.xcc"
//
{
  BBTree_ btree1[1];
  BBTree_ btree2[1];
  MyStruct *root1, *node1, *node2, *node3, *node4;
  MyStruct *root2, *node5, *node6;
  //
  BBTree_Ctor(btree1, Memory_Root);
  /* Populate the BBTree 1 */
  root1 = (MyStruct*)BBTree_createNode(btree1,sizeof(MyStruct));
  BBTree_setRoot(btree1,root1);
  root1->x = 0;
  root1->y = 100;
  //
  node1 = (MyStruct*)BBTree_createNode(btree1,sizeof(MyStruct));
  node1->x = 1;
  node1->y = 101;
  //
  node2 = (MyStruct*)BBTree_createNode(btree1,sizeof(MyStruct));
  node2->x = 2;
  node2->y = 102;
  //
  BBTreeNode_attachKids(root1,node1,node2);
  //
  node3 = (MyStruct*)BBTree_createNode(btree1,sizeof(MyStruct));
  node3->x = 3;
  node3->y = 103;
  //
  node4 = (MyStruct*)BBTree_createNode(btree1,sizeof(MyStruct));
  node4->x = 4;
  node4->y = 104;
  //
  BBTreeNode_attachKids(node2,node3,node4);
  //
  printf("Tree #1: COUNT=%d\n",BBTree_COUNT(btree1));
  BBTree_dfs(btree1, dump, stdout);
  //
  BBTree_Ctor(btree2, Memory_Root);
  /* Populate the BBTree 2 */
  root2 = (MyStruct*)BBTree_createNode(btree2,sizeof(MyStruct));
  BBTree_setRoot(btree2,root2);
  root2->x = 5;
  root2->y = 105;
  //
  node5 = (MyStruct*)BBTree_createNode(btree2,sizeof(MyStruct));
  node5->x = 6;
  node5->y = 106;
  //
  node6 = (MyStruct*)BBTree_createNode(btree2,sizeof(MyStruct));
  node6->x = 7;
  node6->y = 107;
  //
  BBTreeNode_attachKids(root2,node5,node6);
  //
  printf("Tree #2: COUNT=%d\n",BBTree_COUNT(btree2));
  BBTree_dfs(btree2, dump, stdout);
  //
  /* Merge the two trees2 */
  BBTree_attachLeftTree(btree1,node3,btree2);
  //
  printf("Tree #1 (after merging): COUNT=%d\n",BBTree_COUNT(btree1));
  BBTree_dfs(btree1, dump, stdout);
  //
  BBTree_Dtor(btree1);
}


#endif//BBTree__c_INCLUDED
