#ifndef REScan_c_INCLUDED
#define REScan_c_INCLUDED

#line 16 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/REScan.xcc"
#include "BSL/BSL_.h"

#line 21 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/REScan.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 45 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/REScan.xcc"
REScan
REScan_Ctor(REScan this, Memory memory, FILE *file)
{
  *REScan__MEMORY(this) = memory;
  *REScan__INPUT(this) = file;
  *REScan__TOKEN(this) = NULL;
  *REScan__LIMIT(this) = NULL;
  *REScan__MARKER(this) = NULL;
  *REScan__CURSOR(this) = NULL;
  *REScan__BASE(this) = NULL;
  *REScan__PAST(this) = NULL;
  *REScan__END(this) = NULL;
  *REScan__LINE(this) = 1;
  *REScan__STATE(this) = -1;
  return this;
}

#line 62 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/REScan.xcc"
void
REScan_Dtor(REScan this)
{
  Memory memory = REScan_MEMORY(this);
  Memory_free(memory, REScan_BASE(this));
}

#line 74 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/REScan.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 80 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/REScan.xcc"
byte *
REScan_fill(REScan this, size_t bsize)
{
  if (REScan_END(this) == NULL) {
    byte *token = REScan_TOKEN(this);
    byte *limit = REScan_LIMIT(this);
    byte *marker = REScan_MARKER(this);
    byte *cursor = REScan_CURSOR(this);
    byte *base = REScan_BASE(this);
    byte *past = REScan_PAST(this);
    size_t count = token - base;
    bsize = MAX(bsize, 1024);
    if (count != 0) {
      // Move data to BASE.
      token = memmove(base, token, limit - token);
      limit -= count;
      marker -= count;
      cursor -= count;
      // Update fields.
      *REScan__TOKEN(this) = token;
      *REScan__LIMIT(this) = limit;
      *REScan__MARKER(this) = marker;
      *REScan__CURSOR(this) = cursor;
    }
    if (past - limit < bsize) {
      // Extend buffer.
      Memory memory = REScan_MEMORY(this);
      size_t size = (limit - base) + bsize;
      byte *alloc = Memory_alloc(memory, size);
      token = memcpy(alloc, token, limit - token);
      limit = alloc + (limit - base);
      marker = alloc + (marker - base);
      cursor = alloc + (cursor - base);
      // Update fields.
      *REScan__TOKEN(this) = token;
      *REScan__LIMIT(this) = limit;
      *REScan__MARKER(this) = marker;
      *REScan__CURSOR(this) = cursor;
      *REScan__BASE(this) = alloc;
      *REScan__PAST(this) = alloc + size;
      Memory_free(memory, base);
    }
    // Read more input.
    count = fread(limit, sizeof(byte), bsize, REScan_INPUT(this));
    if (count == 0) {
      // No more input.
      byte *end = limit;
      *end++ = '\n';
      *REScan__END(this) = end;
    }
    *REScan__LIMIT(this) = limit + count;
  }
  return REScan_CURSOR(this);
}

#line 149 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/REScan.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 151 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/REScan.xcc"
#if XCC__C
const char *
REScan_getToken(REScan this);
#endif//XCC__C

#line 306 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/REScan.xcc"
#if XCC__C
#include "REScan_.re.c"
#endif//#if XCC__C

#line 326 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/REScan.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 338 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/REScan.xcc"
#if XCC__C
static void
REScan_TEST(void)
{
#include "BSL/REScan_.c"
}

#line 345 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/REScan.xcc"
int
main(int argc, char **argv)
{
#if RE2C_ENABLED
  BSL_Test(REScan_TEST);
#endif
  return 0;
}
#endif


#endif//REScan_c_INCLUDED
