
#line 156 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/REScan.xcc"
//
#define	YYCTYPE		byte
#define	YYTOKEN		REScan_TOKEN(this)
#define	YYLIMIT		REScan_LIMIT(this)
#define	YYMARKER	REScan_MARKER(this)
#define	YYCURSOR	REScan_CURSOR(this)
#define	YYFILL(n)	REScan_fill(this, n)
#define YYRETURN(s)	return #s
#define YYDEBUG(state, current) \
                        if (YYCURSOR != NULL) { \
                          fprintf(stderr, "state %d\tcurrent %c\n", state, current); \
                        }
const char *
REScan_getToken(REScan this)
{
/*!re2c
any	= [\000-\377];
O	= [0-7];
D	= [0-9];
L	= [a-zA-Z_];
H	= [a-fA-F0-9];
E	= [Ee] [+-]? D+;
FS	= [fFlL];
IS	= [uUlL]*;
ESC	= [\\] ([abfnrtv?'"\\] | "x" H+ | O+);
*/
std:
  YYTOKEN = YYCURSOR;
/*!re2c
	"/""*"			{ goto comment; }
	
	"auto"			{ YYRETURN(AUTO); }
	"break"			{ YYRETURN(BREAK); }
	"case"			{ YYRETURN(CASE); }
	"char"			{ YYRETURN(CHAR); }
	"const"			{ YYRETURN(CONST); }
	"continue"		{ YYRETURN(CONTINUE); }
	"default"		{ YYRETURN(DEFAULT); }
	"do"			{ YYRETURN(DO); }
	"double"		{ YYRETURN(DOUBLE); }
	"else"			{ YYRETURN(ELSE); }
	"enum"			{ YYRETURN(ENUM); }
	"extern"		{ YYRETURN(EXTERN); }
	"float"			{ YYRETURN(FLOAT); }
	"for"			{ YYRETURN(FOR); }
	"goto"			{ YYRETURN(GOTO); }
	"if"			{ YYRETURN(IF); }
	"int"			{ YYRETURN(INT); }
	"long"			{ YYRETURN(LONG); }
	"register"		{ YYRETURN(REGISTER); }
	"return"		{ YYRETURN(RETURN); }
	"short"			{ YYRETURN(SHORT); }
	"signed"		{ YYRETURN(SIGNED); }
	"sizeof"		{ YYRETURN(SIZEOF); }
	"static"		{ YYRETURN(STATIC); }
	"struct"		{ YYRETURN(STRUCT); }
	"switch"		{ YYRETURN(SWITCH); }
	"typedef"		{ YYRETURN(TYPEDEF); }
	"union"			{ YYRETURN(UNION); }
	"unsigned"		{ YYRETURN(UNSIGNED); }
	"void"			{ YYRETURN(VOID); }
	"volatile"		{ YYRETURN(VOLATILE); }
	"while"			{ YYRETURN(WHILE); }
	
	L (L|D)*		{ YYRETURN(ID); }
	
	("0" [xX] H+ IS?) | ("0" D+ IS?) | (D+ IS?) |
	(['] (ESC|any\[\n\\'])* ['])
				{ YYRETURN(ICON); }
	
	(D+ E FS?) | (D* "." D+ E? FS?) | (D+ "." D* E? FS?)
				{ YYRETURN(FCON); }
	
	(["] (ESC|any\[\n\\"])* ["])
				{ YYRETURN(SCON); }
	
	"..."                   { YYRETURN(ELLIPSIS); }
	">>="			{ YYRETURN(RSHIFTEQ); }
	"<<="			{ YYRETURN(LSHIFTEQ); }
	"+="			{ YYRETURN(ADDEQ); }
	"-="			{ YYRETURN(SUBEQ); }
	"*="			{ YYRETURN(MULEQ); }
	"/="			{ YYRETURN(DIVEQ); }
	"%="			{ YYRETURN(MODEQ); }
	"&="			{ YYRETURN(ANDEQ); }
	"^="			{ YYRETURN(XOREQ); }
	"|="			{ YYRETURN(OREQ); }
	">>"			{ YYRETURN(RSHIFT); }
	"<<"			{ YYRETURN(LSHIFT); }
	"++"			{ YYRETURN(INCR); }
	"--"			{ YYRETURN(DECR); }
	"->"			{ YYRETURN(DEREF); }
	"&&"			{ YYRETURN(ANDAND); }
	"||"			{ YYRETURN(OROR); }
	"<="			{ YYRETURN(LEQ); }
	">="			{ YYRETURN(GEQ); }
	"=="			{ YYRETURN(EQL); }
	"!="			{ YYRETURN(NEQ); }
	";"			{ YYRETURN(';'); }
	"{"			{ YYRETURN('{'); }
	"}"			{ YYRETURN('}'); }
	","			{ YYRETURN(','); }
	":"			{ YYRETURN(':'); }
	"="			{ YYRETURN('='); }
	"("			{ YYRETURN('('); }
	")"			{ YYRETURN(')'); }
	"["			{ YYRETURN('['); }
	"]"			{ YYRETURN(']'); }
	"."			{ YYRETURN('.'); }
	"&"			{ YYRETURN('&'); }
	"!"			{ YYRETURN('!'); }
	"~"			{ YYRETURN('~'); }
	"-"			{ YYRETURN('-'); }
	"+"			{ YYRETURN('+'); }
	"*"			{ YYRETURN('*'); }
	"/"			{ YYRETURN('/'); }
	"%"			{ YYRETURN('%'); }
	"<"			{ YYRETURN('<'); }
	">"			{ YYRETURN('>'); }
	"^"			{ YYRETURN('^'); }
	"|"			{ YYRETURN('|'); }
	"?"			{ YYRETURN('?'); }
	[ \t\v\f]+		{ goto std; }
	"\n"
	    {
		if (REScan_atEnd(this)) return "";
                REScan_incLine(this);
		goto std;
	    }
	any
	    {
		printf("unexpected:\t%c\n", yych);
		goto std;
	    }
*/
//
comment:
/*!re2c
	"*""/"			{ goto std; }
	"\n"
	    {
		if (REScan_atEnd(this)) return "";
                REScan_incLine(this);
		goto comment;
	    }
        any			{ goto comment; }
*/
  return "";
}
