#ifndef String__c_INCLUDED
#define String__c_INCLUDED

#line 363 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/String.xcc"
//
{
  printf("sizeof(StringTable_) = %d\n", sizeof(StringTable_));
}

#line 631 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/String.xcc"
//
{
  int32_t i, j, *k;
  StringTable_ stringTable[1];
  StringTable_Ctor(stringTable, Memory_Root, true);
#define NumItems 500
  printf("Insert:\n");
  for (i = 0, j = 0; i < NumItems; i++, j = (j + 7)%NumItems) {
    StringTable_insert(stringTable, &j, 4);
    k = (int32_t *)StringTable_search(stringTable, &j, 4);
    if (!k || *k != j) printf("Error0 at %d\n", j);
  }
  printf("String count = %d\n", StringTable_COUNT(stringTable));
  for (j = 0; j < 2; j++) {
    for (i = 0; i < NumItems; i++) {
      k = (int32_t *)StringTable_search(stringTable, &i, 4);
      if (!k || *k != i) printf("Error1 at %d\n", i);
    }
  }
  printf("Remove:\n");
  for (i = 0; i < NumItems; i += 2) {
    if (StringTable_remove(stringTable, &i, 4));
    else printf("Error3 at %d\n", i);
  }
  for (i = 1; i < NumItems; i += 2) {
    k = (int32_t *)StringTable_search(stringTable, &i, 4);
    if (!k || *k != i) printf("Error4 at %d\n", i);
  }
  for (i = 0; i < NumItems; i += 2) {
    k = (int32_t *)StringTable_search(stringTable, &i, 4);
    if (k) printf("Error5 at %d\n", i);
  }
  printf("String count = %d\n", StringTable_COUNT(stringTable));
  for (i = 1; i < NumItems; i += 2) {
    if (StringTable_remove(stringTable, &i, 4));
    else printf("Error6 at %d\n", i);
  }
  printf("String count = %d\n", StringTable_COUNT(stringTable));
  StringTable_Dtor(stringTable);
}

#line 717 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/String.xcc"
//
{
  StringTableEntry_cmpCount = 0;
  StringTable_test(true);
  StringTable_test(false);
  printf("CMP count = %d\n", StringTableEntry_cmpCount);
}

#line 762 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/String.xcc"
//
{
  const char *string = "BSL Library";
  StringTable_ table[1];
  StringTable_Ctor(table, Memory_Root, true);
  {
    String name = StringTable_S(table, string);
    String number = StringTable_D(table, 1+0);
    printf("name\t%s\n", name);
    printf("number\t%s\n", number);
  }
  StringTable_Dtor(table);
}

#line 886 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/String.xcc"
//
{
  StringStore_ stringStore[1];
  StringStore_Ctor(stringStore, Memory_Root);
  StringStore_S(stringStore, "this is the end...");
  StringStore_S(stringStore, "when the music's over");
  StringStore_FOREACH_String(stringStore, string) {
    printf("String:\t%s\n", string);
  } StringStore_ENDEACH_String;
  StringStore_Dtor(stringStore);
}


#endif//String__c_INCLUDED
