#ifndef XMLCan_c_INCLUDED
#define XMLCan_c_INCLUDED

#line 16 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
#include "BSL/BSL_.h"

#line 21 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 39 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
XMLCanBuffer
XMLCanBuffer_Ctor(XMLCanBuffer this,
                  Memory memory, FILE *input, size_t size)
{
  char *data = Memory_alloc(memory, size + 8);
  *XMLCanBuffer__MEMORY(this) = memory;
  *XMLCanBuffer__INPUT(this) = input;
  *XMLCanBuffer__SIZE(this) = size;
  *XMLCanBuffer__DATA(this) = data;
  *XMLCanBuffer__START(this) = data;
  *XMLCanBuffer__PAST(this) = data;
  return this;
}

#line 53 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
void
XMLCanBuffer_Dtor(XMLCanBuffer this)
{
  Memory memory = XMLCanBuffer_MEMORY(this);
  Memory_free(memory, XMLCanBuffer_DATA(this));
}

#line 60 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
size_t
XMLCanBuffer_Size(Memory memory, FILE *input, size_t size)
{
  return sizeof(XMLCanBuffer_);
}

#line 66 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
static bool
XMLCanBuffer_check(XMLCanBuffer this)
{
  Except_ALWAYS(XMLCanBuffer_DATA(this) <= XMLCanBuffer_START(this));
  Except_ALWAYS(XMLCanBuffer_START(this) <= XMLCanBuffer_DATA(this) + XMLCanBuffer_SIZE(this) + 8);
  Except_ALWAYS(XMLCanBuffer_PAST(this) <= XMLCanBuffer_DATA(this) + XMLCanBuffer_SIZE(this) + 8);
  return true;
}

#line 81 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
void
XMLCanBuffer_prefill(XMLCanBuffer this, const char *str)
{
  size_t length = strlen(str);
  char *data = XMLCanBuffer_DATA(this);
  size_t size = XMLCanBuffer_SIZE(this);
  Except_CHECK(length <= size);
  *XMLCanBuffer__START(this) = memcpy(data, str, length + 1);
  *XMLCanBuffer__PAST(this) = data + length;
}

#line 98 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
intptr_t
XMLCanBuffer_refill(XMLCanBuffer this)
{
  intptr_t readCount = 0;
  FILE *input = XMLCanBuffer_INPUT(this);
  size_t size = XMLCanBuffer_SIZE(this);
  char *data = XMLCanBuffer_DATA(this);
  char *start = XMLCanBuffer_START(this);
  char *past = XMLCanBuffer_PAST(this);
  intptr_t inUse = past - start;
  Except_DEBUG(XMLCanBuffer_check(this));
  if (inUse <= 0) inUse = 0;
  else memmove(data, start, inUse);
  if (input != NULL) {
    readCount = fread(data + inUse, 1, size - inUse, input);
  }
  if (readCount > 0) {
    *XMLCanBuffer__START(this) = data;
    *XMLCanBuffer__PAST(this) = data + inUse + readCount;
    *XMLCanBuffer_PAST(this) = '\0';
  }
  return readCount;
}

#line 200 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
XMLCan
XMLCan_Ctor(XMLCan this,
            XMLCanBuffer buffer,
            int (*lookup)(struct XMLCan_ *this, const char *name), XMLCanFlags flags)
{
  *XMLCan__BUFFER(this) = buffer;
  *XMLCan__LOOKUP(this) = lookup;
  *XMLCan__ERROR(this) = NULL;
  *XMLCan__LINE(this) = 1;
  *XMLCan__TEXT(this) = NULL;
  *XMLCan__SIZE(this) = 0;
  *XMLCan__FLAGS(this) = flags;
  *XMLCan__EXPECT(this) = XMLCanEvent__;
  *XMLCan__EVENT(this) = XMLCanEvent__;
  *XMLCan__SAVED(this) = '\0';
  *XMLCan__QUOTE(this) = '\0';
  *XMLCan__DEPTH(this) = 0;
  XMLCanCharacterClass_Ctor();
  return this;
}

#line 221 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
void
XMLCan_Dtor(XMLCan this)
{
  memset(this, -1, sizeof(XMLCan_));
}

#line 227 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
size_t
XMLCan_Size(XMLCanBuffer buffer,
            int (*lookup)(struct XMLCan_ *this, const char *name), XMLCanFlags flags)
{
  return sizeof(XMLCan_);
}

#line 234 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
typedef enum {
  XMLCanCharacter_WhiteSpace = 0x1,
  XMLCanCharacter_NameStart = 0x2,
  XMLCanCharacter_NameChar = 0x4,
  XMLCanCharacter_DecChar = 0x8,
  XMLCanCharacter_HexChar = 0x10,
  XMLCanCharacter__
} XMLCanCharacter;

#line 243 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
static uint8_t XMLCanCharacterClass[256];

#line 249 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
void
XMLCanCharacterClass_Ctor(void)
{
  int count = sizeof(XMLCanCharacterClass)/sizeof(XMLCanCharacterClass[0]), c;
  if (XMLCanCharacterClass[0x9] != 0) return;
  for (c = 0; c < count; c++) {
    if ((c) == 0x9 ||
        (c) == 0xA ||
        (c) == 0xD ||
        (c) == 0x20) {
      XMLCanCharacterClass[c] |= XMLCanCharacter_WhiteSpace;
    }
    if ((c) == ':' ||
        ((c) >= 'A' && (c) <= 'Z') ||
        (c) == '_' ||
        ((c) >= 'a' && (c) <= 'z') ||
        ((c) >= 0xC0 && (c) <= 0xD6) ||
        ((c) >= 0xD8 && (c) <= 0xF6) ||
        ((c) >= 0xF8 && (c) <= 0x2FF)) {
      XMLCanCharacterClass[c] |= XMLCanCharacter_NameStart;
      XMLCanCharacterClass[c] |= XMLCanCharacter_NameChar;
    }
    if ((c) == '-' ||
        (c) == '.' ||
        ((c) >= '0' && (c) <= '9') ||
        (c) == 0xB7) {
      XMLCanCharacterClass[c] |= XMLCanCharacter_NameChar;
    }
    if ((c) >= '0' && (c) <= '9') {
      XMLCanCharacterClass[c] |= XMLCanCharacter_DecChar;
      XMLCanCharacterClass[c] |= XMLCanCharacter_HexChar;
    }
    if (((c) >= 'A' && (c) <= 'F') ||
        ((c) >= 'a' && (c) <= 'f')) {
      XMLCanCharacterClass[c] |= XMLCanCharacter_HexChar;
    }
  }
}

#line 310 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
size_t
XMLCan_normalizeWhiteSpace(const_XMLCan this, char *text, size_t size)
{
  XMLCanFlags flags = XMLCan_FLAGS(this);
  bool trim = (flags & XMLCanFlag_Trim) != 0;
  bool skipStore = trim;
  char *dest = text;
  int i = 0;
  for (; i < size; i++) {
    char current = text[i];
    if (XMLCanIsWhiteSpace(current)) {
      if (!skipStore) {
        *dest++ = ' ';
      }
      skipStore = true;
    } else {
      *dest++ = current;
      skipStore = false;
    }
  }
  if (trim) {
    if (dest[-1] == ' ') --dest;
  }
  return dest - text;
}

#line 358 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
int
XMLCan_lookupEntity(XMLCan this, const char *name, size_t size)
{
  int value = -1, i;
  if (size == 2 && name[0] == 'l' && name[1] == 't') return 60;
  if (size == 2 && name[0] == 'g' && name[1] == 't') return 62;
  if (size == 3 && name[0] == 'a' && name[1] == 'm' && name[2] == 'p') return 38;
  if (size == 4 && name[0] == 'a' && name[1] == 'p' && name[2] == 'o' && name[3] == 's') return 39;
  if (size == 4 && name[0] == 'q' && name[1] == 'u' && name[2] == 'o' && name[3] == 't') return 34;
  if (name[0] == '#') {
    if (name[1] == 'x') {
      for (i = 2; i < size; i++) {
        if (!XMLCanIsHexChar(name[i])) return -1;
      }
      sscanf(name + 2, "%x", &value);
    } else {
      for (i = 1; i < size; i++) {
        if (!XMLCanIsDecChar(name[i])) return -1;
      }
      sscanf(name + 1, "%d", &value);
    }
  } else {
    if (XMLCanIsNameStart(name[0])) {
      int (*lookup)(struct XMLCan_ *this, const char *name) = XMLCan_LOOKUP(this);
      for (i = 1; i < size; i++) {
        if (!XMLCanIsNameChar(name[i])) return -1;
      }
      if (lookup != NULL) {
        value = (*lookup)(this, name);
      }
    }
  }
  return value;
}

#line 399 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
bool
XMLCan_expandEntity(XMLCan this, char *start, char *stop)
{
  int value = -1;
  char *name = start + 1;
  size_t size = stop - name;
  char saved = *stop;
  *stop = '\0';
  value = XMLCan_lookupEntity(this, name, size);
  *stop = saved;
  if (value > 0) {
    // Expand the value using UTF-8 encoding:
    //	bytes | bits | encoding
    //	    1 |    7 | 0vvvvvvv
    //	    2 |   11 | 110vvvvv 10vvvvvv
    //	    3 |   16 | 1110vvvv 10vvvvvv 10vvvvvv
    //	    4 |   21 | 11110vvv 10vvvvvv 10vvvvvv 10vvvvvv
    if (value < 0x80) {
      *start++ = (value);
    } else if (value < 0x800) {
      *start++ = 0xC0 | (value>>6);
      *start++ = 0x80 | (value & 0x3F);
    } else if (value < 0x10000) {
      *start++ = 0xE0 | (value>>12);
      *start++ = 0x80 | (value>>6 & 0x3F);
      *start++ = 0x80 | (value & 0x3F);
    } else if (value < 0x200000) {
      *start++ = 0xF0 | (value>>18);
      *start++ = 0x80 | (value>>12 & 0x3F);
      *start++ = 0x80 | (value>>6 & 0x3F);
      *start++ = 0x80 | (value & 0x3F);
    }
    Except_CHECK(start <= stop + 1);
    // Pad with '\0', that will be later squashed.
    while (start <= stop) *start++ = '\0';
    return true;
  }
  return false;
}

#line 445 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
size_t
XMLCan_expandEntities(XMLCan this, char *text, size_t size)
{
  char *start = NULL;
  int replaced = 0, i = 0;
  for (i = 0; i < size; i++) {
    char current = text[i];
    if (current == '&') {
      start = text + i;
    }
    if (current == ';') {
      if (start != NULL) {
        replaced += XMLCan_expandEntity(this, start, text + i);
      }
      start = NULL;
    }
  }
  if (replaced != 0) {
    char *dest = text;
    for (i = 0; i < size; i++) {
      char current = text[i];
      if (current != '\0') {
        *dest++ = current;
      }
    }
    return dest - text;
  }
  return size;
}

#line 491 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
static void
XMLCan_normalizeCharData(XMLCan this)
{
  XMLCanFlags flags = XMLCan_FLAGS(this);
  if (flags & XMLCanFlag_Raw);
  else {
    char *text = XMLCan_TEXT(this);
    size_t size = XMLCan_SIZE(this);
    size = XMLCan_expandEntities(this, text, size);
    *XMLCan__SIZE(this) = size;
    text[size] = '\0';
  }
}

#line 505 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
static void
XMLCan_normalizeAttValue(XMLCan this)
{
  XMLCanFlags flags = XMLCan_FLAGS(this);
  if (flags & XMLCanFlag_Raw);
  else {
    char *text = XMLCan_TEXT(this);
    size_t size = XMLCan_SIZE(this);
    size = XMLCan_normalizeWhiteSpace(this, text, size);
    size = XMLCan_expandEntities(this, text, size);
    *XMLCan__SIZE(this) = size;
    text[size] = '\0';
  }
}

#line 520 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
static XMLCanEvent
XMLCan_getEvent_expect_STag(XMLCan this, char *pointer, char current)
{
  XMLCanBuffer buffer = XMLCan_BUFFER(this);
  int32_t line = XMLCan_LINE(this);
  char *name = pointer;
  size_t size = 0;
  if (XMLCanIsNameStart(current)) {
    current = *++pointer;
    size++;
  }
  while (XMLCanIsNameChar(current)) {
    current = *++pointer;
    size++;
  }
  while (XMLCanIsWhiteSpace(current)) {
    line += XMLCanIsNewLineChar(current);
    current = *++pointer;
  }
  if (current == '>') {
    name[size] = '\0';
    *XMLCan__NAME(this) = name;
    *XMLCan__SIZE(this) = size;
    *XMLCanBuffer__START(buffer) = pointer + 1;
    *XMLCan__EXPECT(this) = XMLCanEvent__;
    *XMLCan__EVENT(this) = XMLCanEvent_STag;
    *XMLCan__DEPTH(this) += 1;
    *XMLCan__LINE(this) = line;
    return XMLCan_EVENT(this);
  } else if (current != '\0') {
    name[size] = '\0';
    *XMLCan__SAVED(this) = current;
    *XMLCan__NAME(this) = name;
    *XMLCan__SIZE(this) = size;
    *XMLCanBuffer__START(buffer) = pointer;
    *XMLCan__EXPECT(this) = XMLCanEvent_AttName;
    *XMLCan__EVENT(this) = XMLCanEvent_STag;
    *XMLCan__LINE(this) = line;
    return XMLCan_EVENT(this);
  }
  if (current == '\0') {
    // Refill buffer and try again.
    if (XMLCanBuffer_refill(buffer)) {
      return XMLCan_getEvent(this);
    }
  }
  *XMLCan__ERROR(this) = "invalid start tag";
  *XMLCan__EXPECT(this) = XMLCanEvent_Error;
  *XMLCan__EVENT(this) = XMLCanEvent_Error;
  *XMLCan__LINE(this) = line;
  return XMLCan_EVENT(this);
}

#line 573 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
static XMLCanEvent
XMLCan_getEvent_expect_ETag(XMLCan this, char *pointer, char current)
{
  XMLCanBuffer buffer = XMLCan_BUFFER(this);
  int32_t line = XMLCan_LINE(this);
  char *name = pointer;
  size_t size = 0;
  if (XMLCanIsNameStart(current)) {
    current = *++pointer;
    size++;
  }
  while (XMLCanIsNameChar(current)) {
    current = *++pointer;
    size++;
  }
  while (XMLCanIsWhiteSpace(current)) {
    line += XMLCanIsNewLineChar(current);
    current = *++pointer;
  }
  if (current == '>') {
    name[size] = '\0';
    *XMLCan__NAME(this) = name;
    *XMLCan__SIZE(this) = size;
    *XMLCanBuffer__START(buffer) = pointer + 1;
    *XMLCan__EXPECT(this) = XMLCanEvent__;
    *XMLCan__EVENT(this) = XMLCanEvent_ETag;
    *XMLCan__DEPTH(this) -= 1;
    *XMLCan__LINE(this) = line;
    return XMLCan_EVENT(this);
  }
  if (current == '\0') {
    // Refill buffer and try again.
    if (XMLCanBuffer_refill(buffer)) {
      return XMLCan_getEvent(this);
    }
  }
  *XMLCan__ERROR(this) = "invalid end tag";
  *XMLCan__EXPECT(this) = XMLCanEvent_Error;
  *XMLCan__EVENT(this) = XMLCanEvent_Error;
  *XMLCan__LINE(this) = line;
  return XMLCan_EVENT(this);
}

#line 616 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
static XMLCanEvent
XMLCan_getEvent_expect_PI(XMLCan this, char *pointer, char current)
{
  XMLCanBuffer buffer = XMLCan_BUFFER(this);
  int32_t line = XMLCan_LINE(this);
  char *text = pointer;
  while (current != '?' || pointer[1] != '>') {
    if (current == '\0') break;
    line += XMLCanIsNewLineChar(current);
    current = *++pointer;
  }
  if (current != '\0') {
    *pointer = '\0';
    *XMLCan__TEXT(this) = text;
    *XMLCan__SIZE(this) = pointer - text;
    *XMLCanBuffer__START(buffer) = pointer + 2;
    *XMLCan__EXPECT(this) = XMLCanEvent__;
    *XMLCan__EVENT(this) = XMLCanEvent_PI;
    *XMLCan__LINE(this) = line;
    return XMLCan_EVENT(this);
  }
  if (current == '\0') {
    // Refill buffer and try again.
    if (XMLCanBuffer_refill(buffer)) {
      return XMLCan_getEvent(this);
    }
  }
  *XMLCan__ERROR(this) = "invalid processing instruction";
  *XMLCan__EXPECT(this) = XMLCanEvent_Error;
  *XMLCan__EVENT(this) = XMLCanEvent_Error;
  *XMLCan__LINE(this) = line;
  return XMLCan_EVENT(this);
}

#line 650 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
static XMLCanEvent
XMLCan_getEvent_expect_Comment(XMLCan this, char *pointer, char current)
{
  XMLCanBuffer buffer = XMLCan_BUFFER(this);
  int32_t line = XMLCan_LINE(this);
  char *text = pointer;
  while (current != '-' || pointer[1] != '-' || pointer[2] != '>') {
    if (current == '\0') break;
    line += XMLCanIsNewLineChar(current);
    current = *++pointer;
  }
  if (current != '\0') {
    *pointer = '\0';
    *XMLCan__TEXT(this) = text;
    *XMLCan__SIZE(this) = pointer - text;
    *XMLCanBuffer__START(buffer) = pointer + 3;
    *XMLCan__EXPECT(this) = XMLCanEvent__;
    *XMLCan__EVENT(this) = XMLCanEvent_Comment;
    *XMLCan__LINE(this) = line;
    return XMLCan_EVENT(this);
  }
  if (current == '\0') {
    // Refill buffer and try again.
    if (XMLCanBuffer_refill(buffer)) {
      return XMLCan_getEvent(this);
    }
  }
  *XMLCan__ERROR(this) = "runaway comment";
  *XMLCan__EXPECT(this) = XMLCanEvent_Error;
  *XMLCan__EVENT(this) = XMLCanEvent_Error;
  *XMLCan__LINE(this) = line;
  return XMLCan_EVENT(this);
}

#line 684 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
static XMLCanEvent
XMLCan_getEvent_expect_CDATA(XMLCan this, char *pointer, char current)
{
  XMLCanBuffer buffer = XMLCan_BUFFER(this);
  int32_t line = XMLCan_LINE(this);
  char *text = pointer;
  while (current != ']' || pointer[1] != ']' || pointer[2] != '>') {
    if (current == '\0') break;
    line += XMLCanIsNewLineChar(current);
    current = *++pointer;
  }
  if (current != '\0') {
    *pointer = '\0';
    *XMLCan__TEXT(this) = text;
    *XMLCan__SIZE(this) = pointer - text;
    *XMLCanBuffer__START(buffer) = pointer + 3;
    *XMLCan__EXPECT(this) = XMLCanEvent__;
    *XMLCan__EVENT(this) = XMLCanEvent_CDATA;
    *XMLCan__LINE(this) = line;
    return XMLCan_EVENT(this);
  }
  if (current == '\0') {
    // Refill buffer and try again.
    if (XMLCanBuffer_refill(buffer)) {
      return XMLCan_getEvent(this);
    }
  }
  *XMLCan__ERROR(this) = "runaway CDATA section";
  *XMLCan__EXPECT(this) = XMLCanEvent_Error;
  *XMLCan__EVENT(this) = XMLCanEvent_Error;
  *XMLCan__LINE(this) = line;
  return XMLCan_EVENT(this);
}

#line 718 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
static XMLCanEvent
XMLCan_getEvent_expect_DOCTYPE(XMLCan this, char *pointer, char current)
{
  XMLCanBuffer buffer = XMLCan_BUFFER(this);
  int32_t line = XMLCan_LINE(this);
  while (XMLCanIsWhiteSpace(current)) {
    line += XMLCanIsNewLineChar(current);
    current = *++pointer;
  }
  if (XMLCanIsNameStart(current)) {
    // Parse the DOCTYPE name.
    char *name = pointer;
    size_t size = 1;
    current = *++pointer;
    while (XMLCanIsNameChar(current)) {
      current = *++pointer;
      size++;
    }
    if (current != '\0') {
      *pointer = '\0';
      *XMLCan__NAME(this) = name;
      *XMLCan__SIZE(this) = size;
      *XMLCanBuffer__START(buffer) = pointer + 1;
      *XMLCan__EXPECT(this) = XMLCanEvent_DTD;
      *XMLCan__EVENT(this) = XMLCanEvent_DOCTYPE;
      *XMLCan__LINE(this) = line;
      return XMLCan_EVENT(this);
    }
  }
  if (current == '\0') {
    // Refill buffer and try again.
    if (XMLCanBuffer_refill(buffer)) {
      return XMLCan_getEvent(this);
    }
  }
  *XMLCan__ERROR(this) = "invalid DOCTYPE declaration";
  *XMLCan__EXPECT(this) = XMLCanEvent_Error;
  *XMLCan__EVENT(this) = XMLCanEvent_Error;
  *XMLCan__LINE(this) = line;
  return XMLCan_EVENT(this);
}

#line 760 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
static XMLCanEvent
XMLCan_getEvent_expect_CharData(XMLCan this, char *pointer, char current)
{
  XMLCanBuffer buffer = XMLCan_BUFFER(this);
  int32_t line = XMLCan_LINE(this);
  char *text = pointer;
  while (current != '<') {
    if (current == '\0') break;
    line += XMLCanIsNewLineChar(current);
    current = *++pointer;
  }
  if (current == '<' || !XMLCanBuffer_refill(buffer)) {
    *pointer = '\0';
    *XMLCan__SAVED(this) = current;
    *XMLCan__TEXT(this) = text;
    *XMLCan__SIZE(this) = pointer - text;
    *XMLCanBuffer__START(buffer) = pointer;
    *XMLCan__EXPECT(this) = XMLCanEvent__;
    *XMLCan__EVENT(this) = XMLCanEvent_CharData;
    XMLCan_normalizeCharData(this);
    *XMLCan__LINE(this) = line;
    return XMLCan_EVENT(this);
  }
  return XMLCan_getEvent(this);
}

#line 786 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
static XMLCanEvent
XMLCan_getEvent_expectDTD(XMLCan this, char *pointer, char current)
{
  XMLCanBuffer buffer = XMLCan_BUFFER(this);
  int32_t line = XMLCan_LINE(this);
  while (XMLCanIsWhiteSpace(current)) {
    line += XMLCanIsNewLineChar(current);
    current = *++pointer;
  }
  if (current == '>') {
    // End of DTD declaration.
    *XMLCanBuffer__START(buffer) = pointer + 1;
    *XMLCan__EXPECT(this) = XMLCanEvent__;
    *XMLCan__LINE(this) = line;
    return XMLCan_getEvent(this);
  } else {
    int i = 0;
    for (i = 0; i < 6; i++) {
      if (current == '\0') break;
      current = *++pointer;
    }
    if (!strncmp(pointer - 6, "PUBLIC", 6)) {
      // Fetch the public ID.
      *XMLCanBuffer__START(buffer) = pointer + 1;
      *XMLCan__EXPECT(this) = XMLCanEvent_PublicID;
      *XMLCan__LINE(this) = line;
      return XMLCan_getEvent(this);
    }
    if (!strncmp(pointer - 6, "SYSTEM", 6)) {
      // Fetch the system ID.
      *XMLCanBuffer__START(buffer) = pointer + 1;
      *XMLCan__EXPECT(this) = XMLCanEvent_SystemID;
      *XMLCan__LINE(this) = line;
      return XMLCan_getEvent(this);
    }
  }
  if (current == '\0') {
    // Refill buffer and try again.
    if (XMLCanBuffer_refill(buffer)) {
      return XMLCan_getEvent(this);
    }
  }
  *XMLCan__ERROR(this) = "invalid DTD declaration";
  *XMLCan__EXPECT(this) = XMLCanEvent_Error;
  *XMLCan__EVENT(this) = XMLCanEvent_Error;
  *XMLCan__LINE(this) = line;
  return XMLCan_EVENT(this);
}

#line 835 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
static XMLCanEvent
XMLCan_getEvent_expectPublicID(XMLCan this, char *pointer, char current)
{
  XMLCanBuffer buffer = XMLCan_BUFFER(this);
  int32_t line = XMLCan_LINE(this);
  while (XMLCanIsWhiteSpace(current)) {
    line += XMLCanIsNewLineChar(current);
    current = *++pointer;
  }
  if (current == '\'' || current == '"') {
    char quote = current;
    char *text = pointer + 1;
    current = *++pointer;
    while (current != quote) {
      if (current == '\0') break;
      line += XMLCanIsNewLineChar(current);
      current = *++pointer;
    }
    if (current == quote) {
      *pointer = '\0';
      *XMLCan__QUOTE(this) = quote;
      *XMLCan__TEXT(this) = text;
      *XMLCan__SIZE(this) = pointer - text;
      *XMLCanBuffer__START(buffer) = pointer + 1;
      *XMLCan__EXPECT(this) = XMLCanEvent_SystemID;
      *XMLCan__EVENT(this) = XMLCanEvent_PublicID;
      XMLCan_normalizeAttValue(this);
      *XMLCan__LINE(this) = line;
      return XMLCan_EVENT(this);
    }
  }
  if (current == '\0') {
    // Refill buffer and try again.
    if (XMLCanBuffer_refill(buffer)) {
      return XMLCan_getEvent(this);
    }
  }
  *XMLCan__ERROR(this) = "invalid public ID";
  *XMLCan__EXPECT(this) = XMLCanEvent_Error;
  *XMLCan__EVENT(this) = XMLCanEvent_Error;
  *XMLCan__LINE(this) = line;
  return XMLCan_EVENT(this);
}

#line 879 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
static XMLCanEvent
XMLCan_getEvent_expectSystemID(XMLCan this, char *pointer, char current)
{
  XMLCanBuffer buffer = XMLCan_BUFFER(this);
  int32_t line = XMLCan_LINE(this);
  while (XMLCanIsWhiteSpace(current)) {
    line += XMLCanIsNewLineChar(current);
    current = *++pointer;
  }
  if (current == '>') {
    if (XMLCan_FLAGS(this) & XMLCanFlag_HTML) {
      // HTML with missing SystemID.
      *XMLCanBuffer__START(buffer) = pointer + 1;
      *XMLCan__EXPECT(this) = XMLCanEvent__;
      *XMLCan__LINE(this) = line;
      return XMLCan_getEvent(this);
    }
  } else if (current == '\'' || current == '"') {
    char quote = current;
    char *text = pointer + 1;
    current = *++pointer;
    while (current != quote) {
      if (current == '\0') break;
      line += XMLCanIsNewLineChar(current);
      current = *++pointer;
    }
    if (current == quote) {
      *pointer = '\0';
      *XMLCan__QUOTE(this) = quote;
      *XMLCan__TEXT(this) = text;
      *XMLCan__SIZE(this) = pointer - text;
      *XMLCanBuffer__START(buffer) = pointer + 1;
      *XMLCan__EXPECT(this) = XMLCanEvent_DTD;
      *XMLCan__EVENT(this) = XMLCanEvent_SystemID;
      XMLCan_normalizeAttValue(this);
      *XMLCan__LINE(this) = line;
      return XMLCan_EVENT(this);
    }
  }
  if (current == '\0') {
    // Refill buffer and try again.
    if (XMLCanBuffer_refill(buffer)) {
      return XMLCan_getEvent(this);
    }
  }
  *XMLCan__ERROR(this) = "invalid system ID";
  *XMLCan__EXPECT(this) = XMLCanEvent_Error;
  *XMLCan__EVENT(this) = XMLCanEvent_Error;
  *XMLCan__LINE(this) = line;
  return XMLCan_EVENT(this);
}

#line 931 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
static XMLCanEvent
XMLCan_getEvent_expectAttName(XMLCan this, char *pointer, char current)
{
  XMLCanBuffer buffer = XMLCan_BUFFER(this);
  int32_t line = XMLCan_LINE(this);
  while (XMLCanIsWhiteSpace(current)) {
    line += XMLCanIsNewLineChar(current);
    current = *++pointer;
  }
  if (current == '>') {
    // End of start tag: parse next input.
    *XMLCanBuffer__START(buffer) = pointer + 1;
    *XMLCan__EXPECT(this) = XMLCanEvent__;
    *XMLCan__DEPTH(this) += 1;
    *XMLCan__LINE(this) = line;
    return XMLCan_getEvent(this);
  } else if (current == '/') {
    current = *++pointer;
    if (current == '>') {
      // Empty tag: post ETag event.
      *XMLCanBuffer__START(buffer) = pointer + 1;
      *XMLCan__EXPECT(this) = XMLCanEvent__;
      *XMLCan__EVENT(this) = XMLCanEvent_ETag;
      *XMLCan__LINE(this) = line;
      return XMLCan_EVENT(this);
    }
  } else if (XMLCanIsNameStart(current)) {
    // Attribute name.
    char *name = pointer;
    size_t size = 1;
    current = *++pointer;
    while (XMLCanIsNameChar(current)) {
      current = *++pointer;
      size++;
    }
    while (XMLCanIsWhiteSpace(current)) {
      line += XMLCanIsNewLineChar(current);
      current = *++pointer;
    }
    if (current == '=') {
      name[size] = '\0';
      *XMLCan__NAME(this) = name;
      *XMLCan__SIZE(this) = size;
      *XMLCanBuffer__START(buffer) = pointer + 1;
      *XMLCan__EXPECT(this) = XMLCanEvent_AttValue;
      *XMLCan__EVENT(this) = XMLCanEvent_AttName;
      *XMLCan__LINE(this) = line;
      return XMLCan_EVENT(this);
    } else if (current != '\0') {
      if (XMLCan_FLAGS(this) & XMLCanFlag_HTML) {
        // HTML missing attribute value.
        name[size] = '\0';
        *XMLCan__SAVED(this) = current;
        *XMLCan__NAME(this) = name;
        *XMLCan__SIZE(this) = size;
        *XMLCanBuffer__START(buffer) = pointer;
        *XMLCan__EXPECT(this) = XMLCanEvent_AttName;
        *XMLCan__EVENT(this) = XMLCanEvent_AttName;
        *XMLCan__LINE(this) = line;
        return XMLCan_EVENT(this);
      }
    }
  }
  if (current == '\0') {
    // Refill buffer and try again.
    if (XMLCanBuffer_refill(buffer)) {
      return XMLCan_getEvent(this);
    }
  }
  *XMLCan__ERROR(this) = "expecting attribute name";
  *XMLCan__EXPECT(this) = XMLCanEvent_Error;
  *XMLCan__EVENT(this) = XMLCanEvent_Error;
  *XMLCan__LINE(this) = line;
  return XMLCan_EVENT(this);
}

#line 1007 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
static XMLCanEvent
XMLCan_getEvent_expectAttValue(XMLCan this, char *pointer, char current)
{
  XMLCanBuffer buffer = XMLCan_BUFFER(this);
  int32_t line = XMLCan_LINE(this);
  while (XMLCanIsWhiteSpace(current)) {
    line += XMLCanIsNewLineChar(current);
    current = *++pointer;
  }
  if (current == '\'' || current == '"') {
    char quote = current;
    char *text = pointer + 1;
    current = *++pointer;
    while (current != quote) {
      if (current == '\0') break;
      line += XMLCanIsNewLineChar(current);
      current = *++pointer;
    }
    if (current == quote) {
      *pointer = '\0';
      *XMLCan__QUOTE(this) = quote;
      *XMLCan__TEXT(this) = text;
      *XMLCan__SIZE(this) = pointer - text;
      *XMLCanBuffer__START(buffer) = pointer + 1;
      *XMLCan__EXPECT(this) = XMLCanEvent_AttName;
      *XMLCan__EVENT(this) = XMLCanEvent_AttValue;
      XMLCan_normalizeAttValue(this);
      *XMLCan__LINE(this) = line;
      return XMLCan_EVENT(this);
    }
  } else if (current != '\0') {
    if (XMLCan_FLAGS(this) & XMLCanFlag_HTML) {
      // HTML unquoted attribute value.
      char *text = pointer;
      while (XMLCanIsNameChar(current)) {
        if (current == '\0') break;
        current = *++pointer;
      }
      if (current != '\0') {
        *pointer = '\0';
        *XMLCan__QUOTE(this) = '"';
        *XMLCan__SAVED(this) = current;
        *XMLCan__TEXT(this) = text;
        *XMLCan__SIZE(this) = pointer - text;
        *XMLCanBuffer__START(buffer) = pointer;
        *XMLCan__EXPECT(this) = XMLCanEvent_AttName;
        *XMLCan__EVENT(this) = XMLCanEvent_AttValue;
        *XMLCan__LINE(this) = line;
        return XMLCan_EVENT(this);
      }
    }
  }
  if (current == '\0') {
    // Refill buffer and try again.
    if (XMLCanBuffer_refill(buffer)) {
      return XMLCan_getEvent(this);
    }
  }
  *XMLCan__ERROR(this) = "expecting attribute value";
  *XMLCan__EXPECT(this) = XMLCanEvent_Error;
  *XMLCan__EVENT(this) = XMLCanEvent_Error;
  *XMLCan__LINE(this) = line;
  return XMLCan_EVENT(this);
}

#line 1078 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
XMLCanEvent
XMLCan_getEvent(XMLCan this)
{
  XMLCanEvent expect = XMLCan_EXPECT(this);
  XMLCanBuffer buffer = XMLCan_BUFFER(this);
  char *pointer = XMLCanBuffer_START(buffer);
  char saved = XMLCan_SAVED(this);
  char current = *pointer;
  if (saved != '\0') {
    *pointer = current = saved;
  }
  Except_DEBUG(XMLCanBuffer_check(buffer));
  *XMLCan__SAVED(this) = '\0';
  *XMLCan__QUOTE(this) = '\0';
  *XMLCan__ERROR(this) = NULL;
  *XMLCan__NAME(this) = NULL;
  *XMLCan__TEXT(this) = NULL;
  *XMLCan__SIZE(this) = 0;
  if (expect == XMLCanEvent__) {
    if (current == '\0') {
      // Refill buffer and try again.
      if (XMLCanBuffer_refill(buffer)) {
        return XMLCan_getEvent(this);
      } else {
        *XMLCan__EVENT(this) = XMLCanEvent_End;
        return XMLCan_EVENT(this);
      }
    } else if (current == '<') {
      // Start of markup of some kind.
      current = *++pointer;
      if (XMLCanIsNameStart(current)) {
        // Start tag: parse the element name.
        return XMLCan_getEvent_expect_STag(this, pointer, current);
      } else if (current == '/') {
        // End tag: parse the element name.
        current = *++pointer;
        return XMLCan_getEvent_expect_ETag(this, pointer, current);
      } else if (current == '?') {
        // XML declaration or processing instruction.
        current = *++pointer;
        return XMLCan_getEvent_expect_PI(this, pointer, current);
      } else if (current == '!') {
        current = *++pointer;
        if (current == '-') {
          current = *++pointer;
          if (current == '-') {
            current = *++pointer;
            return XMLCan_getEvent_expect_Comment(this, pointer, current);
          }
        } else {
          int i = 0;
          for (i = 0; i < 7; i++) {
            if (current == '\0') break;
            current = *++pointer;
          }
          if (!strncmp(pointer - 7, "[CDATA[", 7)) {
            // CDATA Section.
            return XMLCan_getEvent_expect_CDATA(this, pointer, current);
          }
          if (!strncmp(pointer - 7, "DOCTYPE", 7)) {
            // DOCTYPE declaration.
            return XMLCan_getEvent_expect_DOCTYPE(this, pointer, current);
          }
        }
      }
      if (current == '\0') {
        // Refill buffer and try again.
        if (XMLCanBuffer_refill(buffer)) {
          return XMLCan_getEvent(this);
        }
      }
      *XMLCan__EXPECT(this) = XMLCanEvent_Error;
      *XMLCan__EVENT(this) = XMLCanEvent_Error;
      *XMLCan__ERROR(this) = "invalid markup";
      return XMLCan_EVENT(this);
    } else {
      // Character Data.
      return XMLCan_getEvent_expect_CharData(this, pointer, current);
    }
  } else if (expect == XMLCanEvent_DTD) {
    return XMLCan_getEvent_expectDTD(this, pointer, current);
  } else if (expect == XMLCanEvent_PublicID) {
    return XMLCan_getEvent_expectPublicID(this, pointer, current);
  } else if (expect == XMLCanEvent_SystemID) {
    return XMLCan_getEvent_expectSystemID(this, pointer, current);
  } else if (expect == XMLCanEvent_AttName) {
    return XMLCan_getEvent_expectAttName(this, pointer, current);
  } else if (expect == XMLCanEvent_AttValue) {
    return XMLCan_getEvent_expectAttValue(this, pointer, current);
  }
  *XMLCan__EXPECT(this) = XMLCanEvent_Error;
  *XMLCan__EVENT(this) = XMLCanEvent_Error;
  *XMLCan__ERROR(this) = "invalid state";
  return XMLCan_EVENT(this);
}

#line 1180 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
XMLCanEvent
XMLCan_event(XMLCan this)
{
  return XMLCan_EVENT(this);
}

#line 1192 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
int32_t
XMLCan_line(XMLCan this)
{
  return XMLCan_LINE(this);
}

#line 1204 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
const char *
XMLCan_error(XMLCan this)
{
  return XMLCan_ERROR(this);
}

#line 1216 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
void
XMLCan_setError(XMLCan this, const char *error)
{
  *XMLCan__EXPECT(this) = XMLCanEvent_Error;
  *XMLCan__EVENT(this) = XMLCanEvent_Error;
  *XMLCan__ERROR(this) = error;
}

#line 1230 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
char
XMLCan_quote(XMLCan this)
{
  return XMLCan_QUOTE(this);
}

#line 1245 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
const char *
XMLCan_name(XMLCan this)
{
  return XMLCan_NAME(this);
}

#line 1259 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
const char *
XMLCan_text(XMLCan this)
{
  return XMLCan_TEXT(this);
}

#line 1274 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
size_t
XMLCan_size(XMLCan this)
{
  return XMLCan_SIZE(this);
}

#line 1288 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
int32_t
XMLCan_depth(XMLCan this)
{
  return XMLCan_DEPTH(this);
}

#line 1300 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
int
XMLCanLatin1(const char *name)
{
  static struct {
    const char *NAME;
    intptr_t VALUE;
  } XMLCan_Latin1[] = {
    { "AElig",	198 },
    { "Aacute",	193 },
    { "Acirc",	194 },
    { "Agrave",	192 },
    { "Aring",	197 },
    { "Atilde",	195 },
    { "Auml",	196 },
    { "Ccedil",	199 },
    { "ETH",	208 },
    { "Eacute",	201 },
    { "Ecirc",	202 },
    { "Egrave",	200 },
    { "Euml",	203 },
    { "Iacute",	205 },
    { "Icirc",	206 },
    { "Igrave",	204 },
    { "Iuml",	207 },
    { "Ntilde",	209 },
    { "Oacute",	211 },
    { "Ocirc",	212 },
    { "Ograve",	210 },
    { "Oslash",	216 },
    { "Otilde",	213 },
    { "Ouml",	214 },
    { "THORN",	222 },
    { "Uacute",	218 },
    { "Ucirc",	219 },
    { "Ugrave",	217 },
    { "Uuml",	220 },
    { "Yacute",	221 },
    { "aacute",	225 },
    { "acirc",	226 },
    { "acute",	180 },
    { "aelig",	230 },
    { "agrave",	224 },
    { "aring",	229 },
    { "atilde",	227 },
    { "auml",	228 },
    { "brvbar",	166 },
    { "ccedil",	231 },
    { "cedil",	184 },
    { "cent",	162 },
    { "copy",	169 },
    { "curren",	164 },
    { "deg",	176 },
    { "divide",	247 },
    { "eacute",	233 },
    { "ecirc",	234 },
    { "egrave",	232 },
    { "eth",	240 },
    { "euml",	235 },
    { "frac12",	189 },
    { "frac14",	188 },
    { "frac34",	190 },
    { "iacute",	237 },
    { "icirc",	238 },
    { "iexcl",	161 },
    { "igrave",	236 },
    { "iquest",	191 },
    { "iuml",	239 },
    { "laquo",	171 },
    { "macr",	175 },
    { "micro",	181 },
    { "middot",	183 },
    { "nbsp",	160 },
    { "not",	172 },
    { "ntilde",	241 },
    { "oacute",	243 },
    { "ocirc",	244 },
    { "ograve",	242 },
    { "ordf",	170 },
    { "ordm",	186 },
    { "oslash",	248 },
    { "otilde",	245 },
    { "ouml",	246 },
    { "para",	182 },
    { "plusmn",	177 },
    { "pound",	163 },
    { "raquo",	187 },
    { "reg",	174 },
    { "sect",	167 },
    { "shy",	173 },
    { "sup1",	185 },
    { "sup2",	178 },
    { "sup3",	179 },
    { "szlig",	223 },
    { "thorn",	254 },
    { "times",	215 },
    { "uacute",	250 },
    { "ucirc",	251 },
    { "ugrave",	249 },
    { "uml",	168 },
    { "uuml",	252 },
    { "yacute",	253 },
    { "yen",	165 },
    { "yuml",	255 },
  };
  int32_t count = sizeof(XMLCan_Latin1)/sizeof(XMLCan_Latin1[0]);
  int32_t l = 0, r = count - 1;
  while (r >= l) {
    int32_t i = (l + r) >> 1;
    int cmp = strcmp(name, XMLCan_Latin1[i].NAME);
    if (cmp < 0) r = i - 1;
    else if (cmp > 0) l = i + 1;
    else return XMLCan_Latin1[i].VALUE;
  }
  return -1;
}

#line 1422 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
int
XMLCan_lookupLatin1(XMLCan this, const char *name)
{
  int value = XMLCanLatin1(name);
  if (value <= 0) {
    XMLCan_setError(this, "unknown Latin1 entity");
  }
  return value;
}

#line 1492 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1504 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
#if XCC__C
static void
XMLCan_TEST(void)
{
#include "BSL/XMLCan_.c"
}

#line 1511 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLCan.xcc"
int
main(int argc, char **argv)
{
  BSL_Test(XMLCan_TEST);
  return 0;
}
#endif


#endif//XMLCan_c_INCLUDED
