#ifndef CAL_c_INCLUDED
#define CAL_c_INCLUDED

#line 16 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/CAL.xcc"
#include "CAL/CAL_.h"

#line 25 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/CAL.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 62 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/CAL.xcc"
#undef CAL_TRACE
FILE *CAL_TRACE = NULL;

#line 73 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/CAL.xcc"
#undef IPF_TRACE
FILE *IPF_TRACE = NULL;

#line 82 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/CAL.xcc"
static int CAL_Initialized = 0;

#line 84 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/CAL.xcc"
void
CAL_INIT(void)
{
  if (CAL_Initialized++ == 0) {
    if (GETENV("CAL_TRACE")) {
      int file = 0;
      sscanf(GETENV("CAL_TRACE"), "%d", &file);
      if (file == 1) CAL_TRACE = stdout;
      else if (file == 2) CAL_TRACE = stderr;
    }
    if (GETENV("IPF_TRACE")) {
      int file = 0;
      sscanf(GETENV("IPF_TRACE"), "%d", &file);
      if (file == 1) IPF_TRACE = stdout;
      else if (file == 2) IPF_TRACE = stderr;
    }
    if (CAL_TRACE) fprintf(CAL_TRACE, "*** CAL INIT\n");
    CCL_INIT();
    DGraph_INIT();
    Dominators_INIT();
    Hierarchy_INIT();
    Network_INIT();
    LProgram_INIT();
  }
}

#line 116 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/CAL.xcc"
void
CAL_FINI(void)
{
  if (--CAL_Initialized == 0) {
    if (CAL_TRACE) fprintf(CAL_TRACE, "*** CAL FINI\n");
    LProgram_FINI();
    Network_FINI();
    Hierarchy_FINI();
    Dominators_FINI();
    DGraph_FINI();
    CCL_FINI();
  }
}

#line 136 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/CAL.xcc"
void
CAL_Test(void (*test)(void))
{
  CAL_INIT();
  (*test)();
  CAL_FINI();
}

#line 144 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/CAL.xcc"
#if XCC__C
static void
CAL_TEST(void)
{
#include "CAL/CAL_.c"
}

#line 151 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/CAL.xcc"
int
main(int argc, char **argv)
{
  CAL_Test(CAL_TEST);
  return 0;
}
#endif


#endif//CAL_c_INCLUDED
