#ifndef Network_c_INCLUDED
#define Network_c_INCLUDED

#line 16 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Network.xcc"
#include "CAL/CAL_.h"

#line 21 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Network.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 40 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Network.xcc"
#ifndef CDT_NTRACE
ETableEntry_ NetArcFlag_Entries[] = {
  ETableENTRY(NetArcFlag, Queued),
  ETableENTRY(NetArcFlag, Active),
  ETableENTRY(NetArcFlag, Acyclic),
  ETableENTRY(NetArcFlag, Longest),
  ETableENTRY(NetArcFlag, Useless),
  ETableENTRY(NetArcFlag, Precious),
  ETableENTRY_NULL
};
ETable_ NetArcFlag_Table[1];
#endif//CDT_NTRACE

#line 73 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Network.xcc"
NetArc
NetArc_Ctor(NetArc this, int32_t delay, NetArcFlags flags)
{
  *NetArc__DELAY(this) = delay;
  *NetArc__FLOW(this) = 0;
  *NetArc__FLAGS(this) = flags;
  *NetArc__TYPE(this) = 0;
  return this;
}

#line 83 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Network.xcc"
size_t
NetArc_Size(int32_t delay, NetArcFlags flags)
{
  return sizeof(NetArc_);
}

#line 108 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Network.xcc"
#if !defined(CDT_NTRACE) || defined(XCC__C)
bool
NetArc_pretty(NetArc this, FILE *file)
{
  NetArcFlags flags = NetArc_FLAGS(this);
  int32_t TAILKEY = NetNode_INDEX(NetArc_TAILNODE(this));
  int32_t HEADKEY = NetNode_INDEX(NetArc_HEADNODE(this));
  if (file == NULL) file = stderr;
  fprintf(file, "(%d, %d)\tdelay=%d",
      TAILKEY, HEADKEY, NetArc_DELAY(this));
  if (flags != 0) {
    fprintf(file, "\t");
#ifndef XCC__C
    ETable_prettyFlags(NetArcFlag_Table, flags, "+", file);
#else
    // ETable_prettyFlags is not available if CDT_NTRACE && XCC__C
    fprintf(file, "%u", flags);
#endif
  }
  return true;
}
#endif//CDT_NTRACE

#line 159 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Network.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 180 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Network.xcc"
NetNode
NetNode_Ctor(NetNode this, int require)
{
  *NetNode__EDGE(this) = NULL;
  *NetNode__DATE(this) = 0;
  *NetNode__REQUIRE(this) = require;
  Except_CHECK(NetNode_REQUIRE(this) == require);
  *NetNode__BALANCE(this) = 0;
  *NetNode__NEXT(this) = NULL;
  *NetNode__PREV(this) = NULL;
  *NetNode__DEPTH(this) = -1;
  *NetNode__STAMP(this) = 0;
  *NetNode__ORDER(this) = 0;
  return this;
}

#line 196 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Network.xcc"
size_t
NetNode_Size(int require) {
	return sizeof(NetNode_);
}

#line 228 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Network.xcc"
#if !defined(CDT_NTRACE) || defined(XCC__C)
bool
NetNode_pretty(NetNode this, FILE *file)
{
  if (file == NULL) file = stderr;
  fprintf(file, "NODE=%d\trequire=%d",
      NetNode_INDEX(this), NetNode_REQUIRE(this));
  return true;
}
#endif//CDT_NTRACE

#line 239 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Network.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 276 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Network.xcc"
Network
Network_Ctor(Network this, Memory memory, int32_t maxNodes)
{
  DGraph_Ctor(Network_DGRAPH(this), memory, maxNodes);
  PtrSeq_Ctor(Network_ACTIVE(this), memory, 0);
  IQueue_Ctor(Network_QUEUED(this), memory, sizeof(NetArc), 0);
  PtrSeq_Ctor(Network_CIRCUIT(this), memory, 0);
  *Network__Q(this) = NULL;
  *Network__L(this) = NULL;
  *Network__K(this) = NULL;
  *Network__P(this) = NULL;
  *Network__J(this) = NULL;
  *Network__STAMP(this) = 0;
  *Network__CRITICAL(this) = NULL;
  return this;
}

#line 293 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Network.xcc"
void
Network_Dtor(Network this)
{
  DGraph_Dtor(Network_DGRAPH(this));
  PtrSeq_Dtor(Network_ACTIVE(this));
  IQueue_Dtor(Network_QUEUED(this));
  PtrSeq_Dtor(Network_CIRCUIT(this));
}

#line 390 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Network.xcc"
NetNode
Network_makeNode(Network this, int require)
{
  size_t size = NetNode_Size(require);
  NetNode node = DGraph_makeNode(Network_DGRAPH(this), size);
  NetNode_Ctor(node, require);
  return node;
}

#line 405 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Network.xcc"
NetArc
Network_makeArc(Network this, NetNode t_node, NetNode h_node, int32_t delay, NetArcFlags flags)
{
  size_t size = NetArc_Size(delay, flags);
  DGraphArc arc = DGraph_makeArc(Network_DGRAPH(this), t_node, h_node, size);
  return NetArc_Ctor((NetArc)arc, delay, flags);
  return arc;
}

#line 420 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Network.xcc"
void
Network_activate(Network this)
{
  PtrSeq active = Network_ACTIVE(this);
  IQueue queued = Network_QUEUED(this);
  PtrSeq circuit = Network_CIRCUIT(this);
  int32_t arcCount = Network_ARCCOUNT(this), activeCount = 0;
  if (PtrSeq_maxCount(active) < arcCount) {
    PtrSeq_empty(active);
    IQueue_empty(queued, NULL);
    PtrSeq_empty(circuit);
    PtrSeq_resize(active, arcCount);
    Network_FOREACH_NetNode(this, NODE) {
      NetNode_FORLEAVE_NetArc(NODE, ARC) {
        if (!NetArc_isUseless(ARC)) {
          PtrSeq_push(active, ARC);
          *NetArc__FLAGS(ARC) |= NetArcFlag_Active;
          activeCount++;
        } else {
          *NetArc__FLAGS(ARC) &= ~NetArcFlag_Active;
        }
      } NetNode_ENDLEAVE_NetArc;
    } Network_ENDEACH_NetNode;
    IQueue_resize(queued, activeCount);
    PtrSeq_resize(circuit, MAX(activeCount/8, 32));
    CAL_TRACE && fprintf(CAL_TRACE, "*** READY ARCS\tcount=%d\tactive=%d\n",
                                    arcCount, activeCount);
  }
}

#line 583 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Network.xcc"
#if !defined(CDT_NTRACE) || defined(XCC__C)
bool
Network_pretty(Network this, FILE *file)
{
  if (file == NULL) file = stderr;
  Network_FOREACH_NetNode(this, NODE) {
    fprintf(file, "    ");
    NetNode_pretty(NODE, file);
    fprintf(file, "\n");
    NetNode_FORLEAVE_NetArc(NODE, ARC) {
      fprintf(file, "\t");
      NetArc_pretty(ARC, file);
      fprintf(file, "\n");
    } NetNode_ENDLEAVE_NetArc;
  } Network_ENDEACH_NetNode;
  return true;
}
#endif//CDT_NTRACE

#line 608 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Network.xcc"
#if !defined(CDT_NTRACE) || defined(XCC__C)
bool
Network_prettyTree(Network this, FILE *file)
{
  if (file == NULL) file = stderr;
  Network_FORNEXT_NetNode(this, NODE) {
    NetArc edge = NetNode_EDGE(NODE);
    fprintf(file, "    NODE=%d\trequire=%d\n", NetNode_INDEX(NODE), NetNode_REQUIRE(NODE));
    fprintf(file, "\tdepth=%d\tdate=%d\n", NetNode_DEPTH(NODE), NetNode_DATE(NODE));
    if (edge != NULL) {
      NetNode t_node = NetArc_TAILNODE(edge);
      NetNode h_node = NetArc_HEADNODE(edge);
      fprintf(file, "\tEDGE\tTAILNODE=%d\tHEADNODE=%d\n", NetNode_INDEX(t_node), NetNode_INDEX(h_node));
      fprintf(file, "\t    delay=%d\tflow=%d\n", NetArc_DELAY(edge), NetArc_FLOW(edge));
    }
  } Network_ENDNEXT_NetNode;
  return true;
}
#endif//CDT_NTRACE

#line 634 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Network.xcc"
bool
Network_checkTree(Network this, bool flows)
{
  int32_t nodeCount = 1;
  NetNode j = Network_ROOTNODE(this);
  int require = NetNode_REQUIRE(j);
  ASSERT(NetNode_EDGE(j) == NULL);
  ASSERT(NetNode_DATE(j) == 0);
  Network_FORNEXT_NetNode(this, NODE) {
    NetNode j = NODE;
    NetArc p = NetNode_EDGE(j);
    if (NetArc_TAILNODE(p) != j) {
      NetNode i = NetArc_TAILNODE(p);
      if (NetNode_DATE(j) != NetNode_DATE(i) + NetArc_DELAY(p)) {
        fprintf(stderr, "i=%d j=%d\n", NetNode_INDEX(i), NetNode_INDEX(j));
#ifndef CDT_NTRACE
        Network_prettyTree(this, stderr);
#endif//CDT_NTRACE
      }
      ASSERT(NetNode_DATE(j) == NetNode_DATE(i) + NetArc_DELAY(p));
    } else {
      NetNode i = NetArc_HEADNODE(p);
      if (NetNode_DATE(j) != NetNode_DATE(i) - NetArc_DELAY(p)) {
        fprintf(stderr, "i=%d j=%d\n", NetNode_INDEX(i), NetNode_INDEX(j));
#ifndef CDT_NTRACE
        Network_prettyTree(this, stderr);
#endif//CDT_NTRACE
      }
      ASSERT(NetNode_DATE(j) == NetNode_DATE(i) - NetArc_DELAY(p));
    }
    *NetNode__BALANCE(j) = NetNode_REQUIRE(j);
    require += NetNode_REQUIRE(j);
    ASSERT(NetNode_PREV(NetNode_NEXT(j)) == j);
    nodeCount++;
  } Network_ENDNEXT_NetNode;
  ASSERT(Network_NODECOUNT(this) == nodeCount);
  if (flows) {
    ASSERT(require == 0);
    Network_FORPREV_NetNode(this, NODE) {
      NetNode j = NODE;
      NetArc p = NetNode_EDGE(j);
      if (NetArc_TAILNODE(p) != j) {
        NetNode i = NetArc_TAILNODE(p);
        ASSERT(NetArc_FLOW(p) == -NetNode_BALANCE(j));
        *NetNode__BALANCE(i) = NetNode_BALANCE(i) + NetNode_BALANCE(j);
      } else {
        NetNode i = NetArc_HEADNODE(p);
        ASSERT(NetArc_FLOW(p) == NetNode_BALANCE(j));
        *NetNode__BALANCE(i) = NetNode_BALANCE(i) + NetNode_BALANCE(j);
      }
    } Network_ENDPREV_NetNode;
  }
  return true;
}

#line 697 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Network.xcc"
bool
Network_checkPrimal(Network this)
{
  Network_ACTIVE_FOREACH_NetArc(this, ARC) {
    if (NetArc_FLOW(ARC) < 0) {
      int32_t TAILKEY = NetNode_INDEX(NetArc_TAILNODE(ARC));
      int32_t HEADKEY = NetNode_INDEX(NetArc_HEADNODE(ARC));
      fprintf(stderr, "NEGATIVE FLOW:\t(%d, %d)\n", TAILKEY, HEADKEY);
#ifndef CDT_NTRACE
      Network_pretty(this, stdout);
      Network_prettyTree(this, stdout);
#endif//CDT_NTRACE
    }
    ASSERT(NetArc_FLOW(ARC) >= 0);
  } Network_ACTIVE_ENDEACH_NetArc;
  return true;
}

#line 725 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Network.xcc"
bool
Network_checkDual(Network this)
{
  Network_ACTIVE_FOREACH_NetArc(this, ARC) {
    int32_t reduced = NetArc_REDUCED(ARC);
    if (reduced > 0) {
      int32_t TAILKEY = NetNode_INDEX(NetArc_TAILNODE(ARC));
      int32_t HEADKEY = NetNode_INDEX(NetArc_HEADNODE(ARC));
      fprintf(stderr, "VIOLATED ARC:\t(%d, %d)\n", TAILKEY, HEADKEY);
#ifndef CDT_NTRACE
      Network_pretty(this, stdout);
      Network_prettyTree(this, stdout);
#endif//CDT_NTRACE
    }
    ASSERT(reduced <= 0);
  } Network_ACTIVE_ENDEACH_NetArc;
  return true;
}

#line 750 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Network.xcc"
bool
Network_checkSolved(Network this)
{
  return Network_checkPrimal(this) && Network_checkDual(this);
}

#line 785 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Network.xcc"
void
Network_doRST(Network this, bool queue)
{
  NetArc q = Network_Q(this);
  NetNode k = Network_K(this);
  NetNode l = Network_L(this);
  NetNode j = Network_J(this);
  NetArc e = NetNode_EDGE(l);
  NetNode z = l, a = l, b = l;
  NetNode x = NetNode_NEXT(a), r = NetNode_PREV(a);
  int32_t depth = NetNode_DEPTH(k) - NetNode_DEPTH(l) + 1;
  int32_t date = NetNode_DATE(k) - NetNode_DATE(l);
  if (NetArc_TAILNODE(q) == k) {
    date += NetArc_DELAY(q);
  } else {
    date -= NetArc_DELAY(q);
  }
  b = NetArc_TAILNODE(e) != b? NetArc_TAILNODE(e): NetArc_HEADNODE(e);
  for (;;) {
    while (NetNode_DEPTH(x) > NetNode_DEPTH(a)) {
      *NetNode__DEPTH(x) = NetNode_DEPTH(x) + depth;
      *NetNode__DATE(x) = NetNode_DATE(x) + date;
      if (queue) Network_QUEUED_putNode(this, x);
      z = x, x = NetNode_NEXT(x);
    }
    *NetNode__DEPTH(a) = NetNode_DEPTH(a) + depth;
    *NetNode__DATE(a) = NetNode_DATE(a) + date;
    if (queue) Network_QUEUED_putNode(this, a);
    if (a == j) break;
    *NetNode__NEXT(r) = x, *NetNode__PREV(x) = r;
    x = NetNode_NEXT(b), r = NetNode_PREV(b);
    *NetNode__NEXT(z) = b, *NetNode__PREV(b) = z;
    z = a = b;
    depth += 2;
    {
      NetArc t = NetNode_EDGE(a);
      *NetNode__EDGE(a) = e, e = t;
    }
    b = NetArc_TAILNODE(e) != b? NetArc_TAILNODE(e): NetArc_HEADNODE(e);
  }
  if (NetNode_NEXT(k) != j) {
    NetNode n = NetNode_NEXT(k);
    *NetNode__NEXT(r) = x, *NetNode__PREV(x) = r;
    *NetNode__NEXT(z) = n, *NetNode__PREV(n) = z;
  }
  *NetNode__NEXT(k) = l, *NetNode__PREV(l) = k;
  *NetNode__EDGE(l) = q;
}

#line 834 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Network.xcc"
/*
 * Network_doTSOSearch --	Topological Sort Order recursive Search.
 */
static void
Network_doTSOSearch(Network this, NetNode node)
{
  *NetNode__ORDER(node) = -1;	// Use ORDER < 0 as visited flag.
  NetNode_FORLEAVE_NetArc(node, ARC) {
    if (NetArc_isAcyclic(ARC)) {
      NetNode h_node = NetArc_HEADNODE(ARC);
      if (NetNode_ORDER(h_node) >= 0) {
        Network_doTSOSearch(this, h_node);
      }
    }
  } NetNode_ENDLEAVE_NetArc;
  *NetNode__SCANNODE(node) = Network_SCANNODE(this);
  *Network__SCANNODE(this) = node;
}

#line 859 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Network.xcc"
void
Network_doTSO(Network this)
{
  int32_t order = 0;
  NetNode root = Network_ROOTNODE(this);
  // Recursive DFS to set the SCANNODE indices.
  *Network__SCANNODE(this) = NULL;
  Network_doTSOSearch(this, root);
  // Set the ORDER fields.
  Network_FORSCAN_NetNode(this, NODE) {
    *NetNode__ORDER(NODE) = order++;
  } Network_ENDSCAN_NetNode;
  Except_CHECK(order == Network_COUNT(this));
}

#line 887 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Network.xcc"
void
Network_doFLP(Network this)
{
  NetNode root = Network_ROOTNODE(this);
  // Initialize the non-root nodes.
  Network_FOREACH_NetNode(this, NODE) {
    *NetNode__NEXT(NODE) = *NetNode__PREV(NODE) = NULL;
    *NetNode__EDGE(NODE) = NULL, *NetNode__DEPTH(NODE) = -1;
    *NetNode__DATE(NODE) = -1;
  } Network_ENDEACH_NetNode;
  // Initialize the root node.
  *NetNode__NEXT(root) = root, *NetNode__PREV(root) = root;
  *NetNode__EDGE(root) = NULL, *NetNode__DEPTH(root) = 0;
  *NetNode__DATE(root) = 0;
  // First step: grow the spanning tree.
  Network_FORSCAN_NetNode(this, NODE) {
    NetNode_FORLEAVE_NetArc(NODE, ARC) {
      if (NetArc_isAcyclic(ARC)) {
        NetNode t_node = NetArc_TAILNODE(ARC);
        NetNode h_node = NetArc_HEADNODE(ARC);
        if (NetNode_DATE(h_node) < NetNode_DATE(t_node) + NetArc_DELAY(ARC)) {
          *NetNode__DATE(h_node) = NetNode_DATE(t_node) + NetArc_DELAY(ARC);
          *NetNode__EDGE(h_node) = ARC;
        }
      } else {
        Network_QUEUED_putArc(this, ARC);
      }
    } NetNode_ENDLEAVE_NetArc;
  } Network_ENDSCAN_NetNode;
  // Second step: set the spanning tree indices.
  Network_FORSCAN_NetNode(this, NODE) {
    NetArc EDGE = NetNode_EDGE(NODE);
    if (EDGE != NULL) {
      NetNode t_node = NetArc_TAILNODE(EDGE);
      NetNode h_node = NetArc_HEADNODE(EDGE);
      NetNode next = NetNode_NEXT(t_node);
      *NetNode__DEPTH(h_node) = NetNode_DEPTH(t_node) + 1;
      *NetNode__NEXT(h_node) = next, *NetNode__PREV(next) = h_node;
      *NetNode__NEXT(t_node) = h_node, *NetNode__PREV(h_node) = t_node;
    } else Except_CHECK(NODE == root);
  } Network_ENDSCAN_NetNode;
  // Check consistency of the indices.
  Except_DEBUG(Network_checkTree(this, false));
}

#line 943 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Network.xcc"
bool
Network_doCDC(Network this, NetArc q, NetNode k, NetNode l)
{
  NetNode a = NULL;
  int32_t arcCount = 1;
  int32_t delay = NetArc_DELAY(q);
  Except_REQUIRE(NetArc_TAILNODE(q) == k);
  Except_REQUIRE(NetArc_HEADNODE(q) == l);
  Except_DEBUG(Network_checkTree(this, false));
  // Check if there is a critical cycle.
  for (a = k; NetNode_DEPTH(a) > NetNode_DEPTH(l);) {
    NetArc e = NetNode_EDGE(a);
    delay += NetArc_DELAY(e);
    a = NetArc_TAILNODE(e);
    arcCount++;
  }
  if (a == l && delay > 0) {
    // Stack the arcs of the critical circuit.
    PtrSeq circuit = Network_CIRCUIT(this);
    PtrSeq_empty(circuit);
    PtrSeq_push2(circuit, q);
    for (a = k; NetNode_DEPTH(a) > NetNode_DEPTH(l);) {
      NetArc e = NetNode_EDGE(a);
      PtrSeq_push2(circuit, e);
      a = NetArc_TAILNODE(e);
    }
    (*Network_CRITICAL(this))(this);
    return true;
  }
  return false;
}

#line 983 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Network.xcc"
#ifdef ST200CCBUG
static void
foo(void) { }
#endif

#line 988 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Network.xcc"
bool
Network_doFAQ(Network this, bool refill)
{
  if (refill || Network_QUEUED_isEmpty(this)) {
    Network_ACTIVE_FOREACH_NetArc(this, ARC) {
      if (NetArc_REDUCED(ARC) > 0) {
        Network_QUEUED_putArc(this, ARC);
      }
    } Network_ACTIVE_ENDEACH_NetArc;
  }
  *Network__Q(this) = NULL;
  while (!Network_QUEUED_isEmpty(this)) {
    NetArc arc = Network_QUEUED_popArc(this);
    if (NetArc_REDUCED(arc) > 0) {
      *Network__Q(this) = arc;
      break;
    }
#ifdef ST200CCBUG
  foo();
#endif
  }
  return Network_Q(this) != NULL;
}

#line 1021 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Network.xcc"
void
Network_doSLC(Network this, bool refill)
{
  while (Network_doFAQ(this, refill)) {
    NetArc q = Network_Q(this);
    NetNode t_node = NetArc_TAILNODE(q);
    NetNode h_node = NetArc_HEADNODE(q);
    NetArc p = NetNode_EDGE(h_node);
    Except_CHECK(p != NULL || h_node == Network_ROOTNODE(this));
    if (Network_doCDC(this, q, t_node, h_node)) {
      refill = true;
    } else {
      *Network__Q(this) = q;
      *Network__K(this) = t_node;
      *Network__L(this) = h_node;
      *Network__J(this) = h_node;
      *Network__P(this) = p;
      Network_doRST(this, true);
      refill = false;
    }
  }
  Except_DEBUG(Network_checkTree(this, false));
  Except_DEBUG(Network_checkDual(this));
}

#line 1111 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Network.xcc"
void
Network_doCNP(Network this)
{
  NetNode root = Network_ROOTNODE(this);
  Except_REQUIRE(NetNode_EDGE(root) == NULL);
  Except_REQUIRE(NetNode_DATE(root) == 0);
  if (NetNode_NEXT(root) != NULL) {
    Network_FORNEXT_NetNode(this, j) {
      NetArc p = NetNode_EDGE(j);
      if (NetArc_TAILNODE(p) != j) {
        NetNode i = NetArc_TAILNODE(p);
        *NetNode__DATE(j) = NetNode_DATE(i) + NetArc_DELAY(p);
        // if (ENTERARCS) PUSHARCS(this, j);
      } else {
        NetNode i = NetArc_HEADNODE(p);
        *NetNode__DATE(j) = NetNode_DATE(i) - NetArc_DELAY(p);
        // if (ENTERARCS) PUSHARCS(this, j);
      }
    } Network_ENDNEXT_NetNode;
  }
}

#line 1141 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Network.xcc"
void
Network_doCEF(Network this)
{
  NetNode r = Network_ROOTNODE(this);
  *NetNode__BALANCE(r) = NetNode_REQUIRE(r);
  Network_FORNEXT_NetNode(this, j) {
    *NetNode__BALANCE(j) = NetNode_REQUIRE(j);
  } Network_ENDNEXT_NetNode;
  Network_FORPREV_NetNode(this, j) {
    NetArc p = NetNode_EDGE(j);
    if (NetArc_TAILNODE(p) != j) {
      NetNode i = NetArc_TAILNODE(p);
      *NetArc__FLOW(p) = -NetNode_BALANCE(j);
      *NetNode__BALANCE(i) = NetNode_BALANCE(i) + NetNode_BALANCE(j);
    } else {
      NetNode i = NetArc_HEADNODE(p);
      *NetArc__FLOW(p) = NetNode_BALANCE(j);
      *NetNode__BALANCE(i) = NetNode_BALANCE(i) + NetNode_BALANCE(j);
    }
    // if (LEAVEARCS) PUSHARC(this, p);
  } Network_ENDPREV_NetNode;
}

#line 1174 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Network.xcc"
void
Network_doUEF(Network this, bool queue)
{
  NetArc q = Network_Q(this);
  NetArc p = Network_P(this);
  int delta = ABS(NetArc_FLOW(p));
  NetNode a = NetArc_TAILNODE(q), b = NetArc_HEADNODE(q);
  while (a != b) {
    if (NetNode_DEPTH(a) >= NetNode_DEPTH(b)) {
      NetArc e = NetNode_EDGE(a);
      if (NetArc_TAILNODE(e) == a) {
        *NetArc__FLOW(e) = NetArc_FLOW(e) - delta;
        a = NetArc_HEADNODE(e);
      } else {
        *NetArc__FLOW(e) = NetArc_FLOW(e) + delta;
        a = NetArc_TAILNODE(e);
      }
      if (queue) Network_QUEUED_putArc(this, e);
    } else {
      NetArc f = NetNode_EDGE(b);
      if (NetArc_HEADNODE(f) == b) {
        *NetArc__FLOW(f) = NetArc_FLOW(f) - delta;
        b = NetArc_TAILNODE(f);
      } else {
        *NetArc__FLOW(f) = NetArc_FLOW(f) + delta;
        b = NetArc_HEADNODE(f);
      }
      if (queue) Network_QUEUED_putArc(this, f);
    }
  }
  *NetArc__FLOW(q) = delta;
}

#line 1217 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Network.xcc"
bool
Network_dualFLE(Network this)
{
  int flow = 0;
  NetArc p = NULL;
  Network_ACTIVE_FOREACH_NetArc(this, ARC) {
    if (NetArc_FLOW(ARC) < flow) {
      flow = NetArc_FLOW(ARC);
      p = ARC;
    }
  } Network_ACTIVE_ENDEACH_NetArc;
  *Network__P(this) = p;
  return p != NULL;
}

#line 1242 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Network.xcc"
void
Network_dualFEA(Network this)
{
  NetArc p = Network_P(this), q = NULL;
  int32_t redmax = INT32_MIN;
  int32_t arcCount = Network_ARCCOUNT(this)*2;
  PtrSeq_ cutSet[1];
  PtrSeq_Ctor(cutSet, Memory_Root, arcCount);
  *Network__STAMP(this) = Network_STAMP(this) + 1;
  if (NetNode_EDGE(NetArc_HEADNODE(p)) == p) {
    int32_t stamp = Network_STAMP(this);
    NetNode j = NetArc_HEADNODE(p), x = j;
    do {
      *NetNode__STAMP(x) = stamp;
      NetNode_FORLEAVE_NetArc(x, ARC) {
        PtrSeq_push(cutSet, ARC);
      } NetNode_ENDLEAVE_NetArc;
      x = NetNode_NEXT(x);
    } while (NetNode_DEPTH(x) > NetNode_DEPTH(j));
    *Network__J(this) = j;
  } else if (NetNode_EDGE(NetArc_TAILNODE(p)) == p) {
    int32_t stamp = Network_STAMP(this);
    NetNode j = NetArc_TAILNODE(p), x = j;
    do {
      *NetNode__STAMP(x) = stamp;
      NetNode_FORENTER_NetArc(x, ARC) {
        PtrSeq_push(cutSet, ARC);
      } NetNode_ENDENTER_NetArc;
      x = NetNode_NEXT(x);
    } while (NetNode_DEPTH(x) > NetNode_DEPTH(j));
    *Network__J(this) = j;
  } else Except_NEVER(true);
  PtrSeq_FOREACH(cutSet, NetArc, a) {
    NetNode o = NetArc_TAILNODE(a), d = NetArc_HEADNODE(a);
    if (NetNode_STAMP(o) != NetNode_STAMP(d)) {
      int32_t reduced = NetArc_REDUCED(a);
      Except_CHECK(reduced <= 0);
      if (reduced > redmax) {
        redmax = reduced;
        q = a;
      }
    }
  } PtrSeq_ENDEACH;
  Except_CHECK(q != NULL);
  if (NetNode_EDGE(NetArc_HEADNODE(p)) == p) {
    *Network__Q(this) = q;
    *Network__K(this) = NetArc_HEADNODE(Network_Q(this));
    *Network__L(this) = NetArc_TAILNODE(Network_Q(this));
  } else {
    *Network__Q(this) = q;
    *Network__K(this) = NetArc_TAILNODE(Network_Q(this));
    *Network__L(this) = NetArc_HEADNODE(Network_Q(this));
  }
  PtrSeq_Dtor(cutSet);
}

#line 1304 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Network.xcc"
void
Network_dualSolve(Network this)
{
  Except_DEBUG(Network_checkDual(this));
  Except_DEBUG(Network_checkTree(this, true));
  while (Network_dualFLE(this)) {
    Network_dualFEA(this);
    Except_CHECK(NetNode_EDGE(Network_J(this)) == Network_P(this));
    Network_doUEF(this, false);
    Network_doRST(this, false);
    Except_DEBUG(Network_checkTree(this, true));
  }
  Except_DEBUG(Network_checkSolved(this));
}

#line 1333 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Network.xcc"
void
Network_primalFLE(Network this)
{
  int32_t delta = INT32_MAX;
  NetArc u = NULL, v = NULL;
  NetNode a = NetArc_TAILNODE(Network_Q(this));
  NetNode b = NetArc_HEADNODE(Network_Q(this));
  while (a != b) {
    if (NetNode_DEPTH(a) >= NetNode_DEPTH(b)) {
      NetArc e = NetNode_EDGE(a);
      if (NetArc_TAILNODE(e) == a) {
        if (NetArc_FLOW(e) <= delta) {
          delta = NetArc_FLOW(e);
          u = e;
        }
      }
      a = NetArc_TAILNODE(e) != a? NetArc_TAILNODE(e): NetArc_HEADNODE(e);
    } else {
      NetArc f = NetNode_EDGE(b);
      if (NetArc_HEADNODE(f) == b) {
        if (NetArc_FLOW(f) < delta) {
          delta = NetArc_FLOW(f);
          v = f;
        }
      }
      b = NetArc_HEADNODE(f) != b? NetArc_HEADNODE(f): NetArc_TAILNODE(f);
    }
  }
  ASSERT(u != NULL || v != NULL);
  if (v == NULL) {
    *Network__K(this) = NetArc_HEADNODE(Network_Q(this));
    *Network__L(this) = NetArc_TAILNODE(Network_Q(this));
    *Network__J(this) = NetArc_TAILNODE(u);
    *Network__P(this) = u;
  } else if (u == NULL) {
    *Network__K(this) = NetArc_TAILNODE(Network_Q(this));
    *Network__L(this) = NetArc_HEADNODE(Network_Q(this));
    *Network__J(this) = NetArc_HEADNODE(v);
    *Network__P(this) = v;
  } else if (NetArc_FLOW(u) <= NetArc_FLOW(v)) {
    *Network__K(this) = NetArc_HEADNODE(Network_Q(this));
    *Network__L(this) = NetArc_TAILNODE(Network_Q(this));
    *Network__J(this) = NetArc_TAILNODE(u);
    *Network__P(this) = u;
  } else {
    *Network__K(this) = NetArc_TAILNODE(Network_Q(this));
    *Network__L(this) = NetArc_HEADNODE(Network_Q(this));
    *Network__J(this) = NetArc_HEADNODE(v);
    *Network__P(this) = v;
  }
}

#line 1396 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Network.xcc"
#ifndef Network_MINORCOUNT
#define Network_MINORCOUNT 64
#endif

#line 1400 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Network.xcc"
bool
Network_primalFEA(Network this, bool refill)
{
  NetArc q = NULL;
  int32_t redmax = 0;
  int32_t minorCount = Network_MINORCOUNT;
  if (refill || Network_QUEUED_isEmpty(this)) {
    Network_ACTIVE_FOREACH_NetArc(this, ARC) {
      int32_t reduced = NetArc_REDUCED(ARC);
      if (reduced > redmax) {
        redmax = reduced;
        q = ARC;
      }
      if (reduced > 0) {
        Network_QUEUED_putArc(this, ARC);
      }
    } Network_ACTIVE_ENDEACH_NetArc;
  } else {
    while (!Network_QUEUED_isEmpty(this)) {
      NetArc ARC = Network_QUEUED_bottomArc(this);
      int32_t reduced = NetArc_REDUCED(ARC);
      if (reduced <= 0) {
        Network_QUEUED_dropArc(this);
      } else break;
    }
    // Here the bottom arc has its REDUCED > 0, so q will be found within minorCount.
    Network_QUEUED_FOREACH_NetArc(this, ARC) {
      int32_t reduced = NetArc_REDUCED(ARC);
      if (reduced > redmax) {
        redmax = reduced;
        q = ARC;
      }
      if (minorCount-- == 0) break;
    } Network_QUEUED_ENDEACH_NetArc;
  }
  *Network__Q(this) = q;
  return q != NULL;
}

#line 1445 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Network.xcc"
void
Network_primalSolve(Network this, bool refill)
{
  Except_DEBUG(Network_checkPrimal(this));
  Except_DEBUG(Network_checkTree(this, true));
  while (Network_primalFEA(this, refill)) {
    Network_primalFLE(this);
    Except_CHECK(NetNode_EDGE(Network_J(this)) == Network_P(this));
    Network_doUEF(this, true);
    Network_doRST(this, true);
    Except_DEBUG(Network_checkTree(this, true));
    refill = false;
  }
  Except_DEBUG(Network_checkSolved(this));
}

#line 1467 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Network.xcc"
void
Network_updateDelay(Network this, NetArc q, int32_t delay, bool queue)
{
  NetNode j = NULL, k = NULL, l = NULL;
  *NetArc__DELAY(q) = delay;
  if (NetNode_EDGE(NetArc_HEADNODE(q)) == q) {
    k = NetArc_TAILNODE(q), l = NetArc_HEADNODE(q);
    *NetNode__DATE(l) = NetNode_DATE(k) + delay;
    if (queue) Network_QUEUED_putNode(this, l);
  } else if (NetNode_EDGE(NetArc_TAILNODE(q)) == q) {
    k = NetArc_HEADNODE(q), l = NetArc_TAILNODE(q);
    *NetNode__DATE(l) = NetNode_DATE(k) - delay;
    if (queue) Network_QUEUED_putNode(this, l);
  } else {
    if (queue) Network_QUEUED_putArc(this, q);
    return;
  }
  for (j = NetNode_NEXT(l); NetNode_DEPTH(j) > NetNode_DEPTH(l); j = NetNode_NEXT(j)) {
    NetArc p = NetNode_EDGE(j);
    if (NetArc_TAILNODE(p) != j) {
      NetNode i = NetArc_TAILNODE(p);
      *NetNode__DATE(j) = NetNode_DATE(i) + NetArc_DELAY(p);
      if (queue) Network_QUEUED_putNode(this, j);
    } else {
      NetNode i = NetArc_HEADNODE(p);
      *NetNode__DATE(j) = NetNode_DATE(i) - NetArc_DELAY(p);
      if (queue) Network_QUEUED_putNode(this, j);
    }
  }
}

#line 1498 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Network.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1510 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Network.xcc"
#ifndef CDT_NTRACE
void
Network_INIT(void)
{
  ETable_Ctor(NetArcFlag_Table, Memory_Root, NetArcFlag_Entries);
}
#endif//CDT_NTRACE

#line 1528 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Network.xcc"
#ifndef CDT_NTRACE
void
Network_FINI(void)
{
  ETable_Dtor(NetArcFlag_Table);
}
#endif//CDT_NTRACE

#line 1536 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Network.xcc"
#if XCC__C
static void
Network_TEST(void)
{
#include "CAL/Network_.c"
}

#line 1543 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Network.xcc"
int
main(int argc, char **argv)
{
  CAL_Test(Network_TEST);
  return 0;
}
#endif


#endif//Network_c_INCLUDED
