#ifndef IArray__c_INCLUDED
#define IArray__c_INCLUDED

#line 66 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IArray.xcc"
//
{
  printf("sizeof(IArray_) = %d\n", sizeof(IArray_));
}

#line 264 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IArray.xcc"
//
{
  int count, i;
  int16_t *array = 0;
  IArray_ iarray[1];
  IArray_Ctor(iarray, Memory_Root, sizeof(int16_t), 5);
  array = IArray_access(iarray, 0);
  count = IArray_maxCount(iarray);
  printf("Array count = %d\n", count);
  for (i = 0 ; i < count; i++) {
    if (array[i] != 0) printf("non-zero at %d\n", i);
    array[i] = 'a' + i;
  }
  IArray_resize(iarray, 20);
  array = IArray_access(iarray, 0);
  count = IArray_maxCount(iarray);
  for (; i < count; i++) {
    if (array[i] != 0) printf("non-zero at %d\n", i);
    array[i] = 'A' + i;
  }
  printf("Array count = %d\n", count);
  i = 0;
  array = IArray_access(iarray, 0);
  IArray_FOREACH(iarray, int16_t, iter) {
    if (iter != IArray_access(iarray, i)) printf("error1 at %d\n", i);
    if (array + i != iter) printf("error2 at %d\n", i);
    printf("%c ", *iter);
    ++i;
  } IArray_ENDEACH;
  printf("\n");
  i = IArray_maxCount(iarray);
  array = IArray_access(iarray, 0);
  IArray_FORBACK(iarray, int16_t, iter) {
    --i;
    if (iter != IArray_access(iarray, i)) printf("error1 at %d\n", i);
    if (array + i != iter) printf("error2 at %d\n", i);
    printf("%c ", *iter);
  } IArray_ENDBACK;
  printf("\n");
  IArray_Dtor(iarray);
}


#endif//IArray__c_INCLUDED
