#ifndef IDList__c_INCLUDED
#define IDList__c_INCLUDED

#line 75 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IDList.xcc"
//
{
  printf("sizeof(IDListItemCell_) = %d\n", sizeof(IDListItemCell_));
  Except_ALWAYS(CDT_ALIGNED(sizeof(IDListItemCell_)));
}

#line 108 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IDList.xcc"
//
{
  printf("sizeof(IDList_) = %d\n", sizeof(IDList_));
}

#line 860 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IDList.xcc"
//
{
  int i, j = 0;
  IDList_ idlist[1];
  IDList_Ctor(idlist, Memory_Root);
  printf("push/pop/FOREACH:\n");
  for (i = 0; i < 16; i++) {
    Pair k = IDList_push(idlist, sizeof(Pair_));
    k->a = i, k->b = j;
    j = (j + 7) & 15;
  }
  while (!IDList_isEmpty(idlist)) {
    printf("[\t");
    IDList_FOREACH(idlist, Pair_, k) {
      printf("%d,%d\t", k->a, k->b);
    } IDList_ENDEACH;
    printf("]\n");
    IDList_pop(idlist, NULL);
  }
  printf("put/drop/FORBACK:\n");
  for (i = 0; i < 16; i++) {
    Pair k = IDList_put(idlist, sizeof(Pair_));
    k->a = i, k->b = j;
    j = (j + 7) & 15;
  }
  while (!IDList_isEmpty(idlist)) {
    printf("[\t");
    IDList_FORBACK(idlist, Pair_, k) {
      printf("%d,%d\t", k->a, k->b);
    } IDList_ENDBACK;
    printf("]\n");
    IDList_drop(idlist, NULL);
  }
  printf("circular test:\n");
  for (i = 0; i < 16 - 1; i++) {
    Pair k1 = IDList_push(idlist, sizeof(Pair_));
    Pair k2 = IDList_push(idlist, sizeof(Pair_));
    k1->a = i, k1->b = 2*i;
    k2->a = -i, k2->b = -2*i;
    IDList_drop(idlist, NULL);
  }
  printf("[\t");
  IDList_FOREACH(idlist, Pair_, k) {
    printf("%d\t", k->a);
  } IDList_ENDEACH;
  printf("]\n");
  printf("remove test:\n");
  i = 0;
  IDList_FOREACH(idlist, Pair_, k) {
    if (++i & 1) {
      printf("remove %d\n", k->a);
      IDList_remove(idlist, k, NULL);
    }
  } IDList_ENDEACH;
  printf("[\t");
  IDList_FOREACH(idlist, Pair_, k) {
    printf("%d\t", k->a);
  } IDList_ENDEACH;
  printf("]\n");
  printf("rotate 1:\n");
  IDList_rotate(idlist, 1);
  printf("[\t");
  IDList_FOREACH(idlist, Pair_, k) {
    printf("%d\t", k->a);
  } IDList_ENDEACH;
  printf("]\n");
  printf("rotate -2:\n");
  IDList_rotate(idlist, -2);
  printf("[\t");
  IDList_FOREACH(idlist, Pair_, k) {
    printf("%d\t", k->a);
  } IDList_ENDEACH;
  printf("]\n");
  IDList_Dtor(idlist);
}

#line 936 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IDList.xcc"
//
{
  IDList_ idlist[1];
  int maxCount = 50, i;
  IDList_Ctor(idlist, Memory_Root);
  for (i = 0; i < maxCount; i++) {
    IDList_PUSH(idlist, int, (47*i)%maxCount);
  }
  printf("list:\n  [\t");
  IDList_FOREACH(idlist, int, p) {
    printf("%d,\t", *p);
  } IDList_ENDEACH;
  printf("]\n");
  IDList_sort(idlist, int_compare);
  printf("sorted:\n  [\t");
  IDList_FOREACH(idlist, int, p) {
    printf("%d,\t", *p);
  } IDList_ENDEACH;
  printf("]\n");
  for (i = 1; i < maxCount; i++) {
    int factor = (47*i)%maxCount;
    IDList_ removed[1];
    IDList_Ctor(removed, Memory_Root);
    printf("remove multiples of %d:\t", factor);
    if (IDList_grep(idlist, removed, not_multiple, factor)) {
      IDList_FOREACH(removed, int, p) {
        printf("%d\t", *p);
      } IDList_ENDEACH;
    } else {
      Except_CHECK(IDList_isEmpty(removed));
      printf("(none)");
    }
    printf("\n");
    IDList_Dtor(removed);
  }
  IDList_Dtor(idlist);
}


#endif//IDList__c_INCLUDED
