#ifndef IETree__c_INCLUDED
#define IETree__c_INCLUDED

#line 144 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IETree.xcc"
//
{
  printf("sizeof(IETree_) = %d\n", sizeof(IETree_));
}

#line 207 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IETree.xcc"
//
{
  // Check Memory_alloc_ is safe in IETree_makeNode.
  Except_ALWAYS(CDT_ALIGNED(sizeof(IETreeNode_)));
}

#line 505 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IETree.xcc"
//
{
  int i = 0, j = 0, k = 5, l = 9;
  IETree_ ietree[1];
  IETree_Ctor(ietree, Memory_Root);
  IETree_insert(ietree, 5);
  IETree_insert(ietree, 2);
  IETree_insert(ietree, 8);
  IETree_remove(ietree, 5);
  IETree_remove(ietree, 2);
  IETree_remove(ietree, 8);
  printf("ietree:  \t");
  IETree_pretty(ietree, stdout);
  for (i = 0; i < 16; i++) {
    printf("insert %d:\t", (i*k)&15);
    IETree_insert(ietree, (i*k)&15);
    IETree_pretty(ietree, stdout);
  }
  do {
    j = (j + l)&15;
    printf("remove %d:\t", j);
    IETree_remove(ietree, j);
    IETree_pretty(ietree, stdout);
  } while (!IETree_isEmpty(ietree));
}

#line 586 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IETree.xcc"
//
{
  int max = 100, i;
  IETree_ sieve[1];
  IETree_ primes[1];
  IETree_Ctor(sieve, Memory_Root);
  IETree_Ctor(primes, Memory_Root);
  for (i = 2; i < max/2; i++) IETree_insert(sieve, (IETreeMember)i);
  for (i = max - 1; i >= max/2; i--) IETree_insert(sieve, (IETreeMember)i);
  while (!IETree_isEmpty(sieve)) {
    int j = (int)IETree_choose(sieve);
    printf("prime %d\n", j);
    IETree_insert(primes, (IETreeMember)j);
    for (i = j + j; i < max; i += j) IETree_remove(sieve, (IETreeMember)i);
    printf("sieve: ");
    IETree_FOREACH(sieve, iter) {
      printf("%d ", iter);
    } IETree_ENDEACH;
    printf("\n");
  }
  printf("primes: ");
  IETree_FOREACH(primes, iter) {
    printf("%d ", iter);
  } IETree_ENDEACH;
  printf("\n");
  IETree_Dtor(primes);
  IETree_Dtor(sieve);
}


#endif//IETree__c_INCLUDED
