#ifndef IQueue__c_INCLUDED
#define IQueue__c_INCLUDED

#line 70 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IQueue.xcc"
//
{
  printf("sizeof(IQueue_) = %d\n", sizeof(IQueue_));
}

#line 492 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IQueue.xcc"
//
{
  int i, j = 0;
  IQueue_ iqueue[1];
  IQueue_Ctor(iqueue, Memory_Root, sizeof(Pair_), 16);
  printf("push/pop/FOREACH:\n");
  for (i = 0; i < 16; i++) {
    Pair k = IQueue_push(iqueue);
    k->a = i, k->b = j;
    j = (j + 7) & 15;
  }
  while (!IQueue_isEmpty(iqueue)) {
    printf("[\t");
    IQueue_FOREACH(iqueue, Pair_, k) {
      printf("%d,%d\t", k->a, k->b);
    } IQueue_ENDEACH;
    printf("]\n");
    IQueue_pop_(iqueue);
  }
  printf("put/drop/FORBACK:\n");
  for (i = 0; i < 16; i++) {
    Pair k = IQueue_put(iqueue);
    k->a = i, k->b = j;
    j = (j + 7) & 15;
  }
  while (!IQueue_isEmpty(iqueue)) {
    printf("[\t");
    IQueue_FORBACK(iqueue, Pair_, k) {
      printf("%d,%d\t", k->a, k->b);
    } IQueue_ENDBACK;
    printf("]\n");
    IQueue_drop_(iqueue);
  }
  printf("circular test:\n");
  for (i = 0; i < 16 - 1; i++) {
    Pair k1 = IQueue_push(iqueue);
    Pair k2 = IQueue_push(iqueue);
    k1->a = i, k1->b = 2*i;
    k2->a = -i, k2->b = -2*i;
    IQueue_drop_(iqueue);
  }
  printf("[\t");
  IQueue_FOREACH(iqueue, Pair_, k) {
    printf("%d\t", k->a);
  } IQueue_ENDEACH;
  printf("]\n");
  IQueue_empty(iqueue, (IQueueItemRelease)Pair_Dtor);
  IQueue_Dtor(iqueue);
}


#endif//IQueue__c_INCLUDED
