#ifndef IStack__c_INCLUDED
#define IStack__c_INCLUDED

#line 70 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IStack.xcc"
//
{
  printf("sizeof(IStack_) = %d\n", sizeof(IStack_));
}

#line 418 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IStack.xcc"
//
{
  int16_t *array = 0;
  int count = 20, resized = 0, i;
  IStack_ istack[1];
  IStack_Ctor(istack, Memory_Root, sizeof(int16_t), count/5);
  for (i = 0 ; i < count; i++) {
    int16_t *item = IStack_push(istack);
    if (item) *item = 'a' + resized*('A' - 'a') + i;
    else {
      IStack_resize(istack, i+3);
      resized = resized ^ 0x1;
      --i;
    }
  }
  printf("Stack count = %d\n", count);
  i = 0;
  array = IStack_base(istack);
  IStack_FOREACH(istack, int16_t, iter) {
    if (iter != IStack_access(istack, i)) printf("error1 at %d\n", i);
    if (array + i != iter) printf("error2 at %d\n", i);
    printf("%c ", *iter);
    ++i;
  } IStack_ENDEACH;
  printf("\n");
  i = IStack_count(istack);
  array = IStack_base(istack);
  IStack_FORBACK(istack, int16_t, iter) {
    --i;
    if (iter != IStack_access(istack, i)) printf("error1 at %d\n", i);
    if (array + i != iter) printf("error2 at %d\n", i);
    printf("%c ", *iter);
  } IStack_ENDBACK;
  printf("\n");
  IStack_Dtor(istack);
}


#endif//IStack__c_INCLUDED
