#ifndef PtrSeq_c_INCLUDED
#define PtrSeq_c_INCLUDED

#line 18 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSeq.xcc"
#include "CCL/CCL_.h"

#line 23 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSeq.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 47 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSeq.xcc"
PtrSeq
PtrSeq_Ctor(PtrSeq this, Memory memory, int32_t maxCount)
{
  *PtrSeq__MEMORY(this) = memory;
  *PtrSeq__STATUS(this) = 0;
  *PtrSeq__BASE(this) = NULL;
  *PtrSeq__PAST(this) = NULL;
  if (maxCount > 0) PtrSeq_resize(this, maxCount);
  return this;
}

#line 58 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSeq.xcc"
void
PtrSeq_Dtor(PtrSeq this)
{
  Memory memory = PtrSeq_MEMORY(this);
  PtrSeq_empty(this);
  Memory_free(memory, PtrSeq_BASE(this));
}

#line 80 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSeq.xcc"
void
PtrSeq_resize(PtrSeq this, int32_t maxCount)
{
  Memory memory = PtrSeq_MEMORY(this);
  size_t itemSize = sizeof(PtrSeqItem);
  bool old_isOrdered = PtrSeq_ISORDERED(this);
  int32_t old_maxCount = PtrSeq_MAXCOUNT(this);
  if (maxCount > old_maxCount) {
    size_t maxSize = maxCount*itemSize;
    size_t alignedSize = CDT_ALIGN_NEXT(maxSize);
    char *new_base = Memory_alloc_(memory, alignedSize);
    char *old_base = (char *)PtrSeq_BASE(this);
    size_t old_usedSize = PtrSeq_USEDSIZE(this);
    if (old_usedSize != 0) {
      memcpy(new_base, old_base, old_usedSize);
      Memory_free_(memory, old_base);
    } else {
      Memory_free(memory, old_base);
    }
    *PtrSeq__PAST(this) = (PtrSeqItem *)(new_base + old_usedSize);
    *PtrSeq__BASE(this) = (PtrSeqItem *)(new_base);
    while ((alignedSize -= itemSize) >= maxSize) ++maxCount;
    *PtrSeq__STATUS(this) = ((maxCount<<1)|old_isOrdered);
  }
  Except_ENSURE(PtrSeq_PAST(this) >= PtrSeq_BASE(this));
  Except_ENSURE(PtrSeq_USEDSIZE(this) <= PtrSeq_MAXSIZE(this));
}

#line 114 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSeq.xcc"
void
PtrSeq_empty(PtrSeq this)
{
  PtrSeqItem base = PtrSeq_BASE(this);
  *PtrSeq__PAST(this) = base;
  Except_CHECK(PtrSeq_isEmpty(this));
}

#line 122 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSeq.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 212 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSeq.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 312 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSeq.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 369 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSeq.xcc"
#ifndef PtrSeq_MAGICCOUNT
#define PtrSeq_MAGICCOUNT 16
#endif//PtrSeq_MAGICCOUNT

#line 373 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSeq.xcc"
void
PtrSeq_push2(PtrSeq this, PtrSeqItem item)
{
  PtrSeqItem *past = PtrSeq_PAST(this);
  if (PtrSeq_isFull(this)) {
    int32_t newCount = PtrSeq_count(this)*2;
    if (newCount < PtrSeq_MAGICCOUNT) {
      newCount = PtrSeq_MAGICCOUNT;
    }
    PtrSeq_resize(this, newCount);
    past = PtrSeq_PAST(this);
    Except_CHECK(!PtrSeq_isFull(this));
  }
  *PtrSeq__PAST(this) = past + 1;
  *past = item;
}

#line 439 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSeq.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 451 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSeq.xcc"
#if XCC__C
static void
PtrSeq_TEST(void)
{
#include "CCL/PtrSeq_.c"
}

#line 458 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSeq.xcc"
int
main(int argc, char **argv)
{
  CCL_Test(PtrSeq_TEST);
  return 0;
}
#endif


#endif//PtrSeq_c_INCLUDED
