#ifndef PtrSet__c_INCLUDED
#define PtrSet__c_INCLUDED

#line 79 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSet.xcc"
//
{
  printf("sizeof(PtrSet_) = %d\n", sizeof(PtrSet_));
}

#line 364 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSet.xcc"
//
{
  PtrSet_ this_set[1];
  int tosort[] = {
    4, 45, 67, 4, 2, 2, 3, 4, 6, 8,
    9, 9, 7, 5, 4, 32, 3, 4, 5, 6, 6,
    4, 3, 2, 3, 5, 7, 8, 9, 8, 7, 6, 54
  };
  int count = sizeof(tosort)/sizeof(*tosort), i;
  PtrSet_Ctor(this_set, Memory_Root, 4);
  for (i = 0; i < count; i++) {
    PtrSet_addMember(this_set, (PtrSetMember)tosort[count - 1 - i]);
  }
  printf("unsorted = { ");
  PtrSet_FOREACH(this_set, intptr_t, member) {
    printf("%d ", (int)member);
  } PtrSet_ENDEACH;
  printf("}\n");
  PtrSet_makeOrder(this_set);
  printf("restored = { ");
  PtrSet_FOREACH(this_set, intptr_t, member) {
    printf("%d ", (int)member);
  } PtrSet_ENDEACH;
  printf("}\n");
  PtrSet_Dtor(this_set);
}

#line 635 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSet.xcc"
//
{
  PtrSet_ this_set[1];
  PtrSet_ that_set[1];
  PtrSet_Ctor(this_set, Memory_Root, 4);
  PtrSet_Ctor(that_set, Memory_Root, 3);
  PtrSet_insert(this_set, (PtrSetMember)1);
  PtrSet_insert(this_set, (PtrSetMember)2);
  PtrSet_insert(this_set, (PtrSetMember)3);
  PtrSet_insert(this_set, (PtrSetMember)4);
  PtrSet_insert(that_set, (PtrSetMember)3);
  PtrSet_insert(that_set, (PtrSetMember)4);
  PtrSet_insert(that_set, (PtrSetMember)5);
  PtrSet_assign(that_set, this_set);
  printf("{ 3 4 5 } assign { 1 2 3 4 } = { ");
  PtrSet_FOREACH(that_set, intptr_t, member) {
    printf("%d ", (int)member);
  } PtrSet_ENDEACH;
  printf("}\n");
  PtrSet_Dtor(that_set);
  PtrSet_Dtor(this_set);
}

#line 753 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSet.xcc"
//
{
  PtrSet_ this_set[1];
  PtrSet_ that_set[1];
  PtrSet_Ctor(this_set, Memory_Root, 4);
  PtrSet_Ctor(that_set, Memory_Root, 3);
  PtrSet_insert(this_set, (PtrSetMember)1);
  PtrSet_insert(this_set, (PtrSetMember)2);
  PtrSet_insert(this_set, (PtrSetMember)3);
  PtrSet_insert(this_set, (PtrSetMember)4);
  PtrSet_insert(that_set, (PtrSetMember)3);
  PtrSet_insert(that_set, (PtrSetMember)4);
  PtrSet_insert(that_set, (PtrSetMember)5);
  PtrSet_union(this_set, that_set);
  printf("{ 1 2 3 4 } union { 3 4 5 } = { ");
  PtrSet_FOREACH(this_set, intptr_t, member) {
    printf("%d ", (int)member);
  } PtrSet_ENDEACH;
  printf("}\n");
  PtrSet_Dtor(that_set);
  PtrSet_Dtor(this_set);
}

#line 776 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSet.xcc"
//
{
  PtrSet_ this_set[1];
  PtrSet_ that_set[1];
  PtrSet_Ctor(this_set, Memory_Root, 4);
  PtrSet_Ctor(that_set, Memory_Root, 3);
  PtrSet_insert(this_set, (PtrSetMember)1);
  PtrSet_insert(this_set, (PtrSetMember)2);
  PtrSet_insert(this_set, (PtrSetMember)3);
  PtrSet_insert(this_set, (PtrSetMember)4);
  PtrSet_insert(that_set, (PtrSetMember)3);
  PtrSet_insert(that_set, (PtrSetMember)4);
  PtrSet_insert(that_set, (PtrSetMember)5);
  PtrSet_union(that_set, this_set);
  printf("{ 3 4 5 } union { 1 2 3 4 } = { ");
  PtrSet_FOREACH(that_set, intptr_t, member) {
    printf("%d ", (int)member);
  } PtrSet_ENDEACH;
  printf("}\n");
  PtrSet_Dtor(that_set);
  PtrSet_Dtor(this_set);
}

#line 833 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSet.xcc"
//
{
  PtrSet_ this_set[1];
  PtrSet_ that_set[1];
  PtrSet_Ctor(this_set, Memory_Root, 4);
  PtrSet_Ctor(that_set, Memory_Root, 3);
  PtrSet_insert(this_set, (PtrSetMember)1);
  PtrSet_insert(this_set, (PtrSetMember)2);
  PtrSet_insert(this_set, (PtrSetMember)3);
  PtrSet_insert(this_set, (PtrSetMember)4);
  PtrSet_insert(that_set, (PtrSetMember)3);
  PtrSet_insert(that_set, (PtrSetMember)4);
  PtrSet_insert(that_set, (PtrSetMember)5);
  PtrSet_inter(this_set, that_set);
  printf("{ 1 2 3 4 } inter { 3 4 5 } = { ");
  PtrSet_FOREACH(this_set, intptr_t, member) {
    printf("%d ", (int)member);
  } PtrSet_ENDEACH;
  printf("}\n");
  PtrSet_Dtor(that_set);
  PtrSet_Dtor(this_set);
}

#line 856 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSet.xcc"
//
{
  PtrSet_ this_set[1];
  PtrSet_ that_set[1];
  PtrSet_Ctor(this_set, Memory_Root, 4);
  PtrSet_Ctor(that_set, Memory_Root, 3);
  PtrSet_insert(this_set, (PtrSetMember)1);
  PtrSet_insert(this_set, (PtrSetMember)2);
  PtrSet_insert(this_set, (PtrSetMember)3);
  PtrSet_insert(this_set, (PtrSetMember)4);
  PtrSet_insert(that_set, (PtrSetMember)3);
  PtrSet_insert(that_set, (PtrSetMember)4);
  PtrSet_insert(that_set, (PtrSetMember)5);
  PtrSet_inter(that_set, this_set);
  printf("{ 3 4 5 } inter { 1 2 3 4 } = { ");
  PtrSet_FOREACH(that_set, intptr_t, member) {
    printf("%d ", (int)member);
  } PtrSet_ENDEACH;
  printf("}\n");
  PtrSet_Dtor(that_set);
  PtrSet_Dtor(this_set);
}

#line 904 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSet.xcc"
//
{
  PtrSet_ this_set[1];
  PtrSet_ that_set[1];
  PtrSet_Ctor(this_set, Memory_Root, 4);
  PtrSet_Ctor(that_set, Memory_Root, 3);
  PtrSet_insert(this_set, (PtrSetMember)1);
  PtrSet_insert(this_set, (PtrSetMember)2);
  PtrSet_insert(this_set, (PtrSetMember)3);
  PtrSet_insert(this_set, (PtrSetMember)4);
  PtrSet_insert(that_set, (PtrSetMember)3);
  PtrSet_insert(that_set, (PtrSetMember)4);
  PtrSet_insert(that_set, (PtrSetMember)5);
  printf("{ 3 4 5 } overlap { 1 2 3 4 } = %d\n",
         PtrSet_overlap(this_set, that_set));
  PtrSet_remove(that_set, (PtrSetMember)3);
  printf("{ 4 5 } overlap { 1 2 3 4 } = %d\n",
         PtrSet_overlap(this_set, that_set));
  PtrSet_remove(this_set, (PtrSetMember)4);
  printf("{ 4 5 } overlap { 1 2 3 } = %d\n",
         PtrSet_overlap(this_set, that_set));
  PtrSet_Dtor(that_set);
  PtrSet_Dtor(this_set);
}

#line 963 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSet.xcc"
//
{
  PtrSet_ this_set[1];
  PtrSet_ that_set[1];
  PtrSet_Ctor(this_set, Memory_Root, 4);
  PtrSet_Ctor(that_set, Memory_Root, 3);
  PtrSet_insert(this_set, (PtrSetMember)1);
  PtrSet_insert(this_set, (PtrSetMember)2);
  PtrSet_insert(this_set, (PtrSetMember)3);
  PtrSet_insert(this_set, (PtrSetMember)4);
  PtrSet_insert(that_set, (PtrSetMember)3);
  PtrSet_insert(that_set, (PtrSetMember)4);
  PtrSet_insert(that_set, (PtrSetMember)5);
  PtrSet_diff(this_set, that_set);
  printf("{ 1 2 3 4 } diff { 3 4 5 } = { ");
  PtrSet_FOREACH(this_set, intptr_t, member) {
    printf("%d ", (int)member);
  } PtrSet_ENDEACH;
  printf("}\n");
  PtrSet_Dtor(that_set);
  PtrSet_Dtor(this_set);
}

#line 986 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSet.xcc"
//
{
  PtrSet_ this_set[1];
  PtrSet_ that_set[1];
  PtrSet_Ctor(this_set, Memory_Root, 4);
  PtrSet_Ctor(that_set, Memory_Root, 3);
  PtrSet_insert(this_set, (PtrSetMember)1);
  PtrSet_insert(this_set, (PtrSetMember)2);
  PtrSet_insert(this_set, (PtrSetMember)3);
  PtrSet_insert(this_set, (PtrSetMember)4);
  PtrSet_insert(that_set, (PtrSetMember)3);
  PtrSet_insert(that_set, (PtrSetMember)4);
  PtrSet_insert(that_set, (PtrSetMember)5);
  PtrSet_diff(that_set, this_set);
  printf("{ 3 4 5 } diff { 1 2 3 4 } = { ");
  PtrSet_FOREACH(that_set, intptr_t, member) {
    printf("%d ", (int)member);
  } PtrSet_ENDEACH;
  printf("}\n");
  PtrSet_Dtor(that_set);
  PtrSet_Dtor(this_set);
}

#line 1009 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PtrSet.xcc"
//
{
  int max = 100, i;
  PtrSet_ sieve[1];
  PtrSet_ primes[1];
  PtrSet_Ctor(sieve, Memory_Root, 5);
  PtrSet_Ctor(primes, Memory_Root, 5);
  for (i = 2; i < max/2; i++) PtrSet_insert(sieve, (PtrSetMember)i);
  for (i = max - 1; i >= max/2; i--) PtrSet_insert(sieve, (PtrSetMember)i);
  while (!PtrSet_isEmpty(sieve)) {
    int j = (int)PtrSet_choose(sieve);
    printf("prime %d\n", j);
    PtrSet_insert(primes, (PtrSetMember)j);
    for (i = j + j; i < max; i += j) PtrSet_remove(sieve, (PtrSetMember)i);
    printf("sieve: ");
    PtrSet_FOREACH(sieve, intptr_t, member) {
      printf("%d ", (int)member);
    } PtrSet_ENDEACH;
    printf("\n");
  }
  printf("primes: ");
  PtrSet_FOREACH(primes, intptr_t, member) {
    printf("%d ", (int)member);
  } PtrSet_ENDEACH;
  printf("\n");
  PtrSet_Dtor(primes);
  PtrSet_Dtor(sieve);
}


#endif//PtrSet__c_INCLUDED
