	.file	"DGraph.c"
	.text
	.p2align 4,,15
.globl DGraphArc_attachTailNode
	.type	DGraphArc_attachTailNode, @function
DGraphArc_attachTailNode:
	pushl	%ebp
	movl	%esp, %ebp
	movl	12(%ebp), %ecx
	movl	8(%ebp), %eax
	leal	-16(%ecx), %edx
	movl	%ecx, -16(%eax)
	movl	8(%edx), %ecx
	movl	%ecx, -8(%eax)
	movl	%eax, 8(%edx)
	popl	%ebp
	ret
	.size	DGraphArc_attachTailNode, .-DGraphArc_attachTailNode
	.p2align 4,,15
.globl DGraphArc_attachHeadNode
	.type	DGraphArc_attachHeadNode, @function
DGraphArc_attachHeadNode:
	pushl	%ebp
	movl	%esp, %ebp
	movl	8(%ebp), %edx
	pushl	%esi
	movl	12(%ebp), %esi
	leal	-16(%edx), %ecx
	leal	-16(%esi), %eax
	movl	%esi, 4(%ecx)
	movl	12(%eax), %esi
	movl	%esi, 12(%ecx)
	movl	%edx, 12(%eax)
	popl	%esi
	popl	%ebp
	ret
	.size	DGraphArc_attachHeadNode, .-DGraphArc_attachHeadNode
	.p2align 4,,15
.globl DGraphArc_detachTailNode
	.type	DGraphArc_detachTailNode, @function
DGraphArc_detachTailNode:
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%edi
	pushl	%esi
	subl	$4, %esp
	movl	8(%ebp), %esi
	movl	-16(%esi), %eax
	leal	-16(%esi), %edi
	subl	$16, %eax
	movl	8(%eax), %edx
	movl	%eax, -12(%ebp)
	cmpl	%edx, %esi
	jne	.L9
	jmp	.L13
	.p2align 4,,7
	.p2align 3
.L8:
	movl	%eax, %edx
.L9:
	leal	-16(%edx), %ecx
	movl	8(%ecx), %eax
	cmpl	%eax, %esi
	jne	.L8
	testl	%edx, %edx
	je	.L4
	movl	-8(%esi), %eax
	movl	%eax, 8(%ecx)
.L6:
	movl	$0, 8(%edi)
	movl	$0, -16(%esi)
	addl	$4, %esp
	popl	%esi
	popl	%edi
	popl	%ebp
	ret
.L13:
	movl	%esi, %eax
.L4:
	movl	-8(%eax), %eax
	movl	-12(%ebp), %edx
	movl	%eax, 8(%edx)
	jmp	.L6
	.size	DGraphArc_detachTailNode, .-DGraphArc_detachTailNode
	.p2align 4,,15
.globl DGraphArc_detachHeadNode
	.type	DGraphArc_detachHeadNode, @function
DGraphArc_detachHeadNode:
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%edi
	pushl	%esi
	subl	$4, %esp
	movl	8(%ebp), %esi
	leal	-16(%esi), %edi
	movl	4(%edi), %eax
	subl	$16, %eax
	movl	12(%eax), %edx
	movl	%eax, -12(%ebp)
	cmpl	%edx, %esi
	jne	.L20
	jmp	.L23
	.p2align 4,,7
	.p2align 3
.L19:
	movl	%eax, %edx
.L20:
	leal	-16(%edx), %ecx
	movl	12(%ecx), %eax
	cmpl	%eax, %esi
	jne	.L19
	testl	%edx, %edx
	je	.L15
	movl	-4(%esi), %eax
	movl	%eax, 12(%ecx)
.L17:
	movl	$0, 12(%edi)
	movl	$0, 4(%edi)
	addl	$4, %esp
	popl	%esi
	popl	%edi
	popl	%ebp
	ret
.L23:
	movl	%esi, %eax
.L15:
	movl	-4(%eax), %eax
	movl	-12(%ebp), %edx
	movl	%eax, 12(%edx)
	jmp	.L17
	.size	DGraphArc_detachHeadNode, .-DGraphArc_detachHeadNode
	.p2align 4,,15
.globl DGraphNode_detachEnterArcs
	.type	DGraphNode_detachEnterArcs, @function
DGraphNode_detachEnterArcs:
	pushl	%ebp
	movl	%esp, %ebp
	movl	8(%ebp), %ecx
	subl	$16, %ecx
	movl	12(%ecx), %edx
	testl	%edx, %edx
	je	.L25
	.p2align 4,,7
	.p2align 3
.L27:
	leal	-16(%edx), %eax
	movl	12(%eax), %edx
	movl	$0, 4(%eax)
	movl	$0, 12(%eax)
	testl	%edx, %edx
	jne	.L27
.L25:
	movl	$0, 12(%ecx)
	popl	%ebp
	ret
	.size	DGraphNode_detachEnterArcs, .-DGraphNode_detachEnterArcs
	.p2align 4,,15
.globl DGraphNode_detachLeaveArcs
	.type	DGraphNode_detachLeaveArcs, @function
DGraphNode_detachLeaveArcs:
	pushl	%ebp
	movl	%esp, %ebp
	movl	8(%ebp), %ecx
	subl	$16, %ecx
	movl	8(%ecx), %edx
	testl	%edx, %edx
	je	.L30
	.p2align 4,,7
	.p2align 3
.L32:
	leal	-16(%edx), %eax
	movl	8(%eax), %edx
	movl	$0, (%eax)
	movl	$0, 8(%eax)
	testl	%edx, %edx
	jne	.L32
.L30:
	movl	$0, 8(%ecx)
	popl	%ebp
	ret
	.size	DGraphNode_detachLeaveArcs, .-DGraphNode_detachLeaveArcs
	.p2align 4,,15
.globl DGraphNode_sortLeaveArcs
	.type	DGraphNode_sortLeaveArcs, @function
DGraphNode_sortLeaveArcs:
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%edi
	pushl	%esi
	pushl	%ebx
	subl	$572, %esp
	movl	8(%ebp), %eax
	call	__i686.get_pc_thunk.bx
	addl	$_GLOBAL_OFFSET_TABLE_, %ebx
	subl	$16, %eax
	movl	8(%eax), %edi
	movl	%eax, -544(%ebp)
	testl	%edi, %edi
	je	.L34
	movl	-8(%edi), %esi
	testl	%esi, %esi
	je	.L34
	movl	%edi, %eax
	xorl	%edx, %edx
	movb	$1, -540(%ebp)
	jmp	.L38
	.p2align 4,,7
	.p2align 3
.L51:
	movl	%edi, %eax
	movl	%esi, %edi
	movl	-8(%esi), %esi
	movl	%ecx, %edx
.L38:
	movl	%edx, -552(%ebp)
	movl	%edi, 4(%esp)
	movl	%eax, (%esp)
	call	*12(%ebp)
	movl	-552(%ebp), %edx
	leal	1(%edx), %ecx
	testl	%eax, %eax
	setg	%al
	subl	$1, %eax
	andb	%al, -540(%ebp)
	testl	%esi, %esi
	jne	.L51
	cmpb	$0, -540(%ebp)
	movl	%ecx, -548(%ebp)
	jne	.L34
	cmpl	$128, %ecx
	leal	-536(%ebp), %eax
	jle	.L50
	movl	Memory_Root@GOT(%ebx), %eax
	sall	$2, %ecx
	movl	(%eax), %esi
	xorl	%eax, %eax
	testl	%ecx, %ecx
	jne	.L52
.L50:
	movl	-544(%ebp), %esi
	movl	%eax, -540(%ebp)
	movl	8(%esi), %ecx
	movl	%eax, %esi
	testl	%ecx, %ecx
	jne	.L42
	jmp	.L41
	.p2align 4,,7
	.p2align 3
.L48:
	movl	%edi, %ecx
.L42:
	movl	-8(%ecx), %edi
	movl	%ecx, (%esi)
	addl	$4, %esi
	testl	%edi, %edi
	jne	.L48
.L41:
	movl	12(%ebp), %ecx
	movl	%edx, 8(%esp)
	movl	%eax, (%esp)
	movl	%eax, -556(%ebp)
	movl	%ecx, 12(%esp)
	movl	%edx, -552(%ebp)
	movl	$0, 4(%esp)
	call	HackerPtr_Sort@PLT
	movl	-556(%ebp), %eax
	movl	-544(%ebp), %esi
	movl	(%eax), %ecx
	movl	%ecx, 8(%esi)
	movl	-552(%ebp), %edx
	testl	%edx, %edx
	je	.L43
	xorl	%ecx, %ecx
	.p2align 4,,7
	.p2align 3
.L44:
	movl	(%eax,%ecx,4), %esi
	movl	4(%eax,%ecx,4), %edi
	addl	$1, %ecx
	cmpl	%edx, %ecx
	movl	%edi, -8(%esi)
	jne	.L44
	leal	(%eax,%ecx,4), %ecx
	movl	%ecx, -540(%ebp)
.L43:
	movl	-540(%ebp), %ecx
	cmpl	$128, -548(%ebp)
	movl	(%ecx), %edx
	movl	$0, -8(%edx)
	jg	.L53
.L34:
	addl	$572, %esp
	popl	%ebx
	popl	%esi
	popl	%edi
	popl	%ebp
	ret
	.p2align 4,,7
	.p2align 3
.L53:
	movl	%eax, 4(%esp)
	movl	Memory_Root@GOT(%ebx), %eax
	movl	(%eax), %eax
	movl	%eax, (%esp)
	call	Memory_free_@PLT
	addl	$572, %esp
	popl	%ebx
	popl	%esi
	popl	%edi
	popl	%ebp
	ret
.L52:
	movl	%edx, -552(%ebp)
	movl	%ecx, 4(%esp)
	movl	%esi, (%esp)
	call	Memory_alloc_@PLT
	movl	-552(%ebp), %edx
	jmp	.L50
	.size	DGraphNode_sortLeaveArcs, .-DGraphNode_sortLeaveArcs
	.p2align 4,,15
.globl DGraphArcCell_Ctor
	.type	DGraphArcCell_Ctor, @function
DGraphArcCell_Ctor:
	pushl	%ebp
	movl	%esp, %ebp
	movl	8(%ebp), %eax
	movl	$0, (%eax)
	movl	$0, 4(%eax)
	movl	$0, 8(%eax)
	movl	$0, 12(%eax)
	popl	%ebp
	ret
	.size	DGraphArcCell_Ctor, .-DGraphArcCell_Ctor
	.p2align 4,,15
.globl DGraphArcCell_Dtor
	.type	DGraphArcCell_Dtor, @function
DGraphArcCell_Dtor:
	pushl	%ebp
	movl	%esp, %ebp
	movl	8(%ebp), %eax
	movl	$0, (%eax)
	movl	$0, 4(%eax)
	movl	$0, 8(%eax)
	movl	$0, 12(%eax)
	popl	%ebp
	ret
	.size	DGraphArcCell_Dtor, .-DGraphArcCell_Dtor
	.p2align 4,,15
.globl DGraphNodeCell_Ctor
	.type	DGraphNodeCell_Ctor, @function
DGraphNodeCell_Ctor:
	pushl	%ebp
	movl	%esp, %ebp
	movl	8(%ebp), %eax
	movl	12(%ebp), %edx
	movl	$0, 4(%eax)
	movl	%edx, (%eax)
	movl	$0, 8(%eax)
	movl	$0, 12(%eax)
	popl	%ebp
	ret
	.size	DGraphNodeCell_Ctor, .-DGraphNodeCell_Ctor
	.p2align 4,,15
.globl DGraphNodeCell_Dtor
	.type	DGraphNodeCell_Dtor, @function
DGraphNodeCell_Dtor:
	pushl	%ebp
	movl	%esp, %ebp
	movl	8(%ebp), %eax
	movl	$0, 4(%eax)
	movl	$0, 8(%eax)
	movl	$0, 12(%eax)
	popl	%ebp
	ret
	.size	DGraphNodeCell_Dtor, .-DGraphNodeCell_Dtor
	.p2align 4,,15
.globl DGraph_Ctor
	.type	DGraph_Ctor, @function
DGraph_Ctor:
	pushl	%ebp
	movl	%esp, %ebp
	subl	$24, %esp
	movl	%esi, -4(%ebp)
	movl	16(%ebp), %eax
	movl	8(%ebp), %esi
	movl	%ebx, -8(%ebp)
	call	__i686.get_pc_thunk.bx
	addl	$_GLOBAL_OFFSET_TABLE_, %ebx
	movl	$0, (%esi)
	movl	$0, 4(%esi)
	movl	$0, 8(%esi)
	movl	$0, 12(%esi)
	movl	%eax, 8(%esp)
	movl	12(%ebp), %eax
	movl	%eax, 4(%esp)
	leal	16(%esi), %eax
	movl	%eax, (%esp)
	call	PtrSeq_Ctor@PLT
	movl	%esi, %eax
	movl	-8(%ebp), %ebx
	movl	-4(%ebp), %esi
	movl	%ebp, %esp
	popl	%ebp
	ret
	.size	DGraph_Ctor, .-DGraph_Ctor
	.p2align 4,,15
.globl DGraph_Dtor
	.type	DGraph_Dtor, @function
DGraph_Dtor:
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%ebx
	call	__i686.get_pc_thunk.bx
	addl	$_GLOBAL_OFFSET_TABLE_, %ebx
	subl	$20, %esp
	movl	8(%ebp), %eax
	addl	$16, %eax
	movl	%eax, (%esp)
	call	PtrSeq_Dtor@PLT
	addl	$20, %esp
	popl	%ebx
	popl	%ebp
	ret
	.size	DGraph_Dtor, .-DGraph_Dtor
	.p2align 4,,15
.globl DGraph_empty
	.type	DGraph_empty, @function
DGraph_empty:
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%edi
	pushl	%esi
	pushl	%ebx
	subl	$60, %esp
	movl	8(%ebp), %eax
	movl	8(%ebp), %edx
	call	__i686.get_pc_thunk.bx
	addl	$_GLOBAL_OFFSET_TABLE_, %ebx
	movl	16(%eax), %eax
	movl	24(%edx), %edx
	movl	%eax, -36(%ebp)
	movl	8(%ebp), %eax
	movl	%edx, -56(%ebp)
	movl	28(%eax), %eax
	subl	%edx, %eax
	sarl	$2, %eax
	testl	%eax, %eax
	movl	%eax, -52(%ebp)
	jle	.L61
	movl	$0, -40(%ebp)
	.p2align 4,,7
	.p2align 3
.L67:
	movl	-40(%ebp), %edx
	movl	-56(%ebp), %eax
	movl	(%eax,%edx,4), %edx
	movl	%edx, -48(%ebp)
	subl	$16, %edx
	movl	8(%edx), %edi
	movl	%edx, -44(%ebp)
	testl	%edi, %edi
	je	.L63
	subl	$16, %edi
	movl	8(%edi), %esi
	movl	%edi, -28(%ebp)
	testl	%esi, %esi
	je	.L70
	.p2align 4,,7
	.p2align 3
.L65:
	leal	-16(%esi), %edi
	movl	-28(%ebp), %edx
	movl	8(%edi), %eax
	movl	%edx, (%esp)
	movl	%eax, -32(%ebp)
	call	DGraphArcCell_Dtor@PLT
	movl	16(%ebp), %edx
	testl	%edx, %edx
	je	.L64
	movl	%esi, (%esp)
	call	*16(%ebp)
.L64:
	movl	-28(%ebp), %eax
	movl	-36(%ebp), %edx
	movl	%eax, 4(%esp)
	movl	%edx, (%esp)
	call	Memory_free_@PLT
	movl	-32(%ebp), %esi
	movl	%edi, -28(%ebp)
	testl	%esi, %esi
	jne	.L65
.L70:
	movl	-28(%ebp), %edi
	movl	%edi, (%esp)
	call	DGraphArcCell_Dtor@PLT
	movl	-36(%ebp), %eax
	movl	%edi, 4(%esp)
	movl	%eax, (%esp)
	call	Memory_free_@PLT
.L63:
	movl	-44(%ebp), %edx
	movl	%edx, (%esp)
	call	DGraphNodeCell_Dtor@PLT
	movl	12(%ebp), %eax
	testl	%eax, %eax
	je	.L66
	movl	-48(%ebp), %eax
	movl	%eax, (%esp)
	call	*12(%ebp)
.L66:
	movl	-44(%ebp), %edx
	movl	-36(%ebp), %eax
	movl	%edx, 4(%esp)
	movl	%eax, (%esp)
	call	Memory_free_@PLT
	movl	-52(%ebp), %edx
	addl	$1, -40(%ebp)
	cmpl	%edx, -40(%ebp)
	jl	.L67
.L61:
	movl	8(%ebp), %eax
	movl	$0, (%eax)
	movl	$0, 4(%eax)
	movl	$0, 8(%eax)
	movl	$0, 12(%eax)
	addl	$16, %eax
	movl	%eax, (%esp)
	call	PtrSeq_empty@PLT
	addl	$60, %esp
	popl	%ebx
	popl	%esi
	popl	%edi
	popl	%ebp
	ret
	.size	DGraph_empty, .-DGraph_empty
	.p2align 4,,15
.globl DGraph_makeNode
	.type	DGraph_makeNode, @function
DGraph_makeNode:
	pushl	%ebp
	movl	%esp, %ebp
	subl	$56, %esp
	movl	12(%ebp), %eax
	movl	%esi, -8(%ebp)
	movl	8(%ebp), %esi
	movl	%ebx, -12(%ebp)
	call	__i686.get_pc_thunk.bx
	addl	$_GLOBAL_OFFSET_TABLE_, %ebx
	addl	$19, %eax
	andl	$-4, %eax
	movl	%edi, -4(%ebp)
	movl	%eax, 4(%esp)
	movl	16(%esi), %eax
	movl	%eax, (%esp)
	call	Memory_alloc_@PLT
	movl	28(%esi), %edi
	leal	16(%esi), %ecx
	subl	24(%esi), %edi
	movl	%ecx, (%esp)
	sarl	$2, %edi
	leal	16(%eax), %edx
	movl	%edx, 4(%esp)
	movl	%edx, -28(%ebp)
	movl	%eax, -32(%ebp)
	call	PtrSeq_push2@PLT
	movl	-32(%ebp), %eax
	movl	%edi, 4(%esp)
	movl	%eax, (%esp)
	call	DGraphNodeCell_Ctor@PLT
	testl	%edi, %edi
	movl	-28(%ebp), %edx
	jne	.L72
	movl	%edx, (%esi)
.L72:
	addl	$1, 8(%esi)
	movl	%edx, %eax
	movl	-12(%ebp), %ebx
	movl	-8(%ebp), %esi
	movl	-4(%ebp), %edi
	movl	%ebp, %esp
	popl	%ebp
	ret
	.size	DGraph_makeNode, .-DGraph_makeNode
	.p2align 4,,15
.globl DGraph_makeArc
	.type	DGraph_makeArc, @function
DGraph_makeArc:
	pushl	%ebp
	movl	%esp, %ebp
	subl	$56, %esp
	movl	20(%ebp), %eax
	movl	%esi, -8(%ebp)
	movl	8(%ebp), %esi
	movl	%ebx, -12(%ebp)
	call	__i686.get_pc_thunk.bx
	addl	$_GLOBAL_OFFSET_TABLE_, %ebx
	addl	$19, %eax
	andl	$-4, %eax
	movl	%edi, -4(%ebp)
	movl	16(%ebp), %edi
	movl	%eax, 4(%esp)
	movl	16(%esi), %eax
	movl	%eax, (%esp)
	call	Memory_alloc_@PLT
	movl	%eax, (%esp)
	call	DGraphArcCell_Ctor@PLT
	movl	12(%ebp), %ecx
	addl	$16, %eax
	testl	%ecx, %ecx
	je	.L74
	movl	12(%ebp), %edx
	movl	%eax, (%esp)
	movl	%eax, -28(%ebp)
	movl	%edx, 4(%esp)
	call	DGraphArc_attachTailNode@PLT
	movl	-28(%ebp), %eax
.L74:
	testl	%edi, %edi
	je	.L75
	movl	%eax, (%esp)
	movl	%eax, -28(%ebp)
	movl	%edi, 4(%esp)
	call	DGraphArc_attachHeadNode@PLT
	movl	-28(%ebp), %eax
.L75:
	addl	$1, 12(%esi)
	movl	-12(%ebp), %ebx
	movl	-8(%ebp), %esi
	movl	-4(%ebp), %edi
	movl	%ebp, %esp
	popl	%ebp
	ret
	.size	DGraph_makeArc, .-DGraph_makeArc
	.p2align 4,,15
.globl DGraph_getArc
	.type	DGraph_getArc, @function
DGraph_getArc:
	pushl	%ebp
	movl	%esp, %ebp
	movl	12(%ebp), %eax
	pushl	%edi
	movl	16(%ebp), %edi
	pushl	%esi
	movl	20(%ebp), %esi
	movl	-8(%eax), %ecx
	xorl	%eax, %eax
	testl	%ecx, %ecx
	jne	.L83
	jmp	.L77
	.p2align 4,,7
	.p2align 3
.L82:
	movl	%edx, %ecx
.L83:
	leal	-16(%ecx), %eax
	cmpl	%edi, 4(%eax)
	movl	8(%eax), %edx
	jne	.L78
	testl	%esi, %esi
	je	.L81
	subl	$1, %esi
.L78:
	testl	%edx, %edx
	jne	.L82
	xorl	%eax, %eax
.L77:
	popl	%esi
	popl	%edi
	popl	%ebp
	ret
	.p2align 4,,7
	.p2align 3
.L81:
	movl	%ecx, %eax
	popl	%esi
	popl	%edi
	popl	%ebp
	ret
	.size	DGraph_getArc, .-DGraph_getArc
	.p2align 4,,15
.globl DGraph_removeArc
	.type	DGraph_removeArc, @function
DGraph_removeArc:
	pushl	%ebp
	movl	%esp, %ebp
	subl	$56, %esp
	movl	%esi, -8(%ebp)
	movl	12(%ebp), %esi
	movl	%edi, -4(%ebp)
	movl	8(%ebp), %edi
	movl	%ebx, -12(%ebp)
	call	__i686.get_pc_thunk.bx
	addl	$_GLOBAL_OFFSET_TABLE_, %ebx
	movl	-16(%esi), %edx
	movl	16(%edi), %eax
	testl	%edx, %edx
	movl	%eax, -32(%ebp)
	leal	-16(%esi), %eax
	movl	%eax, -28(%ebp)
	je	.L85
	movl	%esi, (%esp)
	call	DGraphArc_detachTailNode@PLT
.L85:
	movl	-28(%ebp), %eax
	movl	4(%eax), %eax
	testl	%eax, %eax
	je	.L86
	movl	%esi, (%esp)
	call	DGraphArc_detachHeadNode@PLT
.L86:
	movl	-28(%ebp), %eax
	movl	%eax, (%esp)
	call	DGraphArcCell_Dtor@PLT
	movl	-28(%ebp), %eax
	movl	%eax, 4(%esp)
	movl	-32(%ebp), %eax
	movl	%eax, (%esp)
	call	Memory_free_@PLT
	subl	$1, 12(%edi)
	movl	-12(%ebp), %ebx
	movl	-8(%ebp), %esi
	movl	-4(%ebp), %edi
	movl	%ebp, %esp
	popl	%ebp
	ret
	.size	DGraph_removeArc, .-DGraph_removeArc
	.comm	escape,4,4
	.section	.text.__i686.get_pc_thunk.bx,"axG",@progbits,__i686.get_pc_thunk.bx,comdat
.globl __i686.get_pc_thunk.bx
	.hidden	__i686.get_pc_thunk.bx
	.type	__i686.get_pc_thunk.bx, @function
__i686.get_pc_thunk.bx:
	movl	(%esp), %ebx
	ret
	.ident	"GCC: (SUSE Linux) 4.5.1 20101208 [gcc-4_5-branch revision 167585]"
	.section	.comment.SUSE.OPTs,"MS",@progbits,1
	.string	"OspWg"
	.section	.note.GNU-stack,"",@progbits
