#ifndef Label_c_INCLUDED
#define Label_c_INCLUDED

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Label.xcc"
#include "AIR/AIR_.h"

#line 26 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Label.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 33 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Label.xcc"
uint32_t Label_NameCounter = 0;

#line 58 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Label.xcc"
Label
Label_Ctor(Label this,
           uint32_t index, String name)
{
  Indexed_Ctor(Label____(this), Label_Factory);
  *Label__INDEX(this) = index;
  *Label__VALUE(this) = 0;
  *Label__NAME(this) = name;
  return this;
}

#line 69 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Label.xcc"
size_t
Label_Size(uint32_t index, String name)
{
  return sizeof(Label_);
}

#line 80 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Label.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 118 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Label.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 133 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Label.xcc"
LabelTable
LabelTable_Ctor(LabelTable this,
                Memory memory, int32_t estimate)
{
  StringStore_Ctor(LabelTable_STRINGS(this), memory);
  HTable_Ctor(LabelTable_HTABLE(this), memory, estimate);
  *LabelTable__INDEXGEN(this) = 0;
  return this;
}

#line 143 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Label.xcc"
void
LabelTable_Dtor(LabelTable this)
{
  StringStore_Dtor(LabelTable_STRINGS(this));
  HTable_Dtor(LabelTable_HTABLE(this));
}

#line 150 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Label.xcc"
size_t
LabelTable_Size(Memory memory, int32_t estimate)
{
  return sizeof(LabelTable_);
}

#line 165 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Label.xcc"
#ifndef LabelTable_POOLED
#define LabelTable_POOLED 128
#endif//LabelTable_POOLED

#line 169 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Label.xcc"
LabelTable
LabelTable_new(Memory parent, int32_t estimate)
{
  Memory memory = Memory_new(parent, LabelTable_POOLED);
  size_t size = LabelTable_Size(memory, estimate);
  LabelTable this = Memory_alloc(memory, size);
  return LabelTable_Ctor(this, memory, estimate);
}

#line 182 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Label.xcc"
LabelTable
LabelTable_delete(LabelTable this)
{
  if (this != NULL) {
    Memory memory = LabelTable_MEMORY(this);
#ifndef ECL_NDTOR
    LabelTable_Dtor(this);
    Memory_free_(memory, this);
#endif//ECL_NDTOR
    Memory_delete(memory);
  }
  return NULL;
}

#line 221 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Label.xcc"
Label
LabelTable_search(LabelTable this, uint32_t index)
{
  HTableKey key = (HTableKey)index;
  HTable htable = LabelTable_HTABLE(this);
  return HTable_search(htable, key);
}

#line 235 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Label.xcc"
Label
LabelTable_lookup(LabelTable this, uint32_t index, const char *name)
{
  HTableKey key = (HTableKey)index;
  HTable htable = LabelTable_HTABLE(this);
  int32_t count = HTable_count(htable);
  size_t size = Label_Size(index, name);
  Label label = HTable_lookup_(htable, key, size);
  if (count != HTable_count(htable)) {
    StringStore strings = LabelTable_STRINGS(this);
    String string = StringStore_S(strings, name);
    Label_Ctor(label, index, string);
  }
  return label;
}

#line 258 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Label.xcc"
Label
LabelTable_insert(LabelTable this, uint32_t index, const char *name)
{
  HTableKey key = (HTableKey)index;
  size_t size = Label_Size(index, name);
  HTable htable = LabelTable_HTABLE(this);
  Label label = HTable_insert(htable, key, size);
  if (label != NULL) {
    StringStore strings = LabelTable_STRINGS(this);
    String string = StringStore_S(strings, name);
    Label_Ctor(label, index, string);
  }
  return label;
}

#line 282 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Label.xcc"
Label
LabelTable_makeLabel(LabelTable this)
{
  char buffer[32];
  int32_t index = (*LabelTable__INDEXGEN(this) -= 256);
  uint32_t number =  ++Label_NameCounter;
  int length = 0, i = 0, num_digits = 0;
  // Compute the number of digits needed to represent the label number.
  do ++num_digits; while (number /= 8);
  if (++num_digits < 3) num_digits = 3;
  // Create the label name, as .LAO and the octal representation of the label number.
  buffer[0] = '.', buffer[1] = 'L', buffer[2] = 'A', buffer[3] = 'O';
  // Produce the string version of the label number.
  number = Label_NameCounter;
  buffer[(length = 3 + num_digits + 1)] = '\0';
  do buffer[3 + num_digits - i++] = '0' + (number%8); while (number /= 8);
  while (num_digits > i) buffer[3 + num_digits - i++] = '0';
  // Insert the label into the label table
  Except_ENSURE(length < sizeof(buffer));
  return LabelTable_insert(this, index, buffer);
}

#line 304 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Label.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 315 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Label.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 322 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Label.xcc"
#ifndef ECL_NTRACE
bool
Label_DTD(FILE *file)
{
  fputs(
        "<!ELEMENT Label EMPTY >"
        "<!ATTLIST Label"
	"	ID ID #REQUIRED"
	"	Name CDATA #IMPLIED"
	"	Value %int64_t; #IMPLIED"
        ">"
       , file);
  return true;
}
#endif//ECL_NTRACE

#line 352 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Label.xcc"
#ifndef ECL_NTRACE
bool
Label_dumpXML(Label this,  XMLGen gen)
{
  char attval[64]="";
  XMLGenElement elemLabel = XMLGen_declareElement(gen, "Label");
  XMLGenAttribute attID = XMLGen_declareAttribute(gen, "ID");
  XMLGenAttribute attName = XMLGen_declareAttribute(gen, "Name");
  XMLGenAttribute attValue = XMLGen_declareAttribute(gen, "Value");
  XMLGen_startElement(gen, elemLabel);
  sprintf(attval, "Label_%d", Label_identity(this));
  XMLGen_addAttribute(gen, attID, attval);
  sprintf(attval, "%s", Label_name(this));
  XMLGen_addAttribute(gen, attName, attval);
  sprintf(attval, "%lld", Label_value(this));
  XMLGen_addAttribute(gen, attValue, attval);
  XMLGen_endEmptyElement(gen);
  return true;
}
#endif//ECL_NTRACE

#line 375 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Label.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 383 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Label.xcc"
IndexedFactory_ Label_Factory[1];

#line 385 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Label.xcc"
void
Label_INIT(void)
{
  IndexedFactory_Ctor(Label_Factory);
  Label_NameCounter = 0;
}

#line 397 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Label.xcc"
#if XCC__C
static void
Label_TEST(void)
{
#include "AIR/Label_.c"
}

#line 404 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Label.xcc"
int
main(int argc, char **argv)
{
  AIR_Test(Label_TEST);
  return 0;
}
#endif


#endif//Label_c_INCLUDED
