#ifndef Literal_c_INCLUDED
#define Literal_c_INCLUDED

#line 15 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Literal.xcc"
#include "AIR/AIR_.h"

#line 20 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Literal.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 71 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Literal.xcc"
Literal
Literal_Ctor(Literal this,
             LiteralType type, void *handle,
             ImmediateValue value, ImmediateValue offset,
             Relocation relocation, NativeType nativeType)
{
  *Literal__VALUE(this) = value;
  *Literal__OFFSET(this) = offset;
  *Literal__HANDLE(this) = handle;
  *Literal__TYPE(this) = type;
  *Literal__RELOCATION(this) = relocation;
  *Literal__NATIVETYPE(this) = nativeType;
  return this;
}

#line 86 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Literal.xcc"
size_t
Literal_Size(LiteralType type, void *handle,
             ImmediateValue value, ImmediateValue offset,
             Relocation relocation, NativeType nativeType)
{
  return sizeof(Literal_);
}

#line 184 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Literal.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 195 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Literal.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 205 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Literal.xcc"
PlatformUInt
Literal_encode(Literal this, PlatformUInt nativePC, void *buffer,
               LiteralRelocationFixup literal_fixup_function,
               void* user_data, NativeStream stream)

#line 210 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Literal.xcc"
{
  ImmediateValue value = Literal_VALUE(this);
  Relocation relocation = Literal_RELOCATION(this);
  NativeType nativeType = Literal_NATIVETYPE(this);
  size_t sizeOf = NativeType_sizeOf(nativeType);
  if (literal_fixup_function) {
    (*literal_fixup_function)(this, nativePC, relocation, user_data, stream);
    value = Literal_VALUE(this);
  }
  if (sizeOf <= 2) {
    if (sizeOf == 1) *(uint8_t *)buffer = (uint8_t)value;
    else *(uint16_t *)buffer = (uint16_t)value;
  } else {
    if (sizeOf == 4) *(uint32_t *)buffer = (uint32_t)value;
    else *(uint64_t *)buffer = (uint64_t)value;
  }
  return sizeOf;
}

#line 229 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Literal.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 235 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Literal.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 247 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Literal.xcc"
#if XCC__C
static void
Literal_TEST(void)
{
#include "AIR/Literal_.c"
}

#line 254 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Literal.xcc"
int
main(int argc, char **argv)
{
  AIR_Test(Literal_TEST);
  return 0;
}
#endif


#endif//Literal_c_INCLUDED
