#ifndef Scoreboard__c_INCLUDED
#define Scoreboard__c_INCLUDED

#line 41 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Scoreboard.xcc"
//
{
  printf("sizeof(ScoreboardAction_)\t%d\n", sizeof(ScoreboardAction_));
}

#line 102 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Scoreboard.xcc"
//
{
  printf("sizeof(Scoreboard_)\t%d\n", sizeof(Scoreboard_));
}

#line 411 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Scoreboard.xcc"
//
{
  Constant_ constant[1];
  Scoreboard_ this_scoreboard[1];
  Scoreboard_ that_scoreboard[1];
  Processor processor = Processor__DEFAULT;
  for (; processor < Processor__; processor++) {
    NativeStream stream = NativeStream_new(Memory_Root, 10);
    NativeBlock block = NativeStream_pushNativeBlock(stream, processor, 0, NULL);
#ifdef MDS_CORE_armv5e
    // Date=0	ldr r1, [r2]
    NativeBlock_makeInstruction_arm_rdNoPC_rnNoPC(
        block, Instance_armv5e_ldral_rdNoPC_rn,
        Register_arm_GR1, Register_arm_GR2);
    // Date=3	add r3, r3, r1
    NativeBlock_makeInstruction_arm_rdNoPC_rn_rm(
        block, Instance_armv5e_addal_reg_rdNoPC_rn_rm,
        Register_arm_GR3, Register_arm_GR3, Register_arm_GR1);
    // Date=4	mov r0, r3
    NativeBlock_makeInstruction_arm_rdNoPC_rm(
        block, Instance_armv5e_moval_reg_rdNoPC_rm,
        Register_arm_GR0, Register_arm_GR3);
    // Date=5	blal #0
    NativeBlock_makeInstruction_arm_btarg1(
        block, Instance_armv5e_blal_btarg1,
        Constant_Ctor(constant, ConstantType_Absolute, NULL, 0, 0),
        Relocation__UNDEF);
    // Date=6	ldr r1, [r2]
    NativeBlock_makeInstruction_arm_rdNoPC_rnNoPC(
        block, Instance_armv5e_ldral_rdNoPC_rn,
        Register_arm_GR1, Register_arm_GR2);
    // Date=10	add r3, r3, r1 lsl #6
    NativeBlock_makeInstruction_arm_rdNoPC_rn_rm_shfimml(
        block, Instance_armv5e_addal_lsl_imm_rdNoPC_rn_rm_shfimml,
        Register_arm_GR3, Register_arm_GR3, Register_arm_GR1,
        Constant_Ctor(constant, ConstantType_Absolute, NULL, 6, 0));
    // Date=11	mov r0, r3
    NativeBlock_makeInstruction_arm_rdNoPC_rm(
        block, Instance_armv5e_moval_reg_rdNoPC_rm,
        Register_arm_GR0, Register_arm_GR3);
    // Date=12	blal #0 
    NativeBlock_makeInstruction_arm_btarg1(
        block, Instance_armv5e_blal_btarg1,
        Constant_Ctor(constant, ConstantType_Absolute, NULL, 0, 0),
        Relocation__UNDEF);
    // Date=13	ldr r1, [r2]
    NativeBlock_makeInstruction_arm_rdNoPC_rnNoPC(
        block, Instance_armv5e_ldral_rdNoPC_rn,
        Register_arm_GR1, Register_arm_GR2);
    // Date=16	add r3, r1, r3, lsl r4
    NativeBlock_makeInstruction_arm_rdNoPC_rnNoPC_rmNoPC_rsNoPC(
        block, Instance_armv5e_addal_lsl_reg_rdNoPC_rnNoPC_rmNoPC_rsNoPC,
        Register_arm_GR3, Register_arm_GR1, Register_arm_GR3, Register_arm_GR4);
    // Date=17	mov r0, r3
    NativeBlock_makeInstruction_arm_rdNoPC_rm(
        block, Instance_armv5e_moval_reg_rdNoPC_rm,
        Register_arm_GR0, Register_arm_GR3);
    // Date=18	blal #0 
    NativeBlock_makeInstruction_arm_btarg1(
        block, Instance_armv5e_blal_btarg1,
        Constant_Ctor(constant, ConstantType_Absolute, NULL, 0, 0),
        Relocation__UNDEF);
    // Date=19	ldr r1, [r2]
    NativeBlock_makeInstruction_arm_rdNoPC_rnNoPC(
        block, Instance_armv5e_ldral_rdNoPC_rn,
        Register_arm_GR1, Register_arm_GR2);
    // Date=20	add r0, r5, r4
    NativeBlock_makeInstruction_arm_rdNoPC_rn_rm(
        block, Instance_armv5e_addal_reg_rdNoPC_rn_rm,
        Register_arm_GR6, Register_arm_GR5, Register_arm_GR4);
    // Date=21	blal #0 
    NativeBlock_makeInstruction_arm_btarg1(
        block, Instance_armv5e_blal_btarg1,
        Constant_Ctor(constant, ConstantType_Absolute, NULL, 0, 0),
        Relocation__UNDEF);
    // Date=22	add r1, r2, r3
    NativeBlock_makeInstruction_arm_rdNoPC_rn_rm(
        block, Instance_armv5e_addal_reg_rdNoPC_rn_rm,
        Register_arm_GR1, Register_arm_GR2, Register_arm_GR3);
    // Date=23	add r0, r6, r1
    NativeBlock_makeInstruction_arm_rdNoPC_rn_rm(
        block, Instance_armv5e_addal_reg_rdNoPC_rn_rm,
        Register_arm_GR9, Register_arm_GR6, Register_arm_GR1);
    // Date=24	blal #0 
    NativeBlock_makeInstruction_arm_btarg1(
        block, Instance_armv5e_blal_btarg1,
        Constant_Ctor(constant, ConstantType_Absolute, NULL, 0, 0),
        Relocation__UNDEF);
    // Date=25	add r2, r5, r6
    NativeBlock_makeInstruction_arm_rdNoPC_rn_rm(
        block, Instance_armv5e_addal_reg_rdNoPC_rn_rm,
        Register_arm_GR2, Register_arm_GR5, Register_arm_GR6);
    // Date=27	ldr r1, [r2]
    NativeBlock_makeInstruction_arm_rdNoPC_rnNoPC(
        block, Instance_armv5e_ldral_rdNoPC_rn,
        Register_arm_GR1, Register_arm_GR2);
    // Date=28	blal #0 
    NativeBlock_makeInstruction_arm_btarg1(
        block, Instance_armv5e_blal_btarg1,
        Constant_Ctor(constant, ConstantType_Absolute, NULL, 0, 0),
        Relocation__UNDEF);
    // Date=29	ldr r1, [r2]
    NativeBlock_makeInstruction_arm_rdNoPC_rnNoPC(
        block, Instance_armv5e_ldral_rdNoPC_rn,
        Register_arm_GR1, Register_arm_GR2);
    // Date=33	ldr r5, [r1]
    NativeBlock_makeInstruction_arm_rdNoPC_rnNoPC(
        block, Instance_armv5e_ldral_rdNoPC_rn,
        Register_arm_GR5, Register_arm_GR1);
    // Date=34	blal #0 
    NativeBlock_makeInstruction_arm_btarg1(
        block, Instance_armv5e_blal_btarg1,
        Constant_Ctor(constant, ConstantType_Absolute, NULL, 0, 0),
        Relocation__UNDEF);
    // Date=35	add r1, r2, r3
    NativeBlock_makeInstruction_arm_rdNoPC_rn_rm(
        block, Instance_armv5e_addal_reg_rdNoPC_rn_rm,
        Register_arm_GR1, Register_arm_GR2, Register_arm_GR3);
    // Date=37	add r4, r5, r1 lsl #1
    NativeBlock_makeInstruction_arm_rdNoPC_rn_rm_shfimml(
        block, Instance_armv5e_addal_lsl_imm_rdNoPC_rn_rm_shfimml,
        Register_arm_GR4, Register_arm_GR5, Register_arm_GR1,
        Constant_Ctor(constant, ConstantType_Absolute, NULL, 1, 0));
    // Date=38	blal #0 
    NativeBlock_makeInstruction_arm_btarg1(
        block, Instance_armv5e_blal_btarg1,
        Constant_Ctor(constant, ConstantType_Absolute, NULL, 0, 0),
        Relocation__UNDEF);
    // Date=39	add r1, r2, r3
    NativeBlock_makeInstruction_arm_rdNoPC_rn_rm(
        block, Instance_armv5e_addal_reg_rdNoPC_rn_rm,
        Register_arm_GR1, Register_arm_GR2, Register_arm_GR3);
    // Date=40	add r4, r1, r9 lsl #1
    NativeBlock_makeInstruction_arm_rdNoPC_rn_rm_shfimml(
        block, Instance_armv5e_addal_lsl_imm_rdNoPC_rn_rm_shfimml,
        Register_arm_GR4, Register_arm_GR1, Register_arm_GR9,
        Constant_Ctor(constant, ConstantType_Absolute, NULL, 1, 0));
    // Date=41	blal #0 
    NativeBlock_makeInstruction_arm_btarg1(
        block, Instance_armv5e_blal_btarg1,
        Constant_Ctor(constant, ConstantType_Absolute, NULL, 0, 0),
        Relocation__UNDEF);
    // Date=42	add r1, r2, r3
    NativeBlock_makeInstruction_arm_rdNoPC_rn_rm(
        block, Instance_armv5e_addal_reg_rdNoPC_rn_rm,
        Register_arm_GR1, Register_arm_GR2, Register_arm_GR3);
    // Date=45	add r4, r2, r4 lsl r1
    NativeBlock_makeInstruction_arm_rdNoPC_rnNoPC_rmNoPC_rsNoPC(
        block, Instance_armv5e_addal_lsl_reg_rdNoPC_rnNoPC_rmNoPC_rsNoPC,
        Register_arm_GR4, Register_arm_GR2, Register_arm_GR4, Register_arm_GR1);
    // Date=46	blal #0 
    NativeBlock_makeInstruction_arm_btarg1(
        block, Instance_armv5e_blal_btarg1,
        Constant_Ctor(constant, ConstantType_Absolute, NULL, 0, 0),
        Relocation__UNDEF);
    // Date=47	ldr r5, [r2, #4]!
    NativeBlock_makeInstruction_arm_rdNoPC_rnNoPC_offset12(
        block, Instance_armv5e_ldral_pre_addi_rdNoPC_rnNoPC_offset13,
        Register_arm_GR5, Register_arm_GR2,
        Constant_Ctor(constant, ConstantType_Absolute, NULL, 4, 0),
        Relocation__UNDEF);
    // Date=48	ldr r6, [r2, #0x10]!
    NativeBlock_makeInstruction_arm_rdNoPC_rnNoPC_offset12(
        block, Instance_armv5e_ldral_pre_addi_rdNoPC_rnNoPC_offset13,
        Register_arm_GR6, Register_arm_GR2,
        Constant_Ctor(constant, ConstantType_Absolute, NULL, 0x10, 0),
        Relocation__UNDEF);
    // Date=49	ldr r7, [r2, #0x20]!
    NativeBlock_makeInstruction_arm_rdNoPC_rnNoPC_offset12(
        block, Instance_armv5e_ldral_pre_addi_rdNoPC_rnNoPC_offset13,
        Register_arm_GR7, Register_arm_GR2,
        Constant_Ctor(constant, ConstantType_Absolute, NULL, 0x20, 0),
        Relocation__UNDEF);
    // Date=50	blal #0 
    NativeBlock_makeInstruction_arm_btarg1(
        block, Instance_armv5e_blal_btarg1,
        Constant_Ctor(constant, ConstantType_Absolute, NULL, 0, 0),
        Relocation__UNDEF);
#endif//MDS_CORE_armv5e
#ifdef MDS_CORE_armv6
    // Date=0	ldr r1, [r2]
    NativeBlock_makeInstruction_arm_rdNoPC_rnNoPC(
        block, Instance_armv6_ldral_rdNoPC_rn,
        Register_arm_GR1, Register_arm_GR2);
    // Date=3	add r3, r3, r1
    NativeBlock_makeInstruction_arm_rdNoPC_rn_rm(
        block, Instance_armv6_addal_reg_rdNoPC_rn_rm,
        Register_arm_GR3, Register_arm_GR3, Register_arm_GR1);
    // Date=4	mov r0, r3
    NativeBlock_makeInstruction_arm_rdNoPC_rm(
        block, Instance_armv6_moval_reg_rdNoPC_rm,
        Register_arm_GR0, Register_arm_GR3);
    // Date=5	blal #0
    NativeBlock_makeInstruction_arm_btarg1(
        block, Instance_armv6_blal_btarg1,
        Constant_Ctor(constant, ConstantType_Absolute, NULL, 0, 0),
        Relocation__UNDEF);
    // Date=6	ldr r1, [r2]
    NativeBlock_makeInstruction_arm_rdNoPC_rnNoPC(
        block, Instance_armv6_ldral_rdNoPC_rn,
        Register_arm_GR1, Register_arm_GR2);
    // Date=10	add r3, r3, r1 lsl #6
    NativeBlock_makeInstruction_arm_rdNoPC_rn_rm_shfimml(
        block, Instance_armv6_addal_lsl_imm_rdNoPC_rn_rm_shfimml,
        Register_arm_GR3, Register_arm_GR3, Register_arm_GR1,
        Constant_Ctor(constant, ConstantType_Absolute, NULL, 6, 0));
    // Date=11	mov r0, r3
    NativeBlock_makeInstruction_arm_rdNoPC_rm(
        block, Instance_armv6_moval_reg_rdNoPC_rm,
        Register_arm_GR0, Register_arm_GR3);
    // Date=12	blal #0 
    NativeBlock_makeInstruction_arm_btarg1(
        block, Instance_armv6_blal_btarg1,
        Constant_Ctor(constant, ConstantType_Absolute, NULL, 0, 0),
        Relocation__UNDEF);
    // Date=13	ldr r1, [r2]
    NativeBlock_makeInstruction_arm_rdNoPC_rnNoPC(
        block, Instance_armv6_ldral_rdNoPC_rn,
        Register_arm_GR1, Register_arm_GR2);
    // Date=16	add r3, r1, r3, lsl r4
    NativeBlock_makeInstruction_arm_rdNoPC_rnNoPC_rmNoPC_rsNoPC(
        block, Instance_armv6_addal_lsl_reg_rdNoPC_rnNoPC_rmNoPC_rsNoPC,
        Register_arm_GR3, Register_arm_GR1, Register_arm_GR3, Register_arm_GR4);
    // Date=17	mov r0, r3
    NativeBlock_makeInstruction_arm_rdNoPC_rm(
        block, Instance_armv6_moval_reg_rdNoPC_rm,
        Register_arm_GR0, Register_arm_GR3);
    // Date=18	blal #0 
    NativeBlock_makeInstruction_arm_btarg1(
        block, Instance_armv6_blal_btarg1,
        Constant_Ctor(constant, ConstantType_Absolute, NULL, 0, 0),
        Relocation__UNDEF);
    // Date=19	ldr r1, [r2]
    NativeBlock_makeInstruction_arm_rdNoPC_rnNoPC(
        block, Instance_armv6_ldral_rdNoPC_rn,
        Register_arm_GR1, Register_arm_GR2);
    // Date=20	add r0, r5, r4
    NativeBlock_makeInstruction_arm_rdNoPC_rn_rm(
        block, Instance_armv6_addal_reg_rdNoPC_rn_rm,
        Register_arm_GR6, Register_arm_GR5, Register_arm_GR4);
    // Date=21	blal #0 
    NativeBlock_makeInstruction_arm_btarg1(
        block, Instance_armv6_blal_btarg1,
        Constant_Ctor(constant, ConstantType_Absolute, NULL, 0, 0),
        Relocation__UNDEF);
    // Date=22	add r1, r2, r3
    NativeBlock_makeInstruction_arm_rdNoPC_rn_rm(
        block, Instance_armv6_addal_reg_rdNoPC_rn_rm,
        Register_arm_GR1, Register_arm_GR2, Register_arm_GR3);
    // Date=23	add r0, r6, r1
    NativeBlock_makeInstruction_arm_rdNoPC_rn_rm(
        block, Instance_armv6_addal_reg_rdNoPC_rn_rm,
        Register_arm_GR9, Register_arm_GR6, Register_arm_GR1);
    // Date=24	blal #0 
    NativeBlock_makeInstruction_arm_btarg1(
        block, Instance_armv6_blal_btarg1,
        Constant_Ctor(constant, ConstantType_Absolute, NULL, 0, 0),
        Relocation__UNDEF);
    // Date=25	add r2, r5, r6
    NativeBlock_makeInstruction_arm_rdNoPC_rn_rm(
        block, Instance_armv6_addal_reg_rdNoPC_rn_rm,
        Register_arm_GR2, Register_arm_GR5, Register_arm_GR6);
    // Date=27	ldr r1, [r2]
    NativeBlock_makeInstruction_arm_rdNoPC_rnNoPC(
        block, Instance_armv6_ldral_rdNoPC_rn,
        Register_arm_GR1, Register_arm_GR2);
    // Date=28	blal #0 
    NativeBlock_makeInstruction_arm_btarg1(
        block, Instance_armv6_blal_btarg1,
        Constant_Ctor(constant, ConstantType_Absolute, NULL, 0, 0),
        Relocation__UNDEF);
    // Date=29	ldr r1, [r2]
    NativeBlock_makeInstruction_arm_rdNoPC_rnNoPC(
        block, Instance_armv6_ldral_rdNoPC_rn,
        Register_arm_GR1, Register_arm_GR2);
    // Date=33	ldr r5, [r1]
    NativeBlock_makeInstruction_arm_rdNoPC_rnNoPC(
        block, Instance_armv6_ldral_rdNoPC_rn,
        Register_arm_GR5, Register_arm_GR1);
    // Date=34	blal #0 
    NativeBlock_makeInstruction_arm_btarg1(
        block, Instance_armv6_blal_btarg1,
        Constant_Ctor(constant, ConstantType_Absolute, NULL, 0, 0),
        Relocation__UNDEF);
    // Date=35	add r1, r2, r3
    NativeBlock_makeInstruction_arm_rdNoPC_rn_rm(
        block, Instance_armv6_addal_reg_rdNoPC_rn_rm,
        Register_arm_GR1, Register_arm_GR2, Register_arm_GR3);
    // Date=37	add r4, r5, r1 lsl #1
    NativeBlock_makeInstruction_arm_rdNoPC_rn_rm_shfimml(
        block, Instance_armv6_addal_lsl_imm_rdNoPC_rn_rm_shfimml,
        Register_arm_GR4, Register_arm_GR5, Register_arm_GR1,
        Constant_Ctor(constant, ConstantType_Absolute, NULL, 1, 0));
    // Date=38	blal #0 
    NativeBlock_makeInstruction_arm_btarg1(
        block, Instance_armv6_blal_btarg1,
        Constant_Ctor(constant, ConstantType_Absolute, NULL, 0, 0),
        Relocation__UNDEF);
    // Date=39	add r1, r2, r3
    NativeBlock_makeInstruction_arm_rdNoPC_rn_rm(
        block, Instance_armv6_addal_reg_rdNoPC_rn_rm,
        Register_arm_GR1, Register_arm_GR2, Register_arm_GR3);
    // Date=40	add r4, r1, r9 lsl #1
    NativeBlock_makeInstruction_arm_rdNoPC_rn_rm_shfimml(
        block, Instance_armv6_addal_lsl_imm_rdNoPC_rn_rm_shfimml,
        Register_arm_GR4, Register_arm_GR1, Register_arm_GR9,
        Constant_Ctor(constant, ConstantType_Absolute, NULL, 1, 0));
    // Date=41	blal #0 
    NativeBlock_makeInstruction_arm_btarg1(
        block, Instance_armv6_blal_btarg1,
        Constant_Ctor(constant, ConstantType_Absolute, NULL, 0, 0),
        Relocation__UNDEF);
    // Date=42	add r1, r2, r3
    NativeBlock_makeInstruction_arm_rdNoPC_rn_rm(
        block, Instance_armv6_addal_reg_rdNoPC_rn_rm,
        Register_arm_GR1, Register_arm_GR2, Register_arm_GR3);
    // Date=45	add r4, r2, r4 lsl r1
    NativeBlock_makeInstruction_arm_rdNoPC_rnNoPC_rmNoPC_rsNoPC(
        block, Instance_armv6_addal_lsl_reg_rdNoPC_rnNoPC_rmNoPC_rsNoPC,
        Register_arm_GR4, Register_arm_GR2, Register_arm_GR4, Register_arm_GR1);
    // Date=46	blal #0 
    NativeBlock_makeInstruction_arm_btarg1(
        block, Instance_armv6_blal_btarg1,
        Constant_Ctor(constant, ConstantType_Absolute, NULL, 0, 0),
        Relocation__UNDEF);
    // Date=47	ldr r5, [r2, #4]!
    NativeBlock_makeInstruction_arm_rdNoPC_rnNoPC_offset12(
        block, Instance_armv6_ldral_pre_addi_rdNoPC_rnNoPC_offset13,
        Register_arm_GR5, Register_arm_GR2,
        Constant_Ctor(constant, ConstantType_Absolute, NULL, 4, 0),
        Relocation__UNDEF);
    // Date=48	ldr r6, [r2, #0x10]!
    NativeBlock_makeInstruction_arm_rdNoPC_rnNoPC_offset12(
        block, Instance_armv6_ldral_pre_addi_rdNoPC_rnNoPC_offset13,
        Register_arm_GR6, Register_arm_GR2,
        Constant_Ctor(constant, ConstantType_Absolute, NULL, 0x10, 0),
        Relocation__UNDEF);
    // Date=49	ldr r7, [r2, #0x20]!
    NativeBlock_makeInstruction_arm_rdNoPC_rnNoPC_offset12(
        block, Instance_armv6_ldral_pre_addi_rdNoPC_rnNoPC_offset13,
        Register_arm_GR7, Register_arm_GR2,
        Constant_Ctor(constant, ConstantType_Absolute, NULL, 0x20, 0),
        Relocation__UNDEF);
    // Date=50	blal #0 
    NativeBlock_makeInstruction_arm_btarg1(
        block, Instance_armv6_blal_btarg1,
        Constant_Ctor(constant, ConstantType_Absolute, NULL, 0, 0),
        Relocation__UNDEF);
#endif//MDS_CORE_armv6
#ifdef MDS_CORE_st231
    // Date=0	ldb $r23 = 9[$r16]
    NativeBlock_makeInstruction_st200_nlidest_isrc2_src1(
        block, Instance_st231_ldb_nlidest_isrc2_src1,
        Register_st200_GR23,
        Constant_Ctor(constant, ConstantType_Absolute, NULL, 9, 0),
        Register_st200_GR16, Relocation__UNDEF);
    // Date=0	add $r18 = $r18, -12
    NativeBlock_makeInstruction_st200_idest_src1_isrc2(
        block, Instance_st231_add_idest_src1_isrc2,
        Register_st200_GR18, Register_st200_GR18,
        Constant_Ctor(constant, ConstantType_Absolute, NULL, -12, 0),
        Relocation__UNDEF);
    // Date=0	add $r19 = $r19, -1
    NativeBlock_makeInstruction_st200_idest_src1_isrc2(
        block, Instance_st231_add_idest_src1_isrc2,
        Register_st200_GR19, Register_st200_GR19,
        Constant_Ctor(constant, ConstantType_Absolute, NULL, -1, 0),
        Relocation__UNDEF);
    // Date=1	ldb $r24 = 11[$r16]
    NativeBlock_makeInstruction_st200_nlidest_isrc2_src1(
        block, Instance_st231_ldb_nlidest_isrc2_src1,
        Register_st200_GR24,
        Constant_Ctor(constant, ConstantType_Absolute, NULL, 11, 0),
        Register_st200_GR16, Relocation__UNDEF);
    // Date=1	mtb $b3 = $r19
    NativeBlock_makeInstruction_st200_bdest_src1(
        block, Instance_st231_mtb_bdest_src1,
        Register_st200_BR3, Register_st200_GR19);
    // Date=2	ldb $r20 = 8[$r16]
    NativeBlock_makeInstruction_st200_nlidest_isrc2_src1(
        block, Instance_st231_ldb_nlidest_isrc2_src1,
        Register_st200_GR20,
        Constant_Ctor(constant, ConstantType_Absolute, NULL, 8, 0),
        Register_st200_GR16, Relocation__UNDEF);
    // Date=3	shl $r23 = $r23, 8
    NativeBlock_makeInstruction_st200_idest_src1_isrc2(
        block, Instance_st231_shl_idest_src1_isrc2,
        Register_st200_GR23, Register_st200_GR23,
        Constant_Ctor(constant, ConstantType_Absolute, NULL, 8, 0),
        Relocation__UNDEF);
    // Date=3	ldb $r21 = 10[$r16]
    NativeBlock_makeInstruction_st200_nlidest_isrc2_src1(
        block, Instance_st231_ldb_nlidest_isrc2_src1,
        Register_st200_GR21,
        Constant_Ctor(constant, ConstantType_Absolute, NULL, 10, 0),
        Register_st200_GR16, Relocation__UNDEF);
    // Date=3	add $r16 = $r16, 12
    NativeBlock_makeInstruction_st200_idest_src1_isrc2(
        block, Instance_st231_add_idest_src1_isrc2,
        Register_st200_GR16, Register_st200_GR16,
        Constant_Ctor(constant, ConstantType_Absolute, NULL, 12, 0),
        Relocation__UNDEF);
    // Date=4	shl $r24 = $r24, 24
    NativeBlock_makeInstruction_st200_idest_src1_isrc2(
        block, Instance_st231_shl_idest_src1_isrc2,
        Register_st200_GR24, Register_st200_GR24,
        Constant_Ctor(constant, ConstantType_Absolute, NULL, 24, 0),
        Relocation__UNDEF);
    // Date=5	add $r15 = $r15, $r24
    NativeBlock_makeInstruction_st200_dest_src1_src2(
        block, Instance_st231_add_dest_src1_src2,
        Register_st200_GR15, Register_st200_GR15,
        Register_st200_GR24);
    // Date=5	add $r20 = $r20, $r23
    NativeBlock_makeInstruction_st200_dest_src1_src2(
        block, Instance_st231_add_dest_src1_src2,
        Register_st200_GR20, Register_st200_GR20,
        Register_st200_GR23);
    // Date=6	shl $r21 = $r21, 16
    NativeBlock_makeInstruction_st200_idest_src1_isrc2(
        block, Instance_st231_shl_idest_src1_isrc2,
        Register_st200_GR21, Register_st200_GR21,
        Constant_Ctor(constant, ConstantType_Absolute, NULL, 16, 0),
        Relocation__UNDEF);
    // Date=7	add $r20 = $r20, $r21
    NativeBlock_makeInstruction_st200_dest_src1_src2(
        block, Instance_st231_add_dest_src1_src2,
        Register_st200_GR20, Register_st200_GR20,
        Register_st200_GR21);
    // Date=8	add $r15 = $r15, $r20
    NativeBlock_makeInstruction_st200_dest_src1_src2(
        block, Instance_st231_add_dest_src1_src2,
        Register_st200_GR15, Register_st200_GR15,
        Register_st200_GR20);
    // Date=8	br $b3, L?__0_7
    NativeBlock_makeInstruction_st200_bcond_btarg(
        block, Instance_st231_br_bcond_btarg,
        Register_st200_BR3,
        Constant_Ctor(constant, ConstantType_Absolute, NULL, -64, 0),
        Relocation__UNDEF);
#endif//MDS_CORE_st231
    // Scoreboard Instruction(s).
    printf("Processor %s:\n", Processor_name_(processor));
    Scoreboard_Ctor(this_scoreboard, Memory_Root, processor, 0);
    Scoreboard_Ctor(that_scoreboard, Memory_Root, processor, 0);
    NativeBlock_FOREACH_Instruction(block, instruction) {
      int startDate = -1;
      OperandsBuffer_ buffer[1];
      Operands operands = Instance_operands(Instruction_INSTANCE(instruction));
      OperandsBuffer_Ctor(buffer);
      (*Operands_decode(operands))(Instruction_OPCODES(instruction), buffer);
      Instruction_makeActions(instruction, buffer);
      startDate = Scoreboard_tryInstruction(this_scoreboard, instruction);
      Scoreboard_addInstruction(this_scoreboard, instruction, startDate);
      printf("\nDate=%d\t", startDate);
      Instruction_pretty(instruction, stdout, stream);
      fputc('\n', stdout);
      Scoreboard_pretty(this_scoreboard, stdout);
    } NativeBlock_ENDEACH_Instruction;
    printf("\nTranslate this Scoreboard:\n");
    Scoreboard_reset(that_scoreboard, 108);
    Scoreboard_merge(that_scoreboard, this_scoreboard, 0);
    Scoreboard_pretty(that_scoreboard, stdout);
    printf("\nMerge(1) this Scoreboard:\n");
    Scoreboard_reset(that_scoreboard, 108);
    Scoreboard_merge(that_scoreboard, this_scoreboard, 1);
    Scoreboard_pretty(that_scoreboard, stdout);
    NativeStream_delete(stream);
  }
  printf("\n");
}

#line 883 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Scoreboard.xcc"
//
{
#ifdef MDS_CORE_st231
  Processor processor = Processor_st231_cpu;
  InstanceOpcodes_ opcodes[] = {
    { { 0x30000000, 0x00000000 } },	// call $r63= <Module>:BM_TimingEnd
    { { 0x2502444c, 0x00000000 } },	// stw 36[$r12] = $r17  ## date 1
    { { 0x2502040c, 0x00000000 } },	// stw 32[$r12] = $r16  ## date 2
    { { 0x2001824c, 0x00000000 } },	// ldw $r9 = 24[$r12]
    { { 0x00010240, 0x00000000 } },	// mov $r16= $r9
    { { 0x30000000, 0x00000000 } },	// call $r63= <Module>:fclose
    { { 0x2001424c, 0x00000000 } },	// ldw $r9 = 20[$r12]
    { { 0x00010240, 0x00000000 } },	// mov $r16= $r9
    { { 0x30000000, 0x00000000 } },	// call $r63= <Module>:fclose
    { { 0x08001400, 0x00000000 } },	// mov $r16= 1
    { { 0x30000000, 0x00000000 } },	// call $r63= <Module>:__io_ftable_get_stdentry
    { { 0x08088240, 0x0004290a } },	// mov $r9 = 139596936  ## date 12
    { { 0x2002424c, 0x00000000 } },	// ldw $r9 = 36[$r12]
    { { 0x0808a280, 0x0004290a } },	// mov $r10= 139596938  ## date 13
    { { 0x2300028a, 0x00000000 } },	// ldb$r10= 0[$r10]
    { { 0x00013280, 0x00000000 } },	// mov $r19= $r10       ## date 17
    { { 0x00012240, 0x00000000 } },	// mov $r18= $r9
    { { 0x08060440, 0x00042905 } },	// mov $r17= 139594336  ## date 17
    { { 0x30000000, 0x00000000 } },	// call $r63= <Module>:fprintf
    { { 0x08001400, 0x00000000 } },	// mov $r16= 1
    { { 0x30000000, 0x00000000 } },	// call $r63= <Module>:__io_ftable_get_stdentry
    { { 0x2002424c, 0x00000000 } },	// ldw $r9 = 36[$r12]
    { { 0x2002028c, 0x00000000 } },	// ldw $r10= 32[$r12]
    { { 0x00013240, 0x00000000 } },	// mov $r19= $r9
    { { 0x00012280, 0x00000000 } },	// mov $r18= $r10       ## date 23
    { { 0x08080440, 0x00042905 } },	// mov $r17= 139594368  ## date 23
    { { 0x30000000, 0x00000000 } },	// call $r63= <Module>:fprintf
    { { 0x08001400, 0x00000000 } },	// mov $r16= 1
    { { 0x30000000, 0x00000000 } },	// call $r63= <Module>:__io_ftable_get_stdentry
    { { 0x2001c24c, 0x00000000 } },	// ldw $r9 = 28[$r12]
    { { 0x2502840c, 0x00000000 } },	// stw 40[$r12] = $r16  ## date 26
    { { 0x00010240, 0x00000000 } },	// mov $r16= $r9
    { { 0x30000000, 0x00000000 } },	// call $r63= <Module>:__wtod
    { { 0x2002424c, 0x00000000 } },	// ldw $r9 = 36[$r12]
    { { 0x2002028c, 0x00000000 } },	// ldw $r10= 32[$r12]
    { { 0x00010400, 0x00000000 } },	// mov $r16= $r16       ## date 30
    { { 0x00011440, 0x00000000 } },	// mov $r17= $r17       ## date 30
    { { 0x00012280, 0x00000000 } },	// mov $r18= $r10       ## date 33
    { { 0x00013240, 0x00000000 } },	// mov $r19= $r9
    { { 0x30000000, 0x00000000 } },	// call $r63= <Module>:__divd
    { { 0x00013440, 0x00000000 } },	// mov $r19= $r17       ## date 34
    { { 0x00012400, 0x00000000 } },	// mov $r18= $r16       ## date 34
    { { 0x080a0440, 0x00042905 } },	// mov $r17= 139594400  ## date 34
    { { 0x2002824c, 0x00000000 } },	// ldw $r9 = 40[$r12]
    { { 0x00010240, 0x00000000 } },	// mov $r16= $r9
    { { 0x30000000, 0x00000000 } },	// call $r63= <Module>:fprintf
    { { 0x08000400, 0x00000000 } },	// mov $r16= 0
    { { 0x2002c04c, 0x00000000 } },	// ldw $r1 = 44[$r12]
    { { 0x20030fcc, 0x00000000 } },	// ldw $r63= 48[$r12]
    { { 0x0803830c, 0x00000000 } },	// add$r12= $r12, 56    ## date 40
    { { 0x31800000, 0x00000000 } },	// return $r63		## date 44
//
    { { 0x302065ff, 0x00000000 } },	// call $r63 = printf	## date 34
    { { 0xa504c20c, 0x00000000 } },	// stw 76[$r12] = $r8	## date 34
    { { 0xa004c20c, 0x00000000 } },	// ldw $r8 = 76[$r12]	## date 35
    { { 0xa004824c, 0x00000000 } },	// ldw $r9 = 72[$r12]	## date 36
    { { 0xa004428c, 0x00000000 } },	// ldw $r10 = 68[$r12]	## date 37
    { { 0xa00402cc, 0x00000000 } },	// ldw $r11 = 64[$r12]	## date 38
    { { 0xa003c3cc, 0x00000000 } },	// ldw $r15 = 60[$r12]	## date 39
    { { 0xa003860c, 0x00000000 } },	// ldw $r24 = 56[$r12]	## date 40
    { { 0xa003464c, 0x00000000 } },	// ldw $r25 = 52[$r12]	## date 41
    { { 0x2005068c, 0x00000000 } },	// ldw $r26 = 80[$r12]	## date 42
    { { 0x0dc046cb, 0x00000000 } },	// mul32 $r27 = $r11, 4 ## date 42
    { { 0x8001b400, 0x00000000 } },	// mov $r27 = $r16	## date 42
    { { 0x8001b29b, 0x00000000 } },	// add $r27 = $r27, $r10## date 45
    { { 0xa00006db, 0x00000000 } },	// ldw $r27 = 0[$r27]	## date 46
//
    { { 0xb880001a, 0x00000000 } },	// br $b1, L?__2_31
    { { 0x8e672049, 0x00000000 } },	// cmpgeu $b1 = $r9, 114
  };
  printf("*** Scoreboard:\n");
  {
    Scoreboard_ scoreboard[1];
    int count = sizeof(opcodes)/sizeof(*opcodes), i;
    Instruction_ instructions_[sizeof(opcodes)/sizeof(*opcodes)];
    Scoreboard_Ctor(scoreboard, Memory_Root, processor, 7);
    for (i = 0; i < count; i++) {
      int startDate = -1;
      InstanceOpcodes instanceOpcodes = opcodes + i;
      Encoding encoding = InstanceOpcodes_WORDS(instanceOpcodes)[1]?
                          Encoding_st231_ANYX: Encoding_st231_ANY;
      Instruction instruction = Instruction_decode(instructions_+i, encoding,
                                                   instanceOpcodes);
      OperandsBuffer_ buffer[1];
      Operands operands = Instance_operands(Instruction_INSTANCE(instruction));
      OperandsBuffer_Ctor(buffer);
      (*Operands_decode(operands))(Instruction_OPCODES(instruction), buffer);
      Instruction_makeActions(instruction, buffer);
      startDate = Scoreboard_tryInstruction(scoreboard, instruction);
      Scoreboard_addInstruction(scoreboard, instruction, startDate);
      printf("\t"), Instruction_pretty(instruction, stdout, NULL), printf("\n");
      Scoreboard_pretty(scoreboard, stdout);
    }
  }
#endif//MDS_CORE_st231
}


#endif//Scoreboard__c_INCLUDED
