#ifndef DomTreeScan_c_INCLUDED
#define DomTreeScan_c_INCLUDED

#line 17 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/DomTreeScan.xcc"
#include "CGO/CGO_.h"

#line 22 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/DomTreeScan.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 33 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/DomTreeScan.xcc"
DomTreeScan
DomTreeScan_Ctor(DomTreeScan this,
                Memory memory, SSAForm ssaForm)
{
  CodeRegion codeRegion = SSAForm_codeRegion(ssaForm);
  TemporaryTable globalTable = CodeRegion_globalTable(codeRegion);
  *DomTreeScan__MEMORY(this) = memory;
  *DomTreeScan__SSAFORM(this) = ssaForm;
  //
  SSAForm_makeConventional(ssaForm, globalTable);
  //
  //
  return this;
}

#line 48 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/DomTreeScan.xcc"
void
DomTreeScan_Dtor(DomTreeScan this)
{
}

#line 53 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/DomTreeScan.xcc"
size_t
DomTreeScan_Size(Memory memory, SSAForm ssaForm)
{
  return sizeof(DomTreeScan_);
}

#line 68 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/DomTreeScan.xcc"
#ifndef DomTreeScan_POOLED
#define DomTreeScan_POOLED 128
#endif//DomTreeScan_POOLED

#line 72 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/DomTreeScan.xcc"
DomTreeScan
DomTreeScan_new(Memory parent, SSAForm ssaForm)
{
  Memory memory = Memory_new(parent, DomTreeScan_POOLED);
  size_t size = DomTreeScan_Size(memory, ssaForm);
  DomTreeScan this = Memory_alloc(memory, size);
  return DomTreeScan_Ctor(this, memory, ssaForm);
}

#line 85 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/DomTreeScan.xcc"
DomTreeScan
DomTreeScan_delete(DomTreeScan this)
{
  if (this != NULL) {
    Memory memory = DomTreeScan_MEMORY(this);
#ifndef ECL_NDTOR
    DomTreeScan_Dtor(this);
    Memory_free_(memory, this);
#endif//ECL_NDTOR
    Memory_delete(memory);
  }
  return NULL;
}

#line 99 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/DomTreeScan.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 107 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/DomTreeScan.xcc"
Memory
DomTreeScan_memory(DomTreeScan this)
{
  return DomTreeScan_MEMORY(this);
}

#line 119 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/DomTreeScan.xcc"
#ifndef ECL_NTRACE
bool
DomTreeScan_pretty(DomTreeScan this, FILE *file)
{
  if (file == NULL) file = stderr;
  return true;
}
#endif//ECL_NTRACE

#line 128 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/DomTreeScan.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 136 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/DomTreeScan.xcc"
void
DomTreeScan_allocate(DomTreeScan this)
{
  Except_NEVER(true);
}

#line 142 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/DomTreeScan.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 154 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/DomTreeScan.xcc"
#if XCC__C
static void
DomTreeScan_TEST(void)
{
#include "CGO/DomTreeScan_.c"
}

#line 161 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/DomTreeScan.xcc"
int
main(int argc, char **argv)
{
  CGO_Test(DomTreeScan_TEST);
  return 0;
}
#endif


#endif//DomTreeScan_c_INCLUDED
