#ifndef ECL_INCLUDED
#define ECL_INCLUDED

#include "ECL_public.h"

/*
 * Set ECL_OPTIMIZE according to __OPTIMIZE__ (defined by gcc and icc) and NDEBUG.
 */
#ifdef __OPTIMIZE__
# ifndef ECL_OPTIMIZE
#  ifdef NDEBUG
#    define ECL_OPTIMIZE 3
#  else//!NDEBUG
#    define ECL_OPTIMIZE 2
#  endif//NDEBUG
# endif//ECL_OPTIMIZE
#else//!__OPTIMIZE__
# ifndef ECL_OPTIMIZE
#  ifdef NDEBUG
#    define ECL_OPTIMIZE 1
#  else//!NDEBUG
#    define ECL_OPTIMIZE 0
#  endif//NDEBUG
# endif//ECL_OPTIMIZE
#endif//__OPTIMIZE__

#endif//ECL_INCLUDED

