#ifndef Compiler_c_INCLUDED
#define Compiler_c_INCLUDED

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/JIT/Compiler.xcc"
#include "JIT/JIT_.h"

#line 21 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/JIT/Compiler.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 29 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/JIT/Compiler.xcc"
void
Compiler_compileProcedure(Procedure procedure)
{
  Memory memory = Procedure_memory(procedure);
  Procedure_buildCodeRegions(procedure);
  Procedure_FOREACH_CodeRegion(procedure, codeRegion) {
    Compiler_compileCodeRegion(codeRegion, memory);
  } Procedure_ENDEACH_CodeRegion;
}

#line 45 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/JIT/Compiler.xcc"
void
Compiler_compileCodeRegion(CodeRegion codeRegion, Memory memory)
{
  Optimize optimize = CodeRegion_optimize(codeRegion);
  LoopForest_delete(LoopForest_new(memory, codeRegion));
  if (Optimize_CONVERSION(optimize) > 0) {
  }
  if (Optimize_SCHEDULING(optimize) > 0) {
  }
  if (Optimize_ALLOCATION(optimize) > 0) {
  }
  if (Optimize_SCOREBOARDING(optimize) > 0) {
  }
}

#line 60 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/JIT/Compiler.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 72 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/JIT/Compiler.xcc"
#if XCC__C
static void
Compiler_TEST(void)
{
#include "JIT/Compiler_.c"
}

#line 79 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/JIT/Compiler.xcc"
int
main(int argc, char **argv)
{
  JIT_Test(Compiler_TEST);
  return 0;
}
#endif


#endif//Compiler_c_INCLUDED
