#ifndef Configure_c_INCLUDED
#define Configure_c_INCLUDED

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Configure.xcc"
#include "LIR/LIR_.h"

#line 21 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Configure.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 38 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Configure.xcc"
#ifndef ECL_NTRACE
const char *
ConfigureCompensation_name_(ConfigureCompensation this)
{
  static const char *_[] = {
    "None",
    "Local",
    "Global",
  };
  Except_REQUIRE((unsigned)this < ConfigureCompensation__);
  return _[this];
}
#endif//ECL_NTRACE

#line 52 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Configure.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 71 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Configure.xcc"
#ifndef ECL_NTRACE
const char *
ConfigureSpeculation_name_(ConfigureSpeculation this)
{
  static const char *_[] = {
    "None",
    "SafeArith",
    "SafeAccess",
    "SafeVariant",
    "MayExcept",
  };
  Except_REQUIRE((unsigned)this < ConfigureSpeculation__);
  return _[this];
}
#endif//ECL_NTRACE

#line 87 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Configure.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 104 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Configure.xcc"
#ifndef ECL_NTRACE
const char *
ConfigureRelaxation_name_(ConfigureRelaxation this)
{
  static const char *_[] = {
    "None",
    "Local",
    "Global",
  };
  Except_REQUIRE((unsigned)this < ConfigureRelaxation__);
  return _[this];
}
#endif//ECL_NTRACE

#line 118 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Configure.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 135 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Configure.xcc"
#ifndef ECL_NTRACE
const char *
ConfigureRenaming_name_(ConfigureRenaming this)
{
  static const char *_[] = {
    "None",
    "Normal",
    "Local",
    "Global",
    "Shuffle",
  };
  Except_REQUIRE((unsigned)this < ConfigureRenaming__);
  return _[this];
}
#endif//ECL_NTRACE

#line 151 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Configure.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 168 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Configure.xcc"
#ifndef ECL_NTRACE
const char *
ConfigureBoosting_name_(ConfigureBoosting this)
{
  static const char *_[] = {
    "None",
    "Reuse",
    "Combine",
  };
  Except_REQUIRE((unsigned)this < ConfigureBoosting__);
  return _[this];
}
#endif//ECL_NTRACE

#line 182 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Configure.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 201 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Configure.xcc"
#ifndef ECL_NTRACE
const char *
ConfigureAliasing_name_(ConfigureAliasing this)
{
  static const char *_[] = {
    "Serial",
    "Normal",
    "Vector",
    "Parallel",
    "Liberal",
  };
  Except_REQUIRE((unsigned)this < ConfigureAliasing__);
  return _[this];
}
#endif//ECL_NTRACE

#line 217 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Configure.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 234 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Configure.xcc"
#ifndef ECL_NTRACE
const char *
ConfigurePreLoading_name_(ConfigurePreLoading this)
{
  static const char *_[] = {
    "None",
    "Simple",
    "Variant",
    "Indirect",
    "NonSpill",
  };
  Except_REQUIRE((unsigned)this < ConfigurePreLoading__);
  return _[this];
}
#endif//ECL_NTRACE

#line 250 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Configure.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 279 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Configure.xcc"
#ifndef ECL_NTRACE
const char *
ConfigureItem_name_(ConfigureItem this)
{
  static const char *_[] = {
    "Processor",
    "Compensation",
    "Speculation",
    "Relaxation",
    "Renaming",
    "Boosting",
    "Aliasing",
    "TripModulus",
    "TripResidue",
    "Pipelining",
    "PreLoading",
    "L1MissExtra",
  };
  Except_REQUIRE((unsigned)this < ConfigureItem__);
  return _[this];
}
#endif//ECL_NTRACE

#line 302 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Configure.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 337 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Configure.xcc"
Configure
Configure_Ctor(Configure this)
{
  memset(this, -1, sizeof(Configure_));
  Configure_load(this,
                 ConfigureItem_Compensation, ConfigureCompensation_None,
                 ConfigureItem_Speculation, ConfigureSpeculation_SafeAccess,
                 ConfigureItem_Relaxation, ConfigureRelaxation_Local,
                 ConfigureItem_Renaming, ConfigureRenaming_Normal,
                 ConfigureItem_Boosting, ConfigureBoosting_None,
                 ConfigureItem_Aliasing, ConfigureAliasing_Normal,
                 ConfigureItem__);
  return this;
}

#line 352 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Configure.xcc"
Configure
Configure_Copy(Configure this, const_Configure that)
{
  *(this) = *(that);
  return this;
}

#line 359 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Configure.xcc"
void
Configure_Dtor(Configure this)
{
}

#line 369 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Configure.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 377 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Configure.xcc"
#ifndef ECL_NTRACE
bool
Configure_pretty(const_Configure this, FILE *file)
{
  int i = 0;
  if (file == NULL) file = stderr;
  for (; i < ConfigureItem__; i++) {
    const char *name = ConfigureItem_name_(i);
    int value = Configure_ITEMS(this)[i];
    if (value >= 0) fprintf(file, "\t%s=%d", name, value);
  }
  return true;
}
#endif//ECL_NTRACE

#line 398 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Configure.xcc"
void
Configure_loadVA(Configure this, int item, va_list va)
{
  while (item != ConfigureItem__) {
    int value = (int)va_arg(va, int);
    Except_REQUIRE(item >= 0 && item < ConfigureItem__);
    if (value >= 0) {
      Configure_ITEMS(this)[item] = value;
    }
    item = (int)va_arg(va, int);
  }
  if (FORCE_COMPENSATION >= 0) *Configure__COMPENSATION(this) = FORCE_COMPENSATION;
  if (FORCE_SPECULATION >= 0) *Configure__SPECULATION(this) = FORCE_SPECULATION;
  if (FORCE_RELAXATION >= 0) *Configure__RELAXATION(this) = FORCE_RELAXATION;
  if (FORCE_PIPELINING >= 0) *Configure__PIPELINING(this) = FORCE_PIPELINING;
  if (FORCE_RENAMING >= 0) *Configure__RENAMING(this) = FORCE_RENAMING;
  if (FORCE_BOOSTING >= 0) *Configure__BOOSTING(this) = FORCE_BOOSTING;
  if (FORCE_ALIASING >= 0) *Configure__ALIASING(this) = FORCE_ALIASING;
  if (FORCE_PRELOADING >= 0) *Configure__PRELOADING(this) = FORCE_PRELOADING;
  if (FORCE_L1MISSEXTRA >= 0) *Configure__L1MISSEXTRA(this) = FORCE_L1MISSEXTRA;
}

#line 426 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Configure.xcc"
void
Configure_load(Configure this, ConfigureItem item, ...)
{
  va_list va;
  va_start(va, item);
  Configure_loadVA(this, item, va);
  va_end(va);
}

#line 441 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Configure.xcc"
#ifndef ECL_NTRACE
bool
Configure_print(Configure this, FILE *file)
{
  int n = 0, i;
  for (i = 0; i < ConfigureItem__; i++) {
    const char *name = ConfigureItem_name_(i);
    int value = Configure_ITEMS(this)[i];
    if (value >= 0) fprintf(file, "ConfigureItem_%s, %d, ", name, value);
  }
  fprintf(file, "ConfigureItem__");
  return true;
}
#endif//ECL_NTRACE

#line 474 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Configure.xcc"
void
Configure_merge(Configure this, Configure that)
{
  int i = 0;
  for (; i < sizeof(Configure)/sizeof(int8_t); i++) {
    if (Configure_ITEMS(that)[i] >= 0) {
      Configure_ITEMS(this)[i] = Configure_ITEMS(that)[i];
    }
  }
}

#line 485 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Configure.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 497 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Configure.xcc"
#if XCC__C
static void
Configure_TEST(void)
{
#include "LIR/Configure_.c"
}

#line 504 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Configure.xcc"
int
main(int argc, char **argv)
{
  LIR_Test(Configure_TEST);
  return 0;
}
#endif


#endif//Configure_c_INCLUDED
