#ifndef Optimize_c_INCLUDED
#define Optimize_c_INCLUDED

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Optimize.xcc"
#include "LIR/LIR_.h"

#line 24 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Optimize.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 58 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Optimize.xcc"
ETableEntry_ OptimizeActivation_Entries[] = {
  ETableENTRY(OptimizeActivation, Encode),
  ETableENTRY(OptimizeActivation, PostPass),
  ETableENTRY(OptimizeActivation, RegAlloc),
  ETableENTRY(OptimizeActivation, PrePass),
  ETableENTRY_NULL
};
ETable_ OptimizeActivation_Table[1];

#line 67 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Optimize.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 102 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Optimize.xcc"
ETableEntry_ OptimizeRegionType_Entries[] = {
  ETableENTRY(OptimizeRegionType, SuperBlock),
  ETableENTRY(OptimizeRegionType, TraceBlock),
  ETableENTRY(OptimizeRegionType, HyperBlock),
  ETableENTRY(OptimizeRegionType, InnerLoop),
  ETableENTRY_NULL
};
ETable_ OptimizeRegionType_Table[1];

#line 111 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Optimize.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 144 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Optimize.xcc"
ETableEntry_ OptimizeProfiling_Entries[] = {
  ETableENTRY(OptimizeProfiling, Static),
  ETableENTRY(OptimizeProfiling, Edge),
  ETableENTRY(OptimizeProfiling, Path),
  ETableENTRY_NULL
};
ETable_ OptimizeProfiling_Table[1];

#line 152 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Optimize.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 169 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Optimize.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 202 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Optimize.xcc"
ETableEntry_ OptimizeAllocation_Entries[] = {
  ETableENTRY(OptimizeAllocation, ELinearScan),
  ETableENTRY(OptimizeAllocation, DomTreeScan),
  ETableENTRY(OptimizeAllocation, GraphColoring),
  ETableENTRY_NULL
};
ETable_ OptimizeAllocation_Table[1];

#line 211 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Optimize.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 249 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Optimize.xcc"
ETableEntry_ OptimizeConversion_Entries[] = {
  ETableENTRY(OptimizeConversion, Folding),
  ETableENTRY(OptimizeConversion, Cleaning),
  ETableENTRY(OptimizeConversion, SemiPruned),
  ETableENTRY(OptimizeConversion, SigmaGoTo),
  ETableENTRY(OptimizeConversion, Dedicated),
  ETableENTRY_NULL
};
ETable_ OptimizeConversion_Table[1];

#line 259 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Optimize.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 298 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Optimize.xcc"
ETableEntry_ OptimizeCoalescing_Entries[] = {
  ETableENTRY(OptimizeCoalescing, Sreedhar),
  ETableENTRY(OptimizeCoalescing, Boissinot),
  ETableENTRY(OptimizeCoalescing, Decoalesce),
  ETableENTRY(OptimizeCoalescing, Virtualize),
  ETableENTRY(OptimizeCoalescing, Congruence),
  ETableENTRY(OptimizeCoalescing, SeqCopies),
  ETableENTRY_NULL
};
ETable_ OptimizeCoalescing_Table[1];

#line 309 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Optimize.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 321 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Optimize.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 332 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Optimize.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 344 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Optimize.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 382 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Optimize.xcc"
ETableEntry_ OptimizeRCMSSolving_Entries[] = {
  ETableENTRY(OptimizeRCMSSolving, Dinechin),
  ETableENTRY(OptimizeRCMSSolving, LNSScan1),
  ETableENTRY(OptimizeRCMSSolving, LNSScan2),
  ETableENTRY(OptimizeRCMSSolving, EicDavAb),
  ETableENTRY(OptimizeRCMSSolving, AggrDeps),
  ETableENTRY(OptimizeRCMSSolving, Rational),
  ETableENTRY(OptimizeRCMSSolving, PostPass),
  ETableENTRY(OptimizeRCMSSolving, Acyclic),
  ETableENTRY_NULL
};
ETable_ OptimizeRCMSSolving_Table[1];

#line 395 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Optimize.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 430 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Optimize.xcc"
ETableEntry_ OptimizeRCMSProblem_Entries[] = {
  ETableENTRY(OptimizeRCMSProblem, Regular),
  ETableENTRY(OptimizeRCMSProblem, Overlap),
  ETableENTRY(OptimizeRCMSProblem, Lifetime),
  ETableENTRY(OptimizeRCMSProblem, Renaming),
  ETableENTRY(OptimizeRCMSProblem, Margins),
  ETableENTRY_NULL
};
ETable_ OptimizeRCMSProblem_Table[1];

#line 440 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Optimize.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 474 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Optimize.xcc"
ETableEntry_ OptimizeLogTimeOut_Entries[] = {
  ETableENTRY(OptimizeLogTimeOut, Times2),
  ETableENTRY(OptimizeLogTimeOut, Times4),
  ETableENTRY(OptimizeLogTimeOut, Times16),
  ETableENTRY(OptimizeLogTimeOut, Times256),
  ETableENTRY_NULL
};
ETable_ OptimizeLogTimeOut_Table[1];

#line 483 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Optimize.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 498 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Optimize.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 531 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Optimize.xcc"
const char *
OptimizeItem_name_(OptimizeItem this)
{
  static const char *_[] = {
    "Activation",
    "LogMaxBBOC",
    "Convention",
    "Profiling",
    "RegionType",
    "Conversion",
    "Coalescing",
    "Numbering",
    "Propagation",
    "Predication",
    "Scheduling",
    "Allocation",
    "RCMSSolving",
    "RCMSProblem",
    "LogTimeOut",
    "Scoreboarding",
    "WindowSize",
    "PrePadding",
    "PostPadding",
  };
  Except_REQUIRE((unsigned)this < OptimizeItem__);
  return _[this];
}

#line 559 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Optimize.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 607 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Optimize.xcc"
Optimize
Optimize_Ctor(Optimize this)
{
  memset(this, 0, sizeof(Optimize_));
  Optimize_load(this,
		OptimizeItem_Activation, OptimizeActivation_default,
		OptimizeItem_Allocation, OptimizeAllocation_default,
                OptimizeItem_LogMaxBBOC, 12,
                OptimizeItem_Convention, Convention__DEFAULT,
                OptimizeItem_RegionType, OptimizeRegionType_default,
                OptimizeItem_Conversion, OptimizeConversion_default,
                OptimizeItem_Coalescing, OptimizeCoalescing_default,
                OptimizeItem_Profiling, OptimizeProfiling_default,
                OptimizeItem_Scheduling, OptimizeScheduling_default,
                OptimizeItem_RCMSSolving, OptimizeRCMSSolving_default,
                OptimizeItem_RCMSProblem, OptimizeRCMSProblem_default,
                OptimizeItem_LogTimeOut, OptimizeLogTimeOut_default,
                OptimizeItem_Scoreboarding, OptimizeScoreboarding_default,
                OptimizeItem_WindowSize, 8,
                OptimizeItem__);
  return this;
}

#line 630 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Optimize.xcc"
void
Optimize_Dtor(Optimize this)
{
}

#line 640 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Optimize.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 648 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Optimize.xcc"
bool
Optimize_pretty(Optimize this, FILE *file)
{
  int i = 0;
  if (file == NULL) file = stderr;
  for (; i < OptimizeItem__; i++) {
    const char *name = OptimizeItem_name_(i);
    int value = Optimize_ITEMS(this)[i];
    fprintf(file, "\t%s=%d", name, value);
  }
  return true;
}

#line 667 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Optimize.xcc"
void
Optimize_loadVA(Optimize this, int item, va_list va)
{
  while (item != OptimizeItem__) {
    uint32_t value = (uint32_t)va_arg(va, uint32_t);
    Except_REQUIRE(item >= 0 && item < OptimizeItem__);
    Optimize_ITEMS(this)[item] = value;
    item = (int)va_arg(va, int);
  }
  if (FORCE_ACTIVATION >= 0) *Optimize__ACTIVATION(this) = FORCE_ACTIVATION;
  if (FORCE_CONVERSION >= 0) *Optimize__CONVERSION(this) = FORCE_CONVERSION;
  if (FORCE_COALESCING >= 0) *Optimize__COALESCING(this) = FORCE_COALESCING;
  if (FORCE_PREDICATION >= 0) *Optimize__PREDICATION(this) = FORCE_PREDICATION;
  if (FORCE_SCHEDULING >= 0) *Optimize__SCHEDULING(this) = FORCE_SCHEDULING;
  if (FORCE_ALLOCATION >= 0) *Optimize__ALLOCATION(this) = FORCE_ALLOCATION;
  if (FORCE_RCMSSOLVING >= 0) *Optimize__RCMSSOLVING(this) = FORCE_RCMSSOLVING;
  if (FORCE_RCMSPROBLEM >= 0) *Optimize__RCMSPROBLEM(this) = FORCE_RCMSPROBLEM;
  if (FORCE_LOGTIMEOUT >= 0) *Optimize__LOGTIMEOUT(this) = FORCE_LOGTIMEOUT;
  if (FORCE_SCOREBOARDING >= 0) *Optimize__SCOREBOARDING(this) = FORCE_SCOREBOARDING;
  if (FORCE_WINDOWSIZE >= 0) *Optimize__WINDOWSIZE(this) = FORCE_WINDOWSIZE;
  if (FORCE_PREPADDING >= 0) *Optimize__PREPADDING(this) = FORCE_PREPADDING;
  if (FORCE_POSTPADDING >= 0) *Optimize__POSTPADDING(this) = FORCE_POSTPADDING;
}

#line 697 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Optimize.xcc"
void
Optimize_load(Optimize this, OptimizeItem item, ...)
{
  va_list va;
  va_start(va, item);
  Optimize_loadVA(this, item, va);
  va_end(va);
}

#line 712 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Optimize.xcc"
bool
Optimize_print(Optimize this, FILE *file)
{
  int i;
  for (i = 0; i < OptimizeItem__; i++) {
    const char *name = OptimizeItem_name_(i);
    uint32_t value = Optimize_ITEMS(this)[i];
    fprintf(file, "OptimizeItem_%s, %u, ", name, value);
  }
  fprintf(file, "OptimizeItem__");
  return true;
}

#line 734 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Optimize.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 742 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Optimize.xcc"
void
Optimize_INIT(void)
{
  ETable_Ctor(OptimizeActivation_Table, Memory_Root, OptimizeActivation_Entries);
  ETable_Ctor(OptimizeConversion_Table, Memory_Root, OptimizeConversion_Entries);
  ETable_Ctor(OptimizeCoalescing_Table, Memory_Root, OptimizeCoalescing_Entries);
  ETable_Ctor(OptimizeRegionType_Table, Memory_Root, OptimizeRegionType_Entries);
  ETable_Ctor(OptimizeProfiling_Table, Memory_Root, OptimizeProfiling_Entries);
  ETable_Ctor(OptimizeAllocation_Table, Memory_Root, OptimizeAllocation_Entries);
  ETable_Ctor(OptimizeRCMSSolving_Table, Memory_Root, OptimizeRCMSSolving_Entries);
  ETable_Ctor(OptimizeRCMSProblem_Table, Memory_Root, OptimizeRCMSProblem_Entries);
  ETable_Ctor(OptimizeLogTimeOut_Table, Memory_Root, OptimizeLogTimeOut_Entries);
}

#line 762 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Optimize.xcc"
void
Optimize_FINI(void)
{
  ETable_Dtor(OptimizeLogTimeOut_Table);
  ETable_Dtor(OptimizeRCMSProblem_Table);
  ETable_Dtor(OptimizeRCMSSolving_Table);
  ETable_Dtor(OptimizeAllocation_Table);
  ETable_Dtor(OptimizeProfiling_Table);
  ETable_Dtor(OptimizeRegionType_Table);
  ETable_Dtor(OptimizeCoalescing_Table);
  ETable_Dtor(OptimizeConversion_Table);
  ETable_Dtor(OptimizeActivation_Table);
}

#line 776 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Optimize.xcc"
#if XCC__C
static void
Optimize_TEST(void)
{
#include "LIR/Optimize_.c"
}

#line 783 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/Optimize.xcc"
int
main(int argc, char **argv)
{
  LIR_Test(Optimize_TEST);
  return 0;
}
#endif


#endif//Optimize_c_INCLUDED
