#ifndef Bundle_c_INCLUDED
#define Bundle_c_INCLUDED

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundle.xcc"
#include "MDS/MDS_.h"

#line 31 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundle.xcc"
const int Bundle__COUNT = Bundle__;

#line 33 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundle.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 41 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundle.xcc"
#ifndef ECL_NTRACE
const char *
Bundle_name_(Bundle this)
{
  static const char *_[] = {
#define Bundle(NAME, ALIGNMENT, CONTENTS, INVERSE, TEMPLATE) \
    #NAME,
    "_UNDEF",
#include "Bundle.enum"
  };
  Except_REQUIRE((unsigned)this < Bundle__);
  return _[this];
}
#endif//ECL_NTRACE

#line 64 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundle.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 72 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundle.xcc"
#if Bundle_ISSUE_MAX
extern const uint8_t
Bundle_AlignBias[];
int
Bundle_alignBias(Bundle this)
{
  Except_REQUIRE((unsigned)this < Bundle__);
  return Bundle_AlignBias[this];
}
#endif//Bundle_ISSUE_MAX

#line 83 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundle.xcc"
#if Bundle_ISSUE_MAX
const uint8_t
Bundle_AlignBias[] = {
#define BIAS(d) d
#define ALIGNMENT(bias, base) bias
#define Bundle(NAME, ALIGNMENT, CONTENTS, INVERSE, TEMPLATE) \
  ALIGNMENT,
  0,
#include "Bundle.enum"
#undef ALIGNMENT
};
#endif//Bundle_ISSUE_MAX

#line 109 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundle.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 117 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundle.xcc"
#if Bundle_ISSUE_MAX
extern const uint8_t
Bundle_AlignBase[];
int
Bundle_alignBase(Bundle this)
{
  Except_REQUIRE((unsigned)this < Bundle__);
  return Bundle_AlignBase[this];
}
#endif//Bundle_ISSUE_MAX

#line 128 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundle.xcc"
#if Bundle_ISSUE_MAX
const uint8_t
Bundle_AlignBase[] = {
#define BASE(d) d
#define ALIGNMENT(bias, base) base
#define Bundle(NAME, ALIGNMENT, CONTENTS, INVERSE, TEMPLATE) \
  ALIGNMENT,
  0,
#include "Bundle.enum"
#undef ALIGNMENT
};
#endif//Bundle_ISSUE_MAX

#line 154 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundle.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 162 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundle.xcc"
#if Bundle_ISSUE_MAX
extern const uint8_t
Bundle_Count[];
int
Bundle_count(Bundle this)
{
  Except_REQUIRE((unsigned)this < Bundle__);
  return Bundle_Count[this];
}
#endif//Bundle_ISSUE_MAX

#line 173 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundle.xcc"
#if Bundle_ISSUE_MAX
const uint8_t
Bundle_Count[] = {
#define CONTENTS(count, items) count
#define Bundle(NAME, ALIGNMENT, CONTENTS, INVERSE, TEMPLATE) \
  CONTENTS,
  CONTENTS(0, /**/),
#include "Bundle.enum"
#undef CONTENTS
};
#endif//Bundle_ISSUE_MAX

#line 197 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundle.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 205 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundle.xcc"
#if Bundle_ISSUE_MAX
extern const Bundling
Bundle_Contents[][Bundle_ISSUE_MAX];
const Bundling *
Bundle_contents(Bundle this)
{
  Except_REQUIRE((unsigned)this < Bundle__);
  return Bundle_Contents[this];
}
#endif//Bundle_ISSUE_MAX

#line 216 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundle.xcc"
#if Bundle_ISSUE_MAX
const Bundling
Bundle_Contents[][Bundle_ISSUE_MAX] = {
#define BUNDLING(name) Bundling_##name,
#define CONTENTS(count, items) { items }
#define Bundle(NAME, ALIGNMENT, CONTENTS, INVERSE, TEMPLATE) \
  CONTENTS,
  CONTENTS(0, /**/),
#include "Bundle.enum"
#undef CONTENTS
};
#endif//Bundle_ISSUE_MAX

#line 246 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundle.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 254 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundle.xcc"
#if Bundle_ISSUE_MAX
extern const uint8_t
Bundle_Inverse[][Bundle_ISSUE_MAX];
const uint8_t *
Bundle_inverse(Bundle this)
{
  Except_REQUIRE((unsigned)this < Bundle__);
  return Bundle_Inverse[this];
}
#endif//Bundle_ISSUE_MAX

#line 265 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundle.xcc"
#if Bundle_ISSUE_MAX
const uint8_t
Bundle_Inverse[][Bundle_ISSUE_MAX] = {
#define INDEX(d) d,
#define INVERSE(indices) { indices }
#define Bundle(NAME, ALIGNMENT, CONTENTS, INVERSE, TEMPLATE) \
  INVERSE,
  { 0 },
#include "Bundle.enum"
};
#endif//Bundle_ISSUE_MAX

#line 294 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundle.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 302 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundle.xcc"
#if Bundle_ISSUE_MAX
extern const Template
Bundle_Template[];
Template
Bundle_template(Bundle this)
{
  Except_REQUIRE((unsigned)this < Bundle__);
  return (Template)Bundle_Template[this];
}
#endif//Bundle_ISSUE_MAX

#line 313 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundle.xcc"
#if Bundle_ISSUE_MAX
const Template
Bundle_Template[] = {
#define BASE(d) d
#define TEMPLATE(name) Template_##name
#define Bundle(NAME, ALIGNMENT, CONTENTS, INVERSE, TEMPLATE) \
  TEMPLATE,
  TEMPLATE(_UNDEF),
#include "Bundle.enum"
};
#endif//Bundle_ISSUE_MAX

#line 338 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundle.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 368 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundle.xcc"
#if Bundle_ISSUE_MAX
const BundleMatch_
BundleMatch_Dense[] = {
#define HASH(d) d
#define BUNDLE(name) Bundle_##name,
#define BUNDLES(length, items) length, { items }
#define BundleMatch(HASH, CANONIC, BUNDLES) \
  { HASH, BUNDLES },
#include "Bundle.enum"
};
#endif//Bundle_ISSUE_MAX

#line 387 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundle.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 389 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundle.xcc"
#if Bundle_ISSUE_MAX
const_BundleMatch
BundleMatch_Table[BundleMatch_HASH_MAX+1];
#endif//Bundle_ISSUE_MAX

#line 400 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundle.xcc"
#if Bundle_ISSUE_MAX
Bundle
BundleMatch_FindBundle(uint32_t hash, PlatformUInt nativePC)
{
  if (hash < sizeof(BundleMatch_Table)/sizeof(BundleMatch_Table[0])) {
    const_BundleMatch match = BundleMatch_Table[hash];
    if (match != NULL) {
      const Bundle *bundles = BundleMatch_BUNDLES(match);
      int count = BundleMatch_COUNT(match), i = 0;
      Except_CHECK(count > 0);
      do {
        int bundle = bundles[i];
        unsigned alignBase = Bundle_alignBase(bundle);
        unsigned alignBias = Bundle_alignBias(bundle);
        if ((nativePC & (alignBase - 1)) == alignBias) {
          return bundle;
        }
      } while (++i < count);
    }
  }
  return Bundle_;
}
#endif//Bundle_ISSUE_MAX

#line 452 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundle.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 464 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundle.xcc"
#if Bundle_ISSUE_MAX
void
Bundle_INIT(void)
{
  int count = sizeof(BundleMatch_Dense)/sizeof(BundleMatch_Dense[0]), i;
  for (i = 0; i < count; i++) {
    const_BundleMatch match = BundleMatch_Dense + i;
    uint32_t hash = BundleMatch_HASH(match);
    Except_CHECK(hash <= BundleMatch_HASH_MAX);
    Except_CHECK(BundleMatch_Table[hash] == NULL);
    BundleMatch_Table[hash] = match;
  }
}
#endif//Bundle_ISSUE_MAX

#line 484 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundle.xcc"
#if XCC__C
static void
Bundle_TEST(void)
{
#include "MDS/Bundle_.c"
}

#line 491 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundle.xcc"
int
main(int argc, char **argv)
{
  MDS_Test(Bundle_TEST);
  return 0;
}
#endif


#endif//Bundle_c_INCLUDED
