#ifndef Bundle__c_INCLUDED
#define Bundle__c_INCLUDED

#line 56 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundle.xcc"
//
{
  int bundle = 0;
  for (bundle = 0; bundle < Bundle__; bundle++) {
    printf("Bundle_%s\t%d\n", Bundle_name_(bundle), bundle);
  }
}

#line 96 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundle.xcc"
//
#if Bundle_ISSUE_MAX
{
  int bundle = 0;
  for (bundle = 0; bundle < Bundle__; bundle++) {
    int alignBias = Bundle_alignBias(bundle);
    printf("\nAlignBias(%s)\t%d", Bundle_name_(bundle), alignBias);
  }
  printf("\n");
  printf("sizeof(Bundle_AlignBias)\t%d\n", sizeof(Bundle_AlignBias));
}
#endif//Bundle_ISSUE_MAX

#line 141 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundle.xcc"
//
#if Bundle_ISSUE_MAX
{
  int bundle = 0;
  for (bundle = 0; bundle < Bundle__; bundle++) {
    int alignBase = Bundle_alignBase(bundle);
    printf("\nAlignBase(%s)\t%d", Bundle_name_(bundle), alignBase);
  }
  printf("\n");
  printf("sizeof(Bundle_AlignBase)\t%d\n", sizeof(Bundle_AlignBase));
}
#endif//Bundle_ISSUE_MAX

#line 185 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundle.xcc"
//
#if Bundle_ISSUE_MAX
{
  int bundle = 0;
  for (bundle = 0; bundle < Bundle__; bundle++) {
    int count = Bundle_count(bundle);
    printf("Count(%s)\t%d\n", Bundle_name_(bundle), count);
  }
  printf("sizeof(Bundle_Count)\t%d\n", sizeof(Bundle_Count));
}
#endif//Bundle_ISSUE_MAX

#line 229 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundle.xcc"
//
#if Bundle_ISSUE_MAX
{
  int bundle = 0;
  for (bundle = 0; bundle < Bundle__; bundle++) {
    const Bundling *contents = Bundle_contents(bundle);
    int count = Bundle_count(bundle), i;
    printf("Contents(%s)\t", Bundle_name_(bundle));
    for (i = 0; i < count; i++) {
      printf("%s\t", Bundling_name_(contents[i]));
    }
    printf("\n");
  }
  printf("sizeof(Bundle_Contents)\t%d\n", sizeof(Bundle_Contents));
}
#endif//Bundle_ISSUE_MAX

#line 277 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundle.xcc"
//
#if Bundle_ISSUE_MAX
{
  int bundle = 0;
  for (bundle = 0; bundle < Bundle__; bundle++) {
    const uint8_t *inverse = Bundle_inverse(bundle);
    int count = Bundle_count(bundle), i;
    printf("Inverse(%s)\t", Bundle_name_(bundle));
    for (i = 0; i < count; i++) {
      printf("%4d", inverse[i]);
    }
    printf("\n");
  }
  printf("sizeof(Bundle_Inverse)\t%d\n", sizeof(Bundle_Inverse));
}
#endif//Bundle_ISSUE_MAX

#line 325 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundle.xcc"
//
#if Bundle_ISSUE_MAX
{
  int bundle = 0;
  for (bundle = 0; bundle < Bundle__; bundle++) {
    int template = Bundle_template(bundle);
    printf("\nTemplate(%s)\t%s", Bundle_name_(bundle), Template_name_(template));
  }
  printf("\n");
  printf("sizeof(Bundle_Template)\t%d\n", sizeof(Bundle_Template));
}
#endif//Bundle_ISSUE_MAX

#line 360 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundle.xcc"
//
{
#if Bundle_ISSUE_MAX
  Except_ALWAYS(BundleMatch_HASH_MAX <= UINT16_MAX);
  printf("sizeof(BundleMatch_)\t%d\n", sizeof(BundleMatch_));
#endif//Bundle_ISSUE_MAX
}

#line 380 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundle.xcc"
//
#if Bundle_ISSUE_MAX
{
  printf("sizeof(BundleMatch_Dense)\t%d\n", sizeof(BundleMatch_Dense));
}
#endif//Bundle_ISSUE_MAX

#line 424 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundle.xcc"
//
#if Bundle_ISSUE_MAX
{
  int bundle = 0;
  for (bundle = 1; bundle < Bundle__; bundle++) {
    uint32_t hash = -1;
    int found = Bundle_;
    BundlingBuffer_ buffer[1];
    Bundling *bundlings = BundlingBuffer_BUNDLINGS(buffer);
    unsigned nativePC = Bundle_alignBase(bundle) + Bundle_alignBias(bundle);
    const Bundling *contents = Bundle_contents(bundle);
    int count = Bundle_count(bundle), i;
    for (i = 0; i < count; i++) {
      bundlings[i] = contents[i];
    }
    hash = BundlingBuffer_sort(buffer, count);
    printf("Match(%s)\t(", Bundle_name_(bundle));
    for (i = 0; i < count; i++) {
      printf("%s", Bundling_name_(bundlings[i]));
      if (i < count - 1) printf(",");
    }
    printf(")\tHASH(%u)\n", hash);
    found = BundleMatch_FindBundle(hash, nativePC);
    Except_ALWAYS(found == bundle);
  }
}
#endif//Bundle_ISSUE_MAX


#endif//Bundle__c_INCLUDED
