#ifndef Bundling_c_INCLUDED
#define Bundling_c_INCLUDED

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundling.xcc"
#include "MDS/MDS_.h"

#line 31 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundling.xcc"
const int Bundling__COUNT = Bundling__;

#line 33 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundling.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 41 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundling.xcc"
#ifndef ECL_NTRACE
const char *
Bundling_name_(Bundling this)
{
  static const char *_[] = {
#define Bundling(NAME) \
    #NAME,
    "_UNDEF",
#include "Bundling.enum"
  };
  Except_REQUIRE((unsigned)this < Bundling__);
  return _[this];
}
#endif//ECL_NTRACE

#line 64 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundling.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 93 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundling.xcc"
#if Bundle_ISSUE_MAX
int32_t
BundlingBuffer_sort(BundlingBuffer this, int count)
{
  Bundling *bundlings = BundlingBuffer_BUNDLINGS(this);
  uint8_t *permute = BundlingBuffer_PERMUTE(this);
  uint32_t hash = -1;
  if (count >= 1) {
    hash = bundlings[0] - Bundling__BIAS;
    permute[0] = 0;
    if (count >= 2) {
      int bundling_0 = bundlings[0];
      int bundling_1 = bundlings[1];
      permute[1] = 1;
      if (bundling_1 < bundling_0) {
        int bundling_t = bundling_0;
        bundlings[0] = bundling_1;
        bundlings[1] = bundling_0;
        permute[0] = 1;
        permute[1] = 0;
        bundling_0 = bundling_1;
        bundling_1 = bundling_t;
      }
      if (count >= 3) {
        int bundling_2 = bundlings[2];
        int permute_2 = 2;
        permute[2] = permute_2;
        if (bundling_2 < bundling_0) {
          int bundling_t = bundling_0;
          bundlings[0] = bundling_2;
          bundlings[2] = bundling_0;
          permute[2] = permute[0];
          permute[0] = permute_2;
          permute_2 = permute[2];
          bundling_2 = bundling_t;
        }
        if (bundling_2 < bundling_1) {
          bundlings[1] = bundling_2;
          bundlings[2] = bundling_1;
          permute[2] = permute[1];
          permute[1] = permute_2;
        }
        if (count >= 4) {
          int sortedCount = 3, i, j;
          // Insertion sort. TODO: implement a better sort algorithm.
          for (i = sortedCount; i < count; i++) {
            int bundling_t = bundlings[i];
            int permute_t = i;
            permute[i] = permute_t;
            for (j = i-1; j >= 0 && bundling_t < bundlings[j]; j--) {
              bundlings[j+1] = bundlings[j];
              permute[j+1] = permute[j];
            }
            bundlings[j+1] = bundling_t;
            permute[j+1] = permute_t;
          }
          hash = bundlings[0] - Bundling__BIAS;
          for (i = 1; i < count; i++) {
            hash++; hash *= (Bundling__ - Bundling__BIAS);
            hash += (bundlings[i] - Bundling__BIAS);
          }
        } else {
          // count == 3
          hash = bundlings[0] - Bundling__BIAS;
          hash++; hash *= (Bundling__ - Bundling__BIAS);
          hash += bundlings[1] - Bundling__BIAS;
          hash++; hash *= (Bundling__ - Bundling__BIAS);
          hash += bundlings[2] - Bundling__BIAS;
        }
      } else {
        // count == 2
        hash = bundlings[0] - Bundling__BIAS;
        hash++; hash *= (Bundling__ - Bundling__BIAS);
        hash += bundlings[1] - Bundling__BIAS;
      }
    }
  }
  return ++hash;
}
#endif//Bundle_ISSUE_MAX

#line 208 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundling.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 214 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundling.xcc"
#ifndef ECL_NTRACE
bool
Bundling_DTD(FILE *file)
{
  fputs(
        "<!ELEMENT Bundling EMPTY >"
        "<!ATTLIST Bundling"
        "  ID ID #REQUIRED"
        ">"
       , file);
  return true;
}
#endif//ECL_NTRACE

#line 232 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundling.xcc"
#ifndef ECL_NTRACE
bool
Bundling_XML(FILE *file)
{
  int bundling;
  for (bundling = 0; bundling < Bundling__; bundling++) {
    fprintf(file, "<Bundling ID=\"Bundling_%s\" />\n", Bundling_name_(bundling));
  }
  return true;
}
#endif//ECL_NTRACE

#line 256 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundling.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 269 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundling.xcc"
#if XCC__C
static void
Bundling_TEST(void)
{
#include "MDS/Bundling_.c"
}

#line 276 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundling.xcc"
int
main(int argc, char **argv)
{
  MDS_Test(Bundling_TEST);
  return 0;
}
#endif


#endif//Bundling_c_INCLUDED
