#ifndef Bundling__c_INCLUDED
#define Bundling__c_INCLUDED

#line 56 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundling.xcc"
//
{
  int bundling = 0;
  for (bundling = 0; bundling < Bundling__; bundling++) {
    printf("Bundling_%s\t%d\n", Bundling_name_(bundling), bundling);
  }
}

#line 174 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundling.xcc"
//
#if Bundle_ISSUE_MAX
{
  int i, j, k, l;
  int count = Bundle_ISSUE_MAX;
  k = 0;
  l = Bundling__ != 7? 7: 11;
  for (j = 0; j < 20; j++) {
    BundlingBuffer_ buffer[1];
    Bundling *bundlings = BundlingBuffer_BUNDLINGS(buffer);
    uint8_t *permute = BundlingBuffer_PERMUTE(buffer);
    Bundling unsorted_bundlings[Bundle_ISSUE_MAX];
    printf("Bundlings:");
    for (i = 0; i < count; i++) {
      unsorted_bundlings[i] = bundlings[i] = k%(Bundling__ - 1) + 1;
      printf("\t%s", Bundling_name_(bundlings[i]));
      k += l;
    }
    printf("\nSorted:   ");
    BundlingBuffer_sort(buffer, count);
    for (i = 0; i < count; i++) {
      printf("\t%s", Bundling_name_(bundlings[i]));
      if (i > 0) Except_ALWAYS(bundlings[i] >= bundlings[i - 1]);
    }
    printf("\nPermute:  ");
    for (i = 0; i < count; i++) {
      printf("\t%d\t", permute[i]);
      Except_ALWAYS(unsorted_bundlings[permute[i]] == bundlings[i]);
    }
    printf("\n");
  }
}
#endif//Bundle_ISSUE_MAX

#line 244 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Bundling.xcc"
//
{
#ifndef ECL_NTRACE
  FILE *dtd = fopen("Bundling.dtd", "w");
  FILE *xml = fopen("Bundling.xml", "w");
  dtd && Bundling_DTD(dtd);
  xml && Bundling_XML(xml);
  dtd && fclose(dtd);
  xml && fclose(xml);
#endif//ECL_NTRACE
}


#endif//Bundling__c_INCLUDED
