#ifndef Convention_c_INCLUDED
#define Convention_c_INCLUDED

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
#include "MDS/MDS_.h"

#line 34 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
const int Convention__COUNT = Convention__;

#line 36 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 64 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
#ifndef ECL_NTRACE
const char *
ConventionRole_name_(ConventionRole this)
{
  static const char *_[] = {
    "Reserved",
    "Argument",
    "Result",
    "Struct",
    "Caller",
    "Callee",
    "Program",
    "Return",
    "Stack",
    "Frame",
    "Static",
    "Global",
    "Local",
    "Wired",
    "Zero",
    "One",
  };
  Except_REQUIRE((unsigned)this < ConventionRole__);
  return _[this];
}
#endif//ECL_NTRACE

#line 91 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 99 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
#ifndef ECL_NTRACE
const char *
Convention_name_(Convention this)
{
  static const char *_[] = {
#define Convention(NAME, RESERVED, ARGUMENT, RESULT, STRUCT, CALLER, CALLEE, PROGRAM, \
                   RETURN, STACK, STATIC, FRAME, GLOBAL, LOCAL, WIRED, ZERO, ONE, \
                   ALIGNTEXT, ALIGNDATA, ALIGNHEAP, ALIGNSTACK, \
                   NATIVEINT, NATIVEUINT, NATIVEFLOAT, NATIVEPTR) \
    #NAME,
    "_UNDEF",
#include "Convention.enum"
  };
  Except_REQUIRE((unsigned)this < Convention__);
  return _[this];
}
#endif//ECL_NTRACE

#line 125 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 136 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
const RegisterList_
Convention_RoleRegisterLists[Convention__][ConventionRole__] = {
#define REGISTER(NAME) Register_##NAME,
#define RESERVED(count, items) { count, { items } }
#define ARGUMENT(count, items) { count, { items } }
#define RESULT(count, items) { count, { items } }
#define STRUCT(count, items) { count, { items } }
#define CALLER(count, items) { count, { items } }
#define CALLEE(count, items) { count, { items } }
#define PROGRAM(count, items) { count, { items } }
#define RETURN(count, items) { count, { items } }
#define STACK(count, items) { count, { items } }
#define FRAME(count, items) { count, { items } }
#define STATIC(count, items) { count, { items } }
#define GLOBAL(count, items) { count, { items } }
#define LOCAL(count, items) { count, { items } }
#define WIRED(count, items) { count, { items } }
#define ZERO(count, items) { count, { items } }
#define ONE(count, items) { count, { items } }
#define Convention(NAME, RESERVED, ARGUMENT, RESULT, STRUCT, CALLER, CALLEE, PROGRAM, \
                   RETURN, STACK, STATIC, FRAME, GLOBAL, LOCAL, WIRED, ZERO, ONE, \
                   ALIGNTEXT, ALIGNDATA, ALIGNHEAP, ALIGNSTACK, \
                   NATIVEINT, NATIVEUINT, NATIVEFLOAT, NATIVEPTR) \
  { RESERVED, ARGUMENT, RESULT, STRUCT, CALLER, CALLEE, PROGRAM, \
    RETURN, STACK, FRAME, STATIC, GLOBAL, LOCAL, WIRED, ZERO, ONE },
  { { 0 } },
#include "Convention.enum"
};

#line 170 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 178 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
extern RegisterSet_
Convention_RoleRegisterSets[Convention__][ConventionRole__];
const_RegisterSet
Convention_roleRegisterSet(Convention this, ConventionRole role)
{
  Except_REQUIRE((unsigned)this < Convention__);
  Except_REQUIRE((unsigned)role < ConventionRole__);
  return &Convention_RoleRegisterSets[this][role];
}

#line 188 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
RegisterSet_
Convention_RoleRegisterSets[Convention__][ConventionRole__];

#line 211 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 281 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 289 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
void
Convention_setRole(Convention this, ConventionRole role, Register registre)
{
  Except_REQUIRE((unsigned)this < Convention__);
  Except_REQUIRE((unsigned)role < ConventionRole__);
  Except_REQUIRE((unsigned)registre < Register__);
  RegisterSet_insert(&Convention_RoleRegisterSets[this][role], registre);
}

#line 298 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 306 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
extern Register
Convention_StructRegister[Convention__];
Register
Convention_structRegister(Convention this)
{
  Except_REQUIRE((unsigned)this < Convention__);
  return (Register)Convention_StructRegister[this];
}

#line 315 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
Register
Convention_StructRegister[Convention__];

#line 328 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 336 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
extern Register
Convention_ProgramRegister[Convention__];
Register
Convention_programRegister(Convention this)
{
  Except_REQUIRE((unsigned)this < Convention__);
  return (Register)Convention_ProgramRegister[this];
}

#line 345 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
Register
Convention_ProgramRegister[Convention__];

#line 358 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 366 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
extern Register
Convention_ReturnRegister[Convention__];
Register
Convention_returnRegister(Convention this)
{
  Except_REQUIRE((unsigned)this < Convention__);
  return (Register)Convention_ReturnRegister[this];
}

#line 375 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
Register
Convention_ReturnRegister[Convention__];

#line 388 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 396 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
extern Register
Convention_StackRegister[Convention__];
Register
Convention_stackRegister(Convention this)
{
  Except_REQUIRE((unsigned)this < Convention__);
  return (Register)Convention_StackRegister[this];
}

#line 405 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
Register
Convention_StackRegister[Convention__];

#line 418 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 426 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
extern Register
Convention_FrameRegister[Convention__];
Register
Convention_frameRegister(Convention this)
{
  Except_REQUIRE((unsigned)this < Convention__);
  return (Register)Convention_FrameRegister[this];
}

#line 435 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
Register
Convention_FrameRegister[Convention__];

#line 448 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 456 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
extern Register
Convention_StaticRegister[Convention__];
Register
Convention_staticRegister(Convention this)
{
  Except_REQUIRE((unsigned)this < Convention__);
  return (Register)Convention_StaticRegister[this];
}

#line 465 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
Register
Convention_StaticRegister[Convention__];

#line 478 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 486 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
extern Register
Convention_GlobalRegister[Convention__];
Register
Convention_globalRegister(Convention this)
{
  Except_REQUIRE((unsigned)this < Convention__);
  return (Register)Convention_GlobalRegister[this];
}

#line 495 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
Register
Convention_GlobalRegister[Convention__];

#line 508 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 516 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
extern Register
Convention_LocalRegister[Convention__];
Register
Convention_localRegister(Convention this)
{
  Except_REQUIRE((unsigned)this < Convention__);
  return (Register)Convention_LocalRegister[this];
}

#line 525 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
Register
Convention_LocalRegister[Convention__];

#line 538 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 546 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
extern const uint8_t
Convention_AlignText[];
unsigned
Convention_alignText(Convention this)
{
  Except_REQUIRE((unsigned)this < Convention__);
  return Convention_AlignText[this];
}

#line 555 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
const uint8_t
Convention_AlignText[] = {
#define ALIGNTEXT(base) base,
#define Convention(NAME, RESERVED, ARGUMENT, RESULT, STRUCT, CALLER, CALLEE, PROGRAM, \
                   RETURN, STACK, STATIC, FRAME, GLOBAL, LOCAL, WIRED, ZERO, ONE, \
                   ALIGNTEXT, ALIGNDATA, ALIGNHEAP, ALIGNSTACK, \
                   NATIVEINT, NATIVEUINT, NATIVEFLOAT, NATIVEPTR) \
  ALIGNTEXT
  ALIGNTEXT(0)
#include "Convention.enum"
#undef ALIGNTEXT
};

#line 577 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 585 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
extern const uint8_t
Convention_AlignData[];
unsigned
Convention_alignData(Convention this)
{
  Except_REQUIRE((unsigned)this < Convention__);
  return Convention_AlignData[this];
}

#line 594 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
const uint8_t
Convention_AlignData[] = {
#define ALIGNDATA(base) base,
#define Convention(NAME, RESERVED, ARGUMENT, RESULT, STRUCT, CALLER, CALLEE, PROGRAM, \
                   RETURN, STACK, STATIC, FRAME, GLOBAL, LOCAL, WIRED, ZERO, ONE, \
                   ALIGNTEXT, ALIGNDATA, ALIGNHEAP, ALIGNSTACK, \
                   NATIVEINT, NATIVEUINT, NATIVEFLOAT, NATIVEPTR) \
  ALIGNDATA
  ALIGNDATA(0)
#include "Convention.enum"
#undef ALIGNDATA
};

#line 616 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 624 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
extern const uint8_t
Convention_AlignHeap[];
unsigned
Convention_alignHeap(Convention this)
{
  Except_REQUIRE((unsigned)this < Convention__);
  return Convention_AlignHeap[this];
}

#line 633 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
const uint8_t
Convention_AlignHeap[] = {
#define ALIGNHEAP(base) base,
#define Convention(NAME, RESERVED, ARGUMENT, RESULT, STRUCT, CALLER, CALLEE, PROGRAM, \
                   RETURN, STACK, STATIC, FRAME, GLOBAL, LOCAL, WIRED, ZERO, ONE, \
                   ALIGNTEXT, ALIGNDATA, ALIGNHEAP, ALIGNSTACK, \
                   NATIVEINT, NATIVEUINT, NATIVEFLOAT, NATIVEPTR) \
  ALIGNHEAP
  ALIGNHEAP(0)
#include "Convention.enum"
#undef ALIGNHEAP
};

#line 655 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 663 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
extern const uint8_t
Convention_AlignStack[];
unsigned
Convention_alignStack(Convention this)
{
  Except_REQUIRE((unsigned)this < Convention__);
  return Convention_AlignStack[this];
}

#line 672 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
const uint8_t
Convention_AlignStack[] = {
#define ALIGNSTACK(base) base,
#define Convention(NAME, RESERVED, ARGUMENT, RESULT, STRUCT, CALLER, CALLEE, PROGRAM, \
                   RETURN, STACK, STATIC, FRAME, GLOBAL, LOCAL, WIRED, ZERO, ONE, \
                   ALIGNTEXT, ALIGNDATA, ALIGNHEAP, ALIGNSTACK, \
                   NATIVEINT, NATIVEUINT, NATIVEFLOAT, NATIVEPTR) \
  ALIGNSTACK
  ALIGNSTACK(0)
#include "Convention.enum"
#undef ALIGNSTACK
};

#line 694 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 702 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
extern const NativeType
Convention_NativeInt[];
NativeType
Convention_nativeInt(Convention this)
{
  Except_REQUIRE((unsigned)this < Convention__);
  return (NativeType)Convention_NativeInt[this];
}

#line 711 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
const NativeType
Convention_NativeInt[] = {
#define NATIVEINT(name) NativeType_##name,
#define Convention(NAME, RESERVED, ARGUMENT, RESULT, STRUCT, CALLER, CALLEE, PROGRAM, \
                   RETURN, STACK, STATIC, FRAME, GLOBAL, LOCAL, WIRED, ZERO, ONE, \
                   ALIGNTEXT, ALIGNDATA, ALIGNHEAP, ALIGNSTACK, \
                   NATIVEINT, NATIVEUINT, NATIVEFLOAT, NATIVEPTR) \
  NATIVEINT
  NativeType_,
#include "Convention.enum"
#undef NATIVEINT
};

#line 734 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 742 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
extern const NativeType
Convention_NativeUInt[];
NativeType
Convention_nativeUInt(Convention this)
{
  Except_REQUIRE((unsigned)this < Convention__);
  return (NativeType)Convention_NativeUInt[this];
}

#line 751 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
const NativeType
Convention_NativeUInt[] = {
#define NATIVEUINT(name) NativeType_##name,
#define Convention(NAME, RESERVED, ARGUMENT, RESULT, STRUCT, CALLER, CALLEE, PROGRAM, \
                   RETURN, STACK, STATIC, FRAME, GLOBAL, LOCAL, WIRED, ZERO, ONE, \
                   ALIGNTEXT, ALIGNDATA, ALIGNHEAP, ALIGNSTACK, \
                   NATIVEINT, NATIVEUINT, NATIVEFLOAT, NATIVEPTR) \
  NATIVEUINT
  NativeType_,
#include "Convention.enum"
#undef NATIVEUINT
};

#line 774 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 782 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
extern const NativeType
Convention_NativeFloat[];
NativeType
Convention_nativeFloat(Convention this)
{
  Except_REQUIRE((unsigned)this < Convention__);
  return (NativeType)Convention_NativeFloat[this];
}

#line 791 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
const NativeType
Convention_NativeFloat[] = {
#define NATIVEFLOAT(name) NativeType_##name,
#define Convention(NAME, RESERVED, ARGUMENT, RESULT, STRUCT, CALLER, CALLEE, PROGRAM, \
                   RETURN, STACK, STATIC, FRAME, GLOBAL, LOCAL, WIRED, ZERO, ONE, \
                   ALIGNTEXT, ALIGNDATA, ALIGNHEAP, ALIGNSTACK, \
                   NATIVEINT, NATIVEUINT, NATIVEFLOAT, NATIVEPTR) \
  NATIVEFLOAT
  NativeType_,
#include "Convention.enum"
#undef NATIVEFLOAT
};

#line 814 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 822 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
extern const NativeType
Convention_NativePtr[];
NativeType
Convention_nativePtr(Convention this)
{
  Except_REQUIRE((unsigned)this < Convention__);
  return (NativeType)Convention_NativePtr[this];
}

#line 831 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
const NativeType
Convention_NativePtr[] = {
#define NATIVEPTR(name) NativeType_##name,
#define Convention(NAME, RESERVED, ARGUMENT, RESULT, STRUCT, CALLER, CALLEE, PROGRAM, \
                   RETURN, STACK, STATIC, FRAME, GLOBAL, LOCAL, WIRED, ZERO, ONE, \
                   ALIGNTEXT, ALIGNDATA, ALIGNHEAP, ALIGNSTACK, \
                   NATIVEINT, NATIVEUINT, NATIVEFLOAT, NATIVEPTR) \
  NATIVEPTR
  NativeType_,
#include "Convention.enum"
#undef NATIVEPTR
};

#line 854 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 856 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
/**
 * Returns a Register identifier from a (kind,num) pair.
 * \param kind the char for the register file
 * \param num the register number in the register file starting at 0
 * \return the Register identifier or \e Register_ if (kind,num) is invalid
 */
static Register
getRegister(char kind, int num)
{
  int class = 0;
  kind = tolower(kind);
#ifndef ECL_NTRACE
  for (; class < RegFile__; class++) {
    char id = tolower(*Register_name(RegFile_lowRegister(class)));
    if (id == kind) {
      if (RegFile_lowRegister(class)+num <= RegFile_highRegister(class))
        return RegFile_lowRegister(class)+num;
      else
        return Register_;
    }
  }
#endif//ECL_NTRACE
  return Register_;
}

#line 881 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
/**
 * Returns a Register identifier from a register string
 * \param str the string to convert
 * \param pptr a pointer into which the position after match is set
 * \return the Register identifier or \e Register_ if str is invalid
 */
static Register
strRegToRegister(const char *str, const char **pptr)
{
  char kind;
  int num;
  char *ptr2;
  const char *ptr;
  int reg;
  //
  ptr = str;
  if (*ptr == '\0') goto failed;
  kind = *ptr;
  if (!isalpha(kind)) goto failed;
  ptr++;
  num = strtol(ptr, &ptr2, 10);
  if (ptr2 == ptr) goto failed;
  ptr = ptr2;
  //
  reg = getRegister(kind, num);
  if (reg == Register_) goto failed;
  *pptr = ptr;
  return reg;
failed:
  *pptr = str;
  return Register_;
}

#line 914 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
/**
 * Add into a RegisterSet the set of registers specified by a register range.
 * \param str the string to convert
 * \param pptr a pointer into which the position after match is set
 * \param registers the RegisterSet to fill
 * \return 0 for success, -1 if the string is an invalid register range
 */
static int
strRangeToRegisters(const char *str, const char **pptr, RegisterSet registers)
{
  char kind;
  int num;
  const char *ptr2;
  const char *ptr;
  int reg1, reg2, reg;
  //
  ptr = str;
  if (*ptr == '\0') goto failed;
  //
  reg1 = strRegToRegister(ptr, &ptr2);
  if (reg1 == Register_) goto failed;
  ptr = ptr2;
  if (*ptr != '-') { reg2 = reg1; }
  else {
    ptr++;
    reg2 = strRegToRegister(ptr, &ptr2);
    if (reg2 == Register_) goto failed;
    ptr = ptr2;
  }
  if (reg2 < reg1) goto failed;
  //
  for (reg = reg1; reg <= reg2; reg++) {
    RegisterSet_insert(registers, reg);
  }
  *pptr = ptr;
  return 0;
failed:
  *pptr = str;
  return -1;
}

#line 955 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
/**
 * Add into a BitSet the set of registers specified by a register set.
 * \param str the string to convert
 * \param pptr a pointer into which the position after match is set
 * \param registers the BitSet to fill
 * \return 0 for success, -1 if the string is an invalid register set
 */
static int
strToRegisters(const char *str, const char **pptr, RegisterSet registers)
{
  const char *ptr;
  const char *ptr2;
  int sep;
  //
  ptr = str;
  if (*ptr == '\0') goto end;
  do {
    int status = strRangeToRegisters(ptr, &ptr2, registers);
    if (status == -1) goto failed;
    ptr = ptr2;
    sep = *ptr++;
  } while (sep == ':' || sep == '_');
  ptr--;
end:
  if (pptr != NULL) *pptr = ptr;
  return 0;
failed:
  if (pptr != NULL) *pptr = str;
  return -1;
}

#line 990 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
RegisterSet_
Convention_allocatableSet(Convention this, RegFile regFile)
{
  const_RegisterSet reservedSet = Convention_roleRegisterSet(this, ConventionRole_Reserved);
  const char *allocatable_str = GETENV("GRA_REGS");
  RegisterSet_ allocatableSet[1];
  RegisterSet_Copy(allocatableSet, RegFile_registerSet(regFile));
  RegisterSet_diff(allocatableSet, reservedSet);
  if (allocatable_str != NULL) {
    RegisterSet_ usableSet[1];
    RegisterSet_Ctor(usableSet);
    if (strToRegisters(allocatable_str, NULL, usableSet) == -1) {
      fprintf(stderr, "Warning: error in alocatable_reg set, ignored\n");
    }
    RegisterSet_inter(allocatableSet, usableSet);
    RegisterSet_Dtor(usableSet);
  }
  return *allocatableSet;
}

#line 1010 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1016 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
#ifndef ECL_NTRACE
bool
Convention_DTD(FILE *file)
{
  fputs(
        "<!ELEMENT Convention EMPTY >"
        "<!ATTLIST Convention"
        "  ID ID #REQUIRED"
        ">"
       , file);
  return true;
}
#endif//ECL_NTRACE

#line 1034 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
#ifndef ECL_NTRACE
bool
Convention_XML(FILE *file)
{
  int convention;
  for (convention = 0; convention < Convention__; convention++) {
    fprintf(file, "<Convention ID=\"Convention_%s\" />\n", Convention_name_(convention));
  }
  return true;
}
#endif//ECL_NTRACE

#line 1058 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1066 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
void
Convention_INIT(void)
{
  int convention = 0, role = 0;
  for (convention = 0; convention < Convention__; convention++) {
    Convention_StructRegister[convention] = Register_;
    Convention_ProgramRegister[convention] = Register_;
    Convention_ReturnRegister[convention] = Register_;
    Convention_StackRegister[convention] = Register_;
    Convention_FrameRegister[convention] = Register_;
    Convention_StaticRegister[convention] = Register_;
    Convention_GlobalRegister[convention] = Register_;
    Convention_LocalRegister[convention] = Register_;
    for (role = 0; role < ConventionRole__; role++) {
      const_RegisterList registerList = &Convention_RoleRegisterLists[convention][role];
      if (RegisterList_count(registerList) > 0) {
        RegisterSet registerSet = &Convention_RoleRegisterSets[convention][role];
        RegisterList_FOREACH_Register(registerList, registre) {
          RegisterSet_insert(registerSet, registre);
        } RegisterList_ENDEACH_Register;
        if (role == ConventionRole_Struct) {
          Convention_StructRegister[convention] = RegisterList_first(registerList);
        }
        if (role == ConventionRole_Program) {
          Convention_ProgramRegister[convention] = RegisterList_first(registerList);
        }
        if (role == ConventionRole_Return) {
          Convention_ReturnRegister[convention] = RegisterList_first(registerList);
        }
        if (role == ConventionRole_Stack) {
          Convention_StackRegister[convention] = RegisterList_first(registerList);
        }
        if (role == ConventionRole_Frame) {
          Convention_FrameRegister[convention] = RegisterList_first(registerList);
        }
        if (role == ConventionRole_Static) {
          Convention_StaticRegister[convention] = RegisterList_first(registerList);
        }
        if (role == ConventionRole_Global) {
          Convention_GlobalRegister[convention] = RegisterList_first(registerList);
        }
        if (role == ConventionRole_Local) {
          Convention_LocalRegister[convention] = RegisterList_first(registerList);
        }
      }
    }
  }
}

#line 1120 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
#if XCC__C
static void
Convention_TEST(void)
{
#include "MDS/Convention_.c"
}

#line 1127 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
int
main(int argc, char **argv)
{
  MDS_Test(Convention_TEST);
  return 0;
}
#endif


#endif//Convention_c_INCLUDED
