#ifndef Convention__c_INCLUDED
#define Convention__c_INCLUDED

#line 117 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
//
{
  int convention;
  for (convention = 0; convention < Convention__; convention++) {
    printf("Convention_%s\t%d\n", Convention_name_(convention), convention);
  }
}

#line 165 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
//
{
  printf("sizeof(Convention_RoleRegisterLists)\t%d\n", sizeof(Convention_RoleRegisterLists));
}

#line 191 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
//
{
  printf("sizeof(Convention_RoleRegisterSets)\t%d\n", sizeof(Convention_RoleRegisterSets));
}

#line 196 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
//
{
  int convention = 0, role = 0;
  for (convention = 0; convention < Convention__; convention++) {
    for (role = 0; role < ConventionRole__; role++) {
      const_RegisterSet registerSet = Convention_roleRegisterSet(convention, role);
      printf("%sSet(%s)", ConventionRole_name_(role), Convention_name_(convention));
      RegisterSet_FOREACH_Register(registerSet, registre) {
        printf("\t%s", Register_name_(registre));
      } RegisterSet_ENDEACH_Register;
      printf("\n");
    }
  }
}

#line 318 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
//
{
  int convention;
  for (convention = 0; convention < Convention__; convention++) {
    Register structRegister = Convention_structRegister(convention);
    printf("StructRegister(%s)\t%s\n", Convention_name_(convention), Register_name_(structRegister));
  }
  printf("sizeof(Convention_StructRegister)\t%d\n", sizeof(Convention_StructRegister));
}

#line 348 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
//
{
  int convention;
  for (convention = 0; convention < Convention__; convention++) {
    int programRegister = Convention_programRegister(convention);
    printf("ProgramRegister(%s)\t%s\n", Convention_name_(convention), Register_name_(programRegister));
  }
  printf("sizeof(Convention_ProgramRegister)\t%d\n", sizeof(Convention_ProgramRegister));
}

#line 378 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
//
{
  int convention;
  for (convention = 0; convention < Convention__; convention++) {
    int returnRegister = Convention_returnRegister(convention);
    printf("ReturnRegister(%s)\t%s\n", Convention_name_(convention), Register_name_(returnRegister));
  }
  printf("sizeof(Convention_ReturnRegister)\t%d\n", sizeof(Convention_ReturnRegister));
}

#line 408 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
//
{
  int convention;
  for (convention = 0; convention < Convention__; convention++) {
    int stackRegister = Convention_stackRegister(convention);
    printf("StackRegister(%s)\t%s\n", Convention_name_(convention), Register_name_(stackRegister));
  }
  printf("sizeof(Convention_StackRegister)\t%d\n", sizeof(Convention_StackRegister));
}

#line 438 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
//
{
  int convention;
  for (convention = 0; convention < Convention__; convention++) {
    int frameRegister = Convention_frameRegister(convention);
    printf("FrameRegister(%s)\t%s\n", Convention_name_(convention), Register_name_(frameRegister));
  }
  printf("sizeof(Convention_FrameRegister)\t%d\n", sizeof(Convention_FrameRegister));
}

#line 468 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
//
{
  int convention;
  for (convention = 0; convention < Convention__; convention++) {
    int staticRegister = Convention_staticRegister(convention);
    printf("StaticRegister(%s)\t%s\n", Convention_name_(convention), Register_name_(staticRegister));
  }
  printf("sizeof(Convention_StaticRegister)\t%d\n", sizeof(Convention_StaticRegister));
}

#line 498 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
//
{
  int convention;
  for (convention = 0; convention < Convention__; convention++) {
    int globalRegister = Convention_globalRegister(convention);
    printf("GlobalRegister(%s)\t%s\n", Convention_name_(convention), Register_name_(globalRegister));
  }
  printf("sizeof(Convention_GlobalRegister)\t%d\n", sizeof(Convention_GlobalRegister));
}

#line 528 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
//
{
  int convention;
  for (convention = 0; convention < Convention__; convention++) {
    int localRegister = Convention_localRegister(convention);
    printf("LocalRegister(%s)\t%s\n", Convention_name_(convention), Register_name_(localRegister));
  }
  printf("sizeof(Convention_LocalRegister)\t%d\n", sizeof(Convention_LocalRegister));
}

#line 568 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
//
{
  int convention;
  for (convention = 0; convention < Convention__; convention++) {
    printf("AlignText(%s)\t%d\n", Convention_name_(convention), Convention_alignText(convention));
  }
  printf("sizeof(Convention_AlignText)\t%d\n", sizeof(Convention_AlignText));
}

#line 607 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
//
{
  int convention;
  for (convention = 0; convention < Convention__; convention++) {
    printf("AlignData(%s)\t%d\n", Convention_name_(convention), Convention_alignData(convention));
  }
  printf("sizeof(Convention_AlignData)\t%d\n", sizeof(Convention_AlignData));
}

#line 646 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
//
{
  int convention;
  for (convention = 0; convention < Convention__; convention++) {
    printf("AlignHeap(%s)\t%d\n", Convention_name_(convention), Convention_alignHeap(convention));
  }
  printf("sizeof(Convention_AlignHeap)\t%d\n", sizeof(Convention_AlignHeap));
}

#line 685 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
//
{
  int convention;
  for (convention = 0; convention < Convention__; convention++) {
    printf("AlignStack(%s)\t%d\n", Convention_name_(convention), Convention_alignStack(convention));
  }
  printf("sizeof(Convention_AlignStack)\t%d\n", sizeof(Convention_AlignStack));
}

#line 724 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
//
{
  int convention;
  for (convention = 0; convention < Convention__; convention++) {
    printf("NativeInt(%s)\t%s\n", Convention_name_(convention),
           NativeType_name_(Convention_nativeInt(convention)));
  }
  printf("sizeof(Convention_NativeInt)\t%d\n", sizeof(Convention_NativeInt));
}

#line 764 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
//
{
  int convention;
  for (convention = 0; convention < Convention__; convention++) {
    printf("NativeUInt(%s)\t%s\n", Convention_name_(convention),
           NativeType_name_(Convention_nativeUInt(convention)));
  }
  printf("sizeof(Convention_NativeUInt)\t%d\n", sizeof(Convention_NativeUInt));
}

#line 804 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
//
{
  int convention;
  for (convention = 0; convention < Convention__; convention++) {
    printf("NativeFloat(%s)\t%s\n", Convention_name_(convention),
           NativeType_name_(Convention_nativeFloat(convention)));
  }
  printf("sizeof(Convention_NativeFloat)\t%d\n", sizeof(Convention_NativeFloat));
}

#line 844 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
//
{
  int convention;
  for (convention = 0; convention < Convention__; convention++) {
    printf("NativePtr(%s)\t%s\n", Convention_name_(convention),
           NativeType_name_(Convention_nativePtr(convention)));
  }
  printf("sizeof(Convention_NativePtr)\t%d\n", sizeof(Convention_NativePtr));
}

#line 1046 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Convention.xcc"
//
{
#ifndef ECL_NTRACE
  FILE *dtd = fopen("Convention.dtd", "w");
  FILE *xml = fopen("Convention.xml", "w");
  dtd && Convention_DTD(dtd);
  xml && Convention_XML(xml);
  dtd && fclose(dtd);
  xml && fclose(xml);
#endif//ECL_NTRACE
}


#endif//Convention__c_INCLUDED
