#ifndef Immediate__c_INCLUDED
#define Immediate__c_INCLUDED

#line 56 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Immediate.xcc"
//
{
  printf("sizeof(ImmediateConstant_)\t%d\n", sizeof(ImmediateConstant_));
}

#line 84 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Immediate.xcc"
//
{
  int immediate = 0;
  for (; immediate < Immediate__; immediate++) {
    printf("Immediate_%s\t%d\n", Immediate_name_(immediate), immediate);
  }
}

#line 118 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Immediate.xcc"
//
{
  int immediate = 0;
  for (; immediate < Immediate__; immediate++) {
    printf("Immediate_minValue(%s)\t%lld\n", Immediate_name_(immediate),
           (long long)Immediate_minValue(immediate));
  }
  printf("sizeof(Immediate_MinValue)\t%d\n", sizeof(Immediate_MinValue));
}

#line 154 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Immediate.xcc"
//
{
  int immediate = 0;
  for (; immediate < Immediate__; immediate++) {
    printf("Immediate_maxValue(%s)\t%lld\n", Immediate_name_(immediate),
           (long long)Immediate_maxValue(immediate));
  }
  printf("sizeof(Immediate_MaxValue)\t%d\n", sizeof(Immediate_MaxValue));
}

#line 243 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Immediate.xcc"
//
{
  int immediate = 0;
  for (; immediate < Immediate__; immediate++) {
    const_ImmediateRelocations relocations = Immediate_relocations(immediate);
    printf("\nImmediate_relocations(%s)", Immediate_name_(immediate));
    ImmediateRelocations_FOREACH_Relocation(relocations, relocation) {
      printf("\t%s", Relocation_name_(relocation));
    } ImmediateRelocations_ENDEACH_Relocation;
  }
  printf("\n");
  printf("sizeof(Immediate_Relocations)\t%d\n", sizeof(Immediate_Relocations));
}

#line 286 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Immediate.xcc"
//
{
  int immediate = 0;
  for (; immediate < Immediate__; immediate++) {
    int64_t minValue = Immediate_minValue(immediate);
    int64_t maxValue = Immediate_maxValue(immediate);
    if (minValue > maxValue) {
    } else if (maxValue - minValue >= 65536) {
    } else {
      int64_t value = minValue - 1;
      for (; value <= maxValue + 1; value++) {
        if (Immediate_canEncode(immediate, value)) {
        } else {
          printf("\nCannotEncode(%s,%lld)\tminValue=%lld\tmaxValue=%lld",
                 Immediate_name_(immediate), value, minValue, maxValue);
        }
      }
    }
  }
  printf("\n");
}


#endif//Immediate__c_INCLUDED
