#ifndef Operand__c_INCLUDED
#define Operand__c_INCLUDED

#line 72 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
//
{
  int operand = 0;
  for (operand = 0; operand < Operand__; operand++) {
    printf("Operand_%s\t%d\n", Operand_name_(operand), operand);
  }
}

#line 138 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
//
{
  int operand = 0;
  for (operand = 0; operand < Operand__; operand++) {
    printf("\nOperandType(%s)\t%s", Operand_name_(operand), OperandType_name_(Operand_type(operand)));
  }
  printf("\n");
  printf("sizeof(Operand_Type)\t%d\n", sizeof(Operand_Type));
}

#line 192 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
//
{
  int operand = 0;
  for (operand = 0; operand < Operand__; operand++) {
    printf("\nOperand_modifier(%s)\t%s", Operand_name_(operand),
           Modifier_name_(Operand_modifier(operand)));
  }
  printf("\n");
}

#line 219 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
//
{
  int operand = 0;
  for (operand = 0; operand < Operand__; operand++) {
    printf("\nOperand_immediate(%s)\t%s", Operand_name_(operand),
           Immediate_name_(Operand_immediate(operand)));
  }
  printf("\n");
}

#line 246 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
//
{
  int operand = 0;
  for (operand = 0; operand < Operand__; operand++) {
    printf("\nOperand_regClass(%s)\t%s", Operand_name_(operand),
           RegClass_name_(Operand_regClass(operand)));
  }
  printf("\n");
}

#line 273 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
//
{
  int operand = 0;
  for (operand = 0; operand < Operand__; operand++) {
    printf("\nOperand_regMask(%s)\t%s", Operand_name_(operand),
           RegMask_name_(Operand_regMask(operand)));
  }
  printf("\n");
}

#line 341 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
//
{
  int operand = 0;
  for (operand = 0; operand < Operand__; operand++) {
    int immediate = Operand_immediate(operand);
    int64_t minValue = Immediate_minValue(immediate);
    int64_t maxValue = Immediate_maxValue(immediate);
    ImmediateValue value = (ImmediateValue)minValue;
    if (immediate != Immediate_) {
    long long encoded = 0;
    Operand_encodeImmediateValue(operand, value, &encoded);
    printf("\nOperand_encodeImmediateValue(%s,0x%llx)\t0x%llx",
           Operand_name_(operand), (long long)minValue, (long long)encoded);
    value = (ImmediateValue)maxValue;
    Operand_encodeImmediateValue(operand, value, &encoded);
    printf("\nOperand_encodeImmediateValue(%s,0x%llx)\t0x%llx",
           Operand_name_(operand), (long long)maxValue, (long long)encoded);
    }
  }
  printf("\n");
}

#line 405 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
//
{
  int operand = 0;
  InstanceOpcodes_ opcodes[1];
  for (operand = 0; operand < Operand__; operand++) {
    OperandEncode operandEncode = Operand_encode(operand);
    OperandDecode operandDecode = Operand_decode(operand);
    OperandType type = Operand_type(operand);
    printf("\nTest OperandEncode(%s)", Operand_name_(operand));
    if (type == OperandType_RegClass) {
      int regClass = Operand_regClass(operand);
      const_RegisterSet registerSet = RegClass_registerSet(regClass);
      RegisterSet_FOREACH_Register(registerSet, registre) {
        OperandDecoded result = -1;
        OperandDecoded decoded = registre;
        InstanceOpcodes_Ctor(opcodes);
        (*operandEncode)(decoded, opcodes);
        (*operandDecode)(opcodes, &result);
        if (decoded != result) {
          printf("\nDecode(Encode(%s,%x))\t%x",
                 Operand_name_(operand), decoded, result);
        }
      } RegisterSet_ENDEACH_Register;
    } else if (type == OperandType_Immediate) {
      int immediate = Operand_immediate(operand);
      int64_t minValue = Immediate_minValue(immediate);
      int64_t maxValue = Immediate_maxValue(immediate);
      if (minValue > maxValue) {
      } else if (maxValue - minValue >= 65536) {
      } else {
        int64_t value = minValue;
        for (; value <= maxValue; value++) {
          ImmediateConstant_ src[1], dst[1];
          OperandDecoded decoded = (OperandDecoded)src;
          ImmediateConstant_Ctor(src, value);
          ImmediateConstant_Ctor(dst, value);
          InstanceOpcodes_Ctor(opcodes);
          (*operandEncode)(decoded, opcodes);
          (*operandDecode)(opcodes, dst);
          if (ImmediateConstant_VALUE(src) != ImmediateConstant_VALUE(dst)) {
            printf("\nDecode(Encode(%s,%llx))\t%llx",
                   Operand_name_(operand),
                   (long long)ImmediateConstant_VALUE(src),
                   (long long)ImmediateConstant_VALUE(dst));
          }
        }
      }
    }
  }
  printf("\n");
}

#line 467 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
//
{
  printf("sizeof(OperandList_) = %d\n", sizeof(OperandList_));
}

#line 535 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
//
{
  int operands = 0;
  for (operands = 0; operands < Operands__; operands++) {
    printf("Operands_%s\t%d\n", Operands_name_(operands), operands);
  }
}

#line 580 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
//
{
  int operands = 0;
  for (operands = 0; operands < Operands__; operands++) {
    printf("\nOperandList(%s)", Operands_name_(operands));
    Operands_FOREACH_Operand(operands, operand) {
      printf("\t%s", Operand_name_(operand));
    } Operands_ENDEACH_Operand;
  }
  printf("\n");
  printf("sizeof(Operands_OperandList)\t%d\n", sizeof(Operands_OperandList));
}

#line 653 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
//
{
  printf("\n");
  printf("sizeof(OperandsBuffer_)\t%d\n", sizeof(OperandsBuffer_));
}

#line 737 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
//
{
  int operands = 0;
  for (operands = 0; operands < Operands__; operands++) {
    int relocatableRank = Operands_relocatableRank(operands);
    printf("\nRelocatableRank(%s)\t%d", Operands_name_(operands), relocatableRank);
  }
  printf("\n");
  printf("sizeof(Operands_RelocatableRank)\t%d\n", sizeof(Operands_RelocatableRank));
}

#line 777 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
//
{
  int operands = 0;
  for (operands = 0; operands < Operands__; operands++) {
    int relocatableOperand = Operands_relocatableOperand(operands);
    printf("RelocatableOperand(%s)\t%s\n", Operands_name_(operands), Operand_name_(relocatableOperand));
  }
  printf("sizeof(Operands_RelocatableOperand)\t%d\n", sizeof(Operands_RelocatableOperand));
}

#line 816 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
//
{
  int operands = 0;
  for (operands = 0; operands < Operands__; operands++) {
    int relocatableImmediate = Operands_relocatableImmediate(operands);
    printf("RelocatableImmediate(%s)\t%s\n", Operands_name_(operands), Immediate_name_(relocatableImmediate));
  }
  printf("sizeof(Operands_RelocatableImmediate)\t%d\n", sizeof(Operands_RelocatableImmediate));
}


#endif//Operand__c_INCLUDED
