#ifndef Operator_c_INCLUDED
#define Operator_c_INCLUDED

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
#include "MDS/MDS_.h"

#line 31 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
const int Operator__COUNT = Operator__;

#line 33 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 57 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
#ifndef ECL_NTRACE
const char *
OperatorParameterKind_name_(OperatorParameterKind this)
{
  static const char *_[] = {
    "Read",
    "ReadCond",
    "ReadPred",
    "ReadBase",
    "ReadOffset",
    "ReadStored",
    "ReadTarget",
    "ReadLeft",
    "ReadRight",
    "ReadList",
    "ReadMultiStored",
    "Write",
    "WriteList",
    "WriteMulti",
  };
  Except_REQUIRE((unsigned)this < OperatorParameterKind__);
  return _[this];
}
#endif//ECL_NTRACE

#line 82 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 169 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 171 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
const OperatorParameter_
Operator_Parameters[] = {
#define KIND(name) OperatorParameterKind_##name
#define RANK(d) d
#define METHOD(type, name) OperandType_##type, type##_##name
#define SAME(d) d
#define CONFLICT(d) d,
#define CONFLICTS(count, items) count, { items }
#define PARAMETER(kind, rank, method, same, conflicts) \
  { kind, rank, method, same, conflicts },
#define PARAMETERS(parameters) parameters
#define OperatorParameters(INDEX, PARAMETERS) \
  PARAMETERS
  // No dummy entry because only used as Operator_Parameters + parametersIndex.
#include "Operator.enum"
#undef PARAMETERS
};

#line 194 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 279 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 287 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
#ifndef ECL_NTRACE
const char *
Operator_name_(Operator this)
{
  static const char *_[] = {
#define Operator(NAME, ATTRIBUTES, INSTANCES, MNEMONIC, PARAMETERARRAY) \
    #NAME,
    "_UNDEF",
#include "Operator.enum"
  };
  Except_REQUIRE((unsigned)this < Operator__);
  return _[this];
}
#endif//ECL_NTRACE

#line 310 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 332 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
extern const OperatorAttributes
Operator_Attributes[];
OperatorAttributes
Operator_attributes(Operator this)
{
  Except_REQUIRE((unsigned)this < Operator__);
  return Operator_Attributes[this];
}

#line 341 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
const OperatorAttributes
Operator_Attributes[] = {
#define ATTRIBUTE(attribute) (1 << OperatorAttribute_##attribute)|
#define ATTRIBUTES(count, attributes) attributes 0
#define Operator(NAME, ATTRIBUTES, INSTANCES, MNEMONIC, PARAMETERARRAY) \
  ATTRIBUTES,
  0,
#include "Operator.enum"
};

#line 351 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 359 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
extern const Instance
Operator_Instances[][Processor__];
Instance 
Operator_instance(Operator this, Processor processor)
{
  Except_REQUIRE((unsigned)this < Operator__);
  Except_REQUIRE((unsigned)processor < Processor__);
  return (Instance)Operator_Instances[this][processor];
}

#line 369 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
const Instance
Operator_Instances[][Processor__] = {
#define INSTANCES(array) { Instance_/*Processor_*/, array }
#define INSTANCE(CORE, NAME) Instance_##NAME,
#define Operator(NAME, ATTRIBUTES, INSTANCES, MNEMONIC, PARAMETERARRAY) \
  INSTANCES,
  INSTANCES(/**/),
#include "Operator.enum"
};

#line 394 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 402 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
#ifndef ECL_NTRACE
const char *
Operator_Mnemonic[] = {
#define MNEMONIC(NAME) NAME
#define Operator(NAME, ATTRIBUTES, INSTANCES, MNEMONIC, PARAMETERARRAY) \
  MNEMONIC,
  NULL,
#include "Operator.enum"
};
#endif//ECL_NTRACE

#line 413 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
#ifndef ECL_NTRACE
const char *
Operator_mnemonic(Operator this)
{
  Except_REQUIRE((unsigned)this < Operator__);
  return Operator_Mnemonic[this];
}
#endif//ECL_NTRACE

#line 422 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 430 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
extern const OperatorParameterArray_
Operator_ParameterArray[];
const_OperatorParameterArray
Operator_parameterArray(Operator this)
{
  Except_REQUIRE((unsigned)this < Operator__);
  return Operator_ParameterArray + this;
}

#line 439 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
const OperatorParameterArray_
Operator_ParameterArray[] = {
#define WRITECOUNT(d) d
#define READCOUNT(d) d
#define PARAMETERSINDEX(index) index
#define PARAMETERARRAY(writeCount, readCount, parametersIndex) \
  { writeCount, readCount, Operator_Parameters + parametersIndex }
#define Operator(NAME, ATTRIBUTES, INSTANCES, MNEMONIC, PARAMETERARRAY) \
  PARAMETERARRAY,
  { 0 },
#include "Operator.enum"
};

#line 512 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 538 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 546 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
int8_t
Operator_getReadOperandType(Operator this, OperandType type)
{
  const_OperatorParameterArray parameterArray = Operator_parameterArray(this);
  const OperatorParameter_ *readParameters =
      OperatorParameterArray_readParameters(parameterArray);
  int readCount = OperatorParameterArray_readCount(parameterArray), index;
  for (index = 0; index < readCount; index++) {
    if (OperatorParameter_type(readParameters + index) == type) return index;
  }
  return -1;
}

#line 574 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 582 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
int8_t
Operator_getReadParameterKind(Operator this, OperatorParameterKind kind)
{
  const_OperatorParameterArray parameterArray = Operator_parameterArray(this);
  const OperatorParameter_ *readParameters =
      OperatorParameterArray_readParameters(parameterArray);
  int readCount = OperatorParameterArray_readCount(parameterArray), index;
  for (index = 0; index < readCount; index++) {
    if (OperatorParameter_kind(readParameters + index) == kind) return index;
  }
  return -1;
}

#line 658 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 691 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1328 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1334 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
#ifndef ECL_NTRACE
bool
Operator_DTD(FILE *file)
{
  fputs(
        "<!ELEMENT Operator EMPTY >"
        "<!ATTLIST Operator"
        "  ID ID #REQUIRED"
        ">"
       , file);
  return true;
}
#endif//ECL_NTRACE

#line 1352 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
#ifndef ECL_NTRACE
bool
Operator_XML(FILE *file)
{
  int operator = 0;
  for (; operator < Operator__; operator++) {
    fprintf(file, "<Operator ID=\"Operator_%s\" />\n", Operator_name_(operator));
  }
  return true;
}
#endif//ECL_NTRACE

#line 1376 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1388 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
#if XCC__C
static void
Operator_TEST(void)
{
#include "MDS/Operator_.c"
}

#line 1395 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operator.xcc"
int
main(int argc, char **argv)
{
  MDS_Test(Operator_TEST);
  return 0;
}
#endif

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/st200-Operator.xcc"
bool
Operator_isFixRegisterRAW(Operator this)
{
  switch (this) {
  case Operator_st200_igoto:
  case Operator_st200_call_1btarg:
  case Operator_st200_icall:
  case Operator_st200_return:
    return true;
  default:
    break;
  }
  return false;
}

#line 31 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/st200-Operator.xcc"
Instance
Operator_selectInstance(Operator this, Processor processor)
{
  Instance instance = Operator_instance(this, processor);
  if (instance == Instance_) {
    switch (this) {
    case Operator_GOTO:
#ifdef MDS_CORE_st220
      if (processor == Processor_st220_cpu) return Instance_st220_goto_btarg;
#endif//MDS_CORE_st220
#ifdef MDS_CORE_st231
      if (processor == Processor_st231_cpu) return Instance_st231_goto_btarg;
#endif//MDS_CORE_st231
#ifdef MDS_CORE_st240
      if (processor == Processor_st240_cpu) return Instance_st240_goto_btarg;
#endif//MDS_CORE_st240
      break;
    case Operator_GOTRUE:
#ifdef MDS_CORE_st220
      if (processor == Processor_st220_cpu) return Instance_st220_br_bcond_btarg;
#endif//MDS_CORE_st220
#ifdef MDS_CORE_st231
      if (processor == Processor_st231_cpu) return Instance_st231_br_bcond_btarg;
#endif//MDS_CORE_st231
#ifdef MDS_CORE_st240
      if (processor == Processor_st240_cpu) return Instance_st240_br_bcond_btarg;
#endif//MDS_CORE_st240
      break;
    case Operator_GOFALSE:
#ifdef MDS_CORE_st220
      if (processor == Processor_st220_cpu) return Instance_st220_brf_bcond_btarg;
#endif//MDS_CORE_st220
#ifdef MDS_CORE_st231
      if (processor == Processor_st231_cpu) return Instance_st231_brf_bcond_btarg;
#endif//MDS_CORE_st231
#ifdef MDS_CORE_st240
      if (processor == Processor_st240_cpu) return Instance_st240_brf_bcond_btarg;
#endif//MDS_CORE_st240
      break;
    case Operator_JUMP:
#ifdef MDS_CORE_st220
      if (processor == Processor_st220_cpu) return Instance_st220_igoto;
#endif//MDS_CORE_st220
#ifdef MDS_CORE_st231
      if (processor == Processor_st231_cpu) return Instance_st231_igoto;
#endif//MDS_CORE_st231
#ifdef MDS_CORE_st240
      if (processor == Processor_st240_cpu) return Instance_st240_igoto;
#endif//MDS_CORE_st240
      break;
    case Operator_CALL:
#ifdef MDS_CORE_st220
      if (processor == Processor_st220_cpu) return Instance_st220_call_btarg;
#endif//MDS_CORE_st220
#ifdef MDS_CORE_st231
      if (processor == Processor_st231_cpu) return Instance_st231_call_btarg;
#endif//MDS_CORE_st231
#ifdef MDS_CORE_st240
      if (processor == Processor_st240_cpu) return Instance_st240_call_btarg;
#endif//MDS_CORE_st240
      break;
    case Operator_LINK:
#ifdef MDS_CORE_st220
      if (processor == Processor_st220_cpu) return Instance_st220_icall;
#endif//MDS_CORE_st220
#ifdef MDS_CORE_st231
      if (processor == Processor_st231_cpu) return Instance_st231_icall;
#endif//MDS_CORE_st231
#ifdef MDS_CORE_st240
      if (processor == Processor_st240_cpu) return Instance_st240_icall;
#endif//MDS_CORE_st240
      break;
    case Operator_RETURN:
#ifdef MDS_CORE_st220
      if (processor == Processor_st220_cpu) return Instance_st220_return;
#endif//MDS_CORE_st220
#ifdef MDS_CORE_st231
      if (processor == Processor_st231_cpu) return Instance_st231_return;
#endif//MDS_CORE_st231
#ifdef MDS_CORE_st240
      if (processor == Processor_st240_cpu) return Instance_st240_return;
#endif//MDS_CORE_st240
      break;
    case Operator_COPY:
#ifdef MDS_CORE_st220
      if (processor == Processor_st220_cpu) return Instance_st220_mov_dest_src2;
#endif//MDS_CORE_st220
#ifdef MDS_CORE_st231
      if (processor == Processor_st231_cpu) return Instance_st231_mov_dest_src2;
#endif//MDS_CORE_st231
#ifdef MDS_CORE_st240
      if (processor == Processor_st240_cpu) return Instance_st240_mov_dest_src2;
#endif//MDS_CORE_st240
      break;
    default:
      break;
    }
  }
  return instance;
}

#line 132 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/st200-Operator.xcc"
int
Operator_require(Operator this, RegFile regFile)
{
  if (regFile == RegFile_st200_BR) return 8;
  return 1;
}

#line 139 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/st200-Operator.xcc"
int
Operator_baseAddressIndex(Operator this)
{
  switch (this) {
  // Load Operator(s).
  case Operator_st200_ldw_1general_2isrc2_3general:
  case Operator_st200_ldw_1general_2xsrc2_3general:
  case Operator_st200_ldh_1nolink_2isrc2_3general:
  case Operator_st200_ldh_1nolink_2xsrc2_3general:
  case Operator_st200_ldhu_1nolink_2isrc2_3general:
  case Operator_st200_ldhu_1nolink_2xsrc2_3general:
  case Operator_st200_ldb_1nolink_2isrc2_3general:
  case Operator_st200_ldb_1nolink_2xsrc2_3general:
  case Operator_st200_ldbu_1nolink_2isrc2_3general:
  case Operator_st200_ldbu_1nolink_2xsrc2_3general:
  case Operator_st200_ldw_d_1general_2isrc2_3general:
  case Operator_st200_ldw_d_1general_2xsrc2_3general:
  case Operator_st200_ldh_d_1nolink_2isrc2_3general:
  case Operator_st200_ldh_d_1nolink_2xsrc2_3general:
  case Operator_st200_ldhu_d_1nolink_2isrc2_3general:
  case Operator_st200_ldhu_d_1nolink_2xsrc2_3general:
  case Operator_st200_ldb_d_1nolink_2isrc2_3general:
  case Operator_st200_ldb_d_1nolink_2xsrc2_3general:
  case Operator_st200_ldbu_d_1nolink_2isrc2_3general:
  case Operator_st200_ldbu_d_1nolink_2xsrc2_3general:
  case Operator_st200_ldwl_1general_2general:
#ifdef MDS_CORE_st240
  case Operator_st200_ldl_1nzpaired_2isrc2_3general:
  case Operator_st200_ldl_1nzpaired_2xsrc2_3general:
  case Operator_st200_MULTI_ldl_1nzpaired_2isrc2_3general:
  case Operator_st200_MULTI_ldl_1nzpaired_2xsrc2_3general:
#endif//MDS_CORE_st240
    return 1;
#ifdef MDS_CORE_st240
  // Load conditional Operator(s).
  case Operator_st200_ldbc_1nolink_2predicate_3isrc2_4general:
  case Operator_st200_ldbc_1nolink_2predicate_3xsrc2_4general:
  case Operator_st200_ldbuc_1nolink_2predicate_3isrc2_4general:
  case Operator_st200_ldbuc_1nolink_2predicate_3xsrc2_4general:
  case Operator_st200_ldlc_1nzpaired_2predicate_3isrc2_4general:
  case Operator_st200_ldlc_1nzpaired_2predicate_3xsrc2_4general:
  case Operator_st200_ldhc_1nolink_2predicate_3isrc2_4general:
  case Operator_st200_ldhc_1nolink_2predicate_3xsrc2_4general:
  case Operator_st200_ldhuc_1nolink_2predicate_3isrc2_4general:
  case Operator_st200_ldhuc_1nolink_2predicate_3xsrc2_4general:
  case Operator_st200_ldwc_1general_2predicate_3isrc2_4general:
  case Operator_st200_ldwc_1general_2predicate_3xsrc2_4general:
  case Operator_st200_MULTI_ldlc_1nzpaired_2predicate_3isrc2_4general:
  case Operator_st200_MULTI_ldlc_1nzpaired_2predicate_3xsrc2_4general:
#endif//MDS_CORE_st240
    return 2;
  // Store Operator(s).
  case Operator_st200_stw_1isrc2_2general_3general:
  case Operator_st200_stw_1xsrc2_2general_3general:
  case Operator_st200_sth_1isrc2_2general_3general:
  case Operator_st200_sth_1xsrc2_2general_3general:
  case Operator_st200_stb_1isrc2_2general_3general:
  case Operator_st200_stb_1xsrc2_2general_3general:
  case Operator_st200_stwl_1branch_2general_3general:
#ifdef MDS_CORE_st240
  case Operator_st200_stl_1isrc2_2general_3paired:
  case Operator_st200_stl_1xsrc2_2general_3paired:
  case Operator_st200_MULTI_stl_1isrc2_2general_3paired:
  case Operator_st200_MULTI_stl_1xsrc2_2general_3paired:
#endif//MDS_CORE_st240
    return 1;
#ifdef MDS_CORE_st240
  // Store conditional Operator(s).
  case Operator_st200_stbc_1isrc2_2general_3predicate_4general:
  case Operator_st200_stbc_1xsrc2_2general_3predicate_4general:
  case Operator_st200_stlc_1isrc2_2general_3predicate_4paired:
  case Operator_st200_stlc_1xsrc2_2general_3predicate_4paired:
  case Operator_st200_sthc_1isrc2_2general_3predicate_4general:
  case Operator_st200_sthc_1xsrc2_2general_3predicate_4general:
  case Operator_st200_stwc_1isrc2_2general_3predicate_4general:
  case Operator_st200_stwc_1xsrc2_2general_3predicate_4general:
  case Operator_st200_MULTI_stlc_1isrc2_2general_3predicate_4paired:
  case Operator_st200_MULTI_stlc_1xsrc2_2general_3predicate_4paired:
#endif//MDS_CORE_st240
    return 1;
  default:
    break;
  }
  return -1;
}

#line 225 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/st200-Operator.xcc"
int
Operator_memoryAccessSize(Operator this)
{
  switch (this) {
#ifdef MDS_CORE_st240
  case Operator_st200_ldl_1nzpaired_2isrc2_3general:
  case Operator_st200_ldl_1nzpaired_2xsrc2_3general:
  case Operator_st200_ldlc_1nzpaired_2predicate_3isrc2_4general:
  case Operator_st200_ldlc_1nzpaired_2predicate_3xsrc2_4general:
  case Operator_st200_MULTI_ldl_1nzpaired_2isrc2_3general:
  case Operator_st200_MULTI_ldl_1nzpaired_2xsrc2_3general:
  case Operator_st200_MULTI_ldlc_1nzpaired_2predicate_3isrc2_4general:
  case Operator_st200_MULTI_ldlc_1nzpaired_2predicate_3xsrc2_4general:
    return 8;
#endif//MDS_CORE_st240
  case Operator_st200_ldw_1general_2isrc2_3general:
  case Operator_st200_ldw_1general_2xsrc2_3general:
  case Operator_st200_ldw_d_1general_2isrc2_3general:
  case Operator_st200_ldw_d_1general_2xsrc2_3general:
  case Operator_st200_ldwl_1general_2general:
#ifdef MDS_CORE_st240
  case Operator_st200_ldwc_1general_2predicate_3isrc2_4general:
  case Operator_st200_ldwc_1general_2predicate_3xsrc2_4general:
#endif//MDS_CORE_st240
    return 4;
  case Operator_st200_ldh_1nolink_2isrc2_3general:
  case Operator_st200_ldh_1nolink_2xsrc2_3general:
  case Operator_st200_ldhu_1nolink_2isrc2_3general:
  case Operator_st200_ldhu_1nolink_2xsrc2_3general:
  case Operator_st200_ldh_d_1nolink_2isrc2_3general:
  case Operator_st200_ldh_d_1nolink_2xsrc2_3general:
  case Operator_st200_ldhu_d_1nolink_2isrc2_3general:
  case Operator_st200_ldhu_d_1nolink_2xsrc2_3general:
#ifdef MDS_CORE_st240
  case Operator_st200_ldhc_1nolink_2predicate_3isrc2_4general:
  case Operator_st200_ldhc_1nolink_2predicate_3xsrc2_4general:
  case Operator_st200_ldhuc_1nolink_2predicate_3isrc2_4general:
  case Operator_st200_ldhuc_1nolink_2predicate_3xsrc2_4general:
#endif//MDS_CORE_st240
    return 2;
  case Operator_st200_ldb_1nolink_2isrc2_3general:
  case Operator_st200_ldb_1nolink_2xsrc2_3general:
  case Operator_st200_ldbu_1nolink_2isrc2_3general:
  case Operator_st200_ldbu_1nolink_2xsrc2_3general:
  case Operator_st200_ldb_d_1nolink_2isrc2_3general:
  case Operator_st200_ldb_d_1nolink_2xsrc2_3general:
  case Operator_st200_ldbu_d_1nolink_2isrc2_3general:
  case Operator_st200_ldbu_d_1nolink_2xsrc2_3general:
#ifdef MDS_CORE_st240
  case Operator_st200_ldbc_1nolink_2predicate_3isrc2_4general:
  case Operator_st200_ldbc_1nolink_2predicate_3xsrc2_4general:
  case Operator_st200_ldbuc_1nolink_2predicate_3isrc2_4general:
  case Operator_st200_ldbuc_1nolink_2predicate_3xsrc2_4general:
#endif//MDS_CORE_st240
    return 1;
#ifdef MDS_CORE_st240
  case Operator_st200_stl_1isrc2_2general_3paired:
  case Operator_st200_stl_1xsrc2_2general_3paired:
  case Operator_st200_stlc_1isrc2_2general_3predicate_4paired:
  case Operator_st200_stlc_1xsrc2_2general_3predicate_4paired:
  case Operator_st200_MULTI_stl_1isrc2_2general_3paired:
  case Operator_st200_MULTI_stl_1xsrc2_2general_3paired:
  case Operator_st200_MULTI_stlc_1isrc2_2general_3predicate_4paired:
  case Operator_st200_MULTI_stlc_1xsrc2_2general_3predicate_4paired:
    return 8;
#endif//MDS_CORE_st240
  case Operator_st200_stw_1isrc2_2general_3general:
  case Operator_st200_stw_1xsrc2_2general_3general:
  case Operator_st200_stwl_1branch_2general_3general:
#ifdef MDS_CORE_st240
  case Operator_st200_stwc_1isrc2_2general_3predicate_4general:
  case Operator_st200_stwc_1xsrc2_2general_3predicate_4general:
#endif//MDS_CORE_st240
    return 4;
  case Operator_st200_sth_1isrc2_2general_3general:
  case Operator_st200_sth_1xsrc2_2general_3general:
#ifdef MDS_CORE_st240
  case Operator_st200_sthc_1isrc2_2general_3predicate_4general:
  case Operator_st200_sthc_1xsrc2_2general_3predicate_4general:
#endif//MDS_CORE_st240
    return 2;
  case Operator_st200_stb_1isrc2_2general_3general:
  case Operator_st200_stb_1xsrc2_2general_3general:
#ifdef MDS_CORE_st240
  case Operator_st200_stbc_1isrc2_2general_3predicate_4general:
  case Operator_st200_stbc_1xsrc2_2general_3predicate_4general:
#endif//MDS_CORE_st240
    return 1;
  default:
    break;
  }
  return 0;
}

#line 319 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/st200-Operator.xcc"
bool
Operator_isSeqCopy(Operator this)
{
  switch (this) {
  case Operator_COPY:
  case Operator_st200_mov_1general_2general:
  case Operator_st200_mov_1general_2isrc2:
  case Operator_st200_mov_1general_2xsrc2:
#ifdef MDS_CORE_st240
  case Operator_st200_mov_bsrc_bdest_1branch_2branch:
#endif//MDS_CORE_st240
    return true;
  default:
    break;
  }
  return false;
}

#line 337 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/st200-Operator.xcc"
bool
Operator_isAdd(Operator this)
{
  switch (this) {
  case Operator_st200_add_1general_2general_3general:
  case Operator_st200_add_1general_2general_3isrc2:
  case Operator_st200_add_1general_2general_3xsrc2:
  case Operator_st200_addcg_1general_2branch_3general_4general_5branch:
    return true;
  default:
    break;
  }
  return false;
}

#line 352 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/st200-Operator.xcc"
bool
Operator_isAdditive(Operator this, int aIndex, int bIndex)
{
  Except_REQUIRE(aIndex >= 0 && bIndex >= 0);
  if (Operator_isAdd(this)) return true;
  switch (this) {
  // Add Operator(s).
  case Operator_st200_add_1general_2general_3general:
  case Operator_st200_add_1general_2general_3isrc2:
  case Operator_st200_add_1general_2general_3xsrc2:
  case Operator_st200_addcg_1general_2branch_3general_4general_5branch:
  // Load Operator(s).
  case Operator_st200_ldw_1general_2isrc2_3general:
  case Operator_st200_ldw_1general_2xsrc2_3general:
  case Operator_st200_ldw_d_1general_2isrc2_3general:
  case Operator_st200_ldw_d_1general_2xsrc2_3general:
  case Operator_st200_ldh_1nolink_2isrc2_3general:
  case Operator_st200_ldh_1nolink_2xsrc2_3general:
  case Operator_st200_ldh_d_1nolink_2isrc2_3general:
  case Operator_st200_ldh_d_1nolink_2xsrc2_3general:
  case Operator_st200_ldhu_1nolink_2isrc2_3general:
  case Operator_st200_ldhu_1nolink_2xsrc2_3general:
  case Operator_st200_ldhu_d_1nolink_2isrc2_3general:
  case Operator_st200_ldhu_d_1nolink_2xsrc2_3general:
  case Operator_st200_ldb_1nolink_2isrc2_3general:
  case Operator_st200_ldb_1nolink_2xsrc2_3general:
  case Operator_st200_ldb_d_1nolink_2isrc2_3general:
  case Operator_st200_ldb_d_1nolink_2xsrc2_3general:
  case Operator_st200_ldbu_1nolink_2isrc2_3general:
  case Operator_st200_ldbu_1nolink_2xsrc2_3general:
  case Operator_st200_ldbu_d_1nolink_2isrc2_3general:
  case Operator_st200_ldbu_d_1nolink_2xsrc2_3general:
#ifdef MDS_CORE_st240
  case Operator_st200_ldl_1nzpaired_2isrc2_3general:
  case Operator_st200_ldl_1nzpaired_2xsrc2_3general:
  case Operator_st200_MULTI_ldl_1nzpaired_2isrc2_3general:
  case Operator_st200_MULTI_ldl_1nzpaired_2xsrc2_3general:
#endif//MDS_CORE_st240
  // Store Operator(s).
  case Operator_st200_stw_1isrc2_2general_3general:
  case Operator_st200_stw_1xsrc2_2general_3general:
  case Operator_st200_sth_1isrc2_2general_3general:
  case Operator_st200_sth_1xsrc2_2general_3general:
  case Operator_st200_stb_1isrc2_2general_3general:
  case Operator_st200_stb_1xsrc2_2general_3general:
#ifdef MDS_CORE_st240
  case Operator_st200_stl_1isrc2_2general_3paired:
  case Operator_st200_stl_1xsrc2_2general_3paired:
  case Operator_st200_MULTI_stl_1isrc2_2general_3paired:
  case Operator_st200_MULTI_stl_1xsrc2_2general_3paired:
#endif//MDS_CORE_st240
  // Memory Operator(s).
  case Operator_st200_pft_1isrc2_2general:
  case Operator_st200_pft_1xsrc2_2general:
#ifdef MDS_CORE_st240
  case Operator_st200_pftc_1predicate_2isrc2_3general:
  case Operator_st200_pftc_1predicate_2xsrc2_3general:
  case Operator_st200_prgadd_l1_1isrc2_2general:
  case Operator_st200_prgadd_l1_1xsrc2_2general:
  case Operator_st200_prgset_l1_1isrc2_2general:
  case Operator_st200_prgset_l1_1xsrc2_2general:
#endif//MDS_CORE_st240
  case Operator_st200_prgadd_1isrc2_2general:
  case Operator_st200_prgadd_1xsrc2_2general:
  case Operator_st200_prgset_1isrc2_2general:
  case Operator_st200_prgset_1xsrc2_2general:
    return aIndex + bIndex == 1;
#ifdef MDS_CORE_st240
  // Load conditional Operator(s).
  case Operator_st200_ldbc_1nolink_2predicate_3isrc2_4general:
  case Operator_st200_ldbc_1nolink_2predicate_3xsrc2_4general:
  case Operator_st200_ldbuc_1nolink_2predicate_3isrc2_4general:
  case Operator_st200_ldbuc_1nolink_2predicate_3xsrc2_4general:
  case Operator_st200_ldlc_1nzpaired_2predicate_3isrc2_4general:
  case Operator_st200_ldlc_1nzpaired_2predicate_3xsrc2_4general:
  case Operator_st200_ldhc_1nolink_2predicate_3isrc2_4general:
  case Operator_st200_ldhc_1nolink_2predicate_3xsrc2_4general:
  case Operator_st200_ldhuc_1nolink_2predicate_3isrc2_4general:
  case Operator_st200_ldhuc_1nolink_2predicate_3xsrc2_4general:
  case Operator_st200_ldwc_1general_2predicate_3isrc2_4general:
  case Operator_st200_ldwc_1general_2predicate_3xsrc2_4general:
  case Operator_st200_MULTI_ldlc_1nzpaired_2predicate_3isrc2_4general:
  case Operator_st200_MULTI_ldlc_1nzpaired_2predicate_3xsrc2_4general:
    return aIndex + bIndex == 3;
  // Store conditional Operator(s).
  case Operator_st200_stbc_1isrc2_2general_3predicate_4general:
  case Operator_st200_stbc_1xsrc2_2general_3predicate_4general:
  case Operator_st200_stlc_1isrc2_2general_3predicate_4paired:
  case Operator_st200_stlc_1xsrc2_2general_3predicate_4paired:
  case Operator_st200_sthc_1isrc2_2general_3predicate_4general:
  case Operator_st200_sthc_1xsrc2_2general_3predicate_4general:
  case Operator_st200_stwc_1isrc2_2general_3predicate_4general:
  case Operator_st200_stwc_1xsrc2_2general_3predicate_4general:
  case Operator_st200_MULTI_stlc_1isrc2_2general_3predicate_4paired:
  case Operator_st200_MULTI_stlc_1xsrc2_2general_3predicate_4paired:
    return aIndex + bIndex == 1;
#endif//MDS_CORE_st240
  default:
    break;
  }
  return false;
}

#line 455 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/st200-Operator.xcc"
bool
Operator_isSubtractive(Operator this, int aIndex, int bIndex)
{
  Except_REQUIRE(aIndex >= 0 && bIndex >= 0);
  switch (this) {
  case Operator_st200_sub_1general_2general_3general:
  case Operator_st200_cmpeq_1general_2general_3general:
  case Operator_st200_cmpne_1general_2general_3general:
  //case Operator_st200_cmpge_1general_2general_3general:
  //case Operator_st200_cmpgt_1general_2general_3general:
  //case Operator_st200_cmple_1general_2general_3general:
  //case Operator_st200_cmplt_1general_2general_3general:
  case Operator_st200_cmpeq_1branch_2general_3general:
  case Operator_st200_cmpne_1branch_2general_3general:
  //case Operator_st200_cmpge_1branch_2general_3general:
  //case Operator_st200_cmpgt_1branch_2general_3general:
  //case Operator_st200_cmple_1branch_2general_3general:
  //case Operator_st200_cmplt_1branch_2general_3general:
  case Operator_st200_sub_1general_2isrc2_3general:
  case Operator_st200_sub_1general_2xsrc2_3general:
  case Operator_st200_cmpeq_1general_2general_3isrc2:
  case Operator_st200_cmpeq_1general_2general_3xsrc2:
  case Operator_st200_cmpne_1general_2general_3isrc2:
  case Operator_st200_cmpne_1general_2general_3xsrc2:
  //case Operator_st200_cmpge_1general_2general_3isrc2:
  //case Operator_st200_cmpge_1general_2general_3xsrc2:
  //case Operator_st200_cmpgt_1general_2general_3isrc2:
  //case Operator_st200_cmpgt_1general_2general_3xsrc2:
  //case Operator_st200_cmple_1general_2general_3isrc2:
  //case Operator_st200_cmple_1general_2general_3xsrc2:
  //case Operator_st200_cmplt_1general_2general_3isrc2:
  //case Operator_st200_cmplt_1general_2general_3xsrc2:
  case Operator_st200_cmpeq_1branch_2general_3isrc2:
  case Operator_st200_cmpeq_1branch_2general_3xsrc2:
  case Operator_st200_cmpne_1branch_2general_3isrc2:
  case Operator_st200_cmpne_1branch_2general_3xsrc2:
  //case Operator_st200_cmpge_1branch_2general_3isrc2:
  //case Operator_st200_cmpge_1branch_2general_3xsrc2:
  //case Operator_st200_cmpgt_1branch_2general_3isrc2:
  //case Operator_st200_cmpgt_1branch_2general_3xsrc2:
  //case Operator_st200_cmple_1branch_2general_3isrc2:
  //case Operator_st200_cmple_1branch_2general_3xsrc2:
  //case Operator_st200_cmplt_1branch_2general_3isrc2:
  //case Operator_st200_cmplt_1branch_2general_3xsrc2:
    return aIndex + bIndex == 1;
  default:
    break;
  }
  return false;
}

#line 506 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/st200-Operator.xcc"
bool
Operator_isTranslative(Operator this, int aIndex, int bIndex)
{
  Except_REQUIRE(aIndex >= 0 && bIndex >= 0);
  switch (this) {
  case Operator_st200_max_1general_2general_3general:
  case Operator_st200_min_1general_2general_3general:
  case Operator_st200_max_1general_2general_3isrc2:
  case Operator_st200_max_1general_2general_3xsrc2:
  case Operator_st200_min_1general_2general_3isrc2:
  case Operator_st200_min_1general_2general_3xsrc2:
    return aIndex + bIndex == 1;
  case Operator_st200_slct_1general_2branch_3general_4general:
#ifdef MDS_CORE_st240
  case Operator_st200_slct_rsrc_1general_2branch_3general_4general:
#endif//MDS_CORE_st240
  case Operator_st200_slctf_1general_2branch_3general_4general:
  case Operator_st200_slct_1general_2branch_3general_4isrc2:
  case Operator_st200_slct_1general_2branch_3general_4xsrc2:
  case Operator_st200_slctf_1general_2branch_3general_4isrc2:
  case Operator_st200_slctf_1general_2branch_3general_4xsrc2:
    return aIndex + bIndex == 3;
  default:
    break;
  }
  return false;
}

#line 534 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/st200-Operator.xcc"
bool
Operator_isAssociative(Operator this, int aIndex, int bIndex)
{
  Except_REQUIRE(aIndex >= 0 && bIndex >= 0);
  if (Operator_isAdd(this)) return true;
  switch (this) {
  case Operator_st200_and_1general_2general_3general:
  case Operator_st200_or_1general_2general_3general:
  case Operator_st200_xor_1general_2general_3general:
  case Operator_st200_max_1general_2general_3general:
  case Operator_st200_maxu_1general_2general_3general:
  case Operator_st200_min_1general_2general_3general:
  case Operator_st200_minu_1general_2general_3general:
  case Operator_st200_mulll_1nolink_2general_3general:
  case Operator_st200_mulllu_1nolink_2general_3general:
  case Operator_st200_mulhh_1nolink_2general_3general:
  case Operator_st200_mulhhu_1nolink_2general_3general:
  case Operator_st200_and_1general_2general_3isrc2:
  case Operator_st200_and_1general_2general_3xsrc2:
  case Operator_st200_or_1general_2general_3isrc2:
  case Operator_st200_or_1general_2general_3xsrc2:
  case Operator_st200_xor_1general_2general_3isrc2:
  case Operator_st200_xor_1general_2general_3xsrc2:
  case Operator_st200_max_1general_2general_3isrc2:
  case Operator_st200_max_1general_2general_3xsrc2:
  case Operator_st200_maxu_1general_2general_3isrc2:
  case Operator_st200_maxu_1general_2general_3xsrc2:
  case Operator_st200_min_1general_2general_3isrc2:
  case Operator_st200_min_1general_2general_3xsrc2:
  case Operator_st200_minu_1general_2general_3isrc2:
  case Operator_st200_minu_1general_2general_3xsrc2:
  case Operator_st200_mulll_1nolink_2general_3isrc2:
  case Operator_st200_mulll_1nolink_2general_3xsrc2:
  case Operator_st200_mulllu_1nolink_2general_3isrc2:
  case Operator_st200_mulllu_1nolink_2general_3xsrc2:
  case Operator_st200_mulhh_1nolink_2general_3isrc2:
  case Operator_st200_mulhh_1nolink_2general_3xsrc2:
  case Operator_st200_mulhhu_1nolink_2general_3isrc2:
  case Operator_st200_mulhhu_1nolink_2general_3xsrc2:
  case Operator_st200_andl_1general_2general_3general:
  case Operator_st200_andl_1branch_2general_3general:
  case Operator_st200_andl_1branch_2general_3isrc2:
  case Operator_st200_andl_1branch_2general_3xsrc2:
  case Operator_st200_nandl_1general_2general_3general:
  case Operator_st200_nandl_1branch_2general_3general:
  case Operator_st200_nandl_1general_2general_3xsrc2:
  case Operator_st200_nandl_1branch_2general_3isrc2:
  case Operator_st200_nandl_1branch_2general_3xsrc2:
  case Operator_st200_orl_1general_2general_3general:
  case Operator_st200_orl_1general_2general_3isrc2:
  case Operator_st200_orl_1general_2general_3xsrc2:
  case Operator_st200_orl_1branch_2general_3isrc2:
  case Operator_st200_orl_1branch_2general_3xsrc2:
  case Operator_st200_norl_1general_2general_3general:
  case Operator_st200_norl_1general_2general_3isrc2:
  case Operator_st200_norl_1general_2general_3xsrc2:
  case Operator_st200_norl_1branch_2general_3isrc2:
  case Operator_st200_norl_1branch_2general_3xsrc2:
    return aIndex + bIndex == 1;
  default:
    break;
  }
  return false;
}

#line 599 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/st200-Operator.xcc"
bool
Operator_isCommutative(Operator this, int aIndex, int bIndex)
{
  Except_REQUIRE(aIndex >= 0 && bIndex >= 0);
  if (Operator_isAssociative(this, aIndex, bIndex)) return true;
  if (Operator_isMemoryRead(this)) return true;
  switch (this) {
  case Operator_st200_cmpeq_1general_2general_3general:
  case Operator_st200_cmpne_1general_2general_3general:
  case Operator_st200_cmpeq_1branch_2general_3general:
  case Operator_st200_cmpne_1branch_2general_3general:
  case Operator_st200_cmpeq_1general_2general_3isrc2:
  case Operator_st200_cmpeq_1general_2general_3xsrc2:
  case Operator_st200_cmpne_1general_2general_3isrc2:
  case Operator_st200_cmpne_1general_2general_3xsrc2:
  case Operator_st200_cmpeq_1branch_2general_3isrc2:
  case Operator_st200_cmpeq_1branch_2general_3xsrc2:
  case Operator_st200_cmpne_1branch_2general_3isrc2:
  case Operator_st200_cmpne_1branch_2general_3xsrc2:
    return aIndex + bIndex == 1;
  default:
    break;
  }
  return false;
}

#line 625 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/st200-Operator.xcc"
bool
Operator_isGoTo(Operator this)
{
  switch (this) {
  case Operator_GOTO:
  case Operator_GOTRUE:
  case Operator_GOFALSE:
  case Operator_st200_goto_1btarg:
  case Operator_st200_br_1branch_2btarg:
  case Operator_st200_brf_1branch_2btarg:
    return true;
  default:
    break;
  }
  return false;
}

#line 642 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/st200-Operator.xcc"
bool
Operator_isJump(Operator this)
{
  switch (this) {
  case Operator_JUMP:
  case Operator_st200_igoto:
    return true;
  default:
    break;
  }
  return false;
}

#line 655 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/st200-Operator.xcc"
bool
Operator_isBranch(Operator this)
{
  switch (this) {
  case Operator_LOOP:
  case Operator_FALL:
  case Operator_GOTO:
  case Operator_GOTRUE:
  case Operator_GOFALSE:
  case Operator_st200_goto_1btarg:
  case Operator_st200_br_1branch_2btarg:
  case Operator_st200_brf_1branch_2btarg:
  case Operator_JUMP:
  case Operator_st200_igoto:
    return true;
  default:
    break;
  }
  return false;
}

#line 676 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/st200-Operator.xcc"
bool
Operator_isCall(Operator this)
{
  switch (this) {
  case Operator_CALL:
  case Operator_st200_call_1btarg:
    return true;
  default:
    break;
  }
  return false;
}

#line 689 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/st200-Operator.xcc"
bool
Operator_isLink(Operator this)
{
  switch (this) {
  case Operator_LINK:
  case Operator_st200_icall:
    return true;
  default:
    break;
  }
  return false;
}

#line 702 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/st200-Operator.xcc"
bool
Operator_isRoutine(Operator this)
{
  switch (this) {
  case Operator_CALL:
  case Operator_st200_call_1btarg:
  case Operator_LINK:
  case Operator_st200_icall:
    return true;
  default:
    break;
  }
  return false;
}

#line 717 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/st200-Operator.xcc"
bool
Operator_isReturn(Operator this)
{
  switch (this) {
  case Operator_RETURN:
  case Operator_st200_return:
  case Operator_st200_rfi:
    return true;
  default:
    break;
  }
  return false;
}

#line 731 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/st200-Operator.xcc"
bool
Operator_isGNUASM(Operator this)
{
  return (this) == Operator_st200_GNUASM;
}

#line 737 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/st200-Operator.xcc"
// J'ai mis toutes ces operations en Memory barrier:
//   case TOP_prgadd_i:    /* data cache purge */
//   case TOP_prgadd_ii:
//   case TOP_prgset_i:    /* data cache purge */
//   case TOP_prgset_ii:
//   case TOP_sync:        /* data cache sync */
//   case TOP_prgins:      /* i-cache purge */
//   case TOP_prginspg_i:  /* i-cache purge */
//   case TOP_prginspg_ii:
//   case TOP_syncins:     /* i-cache sync. */
//   case TOP_break:       /* exceptions. */
//   case TOP_sbrk:
//   case TOP_syscall:
//   case TOP_pswset_r:    /* global state change. */
//   case TOP_pswclr_r:  
//         return TRUE;
//
// La propriete devrait etre transferee dans l'interface LAO.
// Ces operations ne finissent pas un block mais se comporte comme des store(MEM).
//
//        -- christophe

#line 759 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/st200-Operator.xcc"
bool
Operator_isMemoryBarrier(Operator this)
{
  switch (this) {
  case Operator_st200_break:
#ifdef MDS_CORE_st240
  case Operator_st200_dbgsbrk:
  case Operator_st200_dib:
  case Operator_st200_invadd_1isrc2_2general:
  case Operator_st200_invadd_1xsrc2_2general:
  case Operator_st200_invadd_l1_1isrc2_2general:
  case Operator_st200_invadd_l1_1xsrc2_2general:
  case Operator_st200_prgadd_l1_1isrc2_2general:
  case Operator_st200_prgadd_l1_1xsrc2_2general:
  case Operator_st200_prgset_l1_1isrc2_2general:
  case Operator_st200_prgset_l1_1xsrc2_2general:
#endif//MDS_CORE_st240
  case Operator_st200_prgadd_1isrc2_2general:
  case Operator_st200_prgadd_1xsrc2_2general:
  case Operator_st200_prgins:
  case Operator_st200_prginspg_1isrc2_2general:
  case Operator_st200_prginspg_1xsrc2_2general:
  case Operator_st200_prgset_1isrc2_2general:
  case Operator_st200_prgset_1xsrc2_2general:
#ifdef MDS_CORE_st240
  case Operator_st200_pswmask_1nolink_2general_3isrc2:
  case Operator_st200_pswmask_1nolink_2general_3xsrc2:
#endif//MDS_CORE_st240
  case Operator_st200_pswclr_1general:
  case Operator_st200_pswset_1general:
  case Operator_st200_sbrk:
  case Operator_st200_sync:
  case Operator_st200_syscall:
  case Operator_st200_wmb:
  case Operator_st200_syncins:
#ifdef MDS_CORE_st240
  case Operator_st200_retention:
  case Operator_st200_waitl:
  case Operator_st240_sbrk:
  case Operator_st240_syscall:
#endif//MDS_CORE_st240
    return true;
  default:
    break;
  }
  return false;
}

#line 807 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/st200-Operator.xcc"
bool
Operator_isStalling(Operator this)
{
  switch (this) {
  // These operations block the pipeline for some cycles.
  // Note that although load/store can also block the pipeline,
  // that is only when they miss the cache.  We optimistically
  // assume that load/store will not miss, so we do not consider them
  // as blocking.
#ifdef MDS_CORE_st240
  case Operator_st200_div_1nolink_2general_3general:
  case Operator_st200_rem_1nolink_2general_3general:
  case Operator_st200_divu_1nolink_2general_3general:
  case Operator_st200_remu_1nolink_2general_3general:
#endif//MDS_CORE_st240
    return true;
  default:
    break;
  }
  return false;
}

#line 829 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/st200-Operator.xcc"
bool
Operator_isPrefetch(Operator this)
{
  return
      this == Operator_st200_pft_1isrc2_2general ||
      this == Operator_st200_pft_1xsrc2_2general ||
#ifdef MDS_CORE_st240
      this == Operator_st200_pftc_1predicate_2isrc2_3general ||
      this == Operator_st200_pftc_1predicate_2xsrc2_3general ||
#endif//MDS_CORE_st240
      false;
}

#line 842 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/st200-Operator.xcc"
bool
Operator_isSafeLoad(Operator this)
{
  switch (this) {
  case Operator_st200_ldw_d_1general_2isrc2_3general:
  case Operator_st200_ldw_d_1general_2xsrc2_3general:
  case Operator_st200_ldh_d_1nolink_2isrc2_3general:
  case Operator_st200_ldh_d_1nolink_2xsrc2_3general:
  case Operator_st200_ldhu_d_1nolink_2isrc2_3general:
  case Operator_st200_ldhu_d_1nolink_2xsrc2_3general:
  case Operator_st200_ldb_d_1nolink_2isrc2_3general:
  case Operator_st200_ldb_d_1nolink_2xsrc2_3general:
  case Operator_st200_ldbu_d_1nolink_2isrc2_3general:
  case Operator_st200_ldbu_d_1nolink_2xsrc2_3general:
    return true;
  default:
    break;
  }
  return false;
}

#line 863 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/st200-Operator.xcc"
Operator
Operator_speculate(Operator this, Processor processor)
{
  if (processor <= Processor_st231_cpu) {
    switch (this) {
    case Operator_st200_ldw_1general_2isrc2_3general: return Operator_st200_ldw_d_1general_2isrc2_3general;
    case Operator_st200_ldw_1general_2xsrc2_3general: return Operator_st200_ldw_d_1general_2xsrc2_3general;
    case Operator_st200_ldh_1nolink_2isrc2_3general: return Operator_st200_ldh_d_1nolink_2isrc2_3general;
    case Operator_st200_ldh_1nolink_2xsrc2_3general: return Operator_st200_ldh_d_1nolink_2xsrc2_3general;
    case Operator_st200_ldhu_1nolink_2isrc2_3general: return Operator_st200_ldhu_d_1nolink_2isrc2_3general;
    case Operator_st200_ldhu_1nolink_2xsrc2_3general: return Operator_st200_ldhu_d_1nolink_2xsrc2_3general;
    case Operator_st200_ldb_1nolink_2isrc2_3general: return Operator_st200_ldb_d_1nolink_2isrc2_3general;
    case Operator_st200_ldb_1nolink_2xsrc2_3general: return Operator_st200_ldb_d_1nolink_2xsrc2_3general;
    case Operator_st200_ldbu_1nolink_2isrc2_3general: return Operator_st200_ldbu_d_1nolink_2isrc2_3general;
    case Operator_st200_ldbu_1nolink_2xsrc2_3general: return Operator_st200_ldbu_d_1nolink_2xsrc2_3general;
    default: break;
    }
  }
  return this;
}

#line 884 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/st200-Operator.xcc"
Operator
Operator_predicatePositive(Operator this, Processor processor)
{
  switch (this) {
  case Operator_GOTO: return Operator_GOTRUE;
  case Operator_st200_goto_1btarg: return Operator_st200_br_1branch_2btarg;
  default: break;
  }
#ifdef MDS_CORE_st240
  if (processor == Processor_st240_cpu) {
    switch (this) {
    case Operator_st200_ldb_1nolink_2isrc2_3general: return Operator_st200_ldbc_1nolink_2predicate_3isrc2_4general;
    case Operator_st200_ldb_1nolink_2xsrc2_3general: return Operator_st200_ldbc_1nolink_2predicate_3xsrc2_4general;
    case Operator_st200_ldbu_1nolink_2isrc2_3general: return Operator_st200_ldbuc_1nolink_2predicate_3isrc2_4general;
    case Operator_st200_ldbu_1nolink_2xsrc2_3general: return Operator_st200_ldbuc_1nolink_2predicate_3xsrc2_4general;
    case Operator_st200_ldh_1nolink_2isrc2_3general: return Operator_st200_ldhc_1nolink_2predicate_3isrc2_4general;
    case Operator_st200_ldh_1nolink_2xsrc2_3general: return Operator_st200_ldhc_1nolink_2predicate_3xsrc2_4general;
    case Operator_st200_ldhu_1nolink_2isrc2_3general: return Operator_st200_ldhuc_1nolink_2predicate_3isrc2_4general;
    case Operator_st200_ldhu_1nolink_2xsrc2_3general: return Operator_st200_ldhuc_1nolink_2predicate_3xsrc2_4general;
    case Operator_st200_ldl_1nzpaired_2isrc2_3general: return Operator_st200_ldlc_1nzpaired_2predicate_3isrc2_4general;
    case Operator_st200_MULTI_ldl_1nzpaired_2isrc2_3general: return Operator_st200_MULTI_ldlc_1nzpaired_2predicate_3isrc2_4general;
    case Operator_st200_ldl_1nzpaired_2xsrc2_3general: return Operator_st200_ldlc_1nzpaired_2predicate_3xsrc2_4general;
    case Operator_st200_MULTI_ldl_1nzpaired_2xsrc2_3general: return Operator_st200_MULTI_ldlc_1nzpaired_2predicate_3xsrc2_4general;
    case Operator_st200_ldw_1general_2isrc2_3general: return Operator_st200_ldwc_1general_2predicate_3isrc2_4general;
    case Operator_st200_ldw_1general_2xsrc2_3general: return Operator_st200_ldwc_1general_2predicate_3xsrc2_4general;
    case Operator_st200_pft_1isrc2_2general: return Operator_st200_pftc_1predicate_2isrc2_3general;
    case Operator_st200_pft_1xsrc2_2general: return Operator_st200_pftc_1predicate_2xsrc2_3general;
    case Operator_st200_stb_1isrc2_2general_3general: return Operator_st200_stbc_1isrc2_2general_3predicate_4general;
    case Operator_st200_stb_1xsrc2_2general_3general: return Operator_st200_stbc_1xsrc2_2general_3predicate_4general;
    case Operator_st200_sth_1isrc2_2general_3general: return Operator_st200_sthc_1isrc2_2general_3predicate_4general;
    case Operator_st200_sth_1xsrc2_2general_3general: return Operator_st200_sthc_1xsrc2_2general_3predicate_4general;
    case Operator_st200_stl_1isrc2_2general_3paired: return Operator_st200_stlc_1isrc2_2general_3predicate_4paired;
    case Operator_st200_MULTI_stl_1isrc2_2general_3paired: return Operator_st200_MULTI_stlc_1isrc2_2general_3predicate_4paired;
    case Operator_st200_stl_1xsrc2_2general_3paired: return Operator_st200_stlc_1xsrc2_2general_3predicate_4paired;
    case Operator_st200_MULTI_stl_1xsrc2_2general_3paired: return Operator_st200_MULTI_stlc_1xsrc2_2general_3predicate_4paired;
    case Operator_st200_stw_1isrc2_2general_3general: return Operator_st200_stwc_1isrc2_2general_3predicate_4general;
    case Operator_st200_stw_1xsrc2_2general_3general: return Operator_st200_stwc_1xsrc2_2general_3predicate_4general;
    default: break;
    }
  }
#endif//MDS_CORE_st240
  return Operator_;
}

#line 928 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/st200-Operator.xcc"
Operator
Operator_predicateNegative(Operator this, Processor processor)
{
  switch (this) {
  case Operator_GOTO: return Operator_GOFALSE;
  case Operator_st200_goto_1btarg: return Operator_st200_brf_1branch_2btarg;
  default: break;
  }
  return Operator_;
}

#line 939 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/st200-Operator.xcc"
int
Operator_predicateIndex(Operator this)
{
  switch (this) {
  case Operator_GOTRUE: return 0;
  case Operator_GOFALSE: return 0;
  case Operator_st200_br_1branch_2btarg: return 0;
  case Operator_st200_brf_1branch_2btarg: return 0;
#ifdef MDS_CORE_st240
  case Operator_st200_ldbc_1nolink_2predicate_3isrc2_4general: return 0;
  case Operator_st200_ldbc_1nolink_2predicate_3xsrc2_4general: return 0;
  case Operator_st200_ldbuc_1nolink_2predicate_3isrc2_4general: return 0;
  case Operator_st200_ldbuc_1nolink_2predicate_3xsrc2_4general: return 0;
  case Operator_st200_ldhc_1nolink_2predicate_3isrc2_4general: return 0;
  case Operator_st200_ldhc_1nolink_2predicate_3xsrc2_4general: return 0;
  case Operator_st200_ldhuc_1nolink_2predicate_3isrc2_4general: return 0;
  case Operator_st200_ldhuc_1nolink_2predicate_3xsrc2_4general: return 0;
  case Operator_st200_ldlc_1nzpaired_2predicate_3isrc2_4general: return 0;
  case Operator_st200_MULTI_ldlc_1nzpaired_2predicate_3isrc2_4general: return 0;
  case Operator_st200_ldlc_1nzpaired_2predicate_3xsrc2_4general: return 0;
  case Operator_st200_MULTI_ldlc_1nzpaired_2predicate_3xsrc2_4general: return 0;
  case Operator_st200_ldwc_1general_2predicate_3isrc2_4general: return 0;
  case Operator_st200_ldwc_1general_2predicate_3xsrc2_4general: return 0;
  case Operator_st200_pftc_1predicate_2isrc2_3general: return 0;
  case Operator_st200_pftc_1predicate_2xsrc2_3general: return 0;
  case Operator_st200_stbc_1isrc2_2general_3predicate_4general: return 2;
  case Operator_st200_stbc_1xsrc2_2general_3predicate_4general: return 2;
  case Operator_st200_sthc_1isrc2_2general_3predicate_4general: return 2;
  case Operator_st200_sthc_1xsrc2_2general_3predicate_4general: return 2;
  case Operator_st200_stlc_1isrc2_2general_3predicate_4paired: return 2;
  case Operator_st200_MULTI_stlc_1isrc2_2general_3predicate_4paired: return 2;
  case Operator_st200_stlc_1xsrc2_2general_3predicate_4paired: return 2;
  case Operator_st200_MULTI_stlc_1xsrc2_2general_3predicate_4paired: return 2;
  case Operator_st200_stwc_1isrc2_2general_3predicate_4general: return 2;
  case Operator_st200_stwc_1xsrc2_2general_3predicate_4general: return 2;
#endif//MDS_CORE_st240
  default: break;
  }
  return -1;
}

#line 980 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/st200-Operator.xcc"
int
Operator_predicatePolarity(Operator this)
{
  switch (this) {
  case Operator_GOTRUE: return 1;
  case Operator_GOFALSE: return -1;
  case Operator_st200_br_1branch_2btarg: return 1;
  case Operator_st200_brf_1branch_2btarg: return -1;
#ifdef MDS_CORE_st240
  case Operator_st200_ldbc_1nolink_2predicate_3isrc2_4general: return 1;
  case Operator_st200_ldbc_1nolink_2predicate_3xsrc2_4general: return 1;
  case Operator_st200_ldbuc_1nolink_2predicate_3isrc2_4general: return 1;
  case Operator_st200_ldbuc_1nolink_2predicate_3xsrc2_4general: return 1;
  case Operator_st200_ldhc_1nolink_2predicate_3isrc2_4general: return 1;
  case Operator_st200_ldhc_1nolink_2predicate_3xsrc2_4general: return 1;
  case Operator_st200_ldhuc_1nolink_2predicate_3isrc2_4general: return 1;
  case Operator_st200_ldhuc_1nolink_2predicate_3xsrc2_4general: return 1;
  case Operator_st200_ldlc_1nzpaired_2predicate_3isrc2_4general: return 1;
  case Operator_st200_MULTI_ldlc_1nzpaired_2predicate_3isrc2_4general: return 1;
  case Operator_st200_ldlc_1nzpaired_2predicate_3xsrc2_4general: return 1;
  case Operator_st200_MULTI_ldlc_1nzpaired_2predicate_3xsrc2_4general: return 1;
  case Operator_st200_ldwc_1general_2predicate_3isrc2_4general: return 1;
  case Operator_st200_ldwc_1general_2predicate_3xsrc2_4general: return 1;
  case Operator_st200_pftc_1predicate_2isrc2_3general: return 1;
  case Operator_st200_pftc_1predicate_2xsrc2_3general: return 1;
  case Operator_st200_stbc_1isrc2_2general_3predicate_4general: return 1;
  case Operator_st200_stbc_1xsrc2_2general_3predicate_4general: return 1;
  case Operator_st200_sthc_1isrc2_2general_3predicate_4general: return 1;
  case Operator_st200_sthc_1xsrc2_2general_3predicate_4general: return 1;
  case Operator_st200_stlc_1isrc2_2general_3predicate_4paired: return 1;
  case Operator_st200_MULTI_stlc_1isrc2_2general_3predicate_4paired: return 1;
  case Operator_st200_stlc_1xsrc2_2general_3predicate_4paired: return 1;
  case Operator_st200_MULTI_stlc_1xsrc2_2general_3predicate_4paired: return 1;
  case Operator_st200_stwc_1isrc2_2general_3predicate_4general: return 1;
  case Operator_st200_stwc_1xsrc2_2general_3predicate_4general: return 1;
#endif//MDS_CORE_st240
  default: break;
  }
  return 0;
}

#line 1021 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/st200-Operator.xcc"
Operator
Operator_unpredicate(Operator this, Processor processor)
{
  switch (this) {
  case Operator_GOTRUE: return Operator_GOTO;
  case Operator_GOFALSE: return Operator_GOTO;
  case Operator_st200_br_1branch_2btarg: return Operator_st200_goto_1btarg;
  case Operator_st200_brf_1branch_2btarg: return Operator_st200_goto_1btarg;
#ifdef MDS_CORE_st240
  case Operator_st200_ldbc_1nolink_2predicate_3isrc2_4general: return Operator_st200_ldb_1nolink_2isrc2_3general;
  case Operator_st200_ldbc_1nolink_2predicate_3xsrc2_4general: return Operator_st200_ldb_1nolink_2xsrc2_3general;
  case Operator_st200_ldbuc_1nolink_2predicate_3isrc2_4general: return Operator_st200_ldbu_1nolink_2isrc2_3general;
  case Operator_st200_ldbuc_1nolink_2predicate_3xsrc2_4general: return Operator_st200_ldbu_1nolink_2xsrc2_3general;
  case Operator_st200_ldhc_1nolink_2predicate_3isrc2_4general: return Operator_st200_ldh_1nolink_2isrc2_3general;
  case Operator_st200_ldhc_1nolink_2predicate_3xsrc2_4general: return Operator_st200_ldh_1nolink_2xsrc2_3general;
  case Operator_st200_ldhuc_1nolink_2predicate_3isrc2_4general: return Operator_st200_ldhu_1nolink_2isrc2_3general;
  case Operator_st200_ldhuc_1nolink_2predicate_3xsrc2_4general: return Operator_st200_ldhu_1nolink_2xsrc2_3general;
  case Operator_st200_ldlc_1nzpaired_2predicate_3isrc2_4general: return Operator_st200_ldl_1nzpaired_2isrc2_3general;
  case Operator_st200_MULTI_ldlc_1nzpaired_2predicate_3isrc2_4general: return Operator_st200_MULTI_ldl_1nzpaired_2isrc2_3general;
  case Operator_st200_ldlc_1nzpaired_2predicate_3xsrc2_4general: return Operator_st200_ldl_1nzpaired_2xsrc2_3general;
  case Operator_st200_MULTI_ldlc_1nzpaired_2predicate_3xsrc2_4general: return Operator_st200_MULTI_ldl_1nzpaired_2xsrc2_3general;
  case Operator_st200_ldwc_1general_2predicate_3isrc2_4general: return Operator_st200_ldw_1general_2isrc2_3general;
  case Operator_st200_ldwc_1general_2predicate_3xsrc2_4general: return Operator_st200_ldw_1general_2xsrc2_3general;
  case Operator_st200_pftc_1predicate_2isrc2_3general: return Operator_st200_pft_1isrc2_2general;
  case Operator_st200_pftc_1predicate_2xsrc2_3general: return Operator_st200_pft_1xsrc2_2general;
  case Operator_st200_stbc_1isrc2_2general_3predicate_4general: return Operator_st200_stb_1isrc2_2general_3general;
  case Operator_st200_stbc_1xsrc2_2general_3predicate_4general: return Operator_st200_stb_1xsrc2_2general_3general;
  case Operator_st200_sthc_1isrc2_2general_3predicate_4general: return Operator_st200_sth_1isrc2_2general_3general;
  case Operator_st200_sthc_1xsrc2_2general_3predicate_4general: return Operator_st200_sth_1xsrc2_2general_3general;
  case Operator_st200_stlc_1isrc2_2general_3predicate_4paired: return Operator_st200_stl_1isrc2_2general_3paired;
  case Operator_st200_MULTI_stlc_1isrc2_2general_3predicate_4paired: return Operator_st200_MULTI_stl_1isrc2_2general_3paired;
  case Operator_st200_stlc_1xsrc2_2general_3predicate_4paired: return Operator_st200_stl_1xsrc2_2general_3paired;
  case Operator_st200_MULTI_stlc_1xsrc2_2general_3predicate_4paired: return Operator_st200_MULTI_stl_1xsrc2_2general_3paired;
  case Operator_st200_stwc_1isrc2_2general_3predicate_4general: return Operator_st200_stw_1isrc2_2general_3general;
  case Operator_st200_stwc_1xsrc2_2general_3predicate_4general: return Operator_st200_stw_1xsrc2_2general_3general;
#endif//MDS_CORE_st240
  default: break;
  }
  return Operator_;
}

#line 1062 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/st200-Operator.xcc"
Operator
Operator_complementWrite(Operator this, Processor processor, int32_t writeIndex)
{
  if (writeIndex == 0) {
    switch (this) {
    case Operator_st200_cmpeq_1branch_2general_3general: return Operator_st200_cmpne_1branch_2general_3general;
    case Operator_st200_cmpeq_1branch_2general_3isrc2: return Operator_st200_cmpne_1branch_2general_3isrc2;
    case Operator_st200_cmpeq_1branch_2general_3xsrc2: return Operator_st200_cmpne_1branch_2general_3xsrc2;
    case Operator_st200_cmpge_1branch_2general_3general: return Operator_st200_cmplt_1branch_2general_3general;
    case Operator_st200_cmpge_1branch_2general_3isrc2: return Operator_st200_cmplt_1branch_2general_3isrc2;
    case Operator_st200_cmpge_1branch_2general_3xsrc2: return Operator_st200_cmplt_1branch_2general_3xsrc2;
    case Operator_st200_cmpgeu_1branch_2general_3general: return Operator_st200_cmpltu_1branch_2general_3general;
    case Operator_st200_cmpgeu_1branch_2general_3isrc2: return Operator_st200_cmpltu_1branch_2general_3isrc2;
    case Operator_st200_cmpgeu_1branch_2general_3xsrc2: return Operator_st200_cmpltu_1branch_2general_3xsrc2;
    case Operator_st200_cmpgt_1branch_2general_3general: return Operator_st200_cmple_1branch_2general_3general;
    case Operator_st200_cmpgt_1branch_2general_3isrc2: return Operator_st200_cmple_1branch_2general_3isrc2;
    case Operator_st200_cmpgt_1branch_2general_3xsrc2: return Operator_st200_cmple_1branch_2general_3xsrc2;
    case Operator_st200_cmpgtu_1branch_2general_3general: return Operator_st200_cmpleu_1branch_2general_3general;
    case Operator_st200_cmpgtu_1branch_2general_3isrc2: return Operator_st200_cmpleu_1branch_2general_3isrc2;
    case Operator_st200_cmpgtu_1branch_2general_3xsrc2: return Operator_st200_cmpleu_1branch_2general_3xsrc2;
    case Operator_st200_cmple_1branch_2general_3general: return Operator_st200_cmpgt_1branch_2general_3general;
    case Operator_st200_cmple_1branch_2general_3isrc2: return Operator_st200_cmpgt_1branch_2general_3isrc2;
    case Operator_st200_cmple_1branch_2general_3xsrc2: return Operator_st200_cmpgt_1branch_2general_3xsrc2;
    case Operator_st200_cmpleu_1branch_2general_3general: return Operator_st200_cmpgtu_1branch_2general_3general;
    case Operator_st200_cmpleu_1branch_2general_3isrc2: return Operator_st200_cmpgtu_1branch_2general_3isrc2;
    case Operator_st200_cmpleu_1branch_2general_3xsrc2: return Operator_st200_cmpgtu_1branch_2general_3xsrc2;
    case Operator_st200_cmplt_1branch_2general_3general: return Operator_st200_cmpge_1branch_2general_3general;
    case Operator_st200_cmplt_1branch_2general_3isrc2: return Operator_st200_cmpge_1branch_2general_3isrc2;
    case Operator_st200_cmplt_1branch_2general_3xsrc2: return Operator_st200_cmpge_1branch_2general_3xsrc2;
    case Operator_st200_cmpltu_1branch_2general_3general: return Operator_st200_cmpgeu_1branch_2general_3general;
    case Operator_st200_cmpltu_1branch_2general_3isrc2: return Operator_st200_cmpgeu_1branch_2general_3isrc2;
    case Operator_st200_cmpltu_1branch_2general_3xsrc2: return Operator_st200_cmpgeu_1branch_2general_3xsrc2;
    case Operator_st200_cmpne_1branch_2general_3general: return Operator_st200_cmpeq_1branch_2general_3general;
    case Operator_st200_cmpne_1branch_2general_3isrc2: return Operator_st200_cmpeq_1branch_2general_3isrc2;
    case Operator_st200_cmpne_1branch_2general_3xsrc2: return Operator_st200_cmpeq_1branch_2general_3xsrc2;
    case Operator_st200_cmpeq_1general_2general_3general: return Operator_st200_cmpne_1general_2general_3general;
    case Operator_st200_cmpeq_1general_2general_3isrc2: return Operator_st200_cmpne_1general_2general_3isrc2;
    case Operator_st200_cmpeq_1general_2general_3xsrc2: return Operator_st200_cmpne_1general_2general_3xsrc2;
    case Operator_st200_cmpge_1general_2general_3general: return Operator_st200_cmplt_1general_2general_3general;
    case Operator_st200_cmpge_1general_2general_3isrc2: return Operator_st200_cmplt_1general_2general_3isrc2;
    case Operator_st200_cmpge_1general_2general_3xsrc2: return Operator_st200_cmplt_1general_2general_3xsrc2;
    case Operator_st200_cmpgeu_1general_2general_3general: return Operator_st200_cmpltu_1general_2general_3general;
    case Operator_st200_cmpgeu_1general_2general_3isrc2: return Operator_st200_cmpltu_1general_2general_3isrc2;
    case Operator_st200_cmpgeu_1general_2general_3xsrc2: return Operator_st200_cmpltu_1general_2general_3xsrc2;
    case Operator_st200_cmpgt_1general_2general_3general: return Operator_st200_cmple_1general_2general_3general;
    case Operator_st200_cmpgt_1general_2general_3isrc2: return Operator_st200_cmple_1general_2general_3isrc2;
    case Operator_st200_cmpgt_1general_2general_3xsrc2: return Operator_st200_cmple_1general_2general_3xsrc2;
    case Operator_st200_cmpgtu_1general_2general_3general: return Operator_st200_cmpleu_1general_2general_3general;
    case Operator_st200_cmpgtu_1general_2general_3isrc2: return Operator_st200_cmpleu_1general_2general_3isrc2;
    case Operator_st200_cmpgtu_1general_2general_3xsrc2: return Operator_st200_cmpleu_1general_2general_3xsrc2;
    case Operator_st200_cmple_1general_2general_3general: return Operator_st200_cmpgt_1general_2general_3general;
    case Operator_st200_cmple_1general_2general_3isrc2: return Operator_st200_cmpgt_1general_2general_3isrc2;
    case Operator_st200_cmple_1general_2general_3xsrc2: return Operator_st200_cmpgt_1general_2general_3xsrc2;
    case Operator_st200_cmpleu_1general_2general_3general: return Operator_st200_cmpgtu_1general_2general_3general;
    case Operator_st200_cmpleu_1general_2general_3isrc2: return Operator_st200_cmpgtu_1general_2general_3isrc2;
    case Operator_st200_cmpleu_1general_2general_3xsrc2: return Operator_st200_cmpgtu_1general_2general_3xsrc2;
    case Operator_st200_cmplt_1general_2general_3general: return Operator_st200_cmpge_1general_2general_3general;
    case Operator_st200_cmplt_1general_2general_3isrc2: return Operator_st200_cmpge_1general_2general_3isrc2;
    case Operator_st200_cmplt_1general_2general_3xsrc2: return Operator_st200_cmpge_1general_2general_3xsrc2;
    case Operator_st200_cmpltu_1general_2general_3general: return Operator_st200_cmpgeu_1general_2general_3general;
    case Operator_st200_cmpltu_1general_2general_3isrc2: return Operator_st200_cmpgeu_1general_2general_3isrc2;
    case Operator_st200_cmpltu_1general_2general_3xsrc2: return Operator_st200_cmpgeu_1general_2general_3xsrc2;
    case Operator_st200_cmpne_1general_2general_3general: return Operator_st200_cmpeq_1general_2general_3general;
    case Operator_st200_cmpne_1general_2general_3isrc2: return Operator_st200_cmpeq_1general_2general_3isrc2;
    case Operator_st200_cmpne_1general_2general_3xsrc2: return Operator_st200_cmpeq_1general_2general_3xsrc2;
    default: break;
    }
  }
  return Operator_;
}

#line 1133 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/st200-Operator.xcc"
Operator
Operator_complementRead(Operator this, Processor processor, int32_t readIndex)
{
  if (readIndex == 0) {
    switch (this) {
    case Operator_GOTRUE: return Operator_GOFALSE;
    case Operator_GOFALSE: return Operator_GOTRUE;
    case Operator_st200_br_1branch_2btarg: return Operator_st200_brf_1branch_2btarg;
    case Operator_st200_brf_1branch_2btarg: return Operator_st200_br_1branch_2btarg;
    case Operator_st200_slct_1general_2branch_3general_4general: return Operator_st200_slctf_1general_2branch_3general_4general;
#ifdef MDS_CORE_st240
    case Operator_st200_slct_rsrc_1general_2branch_3general_4general: return Operator_st200_slctf_1general_2branch_3general_4general;
#endif//MDS_CORE_st240
    case Operator_st200_slct_1general_2branch_3general_4isrc2: return Operator_st200_slctf_1general_2branch_3general_4isrc2;
    case Operator_st200_slct_1general_2branch_3general_4xsrc2: return Operator_st200_slctf_1general_2branch_3general_4xsrc2;
#ifdef MDS_CORE_st240
    case Operator_st200_slctf_1general_2branch_3general_4general: return (processor == Processor_st240_cpu)?
                                                                         Operator_st200_slct_rsrc_1general_2branch_3general_4general:
                                                                         Operator_st200_slct_1general_2branch_3general_4general;
#else//!MDS_CORE_st240
    case Operator_st200_slctf_1general_2branch_3general_4general: return Operator_st200_slct_1general_2branch_3general_4general;
#endif//MDS_CORE_st240
    case Operator_st200_slctf_1general_2branch_3general_4isrc2: return Operator_st200_slct_1general_2branch_3general_4isrc2;
    case Operator_st200_slctf_1general_2branch_3general_4xsrc2: return Operator_st200_slct_1general_2branch_3general_4xsrc2;
    default: break;
    }
  }
  return Operator_;
}


#endif//Operator_c_INCLUDED
