#ifndef Platform_c_INCLUDED
#define Platform_c_INCLUDED

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Platform.xcc"
#include "MDS/MDS_.h"

#line 31 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Platform.xcc"
const int Platform__COUNT = Platform__;

#line 33 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Platform.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 41 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Platform.xcc"
#ifndef ECL_NTRACE
const char *
Platform_name_(Platform this)
{
  static const char *_[] = {
#define Platform(NAME, CHARWIDTH, ADDRWIDTH, ENDIAN) \
    #NAME,
    "_UNDEF",
#include "Platform.enum"
  };
  Except_REQUIRE((unsigned)this < Platform__);
  return _[this];
}
#endif//ECL_NTRACE

#line 64 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Platform.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 72 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Platform.xcc"
extern const int8_t
Platform_CharWidth[];
int
Platform_charWidth(Platform this)
{
  Except_REQUIRE((unsigned)this < Platform__);
  return Platform_CharWidth[this];
}

#line 81 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Platform.xcc"
const int8_t
Platform_CharWidth[] = {
#define CHARWIDTH(d) d
#define Platform(NAME, CHARWIDTH, ADDRWIDTH, ENDIAN) \
  CHARWIDTH,
  CHARWIDTH(0),
#include "Platform.enum"
};

#line 90 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Platform.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 98 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Platform.xcc"
extern const int8_t
Platform_AddrWidth[];
int
Platform_addrWidth(Platform this)
{
  Except_REQUIRE((unsigned)this < Platform__);
  return Platform_AddrWidth[this];
}

#line 107 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Platform.xcc"
const int8_t
Platform_AddrWidth[] = {
#define ADDRWIDTH(d) d
#define Platform(NAME, CHARWIDTH, ADDRWIDTH, ENDIAN) \
  ADDRWIDTH,
  ADDRWIDTH(0),
#include "Platform.enum"
};

#line 116 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Platform.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 133 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Platform.xcc"
extern const PlatformEndian
Platform_Endian[];
PlatformEndian
Platform_endian(Platform this)
{
  Except_REQUIRE((unsigned)this < Platform__);
  return (PlatformEndian)Platform_Endian[this];
}

#line 142 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Platform.xcc"
const PlatformEndian
Platform_Endian[] = {
#define ENDIAN(endian) PlatformEndian_##endian
#define Platform(NAME, CHARWIDTH, ADDRWIDTH, ENDIAN) \
  ENDIAN,
  ENDIAN(_UNDEF),
#include "Platform.enum"
};

#line 151 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Platform.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 163 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Platform.xcc"
#if XCC__C
static void
Platform_TEST(void)
{
#include "MDS/Platform_.c"
}

#line 170 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Platform.xcc"
int
main(int argc, char **argv)
{
  MDS_Test(Platform_TEST);
  return 0;
}
#endif


#endif//Platform_c_INCLUDED
