#ifndef RegFile_c_INCLUDED
#define RegFile_c_INCLUDED

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/RegFile.xcc"
#include "MDS/MDS_.h"

#line 31 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/RegFile.xcc"
const int RegFile__COUNT = RegFile__;

#line 33 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/RegFile.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 43 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/RegFile.xcc"
#ifndef ECL_NTRACE
const char *
RegFile_name_(RegFile this)
{
  static const char *_[] = {
#define RegFile(NAME, WIDTH, LOWREGISTER, HIGHREGISTER, NATIVETYPES) \
    #NAME,
    "_UNDEF",
#include "RegFile.enum"
  };
  Except_REQUIRE((unsigned)this < RegFile__);
  return _[this];
}
const char *
RegFile_name(RegFile this)
{
  return this? RegFile_name_(this) + sizeof(MDS_FAMILY): "_UNDEF";
}
#endif//ECL_NTRACE

#line 71 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/RegFile.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 79 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/RegFile.xcc"
extern const uint8_t
RegFile_Width[];
unsigned
RegFile_width(RegFile this)
{
  Except_REQUIRE((unsigned)this < RegFile__);
  return RegFile_Width[this];
}

#line 88 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/RegFile.xcc"
const uint8_t
RegFile_Width[] = {
#define WIDTH(d) d
#define RegFile(NAME, WIDTH, LOWREGISTER, HIGHREGISTER, NATIVETYPES) \
  WIDTH,
  WIDTH(0),
#include "RegFile.enum"
};

#line 106 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/RegFile.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 115 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/RegFile.xcc"
extern const NativeType
RegFile_NativeType[][NativeType__];
NativeType
RegFile_getNativeType(RegFile this)
{
  Except_REQUIRE((unsigned)this < RegFile__);
  return (NativeType)RegFile_NativeType[this][0];
}

#line 124 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/RegFile.xcc"
const NativeType
RegFile_NativeType[][NativeType__] = {
#define NATIVETYPES(count, items) { items NativeType_ }
#define NATIVETYPE(NAME) NativeType_##NAME,
#define RegFile(NAME, WIDTH, LOWREGISTER, HIGHREGISTER, NATIVETYPES) \
  NATIVETYPES,
  NATIVETYPES(0, /**/),
#include "RegFile.enum"
};

#line 144 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/RegFile.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 152 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/RegFile.xcc"
extern const Register
RegFile_LowReg[];
Register
RegFile_lowRegister(RegFile this)
{
  Except_REQUIRE((unsigned)this < RegFile__);
  return (Register)RegFile_LowReg[this];
}

#line 161 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/RegFile.xcc"
const Register
RegFile_LowReg[] = {
#define LOWREGISTER(NAME) Register_##NAME
#define RegFile(NAME, WIDTH, LOWREGISTER, HIGHREGISTER, NATIVETYPES) \
  LOWREGISTER,
  LOWREGISTER(_UNDEF),
#include "RegFile.enum"
};

#line 177 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/RegFile.xcc"
extern const Register
RegFile_HighReg[];
Register
RegFile_highRegister(RegFile this)
{
  Except_REQUIRE((unsigned)this < RegFile__);
  return (Register)RegFile_HighReg[this];
}

#line 186 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/RegFile.xcc"
const Register
RegFile_HighReg[] = {
#define HIGHREGISTER(NAME) Register_##NAME
#define RegFile(NAME, WIDTH, LOWREGISTER, HIGHREGISTER, NATIVETYPES) \
  HIGHREGISTER,
  HIGHREGISTER(_UNDEF),
#include "RegFile.enum"
};

#line 215 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/RegFile.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 223 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/RegFile.xcc"
extern /*const*/ RegisterSet_
RegFile_RegisterSet[];
const_RegisterSet
RegFile_registerSet(RegFile this)
{
  Except_REQUIRE((unsigned)this < RegFile__);
  return RegFile_RegisterSet + this;
}

#line 232 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/RegFile.xcc"
/*const*/ RegisterSet_
RegFile_RegisterSet[RegFile__];

#line 246 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/RegFile.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 252 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/RegFile.xcc"
#ifndef ECL_NTRACE
bool
RegFile_DTD(FILE *file)
{
  fputs(
        "<!ELEMENT RegFile EMPTY >"
        "<!ATTLIST RegFile"
        "  ID ID #REQUIRED"
        ">"
       , file);
  return true;
}
#endif//ECL_NTRACE

#line 270 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/RegFile.xcc"
#ifndef ECL_NTRACE
bool
RegFile_XML(FILE *file)
{
  int regFile = 0;
  for (; regFile < RegFile__; regFile++) {
    fprintf(file, "<RegFile ID=\"RegFile_%s\" />\n", RegFile_name_(regFile));
  }
  return true;
}
#endif//ECL_NTRACE

#line 294 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/RegFile.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 302 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/RegFile.xcc"
void
RegFile_INIT(void)
{
  int regFile = 0, registre = 0;
  for (; regFile < RegFile__; regFile++) {
    int lowRegister = RegFile_lowRegister(regFile);
    int highRegister = RegFile_highRegister(regFile);
    RegisterSet registerSet = RegFile_RegisterSet + regFile;
    for (registre = lowRegister; registre <= highRegister; registre++) {
      RegisterSet_insert(registerSet, registre);
    }
  }
}

#line 321 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/RegFile.xcc"
#if XCC__C
static void
RegFile_TEST(void)
{
#include "MDS/RegFile_.c"
}

#line 328 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/RegFile.xcc"
int
main(int argc, char **argv)
{
  MDS_Test(RegFile_TEST);
  return 0;
}
#endif


#endif//RegFile_c_INCLUDED
