#ifndef RegMask_h_INCLUDED
#define RegMask_h_INCLUDED

/*
 * !!!!	RegMask.xcc
 *
 * Benoit Dupont de Dinechin (Benoit.Dupont-de-Dinechin@st.com).
 *
 * Copyright 2002 - 2007 STMicroelectronics.
 * Copyright 1995 - 1998 Commissariat a l'Energie Atomique.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of either (at your option): the GNU
 * General Public License (GPL) version 2; the GNU Lesser General
 * Public License (LGPL) version 2.1; any later version of these
 * licences as published by the Free Software Foundation.
 */

/*
 * RegMask_name_ --	Names for the RegMask enumeration.
 */
extern const char *
RegMask_name_(RegMask this);

/*
 * RegMask_registerList --	This RegMask Register(s) as a RegisterList.
 */
const_RegisterList
RegMask_registerList(RegMask this);

/*
 * RegMask_regFile --	The RegFile this RegMask belongs to.
 */
RegFile
RegMask_regFile(RegMask this);

/*
 * RegMask_registerSet --	This RegMask Register(s) as a RegisterSet.
 */
const_RegisterSet
RegMask_registerSet(RegMask this);


#endif//RegMask_h_INCLUDED
