#ifndef Register_c_INCLUDED
#define Register_c_INCLUDED

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
#include "MDS/MDS_.h"

#line 32 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
const int Register__COUNT = Register__;

#line 34 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 44 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
#ifndef ECL_NTRACE
const char *
Register_name_(Register this)
{
  static const char *_[] = {
#define Register(NAME, NAMES, REGFILE, WIRED, STORAGECELLS, MINREADSTAGES) \
    #NAME,
    "_UNDEF",
#include "Register.enum"
  };
  Except_REQUIRE((unsigned)this < Register__);
  return _[this];
}
const char *
Register_name(Register this)
{
  return this? Register_name_(this) + sizeof(MDS_FAMILY): "_UNDEF";
}
#endif//ECL_NTRACE

#line 72 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 80 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
extern const char *
Register_Names[][Register_NAMES_COUNT_MAX+1];
const char **
Register_names(Register this)
{
  Except_REQUIRE((unsigned)this < Register__);
  return Register_Names[this];
}

#line 89 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
const char *
Register_Names[][Register_NAMES_COUNT_MAX+1] = {
#define NAME(NAME) #NAME,
#define NAMES(count, items) { items 0 }
#define Register(NAME, NAMES, REGFILE, WIRED, STORAGECELLS, MINREADSTAGES) \
  NAMES,
  NAMES(1, NAME(_UNDEF)),
#include "Register.enum"
};

#line 99 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 107 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
extern const RegFile
Register_RegFile[];
RegFile
Register_regFile(Register this)
{
  Except_REQUIRE((unsigned)this < Register__);
  return (RegFile)Register_RegFile[this];
}

#line 116 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
const RegFile
Register_RegFile[] = {
#define REGFILE(NAME) RegFile_##NAME
#define Register(NAME, NAMES, REGFILE, WIRED, STORAGECELLS, MINREADSTAGES) \
  REGFILE,
  REGFILE(_UNDEF),
#include "Register.enum"
};

#line 134 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 142 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
extern bool
Register_Wired[];
bool
Register_isWired(Register this)
{
  Except_REQUIRE((unsigned)this < Register__);
  return Register_Wired[this];
}

#line 151 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
bool
Register_Wired[] = {
#define WIRED(b) b
#define Register(NAME, NAMES, REGFILE, WIRED, STORAGECELLS, MINREADSTAGES) \
  WIRED,
  WIRED(true),	// Ensure Register_isWired(Register_) is true.
#include "Register.enum"
};

#line 171 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 222 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 230 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
extern RegisterStorageCells_
Register_StorageCells[];
const_RegisterStorageCells
Register_storageCells(Register this)
{
  Except_REQUIRE((unsigned)this < Register__);
  return Register_StorageCells + this;
}

#line 239 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
RegisterStorageCells_
Register_StorageCells[] = {
#define STORAGECELL(NAME) StorageCell_##NAME,
#define STORAGECELLS(count, items) count, { items }
#define Register(NAME, NAMES, REGFILE, WIRED, STORAGECELLS, MINREADSTAGES) \
  { STORAGECELLS },
  { STORAGECELLS(0, /**/) },
#include "Register.enum"
};

#line 263 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 271 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
extern const uint8_t
Register_MinReadStages[][Processor__];
int
Register_minReadStage(Register this, Processor processor)
{
  Except_REQUIRE((unsigned)this < Register__);
  Except_REQUIRE((unsigned)processor < Processor__);
  return Register_MinReadStages[this][processor];
}

#line 281 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
const uint8_t
Register_MinReadStages[][Processor__] = {
#define MINREADSTAGE(processor, stage) (uint8_t)(stage),
#define MINREADSTAGES(items) { 0/*Processor_*/, items }
#define Register(NAME, NAMES, REGFILE, WIRED, STORAGECELLS, MINREADSTAGES) \
  MINREADSTAGES,
  MINREADSTAGES(/**/),
#include "Register.enum"
#undef MINREADSTAGES
};

#line 311 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 386 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
bool
RegisterList_contains(const_RegisterList this, Register member)
{
  RegisterList_FOREACH_Register(this, registre) {
    if (registre == member) return true;
  } RegisterList_ENDEACH_Register;
  return false;
}

#line 395 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 403 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
bool
Register_isLifetime(Register this, Convention convention)
{
  if (   RegisterSet_contains(Convention_roleRegisterSet(convention,
                                                         ConventionRole_Program), this)
      || RegisterSet_contains(Convention_roleRegisterSet(convention,
                                                         ConventionRole_Stack), this)
      || RegisterSet_contains(Convention_roleRegisterSet(convention,
                                                         ConventionRole_Wired), this)) {
    return false;
  }
  return true;
}

#line 417 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 435 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
RegisterSet
RegisterSet_Ctor(RegisterSet this)
{
  int i;
  for (i = 0; i < RegisterSet_WORDCOUNT; i++) {
    RegisterSet_WORDS(this)[i] = 0;
  }
  return this;
}

#line 445 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
RegisterSet
RegisterSet_Copy(RegisterSet this, const_RegisterSet that)
{
  *(this) = *(that);
  return this;
}

#line 452 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
void
RegisterSet_Dtor(RegisterSet this)
{
}

#line 477 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
bool
RegisterSet_isEmpty(const_RegisterSet this)
{
  const RegisterSetWord *words = RegisterSet_WORDS(this);
  int wordCount = RegisterSet_WORDCOUNT, i;
  for (i = 0; i < wordCount; i++) {
    if (words[i] != 0) return false;
  }
  return true;
}

#line 495 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
int
RegisterSet_count(const_RegisterSet this)
{
  const RegisterSetWord *words = RegisterSet_WORDS(this);
  int wordCount = RegisterSet_WORDCOUNT, count = 0, i;
  if (sizeof(RegisterSetWord) <= 32) {
    for (i = 0; i < wordCount; i++) count += HackerU32_popc(words[i]);
  } else {
    for (i = 0; i < wordCount; i++) count += HackerU64_popc(words[i]);
  }
  return count;
}

#line 514 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
Register
RegisterSet_first(const_RegisterSet this)
{
  int result = 0;
  const RegisterSetWord *words = RegisterSet_WORDS(this);
  int wordCount = RegisterSet_WORDCOUNT, i;
  for (i = 0; i < wordCount; i++) {
    RegisterSetWord word = *words++;
    RegisterSetWord least = word & -word;
    if (least != 0) {
      if (RegisterSet_WORDBITS <= 32) {
#ifndef __st200__
        result += HackerU32_popc(least - 1);
#else// __st200__
        result += 31 - __lzcntw(least);
#endif
      } else {
        result += HackerU64_popc(least - 1);
      }
      return result;
    }
    result += RegisterSet_WORDBITS;
  }
  return Register_;
}

#line 546 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
void
RegisterSet_empty(RegisterSet this)
{
  RegisterSetWord *words = RegisterSet_WORDS(this);
  int wordCount = RegisterSet_WORDCOUNT, i;
  for (i = 0; i < wordCount; i++) words[i] = 0;
}

#line 562 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
Register
RegisterSet_choose(RegisterSet this)
{
  int wordCount = RegisterSet_WORDCOUNT, index = 0, i, j;
  RegisterSetWord *words = RegisterSet_WORDS(this), word = 0;
  for (i = 0; i < wordCount; i++) {
    if (word == 0) {
      word = words[i];
      index = i;
    }
  }
  if (word != 0) {
    RegisterSetWord least = word & -word;
    if (RegisterSet_WORDBITS <= 32) {
#ifndef __st200__
      j = HackerU32_popc(least - 1);
#else// __st200__
      j = 31 - __lzcntw(least);
      Except_CHECK(j == HackerU32_popc(least - 1));
#endif
    } else {
      j = HackerU64_popc(least - 1);
    }
    words[index] = word ^ least;
    return index*RegisterSet_WORDBITS + j;
  }
  return Register_;
}

#line 591 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
#if 0
Register
RegisterSet_choose(RegisterSet this)
{
  RegisterSetWord *words = RegisterSet_WORDS(this);
  int wordCount = RegisterSet_WORDCOUNT, i, j;
  for (i = 0; i < wordCount; i++) {
    RegisterSetWord word = words[i];
    for (j = 0; word != 0; j++, word >>= 1) {
      if (word & 1) {
        words[i] &= ~((RegisterSetWord)1 << j);
        return i*RegisterSet_WORDBITS + j;
      }
    }
  }
  return Register_;
}
#endif

#line 616 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
Register
RegisterSet_nextMember(const_RegisterSet this, Register member)
{
  const RegisterSetWord *words = RegisterSet_WORDS(this);
  int32_t wordCount = RegisterSet_WORDCOUNT;
  int32_t i = RegisterSet_MAJOR(member + 1);
  int32_t j = RegisterSet_MINOR(member + 1);
  if (i < wordCount) {
    RegisterSetWord word = words[i] >> j;
    for (; word != 0; j++, word >>= 1) {
      if (word & 1) {
        return i*RegisterSet_WORDBITS + j;
      }
    }
  }
  for (i++; i < wordCount; i++) {
    RegisterSetWord word = words[i];
    for (j = 0; word != 0; j++, word >>= 1) {
      if (word & 1) {
        return i*RegisterSet_WORDBITS + j;
      }
    }
  }
  return Register_;
}

#line 652 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
Register
RegisterSet_chooseFromLast(RegisterSet set, Register last_reg)
{
  int wordCount = RegisterSet_WORDCOUNT;
  int index = 0, i, j;
  RegisterSetWord *words = RegisterSet_WORDS(set);
  RegisterSetWord word = 0;
  int start_idx = last_reg/RegisterSet_WORDBITS;
  int start_pos = last_reg - (start_idx * RegisterSet_WORDBITS);

#line 662 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
  index = start_idx;
  if (RegisterSet_WORDBITS <= 32) {
    if (start_pos != 31)
      word = words[index] & (0xFFFFFFFF << (start_pos+1));
  }
  else {
    if (start_pos != 63)
      word = words[index] & (0xFFFFFFFFFFFFFFFFLL << (start_pos+1));
  }

#line 672 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
  if (word)
    goto assign_reg;

#line 675 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
  for (i = start_idx + 1;  i < wordCount; i++) {
    if (words[i] != 0) {
      word = words[i];
      index = i;
      goto assign_reg;
    }
  }
  for (i = 0; i < start_idx + 1; i++) {
    if (words[i] != 0) {
      word = words[i];
      index = i;
      goto assign_reg;
    }
  }

#line 690 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
  return Register_;

#line 692 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
assign_reg:
  {
    RegisterSetWord least = word & -word;
    if (RegisterSet_WORDBITS <= 32) {
// TODO: Add rules to configure to check for __builtin_clz and use it if it exists.
// #if defined(HAVE___BUILTIN_CLZ)
//    ERR_ASSERT(sizeof(RegisterSetWord) == SIZEOF_UNSIGNED_INT);
//    j = 31 - __builtin_clz(least);
#if defined(__st200__)
      j = 31 - __lzcntw(least);
#else
      int32_t value = least;
      j  = (-(value & 0x0000FFFF)>>31)<<4;
      j += (-(value & 0x00FF00FF)>>31)<<3;
      j += (-(value & 0x0F0F0F0F)>>31)<<2;
      j += (-(value & 0x33333333)>>31)<<1;
      j += (-(value & 0x55555555)>>31)+31;
#endif // HAVE___BUILTIN_CLZ
      Except_CHECK(j == HackerU32_popc(least - 1));
    }
    else {
      Except_CHECK(RegisterSet_WORDBITS == 64);
      j = HackerU64_popc(least - 1);
    }
    words[index] = word ^ least;
    return index*RegisterSet_WORDBITS + j;
  }
}

#line 729 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
bool
RegisterSet_contains(const_RegisterSet this, Register member)
{
  RegisterSetWord old_word, new_word;
  int major = RegisterSet_MAJOR(member);
  int minor = RegisterSet_MINOR(member);
  Except_REQUIRE(major < RegisterSet_WORDCOUNT);
  old_word = new_word = RegisterSet_WORDS(this)[major];
  new_word |= ((RegisterSetWord)1 << minor);
  return old_word == new_word;
}

#line 748 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
bool
RegisterSet_insert(RegisterSet this, Register member)
{
  RegisterSetWord old_word, new_word;
  int major = RegisterSet_MAJOR(member);
  int minor = RegisterSet_MINOR(member);
  Except_REQUIRE(major < RegisterSet_WORDCOUNT);
  old_word = new_word = RegisterSet_WORDS(this)[major];
  new_word |= ((RegisterSetWord)1 << minor);
  RegisterSet_WORDS(this)[major] = new_word;
  return old_word != new_word;
}

#line 768 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
bool
RegisterSet_remove(RegisterSet this, Register member)
{
  RegisterSetWord old_word, new_word;
  int major = RegisterSet_MAJOR(member);
  int minor = RegisterSet_MINOR(member);
  Except_REQUIRE(major < RegisterSet_WORDCOUNT);
  old_word = new_word = RegisterSet_WORDS(this)[major];
  new_word &= ~((RegisterSetWord)1 << minor);
  RegisterSet_WORDS(this)[major] = new_word;
  return old_word != new_word;
}

#line 787 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
bool
RegisterSet_equals(const_RegisterSet this, const_RegisterSet that)
{
  int i = 0;
  for (; i < RegisterSet_WORDCOUNT; i++) {
    if (RegisterSet_WORDS(this)[i] != RegisterSet_WORDS(that)[i]) return false;
  }
  return true;
}

#line 803 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
void
RegisterSet_union(RegisterSet this, const_RegisterSet that)
{
  int i = 0;
  for (; i < RegisterSet_WORDCOUNT; i++) {
    RegisterSet_WORDS(this)[i] |= RegisterSet_WORDS(that)[i];
  }
}

#line 818 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
void
RegisterSet_inter(RegisterSet this, const_RegisterSet that)
{
  int i = 0;
  for (; i < RegisterSet_WORDCOUNT; i++) {
    RegisterSet_WORDS(this)[i] &= RegisterSet_WORDS(that)[i];
  }
}

#line 833 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
void
RegisterSet_diff(RegisterSet this, const_RegisterSet that)
{
  int i = 0;
  for (; i < RegisterSet_WORDCOUNT; i++) {
    RegisterSet_WORDS(this)[i] &= ~RegisterSet_WORDS(that)[i];
  }
}

#line 867 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
#ifndef ECL_NTRACE
bool
RegisterSet_pretty(const_RegisterSet this, FILE *file)
{
  bool inRange = false;
  int prevReg = Register_;
  if (file == NULL) file = stderr;
  RegisterSet_FOREACH_Register(this, registre) {
    if (prevReg == Register_) {
      fprintf(file, "%s", Register_name(registre));
    } else if (registre == prevReg + 1 &&
        Register_regFile(registre) == Register_regFile(prevReg)) {
      // Inside Register range.
      inRange = true;
    } else if (inRange) {
      // Stop Register range.
      fprintf(file, "-%s", Register_name(prevReg));
      fprintf(file, " %s", Register_name(registre));
      inRange = false;
    } else {
      fprintf(file, " %s", Register_name(registre));
    }
    prevReg = registre;
  } RegisterSet_ENDEACH_Register;
  if (inRange && prevReg != Register_) {
    fprintf(file, "-%s", Register_name(prevReg));
  }
  return true;
}
#endif//ECL_NTRACE

#line 912 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 986 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1117 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1123 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
#ifndef ECL_NTRACE
bool
Register_DTD(FILE *file)
{
  fputs(
        "<!ELEMENT Register EMPTY >"
        "<!ATTLIST Register"
        "  ID ID #REQUIRED"
        ">"
       , file);
  return true;
}
#endif//ECL_NTRACE

#line 1141 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
#ifndef ECL_NTRACE
bool
Register_XML(FILE *file)
{
  int registre = 0;
  for (; registre < Register__; registre++) {
    fprintf(file, "<Register ID=\"Register_%s\" />\n", Register_name_(registre));
  }
  return true;
}
#endif//ECL_NTRACE

#line 1165 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1177 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
#if XCC__C
static void
Register_TEST(void)
{
#include "MDS/Register_.c"
}

#line 1184 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
int
main(int argc, char **argv)
{
  MDS_Test(Register_TEST);
  return 0;
}
#endif


#endif//Register_c_INCLUDED
