#ifndef Reservation_c_INCLUDED
#define Reservation_c_INCLUDED

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Reservation.xcc"
#include "MDS/MDS_.h"

#line 31 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Reservation.xcc"
const int Reservation__COUNT = Reservation__;

#line 33 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Reservation.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 61 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Reservation.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 71 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Reservation.xcc"
#ifndef ECL_NTRACE
const char *
Reservation_name_(Reservation this)
{
  static const char *_[] = {
#define Reservation(NAME, TABLE) \
    #NAME,
    "_UNDEF",
#include "Reservation.enum"
  };
  Except_REQUIRE((unsigned)this < Reservation__);
  return _[this];
}
const char *
Reservation_name(Reservation this)
{
  return this? Reservation_name_(this) + sizeof(MDS_FAMILY): "_UNDEF";
}
#endif//ECL_NTRACE

#line 99 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Reservation.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 101 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Reservation.xcc"
/*const*/ ResourceVector_
Reservation_Columns[] = {
#define REQUIRED(resource, units) units,
#define REQUIREMENTS(items) { { 0/*Resource_*/, items } }
#define ReservationColumn(COLUMNINDEX, REQUIREMENTS) \
  REQUIREMENTS,
  // No dummy entry because only used as Reservation_Columns + columnIndex.
#include "Reservation.enum"
#undef REQUIREMENTS
};

#line 112 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Reservation.xcc"
// Zero ResourceVector for use by ReservationTable of Reservation_.
/*const*/ ResourceVector_
Reservation_Columns__ZERO;

#line 116 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Reservation.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 128 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Reservation.xcc"
const_ReservationTable
Reservation_table(Reservation this)
{
  Except_REQUIRE((unsigned)this < Reservation__);
  return Reservation_Table + this;
}

#line 135 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Reservation.xcc"
/*const*/ ReservationTable_
Reservation_Table[] = {
#define COLUMNCOUNT(d) d
#define COLUMNINDEX(d) d
#define TABLE(columnCount, columnIndex) \
  { columnCount, Reservation_Columns + columnIndex }
#define Reservation(NAME, TABLE) \
  TABLE,
  { 0, &Reservation_Columns__ZERO },
#include "Reservation.enum"
};

#line 175 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Reservation.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 183 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Reservation.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 191 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Reservation.xcc"
extern int8_t
Reservation_ODot[Reservation__][Reservation__][Processor__];
int
Reservation_odot(Reservation this, Reservation that, Processor processor)
{
  Except_REQUIRE((unsigned)this < Reservation__);
  Except_REQUIRE((unsigned)that < Reservation__);
  Except_REQUIRE((unsigned)processor < Processor__);
  return Reservation_ODot[this][that][processor];
}

#line 202 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Reservation.xcc"
int8_t Reservation_ODot[Reservation__][Reservation__][Processor__];

#line 228 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Reservation.xcc"
void
Reservation_InitializeODot(void)
{
  int processor, this, that, resource;
  for (processor = 0; processor < Processor__; processor++) {
    for (this = 0; this < Reservation__; this++) {
      for (that = 0; that < Reservation__; that++) {
        for (resource = 0; resource < Resource__; resource++) {
          const_ResourceVector this_requirements = Reservation_requirements(this);
          const_ResourceVector that_requirements = Reservation_requirements(that);
          const_ResourceVector availability = Processor_availability(processor);
          int this_required = ResourceVector_UNITS(this_requirements)[resource];
          int that_required = ResourceVector_UNITS(that_requirements)[resource];
          int available = ResourceVector_UNITS(availability)[resource];
          if (this_required + that_required > available) {
            Reservation_ODot[this][that][processor] = 1;
          }
        }
      }
    }
  }
}

#line 251 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Reservation.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 257 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Reservation.xcc"
#ifndef ECL_NTRACE
bool
Reservation_DTD(FILE *file)
{
  fputs(
        "<!ELEMENT Reservation EMPTY >"
        "<!ATTLIST Reservation"
        "  ID ID #REQUIRED"
        ">"
       , file);
  return true;
}
#endif//ECL_NTRACE

#line 275 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Reservation.xcc"
#ifndef ECL_NTRACE
bool
Reservation_XML(FILE *file)
{
  int reservation;
  for (reservation = 0; reservation < Reservation__; reservation++) {
    fprintf(file, "<Reservation ID=\"Reservation_%s\" />\n", Reservation_name_(reservation));
  }
  return true;
}
#endif//ECL_NTRACE

#line 299 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Reservation.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 307 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Reservation.xcc"
void
Reservation_INIT(void)
{
  Reservation_InitializeODot();
}

#line 318 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Reservation.xcc"
#if XCC__C
static void
Reservation_TEST(void)
{
#include "MDS/Reservation_.c"
}

#line 325 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Reservation.xcc"
int
main(int argc, char **argv)
{
  MDS_Test(Reservation_TEST);
  return 0;
}
#endif

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/st200-Reservation.xcc"
unsigned
Reservation_criticality(Reservation this)
{
  switch (this) {
#ifdef MDS_CORE_st220
  case Reservation_st220_ALL:	return 8;
  case Reservation_st220_ALU:	return 1;
  case Reservation_st220_ALUX:	return 2;
  case Reservation_st220_CTL:	return 4;
  case Reservation_st220_ODD:	return 3;
  case Reservation_st220_ODDX:	return 4;
  case Reservation_st220_MEM:	return 5;
  case Reservation_st220_MEMX:	return 6;
  case Reservation_st220_PSW:	return 2;
  case Reservation_st220_EVEN:	return 3;
#endif//MDS_CORE_st220
#ifdef MDS_CORE_st231
  case Reservation_st231_ALL:	return 8;
  case Reservation_st231_ALU:	return 1;
  case Reservation_st231_ALUX:	return 2;
  case Reservation_st231_CTL:	return 4;
  case Reservation_st231_ODD:	return 3;
  case Reservation_st231_ODDX:	return 4;
  case Reservation_st231_MEM:	return 5;
  case Reservation_st231_MEMX:	return 6;
  case Reservation_st231_PSW:	return 2;
  case Reservation_st231_EVEN:	return 3;
#endif//MDS_CORE_st231
#ifdef MDS_CORE_st240
  case Reservation_st240_ALL:	return 8;
  case Reservation_st240_ALU:	return 1;
  case Reservation_st240_ALUX:	return 2;
  case Reservation_st240_CTL:	return 4;
  case Reservation_st240_ODD:	return 3;
  case Reservation_st240_ODDX:	return 4;
  case Reservation_st240_MEM:	return 5;
  case Reservation_st240_MEMX:	return 6;
  case Reservation_st240_PSW:	return 2;
  case Reservation_st240_EVEN:	return 3;
#endif//MDS_CORE_st240
  default: return 0;
  }
}


#endif//Reservation_c_INCLUDED
