#ifndef Reservation__h_INCLUDED
#define Reservation__h_INCLUDED

//
#include "MDS/Reservation.h"

//
typedef enum {
#define Reservation(NAME, TABLE) \
  Reservation_##NAME,
  Reservation_,
#include /*MDS*/"Reservation.enum"
  Reservation__
#undef Reservation
} enum_Reservation;

//
extern /*const*/ ReservationTable_
Reservation_Table[];

/*
 * Reservation_InitializeODot --	Initialize the contents of the Reservation_ODot array.
 */
void
Reservation_InitializeODot(void);

/*
 * Reservation_INIT --	Initialize the Reservation module.
 */
void
Reservation_INIT(void);

/*
 * Reservation_FINI --	Finalize the Reservation module.
 */
#define Reservation_FINI()


#endif//Reservation__h_INCLUDED
