	.file	"PFA.c"
	.text
	.p2align 4,,15
.globl Timer_Ctor
	.type	Timer_Ctor, @function
Timer_Ctor:
	pushl	%ebp
	movl	%esp, %ebp
	subl	$24, %esp
	movl	16(%ebp), %eax
	movl	%esi, -4(%ebp)
	movl	8(%ebp), %esi
	movl	12(%ebp), %edx
	movl	%ebx, -8(%ebp)
	movl	%eax, %ecx
	sall	$4, %ecx
	call	__i686.get_pc_thunk.bx
	addl	$_GLOBAL_OFFSET_TABLE_, %ebx
	movl	%eax, 4(%esi)
	xorl	%eax, %eax
	testl	%ecx, %ecx
	movl	%edx, (%esi)
	je	.L2
	movl	%ecx, 4(%esp)
	movl	%edx, (%esp)
	call	Memory_alloc_@PLT
.L2:
	movl	%eax, 8(%esi)
	movl	%esi, %eax
	movl	-8(%ebp), %ebx
	movl	-4(%ebp), %esi
	movl	%ebp, %esp
	popl	%ebp
	ret
	.size	Timer_Ctor, .-Timer_Ctor
	.p2align 4,,15
.globl Timer_Dtor
	.type	Timer_Dtor, @function
Timer_Dtor:
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%ebx
	subl	$20, %esp
	movl	8(%ebp), %eax
	call	__i686.get_pc_thunk.bx
	addl	$_GLOBAL_OFFSET_TABLE_, %ebx
	movl	8(%eax), %edx
	movl	(%eax), %eax
	testl	%edx, %edx
	je	.L5
	movl	%edx, 4(%esp)
	movl	%eax, (%esp)
	call	Memory_free_@PLT
.L5:
	addl	$20, %esp
	popl	%ebx
	popl	%ebp
	ret
	.size	Timer_Dtor, .-Timer_Dtor
	.p2align 4,,15
.globl Timer_value
	.type	Timer_value, @function
Timer_value:
	pushl	%ebp
	movl	%esp, %ebp
	subl	$8, %esp
	movl	12(%ebp), %eax
	movl	%esi, (%esp)
	movl	%edi, 4(%esp)
	leal	1(%eax,%eax), %ecx
	movl	8(%ebp), %eax
	sall	$3, %ecx
	addl	8(%eax), %ecx
	movl	$1000000, %eax
	movl	4(%ecx), %esi
	imull	(%ecx)
	movl	%esi, %edi
	sarl	$31, %edi
	addl	%esi, %eax
	movl	(%esp), %esi
	adcl	%edi, %edx
	movl	4(%esp), %edi
	movl	%ebp, %esp
	popl	%ebp
	ret
	.size	Timer_value, .-Timer_value
	.p2align 4,,15
.globl Timer_lastValue
	.type	Timer_lastValue, @function
Timer_lastValue:
	pushl	%ebp
	movl	%esp, %ebp
	subl	$8, %esp
	movl	8(%ebp), %eax
	movl	12(%ebp), %ecx
	movl	%esi, (%esp)
	movl	%edi, 4(%esp)
	sall	$4, %ecx
	addl	8(%eax), %ecx
	movl	$1000000, %eax
	movl	4(%ecx), %esi
	imull	(%ecx)
	movl	%esi, %edi
	sarl	$31, %edi
	addl	%esi, %eax
	movl	(%esp), %esi
	adcl	%edi, %edx
	movl	4(%esp), %edi
	movl	%ebp, %esp
	popl	%ebp
	ret
	.size	Timer_lastValue, .-Timer_lastValue
	.p2align 4,,15
.globl Timer_start
	.type	Timer_start, @function
Timer_start:
	pushl	%ebp
	movl	%esp, %ebp
	subl	$136, %esp
	movl	8(%ebp), %eax
	movl	%ebx, -12(%ebp)
	movl	12(%ebp), %edx
	call	__i686.get_pc_thunk.bx
	addl	$_GLOBAL_OFFSET_TABLE_, %ebx
	movl	%esi, -8(%ebp)
	movl	%edi, -4(%ebp)
	movl	8(%eax), %edi
	leal	-96(%ebp), %eax
	leal	(%edx,%edx), %ecx
	movl	%ecx, -108(%ebp)
	movl	%eax, 4(%esp)
	leal	8(%edi,%ecx,8), %esi
	movl	$0, (%esp)
	call	getrusage@PLT
	movl	-96(%ebp), %eax
	movl	-92(%ebp), %edx
	movl	-108(%ebp), %ecx
	movl	%eax, (%edi,%ecx,8)
	movl	$1000000, %eax
	movl	%edx, 4(%edi,%ecx,8)
	movl	-12(%ebp), %ebx
	imull	(%esi)
	movl	4(%esi), %esi
	movl	%esi, %edi
	sarl	$31, %edi
	addl	%esi, %eax
	movl	-8(%ebp), %esi
	adcl	%edi, %edx
	movl	-4(%ebp), %edi
	movl	%ebp, %esp
	popl	%ebp
	ret
	.size	Timer_start, .-Timer_start
	.p2align 4,,15
.globl Timer_stop
	.type	Timer_stop, @function
Timer_stop:
	pushl	%ebp
	movl	%esp, %ebp
	subl	$120, %esp
	movl	8(%ebp), %eax
	movl	12(%ebp), %edx
	movl	%ebx, -12(%ebp)
	call	__i686.get_pc_thunk.bx
	addl	$_GLOBAL_OFFSET_TABLE_, %ebx
	movl	%esi, -8(%ebp)
	movl	%edi, -4(%ebp)
	movl	8(%eax), %eax
	movl	%edx, %esi
	sall	$4, %esi
	leal	1(%edx,%edx), %edx
	movl	$0, (%esp)
	leal	(%eax,%edx,8), %edi
	leal	(%eax,%esi), %esi
	leal	-96(%ebp), %eax
	movl	%eax, 4(%esp)
	call	getrusage@PLT
	movl	-92(%ebp), %edx
	movl	-96(%ebp), %eax
	subl	(%esi), %eax
	subl	4(%esi), %edx
	movl	%eax, (%esi)
	movl	%edx, 4(%esi)
	movl	$1000000, %edx
	addl	(%edi), %eax
	movl	%eax, (%edi)
	movl	4(%esi), %ecx
	imull	%edx
	addl	4(%edi), %ecx
	movl	%ecx, 4(%edi)
	movl	%ecx, %edi
	movl	-12(%ebp), %ebx
	sarl	$31, %edi
	addl	%ecx, %eax
	movl	-8(%ebp), %esi
	adcl	%edi, %edx
	movl	-4(%ebp), %edi
	movl	%ebp, %esp
	popl	%ebp
	ret
	.size	Timer_stop, .-Timer_stop
	.p2align 4,,15
.globl Timer_reset
	.type	Timer_reset, @function
Timer_reset:
	pushl	%ebp
	movl	%esp, %ebp
	movl	8(%ebp), %eax
	movl	12(%ebp), %ecx
	movl	8(%eax), %eax
	movl	%ecx, %edx
	sall	$4, %edx
	leal	1(%ecx,%ecx), %ecx
	leal	(%eax,%edx), %edx
	leal	(%eax,%ecx,8), %eax
	movl	$0, 4(%edx)
	movl	$0, (%edx)
	movl	$0, 4(%eax)
	movl	$0, (%eax)
	popl	%ebp
	ret
	.size	Timer_reset, .-Timer_reset
	.p2align 4,,15
.globl Timer_resetAll
	.type	Timer_resetAll, @function
Timer_resetAll:
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%edi
	pushl	%esi
	pushl	%ebx
	subl	$28, %esp
	movl	8(%ebp), %edi
	call	__i686.get_pc_thunk.bx
	addl	$_GLOBAL_OFFSET_TABLE_, %ebx
	movl	4(%edi), %eax
	testl	%eax, %eax
	jle	.L12
	xorl	%esi, %esi
	.p2align 4,,7
	.p2align 3
.L14:
	movl	%esi, 4(%esp)
	addl	$1, %esi
	movl	%edi, (%esp)
	call	Timer_reset@PLT
	cmpl	%esi, 4(%edi)
	jg	.L14
.L12:
	addl	$28, %esp
	popl	%ebx
	popl	%esi
	popl	%edi
	popl	%ebp
	ret
	.size	Timer_resetAll, .-Timer_resetAll
	.section	.rodata.str1.1,"aMS",@progbits,1
.LC0:
	.string	"PFA_TRACE"
.LC1:
	.string	"%d"
.LC2:
	.string	"MAXLIVE_TRACE"
.LC3:
	.string	"PFA_TIMER"
.LC4:
	.string	"PFA_STATS"
.LC5:
	.string	"FORCE_SUPERGROW"
.LC6:
	.string	"*** FORCE_SUPERGROW=%d\n"
.LC7:
	.string	"FORCE_REUSELIMIT"
.LC8:
	.string	"*** FORCE_REUSELIMIT=%d\n"
	.text
	.p2align 4,,15
.globl PFA_INIT
	.type	PFA_INIT, @function
PFA_INIT:
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%edi
	pushl	%esi
	pushl	%ebx
	call	__i686.get_pc_thunk.bx
	addl	$_GLOBAL_OFFSET_TABLE_, %ebx
	subl	$44, %esp
	movl	PFA_Initialized@GOTOFF(%ebx), %eax
	leal	1(%eax), %edx
	testl	%eax, %eax
	movl	%edx, PFA_Initialized@GOTOFF(%ebx)
	je	.L28
	addl	$44, %esp
	popl	%ebx
	popl	%esi
	popl	%edi
	popl	%ebp
	ret
	.p2align 4,,7
	.p2align 3
.L28:
	leal	.LC0@GOTOFF(%ebx), %esi
	movl	%esi, (%esp)
	call	getenv@PLT
	testl	%eax, %eax
	je	.L18
	movl	$0, -28(%ebp)
	movl	%esi, (%esp)
	call	getenv@PLT
	leal	-28(%ebp), %edx
	movl	%edx, 8(%esp)
	leal	.LC1@GOTOFF(%ebx), %edx
	movl	%edx, 4(%esp)
	movl	%eax, (%esp)
	call	__isoc99_sscanf@PLT
	movl	-28(%ebp), %eax
	cmpl	$1, %eax
	je	.L29
	cmpl	$2, %eax
	jne	.L18
	movl	stderr@GOT(%ebx), %eax
	movl	(%eax), %edx
	movl	PFA_TRACE@GOT(%ebx), %eax
	movl	%edx, (%eax)
	.p2align 4,,7
	.p2align 3
.L18:
	leal	.LC2@GOTOFF(%ebx), %esi
	movl	%esi, (%esp)
	call	getenv@PLT
	testl	%eax, %eax
	je	.L20
	movl	$0, -28(%ebp)
	movl	%esi, (%esp)
	call	getenv@PLT
	leal	-28(%ebp), %edx
	movl	%edx, 8(%esp)
	leal	.LC1@GOTOFF(%ebx), %edx
	movl	%edx, 4(%esp)
	movl	%eax, (%esp)
	call	__isoc99_sscanf@PLT
	movl	-28(%ebp), %eax
	cmpl	$1, %eax
	je	.L30
	cmpl	$2, %eax
	jne	.L20
	movl	stderr@GOT(%ebx), %eax
	movl	(%eax), %edx
	movl	MAXLIVE_TRACE@GOT(%ebx), %eax
	movl	%edx, (%eax)
	.p2align 4,,7
	.p2align 3
.L20:
	leal	.LC3@GOTOFF(%ebx), %esi
	movl	%esi, (%esp)
	call	getenv@PLT
	testl	%eax, %eax
	je	.L22
	movl	$0, -28(%ebp)
	movl	%esi, (%esp)
	call	getenv@PLT
	leal	-28(%ebp), %edx
	movl	%edx, 8(%esp)
	leal	.LC1@GOTOFF(%ebx), %edx
	movl	%edx, 4(%esp)
	movl	%eax, (%esp)
	call	__isoc99_sscanf@PLT
	movl	-28(%ebp), %eax
	cmpl	$1, %eax
	je	.L31
	cmpl	$2, %eax
	jne	.L22
	movl	stderr@GOT(%ebx), %eax
	movl	(%eax), %edx
	movl	PFA_TIMER@GOT(%ebx), %eax
	movl	%edx, (%eax)
	.p2align 4,,7
	.p2align 3
.L22:
	leal	.LC4@GOTOFF(%ebx), %esi
	movl	%esi, (%esp)
	call	getenv@PLT
	testl	%eax, %eax
	je	.L24
	movl	$0, -28(%ebp)
	movl	%esi, (%esp)
	call	getenv@PLT
	leal	-28(%ebp), %edx
	movl	%edx, 8(%esp)
	leal	.LC1@GOTOFF(%ebx), %edx
	movl	%edx, 4(%esp)
	movl	%eax, (%esp)
	call	__isoc99_sscanf@PLT
	movl	-28(%ebp), %eax
	cmpl	$1, %eax
	je	.L32
	cmpl	$2, %eax
	jne	.L24
	movl	stderr@GOT(%ebx), %eax
	movl	(%eax), %edx
	movl	PFA_STATS@GOT(%ebx), %eax
	movl	%edx, (%eax)
	.p2align 4,,7
	.p2align 3
.L24:
	movl	FORCE_SUPERGROW@GOT(%ebx), %esi
	leal	.LC5@GOTOFF(%ebx), %edi
	movl	$2, (%esi)
	movl	%edi, (%esp)
	call	getenv@PLT
	testl	%eax, %eax
	je	.L26
	movl	%edi, (%esp)
	call	getenv@PLT
	leal	.LC1@GOTOFF(%ebx), %edx
	movl	%esi, 8(%esp)
	movl	%edx, 4(%esp)
	movl	%eax, (%esp)
	call	__isoc99_sscanf@PLT
	movl	(%esi), %eax
	movl	%eax, 8(%esp)
	leal	.LC6@GOTOFF(%ebx), %eax
	movl	%eax, 4(%esp)
	movl	stderr@GOT(%ebx), %eax
	movl	(%eax), %eax
	movl	%eax, (%esp)
	call	fprintf@PLT
.L26:
	movl	FORCE_REUSELIMIT@GOT(%ebx), %esi
	leal	.LC7@GOTOFF(%ebx), %edi
	movl	$0, (%esi)
	movl	%edi, (%esp)
	call	getenv@PLT
	testl	%eax, %eax
	je	.L27
	movl	%edi, (%esp)
	call	getenv@PLT
	leal	.LC1@GOTOFF(%ebx), %edx
	movl	%esi, 8(%esp)
	movl	%edx, 4(%esp)
	movl	%eax, (%esp)
	call	__isoc99_sscanf@PLT
	movl	(%esi), %eax
	movl	%eax, 8(%esp)
	leal	.LC8@GOTOFF(%ebx), %eax
	movl	%eax, 4(%esp)
	movl	stderr@GOT(%ebx), %eax
	movl	(%eax), %eax
	movl	%eax, (%esp)
	call	fprintf@PLT
.L27:
	call	CCL_INIT@PLT
	call	MDS_INIT@PLT
	.p2align 4,,5
	call	AIR_INIT@PLT
	.p2align 4,,5
	call	LIR_INIT@PLT
	.p2align 4,,5
	call	SSAConstruct_INIT@PLT
	.p2align 4,,5
	call	LiveCheck_INIT@PLT
	.p2align 4,,5
	call	Coalescer_INIT@PLT
	addl	$44, %esp
	popl	%ebx
	popl	%esi
	popl	%edi
	popl	%ebp
	ret
	.p2align 4,,7
	.p2align 3
.L30:
	movl	stdout@GOT(%ebx), %eax
	movl	(%eax), %edx
	movl	MAXLIVE_TRACE@GOT(%ebx), %eax
	movl	%edx, (%eax)
	jmp	.L20
	.p2align 4,,7
	.p2align 3
.L29:
	movl	stdout@GOT(%ebx), %eax
	movl	(%eax), %edx
	movl	PFA_TRACE@GOT(%ebx), %eax
	movl	%edx, (%eax)
	jmp	.L18
	.p2align 4,,7
	.p2align 3
.L32:
	movl	stdout@GOT(%ebx), %eax
	movl	(%eax), %edx
	movl	PFA_STATS@GOT(%ebx), %eax
	movl	%edx, (%eax)
	jmp	.L24
	.p2align 4,,7
	.p2align 3
.L31:
	movl	stdout@GOT(%ebx), %eax
	movl	(%eax), %edx
	movl	PFA_TIMER@GOT(%ebx), %eax
	movl	%edx, (%eax)
	jmp	.L22
	.size	PFA_INIT, .-PFA_INIT
	.p2align 4,,15
.globl PFA_FINI
	.type	PFA_FINI, @function
PFA_FINI:
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%ebx
	call	__i686.get_pc_thunk.bx
	addl	$_GLOBAL_OFFSET_TABLE_, %ebx
	subl	$4, %esp
	movl	PFA_Initialized@GOTOFF(%ebx), %eax
	subl	$1, %eax
	testl	%eax, %eax
	movl	%eax, PFA_Initialized@GOTOFF(%ebx)
	jne	.L33
	call	LiveCheck_FINI@PLT
	call	LIR_FINI@PLT
	.p2align 4,,5
	call	AIR_FINI@PLT
	.p2align 4,,5
	call	MDS_FINI@PLT
	.p2align 4,,5
	call	CCL_FINI@PLT
.L33:
	addl	$4, %esp
	popl	%ebx
	popl	%ebp
	ret
	.size	PFA_FINI, .-PFA_FINI
	.p2align 4,,15
.globl PFA_Test
	.type	PFA_Test, @function
PFA_Test:
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%ebx
	call	__i686.get_pc_thunk.bx
	addl	$_GLOBAL_OFFSET_TABLE_, %ebx
	subl	$4, %esp
	call	PFA_INIT@PLT
	call	*8(%ebp)
	call	PFA_FINI@PLT
	addl	$4, %esp
	popl	%ebx
	popl	%ebp
	.p2align 4,,2
	ret
	.size	PFA_Test, .-PFA_Test
.globl PFA_TRACE
	.bss
	.align 4
	.type	PFA_TRACE, @object
	.size	PFA_TRACE, 4
PFA_TRACE:
	.zero	4
.globl MAXLIVE_TRACE
	.align 4
	.type	MAXLIVE_TRACE, @object
	.size	MAXLIVE_TRACE, 4
MAXLIVE_TRACE:
	.zero	4
.globl PFA_TIMER
	.align 4
	.type	PFA_TIMER, @object
	.size	PFA_TIMER, 4
PFA_TIMER:
	.zero	4
.globl PFA_STATS
	.align 4
	.type	PFA_STATS, @object
	.size	PFA_STATS, 4
PFA_STATS:
	.zero	4
	.comm	escape,4,4
	.comm	FORCE_SUPERGROW,4,4
	.comm	FORCE_REUSELIMIT,4,4
	.local	PFA_Initialized
	.comm	PFA_Initialized,4,4
	.section	.text.__i686.get_pc_thunk.bx,"axG",@progbits,__i686.get_pc_thunk.bx,comdat
.globl __i686.get_pc_thunk.bx
	.hidden	__i686.get_pc_thunk.bx
	.type	__i686.get_pc_thunk.bx, @function
__i686.get_pc_thunk.bx:
	movl	(%esp), %ebx
	ret
	.ident	"GCC: (SUSE Linux) 4.5.1 20101208 [gcc-4_5-branch revision 167585]"
	.section	.comment.SUSE.OPTs,"MS",@progbits,1
	.string	"OspWg"
	.section	.note.GNU-stack,"",@progbits
