#ifndef Interference__c_INCLUDED
#define Interference__c_INCLUDED

#line 155 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Interference.xcc"
//
{
  printf("sizeof(Interference_) = %d\n", sizeof(Interference_));
}

#line 302 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/Interference.xcc"
//
{
  Symbol_ symbol_;
  Program program = Program_new(Memory_Root);
  Procedure procedure = Program_makeProcedure(program, &symbol_);
  Memory memory = Procedure_memory(procedure);
  BasicBlock block_1 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  Procedure_buildCodeRegions(procedure);
  {
    CodeRegion codeRegion = Procedure_findCodeRegion(procedure, 0);
    TemporaryTable globalTable = CodeRegion_globalTable(codeRegion);
    // For testing purposes 8 variables will be created and few interferences will be
    // added among them. Output should give symetrical matrix that will contain these
    // interferencies.
    Temporary temporary_1 = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_2 = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_3 = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_4 = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_5 = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_6 = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_7 = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_8 = Procedure_makeVirtualTemporary(procedure, 0);
    TemporaryTable_empty(globalTable);
    TemporaryTable_insert(globalTable, temporary_1);
    TemporaryTable_insert(globalTable, temporary_2);
    TemporaryTable_insert(globalTable, temporary_3);
    TemporaryTable_insert(globalTable, temporary_4);
    TemporaryTable_insert(globalTable, temporary_5);
    TemporaryTable_insert(globalTable, temporary_6);
    TemporaryTable_insert(globalTable, temporary_7);
    TemporaryTable_insert(globalTable, temporary_8);
    {
      Interference_ interference[1];
      Liveness liveness = Liveness_make(memory, codeRegion, globalTable, true);
      Interference_Ctor(interference, memory, codeRegion, liveness, true);
      Interference_add(interference, temporary_1, temporary_4);
      Interference_add(interference, temporary_2, temporary_8);
      Interference_add(interference, temporary_3, temporary_6);
      Interference_add(interference, temporary_4, temporary_7);
      Interference_add(interference, temporary_5, temporary_2);
      Interference_add(interference, temporary_6, temporary_5);
      printf("Interference test:\n");
      Interference_pretty(interference, stdout);
      Interference_Dtor(interference);
      Liveness_kill(liveness);
    }
  }
  Program_delete(program);
}


#endif//Interference__c_INCLUDED
