#ifndef SSAForm__c_INCLUDED
#define SSAForm__c_INCLUDED

#line 72 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/SSAForm.xcc"
//
{
  printf("sizeof(SSAForm_) = %d\n", sizeof(SSAForm_));
}

#line 1137 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/SSAForm.xcc"
//
{
  // Test of SSAForm_display.
  Program program = Program_new(Memory_Root);
  Memory memory = Program_memory(program);
  SymbolTable symbolTable = Program_symbolTable(program);
  Symbol symbol = SymbolTable_lookup(symbolTable, 1, "lost-copy");
  Procedure procedure = Program_makeProcedure(program, symbol);
  LabelTable labelTable = Program_labelTable(program);
  Label L1 = LabelTable_lookup(labelTable, 1, "L1");
  Label L2 = LabelTable_lookup(labelTable, 2, "L2");
  Label L3 = LabelTable_lookup(labelTable, 3, "L3");
  BasicBlock block_l1 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l2 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l3 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock_addLabels(block_l1, 1, &L1);
  BasicBlock_addLabels(block_l2, 1, &L2);
  BasicBlock_addLabels(block_l3, 1, &L3);
  BasicBlock_makeEdge(block_l1, block_l2, 0.0);
  BasicBlock_makeEdge(block_l2, block_l2, 0.0);
  BasicBlock_makeEdge(block_l2, block_l3, 0.0);
  Procedure_buildCodeRegions(procedure);
  {
    CodeRegion codeRegion = Procedure_findCodeRegion(procedure, 0);
    SSAForm ssaForm = SSAForm_construct(Memory_Root, codeRegion, true);
    Temporary temporary_x = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_y = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_a1 = Procedure_makeAbsoluteTemporary(procedure, 1, Relocation__UNDEF);
    Temporary temporary_a2 = Procedure_makeAbsoluteTemporary(procedure, 2, Relocation__UNDEF);
    Temporary temporary_x1 = CodeRegion_makeVariableTemporary(codeRegion, temporary_x);
    Temporary temporary_x2 = CodeRegion_makeVariableTemporary(codeRegion, temporary_x);
    Temporary temporary_y1 = CodeRegion_makeVariableTemporary(codeRegion, temporary_y);
    Temporary temporary_y2 = CodeRegion_makeVariableTemporary(codeRegion, temporary_y);
    Temporary temporary_y3 = CodeRegion_makeVariableTemporary(codeRegion, temporary_y);
    Temporary temporary_y4 = CodeRegion_makeVariableTemporary(codeRegion, temporary_y);
    TemporarySet set1 = TemporarySet_make(memory, 6);
    TemporarySet set2 = TemporarySet_make(memory, 3);
    Operation phiOperation_x = BasicBlock_makeOperationPHI(block_l2, NULL);
    Operation phiOperation_y = BasicBlock_makeOperationPHI(block_l2, NULL);
    Variable_setOperationResult(Temporary_VARIABLE(temporary_x2), phiOperation_x, 0);
    Variable_setOperationArgument(Temporary_VARIABLE(temporary_x1), phiOperation_x, 0);
    Variable_setOperationArgument(Temporary_VARIABLE(temporary_y2), phiOperation_x, 1);
    Variable_setOperationResult(Temporary_VARIABLE(temporary_y2), phiOperation_y, 0);
    Variable_setOperationArgument(Temporary_VARIABLE(temporary_y1), phiOperation_y, 0);
    Variable_setOperationArgument(Temporary_VARIABLE(temporary_x2), phiOperation_y, 1);
    TemporarySet_insert(set1, temporary_x1);
    TemporarySet_insert(set1, temporary_x2);
    TemporarySet_insert(set1, temporary_y1);
    TemporarySet_insert(set1, temporary_y2);
    TemporarySet_insert(set1, temporary_y3);
    TemporarySet_insert(set1, temporary_y4);
    TemporarySet_insert(set2, temporary_x2);
    TemporarySet_insert(set2, temporary_y1);
    TemporarySet_insert(set2, temporary_y2);
    CodeRegion_setLiveSets(codeRegion, 1, set1, set2, NULL, NULL);
    Selector_makeOperation_1_1(BasicBlock_selector(block_l1),
                               Operator_APPLY, temporary_x1, temporary_a1);
    Selector_makeOperation_1_1(BasicBlock_selector(block_l1),
                               Operator_APPLY, temporary_y1, temporary_a2);
    SSAForm_display(ssaForm, stdout, "Swap Problem");
  }
}


#endif//SSAForm__c_INCLUDED
