#ifndef ValueNumber__c_INCLUDED
#define ValueNumber__c_INCLUDED

#line 457 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/ValueNumber.xcc"
//
{
  printf("sizeof(ValueNumber_) = %d\n", sizeof(ValueNumber_));
}

#line 722 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/PFA/ValueNumber.xcc"
//
{
  // Figure 5. from Briggs paper.
  Program program = Program_new(Memory_Root);
  Optimize optimize = Program_optimize(program);
  SymbolTable symbolTable = Program_symbolTable(program);
  Symbol symbol = SymbolTable_lookup(symbolTable, 1, "figure-1");
  Procedure procedure = Program_makeProcedure(program, symbol);
  LabelTable labelTable = Program_labelTable(program);
  Label L1 = LabelTable_lookup(labelTable, 1, "L1");
  Label L2 = LabelTable_lookup(labelTable, 2, "L2");
  Label L3 = LabelTable_lookup(labelTable, 3, "L3");
  Label L4 = LabelTable_lookup(labelTable, 4, "L4");
  BasicBlock block_l1 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l2 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l3 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock block_l4 = Procedure_makeBasicBlock(procedure, 0, 0, 0.0);
  BasicBlock_addLabels(block_l1, 1, &L1);
  BasicBlock_addLabels(block_l2, 1, &L2);
  BasicBlock_addLabels(block_l3, 1, &L3);
  BasicBlock_addLabels(block_l4, 1, &L4);
  BasicBlock_makeEdge(block_l1, block_l2, 0.0);
  BasicBlock_makeEdge(block_l1, block_l3, 0.0);
  BasicBlock_makeEdge(block_l2, block_l4, 0.0);
  BasicBlock_makeEdge(block_l3, block_l4, 0.0);
  //*Optimize__CONVERSION(optimize) = OptimizeConversion_Numbering;
  Procedure_buildCodeRegions(procedure); 
  printf("\nFigure 5 in Briggs' paper:\n");
  {
    CodeRegion codeRegion = Procedure_findCodeRegion(procedure, 0);
    Temporary temporary_x = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_y = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_z = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_a = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_b = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_c = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_d = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_e = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_f = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_u = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_v = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_w = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_a1 = Procedure_makeAbsoluteTemporary(procedure, 1, Relocation__UNDEF);
    // B1 operations...
  //  Selector_makeOperation_1_1(BasicBlock_selector(block_l1),
  //                             Operator_APPLY, temporary_a, temporary_a1);
    Selector_makeOperation_1_2(BasicBlock_selector(block_l1),
                               Operator_ADD, temporary_u, temporary_a, temporary_b);
    Selector_makeOperation_1_2(BasicBlock_selector(block_l1),
                               Operator_ADD, temporary_v, temporary_c, temporary_d);
    Selector_makeOperation_1_2(BasicBlock_selector(block_l1),
                               Operator_ADD, temporary_w, temporary_e, temporary_f);
    // B2 operations...
    Selector_makeOperation_1_2(BasicBlock_selector(block_l2),
                               Operator_ADD, temporary_x, temporary_c, temporary_d);
    Selector_makeOperation_1_2(BasicBlock_selector(block_l2),
                               Operator_ADD, temporary_y, temporary_c, temporary_d);
    // B3 operations...
    Selector_makeOperation_1_2(BasicBlock_selector(block_l3),
                               Operator_ADD, temporary_u, temporary_a, temporary_b);
    Selector_makeOperation_1_2(BasicBlock_selector(block_l3),
                               Operator_ADD, temporary_x, temporary_e, temporary_f);
    Selector_makeOperation_1_2(BasicBlock_selector(block_l3),
                               Operator_ADD, temporary_y, temporary_e, temporary_f);
    // B4 operations...
    Selector_makeOperation_1_2(BasicBlock_selector(block_l4),
                               Operator_ADD, temporary_z, temporary_u, temporary_y);
    Selector_makeOperation_1_2(BasicBlock_selector(block_l4),
                               Operator_ADD, temporary_u, temporary_a, temporary_b);
    {
      SSAForm ssaForm = SSAForm_construct(Memory_Root, codeRegion, true);
      printf("\nCode after performing Value Numbering:\n\n");
      CodeRegion_pretty(codeRegion, stdout);
      SSAForm_destruct(ssaForm);
    }
  }
}


#endif//ValueNumber__c_INCLUDED
