	.file	"Spill.c"
	.text
	.p2align 4,,15
.globl Spill_initCodeRegion
	.type	Spill_initCodeRegion, @function
Spill_initCodeRegion:
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%ebx
	call	__i686.get_pc_thunk.bx
	addl	$_GLOBAL_OFFSET_TABLE_, %ebx
	subl	$20, %esp
	movl	8(%ebp), %eax
	movl	%eax, (%esp)
	movl	%eax, spill_coderegion@GOTOFF(%ebx)
	call	CodeRegion_procedure@PLT
	movl	%eax, (%esp)
	call	Procedure_memory@PLT
	movl	$1024, 8(%esp)
	movl	%eax, 4(%esp)
	leal	spill_table_@GOTOFF(%ebx), %eax
	movl	%eax, (%esp)
	call	HTable_Ctor@PLT
	addl	$20, %esp
	popl	%ebx
	popl	%ebp
	ret
	.size	Spill_initCodeRegion, .-Spill_initCodeRegion
	.p2align 4,,15
.globl Spill_finiCodeRegion
	.type	Spill_finiCodeRegion, @function
Spill_finiCodeRegion:
	pushl	%ebp
	movl	%esp, %ebp
	popl	%ebp
	ret
	.size	Spill_finiCodeRegion, .-Spill_finiCodeRegion
	.section	.rodata.str1.1,"aMS",@progbits,1
.LC0:
	.string	".lao_spill_temp_%u"
	.text
	.p2align 4,,15
.globl Spill_genStackedLocation
	.type	Spill_genStackedLocation, @function
Spill_genStackedLocation:
	pushl	%ebp
	movl	%esp, %ebp
	subl	$72, %esp
	movl	%ebx, -12(%ebp)
	call	__i686.get_pc_thunk.bx
	addl	$_GLOBAL_OFFSET_TABLE_, %ebx
	movl	%edi, -4(%ebp)
	movl	%esi, -8(%ebp)
	movl	spill_coderegion@GOTOFF(%ebx), %eax
	movl	%eax, (%esp)
	call	CodeRegion_procedure@PLT
	movl	%eax, %edi
	movl	%eax, (%esp)
	call	Procedure_program@PLT
	leal	spill_table_@GOTOFF(%ebx), %edx
	movl	%edx, -28(%ebp)
	movl	%edx, (%esp)
	movl	%eax, -32(%ebp)
	movl	8(%ebp), %eax
	movl	%eax, 4(%esp)
	call	HTable_search@PLT
	testl	%eax, %eax
	je	.L4
	movl	(%eax), %esi
	testl	%esi, %esi
	je	.L4
.L5:
	movl	%esi, 4(%esp)
	movl	%edi, (%esp)
	movl	$0, 16(%esp)
	movl	$0, 8(%esp)
	movl	$0, 12(%esp)
	call	Procedure_makeSymbolTemporary@PLT
	movl	-12(%ebp), %ebx
	movl	-8(%ebp), %esi
	movl	-4(%ebp), %edi
	movl	%ebp, %esp
	popl	%ebp
	ret
	.p2align 4,,7
	.p2align 3
.L4:
	movl	spill_temp.11446@GOTOFF(%ebx), %edx
	leal	buffer.11447@GOTOFF(%ebx), %esi
	movl	%esi, (%esp)
	leal	1(%edx), %eax
	movl	%eax, spill_temp.11446@GOTOFF(%ebx)
	leal	.LC0@GOTOFF(%ebx), %eax
	movl	%edx, 8(%esp)
	movl	%eax, 4(%esp)
	call	sprintf@PLT
	movl	-32(%ebp), %eax
	movl	%eax, (%esp)
	call	Program_symbolTable@PLT
	movl	%esi, 4(%esp)
	movl	%eax, (%esp)
	call	SymbolTable_makeSymbol@PLT
	movb	$1, 28(%eax)
	movl	%eax, %esi
	movb	$1, 29(%eax)
	movb	$1, 30(%eax)
	movl	8(%ebp), %edx
	movzbl	14(%edx), %eax
	movl	%eax, (%esp)
	call	Register_regFile@PLT
	movzbl	%al, %eax
	movl	%eax, (%esp)
	call	RegFile_getNativeType@PLT
	movb	%al, 52(%esi)
	movzbl	%al, %eax
	movl	%eax, (%esp)
	call	NativeType_sizeOf@PLT
	movl	8+spill_table_@GOTOFF(%ebx), %edx
	movl	$0, 36(%esi)
	movl	%eax, 32(%esi)
	movl	8(%ebp), %eax
	movl	%edx, -36(%ebp)
	movl	$4, 8(%esp)
	movl	%eax, 4(%esp)
	movl	-28(%ebp), %eax
	movl	%eax, (%esp)
	call	HTable_lookup_@PLT
	movl	-36(%ebp), %edx
	cmpl	8+spill_table_@GOTOFF(%ebx), %edx
	je	.L6
	movl	$0, (%eax)
.L6:
	movl	%esi, (%eax)
	jmp	.L5
	.size	Spill_genStackedLocation, .-Spill_genStackedLocation
	.p2align 4,,15
.globl Spill_getRematerializeValue
	.type	Spill_getRematerializeValue, @function
Spill_getRematerializeValue:
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%ebx
	call	__i686.get_pc_thunk.bx
	addl	$_GLOBAL_OFFSET_TABLE_, %ebx
	subl	$20, %esp
	movl	spill_coderegion@GOTOFF(%ebx), %eax
	movl	%eax, (%esp)
	call	CodeRegion_procedure@PLT
	movl	8(%ebp), %edx
	movl	%edx, 4(%esp)
	movl	%eax, (%esp)
	call	Procedure_getRemater@PLT
	addl	$20, %esp
	popl	%ebx
	popl	%ebp
	ret
	.size	Spill_getRematerializeValue, .-Spill_getRematerializeValue
	.p2align 4,,15
.globl Spill_getHomeLocation
	.type	Spill_getHomeLocation, @function
Spill_getHomeLocation:
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%ebx
	call	__i686.get_pc_thunk.bx
	addl	$_GLOBAL_OFFSET_TABLE_, %ebx
	subl	$20, %esp
	movl	spill_coderegion@GOTOFF(%ebx), %eax
	movl	%eax, (%esp)
	call	CodeRegion_procedure@PLT
	movl	8(%ebp), %edx
	movl	%edx, 4(%esp)
	movl	%eax, (%esp)
	call	Procedure_getHomeable@PLT
	addl	$20, %esp
	popl	%ebx
	popl	%ebp
	ret
	.size	Spill_getHomeLocation, .-Spill_getHomeLocation
	.p2align 4,,15
.globl Spill_findFirstAppendPoint
	.type	Spill_findFirstAppendPoint, @function
Spill_findFirstAppendPoint:
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%edi
	pushl	%esi
	subl	$16, %esp
	movl	8(%ebp), %edx
	movl	12(%ebp), %eax
	movb	$1, -9(%ebp)
	movl	12(%edx), %ecx
	movl	%ecx, -16(%ebp)
	movl	-16(%ebp), %edi
	xorl	%ecx, %ecx
	testl	%edi, %edi
	je	.L11
	movl	-16(%ebp), %esi
	cmpw	$12, 20(%esi)
	je	.L31
	jmp	.L11
	.p2align 4,,7
	.p2align 3
.L44:
	cmpw	$12, 20(%esi)
	jne	.L30
.L31:
	movl	%esi, %ecx
	movl	-8(%esi), %esi
	testl	%esi, %esi
	jne	.L44
.L30:
	movb	$0, -9(%ebp)
.L11:
	testb	$1, 98(%edx)
	je	.L13
	movl	-16(%ebp), %esi
	testl	%esi, %esi
	je	.L13
	movl	-16(%ebp), %esi
	testb	$64, 23(%esi)
	movl	-8(%esi), %edx
	jne	.L36
	jmp	.L13
	.p2align 4,,7
	.p2align 3
.L17:
	testb	$64, 23(%esi)
	movl	-8(%edx), %edx
	je	.L40
.L36:
	testl	%edx, %edx
	movl	%edx, %esi
	jne	.L17
.L13:
	cmpb	$0, -9(%ebp)
	je	.L45
.L18:
	addl	$16, %esp
	popl	%esi
	popl	%edi
	popl	%ebp
	ret
.L45:
	movl	-16(%ebp), %edx
	testl	%edx, %edx
	je	.L18
	xorl	%esi, %esi
	movl	$1, %edi
.L27:
	movl	%eax, -20(%ebp)
	movl	-16(%ebp), %edx
	movl	%edi, %eax
	movl	%ecx, -24(%ebp)
	jmp	.L23
	.p2align 4,,7
	.p2align 3
.L48:
	cmpl	%edx, %esi
	movzbl	-9(%ebp), %edi
	je	.L46
.L41:
	testb	%al, %al
	jne	.L42
.L35:
	movl	-8(%edx), %edx
	testl	%edx, %edx
	je	.L47
.L23:
	cmpl	%edx, -24(%ebp)
	jne	.L48
	cmpl	%edx, %esi
	movl	$1, %edi
	movb	$1, -9(%ebp)
	jne	.L41
	.p2align 4,,7
	.p2align 3
.L46:
	movl	$1, %eax
.L42:
	movl	%edi, %ecx
	testb	%cl, %cl
	je	.L35
	testl	%edx, %edx
	movl	-20(%ebp), %eax
	je	.L18
	testl	%eax, %eax
	sete	%cl
	movl	%ecx, %esi
	movl	-16(%ebp), %ecx
	jmp	.L26
	.p2align 4,,7
	.p2align 3
.L24:
	cmpl	%edx, %ecx
	je	.L25
.L49:
	movl	-8(%ecx), %ecx
	testl	%ecx, %ecx
	je	.L25
.L26:
	cmpl	%eax, %ecx
	.p2align 4,,2
	jne	.L24
	cmpl	%edx, %ecx
	movl	$1, %esi
	jne	.L49
	.p2align 4,,7
	.p2align 3
.L25:
	movl	%esi, %edx
	testb	%dl, %dl
	je	.L18
	addl	$16, %esp
	movl	%ecx, %eax
	popl	%esi
	popl	%edi
	popl	%ebp
	ret
	.p2align 4,,7
	.p2align 3
.L47:
	movl	-20(%ebp), %eax
	addl	$16, %esp
	popl	%esi
	popl	%edi
	popl	%ebp
	ret
	.p2align 4,,7
	.p2align 3
.L40:
	xorl	%edi, %edi
	jmp	.L27
	.size	Spill_findFirstAppendPoint, .-Spill_findFirstAppendPoint
	.p2align 4,,15
.globl Spill_findLastInsertPoint
	.type	Spill_findLastInsertPoint, @function
Spill_findLastInsertPoint:
	pushl	%ebp
	movl	$1, %ecx
	movl	%esp, %ebp
	pushl	%edi
	pushl	%esi
	pushl	%ebx
	subl	$60, %esp
	movl	8(%ebp), %eax
	call	__i686.get_pc_thunk.bx
	addl	$_GLOBAL_OFFSET_TABLE_, %ebx
	movl	12(%ebp), %esi
	movl	16(%eax), %edi
	testl	%edi, %edi
	je	.L51
	movzwl	20(%edi), %eax
	movl	%eax, (%esp)
	call	Operator_attributes@PLT
	shrw	$3, %ax
	andl	$1, %eax
	cmpl	$1, %eax
	sbbl	%ecx, %ecx
	negl	%eax
	andl	$1, %ecx
	andl	%eax, %edi
.L51:
	movl	8(%ebp), %edx
	testb	$2, 98(%edx)
	je	.L52
	movl	16(%edx), %eax
	testl	%eax, %eax
	movl	%eax, -32(%ebp)
	je	.L52
	movl	%eax, %edx
	movl	-4(%eax), %eax
	testb	$-128, 23(%edx)
	jne	.L73
	jmp	.L52
	.p2align 4,,7
	.p2align 3
.L56:
	testb	$-128, 23(%edx)
	movl	-4(%eax), %eax
	je	.L77
.L73:
	testl	%eax, %eax
	movl	%eax, %edx
	jne	.L56
.L52:
	testb	$1, %cl
	je	.L81
.L57:
	addl	$60, %esp
	movl	%esi, %eax
	popl	%ebx
	popl	%esi
	popl	%edi
	popl	%ebp
	ret
	.p2align 4,,7
	.p2align 3
.L77:
	movb	$0, -36(%ebp)
.L66:
	movl	%edi, -28(%ebp)
	movl	-32(%ebp), %eax
	movl	%edx, %edi
	movb	%cl, -41(%ebp)
	movzbl	-36(%ebp), %edx
	movl	%esi, -36(%ebp)
	jmp	.L62
	.p2align 4,,7
	.p2align 3
.L84:
	cmpl	%eax, %edi
	movzbl	-41(%ebp), %esi
	je	.L82
.L78:
	testb	%dl, %dl
	jne	.L79
.L72:
	movl	-4(%eax), %eax
	testl	%eax, %eax
	je	.L83
.L62:
	cmpl	%eax, -28(%ebp)
	jne	.L84
	cmpl	%eax, %edi
	movl	$1, %esi
	movb	$1, -41(%ebp)
	jne	.L78
	.p2align 4,,7
	.p2align 3
.L82:
	movl	$1, %edx
.L79:
	movl	%esi, %ecx
	testb	%cl, %cl
	je	.L72
	testl	%eax, %eax
	movl	-36(%ebp), %esi
	je	.L57
	testl	%esi, %esi
	movl	-32(%ebp), %edx
	sete	%cl
	jmp	.L65
	.p2align 4,,7
	.p2align 3
.L63:
	cmpl	%eax, %edx
	je	.L64
.L85:
	movl	-4(%edx), %edx
	testl	%edx, %edx
	je	.L64
.L65:
	cmpl	%esi, %edx
	.p2align 4,,2
	jne	.L63
	cmpl	%eax, %edx
	movl	$1, %ecx
	jne	.L85
	.p2align 4,,7
	.p2align 3
.L64:
	testb	%cl, %cl
	je	.L57
	movl	%edx, %esi
	addl	$60, %esp
	movl	%esi, %eax
	popl	%ebx
	popl	%esi
	popl	%edi
	popl	%ebp
	ret
	.p2align 4,,7
	.p2align 3
.L83:
	movl	-36(%ebp), %esi
	addl	$60, %esp
	popl	%ebx
	movl	%esi, %eax
	popl	%esi
	popl	%edi
	popl	%ebp
	ret
.L81:
	movl	8(%ebp), %eax
	movl	16(%eax), %eax
	testl	%eax, %eax
	movl	%eax, -32(%ebp)
	je	.L57
	xorl	%edx, %edx
	movb	$1, -36(%ebp)
	jmp	.L66
	.size	Spill_findLastInsertPoint, .-Spill_findLastInsertPoint
	.section	.rodata.str1.1
.LC1:
	.string	"Insert rematerialization: "
	.section	.rodata.str1.4,"aMS",@progbits,1
	.align 4
.LC2:
	.string	"Remove reload/store sequence: "
	.section	.rodata.str1.1
.LC3:
	.string	"Insert reload: "
	.text
	.p2align 4,,15
.globl Spill_insertReload
	.type	Spill_insertReload, @function
Spill_insertReload:
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%edi
	pushl	%esi
	pushl	%ebx
	subl	$108, %esp
	movl	8(%ebp), %edx
	movl	$0, 16(%esp)
	leal	-52(%ebp), %ecx
	movl	20(%ebp), %esi
	call	__i686.get_pc_thunk.bx
	addl	$_GLOBAL_OFFSET_TABLE_, %ebx
	movl	16(%ebp), %edi
	movl	%ecx, -60(%ebp)
	movzbl	28(%edx), %eax
	movl	%eax, 12(%esp)
	movl	24(%edx), %eax
	movl	%eax, 8(%esp)
	movl	8(%edx), %eax
	movl	%ecx, (%esp)
	movl	%eax, 4(%esp)
	call	Selector_Ctor@PLT
	movl	12(%ebp), %eax
	movl	%eax, 4(%esp)
	movl	8(%ebp), %eax
	movl	%eax, (%esp)
	call	Spill_findLastInsertPoint@PLT
	movl	%eax, -64(%ebp)
	movzbl	13(%esi), %eax
	testb	$16, %al
	jne	.L115
	testb	$32, %al
	jne	.L116
	movl	%esi, (%esp)
	call	Spill_genStackedLocation@PLT
	movl	%eax, %esi
.L96:
	movl	-64(%ebp), %edx
	testl	%edx, %edx
	je	.L97
	movl	-64(%ebp), %ecx
	movzwl	20(%ecx), %eax
	movl	%eax, (%esp)
	call	Operator_attributes@PLT
	testb	$32, %al
	je	.L97
	movl	-64(%ebp), %eax
	testb	$2, 22(%eax)
	jne	.L117
.L97:
	movl	24(%esi), %edx
	movl	28(%esi), %ecx
	movzbl	14(%edi), %eax
	movl	16(%esi), %esi
	movl	%edx, -76(%ebp)
	movl	%ecx, -80(%ebp)
	movl	%eax, (%esp)
	call	Register_regFile@PLT
	movzbl	%al, %eax
	movl	%eax, (%esp)
	call	RegFile_getNativeType@PLT
	movl	-80(%ebp), %ecx
	movl	-76(%ebp), %edx
	movl	%esi, 12(%esp)
	movl	%edi, 8(%esp)
	movl	%ecx, 20(%esp)
	movl	-60(%ebp), %ecx
	movl	%edx, 16(%esp)
	movzbl	%al, %eax
	movl	%eax, 4(%esp)
	movl	%ecx, (%esp)
	call	Selector_selectDirectLOAD@PLT
	movl	-48(%ebp), %esi
	testl	%esi, %esi
	jne	.L109
	jmp	.L101
	.p2align 4,,7
	.p2align 3
.L102:
	movl	-8(%esi), %esi
	testl	%esi, %esi
	je	.L101
.L109:
	movzwl	20(%esi), %eax
	movl	%eax, (%esp)
	call	Operator_attributes@PLT
	testb	$16, %al
	je	.L102
	orw	$2, 22(%esi)
.L101:
	movl	CGO_TRACE@GOT(%ebx), %edi
	movl	(%edi), %eax
	testl	%eax, %eax
	je	.L104
	movl	%eax, 12(%esp)
	leal	.LC3@GOTOFF(%ebx), %eax
	movl	$15, 8(%esp)
	movl	$1, 4(%esp)
	movl	%eax, (%esp)
	call	fwrite@PLT
	movl	-48(%ebp), %eax
	testl	%eax, %eax
	je	.L104
	.p2align 4,,7
	.p2align 3
.L108:
	movl	-8(%eax), %esi
	movl	(%edi), %edx
	movl	%eax, (%esp)
	movl	%edx, 4(%esp)
	call	Operation_pretty@PLT
	testl	%esi, %esi
	movl	%esi, %eax
	jne	.L108
.L104:
	movl	-64(%ebp), %eax
	testl	%eax, %eax
	je	.L118
	movl	-60(%ebp), %ecx
	movl	-64(%ebp), %eax
	movl	8(%ebp), %edx
	movl	%ecx, 8(%esp)
	movl	%eax, 4(%esp)
	movl	%edx, (%esp)
	call	BasicBlock_insertSelector@PLT
.L94:
	movl	-60(%ebp), %ecx
	movl	%ecx, (%esp)
	call	Selector_Dtor@PLT
.L86:
	addl	$108, %esp
	popl	%ebx
	popl	%esi
	popl	%edi
	popl	%ebp
	ret
	.p2align 4,,7
	.p2align 3
.L116:
	movl	%esi, (%esp)
	call	Spill_getHomeLocation@PLT
	movl	%eax, %esi
	jmp	.L96
	.p2align 4,,7
	.p2align 3
.L115:
	movl	%esi, (%esp)
	call	Spill_getRematerializeValue@PLT
	movzbl	12(%eax), %edx
	cmpb	$3, %dl
	je	.L119
	cmpb	$4, %dl
	jne	.L90
	movl	24(%eax), %edx
	movl	28(%eax), %ecx
	movl	16(%eax), %esi
	movzbl	14(%edi), %eax
	movl	%edx, -76(%ebp)
	movl	%ecx, -80(%ebp)
	movl	%eax, (%esp)
	call	Register_regFile@PLT
	movzbl	%al, %eax
	movl	%eax, (%esp)
	call	RegFile_getNativeType@PLT
	movl	-80(%ebp), %ecx
	movl	-76(%ebp), %edx
	movl	%esi, 12(%esp)
	movl	%edi, 8(%esp)
	movl	%ecx, 20(%esp)
	movl	-60(%ebp), %ecx
	movl	%edx, 16(%esp)
	movzbl	%al, %eax
	movl	%eax, 4(%esp)
	movl	%ecx, (%esp)
	call	Selector_selectMAKEAddress@PLT
.L89:
	movl	CGO_TRACE@GOT(%ebx), %edi
	movl	(%edi), %eax
	testl	%eax, %eax
	je	.L104
	movl	%eax, 12(%esp)
	leal	.LC1@GOTOFF(%ebx), %eax
	movl	$26, 8(%esp)
	movl	$1, 4(%esp)
	movl	%eax, (%esp)
	call	fwrite@PLT
	movl	-48(%ebp), %eax
	testl	%eax, %eax
	je	.L104
	.p2align 4,,7
	.p2align 3
.L107:
	movl	-8(%eax), %esi
	movl	(%edi), %edx
	movl	%eax, (%esp)
	movl	%edx, 4(%esp)
	call	Operation_pretty@PLT
	testl	%esi, %esi
	movl	%esi, %eax
	jne	.L107
	jmp	.L104
	.p2align 4,,7
	.p2align 3
.L118:
	movl	-60(%ebp), %eax
	movl	8(%ebp), %edx
	movl	%eax, 4(%esp)
	movl	%edx, (%esp)
	call	BasicBlock_pushSelector@PLT
	jmp	.L94
	.p2align 4,,7
	.p2align 3
.L117:
	movzwl	20(%eax), %edx
	movl	$4, 4(%esp)
	movl	%edx, (%esp)
	movl	%edx, -76(%ebp)
	call	Operator_getReadParameterKind@PLT
	movl	-76(%ebp), %edx
	movl	$5, 4(%esp)
	movl	%edx, (%esp)
	movb	%al, -68(%ebp)
	call	Operator_getReadParameterKind@PLT
	movl	%eax, %edx
	movl	-64(%ebp), %eax
	movl	40(%eax), %ecx
	movl	32(%eax), %eax
	movl	%eax, -72(%ebp)
	movsbl	-68(%ebp), %eax
	addl	-72(%ebp), %eax
	movl	(%ecx,%eax,4), %eax
	movl	%eax, -68(%ebp)
	movsbl	%dl, %eax
	addl	-72(%ebp), %eax
	cmpl	(%ecx,%eax,4), %edi
	jne	.L97
	movl	-68(%ebp), %edx
	cmpb	$4, 12(%edx)
	jne	.L97
	movl	16(%esi), %ecx
	cmpl	%ecx, 16(%edx)
	jne	.L97
	movl	28(%esi), %ecx
	cmpl	%ecx, 28(%edx)
	movl	24(%edx), %eax
	jne	.L97
	cmpl	24(%esi), %eax
	jne	.L97
	movl	CGO_TRACE@GOT(%ebx), %edi
	movl	(%edi), %eax
	testl	%eax, %eax
	je	.L99
	leal	.LC2@GOTOFF(%ebx), %edx
	movl	%edx, 4(%esp)
	movl	%eax, (%esp)
	call	fprintf@PLT
	testl	%eax, %eax
	je	.L99
	movl	(%edi), %eax
	movl	%eax, 4(%esp)
	movl	-64(%ebp), %eax
	movl	%eax, (%esp)
	call	Operation_pretty@PLT
.L99:
	movl	-64(%ebp), %edx
	movl	%edx, 4(%esp)
	movl	12(%edx), %eax
	movl	%eax, (%esp)
	call	BasicBlock_detachOperation@PLT
	jmp	.L86
	.p2align 4,,7
	.p2align 3
.L119:
	movl	24(%eax), %edx
	movl	28(%eax), %ecx
	movzbl	14(%edi), %eax
	movl	%edx, -76(%ebp)
	movl	%ecx, -80(%ebp)
	movl	%eax, (%esp)
	call	Register_regFile@PLT
	movzbl	%al, %eax
	movl	%eax, (%esp)
	call	RegFile_getNativeType@PLT
	movl	-76(%ebp), %edx
	movl	-80(%ebp), %ecx
	movl	%edi, 8(%esp)
	movl	%edx, 12(%esp)
	movl	-60(%ebp), %edx
	movl	%ecx, 16(%esp)
	movzbl	%al, %eax
	movl	%eax, 4(%esp)
	movl	%edx, (%esp)
	call	Selector_selectMAKEAbsolute@PLT
	jmp	.L89
.L90:
	call	abort@PLT
	.size	Spill_insertReload, .-Spill_insertReload
	.section	.rodata.str1.1
.LC4:
	.string	"Remove load/spill sequence: "
	.section	.rodata.str1.4
	.align 4
.LC5:
	.string	"Skip spill redundant with store: "
	.section	.rodata.str1.1
.LC6:
	.string	"Insert spill: "
	.text
	.p2align 4,,15
.globl Spill_appendSpill
	.type	Spill_appendSpill, @function
Spill_appendSpill:
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%edi
	pushl	%esi
	pushl	%ebx
	subl	$124, %esp
	movl	20(%ebp), %esi
	call	__i686.get_pc_thunk.bx
	addl	$_GLOBAL_OFFSET_TABLE_, %ebx
	movl	16(%ebp), %edi
	testb	$16, 13(%esi)
	je	.L141
.L120:
	addl	$124, %esp
	popl	%ebx
	popl	%esi
	popl	%edi
	popl	%ebp
	ret
	.p2align 4,,7
	.p2align 3
.L141:
	movl	12(%ebp), %eax
	movl	%eax, 4(%esp)
	movl	8(%ebp), %eax
	movl	%eax, (%esp)
	call	Spill_findFirstAppendPoint@PLT
	testb	$32, 13(%esi)
	movl	%eax, -60(%ebp)
	jne	.L142
	movl	%esi, (%esp)
	call	Spill_genStackedLocation@PLT
	movl	%eax, %esi
.L123:
	movl	-60(%ebp), %eax
	testl	%eax, %eax
	je	.L124
	movl	-60(%ebp), %edx
	movzwl	20(%edx), %eax
	movl	%eax, (%esp)
	call	Operator_attributes@PLT
	testb	$16, %al
	je	.L125
	movl	-60(%ebp), %ecx
	testb	$2, 22(%ecx)
	jne	.L143
.L125:
	movl	-60(%ebp), %ecx
	movl	-8(%ecx), %edx
	testl	%edx, %edx
	je	.L124
	movzwl	20(%edx), %eax
	movl	%edx, -72(%ebp)
	movl	%eax, (%esp)
	call	Operator_attributes@PLT
	movl	-72(%ebp), %edx
	testb	$32, %al
	je	.L124
	testb	$2, 22(%edx)
	jne	.L144
	.p2align 4,,7
	.p2align 3
.L124:
	movl	8(%ebp), %edx
	leal	-52(%ebp), %ecx
	movl	$0, 16(%esp)
	movl	%ecx, -64(%ebp)
	movzbl	28(%edx), %eax
	movl	%eax, 12(%esp)
	movl	24(%edx), %eax
	movl	%eax, 8(%esp)
	movl	8(%edx), %eax
	movl	%ecx, (%esp)
	movl	%eax, 4(%esp)
	call	Selector_Ctor@PLT
	movl	24(%esi), %edx
	movl	28(%esi), %ecx
	movzbl	14(%edi), %eax
	movl	16(%esi), %esi
	movl	%edx, -72(%ebp)
	movl	%ecx, -76(%ebp)
	movl	%eax, (%esp)
	call	Register_regFile@PLT
	movzbl	%al, %eax
	movl	%eax, (%esp)
	call	RegFile_getNativeType@PLT
	movl	-72(%ebp), %edx
	movl	-76(%ebp), %ecx
	movl	%esi, 12(%esp)
	movl	%edi, 8(%esp)
	movl	%edx, 16(%esp)
	movl	%ecx, 20(%esp)
	movzbl	%al, %eax
	movl	%eax, 4(%esp)
	movl	-64(%ebp), %eax
	movl	%eax, (%esp)
	call	Selector_selectDirectSTORE@PLT
	movl	-48(%ebp), %esi
	testl	%esi, %esi
	jne	.L138
	jmp	.L129
	.p2align 4,,7
	.p2align 3
.L130:
	movl	-8(%esi), %esi
	testl	%esi, %esi
	je	.L129
.L138:
	movzwl	20(%esi), %eax
	movl	%eax, (%esp)
	call	Operator_attributes@PLT
	testb	$32, %al
	je	.L130
	orw	$2, 22(%esi)
.L129:
	movl	CGO_TRACE@GOT(%ebx), %edi
	movl	(%edi), %eax
	testl	%eax, %eax
	je	.L132
	movl	%eax, 12(%esp)
	leal	.LC6@GOTOFF(%ebx), %eax
	movl	$14, 8(%esp)
	movl	$1, 4(%esp)
	movl	%eax, (%esp)
	call	fwrite@PLT
	movl	-48(%ebp), %eax
	testl	%eax, %eax
	je	.L132
	.p2align 4,,7
	.p2align 3
.L137:
	movl	-8(%eax), %esi
	movl	(%edi), %edx
	movl	%eax, (%esp)
	movl	%edx, 4(%esp)
	call	Operation_pretty@PLT
	testl	%esi, %esi
	movl	%esi, %eax
	jne	.L137
.L132:
	movl	-60(%ebp), %ecx
	testl	%ecx, %ecx
	je	.L145
	movl	-64(%ebp), %eax
	movl	-60(%ebp), %edx
	movl	8(%ebp), %ecx
	movl	%eax, 8(%esp)
	movl	%edx, 4(%esp)
	movl	%ecx, (%esp)
	call	BasicBlock_appendSelector@PLT
.L135:
	movl	-64(%ebp), %eax
	movl	%eax, (%esp)
	call	Selector_Dtor@PLT
	addl	$124, %esp
	popl	%ebx
	popl	%esi
	popl	%edi
	popl	%ebp
	ret
	.p2align 4,,7
	.p2align 3
.L142:
	movl	%esi, (%esp)
	call	Spill_getHomeLocation@PLT
	movl	%eax, %esi
	jmp	.L123
	.p2align 4,,7
	.p2align 3
.L145:
	movl	-64(%ebp), %edx
	movl	8(%ebp), %ecx
	movl	%edx, 4(%esp)
	movl	%ecx, (%esp)
	call	BasicBlock_putSelector@PLT
	jmp	.L135
.L143:
	movl	$4, 4(%esp)
	movzwl	20(%ecx), %eax
	movl	%eax, (%esp)
	call	Operator_getReadParameterKind@PLT
	movl	-60(%ebp), %ecx
	movl	40(%ecx), %edx
	movsbl	%al, %eax
	addl	32(%ecx), %eax
	cmpl	(%edx), %edi
	movl	(%edx,%eax,4), %eax
	jne	.L125
	cmpb	$4, 12(%eax)
	jne	.L125
	movl	16(%esi), %edx
	cmpl	%edx, 16(%eax)
	jne	.L125
	movl	28(%esi), %ecx
	cmpl	%ecx, 28(%eax)
	movl	24(%eax), %edx
	jne	.L125
	cmpl	24(%esi), %edx
	jne	.L125
	movl	CGO_TRACE@GOT(%ebx), %edi
	movl	(%edi), %eax
	testl	%eax, %eax
	je	.L127
	leal	.LC4@GOTOFF(%ebx), %edx
	movl	%edx, 4(%esp)
	movl	%eax, (%esp)
	call	fprintf@PLT
	testl	%eax, %eax
	je	.L127
	movl	(%edi), %eax
	movl	%eax, 4(%esp)
	movl	-60(%ebp), %eax
	movl	%eax, (%esp)
	call	Operation_pretty@PLT
.L127:
	movl	-60(%ebp), %edx
	movl	%edx, 4(%esp)
	movl	12(%edx), %eax
	movl	%eax, (%esp)
	call	BasicBlock_detachOperation@PLT
	jmp	.L120
	.p2align 4,,7
	.p2align 3
.L144:
	movzwl	20(%edx), %ecx
	movl	$4, 4(%esp)
	movl	%ecx, (%esp)
	movl	%ecx, -76(%ebp)
	call	Operator_getReadParameterKind@PLT
	movl	-76(%ebp), %ecx
	movl	$5, 4(%esp)
	movl	%ecx, (%esp)
	movb	%al, -68(%ebp)
	call	Operator_getReadParameterKind@PLT
	movl	-72(%ebp), %edx
	movb	%al, -89(%ebp)
	movsbl	-68(%ebp), %eax
	movl	40(%edx), %ecx
	addl	32(%edx), %eax
	movl	(%ecx,%eax,4), %ecx
	movsbl	-89(%ebp), %eax
	addl	32(%edx), %eax
	movl	%ecx, -68(%ebp)
	movl	40(%edx), %ecx
	cmpl	(%ecx,%eax,4), %edi
	jne	.L124
	movl	-68(%ebp), %eax
	cmpb	$4, 12(%eax)
	jne	.L124
	movl	16(%esi), %ecx
	cmpl	%ecx, 16(%eax)
	jne	.L124
	movl	24(%eax), %eax
	movl	-68(%ebp), %ecx
	movl	%eax, -64(%ebp)
	movl	28(%esi), %eax
	cmpl	%eax, 28(%ecx)
	jne	.L124
	movl	-64(%ebp), %ecx
	cmpl	24(%esi), %ecx
	jne	.L124
	movl	CGO_TRACE@GOT(%ebx), %edi
	movl	(%edi), %eax
	testl	%eax, %eax
	je	.L120
	leal	.LC5@GOTOFF(%ebx), %ecx
	movl	%ecx, 4(%esp)
	movl	%eax, (%esp)
	call	fprintf@PLT
	movl	-72(%ebp), %edx
	testl	%eax, %eax
	je	.L120
	movl	(%edi), %eax
	movl	%edx, (%esp)
	movl	%eax, 4(%esp)
	call	Operation_pretty@PLT
	jmp	.L120
	.size	Spill_appendSpill, .-Spill_appendSpill
	.p2align 4,,15
.globl Spill_getSpillCost
	.type	Spill_getSpillCost, @function
Spill_getSpillCost:
	pushl	%ebp
	movl	%esp, %ebp
	movl	8(%ebp), %eax
	testb	$16, 13(%eax)
	jne	.L149
	fld1
	popl	%ebp
	ret
	.p2align 4,,7
	.p2align 3
.L149:
	fldz
	popl	%ebp
	ret
	.size	Spill_getSpillCost, .-Spill_getSpillCost
	.p2align 4,,15
.globl Spill_getReloadCost
	.type	Spill_getReloadCost, @function
Spill_getReloadCost:
	pushl	%ebp
	movl	%esp, %ebp
	movl	8(%ebp), %eax
	call	__i686.get_pc_thunk.cx
	addl	$_GLOBAL_OFFSET_TABLE_, %ecx
	testb	$16, 13(%eax)
	jne	.L153
	flds	.LC10@GOTOFF(%ecx)
	popl	%ebp
	ret
	.p2align 4,,7
	.p2align 3
.L153:
	flds	.LC9@GOTOFF(%ecx)
	popl	%ebp
	ret
	.size	Spill_getReloadCost, .-Spill_getReloadCost
	.comm	escape,4,4
	.local	spill_coderegion
	.comm	spill_coderegion,4,4
	.local	buffer.11447
	.comm	buffer.11447,27,1
	.local	spill_temp.11446
	.comm	spill_temp.11446,4,4
	.local	spill_table_
	.comm	spill_table_,16,4
	.section	.rodata.cst4,"aM",@progbits,4
	.align 4
.LC9:
	.long	1067450368
	.align 4
.LC10:
	.long	1082130432
	.section	.text.__i686.get_pc_thunk.cx,"axG",@progbits,__i686.get_pc_thunk.cx,comdat
.globl __i686.get_pc_thunk.cx
	.hidden	__i686.get_pc_thunk.cx
	.type	__i686.get_pc_thunk.cx, @function
__i686.get_pc_thunk.cx:
	movl	(%esp), %ecx
	ret
	.section	.text.__i686.get_pc_thunk.bx,"axG",@progbits,__i686.get_pc_thunk.bx,comdat
.globl __i686.get_pc_thunk.bx
	.hidden	__i686.get_pc_thunk.bx
	.type	__i686.get_pc_thunk.bx, @function
__i686.get_pc_thunk.bx:
	movl	(%esp), %ebx
	ret
	.ident	"GCC: (SUSE Linux) 4.5.1 20101208 [gcc-4_5-branch revision 167585]"
	.section	.comment.SUSE.OPTs,"MS",@progbits,1
	.string	"OspWg"
	.section	.note.GNU-stack,"",@progbits
