#ifndef Florent_h_INCLUDED
#define Florent_h_INCLUDED

/*
 * !!!!	Florent.xcc
 *
 * Quentin Colombet (quentin.colombet@ens-lyon.fr)
 *
 * Copyright 2002 - 2007 STMicroelectronics.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of either (at your option): the GNU
 * General Public License (GPL) version 2; the GNU Lesser General
 * Public License (LGPL) version 2.1; any later version of these
 * licences as published by the Free Software Foundation.
 */

/*
 * This file contains all stuff related to florent's allocation.
 * In other words:
 * * Bridge to Florent's executable
 * * Repair allocation when pressure is at limit (insert split point)
 */

//
extern bool
Florent_allocCodeRegion(SSAForm ssaForm);


#endif//Florent_h_INCLUDED
