#ifndef OutOfColoredSSA_c_INCLUDED
#define OutOfColoredSSA_c_INCLUDED

#line 18 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
#include "GRA/GRA_.h"

#line 70 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
OutOfColoredSSA
OutOfColoredSSA_Ctor(OutOfColoredSSA this, CodeRegion codeRegion, RegFile regFile, Liveness* pliveness, Memory memory) {
  *OutOfColoredSSA__MEMORY(this) = memory;
  *OutOfColoredSSA__CODEREGION(this) = codeRegion;
  *OutOfColoredSSA__REGFILE(this) = regFile;
  *OutOfColoredSSA__PLIVENESS(this) = pliveness;
  OutOfColoredSSA_initRegisterMap(this);

#line 78 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  return this;
}

#line 81 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
void
OutOfColoredSSA_Dtor(OutOfColoredSSA this) {
}

#line 109 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static Temporary
OutOfColoredSSA_getDedicated(OutOfColoredSSA this, Register registre)
{
  return Procedure_makeDedicatedTemporary(OutOfColoredSSA_procedure(this), registre);
}

#line 116 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
/************************************************************
 * Support for out of colored SSA form BEGIN                *
 ************************************************************/

#line 120 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static int register_to_id_map[Register__FIXME];
static int id_to_register_map[Register__FIXME];
static int register_id_map_size;

#line 127 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static void OutOfColoredSSA_initRegisterMap(OutOfColoredSSA this) 
{
  Convention convention = OutOfColoredSSA_CONVENTION(this);
  RegFile regFile = OutOfColoredSSA_regFile(this);
  int i;
  int idx = 0;
  RegisterSet_ allocatableSet[1];
  *allocatableSet = Convention_allocatableSet(convention, regFile);
  for(i = RegFile_lowRegister(regFile); i <= RegFile_highRegister(regFile); i++) {
    if(RegisterSet_contains(allocatableSet, i)) {
      register_to_id_map[i] = idx;
      id_to_register_map[idx] = i;
      ++idx;
    } else {
      register_to_id_map[i] = -1;
    }
  }
  register_id_map_size = idx;
  RegisterSet_Dtor(allocatableSet);
}

#line 148 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static int
OutOfColoredSSA_nRegs(OutOfColoredSSA this)
{
  /* OutOfColoredSSA_initRegisterMap() must have been called for the current regFile. */
  return register_id_map_size;
}

#line 155 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static int
OutOfColoredSSA_temporaryReg(OutOfColoredSSA this, Temporary temporary)
{
  RegFile regFile = OutOfColoredSSA_regFile(this);
  if (!Temporary_hasRegFile(temporary)) return -1;
  if (regFile != Temporary_regFile(temporary)) return -1;
  return register_to_id_map[Temporary_REGISTER(temporary)];
}

#line 164 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static bool
OutOfColoredSSA_isPHI(OutOfColoredSSA this, Operation operation)
{
  return Operation_operator(operation) == Operator_PHI &&
    Temporary_regFile(Operation_getResult(operation, 0)) == OutOfColoredSSA_regFile(this);
}

#line 171 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static int
OutOfColoredSSA_getPHIArgIdx(Operation operation, BasicBlockEdge edge)
{
  int idx = -1;
  PHI_arguments_FOREACH_temporary(operation, arc_in, arg_idx, use) {
    if (arc_in == edge) {
      idx = arg_idx;
      break;
    }
  } PHI_arguments_ENDEACH_temporary;
  Except_CHECK(idx != -1);
  return idx;
}

#line 185 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static Temporary
OutOfColoredSSA_getPHIArgument(Operation operation, BasicBlockEdge edge)
{
  int idx = OutOfColoredSSA_getPHIArgIdx(operation, edge);
  return Operation_getArgument(operation, idx);
}

#line 192 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static Temporary
OutOfColoredSSA_getPHIResult(Operation operation)
{
  return Operation_getResult(operation, 0);
}

#line 198 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static bool
Operator_isCondTrue(Operator opr)
{
  return false;
}

#line 205 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static void
BasicBlock_putFirstSelector(BasicBlock bb, Selector ops)
{
  Operation point = NULL;
  BasicBlock_FOREACH_Operation(bb, op) {
    if (Operation_operator(op) == Operator_PHI) {
      point = op;
    }
  } BasicBlock_ENDEACH_Operation;
  if (point == NULL)
    BasicBlock_putSelector(bb, ops);
  else
    BasicBlock_appendSelector(bb, point, ops);

#line 219 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
}

#line 222 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static void
BasicBlock_pushLastSelector(BasicBlock bb, Selector ops)
{
  Operation point = NULL;
  BasicBlock_FORBACK_Operation(bb, op) {
    Operator operator = Operation_operator(op);
    if (Operator_isSigma(operator) || Operator_isControl(operator)) {
      point = op;
    }
  } BasicBlock_ENDBACK_Operation;
  if (point == NULL)
    BasicBlock_pushSelector(bb, ops);
  else
    BasicBlock_insertSelector(bb, point, ops);
}

#line 238 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static Temporary
OutOfColoredSSA_regTemporary(OutOfColoredSSA this, int reg)
{
  RegFile regFile = OutOfColoredSSA_regFile(this);
  Register rreg;
  Temporary treg;
  Except_CHECK(reg >= 0 && reg < register_id_map_size);
  rreg = id_to_register_map[reg];
  treg = Procedure_makeAssignedTemporary(OutOfColoredSSA_procedure(this), rreg);
  return treg;
}

#line 250 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static void
OutOfColoredSSA_expandRegMove(OutOfColoredSSA this, int src, int dst, Selector ops)
{
  Temporary tSrc, tDst;
  tSrc = OutOfColoredSSA_regTemporary(this, src);
  tDst = OutOfColoredSSA_regTemporary(this, dst);
  Selector_selectCOPY(ops, tDst, tSrc);
}

#line 260 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static void
OutOfColoredSSA_expandRegSwap(OutOfColoredSSA this, int src, int dst, Selector ops)
{
  Temporary tSrc, tDst;
  tSrc = OutOfColoredSSA_regTemporary(this, src);
  tDst = OutOfColoredSSA_regTemporary(this, dst);
  Selector_selectSWAP(ops, tDst, tSrc);
}

#line 269 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static void
OutOfColoredSSA_expandRegCondMove(OutOfColoredSSA this, Temporary condition, bool on_true, int src, int dst, Selector ops)
{
  Temporary tSrc, tDst;
  tSrc = OutOfColoredSSA_regTemporary(this, src);
  tDst = OutOfColoredSSA_regTemporary(this, dst);
  if (on_true)
    Selector_selectCOPYOnTrue(ops, tDst, condition, tSrc);
  else 
    Selector_selectCOPYOnFalse(ops, tDst, condition, tSrc);
}

#line 281 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
/*int max_perm = 64; |+ == max Reg +|*/

#line 286 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
#define COND_MOVE_COST	0.25
#define MOVE_COST	0.25
#define BRANCH_COST	0.25
#define BRANCH_PENALTY	1.0
#define CEIL(x)		((float)((int)(x) < (x)? (int)(x) + 1: (int)(x)))

#line 294 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
/* 
 * Permutation: if Ri becomes Rj then 
 *   - to[i] = j
 *   - inv[j] = i
 */

#line 301 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
// Fafab notations...

#line 317 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
Rpc
Rpc_Ctor(Rpc this, int nregs) {
  *Rpc__NREGS(this) = nregs;
  Rpc_clear(this);
  return this;
}

#line 324 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
void
Rpc_Dtor(Rpc this) {
}

#line 344 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
RpcBlock
RpcBlock_Ctor(RpcBlock this, int nregs) {
  Rpc_Ctor(RpcBlock_rpc_in(this), nregs);
  Rpc_Ctor(RpcBlock_rpc_out(this), nregs);
  *RpcBlock__FREQUENCY(this) = 0.0;
  return this;
}

#line 352 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
void
RpcBlock_Dtor(RpcBlock this) {
}

#line 384 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
RpcEdge
RpcEdge_Ctor(RpcEdge this, int nregs, BasicBlockEdge flowArc) {
  Rpc_Ctor(RpcEdge_rpc(this), nregs);
  *RpcEdge__FLOWARC(this) = flowArc;
  *RpcEdge__SPLIT(this) = false;
  *RpcEdge__PSPLIT(this) = false;
  *RpcEdge__SPLITABLE(this) = true;
  *RpcEdge__MARK(this) = false;
  *RpcEdge__FREQUENCY(this) = 0.0;
  *RpcEdge__FALSEEDGE(this) = false;
  *RpcEdge__BACKEDGE(this) = false;
  return this;
}

#line 399 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
void
RpcEdge_Dtor(RpcEdge this) {
}

#line 427 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
void
RpcEvolved_clear(RpcEvolved this) {
  Rpc_clear(RpcEvolved_RPC(this));
  memset(RpcEvolved_BEFORE(this), 0, MAX_RPC * sizeof(Temporary));
  memset(RpcEvolved_AFTER(this), 0, MAX_RPC * sizeof(Temporary));
}

#line 434 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
RpcEvolved
RpcEvolved_Ctor(RpcEvolved this, int nregs) {
  Rpc_Ctor(RpcEvolved_RPC(this), nregs);
  RpcEvolved_clear(this);
  return this;
}

#line 441 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
void
RpcEvolved_Dtor(RpcEvolved this) {
  Rpc_Dtor(RpcEvolved_RPC(this));
}

#line 446 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static void
RpcEvolved_insertRpc(BasicBlock block, Operation pointInsertionAfter,
                     void* structParam) {
  Selector selectorAfter = (Selector)structParam;
  if(pointInsertionAfter == NULL) {
    BasicBlock_putSelector(block, selectorAfter);
  } else {
    BasicBlock_appendSelector(block, pointInsertionAfter, selectorAfter);
  }  // set ordering after move insertion
  // This can be done in a more efficient way. Here this may be done several
  // times for same basic block
  BasicBlock_makeOrderings(block, 0, 1);
}

#line 465 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
void
RpcEvolved_generateRpc(Operation point, RpcEvolved rpc, int32_t idxToReg[],
                       bool before) {
  if(!Rpc_isIdentity(RpcEvolved_RPC(rpc))) {
    BasicBlock block = Operation_basicBlock(point);
    Procedure proc = BasicBlock_procedure(block);
    Selector_ selector[1];
    Selector blockSelector = BasicBlock_selector(block);
    int moves[(MAX_RPC+1)*3], i;
    Rpc_getMoveList(RpcEvolved_RPC(rpc), moves);
    
    Selector_Ctor(selector, Selector_memory(blockSelector), proc,
                  Selector_processor(blockSelector), false);
    for (i = 0; moves[i] != -1; i += 3) {
      // In case of cycle, we use another variable. Hence, AFTER and BEFORE
      // may be uninitialized
      if(RpcEvolved_AFTER(rpc)[moves[i+2]] == NULL) {
        RpcEvolved_AFTER(rpc)[moves[i+2]] =
          Procedure_makeAssignedTemporary(proc, idxToReg[moves[i+2]]);
        if(RpcEvolved_BEFORE(rpc)[moves[i+2]] == NULL) {
          // Variable is used to make a swap, so to have coherent naming use it
          RpcEvolved_BEFORE(rpc)[moves[i+2]] =
            RpcEvolved_AFTER(rpc)[moves[i+2]];
        }
        // else, for swap, we may have incorrect naming. Coherence is on color
      }
      if(RpcEvolved_BEFORE(rpc)[moves[i+1]] == NULL) {
        RpcEvolved_BEFORE(rpc)[moves[i+1]] =
          Procedure_makeAssignedTemporary(proc, idxToReg[moves[i+1]]);
        if(RpcEvolved_AFTER(rpc)[moves[i+1]] == NULL) {
          // Variable is used to make a swap, so to have coherent naming use it
          RpcEvolved_AFTER(rpc)[moves[i+1]] =
            RpcEvolved_BEFORE(rpc)[moves[i+1]];
        }
        // else, for swap, we may have incorrect naming. Coherence is on color
      }
      // moves format is {kind, src, dst}
      if (moves[i] == 0) {
        Selector_selectCOPY(selector, RpcEvolved_AFTER(rpc)[moves[i+2]],
                            RpcEvolved_BEFORE(rpc)[moves[i+1]]);
      } else {
        Selector_selectSWAP(selector, RpcEvolved_AFTER(rpc)[moves[i+1]],
                            RpcEvolved_BEFORE(rpc)[moves[i+2]]);
      }
    }

#line 511 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
    if(before) {
      BasicBlock_insertSelector(block, point, selector);
    } else if(BasicBlock_lastOperation(block) == point) {
      // if this operation is the last operation of block, this is for
      // good reasons. So, do not break that.
      BasicBlock_splitLeaveEdgeAndAction(block, true, (void*)selector,
                                         RpcEvolved_insertRpc);
    } else {
      BasicBlock_appendSelector(block, point, selector);
    }
    // set ordering after move insertion
    // This can be done in a more efficient way. Here this may be done several
    // times for same basic block
    BasicBlock_makeOrderings(block, 0, 1);
  }
  // else rpc is identity, do nothing
}

#line 536 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
void
RpcEvolved_initRegMap(int32_t regToIdx[], int32_t idxToReg[],
                      const_RegisterSet allocatableSet,
                      RegFile regFile) {
  Register reg;
  int32_t idx = 0;
  for(reg = RegFile_lowRegister(regFile); reg <= RegFile_highRegister(regFile);
      ++reg) {
    if(RegisterSet_contains(allocatableSet, reg)) {
      regToIdx[reg] = idx;
      idxToReg[idx] = reg;
      ++idx;
    } else {
      regToIdx[reg] = -1;
    }
  }
}

#line 554 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
/*#define BasicBlock_RpcBlock(block) (RpcBlock)BasicBlock_NUMBERING(block)*/
/*#define BasicBlock__RpcBlock(block) BasicBlock__NUMBERING(block)*/
/*#define BasicBlockEdge_RpcEdge(edge) (RpcEdge)BasicBlockEdge_INDEX(edge)*/
/*#define BasicBlockEdge__RpcEdge(edge) BasicBlockEdge__INDEX(edge)*/

#line 559 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
HTable_  RpcBlocks[1];    /* HTable mapping BasicBlock to RpcBlock */
HTable_  RpcEdges[1];    /* HTable mapping BasicBlockEdges to RpcEdges */

#line 563 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
#define BasicBlock_rpcbb(bb) (RpcBlock)HTable_search(RpcBlocks, bb)
#define BasicBlockEdge_rpce(edge) (RpcEdge)HTable_search(RpcEdges, edge)

#line 568 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
/**
 * Check that the RPC is correct.
 * Check that TO and INV are coherent.
 * Check that all regs are in range [-1...nreg[
 */
static bool Rpc_check(Rpc Rpc);

#line 575 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static bool Rpc_check(Rpc Rpc)
{
  int i;
  bool failed = false;

#line 580 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  for (i = 0; i < Rpc_nRegs(Rpc); i++) {
    if (!(Rpc_TO(Rpc)[i] >= -1 && Rpc_TO(Rpc)[i] < Rpc_nRegs(Rpc))) {
      failed = true; break;
    }
    if (!(Rpc_INV(Rpc)[i] >= -1 && Rpc_INV(Rpc)[i] < Rpc_nRegs(Rpc))) {
      failed = true; break;
    }
    if (!(Rpc_TO(Rpc)[i] == -1 || Rpc_INV(Rpc)[Rpc_TO(Rpc)[i]] == i)) {
      failed = true; break;
    }
    if (!(Rpc_INV(Rpc)[i] == -1 || Rpc_TO(Rpc)[Rpc_INV(Rpc)[i]] == i)) {
      failed = true; break;
    }
  }
  if (failed) {
    FILE *f = fopen("/tmp/LAO.out","w");
    Rpc_pretty(Rpc, f);
    fprintf(f, "Rpc_check failed for node %d\n", i);
    fclose(f);
  }
  return !failed;
}

#line 611 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
void
Rpc_clear(Rpc Rpc)
{
/*   int i; */
/*   for (i = 0; i < Rpc_nRegs(Rpc); i++) { */
/*     Rpc_TO(Rpc)[i] = Rpc_INV(Rpc)[i] = -1; */
/*   } */
  memset(Rpc_TO(Rpc), -1, MAX_RPC * sizeof(int));
  memset(Rpc_INV(Rpc), -1, MAX_RPC * sizeof(int));
  Except_CHECK(Rpc_isEmpty(Rpc));
}

#line 630 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static bool
Rpc_isEmpty(Rpc Rpc)
{
  int i;
  Except_CHECK(Rpc_check(Rpc));
  for (i = 0; i < Rpc_nRegs(Rpc); i++) {
    if (!(Rpc_TO(Rpc)[i] == -1 && Rpc_INV(Rpc)[i] == -1))
      return false;
  }
  return true;
}

#line 650 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
bool
Rpc_isIdentity(Rpc Rpc)
{
  int i;
  Except_CHECK(Rpc_check(Rpc));
  for (i = 0; i < Rpc_nRegs(Rpc); i++) {
    if (!((Rpc_TO(Rpc)[i] == -1 && Rpc_INV(Rpc)[i] == -1) ||
          Rpc_TO(Rpc)[i] == i))
      return false;
  }
  return true;
}

#line 670 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
bool
Rpc_pretty(Rpc Rpc, FILE *file)
{
  int i;
  fprintf(file, "<Rpc>\n");
  for (i = 0; i < Rpc_nRegs(Rpc); i++) {
    if (Rpc_TO(Rpc)[i] != -1 ||
        Rpc_INV(Rpc)[i] != -1) {
      fprintf(file, "%d -> %d -> %d\n", Rpc_INV(Rpc)[i], i, Rpc_TO(Rpc)[i]);
    }
  }
  fprintf(file, "</Rpc>\n");
  //
  return true;
}

#line 693 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
void
Rpc_getMoveList (Rpc Rpc, int *moves) 
{
  /* TODO: if the reversible parallel copy Rpc is generated at the bottom,
   * one should check whether there is some move instructions
   * which could be combined with Rpc */
  int i = 0;
  int nRegs = Rpc_nRegs(Rpc);
  int Rtmp;
  int Rtemporary;

#line 704 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  Except_CHECK(Rpc_check(Rpc));

#line 706 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  if (GRA_TRACE) Rpc_pretty(Rpc, GRA_TRACE);
  /* first, consider all path (no cycles) */
  for(;;) {
    /* find a register with a predecessor but no successor */
    Rtmp = 0;
    while ( Rtmp < nRegs &&
            !( Rpc_TO(Rpc)[Rtmp] == -1 && Rpc_INV(Rpc)[Rtmp] != -1 ))
      Rtmp++;

#line 715 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
    if (Rtmp == nRegs) { /* no more path */
      break;
    } else {
      /* generate all the copies along the path from the leaf */
      int Rleaf = Rtmp;
      while ((Rtmp = Rpc_INV(Rpc)[Rleaf]) != -1) {
        /* Add a move (Rtmp => Rleaf) */
        Except_CHECK(Rpc_TO(Rpc)[Rtmp] == Rleaf);
        moves[i++] = 0/*move*/; moves[i++] = Rtmp; moves[i++] = Rleaf;

#line 725 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
        /* Update Rpc to have a self-cycle on Rleaf. */
        Rpc_TO(Rpc)[Rleaf] = Rleaf;
        Rpc_INV(Rpc)[Rleaf] = Rleaf;

#line 729 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
        /* Rtmp becomes leaf. */
        Rpc_TO(Rpc)[Rtmp] = -1;
        Rleaf = Rtmp;
        Except_CHECK(Rpc_check(Rpc));
      }
    }
  } 

#line 737 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  /* now there are only cycles or isolated points
   * Is there:
   * - any cycle of size > 1?
   * - a temporary register to do the reverse parallel copy?
   *   */

#line 743 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  /* find a temporary register */
  Rtemporary = 0;
  while( Rtemporary < nRegs && Rpc_TO(Rpc)[Rtemporary] != -1 ) {
    Rtemporary ++;
  }
  if (Rtemporary == nRegs) {
    Rtemporary = -1;
  } else {
    Except_CHECK (Rpc_INV(Rpc)[Rtemporary] == -1);
  }

#line 754 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  /* find cycles of size > 1 */
  for(;;) {
    Rtmp = 0;
    while ( Rtmp < nRegs &&
            (Rpc_TO(Rpc)[Rtmp] == -1 || Rpc_TO(Rpc)[Rtmp] == Rtmp) )
      Rtmp++;

#line 761 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
    if (Rtmp == nRegs) { /* no more cycle of size > 1 */
      break;
    } else {
      if (Rtemporary != -1) {
        int Rleaf;

#line 767 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
        /* Add a move (Rtemp => Rtemporary) and make Rtemp a leaf. */
        moves[i++] = 0/*move*/; moves[i++] = Rtmp; moves[i++] = Rtemporary;
        Rpc_INV(Rpc)[Rpc_TO(Rpc)[Rtmp]] = -1;
        Rpc_TO(Rpc)[Rtmp] = -1;
        Rleaf = Rtmp;

#line 773 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
        Except_CHECK(Rpc_check(Rpc));
        while ((Rtmp = Rpc_INV(Rpc)[Rleaf]) != -1) {
          /* Add a move (Rtmp => Rleaf) */
          Except_CHECK(Rpc_TO(Rpc)[Rtmp] == Rleaf);
          moves[i++] = 0/*move*/; moves[i++] = Rtmp; moves[i++] = Rleaf;

#line 779 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
          /* Update Rpc to have a self-cycle on Rleaf. */
          Rpc_TO(Rpc)[Rleaf] = Rleaf;
          Rpc_INV(Rpc)[Rleaf] = Rleaf;

#line 783 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
          /* Rtmp becomes leaf. */
          Rpc_TO(Rpc)[Rtmp] = -1;
          Rleaf = Rtmp;
        }

#line 788 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
        /* Add a move (Rtemporary => Rleaf) */
        moves[i++] = 0/*move*/; moves[i++] = Rtemporary; moves[i++] = Rleaf;

#line 791 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
        /* Update Rpc to have a self-cycle on Rleaf. */
        Rpc_TO(Rpc)[Rleaf] = Rleaf;
        Rpc_INV(Rpc)[Rleaf] = Rleaf;

#line 795 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
        Except_CHECK(Rpc_check(Rpc));

#line 797 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
      } else {
        /* Need to generate swaps. */
        int Rleaf;
        Rleaf = Rpc_TO(Rpc)[Rtmp];
        while (Rleaf != Rtmp) {
          /* Add a swap (Rtmp <=> Rleaf) */
          moves[i++] = 1/*swap*/; moves[i++] = Rtmp; moves[i++] = Rleaf;
          Rpc_INV(Rpc)[Rpc_TO(Rpc)[Rleaf]] = Rtmp;
          Rpc_TO(Rpc)[Rtmp] = Rpc_TO(Rpc)[Rleaf];

#line 807 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
          Rpc_TO(Rpc)[Rleaf] = Rleaf;
          Rpc_INV(Rpc)[Rleaf] = Rleaf;
          Rleaf = Rpc_TO(Rpc)[Rtmp];
        }
      }
    }
  }

#line 815 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  moves[i] = -1; /* Terminate the list of moves. */
}

#line 819 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static void
OutOfColoredSSA_generateMoves(OutOfColoredSSA this, BasicBlock B, int *moves, bool on_top)
{
  int i;
  Selector ops = CodeRegion_selector(OutOfColoredSSA_codeRegion(this));

#line 825 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  for (i = 0; moves[i] != -1; i += 3) {
    if (moves[i] == 0)
      OutOfColoredSSA_expandRegMove(this, moves[i+1], moves[i+2], ops);
    else 
      OutOfColoredSSA_expandRegSwap(this, moves[i+1], moves[i+2], ops);
  }

#line 832 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  if (on_top) {
    BasicBlock_putFirstSelector(B, ops);
  } else {
    BasicBlock_pushLastSelector(B, ops);
  }
  // set ordering after move insertion
  // This can be done in a more efficient way. Here this may be done several
  // times for same basic block
  BasicBlock_makeOrderings(B, 0, 1);
}

#line 843 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static void
OutOfColoredSSA_generateMovesFab(OutOfColoredSSA this, BasicBlock B, Operation baseop, int *moves);

#line 846 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static void
OutOfColoredSSA_generateMovesFab(OutOfColoredSSA this, BasicBlock B, Operation baseop, int *moves)
{
  int i;
  Selector ops = CodeRegion_selector(OutOfColoredSSA_codeRegion(this));
  
  for (i = 0; moves[i] != -1; i += 3) {
    if (moves[i] == 0)
      OutOfColoredSSA_expandRegMove(this, moves[i+1], moves[i+2], ops);
    else 
      OutOfColoredSSA_expandRegSwap(this, moves[i+1], moves[i+2], ops);
  }

#line 859 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  if (baseop == NULL)
    BasicBlock_putSelector(B, ops);
  else
    BasicBlock_appendSelector(B, baseop, ops);
  // set ordering after move insertion
  // This can be done in a more efficient way. Here this may be done several
  // times for same basic block
  BasicBlock_makeOrderings(B, 0, 1);
}

#line 869 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static void
OutOfColoredSSA_generateCondMoves(OutOfColoredSSA this, BasicBlock B, int *moves, Temporary condition, bool on_true, bool on_top)
{
  int i;
  Selector ops = CodeRegion_selector(OutOfColoredSSA_codeRegion(this));

#line 875 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  for (i = 0; moves[i] != -1; i += 3) {
    if (moves[i] == 0)
      OutOfColoredSSA_expandRegCondMove(this, condition, on_true, moves[i+1], moves[i+2], ops);
    else {
      fflush(GRA_TRACE);
      Except_CHECK(0); /* Don't know how to swap conditionally. */
    }
  }

#line 884 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  if (on_top) {
    BasicBlock_putFirstSelector(B, ops);
  } else {
    BasicBlock_pushLastSelector(B, ops);
  }
  // set ordering after move insertion
  // This can be done in a more efficient way. Here this may be done several
  // times for same basic block
  BasicBlock_makeOrderings(B, 0, 1);
}

#line 895 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static void
OutOfColoredSSA_generateRpcTop(OutOfColoredSSA this, Rpc Rpc, BasicBlock B) {
  int moves[(MAX_RPC+1)*3];
  Rpc_getMoveList(Rpc, moves);
  OutOfColoredSSA_generateMoves(this, B, moves, true);
}

#line 902 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static void
OutOfColoredSSA_generateRpcBottom(OutOfColoredSSA this, Rpc Rpc, BasicBlock B) {
  int moves[(MAX_RPC+1)*3];
  Rpc_getMoveList(Rpc, moves);
  OutOfColoredSSA_generateMoves(this, B, moves, false);
}

#line 909 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static void
OutOfColoredSSA_generateCondRpcBottom(OutOfColoredSSA this, Rpc Rpc, BasicBlock B, BasicBlockEdge E)
{
  Operation control = BasicBlock_getControlOperation(B);
  Temporary condition;
  BasicBlockEdge target_arc;
  bool on_true, arc_true;
  int moves[(MAX_RPC+1)*3];

#line 918 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  Except_CHECK(BasicBlockEdge_isConditional(E) && BasicBlockEdge_origBlock(E) == B);
  Rpc_check(Rpc);
  target_arc = BasicBlock_getTargetEdge(B);
  condition = Operation_getCondition(control);
  on_true = Operator_isCondTrue(Operation_operator(control));
  arc_true = (target_arc == E && on_true) ||
    (target_arc != E && !on_true);
  Rpc_getMoveList(Rpc, moves);
  OutOfColoredSSA_generateCondMoves(this, B, moves, condition, arc_true, false);
}

#line 930 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
/*
 * Clear live set.
 */
static void
OutOfColoredSSA_clearLive(OutOfColoredSSA this, bool *live)
{
  int i, nRegs;
  nRegs = OutOfColoredSSA_nRegs(this);

#line 939 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  for (i=0; i < nRegs; i++) live[i] = false; 
}

#line 942 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
/*
 * Add live on edges E = (A,B) , i.e. + (livein(B) - phi results) + phi arguments on E.
 */
static void
OutOfColoredSSA_addLiveOnEdge(OutOfColoredSSA this, BasicBlockEdge E, bool *live)
{
  BasicBlock A, B;
  bool uses[MAX_RPC];
  bool defs[MAX_RPC];
  int i, nRegs;
  A = BasicBlockEdge_origBlock(E);
  B = BasicBlockEdge_destBlock(E);

#line 955 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  nRegs = OutOfColoredSSA_nRegs(this);
  for (i=0; i < nRegs; i++) uses[i] = defs[i] = false; 

#line 958 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  BasicBlock_FOREACH_Operation(B, operation) {
    if (OutOfColoredSSA_isPHI(this, operation)) {
      int argIdx = OutOfColoredSSA_getPHIArgIdx(operation, E);
      int use, def;
      use = OutOfColoredSSA_temporaryReg(this, Operation_getArgument(operation, argIdx));
      Except_CHECK(use != -1);
      uses[use] = true;
      def = OutOfColoredSSA_temporaryReg(this, Operation_getResult(operation, 0));
      Except_CHECK(def != -1);
      defs[def] = true;
    }
  } BasicBlock_ENDEACH_Operation;

#line 971 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  TemporarySet_FOREACH_Temporary (BasicBlock_liveInSet(B), temp) {
    int reg = OutOfColoredSSA_temporaryReg(this, temp);
    if (reg != -1) {
      if (!defs[reg]) live[reg] = true;
    }
  } TemporarySet_ENDEACH_Temporary;

#line 978 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  for (i=0; i < nRegs; i++) if (uses[i])  live[i] = true; 
}

#line 981 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
/*
 * Init Live on edges E.
 */
static void
OutOfColoredSSA_initLiveOnEdge(OutOfColoredSSA this, BasicBlockEdge E, bool *live)
{

#line 988 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  OutOfColoredSSA_clearLive(this, live);
  OutOfColoredSSA_addLiveOnEdge(this, E, live);
}

#line 992 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static void
OutOfColoredSSA_initLiveOut(OutOfColoredSSA this, BasicBlock B, bool *liveOut,
                            bool beforeMoves)
{
  int i, nRegs;
  Rpc rpcBBout = GRA_ssa_use_new_rpc? RpcBlock_rpc_out(BasicBlock_rpcbb(B)): NULL;
  nRegs = OutOfColoredSSA_nRegs(this);

#line 1000 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  if(rpcBBout != NULL) {
    int *array = beforeMoves? Rpc_TO(rpcBBout): Rpc_INV(rpcBBout);
    Except_CHECK(nRegs == Rpc_nRegs(rpcBBout));

#line 1004 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
    for (i=0; i < nRegs; i++) {
      liveOut[i] = (array[i] != -1);
    }
  } else {
    for (i=0; i < nRegs; i++) liveOut[i] = false;

#line 1010 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
    TemporarySet_FOREACH_Temporary (BasicBlock_liveOutSet(B), temp) {
      int reg = OutOfColoredSSA_temporaryReg(this, temp);
      if (reg != -1) liveOut[reg] = true;
    } TemporarySet_ENDEACH_Temporary;

#line 1015 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
    if(BasicBlock_phiOutSet(B) != NULL) {
      TemporarySet_FOREACH_Temporary (BasicBlock_phiOutSet(B), temp) {
        int reg = OutOfColoredSSA_temporaryReg(this, temp);
        if (reg != -1) liveOut[reg] = true;
      } TemporarySet_ENDEACH_Temporary;
    }
  }
}

#line 1024 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static void
OutOfColoredSSA_initLiveIn(OutOfColoredSSA this, BasicBlock B, bool *liveIn,
                           bool beforeMoves)
{
  int i, nRegs;
  Rpc rpcBBin = GRA_ssa_use_new_rpc? RpcBlock_rpc_in(BasicBlock_rpcbb(B)): NULL;
  nRegs = OutOfColoredSSA_nRegs(this);
  if(rpcBBin != NULL) {
    int *array = beforeMoves? Rpc_TO(rpcBBin): Rpc_INV(rpcBBin);
    Except_CHECK(nRegs == Rpc_nRegs(rpcBBin));

#line 1035 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
    for (i=0; i < nRegs; i++) {
      liveIn[i] = (array[i] != -1);
    }
  } else {
    for (i=0; i < nRegs; i++) liveIn[i] = false;

#line 1041 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
    TemporarySet_FOREACH_Temporary (BasicBlock_liveInSet(B), temp) {
      int reg = OutOfColoredSSA_temporaryReg(this, temp);
      if (reg != -1) liveIn[reg] = true;
    } TemporarySet_ENDEACH_Temporary;
  }
}

#line 1057 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static void
OutOfColoredSSA_updateLiveIn(OutOfColoredSSA this, BasicBlock B, Rpc Rpc)
{
  int i;
  TemporarySet live = BasicBlock_liveInSet(B);

#line 1063 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  TemporarySet_empty(live);
  TemporarySet_union(live, BasicBlock_liveOutSet(B));
  for (i = 0; i < Rpc_nRegs(Rpc); i++) {
    if (Rpc_INV(Rpc)[i] != -1 &&
        Rpc_INV(Rpc)[i] != i) {
      /* Remove occurence of register in live. */
      TemporarySet_FORSORT_Temporary(live, Temporary_compare, var) {
        if (OutOfColoredSSA_temporaryReg(this, var) == i)
          TemporarySet_remove(live, var);
      } TemporarySet_ENDSORT_Temporary;
    }
  }
  for (i = 0; i < Rpc_nRegs(Rpc); i++) {
    if (Rpc_TO(Rpc)[i] != -1 &&
        Rpc_TO(Rpc)[i] != i) {
      Temporary use = OutOfColoredSSA_regTemporary(this, i);
      TemporarySet_insert(live, use);
    }
  }
}

#line 1084 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
/*// @ XCC_.h*/
 /*
  * Estimate the move count for a reverse parallel copy
  * Estimated as the number of move to a different register.
  */

#line 1090 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
 /*int Rpc_moveCount(Rpc Rpc);*/

#line 1093 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
 /*int*/
 /*Rpc_moveCount(Rpc Rpc)*/
 /*{*/
 /*  int i;*/
 /*  int count = 0;*/
 /*  for (i = 0; i < Rpc_nRegs(Rpc); i++) {*/
 /*    if (Rpc_INV(Rpc)[i] != -1 &&*/
 /*        Rpc_INV(Rpc)[i] != i) {*/
 /*      count++;*/
 /*    }*/
 /*  }*/
 /*  return count;*/
 /*}*/

#line 1108 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
float
OutOfColoredSSA_RpcCost(OutOfColoredSSA this, Rpc Rpc, BasicBlockEdge E, bool split, bool cond)
{
  float weight, tmp;
  float cost;
  int count = Rpc_moveCount(Rpc);
  if (count == 0) return 0.0;

#line 1116 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  if (BasicBlockEdge_isSweetTop(E, &weight)) {
    cost = MOVE_COST*count*weight;
  } else if (BasicBlockEdge_isSweetBottom(E, &weight)) {
    cost = MOVE_COST*count*weight;
  } else if (cond) {	
    BasicBlock dest = BasicBlockEdge_destBlock(E);
    cost = COND_MOVE_COST*count*BasicBlock_frequency(dest);
  } else if (!split && BasicBlockEdge_isWeakTop(E, &weight)) {
    BasicBlock B = BasicBlockEdge_origBlock(E);
    cost = MOVE_COST*count*BasicBlock_frequency(B);
    BasicBlock_LEAVE_FOREACH_BasicBlockEdge(B, Ei) {
      if (Ei != E) {
        Except_CHECK((BasicBlockEdge_isCritical(Ei) && BasicBlockEdge_isFalse(Ei, &tmp)) ||
                     BasicBlockEdge_isSweetBottom(Ei, &tmp));
        cost += OutOfColoredSSA_RpcCost(this, Rpc, Ei, true, false);
      }
    } BasicBlock_LEAVE_ENDEACH_BasicBlockEdge;
  } else if (!split && BasicBlockEdge_isWeakBottom(E, &weight)) {
    BasicBlock B = BasicBlockEdge_destBlock(E);
    cost = MOVE_COST*count*BasicBlock_frequency(B);
    BasicBlock_ENTER_FOREACH_BasicBlockEdge(B, Ei) {
      if (Ei != E) {
        Except_CHECK((BasicBlockEdge_isCritical(Ei) && BasicBlockEdge_isFalse(Ei, &tmp)) ||
                     BasicBlockEdge_isSweetTop(Ei, &tmp));
        cost += OutOfColoredSSA_RpcCost(this, Rpc, Ei, true, false);
      }
    } BasicBlock_ENTER_ENDEACH_BasicBlockEdge;
  } else if (split && BasicBlockEdge_isFalse(E, &weight)) {
    cost = CEIL(MOVE_COST*count)*weight;
  } else if (split) {
    weight = BasicBlock_frequency(BasicBlockEdge_origBlock(E))*BasicBlockEdge_probability(E);
    cost = (CEIL(MOVE_COST*count+BRANCH_COST)+BRANCH_PENALTY)*weight;
  } else {
    fprintf(stderr, "BasicBlockEdge: %d->%d: split:%d, cmove:%d\n", BasicBlock_INDEX(BasicBlockEdge_origBlock(E)), BasicBlock_INDEX(BasicBlockEdge_destBlock(E)), split, cond);
    Except_CHECK(0);
  }
  return cost;
}

#line 1155 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static bool
Operation_usesOrDefinesRegFile(Operation operation, RegFile regFile) {
  Operation_OPERANDS_FOREACH_Temporary(operation, temp) {
    if(Temporary_regFile(temp) == regFile) {
      return true;
    }
  } Operation_OPERANDS_ENDEACH_Temporary;
  if(Operation_hasClobber(operation)) {
    RegisterSet_FOREACH_Register(Operation_clobberSet(operation), reg) {
      if(Register_regFile(reg) == regFile) {
        return true;
      }
    } RegisterSet_ENDEACH_Register;
  }
  return false;
}

#line 1172 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static bool
canSplit(BasicBlockEdge E) {
  BasicBlock origBlock = BasicBlockEdge_origBlock(E);
  Operation lastOp = BasicBlock_lastOperation(origBlock);
  if(lastOp != NULL && Operator_isControl(Operation_operator(lastOp))) {
    // code from Procedure_updateTargetedOperation
    int32_t targetIndex = Operation_ARGCOUNT(lastOp) - 1;	// HACK ALERT!
    Temporary target_temporary = Operation_getArgument(lastOp, targetIndex);
    return Temporary_isLabel(target_temporary);
  }
  return true;
}

#line 1190 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static void
OutOfColoredSSA_connectLiveNode(OutOfColoredSSA this, bool liveOther[],
                                Rpc rpc) {
  int Rtmp;
  for (Rtmp = 0; Rtmp < OutOfColoredSSA_nRegs(this); Rtmp++) {
    if (liveOther[Rtmp] && 
        Rpc_INV(rpc)[Rtmp] == -1 && Rpc_TO(rpc)[Rtmp] == -1) {
      Rpc_TO(rpc)[Rtmp] = Rtmp;
      Rpc_INV(rpc)[Rtmp] = Rtmp;
      GRA_TRACE && fprintf(GRA_TRACE, "add self on E: %d\n", Rtmp);
    }
  }
}

#line 1209 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static void
OutOfColoredSSA_saveRemainingLive(OutOfColoredSSA this, bool liveOther[],
                                  Rpc rpc) {
  int32_t Rtmp = 0;
  uint32_t nRegs = OutOfColoredSSA_nRegs(this);
  /* find a register available (unconnected node). */
  while (Rtmp < nRegs && !(Rpc_INV(rpc)[Rtmp] == -1 && Rpc_TO(rpc)[Rtmp] == -1)) Rtmp++;

#line 1217 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  /* Now save remaining live on other edges. */
  if (Rtmp < nRegs) {
    /* Temporary register available */
    int Ri;
    for (Ri = 0; Ri < nRegs; Ri++) {
      if (liveOther[Ri]) {
        if (Rpc_INV(rpc)[Ri] != -1 && Rpc_TO(rpc)[Ri] == -1 ) {
          /* Ri has one predecessor but no successor
           * => need to save it in another register
           * => then there is a new avaliable register at the start 
           * of the path  */
          GRA_TRACE && fprintf(GRA_TRACE, "add successor for other Edges: %d\n", Ri);
          Rpc_TO(rpc)[Ri] = Rtmp;
          Rpc_INV(rpc)[Rtmp] = Ri;
          while (Rpc_INV(rpc)[Rtmp] != -1) {
            Rtmp = Rpc_INV(rpc)[Rtmp];
          }
        }
      }
    }
  } else {
    /* Maxlive = max reg */
    int Ri;
    for (Ri = 0; Ri < nRegs; Ri++) {
      if (liveOther[Ri]) {
        if (Rpc_INV(rpc)[Ri] != -1 && Rpc_TO(rpc)[Ri] == -1 ) {
          /* Ri has one predecessor but no successor
           * => need to save it in another register */
          Rtmp = Ri;
          while (Rpc_INV(rpc)[Rtmp] != -1) {
            Rtmp = Rpc_INV(rpc)[Rtmp];
          }
          GRA_TRACE && fprintf(GRA_TRACE, "add successor (cycle) for other Edges: %d\n", Ri);
          Rpc_TO(rpc)[Ri] = Rtmp;
          Rpc_INV(rpc)[Rtmp] = Ri;
        }
      }
    }
  }
}

#line 1266 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static void
OutOfColoredSSA_RpcMoveup (OutOfColoredSSA this, Rpc rpc, BasicBlockEdge E, bool split, bool cond_move)
{
  CodeRegion codeRegion = OutOfColoredSSA_codeRegion(this);
  int nRegs = OutOfColoredSSA_nRegs(this);
  int i;
  bool identity;
  float tmp;
  BasicBlock B = BasicBlockEdge_origBlock(E);
  bool liveE[MAX_RPC];
  bool liveOther[MAX_RPC];
  Rpc_ Rpctmp_;
  Rpc_ Rpcinv_;
  Rpc Rpcinv = &Rpcinv_;
  IDList_ arcs_;
  IDList arcs = (IDList)&arcs_;
  Memory memory = OutOfColoredSSA_memory(this);
  RegFile regFile = OutOfColoredSSA_REGFILE(this);
  Operation lastOp = BasicBlock_lastOperation(B);

#line 1286 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  Except_CHECK(!split || !cond_move);

#line 1288 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  /* check if Rpc == identity. */
  if (Rpc_isIdentity(rpc)) return;

#line 1291 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  if (GRA_TRACE) {
    fprintf(GRA_TRACE, "Generate Rpc Bottom for edge %d -> %d: %s %s\n", 
            BasicBlock_INDEX(BasicBlockEdge_origBlock(E)), 
            BasicBlock_INDEX(BasicBlockEdge_destBlock(E)),
            split?"split": "nsplit", cond_move?"cond":"ncond");
  }
  if (GRA_TRACE) Rpc_pretty(rpc, GRA_TRACE);
  
  /* initialize live on edge. */
  OutOfColoredSSA_initLiveOnEdge(this, E, liveE);

#line 1302 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  /* for each live on the edge we insert a self cycle
     if it is a unconnected node.
     We must ensure that all live on edge keep their original value.
  */
  OutOfColoredSSA_connectLiveNode(this, liveE, rpc);

#line 1308 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  if (BasicBlockEdge_isSweetTop(E, &tmp)
      && (lastOp == NULL
          || !Operator_isControl(Operation_operator(lastOp))
          //FIXME: Do a more accurate test. Here we block this handling even if
          //       the expansion of the rpc can cross the control option.
          || !Operation_usesOrDefinesRegFile(lastOp, regFile))) {
    if (GRA_TRACE) fprintf(GRA_TRACE, "Generate Rpc Bottom on sweet edge %d -> %d\n", BasicBlock_INDEX(BasicBlockEdge_origBlock(E)), BasicBlock_INDEX(BasicBlockEdge_destBlock(E)));
    /* if E is a sweet top edge, generate the reverse parallel copy in the predecessor. */
    OutOfColoredSSA_generateRpcBottom(this, rpc, BasicBlockEdge_origBlock(E));
  } else if (!cond_move && BasicBlockEdge_isFalse(E, &tmp)) {
    /* if E is a false edge, split it and generate the reverse parallel copy on
     * the new basic bloc */
    BasicBlock Be;
    if (GRA_TRACE) fprintf(GRA_TRACE, "Generate Rpc Bottom on split false edge %d -> %d\n", BasicBlock_INDEX(BasicBlockEdge_origBlock(E)), BasicBlock_INDEX(BasicBlockEdge_destBlock(E)));
    Be = BasicBlockEdge_splitFalseWithLiveness(OutOfColoredSSA_PLIVENESS(this), OutOfColoredSSA_memory(this), codeRegion, E);
    OutOfColoredSSA_updateLiveIn(this, Be, rpc);
    OutOfColoredSSA_generateRpcBottom(this, rpc, Be); /* generate pmove on Be */
  } else if (split && (BasicBlockEdge_isCritical(E)
                       || (lastOp != NULL
                           && Operator_isControl(Operation_operator(lastOp))
                           && Operation_usesOrDefinesRegFile(lastOp, regFile)))
             && canSplit(E)) {
    BasicBlock Be;
    if (GRA_TRACE) fprintf(GRA_TRACE, "Generate Rpc on split edge %d -> %d\n", BasicBlock_INDEX(BasicBlockEdge_origBlock(E)), BasicBlock_INDEX(BasicBlockEdge_destBlock(E)));
    Be = BasicBlockEdge_splitWithLiveness(OutOfColoredSSA_PLIVENESS(this),
                                          OutOfColoredSSA_memory(this),
                                          codeRegion, E, false, NULL);
    OutOfColoredSSA_updateLiveIn(this, Be, rpc);
    OutOfColoredSSA_generateRpcBottom(this, rpc, Be); /* generate pmove on Be */
  } else if (cond_move) {
    if (GRA_TRACE) fprintf(GRA_TRACE, "Generate Rpc Bottom with cond move on edge %d -> %d\n", BasicBlock_INDEX(BasicBlockEdge_origBlock(E)), BasicBlock_INDEX(BasicBlockEdge_destBlock(E)));
    /* generate conditional pmove at the end of B */
    OutOfColoredSSA_generateCondRpcBottom(this, rpc, B, E);
  } else {
    Except_CHECK(BasicBlockEdge_isWeakTop(E, &tmp));

#line 1344 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
    if (GRA_TRACE) fprintf(GRA_TRACE, "Generate Rpc Bottom on edge %d -> %d\n", BasicBlock_INDEX(BasicBlockEdge_origBlock(E)), BasicBlock_INDEX(BasicBlockEdge_destBlock(E)));

#line 1346 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
    /* Init live on other edges, these must be preserved or
       saved in another register. */
    OutOfColoredSSA_clearLive(this, liveOther);
    BasicBlock_LEAVE_FOREACH_BasicBlockEdge(B, Ei) {
      if (Ei != E) {
        OutOfColoredSSA_addLiveOnEdge(this, Ei, liveOther);
      }
    } BasicBlock_LEAVE_ENDEACH_BasicBlockEdge;

#line 1355 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
    /* If live on other edges and unconnected, force self-edge. */
    OutOfColoredSSA_connectLiveNode(this, liveOther, rpc);

#line 1358 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
    OutOfColoredSSA_saveRemainingLive(this, liveOther, rpc);

#line 1360 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
    if (GRA_TRACE) fprintf(GRA_TRACE, "Insert parallel copy at bottom node %d\n", BasicBlock_INDEX(B));
    
    /* Need to copy reverse parallel copy first as is is modified by generateRpc. */
    Rpctmp_ = *rpc;
    /* generate pmove at the end of B */
    OutOfColoredSSA_generateRpcBottom(this, &Rpctmp_, B);
    
    /* now, compensate [Rpc] at the beginning of every other block
     * successor of B */
    Rpc_Ctor(Rpcinv, nRegs);
    
    IDList_Ctor(arcs, memory);
    /* We must first create the list of edges to process as the control flow
       will change due to spliting of false edges.
    */
    BasicBlock_LEAVE_FOREACH_BasicBlockEdge(B, Ei) {
      IDList_PUSH(arcs, BasicBlockEdge, Ei);
    } BasicBlock_LEAVE_ENDEACH_BasicBlockEdge;
    
    IDList_FOREACH(arcs, BasicBlockEdge, arc_p) {
      BasicBlockEdge Ei = *arc_p;
      BasicBlock Bi = BasicBlockEdge_destBlock(Ei);
      if (Ei != E) {
        /* Init live in.. */
        OutOfColoredSSA_initLiveOnEdge(this, Ei, liveOther);
        if (BasicBlockEdge_isCritical(Ei) && BasicBlockEdge_isFalse(Ei, &tmp)) {
          Bi = BasicBlockEdge_splitFalseWithLiveness(OutOfColoredSSA_PLIVENESS(this), OutOfColoredSSA_memory(this), codeRegion, Ei);
          /* For sanity check get the possibly new edge Ei. */
          Ei = NULL;
          BasicBlock_ENTER_FOREACH_BasicBlockEdge(Bi, Ej) {
            Except_CHECK(Ei == NULL); /* Only one edge entering Bi . */
            Ei = Ej;
          } BasicBlock_ENTER_ENDEACH_BasicBlockEdge;
        }
        /* invert [Rpc]: swap TO and INV */
        for(i=0; i < nRegs; i++) {
          Rpc_TO(Rpcinv)[i] = Rpc_INV(rpc)[i];
          Rpc_INV(Rpcinv)[i] = Rpc_TO(rpc)[i];
        }
        /* delete all arcs to a non live-in variables of Bi */
        for(i=0; i < nRegs; i++) {
          if (!liveOther[i]) {
            if (Rpc_INV(Rpcinv)[i] != -1) {
              Rpc_TO(Rpcinv)[Rpc_INV(Rpcinv)[i]] = -1;
              Rpc_INV(Rpcinv)[i] = -1;
            }
          }
        }
	
        Except_CHECK(BasicBlockEdge_isSweetBottom(Ei, &tmp));
        if (GRA_TRACE) fprintf(GRA_TRACE, "Insert parallel copy at top node %d\n", BasicBlock_INDEX(Bi));
        /* generate pmove at the top of Bi */
        OutOfColoredSSA_generateRpcTop(this, Rpcinv, Bi);
      }
    } IDList_ENDEACH;
    IDList_Dtor(arcs);
  }
}

#line 1419 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static bool
BasicBlock_colorIsLiveIn(BasicBlock block, Register color) {
  bool result = false;
  TemporarySet_FOREACH_Temporary(BasicBlock_liveInSet(block), temp) {
    if(Temporary_hasRegister(temp) && Temporary_register(temp) == color) {
      result = true;
      break;
    }
  } TemporarySet_ENDEACH_Temporary;
  return result;
}

#line 1440 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
Change
Change_Ctor(Change this, Operation point, int32_t idx, Temporary previous,
            bool isArg) {
  *Change__POINT(this) = point;
  *Change__IDX(this) = idx;
  *Change__PREVIOUS(this) = previous;
  *Change__ISARG(this) = isArg;
  return this;
}

#line 1450 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
void
Change_Dtor(Change this) {
}

#line 1458 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
void
Change_undo(Change this) {
  if(Change_ISARG(this)) {
    Operation_setArgument(Change_POINT(this), Change_IDX(this),
                          Change_PREVIOUS(this));
  } else {
    Operation_setResult(Change_POINT(this), Change_IDX(this),
                        Change_PREVIOUS(this));
  }
}

#line 1484 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static void
OutOfColoredSSA_RpcForArc (OutOfColoredSSA this, BasicBlockEdge E, Rpc Rpc, bool after)
{
  BasicBlock B;
  IDList_ changes[1];
  B = BasicBlockEdge_destBlock(E);
  IDList_Ctor(changes, OutOfColoredSSA_memory(this));

#line 1492 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  BasicBlock_FOREACH_Operation(B, operation) {
    if (OutOfColoredSSA_isPHI(this, operation)) {
      /* Add in Rpc Rk -> Rj where Rk comes from E in
       * Rj = phi(...Rk...) 
       */
      int Rj, Rk;
      int argIdx = OutOfColoredSSA_getPHIArgIdx(operation, E);
      Temporary arg =  Operation_getArgument(operation, argIdx);
      Temporary res =  OutOfColoredSSA_getPHIResult(operation);
      // if we are in after case, interferences may exists
      // and doing the transformation may produce incorrect code.
      // Check live in to see interference
      if(after == true
         // interference exists if I am live in or my color is live in
         && (BasicBlock_isLiveIn(B, arg)
             || BasicBlock_colorIsLiveIn(B, Temporary_register(arg)))) {
        // Undo changes
        Rpc_clear(Rpc);
        IDList_FORBACK(changes, Change_, change) {
          Change_undo(change);
        } IDList_ENDBACK;
        break;
      }
      Rk = OutOfColoredSSA_temporaryReg(this, arg);
      Rj = OutOfColoredSSA_temporaryReg(this, res);
      Except_CHECK(Rk != -1);
      Except_CHECK(Rj != -1);
      // Check if there is a duplication, because it is not handle currently
      Except_CHECK(Rpc_TO(Rpc)[Rk] == -1);
      Except_CHECK(Rpc_INV(Rpc)[Rj] == -1);
      Rpc_TO(Rpc)[Rk] = Rj;
      Rpc_INV(Rpc)[Rj] = Rk;
      {
        Change_ change;
        if (after) {
          /* Replace result in phi: Rk = phi(..., Rk, ...). */
          Change_Ctor(&change, operation, 0,
                      Operation_getResult(operation, 0), false);
          Operation_setResult(operation, 0, arg);
        } else {
          Change_Ctor(&change, operation, argIdx,
                      Operation_getArgument(operation, argIdx), true);
          Operation_setArgument(operation, argIdx, res);
        }
        IDList_PUSH(changes, Change_, change);
      }
    }
  } BasicBlock_ENDEACH_Operation;
  IDList_FORBACK(changes, Change_, change) {
    Change_Dtor(change);
  } IDList_ENDBACK;
  IDList_Dtor(changes);
}

#line 1546 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static bool
OutOfColoredSSA_cmove_condition(OutOfColoredSSA this, BasicBlockEdge E, Rpc Rpc)
{
  /* We cannot generate a conditional swap. Thus ensure that live out
     of the block it not already at maxlive. */
  bool liveOut[MAX_RPC];
  int nRegs = Rpc_nRegs(Rpc);
  int i;
  BasicBlock orig = BasicBlockEdge_origBlock(E);
  OutOfColoredSSA_initLiveOut(this, orig, liveOut, true);
  for (i = 0; i < nRegs; i++) {
    if (!liveOut[i]) return true;
  }
  return false;
}

#line 1562 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
/**************************************
 * BEGIN: fonctions using RPC
 * (reversible parallel copies)
 **************************************/

#line 1578 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static int Rpc_moveCount(Rpc rpc)
{
  int nRegs = Rpc_nRegs(rpc);
  bool Tmp[MAX_RPC];
  int Ri;
  int cost=0;

#line 1585 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  bool needswap=true;
  for (Ri=0; Ri<nRegs; Ri++) {
    if (Rpc_TO(rpc)[Ri]==-1) {
      needswap=false;
      break;
    }
  }

#line 1593 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  for (Ri=0; Ri<nRegs; Ri++) Tmp[Ri]=false;

#line 1595 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  for (Ri=0; Ri<nRegs; Ri++) {
    int Rj=Ri;
    while (Tmp[Rj]==false) {
      int Rk=Rpc_TO(rpc)[Rj];
      Tmp[Rj]=true;
      if (Rk != -1 && Rk != Rj) {
        cost+= needswap? SWAPCOST: 1;
        // if Tmp[Rk] == true, we are in a cycle and two cases are possible:
        // * a temporary is available: we need n+1 copies
        // * no temporary is available: we need n-1 swap
        if (Tmp[Rk]==true) cost += needswap? -SWAPCOST: 1;
      } else {
        break;
      }
      Rj = Rk;
    }
  }

#line 1613 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  return cost;
}

#line 1623 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
float Rpc_CostOnEdge(Rpc rpc, BasicBlockEdge E, bool cond)
{  
  float weight, tmp;
  float cost;
  int count = Rpc_moveCount(rpc);
  if (count == 0) return 0.0;

#line 1630 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  if (BasicBlockEdge_isSweetTop(E, &weight)) {
    cost = MOVE_COST*count*weight;
  } else if (BasicBlockEdge_isSweetBottom(E, &weight)) {
    cost = MOVE_COST*count*weight;
  } else if (cond) {	
    BasicBlock dest = BasicBlockEdge_destBlock(E);
    cost = COND_MOVE_COST*count*BasicBlock_frequency(dest); // TODO: compenser av ec la Rpc en fin de dest...
    // TODO: when at maxlive, permutations are required, which cannot be
    // predicated, hence the cost should be the normal cost.
  } else if (BasicBlockEdge_isFalse(E, &weight)) {
    cost = CEIL(MOVE_COST*count)*weight;
  } else {
    weight = BasicBlock_frequency(BasicBlockEdge_origBlock(E))*BasicBlockEdge_probability(E);
    cost = (CEIL(MOVE_COST*count+BRANCH_COST)+BRANCH_PENALTY)*weight;
  } 
  return cost;
}

#line 1655 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
float Rpc_CostOnBlockBottom(OutOfColoredSSA this, Rpc rpc, BasicBlock B)
{
  float min_cost;
  float weight = BasicBlock_frequency(B);
  Rpc_ rpccopy_ = *rpc;
  Rpc rpccopy = &rpccopy_;
  min_cost = Rpc_moveCount(rpccopy) * weight;

#line 1663 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  BasicBlock_FORBACK_Operation(B, operation) {
    float cost;
    if (Operation_operator(operation) == Operator_PHI
        || !(adjustRpcWithDeadDefinition(this, operation, rpccopy)
             && Traverse_DownUp(this,operation, rpccopy, true, NULL))) {
      break;
    }
    cost = Rpc_moveCount(rpccopy) * weight;
    min_cost = MIN(min_cost, cost);
  } BasicBlock_ENDBACK_Operation;

#line 1674 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  return min_cost;
}

#line 1682 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static bool
adjustRpcWithDeadDefinition(OutOfColoredSSA this, Operation op, Rpc rpc) {
  RegisterSet_ deadColor[1];
  RegisterSet_Ctor(deadColor);
  Operation_RESULTS_FOREACH_Temporary(op, temp) {
    int reg = OutOfColoredSSA_temporaryReg(this, temp);
    if(reg != -1 && Rpc_TO(rpc)[reg] == -1
       && Rpc_INV(rpc)[reg] != -1) {
      // we are on a dead definition, but the color has been used to save
      // another live variable.
      // E.g.
      // Ra, Rb = setFlag
      // Rz = add Rx, Rw
      // Rx = Ry
      // Rx = RPC Rx
      // Moving RPC form bottom to top
      // -> step 1
      // Ra, Rb = setFlag
      // Rz = add Rx, Rw
      // Rx = RPC Ry
      // Rx = Rx
      // -> step 2
      // Ra, Rb = setFlag
      // Rx, Ra = RPC Ry, Rx // see comment hereafter
      // Rz = add Ra, Rw // Rx is used save its value in Ra
      // Rx = Rx
      // -> step 3
      // Ra, Rb = setFlag // <- we are blocked because we do not see Ra color
      //                  //    is no more available
      // *
      // Rx, Ra = RPC Ry, Rx
      // Rz = add Ra, Rw
      // Rx = Rx
      // OUR SOLUTION: insert at * a dummy operation that uses Ra
      RegisterSet_insert(deadColor, Temporary_register(temp));
    }
  } Operation_RESULTS_ENDEACH_Temporary;
  if(!RegisterSet_isEmpty(deadColor)) {
    BasicBlock basicBlock = Operation_basicBlock(op);
    Selector curSelector = BasicBlock_selector(basicBlock);
    Operation dummyUsage = Selector_makeOperation_(curSelector, 0 /*dummy op*/,
                                                   0/*nbOfRes*/,
                                                   RegisterSet_count(deadColor),
                                                   NULL);
    int32_t argIdx = 0, res;
    Procedure procedure = BasicBlock_procedure(basicBlock);
    
    RegisterSet_FOREACH_Register(deadColor, reg) {
      Operation_setArgument(dummyUsage, argIdx,
                            Procedure_makeAssignedTemporary(procedure, reg));
      ++argIdx;
    } RegisterSet_ENDEACH_Register;
    res = Traverse_DownUp(this, dummyUsage, rpc, true, NULL);
    Except_CHECK(res != 0);
    Selector_detachOperation(curSelector, dummyUsage);
  }
  return true;
}

#line 1748 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
void Rpc_motionUpfromBlockBottom(OutOfColoredSSA this, Rpc rpc, BasicBlock B)
{
  float min_cost;
  float weight = BasicBlock_frequency(B);
  Rpc_ rpccopy_ = *rpc;
  Rpc rpccopy = &rpccopy_;
  Rpc_ optRpc_ = *rpc;
  Rpc optRpc = &optRpc_;
  bool OpIsNext = true;
  Operation optOp = NULL;
  BasicBlock curBB, stopBB = NULL, optBB = NULL;
  double costIncludedMoves = 0.0;
  int32_t swallowMoves = getenv("SWALLOW_MOVES") != NULL;

#line 1762 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  min_cost = Rpc_moveCount(rpccopy) * weight;
  BasicBlock_FORBACK_ContinusOperation(B, curBB, operation) {
    double cost;
    if (OpIsNext) {
        optOp = operation;
        OpIsNext = false;
        optBB = curBB;
    }
    if (Operation_operator(operation) == Operator_PHI
        || !(adjustRpcWithDeadDefinition(this, operation, rpccopy)
             && Traverse_DownUp(this,operation, rpccopy, true, &costIncludedMoves))) {
      break;
    }
    // FIXME: Here we can have a rouding problem.
    // Thus costIncludedMoves is a sum of float whereas moveCount * weight is
    // a product. In some cases, it does not gives the same results whereas it
    // should. What is a good epsilon to consider cost to be zero?
    // Currently we use double precision
    cost = Rpc_moveCount(rpccopy) * weight - (costIncludedMoves * swallowMoves);
    if (((float)cost) < min_cost
        // if cost is equal, try to go before control operation.
        // This is to avoid edges splitting
        || (((float)cost) == min_cost
            && Operator_isControl(Operation_operator(operation)))) {
      optRpc_ = rpccopy_;
      min_cost = cost;
      OpIsNext = true;
    }
  } BasicBlock_ENDBACK_ContinusOperation;
  if (OpIsNext) {
    optOp=NULL;
    optBB = curBB;
  }
  if(optOp != NULL
     && Operator_isControl(Operation_operator(optOp))) {
    if(!Rpc_isIdentity(rpccopy)) {
      BasicBlock dstBB = NULL;
      Except_CHECK(BasicBlock_leaveCount(curBB) > 0);
      dstBB = BasicBlockEdge_destBlock(BasicBlock_leaveFirst(curBB));
      // LAO constraint: We cannot insert instruction after control operation
      // In that case, we must split each leave edges
      Except_CHECK((BasicBlock_leaveCount(curBB) == 1
                    && BasicBlock_enterCount(dstBB) == 1)
                   && "Not yet implemented");
      stopBB = curBB;
      // begining of the block
      optBB = dstBB;
      optOp = NULL;
    }
  }
  rpccopy_=*rpc;
  BasicBlock_FORBACK_ContinusOperation(B, curBB, operation) {
    if ((optOp != NULL
         && Operation_identity(operation) == Operation_identity(optOp))
        || (stopBB != NULL && curBB == stopBB)) {
      break;
    }
    if (Operation_operator(operation) == Operator_PHI) Except_CHECK(0);
    if (!(adjustRpcWithDeadDefinition(this, operation, rpccopy)
          && Traverse_DownUp(this,operation, rpccopy, false, NULL))) {
      Except_CHECK(0);
    }
  } BasicBlock_ENDBACK_ContinusOperation;

#line 1826 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  {
    int moves[(MAX_RPC+1)*3];
    Rpc_getMoveList(optRpc, moves);
    Except_CHECK(optOp == NULL || optBB == Operation_basicBlock(optOp));
    OutOfColoredSSA_generateMovesFab(this, optBB, optOp, moves);
  }
}

#line 1841 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
void Rpc_motionDownfromBlockTop(OutOfColoredSSA this, Rpc rpc, BasicBlock B)
{
  float min_cost;
  float weight = BasicBlock_frequency(B);
  Rpc_ rpccopy_ = *rpc;
  Rpc rpccopy = &rpccopy_;
  Rpc_ optRpc_ = *rpc;
  Rpc optRpc = &optRpc_;
  Operation optOp = NULL;

#line 1851 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  min_cost = Rpc_moveCount(rpccopy) * weight;
  
  // find the optimal place
  BasicBlock_FOREACH_Operation(B, operation) {
    float cost;
    if (Operation_operator(operation) == Operator_PHI) continue;
    if (!Traverse_UpDown(this,operation, rpccopy, true)) {
      break;
    }
    cost = Rpc_moveCount(rpccopy) * weight;
    if (cost < min_cost) { 
      optRpc_ = rpccopy_; 
      min_cost = cost;	
      optOp = operation;
    }
  } BasicBlock_ENDEACH_Operation;

#line 1868 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  // move down
  rpccopy_=*rpc;
  BasicBlock_FOREACH_Operation(B, operation) {
    if (Operation_operator(operation) == Operator_PHI) continue;
    // After adding rpc on the edges, we should remove the phis
    if (optOp==NULL) {
      optOp = Operation_prev(operation);
      break;
    }
    if (!Traverse_UpDown(this,operation, rpccopy, false)) Except_CHECK(0);
    if (Operation_identity(optOp) == Operation_identity(operation)) {
      break;
    }
  } BasicBlock_ENDEACH_Operation;

#line 1883 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  // generate the rpc
  {
    int moves[(MAX_RPC+1)*3];
    Rpc_getMoveList(optRpc, moves);
    Except_CHECK((Rpc_isIdentity(optRpc) || optOp == NULL
                  || !Operator_isControl(Operation_operator(optOp)))
                 && "Not yet implemented");
    OutOfColoredSSA_generateMovesFab(this, B, optOp, moves);
  }
}

#line 1901 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
float Rpc_CostOnBlockTop(OutOfColoredSSA this, Rpc rpc, BasicBlock B)
{
  float min_cost;
  float weight = BasicBlock_frequency(B);
  Rpc_ rpccopy_ = *rpc;
  Rpc rpccopy = &rpccopy_;
  min_cost = Rpc_moveCount(rpccopy) * weight;

#line 1909 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  BasicBlock_FOREACH_Operation(B, operation) {
    float cost;
    if (Operation_operator(operation) == Operator_PHI) continue;
    if (!Traverse_UpDown(this,operation, rpccopy, true)) {
      break;
    }
    cost = Rpc_moveCount(rpccopy) * weight;
    min_cost = MIN(min_cost, cost);
  } BasicBlock_ENDEACH_Operation;
  return min_cost;
}

#line 1929 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static void Rpc_invert( Rpc rpc, Rpc rpcinv)
{
  int i;
  int nRegs = Rpc_nRegs(rpc);
  
  for(i=0; i < nRegs; i++) {
    // rpc and rpcinv can be the same object: use a temporary
    int tmp = Rpc_TO(rpc)[i];
    Rpc_TO(rpcinv)[i] = Rpc_INV(rpc)[i];
    Rpc_INV(rpcinv)[i] = tmp;
  }
}

#line 1952 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static
void Expand_in (OutOfColoredSSA this, Rpc rpc, bool *liveIn)
{ 
  int nRegs = OutOfColoredSSA_nRegs(this);
  int Ri;

#line 1958 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  /* Asserts that the old set of live in is included in the new set */
  for (Ri = 0; Ri < nRegs; Ri++) {
    if (Rpc_TO(rpc)[Ri]!=-1) Except_CHECK(liveIn[Ri]);
  }

#line 1963 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  /* If in liveIn and unconnected, force self-edge. */
  OutOfColoredSSA_connectLiveNode(this, liveIn, rpc);

#line 1966 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  OutOfColoredSSA_saveRemainingLive(this, liveIn, rpc);
  Except_CHECK(Rpc_check(rpc));
}

#line 1980 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static
void Expand_out (OutOfColoredSSA this, Rpc rpc, bool *liveOut)
{ 
  //TODO: eventuellement, ca sert a rien rpcinv
  Rpc rpcinv=rpc;
  bool *liveIn;

#line 1987 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  Rpc_invert( rpc, rpcinv);
  liveIn = liveOut;

#line 1990 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  Expand_in(this, rpcinv, liveIn);

#line 1992 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  Rpc_invert( rpcinv, rpc);
}

#line 2001 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static void Operation_live(OutOfColoredSSA this, Operation op, bool *live)
{
  int nRegs = OutOfColoredSSA_nRegs(this);  
  BasicBlock BB=Operation_BASICBLOCK(op);
  OutOfColoredSSA_initLiveOut(this, BB, live, true);

#line 2008 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  BasicBlock_FORBACK_Operation( BB, operation) {
    // Should not be a PHI operation
    Except_CHECK(Operation_operator(operation) != Operator_PHI); 
    
    Operation_RESULTS_FOREACH_Temporary( operation, temporary) {
      int Ri = OutOfColoredSSA_temporaryReg(this, temporary);
      if (Ri!=-1) live[Ri]=false;
    } Operation_RESULTS_ENDEACH_Temporary;			
  
    if(Operation_hasClobber(operation)) {
      RegisterSet clobberSet = Operation_clobberSet(operation);
      RegisterSet_FOREACH_Register(clobberSet, reg_clobber) {
        Temporary temporary_clobber = OutOfColoredSSA_getDedicated(this, reg_clobber); 
        int Ri = OutOfColoredSSA_temporaryReg(this, temporary_clobber);
        if (Ri!=-1) live[Ri]=false;
      } RegisterSet_ENDEACH_Register;
    }
  
    if (Operation_identity(op) == Operation_identity(operation)) return;

#line 2028 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
    Operation_ARGUMENTS_FOREACH_Temporary( operation, temporary) {
      int Ri = OutOfColoredSSA_temporaryReg(this, temporary);
      if (Ri!=-1) live[Ri]=true;
    } Operation_ARGUMENTS_ENDEACH_Temporary;
  } BasicBlock_ENDBACK_Operation;

#line 2034 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  Except_CHECK(0);
}

#line 2043 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static void Rpc_livein(Rpc rpc, bool *live)
{
  int i=0;
  for(;i<Rpc_nRegs(rpc);i++)
    live[i] = Rpc_TO(rpc)[i] != -1;
}

#line 2050 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
 
//@XCC_.h
/*
 * Return the set of liveout registers of a RPC
 */
static void Rpc_liveout(Rpc rpc, bool *live);

#line 2057 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static void Rpc_liveout(Rpc rpc, bool *live)
{
  int i=0;
  for(;i<Rpc_nRegs(rpc);i++)
    live[i] = Rpc_INV(rpc)[i] != -1;
}

#line 2064 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static void
Operation_reassignRegisterResult(OutOfColoredSSA this,
                                 Operation op, int32_t idx, Register reg) {
  Temporary temp = Operation_getResult(op, idx);
#if 1
  if(Temporary_register(temp) != reg) {
    temp = Procedure_makeAssignedTemporary(OutOfColoredSSA_procedure(this), reg);
    Operation_setResult(op, idx, temp);
  }
#else
  if(Temporary_register(temp) != reg) {
    Except_CHECK(Temporary_hasRegister(temp));
    Temporary_unassignRegister(temp);
    Temporary_assignRegister(temp, reg);
  }
#endif
}

#line 2082 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static void
Operation_reassignRegisterArgument(OutOfColoredSSA this,
                                   Operation op, int32_t idx, Register reg) {
  Temporary temp = Operation_getArgument(op, idx);
  if(Temporary_register(temp) != reg) {
    temp = Procedure_makeAssignedTemporary(OutOfColoredSSA_procedure(this), reg);
    Operation_setArgument(op, idx, temp);
  }
}

#line 2092 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
/**
   Compute rpc1 o rpc2 into rpc3 ie rpc2 followed by rpc1...
   Inplace composition possible.
*/
static void Rpc_o_Rpc(Rpc rpc1, Rpc rpc2, Rpc rpc3);

#line 2106 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static int Traverse_DownUp(OutOfColoredSSA this, Operation op, Rpc rpc, bool simulate, double *p_costIncludedMoves)
{
  RegFile regFile = OutOfColoredSSA_regFile(this);
  int nRegs = OutOfColoredSSA_nRegs(this);
  bool liveIn[MAX_RPC];
  bool definedColors[MAX_RPC];
  float bbCost = BasicBlock_frequency(Operation_basicBlock(op));
  memset(definedColors, false, sizeof(bool) * MAX_RPC);

#line 2115 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  /* Do not traverse clobbers. */
//  if (Operation_hasClobber(op)) return 0;

#line 2118 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  /* Check first that the function does not contain any temporary
     that we have to recolor but we cannot. */
  /* Check in def list */
  Operation_RESULTS_FOREACH_Temporary( op, temporary) {
    int def = OutOfColoredSSA_temporaryReg(this, temporary);
    if (def==-1) continue;
    definedColors[def] = true;

#line 2126 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
    // either def goes on some or def is death, that is why we do not see it.
    // In the case variable is dead then, we should see its color like a
    // clobber.
    Except_CHECK(Rpc_TO(rpc)[def]!=-1 || Rpc_INV(rpc)[def] == -1);
    if (Temporary_isDedicated(temporary) &&
        ((Rpc_TO(rpc)[def]!=def && Rpc_TO(rpc)[def]!=-1) 
         || (Rpc_INV(rpc)[def]!=def && Rpc_INV(rpc)[def]!=-1)) 
        ) return 0;
  } Operation_RESULTS_ENDEACH_Temporary;
  
  /* Check in Clobber list */
  if (Operation_hasClobber(op)) {
    RegisterSet clobberSet = Operation_clobberSet(op);
    Temporary temporary_clobber = NULL;
    RegisterSet_FOREACH_Register(clobberSet, clobber) {
      int clob = OutOfColoredSSA_temporaryReg(this, OutOfColoredSSA_getDedicated(this, clobber));
      if (clob==-1) continue;
      // if our color is in the rpc, this means our live range do not cross
      // that operation, thus, we cannot go up.
      if (Rpc_TO(rpc)[clob]!=-1
          || Rpc_INV(rpc)[clob]!=-1) return 0;
    } RegisterSet_ENDEACH_Register;
  }

#line 2150 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  /* Check in use list */
  Operation_ARGUMENTS_FOREACH_Temporary( op, temporary) {
    int use = OutOfColoredSSA_temporaryReg(this, temporary);
    if (use==-1) continue;
    if (Temporary_isDedicated(temporary) &&
        ((Rpc_TO(rpc)[use]!=use && Rpc_TO(rpc)[use]!=-1) 
         || (Rpc_INV(rpc)[use]!=use && Rpc_INV(rpc)[use]!=-1)) 
        ) return 0;
  } Operation_ARGUMENTS_ENDEACH_Temporary;

#line 2160 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  if(Operator_isSeqCopy(Operation_operator(op))) {
    Temporary res = Operation_getResult(op, 0);
    Temporary arg = Operation_getArgument(op, 0);
    if(OutOfColoredSSA_temporaryReg(this, res) != -1
       && OutOfColoredSSA_temporaryReg(this, arg) != -1) {
      int32_t resReg = OutOfColoredSSA_temporaryReg(this, res);
      int32_t argReg = OutOfColoredSSA_temporaryReg(this, arg);
      if(Rpc_TO(rpc)[argReg] == -1) {
        // this is not a duplication
        if(Rpc_TO(rpc)[resReg] != -1) {
          Rpc_TO(rpc)[argReg] = Rpc_TO(rpc)[resReg];
          Rpc_INV(rpc)[Rpc_TO(rpc)[argReg]] = argReg;
          if(resReg != argReg) {
            Rpc_TO(rpc)[resReg] = -1;
          }
          if(p_costIncludedMoves != NULL) {
            *p_costIncludedMoves += bbCost;
          }
          if (!simulate) {
            // after going up on something like this:
            // Ry <- Ri
            // Rk <- RPC Ry
            // it will give:
            // first:
            // Rk <- Ri
            // Rk <- RPC Ri
            // second:
            // Rk <- RPC Ri
            // Rk <- Rk
            // second phase is done by standard processing
            // only do the first step here
            Operation_reassignRegisterResult(this, op, 0,
                                             id_to_register_map[Rpc_TO(rpc)[argReg]]);
            Operation_reassignRegisterArgument(this, op, 0,
                                               id_to_register_map[Rpc_TO(rpc)[argReg]]);
          }
          return 1;
        } // else, code is dead
      }
    }
    // assume parCopy are Rpc
  } else if(Operator_isParCopy(Operation_operator(op))
            && Temporary_regFile(Operation_getResult(op, 0)) == regFile) {
    // build the rpc and compose it with the current one
    int32_t idx;
    Rpc_ curRpc[1];
    bool compose = true;
    Rpc_Ctor(curRpc, nRegs);
    for(idx = 0; idx < Operation_resCount(op); ++idx) {
      Temporary res = Operation_getResult(op, idx);
      Temporary arg = Operation_getArgument(op, idx);
      int32_t resReg = OutOfColoredSSA_temporaryReg(this, res);
      int32_t argReg = OutOfColoredSSA_temporaryReg(this, arg);
      Except_CHECK(resReg != -1 && argReg != -1);
      // duplication not supported
      if(Rpc_TO(curRpc)[argReg] != -1) {
        compose = false;
        fprintf(stderr, "WARNING: parallel copy should be reversal but is not\n");
        break;
      }
      Rpc_TO(curRpc)[argReg] = resReg;
      Rpc_INV(curRpc)[resReg] = argReg;
    }
    // add live through color
    for(idx = 0; idx < MAX_RPC; ++idx) {
      if(Rpc_TO(curRpc)[idx] != -1
         && definedColors[idx] == false
         && Rpc_TO(rpc)[idx] != -1) {
        // there is a duplication
        compose = false;
        break;
      }
      if(Rpc_TO(curRpc)[idx] == -1
         && definedColors[idx] == false
         && Rpc_TO(rpc)[idx] != -1) {
        // live through color
        Rpc_TO(curRpc)[idx] = idx;
        Except_CHECK(Rpc_INV(curRpc)[idx] == -1);
        Rpc_INV(curRpc)[idx] = idx;
      }
    }
    if(compose) {
      Rpc_ rpcTmp[1];
      Rpc_Ctor(rpcTmp, nRegs);
      Rpc_o_Rpc(rpc, curRpc, rpcTmp);
      *rpc = *rpcTmp;
      if(!simulate) {
        Operation_ARGUMENTS_FOREACH_Temporary(op, arg) {
          int32_t argReg = OutOfColoredSSA_temporaryReg(this, arg);
          if(p_costIncludedMoves != NULL) {
            *p_costIncludedMoves += bbCost;
          }
          Operation_reassignRegisterResult(this, op, Operation_ARGUMENTS_INDEX,
                                           id_to_register_map[Rpc_TO(rpc)[argReg]]);
          Operation_reassignRegisterArgument(this, op, Operation_ARGUMENTS_INDEX,
                                             id_to_register_map[Rpc_TO(rpc)[argReg]]);
        } Operation_ARGUMENTS_ENDEACH_Temporary;
      }
      Rpc_Dtor(rpcTmp);
      Rpc_Dtor(curRpc);
      return 1;
    }
    Rpc_Dtor(curRpc);
  }

#line 2265 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  /* Now traverse upward the definitions */
  Operation_RESULTS_FOREACH_Temporary( op, temporary) {
    int Ry, Ri = OutOfColoredSSA_temporaryReg(this, temporary);
    if (Ri==-1) continue;
    Ry=Rpc_TO(rpc)[Ri];
    Rpc_TO(rpc)[Ri]=-1; Rpc_INV(rpc)[Ry]=-1; // project
    if (!simulate && Ry != -1) { // Ry == -1: dead variable
      // For result, recoloring is global because we assume there is no
      // duplication. Otherwise, we should do a phase of ssa reconstruct +
      // handling new created phi!
      // A better method is to be sure to remove all duplications before
      // applying this algorithm
      Operation_reassignRegisterResult(this, op, Operation_RESULTS_INDEX,
                                       id_to_register_map[Ry]);
    }
  } Operation_RESULTS_ENDEACH_Temporary;

#line 2282 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  /* Then traverse upward the arguments */
  {int i;   for (i=0; i < nRegs; i++) liveIn[i] = (Rpc_TO(rpc)[i]!=-1); }
  Operation_ARGUMENTS_FOREACH_Temporary( op, temporary) {
    int use = OutOfColoredSSA_temporaryReg(this, temporary);
    if (use != -1) liveIn[use] = true;
  } Operation_ARGUMENTS_ENDEACH_Temporary;
  Expand_in(this, rpc, liveIn); // Risque de bug ici car on risque d'expander en utilisant un registre dedie. 
  Operation_ARGUMENTS_FOREACH_Temporary( op, temporary) {
    int Ri = OutOfColoredSSA_temporaryReg(this, temporary);
    int Ry;
    if (Ri==-1) continue;
    Ry = Rpc_TO(rpc)[Ri];
    Except_CHECK(Ry!=-1);
    if (!simulate) {
      // recoloring is local, we cannot reassign temporary globaly on its
      // liverange.
      // E.g.
      // Rx =
      // call {Ry} // Ry is clobber
      // = Rx
      // Ry = Rx // Try to move up this RPC
      // ->
      // Ry will not go up to definition of Rx because of the call
      // but it may be cheaper to move this RPC anyway
      Operation_reassignRegisterArgument(this, op, Operation_ARGUMENTS_INDEX,
                                         id_to_register_map[Ry]);
    }
  } Operation_ARGUMENTS_ENDEACH_Temporary;

#line 2311 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  return 1;
}

#line 2314 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static bool
temporaryIsUnallocatable(Temporary temp, Operation op, int32_t opndIdx,
                         void* outOfColoredSSA) {
  OutOfColoredSSA this = (OutOfColoredSSA)outOfColoredSSA;
  return OutOfColoredSSA_temporaryReg(this, temp) == -1;
}

#line 2321 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static void
OutOfColoredSSA_removeUnallocatableColorFromParCopies(OutOfColoredSSA this) {
  GRA_removeCheckedColorFromParCopies(OutOfColoredSSA_codeRegion(this),
                                      OutOfColoredSSA_memory(this),
                                      OutOfColoredSSA_regFile(this),
                                      this, temporaryIsUnallocatable);
}

#line 2335 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static void Project_out(OutOfColoredSSA this, Rpc rpc, bool *liveOut)
{
  int nRegs = OutOfColoredSSA_nRegs(this);
  int Ri;

#line 2340 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  /* Asserts that the set of live out is included in the liveout set of the 
   * RPC */
  for (Ri = 0; Ri < nRegs; Ri++) {
    if (liveOut[Ri]) Except_CHECK(Rpc_INV(rpc)[Ri]!=-1);
  }

#line 2346 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  for(Ri=0; Ri < nRegs; Ri++) {
    if (!liveOut[Ri]) {
      if (Rpc_INV(rpc)[Ri] != -1) {
        Rpc_TO(rpc)[Rpc_INV(rpc)[Ri]] = -1;
        Rpc_INV(rpc)[Ri] = -1;
      }
    }
  }
}

#line 2365 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static int Traverse_UpDown(OutOfColoredSSA this, Operation op, Rpc rpc, bool simulate)
{
  RegFile regFile = OutOfColoredSSA_regFile(this);
  int nRegs = OutOfColoredSSA_nRegs(this);
  bool live[MAX_RPC];

#line 2372 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  /* Do not traverse clobbers. */
//  if (Operation_hasClobber(op)) return 0;

#line 2376 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  /* Check first that the instruction does not contain any temporary
     that we have to recolor but we cannot. */
  /* Check in use list */
  Operation_ARGUMENTS_FOREACH_Temporary( op, temporary) {
    int use = OutOfColoredSSA_temporaryReg(this, temporary);
    if (use==-1) continue;
    Except_CHECK(Rpc_INV(rpc)[use]!=-1);
    if (Temporary_isDedicated(temporary) &&
        ((Rpc_TO(rpc)[use]!=use && Rpc_TO(rpc)[use]!=-1) 
         || (Rpc_INV(rpc)[use]!=use && Rpc_INV(rpc)[use]!=-1)) 
        ) return 0;
  } Operation_ARGUMENTS_ENDEACH_Temporary;
  
  /* Check in Clobber list */
  if(Operation_hasClobber(op)) {
    RegisterSet clobberSet = Operation_clobberSet(op);
    Temporary temporary_clobber = NULL;
    RegisterSet_FOREACH_Register(clobberSet, clobber) {
      int clob = OutOfColoredSSA_temporaryReg(this, OutOfColoredSSA_getDedicated(this, clobber));
      if (clob==-1) continue;
      // if our color is in the rpc, this means our live range do not cross
      // that operation, thus, we cannot go down.
      if (Rpc_TO(rpc)[clob]!=-1
          || Rpc_INV(rpc)[clob]!=-1) return 0;
    } RegisterSet_ENDEACH_Register;
  }

#line 2403 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  /* Check in def list */
  Operation_RESULTS_FOREACH_Temporary( op, temporary) {
    int def = OutOfColoredSSA_temporaryReg(this, temporary);
    if (def==-1) continue;
    if (!Temporary_isDedicated(temporary) &&
        ((Rpc_TO(rpc)[def]!=def && Rpc_TO(rpc)[def]!=-1) 
         || (Rpc_INV(rpc)[def]!=def && Rpc_INV(rpc)[def]!=-1)) 
        ) return 0;
  } Operation_RESULTS_ENDEACH_Temporary;

#line 2413 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  
  /* Now traverse downward the arguments */
  Operation_ARGUMENTS_FOREACH_Temporary( op, temporary) {
    int Ry, Ri = OutOfColoredSSA_temporaryReg(this, temporary);
    if (Ri==-1) continue;
    Ry=Rpc_INV(rpc)[Ri];
    if (!simulate) {
      Operation_reassignRegisterArgument(this, op, Operation_ARGUMENTS_INDEX,
                                         id_to_register_map[Ry]);
    }
  } Operation_ARGUMENTS_ENDEACH_Temporary;
  Operation_live(this, op, live);
  Project_out(this, rpc, live);

#line 2427 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  /* Then traverse downward the definitions */
  Operation_RESULTS_FOREACH_Temporary( op, temporary) {
    int def = OutOfColoredSSA_temporaryReg(this, temporary);
    if (def != -1) live[def] = true; // le risque c'est de descendre une variable dead ici.
  } Operation_RESULTS_ENDEACH_Temporary;
  Expand_out(this, rpc, live); // Risque de bug ici car on expand sans savoir si on utilise pas un dedicated
  Operation_RESULTS_FOREACH_Temporary( op, temporary) {
    int Ri = OutOfColoredSSA_temporaryReg(this, temporary);
    int Ry;
    if (Ri==-1) continue;
    Ry=Rpc_INV(rpc)[Ri];
    Except_CHECK(Ry!=-1);
    if (!simulate) {
      Operation_reassignRegisterResult(this, op, Operation_RESULTS_INDEX,
                                       id_to_register_map[Ry]);
    }
  } Operation_RESULTS_ENDEACH_Temporary;

#line 2445 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  return 1;
}

#line 2449 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static void Rpc_o_Rpc(Rpc rpc1, Rpc rpc2, Rpc rpcRes)
{
  int nRegs = Rpc_nRegs(rpc1);
  int Ri, Rj, Rk;

#line 2454 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  /* check that the number of live variables (number of edges) is the same in rpc1 anbd rpc2. */
  int nedges12=0;
  int i;
  Rpc_ rpcTmp[1];
  Rpc rpc3;

#line 2460 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  for (i=0; i<nRegs; i++) {
    if(Rpc_TO(rpc1)[i]!=-1) nedges12++;
    if(Rpc_TO(rpc2)[i]!=-1) nedges12--;
  }
  Except_CHECK(nedges12==0);

#line 2466 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  // it is complicated, when doing the composition with same rpc as destination,
  // to remove permutations no longer needed or incompletes. Thus, we use a
  // temporary one.
  if(rpc1 == rpcRes) {
    Rpc_Ctor(rpcTmp, Rpc_nRegs(rpc1));
    rpc3 = rpcTmp;
  } else {
    rpc3 = rpcRes;
  }

#line 2476 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  /* treat forward edges Ri -(rpc2)-> Rj -(rpc1)-> Rk */
  for (Ri=0; Ri<nRegs; Ri++) {
    Rj=Rpc_TO(rpc2)[Ri];
    if (Rj!=-1) {
      Rk = Rpc_TO(rpc1)[Rj];
      Except_CHECK(Rk != -1);
      Rpc_INV(rpc3)[Rk]=Ri;
    }
    else Rk=-1;
    Rpc_TO(rpc3)[Ri]=Rk;
  }

#line 2488 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  Except_CHECK(Rpc_check(rpc3));

#line 2490 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  if(rpc3 != rpcRes) {
    *rpcRes = *rpc3;
  }
}

#line 2504 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static void BasicBlockEdge_initialRpc(OutOfColoredSSA this, BasicBlockEdge E, Rpc rpc)
{
  BasicBlock B;
  bool liveIn[MAX_RPC];
  int i, nRegs = OutOfColoredSSA_nRegs(this);

#line 2510 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  B = BasicBlockEdge_destBlock(E);
  /* phi flows */ 
  BasicBlock_FOREACH_Operation(B, operation) {
    if (OutOfColoredSSA_isPHI(this, operation)) {
      /* Add in rpc Rk -> Rj where Rk comes from E in
       * Rj = phi(...Rk...) 
       */
      int Rj, Rk;
      int argIdx = OutOfColoredSSA_getPHIArgIdx(operation, E);
      Temporary arg =  Operation_getArgument(operation, argIdx);
      Temporary res =  OutOfColoredSSA_getPHIResult(operation);
      Rk = OutOfColoredSSA_temporaryReg(this, arg);
      Rj = OutOfColoredSSA_temporaryReg(this, res);
      Except_CHECK(Rk != -1);
      Except_CHECK(Rj != -1);
      Rpc_TO(rpc)[Rk] = Rj;
      Rpc_INV(rpc)[Rj] = Rk;
      /*       fprintf(stderr, " initial: phi %d -> %d\n", Rk, Rj);*/
    } 
  } BasicBlock_ENDEACH_Operation;

#line 2531 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  Except_CHECK(Rpc_check(rpc));

#line 2533 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  /* live-through variables */
  OutOfColoredSSA_initLiveIn(this, B, liveIn, false);
  for (i = 0; i < nRegs; i++) {
    if (liveIn[i] && 
        Rpc_INV(rpc)[i] == -1 && Rpc_TO(rpc)[i] == -1) {
      Rpc_TO(rpc)[i] = i;
      Rpc_INV(rpc)[i] = i;
    }
  }
  Except_CHECK(Rpc_check(rpc));
}

#line 2555 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static BasicBlockEdge RpcEdge_bestCandidate()
{
  // initial to -1 to proceed also edges with frequency equal to 0.
  // i.e. dead code not passed
  float maxf = -1;
  RpcEdge maxrpce = NULL;

#line 2562 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  HTable_FOREACH(RpcEdges, edge, RpcEdge_, rpce) {

#line 2564 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
    /*    fprintf(stderr, "trying %d to %d\n",*/
    /*        BasicBlockEdge_origBlock(rpce->FLOWARC)->BASICBLOCK->IDENTITY,*/
    /*        BasicBlockEdge_destBlock(rpce->FLOWARC)->BASICBLOCK->IDENTITY);*/
    /*    if( Rpc_isIdentity(RpcEdge_rpc(rpce))) {*/
    /*      fprintf(stderr, "\t identity\n");*/
    /*    }*/
    if (RpcEdge_FREQUENCY(rpce) > maxf &&
        ! RpcEdge_SPLIT(rpce) &&
        ! Rpc_isIdentity(RpcEdge_rpc(rpce))) {

#line 2574 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
      maxf = RpcEdge_FREQUENCY(rpce);
      maxrpce = rpce;
    }
  } HTable_ENDEACH;

#line 2579 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  if (maxrpce)  {
    /*    fprintf(stderr, " Found !!\n");*/
    return RpcEdge_FLOWARC(maxrpce);
  }
  else {
    /*    fprintf(stderr, " not found\n");*/
    return NULL;
  }
}

#line 2596 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
// Already seen edges during unmark algorithm
static PtrSet_ seenEdges_;
static PtrSet seenEdges = NULL;
// Constant used to increase the size of the ptr set 
#define DEFAULT_EDGES_NB_IN_REGION 16

#line 2602 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
void static unmark_potential_split(OutOfColoredSSA this, BasicBlockEdge E, bool dir_up, bool first) 
{
  RpcEdge rpce = BasicBlockEdge_rpce(E);
  BasicBlock B;

#line 2607 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  if(first) {
    if(seenEdges == NULL) {
      seenEdges = &seenEdges_;
      PtrSet_Ctor(seenEdges, OutOfColoredSSA_memory(this),
                  DEFAULT_EDGES_NB_IN_REGION);

#line 2613 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
    } else {
      PtrSet_empty(seenEdges);
    }
  }

#line 2618 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  if (!first && RpcEdge_PSPLIT(rpce)) {
    *RpcEdge__PSPLIT(rpce) = false;
    return;
  }

#line 2623 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  // avoid loop during recursion e.g. with several butterflies
  Except_CHECK(seenEdges != NULL);
  if(PtrSet_contains(seenEdges, E)) {
    return;
  } else {
    PtrSet_insert(seenEdges, E);
  }

#line 2631 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  B = dir_up? BasicBlockEdge_origBlock(E):  BasicBlockEdge_destBlock(E);
  if (dir_up) {
    BasicBlock_LEAVE_FOREACH_BasicBlockEdge(B, Ep) {
      if (E!=Ep) unmark_potential_split(this, Ep, !dir_up, false);
    } BasicBlock_LEAVE_ENDEACH_BasicBlockEdge;
  }
  else {
    BasicBlock_ENTER_FOREACH_BasicBlockEdge(B, Ep) {
      if (E!=Ep) unmark_potential_split(this, Ep, !dir_up, false);
    } BasicBlock_ENTER_ENDEACH_BasicBlockEdge;
  } 
  
  return;
}

#line 2646 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
//TODO: attention lors de la materialisation des copies paralleles, bien mettre a jour la liveness qd on traverse un bloc
//@XCC_.h
// Sinon la liveness est la suivante: pour chaque bloc on a une copie parallele en debut et en fin. La liveness a l'interieur du bloc ne change pas. Liveout du bloc est le live avant la copie parallele en sortie et livein du bloc est le live apres la copie parallele en entree. Par contre lorsqu'on remonte une copie parallele en bordure d'un bloc, en fait on la remonte apres la copie parallele deja existante de fin de bloc.
// D'ou besoin de Rpc_livein et Rpc_liveout
// Lorsque l'on traverse un bloc, qd on arrive au bout traiter l'eventualite de fusionner les copies paralleles.
/**
 * @param dir_up  direction we try to move the rpc      
 * @param depth   max depth of recursive call 
 *                (longest path of compensation on edges)
 * @return        -1 on failure (cannot split nor compensate this way)
 */
float static
mark_potential_split(OutOfColoredSSA this, BasicBlockEdge E, bool dir_up, Rpc rpc, int depth);

#line 2660 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
float static
mark_potential_split(OutOfColoredSSA this, BasicBlockEdge E, bool dir_up, Rpc rpc, int depth) 
{
  float compensate_cost = 0;
  float split_cost;
  bool livetmp[Rpc_nRegs(rpc)];
  Rpc_ rpc_moved_ = *rpc;
  Rpc rpc_moved = &rpc_moved_;
  Rpc rpc_B;
  Rpc_ rpc_tmp_; 
  Rpc rpc_tmp = &rpc_tmp_;
  Rpc_ rpc_comp_;
  Rpc rpc_comp = &rpc_comp_;
  BasicBlock B;
  // dir_up = true if direction of compensation goes upward 
  // false if downward
  RpcEdge rpce = BasicBlockEdge_rpce(E);
  if (RpcEdge_MARK(rpce)) return -1;

#line 2680 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  split_cost=Rpc_CostOnEdge(rpc, E, false); //TODO: add predication case
  if (RpcEdge_splitable(rpce) && 
      (depth<=0 || RpcEdge_PSPLIT(rpce) || RpcEdge_SPLIT(rpce)))  {
    *RpcEdge__PSPLIT(rpce) = true;
    return split_cost;
  }
  // TODO: doit-on s'arreter aussi si elle est splittee

#line 2688 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  *RpcEdge__MARK(rpce) = true;

#line 2690 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  B = dir_up? BasicBlockEdge_origBlock(E):  BasicBlockEdge_destBlock(E);

#line 2692 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  rpc_B =
    dir_up?
    RpcBlock_rpc_out(BasicBlock_rpcbb(B)):
    RpcBlock_rpc_in(BasicBlock_rpcbb(B));

#line 2697 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  if (dir_up) {
    Rpc_liveout(rpc_B, livetmp);
    Expand_in(this, rpc_moved, livetmp);
  }

#line 2702 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  
  Rpc_Ctor(rpc_tmp, Rpc_nRegs(rpc));
  
  if (dir_up) Rpc_o_Rpc(rpc_moved, rpc_B, rpc_tmp);
  else Rpc_o_Rpc(rpc_B, rpc_moved, rpc_tmp);
    
  compensate_cost = dir_up? Rpc_CostOnBlockBottom(this, rpc_tmp, B): Rpc_CostOnBlockTop(this, rpc_tmp, B);
  

#line 2711 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  Rpc_invert(rpc_moved, rpc_moved);
  Rpc_Ctor(rpc_comp, Rpc_nRegs(rpc));
  if (dir_up) {
    BasicBlock_LEAVE_FOREACH_BasicBlockEdge(B, Ep) {
      if (E!=Ep) {
        float cost;
        Rpc rpcEp = RpcEdge_rpc(BasicBlockEdge_rpce(Ep));
        rpc_comp_ = rpc_moved_;
        Rpc_livein(rpcEp,livetmp);
        Project_out(this, rpc_comp, livetmp);
        Rpc_clear(rpc_tmp);
        Rpc_o_Rpc(rpcEp, rpc_comp, rpc_tmp);
        cost=mark_potential_split(this, Ep, !dir_up, rpc_tmp, depth-1);
        if (cost==-1) {compensate_cost=-1; break;}
        else compensate_cost+=cost;
      }
    } BasicBlock_LEAVE_ENDEACH_BasicBlockEdge;
  }
  else {
    BasicBlock_ENTER_FOREACH_BasicBlockEdge(B, Ep) {
      if (E!=Ep) {
        float cost;
        Rpc rpcEp = RpcEdge_rpc(BasicBlockEdge_rpce(Ep));
        rpc_comp_ = rpc_moved_;
        Rpc_clear(rpc_tmp);
        Rpc_o_Rpc(rpc_comp, rpcEp, rpc_tmp);
        cost=mark_potential_split(this, Ep, !dir_up, rpc_tmp, depth-1);
        if (cost==-1) { compensate_cost=-1; break; } 
        else compensate_cost+=cost;
      }
    } BasicBlock_ENTER_ENDEACH_BasicBlockEdge;
  } 

#line 2744 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  if (RpcEdge_splitable(rpce) && 
      (compensate_cost==-1 || (split_cost<=compensate_cost
                               && !GRA_ssa_nsplit)
       || depth<=0 || GRA_ssa_split)) {
    Except_CHECK(*RpcEdge__PSPLIT(rpce) == false);
    unmark_potential_split(this, E, dir_up, true);
    *RpcEdge__PSPLIT(rpce) = true;
    *RpcEdge__MARK(rpce) = false;
    return split_cost;
  } else {
    *RpcEdge__MARK(rpce) = false;
    return compensate_cost;
  }
}

#line 2766 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
void static
apply_compensation(OutOfColoredSSA this, BasicBlockEdge E, bool dir_up)
{
  bool livetmp[OutOfColoredSSA_nRegs(this)];
  BasicBlock B;
  Rpc rpc_B;
  Rpc_ rpc_moved_;
  Rpc rpc_moved = &rpc_moved_;
  Rpc_ rpc_tmp_; 
  Rpc rpc_tmp = &rpc_tmp_;
  Rpc_ rpc_comp_;
  Rpc rpc_comp = &rpc_comp_;
  // dir_up = true if direction of compensation goes upward 
  // false if downward
  RpcEdge rpce = BasicBlockEdge_rpce(E);
  Rpc rpc = RpcEdge_rpc(rpce);
  Rpc_Ctor(rpc_moved, Rpc_nRegs(rpc));
  *rpc_moved = *rpc;
  Except_CHECK(! RpcEdge_MARK(rpce));

#line 2786 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  if (RpcEdge_psplit(rpce)) {
    Except_CHECK(RpcEdge_splitable(rpce));
    *RpcEdge__PSPLIT(rpce) = false;
    *RpcEdge__SPLIT(rpce) = true;
    return;
  }

#line 2793 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  *RpcEdge__MARK(rpce) = true;

#line 2795 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  B = dir_up? BasicBlockEdge_origBlock(E):  BasicBlockEdge_destBlock(E);

#line 2797 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  rpc_B = dir_up?  RpcBlock_rpc_out(BasicBlock_rpcbb(B)):
    RpcBlock_rpc_in(BasicBlock_rpcbb(B));

#line 2800 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  if (dir_up) {
    Rpc_liveout(rpc_B, livetmp);
    Expand_in(this, rpc_moved, livetmp);
  }

#line 2805 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  
  Rpc_Ctor(rpc_tmp, Rpc_nRegs(rpc));
  
  if (dir_up) Rpc_o_Rpc(rpc_moved, rpc_B, rpc_tmp);
  else        Rpc_o_Rpc(rpc_B, rpc_moved, rpc_tmp);
  *rpc_B = *rpc_tmp;

#line 2812 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  Rpc_invert(rpc_moved, rpc_moved);
  Rpc_Ctor(rpc_comp, Rpc_nRegs(rpc));
  if (dir_up) {
    BasicBlock_LEAVE_FOREACH_BasicBlockEdge(B, Ep) {
      if (E!=Ep) {
        Rpc rpcEp = RpcEdge_rpc(BasicBlockEdge_rpce(Ep));
        rpc_comp_ = rpc_moved_;
        Rpc_livein(rpcEp,livetmp);
        Project_out(this, rpc_comp, livetmp);
        Rpc_clear(rpc_tmp);
        Rpc_o_Rpc(rpcEp, rpc_comp, rpc_tmp);
        *rpcEp = rpc_tmp_;
        apply_compensation(this, Ep, !dir_up);
      }
    } BasicBlock_LEAVE_ENDEACH_BasicBlockEdge;
  }
  else {
    BasicBlock_ENTER_FOREACH_BasicBlockEdge(B, Ep) {
      if (E!=Ep) {
        Rpc rpcEp = RpcEdge_rpc(BasicBlockEdge_rpce(Ep));
        rpc_comp_ = rpc_moved_;
        Rpc_clear(rpc_tmp);
        Rpc_o_Rpc(rpc_comp, rpcEp, rpc_tmp);
        *rpcEp = rpc_tmp_;
        apply_compensation(this, Ep, !dir_up);
      }
    } BasicBlock_ENTER_ENDEACH_BasicBlockEdge;
  } 

#line 2841 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  Rpc_invert(rpc, rpc_comp);
  Rpc_o_Rpc(rpc, rpc_comp, rpc);

#line 2844 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  Except_CHECK(Rpc_isIdentity(rpc));

#line 2846 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  // this edge may be involved in next compensations processes.
  // E.g.
  // bbX   bbY
  //  \   /  \ <- we want to clear this edge but processing of edge X to Z
  //   \ /    \   may need it
  //   bbZ   ...
  // instead, we should set the registers live on this edge
  // Note: this final step is tricky because we destroy (during the composition)
  // the orignal rpc edge
  Rpc_clear(RpcEdge_rpc(rpce));
  {
    int i;
    int *array = dir_up? Rpc_TO(rpc_comp): Rpc_INV(rpc_comp);
    for(i = 0; i < Rpc_nRegs(rpc_comp); ++i) {
      if(array[i] != -1) {
        Rpc_TO(RpcEdge_rpc(rpce))[i] = i;
        Rpc_INV(RpcEdge_rpc(rpce))[i] = i;
      }
    }
  }
  *RpcEdge__MARK(rpce) = false;
}

#line 2880 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static int
OutOfColoredSSA_Process_rpc_Arc(OutOfColoredSSA this, BasicBlockEdge edge)
{
  float costup, costdown;
  Rpc rpc = RpcEdge_rpc(BasicBlockEdge_rpce(edge));

#line 2886 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  costup = mark_potential_split(this, edge, true, rpc, 1000);
  costdown = mark_potential_split(this, edge, false, rpc, 1000);

#line 2889 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  if (costup == -1 && costdown == -1) return -1;

#line 2891 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  apply_compensation(this, edge, costup<costdown);

#line 2893 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  return 0;

#line 2895 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
}

#line 2898 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
 
/**************************************
 * END: fonctions using RPC
 **************************************/

#line 2910 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static void
OutOfColoredSSA_processPHIs (OutOfColoredSSA this, BasicBlock B)
{
  CodeRegion codeRegion = OutOfColoredSSA_codeRegion(this);
  RegFile regFile = OutOfColoredSSA_regFile(this);
  int nRegs = OutOfColoredSSA_nRegs(this);
  BasicBlockEdge Eb = NULL;  /* will be a Weak-Bottom Edge if there exists one */
  float weight;
  int i;
  Rpc_ Rpc_;
  Rpc Rpc = &Rpc_;
  IDList_ arcs_;
  IDList arcs = (IDList)&arcs_;
  bool liveIn[MAX_RPC];
  Memory memory = OutOfColoredSSA_memory(this);

#line 2926 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  /* Setup a reverse parallel copy for nRegs registers. */
  Rpc_Ctor(Rpc, nRegs);

#line 2929 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  /* Is there any weak-bottom edge entering B? */
  BasicBlock_ENTER_FOREACH_BasicBlockEdge(B, Ei) {
    Except_CHECK (! BasicBlockEdge_isSweetBottom(Ei, &weight)); /* not possible if there is a PHI */
    if(BasicBlockEdge_isWeakBottom(Ei, &weight)) {
      float tmp;
      Except_CHECK (! Eb); /* there should be at most one weak-bottom edge */
      if( ! BasicBlockEdge_isWeakTop(Ei, &tmp) ||
          tmp > weight ) {
        Eb = Ei;
      }
    }
  } BasicBlock_ENTER_ENDEACH_BasicBlockEdge;

#line 2942 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  if (Eb) {
    /* Eb is a weak-bottom edge =>
     *   sigma is added at the beginning of B
     *   sigma^-1 is added at the end of other predecessors of B */
    int Rj, Rk;

#line 2948 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
    Except_CHECK(BasicBlockEdge_isWeakBottom(Eb, &weight));

#line 2950 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
    Rpc_clear(Rpc);

#line 2952 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
    /* for all phi
     * let Rk be the register comming from edge Eb to be placed in Rj
     * sigma^-1 will be added automatically with this modification of PHI:
     * Replace in PHI Rj = phi( ... Rk ...) by Rk = phi ( ... Rk ... )
     * The pmove is generated aftr the PHI
     */
    OutOfColoredSSA_RpcForArc(this, Eb, Rpc, true/*after*/);

#line 2960 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
    /* check if Rpc == identity. */
    if (Rpc_isIdentity(Rpc)) { /* continue */; } 
    else {

#line 2964 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
      /* Add to Rpc self edges for live-in variables, as these variables
         must keep their value.
      */
      OutOfColoredSSA_initLiveIn(this, B, liveIn, false);
      for (i = 0; i < nRegs; i++) {
        if (liveIn[i] && 
            Rpc_INV(Rpc)[i] == -1 && Rpc_TO(Rpc)[i] == -1) {
          Rpc_TO(Rpc)[i] = i;
          Rpc_INV(Rpc)[i] = i;
        }
      }

#line 2976 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
      if (GRA_TRACE) fprintf(GRA_TRACE, "Move after PHI for weakbottom edge: %d -> %d\n",  BasicBlock_INDEX(BasicBlockEdge_origBlock(Eb)), BasicBlock_INDEX(BasicBlockEdge_destBlock(Eb)));
      if (GRA_TRACE) Rpc_pretty(Rpc, GRA_TRACE);
      OutOfColoredSSA_generateRpcTop(this, Rpc, B);
    }
  }

#line 2982 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  /* Then, generate all the other reverse parallel copys. The corresponding
   * edges are either sweet-top, week-top or false */

#line 2985 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  IDList_Ctor(arcs, memory);
  /* We must first create the list of edges to process as the control flow
     will change due to spliting of false edges.
  */
  BasicBlock_ENTER_FOREACH_BasicBlockEdge(B, Ei) {
    IDList_PUSH(arcs, BasicBlockEdge, Ei);
  } BasicBlock_ENTER_ENDEACH_BasicBlockEdge;

#line 2993 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  IDList_FOREACH(arcs, BasicBlockEdge, arc_p) {
    BasicBlockEdge Ei = *arc_p;
    float tmp;
    float cost_split, cost_nsplit, cost_cmove, cost_best_nsplit, cost_best_cmove, cost_nback;
    bool split = false;
    bool cond_move = false;
    bool can_cmove;
    bool can_nsplit;
    bool is_back;
    Operation lastOp = BasicBlock_lastOperation(BasicBlockEdge_origBlock(Ei));

#line 3004 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
    Rpc_clear(Rpc);
    OutOfColoredSSA_RpcForArc(this, Ei, Rpc, false/*before*/);

#line 3007 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
    /* Early exit if Rpc is identity. */
    if (Rpc_isIdentity(Rpc)) continue;

#line 3010 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
    is_back = BasicBlockEdge_isBack(Ei);
    can_nsplit = !((BasicBlockEdge_isCritical(Ei) && (BasicBlockEdge_isStrong(Ei) || BasicBlockEdge_isFalse(Ei, &tmp)))
                   // it is dangerous not to split if control operation uses
                   // or defines operands or clobbers form regFile
                   || (lastOp != NULL
                       && Operator_isControl(Operation_operator(lastOp))
                       //FIXME: Do a more accurate test. Here we block this
                       //       handling even if the expansion of the rpc can
                       //       cross the control option.
                       && Operation_usesOrDefinesRegFile(lastOp, regFile)));
    can_cmove = BasicBlockEdge_isConditional(Ei) && OutOfColoredSSA_cmove_condition(this, Ei, Rpc);
    if (GRA_TRACE) fprintf(GRA_TRACE, "reverse parallel copy for edge: %d -> %d\n",  BasicBlock_INDEX(BasicBlockEdge_origBlock(Ei)), BasicBlock_INDEX(BasicBlockEdge_destBlock(Ei)));
    
    Except_CHECK(Rpc_check(Rpc));

#line 3025 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
    cost_split = OutOfColoredSSA_RpcCost(this, Rpc, Ei, true/*split*/, false/*cond*/);
    cost_nsplit = can_nsplit? OutOfColoredSSA_RpcCost(this, Rpc, Ei, false/*split*/, false/*cond*/): cost_split;
    cost_cmove = can_cmove? OutOfColoredSSA_RpcCost(this, Rpc, Ei, false/*split*/, true/*cond*/): cost_split;
    cost_best_nsplit = (can_nsplit && cost_nsplit <= cost_split)? cost_nsplit: cost_split;
    cost_best_cmove = (can_cmove && cost_cmove <= cost_best_nsplit)? cost_cmove: cost_best_nsplit;
    cost_nback = (can_nsplit && is_back)? cost_nsplit: cost_split;
    GRA_ssa_cost_split += cost_split;
    GRA_ssa_cost_nsplit += cost_nsplit;
    GRA_ssa_cost_cmove += cost_cmove;
    GRA_ssa_cost_best_nsplit += cost_best_nsplit;
    GRA_ssa_cost_best_cmove += cost_best_cmove;
    GRA_ssa_cost_nback += cost_nback;
    GRA_ssa_move_count += Rpc_moveCount(Rpc);
    
    if (GRA_ssa_split) {
      /* Split all. */
      split = true;
    } else if (GRA_ssa_nsplit) {
      if (can_nsplit)
        split = false;
      else 
        split = true;
    } else if (GRA_ssa_cmove) {
      if (can_cmove) {
        cond_move = true;
        split = false;
      } else {
        cond_move = false;
        split = true;
      }
    } else if (GRA_ssa_best_nsplit) {
      if (can_nsplit && cost_nsplit <= cost_split)
        split = false;
      else
        split = true;
    } else if (GRA_ssa_best_cmove) {
      float cost;
      if (can_nsplit && cost_nsplit <= cost_split) {
        split = false;
        cost = cost_nsplit;
      } else {
        split = true;
        cost = cost_split;
      }
      cond_move = false;
      if (can_cmove && cost_cmove <= cost) {
        cond_move = true;
        split = false;
      }
    } else if (GRA_ssa_nback) {
      if (can_nsplit && is_back)
        split = false;
      else 
        split = true;
      
    } 
    OutOfColoredSSA_RpcMoveup(this, Rpc, Ei, split, cond_move);
  } IDList_ENDEACH;
  IDList_Dtor(arcs);
}

#line 3086 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static void
OutOfColoredSSA_discardPHIs_(OutOfColoredSSA this);

#line 3089 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static void
OutOfColoredSSA_initRpcEdge(OutOfColoredSSA this, BasicBlockEdge edge);

#line 3092 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static void
OutOfColoredSSA_initRpcEdge(OutOfColoredSSA this, BasicBlockEdge edge/*,
                            HTable RpcEdge*/) {
  if (   BasicBlockEdge_destBlock(edge) != NULL
         && BasicBlockEdge_origBlock(edge) != NULL) {
    RpcEdge pe;
    float weight;

#line 3100 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
    pe = HTable_insert(RpcEdges, edge, sizeof(RpcEdge_));
    RpcEdge_Ctor(pe,OutOfColoredSSA_nRegs(this),edge);

#line 3103 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
    *RpcEdge__BACKEDGE(pe) = BasicBlockEdge_isBack(edge);
    *RpcEdge__FALSEEDGE(pe) = BasicBlockEdge_isFalse(edge,&weight);
    *RpcEdge__FREQUENCY(pe) = weight;

#line 3107 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
    Rpc_clear(RpcEdge_rpc(pe)); /* TODO: necessary? */
    BasicBlockEdge_initialRpc (this, edge, RpcEdge_rpc(pe));
    Except_CHECK(Rpc_check(RpcEdge_rpc(pe)));
  }
}

#line 3113 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static void
OutOfColoredSSA_initRpcBlock(OutOfColoredSSA this, BasicBlock basicBlock);

#line 3116 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static void
OutOfColoredSSA_initRpcBlock(OutOfColoredSSA this, BasicBlock basicBlock) {
  Rpc rpc;
  RpcBlock rpcBlock = HTable_insert(RpcBlocks, basicBlock, sizeof(RpcBlock_));
  RpcBlock_Ctor(rpcBlock,OutOfColoredSSA_nRegs(this));

#line 3122 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  *RpcBlock__FREQUENCY(rpcBlock) = BasicBlock_frequency(basicBlock);
  rpc = RpcBlock_rpc_in(rpcBlock);

#line 3125 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  /* All live variables have a self edge in the PC */
  BasicBlock_liveInSet_FORSORT_Temporary(basicBlock, temporary) {
    int reg = OutOfColoredSSA_temporaryReg(this, temporary);
    if(reg != -1) {
      Rpc_TO(rpc)[reg] = reg;
      Rpc_INV(rpc)[reg] = reg;
    }
  } BasicBlock_liveInSet_ENDSORT_Temporary;
  
  // this rpc represents color alive at the begining of the block
  // We have to add phi results to ensure the same number of live variable
  // on a entry edge and the enter of the block

#line 3138 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  // FIXME: maybe we should consider this as a bug, but phis'results are
  // not put into liveness's phi in sets, because CodeRegion_makeGlobalTable
  // does not see them as global temporaries. Thus, to have a correct liveness
  // at block entry, we must compute it manually.
  if(BasicBlock_phiCount(basicBlock) != 0) {
    BasicBlock_FOREACH_Operation(basicBlock, operation) {
      if(Operator_isPhi(Operation_operator(operation))) {
        int reg = OutOfColoredSSA_temporaryReg(this,
                                               Operation_getResult(operation, 0));
        if(reg != -1) {
          Rpc_TO(rpc)[reg] = reg;
          Rpc_INV(rpc)[reg] = reg;
        }
      } else if(!Operator_isLabel(Operation_operator(operation))) {
        break;
      }
    } BasicBlock_ENDEACH_Operation;
  }
/*   if(BasicBlock_phiInSet(basicBlock) != NULL) { */
/*     TemporarySet_FOREACH_Temporary(BasicBlock_phiInSet(basicBlock), */
/*                                    temporary) { */
/*       int reg = OutOfColoredSSA_temporaryReg(this, temporary); */
/*       if(reg != -1) { */
/*         Rpc_TO(rpc)[reg] = reg; */
/*         Rpc_INV(rpc)[reg] = reg; */
/*       } */
/*     } TemporarySet_ENDEACH_Temporary; */
/*   } */
  Except_CHECK(Rpc_check(rpc));

#line 3168 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  rpc = RpcBlock_rpc_out(BasicBlock_rpcbb(basicBlock));
  Rpc_clear(rpc);
  // this macro take phiOutSet too
  BasicBlock_liveOutSet_FORSORT_Temporary(basicBlock, temporary) {
    int reg = OutOfColoredSSA_temporaryReg(this, temporary);
    if(reg != -1) {
      Rpc_TO(rpc)[reg] = reg;
      Rpc_INV(rpc)[reg] = reg;
    }
  } BasicBlock_liveOutSet_ENDSORT_Temporary;

#line 3179 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  Except_CHECK(Rpc_check(rpc));
}

#line 3198 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
void
OutOfColoredSSA_discardPHIs(CodeRegion codeRegion, RegFile regFile,
                             Liveness* pliveness, Memory memory) {
  OutOfColoredSSA_ outOfColoredSSA[1];
  OutOfColoredSSA_Ctor(outOfColoredSSA, codeRegion, regFile, pliveness, memory);
  // We expand move to or from unallocable color to have relevant RPC.
  // More over, we avoid the ambiguity with -1 value, which is both used to
  // specify an unallocable color and no target/source in a RPC
  OutOfColoredSSA_removeUnallocatableColorFromParCopies(outOfColoredSSA);
  OutOfColoredSSA_discardPHIs_(outOfColoredSSA);
  OutOfColoredSSA_Dtor(outOfColoredSSA);
}

#line 3211 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static void
removeUselessMoves(OutOfColoredSSA this) {
  CodeRegion codeRegion = OutOfColoredSSA_codeRegion(this);
  uint32_t count = 0;
  CodeRegion_FOREACH_BasicBlock(codeRegion, basicBlock) {
    BasicBlock_FOREACH_Operation(basicBlock, operation) {
      if(Operator_isSeqCopy(Operation_operator(operation))
         || Operator_isParCopy(Operation_operator(operation))) {
        int32_t idx;
        for(idx = 0; idx < Operation_resCount(operation); ++idx) {
          if((Temporary_regFile(Operation_getResult(operation, idx))
              == OutOfColoredSSA_regFile(this))
             && Temporary_hasRegFile(Operation_getArgument(operation, idx))
             && (Temporary_register(Operation_getResult(operation, idx))
                 == Temporary_register(Operation_getArgument(operation, idx)))) {
            if(Operator_isSeqCopy(Operation_operator(operation))) {
              BasicBlock_detachOperation(basicBlock, operation);
            }
          }
        }
      }
    } BasicBlock_ENDEACH_Operation;
  } CodeRegion_ENDEACH_BasicBlock;
}

#line 3236 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
// Update rpcs edges and basic blocks to reflect edge splitting done with
// given rpc
static void
OutOfColoredSSA_updateRpcs(OutOfColoredSSA this, BasicBlock basicBlock,
                           BasicBlock curBB, BasicBlockEdge newEdgeEntry,
                           BasicBlockEdge newEdgeExit, int oldMaxBb, Rpc rpc) {
  // Considering the splitting case for:
  // BB
  // | RPC
  // V
  //
  // Three cases are possible:
  // 1. Edge splitting
  // BB
  // | New edge entry (rpc == id ==  livein(RPC))
  // V
  // curBB is NEW
  // rpc_in == livein(RPC)
  // RPC
  // rpc_out == liveout(RPC)
  // | New edge exit (rpc == id ==  liveout(RPC))
  // V
  //
  // 2. Recycle source basic block:
  // BB (curBB is old src BB)
  // RPC
  // rpc_out == liveout(RPC)
  // | New edge exit == old edge (rpc == id == liveout(RPC))
  // V
  //
  // 3. Recycle destination basic block:
  // BB
  // | New edge entry == old edge (rpc == id == livein(RPC))
  // V
  // curBB is old dst BB
  // rpc_in == livein(RPC)
  // RPC
  //
  // Note: recyling occurred only on simple basic blocks (one entry or one exit)
#define CASE_EDGE_SPLITTING 1
#define CASE_SOURCE_BB 2
#define CASE_DST_BB 3
  // New basic block
  int caseId = BasicBlock_identity(curBB) >= oldMaxBb
    ? CASE_EDGE_SPLITTING
    // source recycled
    : (basicBlock == curBB
       ? CASE_SOURCE_BB
       : CASE_DST_BB);
  int i, nRegs = OutOfColoredSSA_nRegs(this);

#line 3287 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  if(caseId == CASE_EDGE_SPLITTING || caseId == CASE_DST_BB) {
    Rpc rpcBbIn = RpcBlock_rpc_in(BasicBlock_rpcbb(curBB));
    RpcEdge rpcEdgeNewEdge = BasicBlockEdge_rpce(newEdgeEntry);
    Rpc rpcOnNewEdge = RpcEdge_rpc(rpcEdgeNewEdge);

#line 3292 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
    Rpc_clear(rpcBbIn);
    for(i = 0; i < nRegs; ++i) {
      if(Rpc_INV(rpc)[i] != -1) {
        Register alive = Rpc_INV(rpc)[i];
        Rpc_TO(rpcBbIn)[alive] = alive;
        Rpc_INV(rpcBbIn)[alive] = alive;
      }
    }

#line 3301 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
    // likely, update the rpc on enter edge:
    *rpcOnNewEdge = *rpcBbIn;
  }
  if(caseId == CASE_EDGE_SPLITTING || caseId == CASE_SOURCE_BB) {
    Rpc rpcBbOut = RpcBlock_rpc_out(BasicBlock_rpcbb(curBB));
    RpcEdge rpcEdgeNewEdge = BasicBlockEdge_rpce(newEdgeExit);
    Rpc rpcOnNewEdge = RpcEdge_rpc(rpcEdgeNewEdge);

#line 3309 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
    Rpc_clear(rpcBbOut);
    for(i = 0; i < nRegs; ++i) {
      if(Rpc_TO(rpc)[i] != -1) {
        Register alive = Rpc_TO(rpc)[i];
        Rpc_TO(rpcBbOut)[alive] = alive;
        Rpc_INV(rpcBbOut)[alive] = alive;
      }
    }
    // likely, update the rpc on leave edge:
    *rpcOnNewEdge = *rpcBbOut;
  }
}

#line 3323 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
static void
OutOfColoredSSA_discardPHIs_(OutOfColoredSSA this) {
  CodeRegion codeRegion = OutOfColoredSSA_codeRegion(this);
  IDList_ nodes_;
  IDList nodes = (IDList)&nodes_;
  int nRegs;
  int maxedge, maxbb;
  BasicBlockEdge edge;
  Memory memory = OutOfColoredSSA_memory(this);

#line 3333 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  nRegs = OutOfColoredSSA_nRegs(this);

#line 3335 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  IDList_Ctor(nodes, memory);

#line 3337 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  /* Initialize Reverse Parallel Copies structures */
  maxbb = 0;   /* number of Basic Blocks */
  maxedge = 0; /* number of edges between BB */

#line 3341 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  if(GRA_ssa_use_new_rpc) {
    CodeRegion_FOREACH_BasicBlock(OutOfColoredSSA_codeRegion(this), basicBlock) {

#line 3344 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
      if (BasicBlock_identity(basicBlock) > maxbb) {
        maxbb = BasicBlock_identity(basicBlock);
      }
      BasicBlock_LEAVE_FOREACH_BasicBlockEdge(basicBlock, edge) {
        maxedge++;
      } BasicBlock_LEAVE_ENDEACH_BasicBlockEdge;
    } CodeRegion_ENDEACH_BasicBlock;
    maxbb++; /* count starts at zero */

#line 3353 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
    /* And a HTabl for parallel copies on edges (I couldn't find a good way to
     * index them and use an array) */
    HTable_Ctor(RpcBlocks, memory, maxbb);
    HTable_Ctor(RpcEdges, memory, maxedge);

#line 3358 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
    /* Initialize parallel copies */
    CodeRegion_FOREACH_BasicBlock(OutOfColoredSSA_codeRegion(this), basicBlock) {
      OutOfColoredSSA_initRpcBlock(this, basicBlock);
    
      /* Initialize the PC on all outgoing edges */
      BasicBlock_LEAVE_FOREACH_BasicBlockEdge(basicBlock, edge) {
        OutOfColoredSSA_initRpcEdge(this, edge);
      } BasicBlock_LEAVE_ENDEACH_BasicBlockEdge;
    } CodeRegion_ENDEACH_BasicBlock;

#line 3368 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
    /*  fprintf(stderr, "will do the loop\n");*/

#line 3370 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
    while ((edge = RpcEdge_bestCandidate()) != NULL) {
      int res;
      /*     fprintf(stderr, "*** Arc between %d and %d\n", */
      /*             BasicBlock_identity(BasicBlockEdge_origBlock(edge)), */
      /*             BasicBlock_identity(BasicBlockEdge_destBlock(edge))); */
      res = OutOfColoredSSA_Process_rpc_Arc (this, edge);
      Except_CHECK(res != 1);
    }

#line 3379 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
    //ALGO: foreach bb in basicblocks
    CodeRegion_FOREACH_BasicBlock(codeRegion, basicBlock) {
      /* For the momemt we must proceed in this order:
         - top down, then
         - bottom up,
         Because top down requires the live out information
         which will be modified by bottom up.
         TODO: Update live information to remove this constraint.
      */
      Rpc rpc_in, rpc_out;

#line 3390 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
      //ALGO: move rpc_in(bb) top down
      rpc_in = RpcBlock_rpc_in(BasicBlock_rpcbb(basicBlock));
      Rpc_motionDownfromBlockTop(this, rpc_in, basicBlock);
    
      //ALGO: move rpc_out(bb) bottom up
      rpc_out = RpcBlock_rpc_out(BasicBlock_rpcbb(basicBlock));
      Rpc_motionUpfromBlockBottom(this, rpc_out, basicBlock);

#line 3398 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
      //ALGO: foreach edge leaving bb
      BasicBlock_LEAVE_FOREACH_BasicBlockEdge(basicBlock, edge) {
        RpcEdge rpce;
        Rpc rpc;
        if (BasicBlockEdge_destBlock(edge) == NULL) continue;
        rpce = BasicBlockEdge_rpce(edge);
        rpc = RpcEdge_rpc(rpce);
        //ALGO: if edge to split
        if (RpcEdge_SPLIT(rpce) && !Rpc_isIdentity(rpc)) {
          //ALGO: split edge and insert parallel copy
          BasicBlock curBB;
          BasicBlockEdge newEdgeEntry = NULL, newEdgeExit = NULL;
          Operation pointInsertionAfter = NULL;
          // edge will be destroyed during the split, thus save its useful data.
          Rpc_ rpcTmp = *rpc;
          int oldMaxbb = maxbb;
          curBB =
            BasicBlockEdge_splitWithLiveness(OutOfColoredSSA_PLIVENESS(this),
                                             OutOfColoredSSA_memory(this),
                                             codeRegion, edge, true,
                                             &pointInsertionAfter);
          // check whether we recycle a basic block
          if(BasicBlock_identity(curBB) >= maxbb) {
            maxbb = BasicBlock_identity(curBB);
            HTable_remove(RpcEdges, edge, NULL);
            // new basic block has been created, set its rpc block information
            OutOfColoredSSA_initRpcBlock(this, curBB);
            // insert rpc object on new created edges
            // first, enter one
            BasicBlock_ENTER_FOREACH_BasicBlockEdge(curBB, curEdge) {
              Except_CHECK(newEdgeEntry == NULL); // There should be only one edge
              newEdgeEntry = curEdge;
            } BasicBlock_ENTER_ENDEACH_BasicBlockEdge;
            OutOfColoredSSA_initRpcEdge(this, newEdgeEntry);

#line 3433 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
            // second, leave one
            BasicBlock_LEAVE_FOREACH_BasicBlockEdge(curBB, curEdge) {
              Except_CHECK(newEdgeExit == NULL); // There should be only one edge
              newEdgeExit = curEdge;
            } BasicBlock_LEAVE_ENDEACH_BasicBlockEdge;
            OutOfColoredSSA_initRpcEdge(this, newEdgeExit);
            Rpc_motionUpfromBlockBottom(this, &rpcTmp, curBB);
          } else {
            // optimisation not to create a new basic block
            int moves[(MAX_RPC+1)*3];
            Rpc_getMoveList(&rpcTmp, moves);
            OutOfColoredSSA_generateMovesFab(this, curBB,
                                             pointInsertionAfter, moves);
            if(curBB == basicBlock) {
              newEdgeExit = edge;
            } else {
              newEdgeEntry = edge;
            }
          }
          // after the motion, block's rpc_out is the result of the rpc
          // normally done on the edge
          // We must do this change because, since phi operands are not updated,
          // liveness is not correct
          OutOfColoredSSA_updateRpcs(this, basicBlock, curBB, newEdgeEntry,
                                     newEdgeExit, oldMaxbb, &rpcTmp);

#line 3459 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
        } else {
          //ALGO: Assert parallel copy is empty
          Except_CHECK(Rpc_isIdentity(rpc));
        }
      } BasicBlock_LEAVE_ENDEACH_BasicBlockEdge;
    } CodeRegion_ENDEACH_BasicBlock;

#line 3466 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
    // Detach proceed PHIs
    CodeRegion_FOREACH_BasicBlock(codeRegion, basicBlock) {
      BasicBlock_FOREACH_Operation(basicBlock, operation) {
        if(Operator_isLabel(Operation_operator(operation))) {
          continue;
        } else if(Operator_isPhi(Operation_operator(operation))) {
          if(Temporary_regFile(Operation_getResult(operation, 0))
             == OutOfColoredSSA_regFile(this)) {
            BasicBlock_detachOperation(basicBlock, operation);
          }
        } else {
          break;
        }
      } BasicBlock_ENDEACH_Operation;
    } CodeRegion_ENDEACH_BasicBlock;
  } else {
    /* OLD version from HERE */
    CodeRegion_FOREACH_BasicBlock(codeRegion, basicBlock) {
      bool has_phi = false;

#line 3486 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
      BasicBlock_FOREACH_Operation(basicBlock, operation) {
        /* Must process basicBlock that contain at least a PHI for the current
           register class bing processed. */
        if (OutOfColoredSSA_isPHI(this, operation)) {
          has_phi = true;
          break;
        }
      } BasicBlock_ENDEACH_Operation;
      if (has_phi) IDList_PUSH(nodes, BasicBlock, basicBlock);
    } CodeRegion_ENDEACH_BasicBlock;

#line 3497 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
    /* Update RPC on edges going to PHIs */
    /*  IDList_FOREACH(nodes, BasicBlock, node_p) {*/
    /*    BasicBlock_LEAVE_FOREACH_BasicBlockEdge(node_p, edge) {*/
    /*      RpcEdge rpce = BasicBlockEdge_rpc(edge);*/
    /*      OutOfColoredSSA_RpcForArc (this, edge, RpcEdge_rpc(rpce), true/false)*/
    /*      BasicBlockEdge_initialRpc (this, edge, RpcEdge_rpc(rpce));*/
    /*    } BasicBlock_ENTER_ENDEACH_BasicBlockEdge;*/
    /*  } IDList_ENDEACH;*/

#line 3507 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
    /* Process PHIs. */
    IDList_FOREACH(nodes, BasicBlock, node_p) {
      GRA_TRACE && fprintf(GRA_TRACE, "*** GRA DISCARD PHI NODE:%d\n", BasicBlock_INDEX(*node_p));
      OutOfColoredSSA_processPHIs (this, *node_p);
    } IDList_ENDEACH;

#line 3513 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
    /* Remove PHI operations */
    IDList_FOREACH(nodes, BasicBlock, node_p) {
      BasicBlock_FOREACH_Operation(*node_p, operation) {
        if (OutOfColoredSSA_isPHI(this, operation)) {
          /* Check that all phi args/results are identical.*/
          Temporary res = Operation_getResult(operation, 0);
          int reg = OutOfColoredSSA_temporaryReg(this, res);
          Except_CHECK(reg != -1);
          Operation_ARGUMENTS_FOREACH_Temporary(operation, use) {
            Except_CHECK(reg == OutOfColoredSSA_temporaryReg(this, use));
          } Operation_ARGUMENTS_ENDEACH_Temporary;
          BasicBlock_detachOperation(*node_p, operation);
        }
      } BasicBlock_ENDEACH_Operation;
    } IDList_ENDEACH;

#line 3529 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
    IDList_Dtor(nodes);
  }

#line 3532 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  /* END of old version */

#line 3534 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  /*  Destroy RPC structures */
  if(GRA_ssa_use_new_rpc) {
    HTable_Dtor(RpcEdges);
    HTable_Dtor(RpcBlocks);
  }

#line 3540 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
  removeUselessMoves(this);
}

#line 3544 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 3556 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
#if XCC__C
static void
OutOfColoredSSA_TEST(void)
{
#include "GRA/OutOfColoredSSA_.c"
}

#line 3563 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/GRA/OutOfColoredSSA.xcc"
int
main(int argc, char **argv)
{
  GRA_Test(OutOfColoredSSA_TEST);
  return 0;
}
#endif


#endif//OutOfColoredSSA_c_INCLUDED
