	.file	"O64.c"
	.text
	.p2align 4,,15
.globl O64_Open
	.type	O64_Open, @function
O64_Open:
	call	__i686.get_pc_thunk.cx
	addl	$_GLOBAL_OFFSET_TABLE_, %ecx
	pushl	%ebp
	movl	%esp, %ebp
	movl	Label_Factory@GOT(%ecx), %eax
	movl	$0, (%eax)
	movl	Symbol_Factory@GOT(%ecx), %eax
	movl	$0, (%eax)
	movl	Temporary_Factory@GOT(%ecx), %eax
	movl	$0, (%eax)
	movl	Operation_Factory@GOT(%ecx), %eax
	movl	$0, (%eax)
	movl	BasicBlock_Factory@GOT(%ecx), %eax
	movl	$0, (%eax)
	movl	LoopScope_Factory@GOT(%ecx), %eax
	movl	$0, (%eax)
	popl	%ebp
	ret
	.size	O64_Open, .-O64_Open
	.p2align 4,,15
.globl O64_Close
	.type	O64_Close, @function
O64_Close:
	call	__i686.get_pc_thunk.cx
	addl	$_GLOBAL_OFFSET_TABLE_, %ecx
	pushl	%ebp
	movl	%esp, %ebp
	movl	LoopScope_Factory@GOT(%ecx), %eax
	movl	$0, (%eax)
	movl	BasicBlock_Factory@GOT(%ecx), %eax
	movl	$0, (%eax)
	movl	Operation_Factory@GOT(%ecx), %eax
	movl	$0, (%eax)
	movl	Temporary_Factory@GOT(%ecx), %eax
	movl	$0, (%eax)
	movl	Symbol_Factory@GOT(%ecx), %eax
	movl	$0, (%eax)
	movl	Label_Factory@GOT(%ecx), %eax
	movl	$0, (%eax)
	popl	%ebp
	ret
	.size	O64_Close, .-O64_Close
	.section	.rodata.str1.1,"aMS",@progbits,1
.LC0:
	.string	"O64_INPUT"
.LC1:
	.string	"%d"
.LC2:
	.string	"O64_OUTPUT"
.LC3:
	.string	"O64_TRACE"
.LC4:
	.string	"O64_XMLIN"
.LC5:
	.string	"O64_XMLOUT"
.LC6:
	.string	"#include \"O64.h\"\n"
	.section	.rodata.str1.4,"aMS",@progbits,1
	.align 4
.LC7:
	.string	"#define CGIR_LAB(cgir_lab)\t(CGIR_LAB)(cgir_lab)\n"
	.align 4
.LC8:
	.string	"#define CGIR_SYM(cgir_sym)\t(CGIR_SYM)(cgir_sym)\n"
	.align 4
.LC9:
	.string	"#define CGIR_WN(cgir_wn)\t(CGIR_WN)(cgir_wn)\n"
	.align 4
.LC10:
	.string	"#define CGIR_TN(cgir_tn)\t(CGIR_TN)(cgir_tn)\n"
	.align 4
.LC11:
	.string	"#define CGIR_OP(cgir_op)\t(CGIR_OP)(cgir_op)\n"
	.align 4
.LC12:
	.string	"#define CGIR_BB(cgir_bb)\t(CGIR_BB)(cgir_bb)\n"
	.align 4
.LC13:
	.string	"#define CGIR_LD(cgir_ld)\t(CGIR_LD)(cgir_ld)\n"
	.section	.rodata.str1.1
.LC14:
	.string	"extern Label label[];\n"
.LC15:
	.string	"extern Symbol symbol[];\n"
	.section	.rodata.str1.4
	.align 4
.LC16:
	.string	"extern Temporary temporary[];\n"
	.align 4
.LC17:
	.string	"extern Operation operation[];\n"
	.align 4
.LC18:
	.string	"extern BasicBlock basicBlock[];\n"
	.align 4
.LC19:
	.string	"extern LoopScope loopScope[];\n"
	.section	.rodata.str1.1
.LC20:
	.string	"extern Interface interface;\n"
.LC21:
	.string	"void Interface_0(void) {\n"
	.text
	.p2align 4,,15
.globl O64_INIT
	.type	O64_INIT, @function
O64_INIT:
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%edi
	pushl	%esi
	pushl	%ebx
	call	__i686.get_pc_thunk.bx
	addl	$_GLOBAL_OFFSET_TABLE_, %ebx
	subl	$44, %esp
	movl	O64_Initialized@GOTOFF(%ebx), %eax
	leal	1(%eax), %edx
	testl	%eax, %eax
	movl	%edx, O64_Initialized@GOTOFF(%ebx)
	je	.L22
	addl	$44, %esp
	popl	%ebx
	popl	%esi
	popl	%edi
	popl	%ebp
	ret
	.p2align 4,,7
	.p2align 3
.L22:
	leal	.LC0@GOTOFF(%ebx), %esi
	movl	%esi, (%esp)
	call	getenv@PLT
	testl	%eax, %eax
	je	.L20
	movl	$0, -28(%ebp)
	movl	%esi, (%esp)
	call	getenv@PLT
	leal	-28(%ebp), %edx
	movl	%edx, 8(%esp)
	leal	.LC1@GOTOFF(%ebx), %edx
	movl	%edx, 4(%esp)
	movl	%eax, (%esp)
	call	__isoc99_sscanf@PLT
	movl	-28(%ebp), %eax
	cmpl	$1, %eax
	je	.L23
	cmpl	$2, %eax
	jne	.L20
	movl	stderr@GOT(%ebx), %eax
	movl	O64_INPUT@GOT(%ebx), %esi
	movl	(%eax), %eax
	movl	%eax, (%esi)
	jmp	.L5
	.p2align 4,,7
	.p2align 3
.L20:
	movl	O64_INPUT@GOT(%ebx), %esi
.L5:
	leal	.LC2@GOTOFF(%ebx), %edi
	movl	%edi, (%esp)
	call	getenv@PLT
	testl	%eax, %eax
	je	.L7
	movl	$0, -28(%ebp)
	movl	%edi, (%esp)
	call	getenv@PLT
	leal	-28(%ebp), %edx
	movl	%edx, 8(%esp)
	leal	.LC1@GOTOFF(%ebx), %edx
	movl	%edx, 4(%esp)
	movl	%eax, (%esp)
	call	__isoc99_sscanf@PLT
	movl	-28(%ebp), %eax
	cmpl	$1, %eax
	je	.L24
	cmpl	$2, %eax
	jne	.L7
	movl	stderr@GOT(%ebx), %eax
	movl	(%eax), %edx
	movl	O64_OUTPUT@GOT(%ebx), %eax
	movl	%edx, (%eax)
	.p2align 4,,7
	.p2align 3
.L7:
	leal	.LC3@GOTOFF(%ebx), %edi
	movl	%edi, (%esp)
	call	getenv@PLT
	testl	%eax, %eax
	je	.L9
	movl	$0, -28(%ebp)
	movl	%edi, (%esp)
	call	getenv@PLT
	leal	-28(%ebp), %edx
	movl	%edx, 8(%esp)
	leal	.LC1@GOTOFF(%ebx), %edx
	movl	%edx, 4(%esp)
	movl	%eax, (%esp)
	call	__isoc99_sscanf@PLT
	movl	-28(%ebp), %eax
	cmpl	$1, %eax
	je	.L25
	cmpl	$2, %eax
	jne	.L9
	movl	stderr@GOT(%ebx), %eax
	movl	(%eax), %edx
	movl	O64_TRACE@GOT(%ebx), %eax
	movl	%edx, (%eax)
	.p2align 4,,7
	.p2align 3
.L9:
	leal	.LC4@GOTOFF(%ebx), %edi
	movl	%edi, (%esp)
	call	getenv@PLT
	testl	%eax, %eax
	je	.L11
	movl	$0, -28(%ebp)
	movl	%edi, (%esp)
	call	getenv@PLT
	leal	-28(%ebp), %edx
	movl	%edx, 8(%esp)
	leal	.LC1@GOTOFF(%ebx), %edx
	movl	%edx, 4(%esp)
	movl	%eax, (%esp)
	call	__isoc99_sscanf@PLT
	movl	-28(%ebp), %eax
	cmpl	$1, %eax
	je	.L26
	cmpl	$2, %eax
	jne	.L11
	movl	stderr@GOT(%ebx), %eax
	movl	(%eax), %edx
	movl	O64_XMLIN@GOT(%ebx), %eax
	movl	%edx, (%eax)
	.p2align 4,,7
	.p2align 3
.L11:
	leal	.LC5@GOTOFF(%ebx), %edi
	movl	%edi, (%esp)
	call	getenv@PLT
	testl	%eax, %eax
	je	.L13
	movl	$0, -28(%ebp)
	movl	%edi, (%esp)
	call	getenv@PLT
	leal	-28(%ebp), %edx
	movl	%edx, 8(%esp)
	leal	.LC1@GOTOFF(%ebx), %edx
	movl	%edx, 4(%esp)
	movl	%eax, (%esp)
	call	__isoc99_sscanf@PLT
	movl	-28(%ebp), %eax
	cmpl	$1, %eax
	je	.L27
	cmpl	$2, %eax
	jne	.L13
	movl	stderr@GOT(%ebx), %eax
	movl	(%eax), %edx
	movl	O64_XMLOUT@GOT(%ebx), %eax
	movl	%edx, (%eax)
	.p2align 4,,7
	.p2align 3
.L13:
	movl	(%esi), %eax
	testl	%eax, %eax
	je	.L15
	movl	%eax, 12(%esp)
	leal	.LC6@GOTOFF(%ebx), %eax
	movl	$17, 8(%esp)
	movl	$1, 4(%esp)
	movl	%eax, (%esp)
	call	fwrite@PLT
	movl	(%esi), %eax
	movl	$10, (%esp)
	movl	%eax, 4(%esp)
	call	fputc@PLT
	movl	(%esi), %eax
	movl	$48, 8(%esp)
	movl	$1, 4(%esp)
	movl	%eax, 12(%esp)
	leal	.LC7@GOTOFF(%ebx), %eax
	movl	%eax, (%esp)
	call	fwrite@PLT
	movl	(%esi), %eax
	movl	$48, 8(%esp)
	movl	$1, 4(%esp)
	movl	%eax, 12(%esp)
	leal	.LC8@GOTOFF(%ebx), %eax
	movl	%eax, (%esp)
	call	fwrite@PLT
	movl	(%esi), %eax
	movl	$44, 8(%esp)
	movl	$1, 4(%esp)
	movl	%eax, 12(%esp)
	leal	.LC9@GOTOFF(%ebx), %eax
	movl	%eax, (%esp)
	call	fwrite@PLT
	movl	(%esi), %eax
	movl	$44, 8(%esp)
	movl	$1, 4(%esp)
	movl	%eax, 12(%esp)
	leal	.LC10@GOTOFF(%ebx), %eax
	movl	%eax, (%esp)
	call	fwrite@PLT
	movl	(%esi), %eax
	movl	$44, 8(%esp)
	movl	$1, 4(%esp)
	movl	%eax, 12(%esp)
	leal	.LC11@GOTOFF(%ebx), %eax
	movl	%eax, (%esp)
	call	fwrite@PLT
	movl	(%esi), %eax
	movl	$44, 8(%esp)
	movl	$1, 4(%esp)
	movl	%eax, 12(%esp)
	leal	.LC12@GOTOFF(%ebx), %eax
	movl	%eax, (%esp)
	call	fwrite@PLT
	movl	(%esi), %eax
	movl	$44, 8(%esp)
	movl	$1, 4(%esp)
	movl	%eax, 12(%esp)
	leal	.LC13@GOTOFF(%ebx), %eax
	movl	%eax, (%esp)
	call	fwrite@PLT
	movl	(%esi), %eax
	movl	$10, (%esp)
	movl	%eax, 4(%esp)
	call	fputc@PLT
	movl	(%esi), %eax
	movl	$22, 8(%esp)
	movl	$1, 4(%esp)
	movl	%eax, 12(%esp)
	leal	.LC14@GOTOFF(%ebx), %eax
	movl	%eax, (%esp)
	call	fwrite@PLT
	movl	(%esi), %eax
	movl	$24, 8(%esp)
	movl	$1, 4(%esp)
	movl	%eax, 12(%esp)
	leal	.LC15@GOTOFF(%ebx), %eax
	movl	%eax, (%esp)
	call	fwrite@PLT
	movl	(%esi), %eax
	movl	$30, 8(%esp)
	movl	$1, 4(%esp)
	movl	%eax, 12(%esp)
	leal	.LC16@GOTOFF(%ebx), %eax
	movl	%eax, (%esp)
	call	fwrite@PLT
	movl	(%esi), %eax
	movl	$30, 8(%esp)
	movl	$1, 4(%esp)
	movl	%eax, 12(%esp)
	leal	.LC17@GOTOFF(%ebx), %eax
	movl	%eax, (%esp)
	call	fwrite@PLT
	movl	(%esi), %eax
	movl	$32, 8(%esp)
	movl	$1, 4(%esp)
	movl	%eax, 12(%esp)
	leal	.LC18@GOTOFF(%ebx), %eax
	movl	%eax, (%esp)
	call	fwrite@PLT
	movl	(%esi), %eax
	movl	$30, 8(%esp)
	movl	$1, 4(%esp)
	movl	%eax, 12(%esp)
	leal	.LC19@GOTOFF(%ebx), %eax
	movl	%eax, (%esp)
	call	fwrite@PLT
	movl	(%esi), %eax
	movl	$28, 8(%esp)
	movl	$1, 4(%esp)
	movl	%eax, 12(%esp)
	leal	.LC20@GOTOFF(%ebx), %eax
	movl	%eax, (%esp)
	call	fwrite@PLT
	movl	(%esi), %eax
	movl	$10, (%esp)
	movl	%eax, 4(%esp)
	call	fputc@PLT
	movl	(%esi), %eax
	movl	$25, 8(%esp)
	movl	$1, 4(%esp)
	movl	%eax, 12(%esp)
	leal	.LC21@GOTOFF(%ebx), %eax
	movl	%eax, (%esp)
	call	fwrite@PLT
.L15:
	movl	Interface_Counter@GOT(%ebx), %eax
	movl	$0, (%eax)
	call	CCL_INIT@PLT
	call	CAL_INIT@PLT
	call	MDS_INIT@PLT
	.p2align 4,,5
	call	AIR_INIT@PLT
	.p2align 4,,5
	call	LIR_INIT@PLT
	.p2align 4,,5
	call	PFA_INIT@PLT
	.p2align 4,,5
	call	CGO_INIT@PLT
	.p2align 4,,5
	call	GRA_INIT@PLT
	.p2align 4,,5
	call	XFA_INIT@PLT
	.p2align 4,,5
	call	SCD_INIT@PLT
	.p2align 4,,5
	call	CGIR_INIT@PLT
	.p2align 4,,5
	call	Interface_INIT@PLT
	addl	$44, %esp
	popl	%ebx
	popl	%esi
	popl	%edi
	popl	%ebp
	ret
	.p2align 4,,7
	.p2align 3
.L23:
	movl	stdout@GOT(%ebx), %eax
	movl	O64_INPUT@GOT(%ebx), %esi
	movl	(%eax), %eax
	movl	%eax, (%esi)
	jmp	.L5
	.p2align 4,,7
	.p2align 3
.L27:
	movl	stdout@GOT(%ebx), %eax
	movl	(%eax), %edx
	movl	O64_XMLOUT@GOT(%ebx), %eax
	movl	%edx, (%eax)
	jmp	.L13
	.p2align 4,,7
	.p2align 3
.L26:
	movl	stdout@GOT(%ebx), %eax
	movl	(%eax), %edx
	movl	O64_XMLIN@GOT(%ebx), %eax
	movl	%edx, (%eax)
	jmp	.L11
	.p2align 4,,7
	.p2align 3
.L25:
	movl	stdout@GOT(%ebx), %eax
	movl	(%eax), %edx
	movl	O64_TRACE@GOT(%ebx), %eax
	movl	%edx, (%eax)
	jmp	.L9
	.p2align 4,,7
	.p2align 3
.L24:
	movl	stdout@GOT(%ebx), %eax
	movl	(%eax), %edx
	movl	O64_OUTPUT@GOT(%ebx), %eax
	movl	%edx, (%eax)
	jmp	.L7
	.size	O64_INIT, .-O64_INIT
	.p2align 4,,15
.globl O64_Initialize
	.type	O64_Initialize, @function
O64_Initialize:
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%ebx
	call	__i686.get_pc_thunk.bx
	addl	$_GLOBAL_OFFSET_TABLE_, %ebx
	subl	$4, %esp
	call	MDS_INIT@PLT
	call	AIR_INIT@PLT
	call	LIR_INIT@PLT
	.p2align 4,,5
	call	PFA_INIT@PLT
	.p2align 4,,5
	call	CGO_INIT@PLT
	.p2align 4,,5
	call	GRA_INIT@PLT
	.p2align 4,,5
	call	XFA_INIT@PLT
	.p2align 4,,5
	call	SCD_INIT@PLT
	.p2align 4,,5
	call	O64_INIT@PLT
	addl	$4, %esp
	popl	%ebx
	popl	%ebp
	ret
	.size	O64_Initialize, .-O64_Initialize
	.section	.rodata.str1.4
	.align 4
.LC22:
	.string	"int main(int argc, char **argv) {\n"
	.section	.rodata.str1.1
.LC23:
	.string	"  Interface_Initialize();\n"
.LC24:
	.string	"  Interface_0();\n"
.LC25:
	.string	"  Interface_%d();\n"
.LC26:
	.string	"  Interface_Finalize();\n"
.LC27:
	.string	"  return 0;\n"
.LC28:
	.string	"}\n\n"
.LC29:
	.string	"Label label[%d];\n"
.LC30:
	.string	"Symbol symbol[%d];\n"
.LC31:
	.string	"Temporary temporary[%d];\n"
.LC32:
	.string	"Operation operation[%d];\n"
.LC33:
	.string	"BasicBlock basicBlock[%d];\n"
.LC34:
	.string	"LoopScope loopScope[%d];\n"
	.text
	.p2align 4,,15
.globl O64_FINI
	.type	O64_FINI, @function
O64_FINI:
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%edi
	pushl	%esi
	pushl	%ebx
	call	__i686.get_pc_thunk.bx
	addl	$_GLOBAL_OFFSET_TABLE_, %ebx
	subl	$44, %esp
	movl	O64_Initialized@GOTOFF(%ebx), %eax
	subl	$1, %eax
	testl	%eax, %eax
	movl	%eax, O64_Initialized@GOTOFF(%ebx)
	je	.L40
.L29:
	addl	$44, %esp
	popl	%ebx
	popl	%esi
	popl	%edi
	popl	%ebp
	ret
	.p2align 4,,7
	.p2align 3
.L40:
	call	Interface_FINI@PLT
	call	CGIR_FINI@PLT
	.p2align 4,,5
	call	SCD_FINI@PLT
	.p2align 4,,5
	call	XFA_FINI@PLT
	.p2align 4,,5
	call	GRA_FINI@PLT
	.p2align 4,,5
	call	CGO_FINI@PLT
	.p2align 4,,5
	call	PFA_FINI@PLT
	.p2align 4,,5
	call	LIR_FINI@PLT
	.p2align 4,,5
	call	AIR_FINI@PLT
	.p2align 4,,5
	call	MDS_FINI@PLT
	.p2align 4,,5
	call	CAL_FINI@PLT
	.p2align 4,,5
	call	CCL_FINI@PLT
	movl	O64_INPUT@GOT(%ebx), %edi
	movl	(%edi), %eax
	testl	%eax, %eax
	je	.L29
	movl	%eax, 12(%esp)
	leal	.LC22@GOTOFF(%ebx), %eax
	movl	$34, 8(%esp)
	movl	$1, 4(%esp)
	movl	%eax, (%esp)
	call	fwrite@PLT
	movl	(%edi), %eax
	movl	$26, 8(%esp)
	movl	$1, 4(%esp)
	movl	%eax, 12(%esp)
	leal	.LC23@GOTOFF(%ebx), %eax
	movl	%eax, (%esp)
	call	fwrite@PLT
	movl	(%edi), %eax
	movl	$17, 8(%esp)
	movl	$1, 4(%esp)
	movl	%eax, 12(%esp)
	leal	.LC24@GOTOFF(%ebx), %eax
	movl	%eax, (%esp)
	call	fwrite@PLT
	movl	Interface_Counter@GOT(%ebx), %eax
	movl	(%eax), %eax
	testl	%eax, %eax
	jle	.L31
	leal	.LC25@GOTOFF(%ebx), %eax
	xorl	%esi, %esi
	movl	%eax, -28(%ebp)
	.p2align 4,,7
	.p2align 3
.L32:
	movl	-28(%ebp), %eax
	addl	$1, %esi
	movl	%esi, 8(%esp)
	movl	%eax, 4(%esp)
	movl	(%edi), %eax
	movl	%eax, (%esp)
	call	fprintf@PLT
	movl	Interface_Counter@GOT(%ebx), %eax
	cmpl	%esi, (%eax)
	jg	.L32
.L31:
	movl	(%edi), %eax
	movl	$24, 8(%esp)
	movl	$1, 4(%esp)
	movl	%eax, 12(%esp)
	leal	.LC26@GOTOFF(%ebx), %eax
	movl	%eax, (%esp)
	call	fwrite@PLT
	movl	(%edi), %eax
	movl	$12, 8(%esp)
	movl	$1, 4(%esp)
	movl	%eax, 12(%esp)
	leal	.LC27@GOTOFF(%ebx), %eax
	movl	%eax, (%esp)
	call	fwrite@PLT
	movl	(%edi), %eax
	movl	$3, 8(%esp)
	movl	$1, 4(%esp)
	movl	%eax, 12(%esp)
	leal	.LC28@GOTOFF(%ebx), %eax
	movl	%eax, (%esp)
	call	fwrite@PLT
	movl	Label_Factory@GOT(%ebx), %eax
	movl	4(%eax), %eax
	testl	%eax, %eax
	jne	.L41
.L33:
	movl	Symbol_Factory@GOT(%ebx), %eax
	movl	4(%eax), %eax
	testl	%eax, %eax
	jne	.L42
.L34:
	movl	Temporary_Factory@GOT(%ebx), %eax
	movl	4(%eax), %eax
	testl	%eax, %eax
	jne	.L43
.L35:
	movl	Operation_Factory@GOT(%ebx), %eax
	movl	4(%eax), %eax
	testl	%eax, %eax
	jne	.L44
.L36:
	movl	BasicBlock_Factory@GOT(%ebx), %eax
	movl	4(%eax), %eax
	testl	%eax, %eax
	jne	.L45
.L37:
	movl	LoopScope_Factory@GOT(%ebx), %eax
	movl	4(%eax), %eax
	testl	%eax, %eax
	jne	.L46
.L38:
	movl	(%edi), %eax
	movl	$10, (%esp)
	movl	%eax, 4(%esp)
	call	fputc@PLT
	addl	$44, %esp
	popl	%ebx
	popl	%esi
	popl	%edi
	popl	%ebp
	ret
	.p2align 4,,7
	.p2align 3
.L41:
	movl	%eax, 8(%esp)
	leal	.LC29@GOTOFF(%ebx), %eax
	movl	%eax, 4(%esp)
	movl	(%edi), %eax
	movl	%eax, (%esp)
	call	fprintf@PLT
	jmp	.L33
	.p2align 4,,7
	.p2align 3
.L46:
	movl	%eax, 8(%esp)
	leal	.LC34@GOTOFF(%ebx), %eax
	movl	%eax, 4(%esp)
	movl	(%edi), %eax
	movl	%eax, (%esp)
	call	fprintf@PLT
	jmp	.L38
	.p2align 4,,7
	.p2align 3
.L45:
	movl	%eax, 8(%esp)
	leal	.LC33@GOTOFF(%ebx), %eax
	movl	%eax, 4(%esp)
	movl	(%edi), %eax
	movl	%eax, (%esp)
	call	fprintf@PLT
	jmp	.L37
	.p2align 4,,7
	.p2align 3
.L44:
	movl	%eax, 8(%esp)
	leal	.LC32@GOTOFF(%ebx), %eax
	movl	%eax, 4(%esp)
	movl	(%edi), %eax
	movl	%eax, (%esp)
	call	fprintf@PLT
	jmp	.L36
	.p2align 4,,7
	.p2align 3
.L43:
	movl	%eax, 8(%esp)
	leal	.LC31@GOTOFF(%ebx), %eax
	movl	%eax, 4(%esp)
	movl	(%edi), %eax
	movl	%eax, (%esp)
	call	fprintf@PLT
	jmp	.L35
	.p2align 4,,7
	.p2align 3
.L42:
	movl	%eax, 8(%esp)
	leal	.LC30@GOTOFF(%ebx), %eax
	movl	%eax, 4(%esp)
	movl	(%edi), %eax
	movl	%eax, (%esp)
	call	fprintf@PLT
	jmp	.L34
	.size	O64_FINI, .-O64_FINI
	.p2align 4,,15
.globl O64_Finalize
	.type	O64_Finalize, @function
O64_Finalize:
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%ebx
	call	__i686.get_pc_thunk.bx
	addl	$_GLOBAL_OFFSET_TABLE_, %ebx
	subl	$4, %esp
	call	O64_FINI@PLT
	call	SCD_FINI@PLT
	call	XFA_FINI@PLT
	.p2align 4,,5
	call	GRA_FINI@PLT
	.p2align 4,,5
	call	CGO_FINI@PLT
	.p2align 4,,5
	call	PFA_FINI@PLT
	.p2align 4,,5
	call	LIR_FINI@PLT
	.p2align 4,,5
	call	AIR_FINI@PLT
	.p2align 4,,5
	call	MDS_FINI@PLT
	.p2align 4,,5
	call	CAL_FINI@PLT
	.p2align 4,,5
	call	CCL_FINI@PLT
	addl	$4, %esp
	popl	%ebx
	popl	%ebp
	ret
	.size	O64_Finalize, .-O64_Finalize
	.p2align 4,,15
.globl O64_Test
	.type	O64_Test, @function
O64_Test:
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%ebx
	call	__i686.get_pc_thunk.bx
	addl	$_GLOBAL_OFFSET_TABLE_, %ebx
	subl	$4, %esp
	call	O64_INIT@PLT
	call	*8(%ebp)
	call	O64_FINI@PLT
	addl	$4, %esp
	popl	%ebx
	popl	%ebp
	.p2align 4,,2
	ret
	.size	O64_Test, .-O64_Test
.globl O64_INPUT
	.bss
	.align 4
	.type	O64_INPUT, @object
	.size	O64_INPUT, 4
O64_INPUT:
	.zero	4
.globl O64_OUTPUT
	.align 4
	.type	O64_OUTPUT, @object
	.size	O64_OUTPUT, 4
O64_OUTPUT:
	.zero	4
.globl O64_TRACE
	.align 4
	.type	O64_TRACE, @object
	.size	O64_TRACE, 4
O64_TRACE:
	.zero	4
.globl O64_XMLIN
	.align 4
	.type	O64_XMLIN, @object
	.size	O64_XMLIN, 4
O64_XMLIN:
	.zero	4
.globl O64_XMLOUT
	.align 4
	.type	O64_XMLOUT, @object
	.size	O64_XMLOUT, 4
O64_XMLOUT:
	.zero	4
	.comm	escape,4,4
	.local	O64_Initialized
	.comm	O64_Initialized,4,4
	.section	.text.__i686.get_pc_thunk.cx,"axG",@progbits,__i686.get_pc_thunk.cx,comdat
.globl __i686.get_pc_thunk.cx
	.hidden	__i686.get_pc_thunk.cx
	.type	__i686.get_pc_thunk.cx, @function
__i686.get_pc_thunk.cx:
	movl	(%esp), %ecx
	ret
	.section	.text.__i686.get_pc_thunk.bx,"axG",@progbits,__i686.get_pc_thunk.bx,comdat
.globl __i686.get_pc_thunk.bx
	.hidden	__i686.get_pc_thunk.bx
	.type	__i686.get_pc_thunk.bx, @function
__i686.get_pc_thunk.bx:
	movl	(%esp), %ebx
	ret
	.ident	"GCC: (SUSE Linux) 4.5.1 20101208 [gcc-4_5-branch revision 167585]"
	.section	.comment.SUSE.OPTs,"MS",@progbits,1
	.string	"OspWg"
	.section	.note.GNU-stack,"",@progbits
