#ifndef Interface_c_INCLUDED
#define Interface_c_INCLUDED

#line 18 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
#include "O64/O64_.h"

#line 31 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
#ifndef Interface_DEDICATED
int Interface_DEDICATED;
#endif

#line 35 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 67 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
InterfaceMapped
InterfaceMapped_Ctor(InterfaceMapped this,
                     void *cgir, InterfaceType type)
{
  *InterfaceMapped__CGIR(this) = cgir;
  *InterfaceMapped__TYPE(this) = type;
  return this;
}

#line 76 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 130 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
Interface
Interface_Ctor(Interface this,
               Memory memory)
{
  *Interface__MEMORY(this) = memory;
  *Interface__CONFIGURE(this) = NULL;
  memset(Interface_SELECTOR(this), 0, sizeof(Selector_));
  memset(Interface_DIRECT(this), 0, sizeof(HTable_)*InterfaceType__);
  *Interface__REGISTERCOUNT(this) = 0;
  *Interface__REGISTERARRAY(this) = NULL;
  *Interface__LABELCOUNT(this) = 0;
  *Interface__LABELARRAY(this) = NULL;
  *Interface__RESULTCOUNT(this) = 0;
  *Interface__RESULTARRAY(this) = NULL;
  *Interface__ARGUMENTCOUNT(this) = 0;
  *Interface__ARGUMENTARRAY(this) = NULL;
  *Interface__TEMPORARYCOUNT(this) = 0;
  *Interface__TEMPORARYARRAY(this) = NULL;
  *Interface__OPERATIONCOUNT(this) = 0;
  *Interface__OPERATIONARRAY(this) = NULL;
  return this;
}

#line 153 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
void
Interface_Dtor(Interface this)
{
  Memory memory = Interface_MEMORY(this);
  Except_ENSURE(Interface_PROCEDURE(this) == NULL);
  Memory_free(memory, Interface_REGISTERARRAY(this));
  Memory_free(memory, Interface_LABELARRAY(this));
  Memory_free(memory, Interface_RESULTARRAY(this));
  Memory_free(memory, Interface_ARGUMENTARRAY(this));
  Memory_free(memory, Interface_TEMPORARYARRAY(this));
  Memory_free(memory, Interface_OPERATIONARRAY(this));
}

#line 172 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
Interface
Interface_getInstance(void)
{
  return interface;
}

#line 183 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
static Interface_ interface_;
Interface interface = &interface_;

#line 285 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
int *Interface_Registers(int count, ...)
{
  int i;
  va_list va;
  Interface this = interface;
  int *registers = Interface_REGISTERARRAY(this);
  if (count > Interface_REGISTERCOUNT(this)) {
    Memory memory = Interface_MEMORY(this);
    Memory_free(memory, Interface_REGISTERARRAY(this));
    registers = *Interface__REGISTERARRAY(this)
              = Memory_alloc(memory, sizeof(int)*count);
    *Interface__REGISTERCOUNT(this) = count;
  }
  va_start(va, count);
  for (i = 0; i < count; i++) {
    registers[i] = va_arg(va, int);
  }
  va_end(va);
  return registers;
}

#line 312 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
#ifndef ECL_NTRACE
int
Interface_PrintRegisters(FILE *file, int count, int registers[])
{
  int i;
  fprintf(file, "Interface_Registers(%d", count);
  for (i = 0; i < count; i++) {
    fprintf(file, ", Register_%s", Register_name_(registers[i]));
  }
  fprintf(file, ")");
  return 1;
}
#endif//ECL_NTRACE

#line 330 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
Label *
Interface_Labels(int count, ...)
{
  int i;
  va_list va;
  Interface this = interface;
  Label *labels = Interface_LABELARRAY(this);
  if (count > Interface_LABELCOUNT(this)) {
    Memory memory = Interface_MEMORY(this);
    Memory_free(memory, Interface_LABELARRAY(this));
    labels = *Interface__LABELARRAY(this)
           = Memory_alloc(memory, sizeof(Label)*count);
    *Interface__LABELCOUNT(this) = count;
  }
  va_start(va, count);
  for (i = 0; i < count; i++) {
    labels[i] = va_arg(va, Label);
  }
  va_end(va);
  return labels;
}

#line 358 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
#ifndef ECL_NTRACE
int
Interface_PrintLabels(FILE *file, int count, Label labels[])
{
  int i;
  fprintf(file, "Interface_Labels(%d", count);
  for (i = 0; i < count; i++) {
    fprintf(file, ", label[%d]", Label_identity(labels[i]));
  }
  fprintf(file, ")");
  return 1;
}
#endif//ECL_NTRACE

#line 376 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
static Temporary *
Interface_Results(int count, va_list va)
{
  int i;
  Interface this = interface;
  Temporary *temporaries = Interface_RESULTARRAY(this);
  if (count > Interface_RESULTCOUNT(this)) {
    Memory memory = Interface_MEMORY(this);
    Memory_free(memory, Interface_RESULTARRAY(this));
    temporaries = *Interface__RESULTARRAY(this)
                = Memory_alloc(memory, sizeof(Temporary)*count);
    *Interface__RESULTCOUNT(this) = count;
  }
  for (i = 0; i < count; i++) {
    temporaries[i] = va_arg(va, Temporary);
  }
  return temporaries;
}

#line 395 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
static Temporary *
Interface_Arguments(int count, va_list va)
{
  int i;
  Interface this = interface;
  Temporary *temporaries = Interface_ARGUMENTARRAY(this);
  if (count > Interface_ARGUMENTCOUNT(this)) {
    Memory memory = Interface_MEMORY(this);
    Memory_free(memory, Interface_ARGUMENTARRAY(this));
    temporaries = *Interface__ARGUMENTARRAY(this)
                = Memory_alloc(memory, sizeof(Temporary)*count);
    *Interface__ARGUMENTCOUNT(this) = count;
  }
  for (i = 0; i < count; i++) {
    temporaries[i] = va_arg(va, Temporary);
  }
  return temporaries;
}

#line 414 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
Temporary *
Interface_Temporaries(int count, ...)
{
  int i;
  va_list va;
  Interface this = interface;
  Temporary *temporaries = NULL;
  static bool results = false;
  va_start(va, count);
  if (results) {
    temporaries = Interface_Arguments(count, va);
    results = false;
  } else {
    temporaries = Interface_Results(count, va);
    results = true;
  }
  va_end(va);
  return temporaries;
}

#line 434 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
#if 0
Temporary *
Interface_Temporaries(int count, ...)
{
  int i;
  va_list va;
  Interface this = interface;
  Temporary *temporaries = Interface_TEMPORARYARRAY(this);
  if (count > Interface_TEMPORARYCOUNT(this)) {
    Memory memory = Interface_MEMORY(this);
    Memory_free(memory, Interface_TEMPORARYARRAY(this));
    temporaries = *Interface__TEMPORARYARRAY(this)
                = Memory_alloc(memory, sizeof(Temporary)*count);
    *Interface__TEMPORARYCOUNT(this) = count;
  }
  va_start(va, count);
  for (i = 0; i < count; i++) {
    temporaries[i] = va_arg(va, Temporary);
  }
  va_end(va);
  return temporaries;
}
#endif

#line 464 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
#ifndef ECL_NTRACE
int
Interface_PrintTemporaries(FILE *file, int count, Temporary temporaries[])
{
  int i;
  fprintf(file, "Interface_Temporaries(%d", count);
  for (i = 0; i < count; i++) {
    fprintf(file, ", temporary[%d]", Temporary_identity(temporaries[i]));
  }
  fprintf(file, ")");
  return 1;
}
#endif//ECL_NTRACE

#line 482 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
Operation *
Interface_Operations(int count, ...)
{
  int i;
  va_list va;
  Interface this = interface;
  Operation *operations = Interface_OPERATIONARRAY(this);
  if (count > Interface_OPERATIONCOUNT(this)) {
    Memory memory = Interface_MEMORY(this);
    Memory_free(memory, Interface_OPERATIONARRAY(this));
    operations = *Interface__OPERATIONARRAY(this)
           = Memory_alloc(memory, sizeof(Operation)*count);
    *Interface__OPERATIONCOUNT(this) = count;
  }
  va_start(va, count);
  for (i = 0; i < count; i++) {
    operations[i] = va_arg(va, Operation);
  }
  va_end(va);
  return operations;
}

#line 510 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
#ifndef ECL_NTRACE
int
Interface_PrintOperations(FILE *file, int count, Operation operations[])
{
  int i;
  fprintf(file, "Interface_Operations(%d", count);
  for (i = 0; i < count; i++) {
    fprintf(file, ", operation[%d]", Operation_identity(operations[i]));
  }
  fprintf(file, ")");
  return 1;
}
#endif//ECL_NTRACE

#line 533 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
void
Interface_setMaxIssue(Interface this, Processor processor, int maxIssue)
{
  MDS_setMaxIssue(processor, maxIssue);
  O64_INPUT && fprintf(O64_INPUT,
                       "  Interface_setMaxIssue(interface, Processor_%s, %d);\n",
                       Processor_name_(processor), maxIssue);
}

#line 548 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
void
Interface_setMinTaken(Interface this, Processor processor, int minTaken)
{
  MDS_setMinTaken(processor, minTaken);
  O64_INPUT && fprintf(O64_INPUT,
                       "  Interface_setMinTaken(interface, Processor_%s, %d);\n",
                       Processor_name_(processor), minTaken);
}

#line 563 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
void
Interface_setReserved(Interface this, Convention convention, Register reserved)
{
  MDS_setReserved(convention, reserved);
  O64_INPUT && fprintf(O64_INPUT,
                       "  Interface_setReserved(interface, Convention_%s, Register_%s);\n",
                       Convention_name_(convention), Register_name_(reserved));
}

#line 579 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
bool
Interface_setArgStage(Interface this, Processor processor,
                      Operator operator, int index, int stage)
{
  Memory memory =  Interface_MEMORY(this);
  Instance instance = Operator_instance(operator, processor);
  O64_INPUT && fprintf(O64_INPUT,
      "Interface_setArgStage(interface, Processor_%s, Operator_%s, %d, %d);\n",
      Processor_name_(processor), Operator_name_(operator), index, stage);
  if (instance != Instance__UNDEF) {
    const_RegisterActionArray actionArray = Instance_actionArray(instance);
    RegisterAction_ *items = Instance_makeRegisterActionItems(instance, memory);
    RegisterActionArray_FORREAD_RegisterAction(actionArray, action) {
      if (RegisterAction_xxxIndex(action) == index) {
        RegisterAction_setStage(items + RegisterActionArray_INDEX, stage);
        return (RegisterAction_stage(action) == stage);
      }
    } RegisterActionArray_ENDREAD_RegisterAction;
  }
  return false;
}

#line 608 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
bool
Interface_setResStage(Interface this, Processor processor,
                      Operator operator, int index, int stage)
{
  Memory memory =  Interface_MEMORY(this);
  Instance instance = Operator_instance(operator, processor);
  O64_INPUT && fprintf(O64_INPUT,
      "Interface_setResStage(interface, Processor_%s, Operator_%s, %d, %d);\n",
      Processor_name_(processor), Operator_name_(operator), index, stage);
  if (instance != Instance__UNDEF) {
    const_RegisterActionArray actionArray = Instance_actionArray(instance);
    RegisterAction_ *items = Instance_makeRegisterActionItems(instance, memory);
    RegisterActionArray_FORWRITE_RegisterAction(actionArray, action) {
      if (RegisterAction_xxxIndex(action) == index) {
        RegisterAction_setStage(items + RegisterActionArray_INDEX, stage);
        return RegisterAction_stage(action) == stage;
      }
    } RegisterActionArray_ENDWRITE_RegisterAction;
  }
  return false;
}

#line 636 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
Label
Interface_makeLabel(Interface this, CGIR_LAB cgir_lab, const char *name)
{
  void *pointer = HTable_lookup(Interface_LABELS(this), (HTableKey)cgir_lab, sizeof(Label));
  Label label = *(Label *)pointer;
  if (label == NULL) {
    Procedure procedure = Interface_PROCEDURE(this);
    LabelTable labelTable = Program_labelTable(program);
    label = *(Label *)pointer = LabelTable_lookup(labelTable, cgir_lab, name);
#ifndef ECL_NTRACE
    O64_INPUT && fprintf(O64_INPUT,
        "    label[%d] = Interface_makeLabel(interface, CGIR_LAB(%d), \"%s\");\n",
        Label_identity(label), CGIR_LAB_identity(cgir_lab), name);
#endif//ECL_NTRACE
    //KEEP Interface_setCGIRImport(this, label);
  }
  return label;
}

#line 661 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
Label
Interface_findLabel(Interface this, CGIR_LAB cgir_lab)
{
  void *pointer = HTable_search(Interface_LABELS(this), (HTableKey)cgir_lab);
  if (pointer != NULL) return *(Label *)pointer;
  return NULL;
}

#line 675 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
Symbol
Interface_makeSymbol(Interface this, CGIR_SYM cgir_sym, const char *name)
{
  void *pointer = HTable_lookup(Interface_SYMBOLS(this), (HTableKey)cgir_sym, sizeof(Symbol));
  Symbol symbol = *(Symbol *)pointer;
  if (symbol == NULL) {
    SymbolTable symbolTable = Program_symbolTable(program);
    symbol = *(Symbol *)pointer = SymbolTable_makeSymbol(symbolTable, name);
#ifndef ECL_NTRACE
    O64_INPUT && fprintf(O64_INPUT,
        "    symbol[%d] = Interface_makeSymbol(interface, CGIR_SYM(%d), \"%s\");\n",
        Symbol_identity(symbol), CGIR_SYM_identity(cgir_sym), name);
#endif//ECL_NTRACE
    //KEEP Interface_setCGIRImport(this, symbol);
  }
  return symbol;
}

#line 699 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
void
Interface_Symbol_setClasses(Interface this, Symbol symbol, SymbolClass sclass, SymbolStore sstore, SymbolExport sexport)
{
  SymbolClass lao_sclass = (SymbolClass)sclass;
  SymbolStore lao_sstore = (SymbolStore)sstore;
  SymbolExport lao_sexport = (SymbolExport)sexport;
  Symbol_setClasses(symbol, lao_sclass, lao_sstore, lao_sexport);
#ifndef ECL_NTRACE
  O64_INPUT && 
    fprintf(O64_INPUT,
            "    Interface_Symbol_setClasses(interface, symbol[%d], SymbolClass_%s, SymbolStore_%s, SymbolExport_%s);\n",
            Symbol_identity(symbol), SymbolClass_name_(lao_sclass), SymbolStore_name_(lao_sstore), SymbolExport_name_(lao_sexport));
#endif//ECL_NTRACE
}

#line 720 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
Symbol
Interface_findSymbol(Interface this, CGIR_SYM cgir_sym)
{
  void *pointer = HTable_search(Interface_SYMBOLS(this), (HTableKey)cgir_sym);
  if (pointer != NULL) return *(Symbol *)pointer;
  return NULL;
}

#line 734 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
Temporary
Interface_makeDedicatedTemporary(Interface this, CGIR_TN cgir_tn, Register cgir_register)
{
  Procedure procedure = Interface_PROCEDURE(this);
  void *pointer = HTable_lookup(Interface_TEMPORARIES(this), (HTableKey)cgir_tn, sizeof(Temporary));
  Temporary temporary = *(Temporary *)pointer;
  Except_REQUIRE(cgir_register != Register__UNDEF);
  if (temporary == NULL) {
    temporary = *(Temporary *)pointer =
                Procedure_makeDedicatedTemporary(procedure, cgir_register);
#ifndef ECL_NTRACE
    O64_INPUT && fprintf(O64_INPUT,
        "    temporary[%d] = Interface_makeDedicatedTemporary(interface, CGIR_TN(%d), Register_%s);\n",
        Temporary_identity(temporary), CGIR_TN_identity(cgir_tn), Register_name_(cgir_register));
#endif//ECL_NTRACE
    //KEEP Interface_setCGIRImport(this, temporary);
  }
  Except_ENSURE(Temporary_isDedicated(temporary));
  return temporary;
}

#line 761 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
Temporary
Interface_makeAssignedTemporary(Interface this, CGIR_TN cgir_tn, Register cgir_register)
{
  Procedure procedure = Interface_PROCEDURE(this);
  void *pointer = HTable_lookup(Interface_TEMPORARIES(this), (HTableKey)cgir_tn, sizeof(Temporary));
  Temporary temporary = *(Temporary *)pointer;
  if (temporary == NULL) {
    temporary = *(Temporary *)pointer =
                Procedure_makeAssignedTemporary(procedure, cgir_register);
#ifndef ECL_NTRACE
    O64_INPUT && fprintf(O64_INPUT,
        "    temporary[%d] = Interface_makeAssignedTemporary(interface, CGIR_TN(%d), Register_%s);\n",
        Temporary_identity(temporary), CGIR_TN_identity(cgir_tn), Register_name_(cgir_register));
#endif//ECL_NTRACE
    //KEEP Interface_setCGIRImport(this, temporary);
  }
  Except_ENSURE(Temporary_isAssigned(temporary));
  return temporary;
}

#line 787 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
Temporary
Interface_makeVirtualTemporary(Interface this, CGIR_TN cgir_tn, RegFile regFile)
{
  Procedure procedure = Interface_PROCEDURE(this);
  void *pointer = HTable_lookup(Interface_TEMPORARIES(this), (HTableKey)cgir_tn, sizeof(Temporary));
  Temporary temporary = *(Temporary *)pointer;
  if (temporary == NULL) {
    temporary = *(Temporary *)pointer =
                Procedure_makeVirtualTemporary(procedure, regFile);
#ifndef ECL_NTRACE
    O64_INPUT && fprintf(O64_INPUT,
        "    temporary[%d] = Interface_makeVirtualTemporary(interface, CGIR_TN(%d), RegFile_%s);\n",
        Temporary_identity(temporary), CGIR_TN_identity(cgir_tn), RegFile_name_(regFile));
#endif//ECL_NTRACE
    //KEEP Interface_setCGIRImport(this, temporary);
  }
  Except_ENSURE(Temporary_isVirtual(temporary));
  return temporary;
}

#line 813 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
Temporary
Interface_makeAbsoluteTemporary(Interface this, CGIR_TN cgir_tn, Immediate immediate, int64_t value)
{
  Procedure procedure = Interface_PROCEDURE(this);
  void *pointer = HTable_lookup(Interface_TEMPORARIES(this), (HTableKey)cgir_tn, sizeof(Temporary));
  Temporary temporary = *(Temporary *)pointer;
  if (temporary == NULL) {
    const_ImmediateRelocations relocations = Immediate_relocations(immediate);
    Relocation relocation = ImmediateRelocations_count(relocations) > 0?
                            ImmediateRelocations_access(relocations, 0):
                            Relocation__UNDEF;
    temporary = *(Temporary *)pointer =
                Procedure_makeAbsoluteTemporary(procedure, value, relocation);
#ifndef ECL_NTRACE
    O64_INPUT && fprintf(O64_INPUT,
        "    temporary[%d] = Interface_makeAbsoluteTemporary(interface, CGIR_TN(%d), Immediate_%s, %lldLL);\n",
        Temporary_identity(temporary), CGIR_TN_identity(cgir_tn),
        Immediate_name_(immediate), (long long)value);
#endif//ECL_NTRACE
    //KEEP Interface_setCGIRImport(this, temporary);
  }
  Except_ENSURE(Temporary_isAbsolute(temporary));
  return temporary;
}

#line 844 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
Temporary
Interface_makeSymbolTemporary(Interface this, CGIR_TN cgir_tn, Immediate immediate, Symbol symbol, int64_t offset)
{
  Procedure procedure = Interface_PROCEDURE(this);
  void *pointer = HTable_lookup(Interface_TEMPORARIES(this), (HTableKey)cgir_tn, sizeof(Temporary));
  Temporary temporary = *(Temporary *)pointer;
  if (temporary == NULL) {
    const_ImmediateRelocations relocations = Immediate_relocations(immediate);
    Relocation relocation = ImmediateRelocations_count(relocations) > 0?
                            ImmediateRelocations_access(relocations, 0):
                            Relocation__UNDEF;
    temporary = *(Temporary *)pointer =
                Procedure_makeSymbolTemporary(procedure, symbol, offset, relocation);
#ifndef ECL_NTRACE
    O64_INPUT && fprintf(O64_INPUT,
        "    temporary[%d] = Interface_makeSymbolTemporary(interface, CGIR_TN(%d), Immediate_%s, symbol[%d], %lldLL);\n",
        Temporary_identity(temporary), CGIR_TN_identity(cgir_tn),
        Immediate_name_(immediate), Symbol_identity(symbol), (long long)offset);
#endif//ECL_NTRACE
    //KEEP Interface_setCGIRImport(this, temporary);
  }
  Except_ENSURE(Temporary_isSymbol(temporary));
  return temporary;
}

#line 875 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
Temporary
Interface_makeLabelTemporary(Interface this, CGIR_TN cgir_tn, Immediate immediate, Label label)
{
  Procedure procedure = Interface_PROCEDURE(this);
  void *pointer = HTable_lookup(Interface_TEMPORARIES(this), (HTableKey)cgir_tn, sizeof(Temporary));
  Temporary temporary = *(Temporary *)pointer;
  if (temporary == NULL) {
    const_ImmediateRelocations relocations = Immediate_relocations(immediate);
    Relocation relocation = ImmediateRelocations_count(relocations) > 0?
                            ImmediateRelocations_access(relocations, 0):
                            Relocation__UNDEF;
    temporary = *(Temporary *)pointer =
                Procedure_makeLabelTemporary(procedure, label, 0, relocation);
#ifndef ECL_NTRACE
    O64_INPUT && fprintf(O64_INPUT,
        "    temporary[%d] = Interface_makeLabelTemporary(interface, CGIR_TN(%d), Immediate_%s, label[%d]);\n",
        Temporary_identity(temporary), CGIR_TN_identity(cgir_tn), Immediate_name_(immediate), Label_identity(label));
#endif//ECL_NTRACE
    //KEEP Interface_setCGIRImport(this, temporary);
  }
  Except_ENSURE(Temporary_isLabel(temporary));
  return temporary;
}

#line 905 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
void
Interface_Temporary_setWidth(Interface this, Temporary temporary, unsigned width)
{
  
  Temporary_setWidth(temporary, width);
#ifndef ECL_NTRACE
  O64_INPUT && 
    fprintf(O64_INPUT,
            "    Interface_Temporary_setWidth(interface, temporary[%d], %u);\n",
            Temporary_identity(temporary), width);
#endif//ECL_NTRACE
}

#line 924 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
void
Interface_Temporary_setRemater(Interface this, Temporary temporary, Temporary value)
{
  Procedure procedure = Interface_PROCEDURE(this);
  Procedure_setRemater(procedure, temporary, value);
#ifndef ECL_NTRACE
  O64_INPUT && 
    fprintf(O64_INPUT,
            "    Interface_Temporary_setRemater(interface, temporary[%d], temporary[%d]);\n",
            Temporary_identity(temporary), Temporary_identity(value));
#endif//ECL_NTRACE
}

#line 943 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
void
Interface_Temporary_setHomeable(Interface this, Temporary temporary, Temporary location)
{
  Procedure procedure = Interface_PROCEDURE(this);
  Temporary_setFlags(temporary, TemporaryFlag_Homeable);
  Procedure_setHomeable(procedure, temporary, location);
#ifndef ECL_NTRACE
  O64_INPUT && 
    fprintf(O64_INPUT,
            "    Interface_Temporary_setHomeable(interface, temporary[%d]. temporary[%d]);\n",
            Temporary_identity(temporary), Temporary_identity(location));
#endif//ECL_NTRACE
}

#line 963 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
void
Interface_Temporary_setDedicated(Interface this, Temporary temporary)
{
  Temporary_setDedicated(temporary);
#ifndef ECL_NTRACE
  O64_INPUT && 
    fprintf(O64_INPUT,
            "    Interface_Temporary_setDedicated(interface, temporary[%d]);\n",
            Temporary_identity(temporary));
#endif//ECL_NTRACE
}

#line 981 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
Temporary
Interface_findTemporary(Interface this, CGIR_TN cgir_tn)
{
  void *pointer = HTable_search(Interface_TEMPORARIES(this), (HTableKey)cgir_tn);
  if (pointer != NULL) return *(Temporary *)pointer;
  return NULL;
}

#line 1076 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
/*
 * Implementation of O64 Interface Accessors Functions.
 */
uint32_t
Interface_Temporary_identity(Temporary temporary)
{
  return Temporary_identity(temporary);
}
int
Interface_Temporary_isAbsolute(Temporary temporary)
{
  return Temporary_isAbsolute(temporary);
}
int64_t
Interface_Temporary_value(Temporary temporary)
{
  TemporaryInvariant invariant = Temporary_INVARIANT(temporary);
  return TemporaryInvariant_VALUE(invariant);
}
int
Interface_Temporary_isSymbol(Temporary temporary)
{
  return Temporary_isSymbol(temporary);
}
Symbol
Interface_Temporary_symbol(Temporary temporary)
{
  TemporaryInvariant invariant = Temporary_INVARIANT(temporary);
  return TemporaryInvariant_SYMBOL(invariant);
}
int64_t
Interface_Temporary_offset(Temporary temporary)
{
  TemporaryInvariant invariant = Temporary_INVARIANT(temporary);
  return TemporaryInvariant_OFFSET(invariant);
}
Immediate
Interface_Temporary_invariant(Temporary temporary)
{
  Except_NEVER(true);
  return Immediate__UNDEF;
}
int
Interface_Temporary_isVirtual(Temporary temporary)
{
  return Temporary_isVirtual(temporary);
}
int
Interface_Temporary_isDedicated(Temporary temporary)
{
  return Temporary_isDedicated(temporary);
}
int
Interface_Temporary_isAssigned(Temporary temporary)
{
  return Temporary_isAssigned(temporary);
}
Register
Interface_Temporary_register(Temporary temporary)
{
  return Temporary_REGISTER(temporary);
}
RegFile
Interface_Temporary_regFile(Temporary temporary)
{
  return Temporary_REGFILE(temporary);
}
uint32_t
Interface_Symbol_identity(Symbol symbol)
{
  return Symbol_identity(symbol);
}
const char *
Interface_Symbol_name(Symbol symbol)
{
  return Symbol_name(symbol);
}
int
Interface_Symbol_isSpill(Symbol symbol)
{
  return Symbol_isSpill(symbol);
}
NativeType
Interface_Symbol_nativeType(Symbol symbol)
{
  return Symbol_nativeType(symbol);
}
uint32_t
Interface_Operation_identity(Operation operation)
{
  return Operation_identity(operation);
}
Operator
Interface_Operation_operator(Operation operation)
{
  return Operation_operator(operation);
}
int
Interface_Operation_iteration(Operation operation)
{
  return Operation_iteration(operation);
}
int
Interface_Operation_startDate(Operation operation)
{
  return Operation_startDate(operation);
}
int
Interface_Operation_isSpillCode(Operation operation)
{
  return Operation_isSpillCode(operation);
}
int
Interface_Operation_isVolatile(Operation operation)
{
  return Operation_isVolatile(operation);
}
int
Interface_Operation_isHoisted(Operation operation)
{
  return Operation_isHoisted(operation);
}
uint32_t
Interface_Label_identity(Label label)
{
  return Label_identity(label);
}
const char *
Interface_Label_name(Label label)
{
  return Label_name(label);
}
uint32_t
Interface_BasicBlock_identity(BasicBlock basicBlock)
{
  return BasicBlock_identity(basicBlock);
}
int
Interface_BasicBlock_unrolled(BasicBlock basicBlock)
{
  return BasicBlock_unrolled(basicBlock);
}
intptr_t
Interface_BasicBlock_traceId(BasicBlock basicBlock)
{
  return BasicBlock_traceId(basicBlock);
}
uint32_t
Interface_LoopScope_identity(LoopScope loopScope)
{
  return LoopScope_identity(loopScope);
}
int
Interface_LoopScope_unrolled(LoopScope loopScope)
{
  return LoopScope_unrolled(loopScope);
}

#line 1242 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
Operation
Interface_makeOperation(Interface this, CGIR_OP cgir_op,
    Operator operator, int iteration, int argCount, Temporary arguments[],
    int resCount, Temporary results[], int regCount, int registers[])
{
  Selector selector = Interface_SELECTOR(this);
  void *pointer = HTable_lookup(Interface_OPERATIONS(this),
                                (HTableKey)cgir_op, sizeof(Operation));
  Operation operation = *(Operation *)pointer;
  if (operation == NULL) {
    int i;
    RegisterSet_ clobberSet_;
    RegisterSet clobberSet = NULL;
    if (regCount != 0) {
      clobberSet = RegisterSet_Ctor(&clobberSet_);
      for (i = 0; i < regCount; i++) {
        RegisterSet_insert(clobberSet, registers[i]);
      }
    }
    operation = *(Operation *)pointer =
        Selector_makeOperation(selector, operator, resCount, argCount,
                               results, arguments, clobberSet);
    Selector_detachOperation(selector, operation);
#ifndef ECL_NTRACE
    O64_INPUT && fprintf(O64_INPUT,
        "    operation[%d] = Interface_makeOperation(interface, CGIR_OP(%d), Operator_%s, %d",
        Operation_identity(operation), CGIR_OP_identity(cgir_op),
        Operator_name_(operator), iteration);
    O64_INPUT && fprintf(O64_INPUT, ",\n\t%d, ", argCount);
    O64_INPUT && Interface_PrintTemporaries(O64_INPUT, argCount, arguments);
    O64_INPUT && fprintf(O64_INPUT, ",\n\t%d, ", resCount);
    O64_INPUT && Interface_PrintTemporaries(O64_INPUT, resCount, results);
    O64_INPUT && fprintf(O64_INPUT, ",\n\t%d, ", regCount);
    O64_INPUT && Interface_PrintRegisters(O64_INPUT, regCount, registers);
    O64_INPUT && fprintf(O64_INPUT, ");\n");
#endif//ECL_NTRACE
    Operation_setIteration(operation, iteration);
    //KEEP Interface_setCGIRImport(this, operation);
  }
  return operation;
}

#line 1290 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
Operation
Interface_findOperation(Interface this, CGIR_OP cgir_op)
{
  void *pointer = HTable_search(Interface_OPERATIONS(this), (HTableKey)cgir_op);
  if (pointer != NULL) return *(Operation *)pointer;
  return NULL;
}

#line 1304 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
void
Interface_Operation_setSafeAccess(Interface this, Operation operation)
{
  Operation_setFlags(operation, OperationFlag_SafeAccess);
#ifndef ECL_NTRACE
  O64_INPUT && fprintf(O64_INPUT,
      "    Interface_Operation_setSafeAccess(interface, operation[%d]);\n",
      Operation_identity(operation));
#endif//ECL_NTRACE
}

#line 1321 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
void
Interface_Operation_setSafePerfs(Interface this, Operation operation)
{
  Operation_setFlags(operation, OperationFlag_SafePerfs);
#ifndef ECL_NTRACE
  O64_INPUT && fprintf(O64_INPUT,
      "    Interface_Operation_setSafePerfs(interface, operation[%d]);\n",
      Operation_identity(operation));
#endif//ECL_NTRACE
}

#line 1338 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
void
Interface_Operation_setHoisted(Interface this, Operation operation)
{
  Operation_setFlags(operation, OperationFlag_Hoisted);
#ifndef ECL_NTRACE
  O64_INPUT && fprintf(O64_INPUT,
      "    Interface_Operation_setHoisted(interface, operation[%d]);\n",
      Operation_identity(operation));
#endif//ECL_NTRACE
}

#line 1355 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
void
Interface_Operation_setVolatile(Interface this, Operation operation)
{
  Operation_setFlags(operation, OperationFlag_Volatile);
#ifndef ECL_NTRACE
  O64_INPUT && fprintf(O64_INPUT,
      "    Interface_Operation_setVolatile(interface, operation[%d]);\n",
      Operation_identity(operation));
#endif//ECL_NTRACE
}

#line 1372 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
void
Interface_Operation_setPrefetch(Interface this, Operation operation)
{
  Operation_setFlags(operation, OperationFlag_Prefetch);
#ifndef ECL_NTRACE
  O64_INPUT && fprintf(O64_INPUT,
      "    Interface_Operation_setPrefetch(interface, operation[%d]);\n",
      Operation_identity(operation));
#endif//ECL_NTRACE
}

#line 1389 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
void
Interface_Operation_setPreload(Interface this, Operation operation)
{
  Operation_setFlags(operation, OperationFlag_Preload);
#ifndef ECL_NTRACE
  O64_INPUT && fprintf(O64_INPUT,
      "    Interface_Operation_setPreload(interface, operation[%d]);\n",
      Operation_identity(operation));
#endif//ECL_NTRACE
}

#line 1406 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
void
Interface_Operation_setBarrier(Interface this, Operation operation)
{
  Operation_setFlags(operation, OperationFlag_Barrier);
#ifndef ECL_NTRACE
  O64_INPUT && fprintf(O64_INPUT,
      "    Interface_Operation_setBarrier(interface, operation[%d]);\n",
      Operation_identity(operation));
#endif//ECL_NTRACE
}

#line 1423 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
void
Interface_Operation_setSpillCode(Interface this, Operation operation, Symbol symbol)
{
  Operation_setFlags(operation, OperationFlag_SpillCode);
#ifndef ECL_NTRACE
  O64_INPUT && fprintf(O64_INPUT,
      "    Interface_Operation_setSpillCode(interface, operation[%d], symbol[%d]);\n",
      Operation_identity(operation), Symbol_identity(symbol));
#endif//ECL_NTRACE
}

#line 1442 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
BasicBlock
Interface_makeBasicBlock(Interface this, CGIR_BB cgir_bb, Processor processor,
                         int unrolled, int labelCount, Label labels[], int operationCount,
                         Operation operations[], intptr_t regionId, float frequency)
{
  void *pointer = HTable_lookup(Interface_BASICBLOCKS(this),
                                (HTableKey)cgir_bb, sizeof(BasicBlock));
  BasicBlock basicBlock = *(BasicBlock *)pointer;
  if (basicBlock == NULL) {
    int i;
    Procedure procedure = Interface_PROCEDURE(this);
    if (frequency < 0.0) frequency = 0.0;	// HACK ALERT!
    basicBlock = *(BasicBlock *)pointer =
        Procedure_makeBasicBlock(procedure, processor, regionId, frequency);
    if (labelCount > 0) BasicBlock_addLabels(basicBlock, labelCount, labels);
#ifndef ECL_NTRACE
    O64_INPUT && fprintf(O64_INPUT,
        "    basicBlock[%d] = Interface_makeBasicBlock(interface, CGIR_BB(%d), Processor_%s, %d",
        BasicBlock_identity(basicBlock), CGIR_BB_identity(cgir_bb), Processor_name_(processor), unrolled);
    O64_INPUT && fprintf(O64_INPUT, ",\n\t%d, ", labelCount);
    O64_INPUT && Interface_PrintLabels(O64_INPUT, labelCount, labels);
    O64_INPUT && fprintf(O64_INPUT, ",\n\t%d, ", operationCount);
    O64_INPUT && Interface_PrintOperations(O64_INPUT, operationCount, operations);
    O64_INPUT && fprintf(O64_INPUT, ", 0x%x, %f);\n", regionId, frequency);
#endif//ECL_NTRACE
    for (i = 0; i < operationCount; i++) {
      Selector_attachLast(BasicBlock_selector(basicBlock), operations[i]);
      // FdF 20090421: The GNUASM flag is only set here. It should also
      // be updated whenever a GNUASM operation is added in or removed from a basic block.
      if (Operator_isGNUASM(Operation_operator(operations[i])))
	BasicBlock_setFlags(basicBlock, BasicBlockFlag_GNUASM);
    }
    BasicBlock_setUnrolled(basicBlock, unrolled);
    Interface_setCGIRImport(this, basicBlock);
  }
  return basicBlock;
}

#line 1486 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
BasicBlock
Interface_findBasicBlock(Interface this, CGIR_BB cgir_bb)
{
  void *pointer = HTable_search(Interface_BASICBLOCKS(this), (HTableKey)cgir_bb);
  if (pointer != NULL) return *(BasicBlock *)pointer;
  return NULL;
}

#line 1501 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
void
Interface_linkBasicBlocks(Interface this, BasicBlock tail_block,
                          BasicBlock head_block, float probability)
{
  Procedure procedure = Interface_PROCEDURE(this);
  if (probability < 0.0) probability = 0.0;	// HACK ALERT!
  BasicBlock_makeEdge(tail_block, head_block, probability);
#ifndef ECL_NTRACE
  O64_INPUT && fprintf(O64_INPUT,
      "    Interface_linkBasicBlocks(interface, basicBlock[%d], basicBlock[%d], %f);\n",
      BasicBlock_identity(tail_block), BasicBlock_identity(head_block), probability);
#endif//ECL_NTRACE
}

#line 1522 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
LoopScope
Interface_makeLoopScope(Interface this, CGIR_LD cgir_ld, BasicBlock basicBlock,
                        Temporary temporary, ConfigureItem item, ...)
{
  void *pointer = HTable_lookup(Interface_LOOPSCOPES(this),
                                (HTableKey)cgir_ld, sizeof(LoopScope));
  LoopScope loopScope = *(LoopScope *)pointer;
  if (loopScope == NULL) {
    va_list va;
    Procedure procedure = Interface_PROCEDURE(this);
    loopScope = *(LoopScope *)pointer = Procedure_makeLoopScope(procedure, basicBlock,
                                                                Interface_CONFIGURE(this));
    LoopScope_setTripCount(loopScope, temporary);	// FIXME! In case of SSA.
    va_start(va, item);
    Configure_loadVA(LoopScope_configure(loopScope), item, va);
    va_end(va);
#ifndef ECL_NTRACE
    O64_INPUT && fprintf(O64_INPUT,
        "    loopScope[%d] = Interface_makeLoopScope(interface, CGIR_LD(%d), basicBlock[%d], ",
        LoopScope_identity(loopScope), CGIR_LD_identity(cgir_ld), BasicBlock_identity(basicBlock));
    O64_INPUT && temporary != NULL && fprintf(O64_INPUT, "temporary[%d], ", Temporary_identity(temporary));
    O64_INPUT && temporary == NULL && fprintf(O64_INPUT, "NULL, ");
    O64_INPUT && Configure_print(LoopScope_configure(loopScope), O64_INPUT);
    O64_INPUT && fprintf(O64_INPUT, ");\n");
#endif//ECL_NTRACE
    //KEEP Interface_setCGIRImport(this, loopScope);
  }
  return loopScope;
}

#line 1558 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
LoopScope
Interface_findLoopScope(Interface this, CGIR_LD cgir_ld)
{
  void *pointer = HTable_search(Interface_LOOPSCOPES(this), (HTableKey)cgir_ld);
  if (pointer != NULL) return *(LoopScope *)pointer;
  return NULL;
}

#line 1572 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
void
Interface_LoopScope_setDependenceNode(Interface this, LoopScope loopScope, Operation operation, DependenceNode node)
{
  DependenceTable dependenceTable = LoopScope_makeDependenceTable(loopScope);
  DependenceTable_enterNode(dependenceTable, operation);
#ifndef ECL_NTRACE
  O64_INPUT && fprintf(O64_INPUT,
      "    Interface_LoopScope_setDependenceNode(interface, loopScope[%d], operation[%d], CGIR_WN(%d));\n",
      LoopScope_identity(loopScope), Operation_identity(operation), (int)node);
#endif//ECL_NTRACE
}

#line 1591 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
void
Interface_LoopScope_setDependenceArc(Interface this, LoopScope loopScope,
    Operation tail_operation, Operation head_operation, int latency, int omega, DependenceKind kind) {
  DependenceTable dependenceTable = LoopScope_makeDependenceTable(loopScope);
  DependenceTable_makeArc(dependenceTable, tail_operation, head_operation,
                          latency, omega, DependenceKind(kind));
#ifndef ECL_NTRACE
  O64_INPUT && fprintf(O64_INPUT,
      "    Interface_LoopScope_setDependenceArc(interface, loopScope[%d], operation[%d], operation[%d], %d, %d",
      LoopScope_identity(loopScope), Operation_identity(tail_operation), Operation_identity(head_operation), latency, omega);
  O64_INPUT && fprintf(O64_INPUT,
      ", DependenceKind_%s);\n",
      DependenceKind_name_(DependenceKind(kind)));
#endif//ECL_NTRACE
}

#line 1614 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
void
Interface_setBody(Interface this, BasicBlock basicBlock)
{
  Procedure procedure = Interface_PROCEDURE(this);
#ifndef ECL_NTRACE
  O64_INPUT && fprintf(O64_INPUT,
      "    Interface_setBody(interface, basicBlock[%d]);\n",
      BasicBlock_identity(basicBlock));
#endif//ECL_NTRACE
}

#line 1632 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
void
Interface_setEntry(Interface this, BasicBlock basicBlock)
{
  Procedure procedure = Interface_PROCEDURE(this);
  Procedure_setEntryBlock(procedure, basicBlock);
#ifndef ECL_NTRACE
  O64_INPUT && fprintf(O64_INPUT,
      "    Interface_setEntry(interface, basicBlock[%d]);\n",
      BasicBlock_identity(basicBlock));
#endif//ECL_NTRACE
}

#line 1651 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
void
Interface_setExit(Interface this, BasicBlock basicBlock)
{
  Procedure procedure = Interface_PROCEDURE(this);
  Procedure_setExitBlock(procedure, basicBlock);
#ifndef ECL_NTRACE
  O64_INPUT && fprintf(O64_INPUT,
      "    Interface_setExit(interface, basicBlock[%d]);\n",
      BasicBlock_identity(basicBlock));
#endif//ECL_NTRACE
}

#line 1670 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
void
Interface_setStart(Interface this, BasicBlock basicBlock)
{
  Procedure procedure = Interface_PROCEDURE(this);
  Procedure_setStartBlock(procedure, basicBlock);
#ifndef ECL_NTRACE
  O64_INPUT && fprintf(O64_INPUT,
      "    Interface_setStart(interface, basicBlock[%d]);\n",
      BasicBlock_identity(basicBlock));
#endif//ECL_NTRACE
}

#line 1685 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
/*
 * Interface_makeCGIR_LAB --	Make the CGIR_LAB associated with a Label.
 */
static CGIR_LAB
Interface_makeCGIR_LAB(Interface this, const_Label label, CGIR_CallBack callback)
{
  InterfaceMapped mapped = HTable_lookup(Interface_LIR2CGIR(this),
                                         (HTableKey)label, sizeof(InterfaceMapped_));
  CGIR_LAB cgir_lab = (CGIR_LAB)InterfaceMapped_CGIR(mapped);
  //
  if (!Interface_isCGIRValid(this, label)) {
    const char *name = Label_name(label);
    if (cgir_lab == (CGIR_LAB)0) {
      // Just created by HTable_lookup.
      cgir_lab = (*CGIR_CallBack_LAB_make(callback))((CGIR_LAB)0, name);
      // WARNING: cgir_lab is now different from Label_INDEX!
      // Update CGIR -> LAO table.
      *(const_Label *)HTable_lookup(Interface_LABELS(this),
                                    (HTableKey)cgir_lab, sizeof(Label)) = label;
      InterfaceMapped_Ctor(mapped, (InterfaceCGIR)cgir_lab, InterfaceType_Label);
    } else {
      cgir_lab = (*CGIR_CallBack_LAB_make(callback))(cgir_lab, name);
      Except_CHECK(InterfaceMapped_TYPE(mapped) == InterfaceType_Label);
      *InterfaceMapped__CGIR(mapped) = (InterfaceCGIR)cgir_lab;
    }
    Interface_setCGIRValid(this, label);
  }
  Except_ENSURE(cgir_lab != 0);
  return cgir_lab;
}

#line 1716 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
/*
 * Interface_makeCGIR_SYM --	Make the CGIR_SYM associated with a Symbol.
 */
static CGIR_SYM
Interface_makeCGIR_SYM(Interface this, const_Symbol symbol, CGIR_CallBack callback)
{
  InterfaceMapped mapped = HTable_lookup(Interface_LIR2CGIR(this),
                                         (HTableKey)symbol, sizeof(InterfaceMapped_));
  CGIR_SYM cgir_sym = (CGIR_SYM)InterfaceMapped_CGIR(mapped);
  //
  if (!Interface_isCGIRValid(this, symbol)) {
    const char *name = Symbol_name(symbol);
    bool isSpill = Symbol_isSpill(symbol);
    NativeType lai_nativeType = Symbol_nativeType(symbol);
    if (cgir_sym == (CGIR_SYM)0) {
      // Just created by HTable_lookup.
      cgir_sym = (*CGIR_CallBack_SYM_make(callback))((CGIR_SYM)0, name, isSpill, lai_nativeType);
      // WARNING: cgir_sym is now different from Symbol_INDEX!
      // Update CGIR -> LAO table.
      *(const_Symbol *)HTable_lookup(Interface_SYMBOLS(this),
                                     (HTableKey)cgir_sym, sizeof(Symbol)) = symbol;
      InterfaceMapped_Ctor(mapped, (InterfaceCGIR)cgir_sym, InterfaceType_Symbol);
    } else {
      cgir_sym = (*CGIR_CallBack_SYM_make(callback))(cgir_sym, name, isSpill, lai_nativeType);
      Except_CHECK(InterfaceMapped_TYPE(mapped) == InterfaceType_Symbol);
      *InterfaceMapped__CGIR(mapped) = (InterfaceCGIR)cgir_sym;
    }
    Interface_setCGIRValid(this, symbol);
  }
  Except_ENSURE(cgir_sym != 0);
  return cgir_sym;
}

#line 1749 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
/*
  Interface_makeCGIR_TN -- Make the CGIR_TN associated with a Temporary.
 */
static CGIR_TN
Interface_makeCGIR_TN(Interface this, const_Temporary temporary, CGIR_CallBack callback)
{
  InterfaceMapped mapped = HTable_lookup(Interface_LIR2CGIR(this),
                                         (HTableKey)temporary, sizeof(InterfaceMapped_));
  CGIR_TN cgir_tn = (CGIR_TN)InterfaceMapped_CGIR(mapped);
  //
  if (!Interface_isCGIRValid(this, temporary)) {
    if (cgir_tn == (CGIR_TN)0) {
      // Just created by HTable_lookup.
      if (Temporary_hasRegFile(temporary)) {
        RegFile cgir_regFile = Temporary_REGFILE(temporary);
        Register cgir_register = Temporary_REGISTER(temporary);
        unsigned width = Temporary_WIDTH(temporary);
        if (Temporary_isAssigned(temporary)) {
          cgir_tn = (*CGIR_CallBack_TN_make(callback))((CGIR_TN)0, CGIRType_Assigned,
                                                       cgir_regFile, cgir_register,
                                                       width);
        } else if (Temporary_isDedicated(temporary)) {
          cgir_tn = (*CGIR_CallBack_TN_make(callback))((CGIR_TN)0, CGIRType_Dedicated,
                                                       cgir_regFile, cgir_register,
                                                       width);
        } else if (Temporary_isVirtual(temporary)) {
          cgir_tn = (*CGIR_CallBack_TN_make(callback))((CGIR_TN)0, CGIRType_Virtual,
                                                       cgir_regFile, cgir_register,
                                                       width);
        } else Except_NEVER(true);
      } else if (Temporary_isInvariant(temporary)) {
        TemporaryInvariant invariant = Temporary_INVARIANT(temporary);
        if (Temporary_isAbsolute(temporary)) {
          int64_t value = TemporaryInvariant_VALUE(invariant);
          cgir_tn = (*CGIR_CallBack_TN_make(callback))((CGIR_TN)0, CGIRType_Absolute,
                                                       value);
        } else if (Temporary_isSymbol(temporary)) {
          CGIR_SYM cgir_sym = Interface_makeCGIR_SYM(this,
                                                     TemporaryInvariant_SYMBOL(invariant),
                                                     callback);
          int64_t offset = TemporaryInvariant_OFFSET(invariant);
          cgir_tn = (*CGIR_CallBack_TN_make(callback))((CGIR_TN)0, CGIRType_Symbol,
                                                       cgir_sym, offset);
        } else if (Temporary_isLabel(temporary)) {
          CGIR_LAB cgir_lab = Interface_makeCGIR_LAB(this,
                                                     TemporaryInvariant_LABEL(invariant),
                                                     callback);
          cgir_tn = (*CGIR_CallBack_TN_make(callback))((CGIR_TN)0, CGIRType_Label,
                                                       cgir_lab);
        } else Except_NEVER(true);
      } else Except_NEVER(true);
      // Update CGIR -> LAO table.
      *(const_Temporary *)HTable_lookup(Interface_TEMPORARIES(this),
                                        (HTableKey)cgir_tn, sizeof(Temporary)) = temporary;
      InterfaceMapped_Ctor(mapped, (InterfaceCGIR)cgir_tn, InterfaceType_Temporary);
    } else {
      if (Temporary_isAssigned(temporary)) {
        RegFile cgir_regFile = Temporary_REGFILE(temporary);
        Register cgir_register = Temporary_REGISTER(temporary);
        cgir_tn = (*CGIR_CallBack_TN_make(callback))(cgir_tn, CGIRType_Assigned,
                                                     cgir_regFile, cgir_register);
      } else if (Temporary_isVirtual(temporary)) {
        RegFile cgir_regFile = Temporary_REGFILE(temporary);
        Register cgir_register = Temporary_REGISTER(temporary);
        cgir_tn = (*CGIR_CallBack_TN_make(callback))(cgir_tn, CGIRType_Virtual,
                                                     cgir_regFile, cgir_register);
      } else {
        cgir_tn = (*CGIR_CallBack_TN_make(callback))(cgir_tn, CGIRType__);
      }
      Except_CHECK(InterfaceMapped_TYPE(mapped) == InterfaceType_Temporary);
      *InterfaceMapped__CGIR(mapped) = (InterfaceCGIR)cgir_tn;
    }
    Interface_setCGIRValid(this, temporary);
  }
  Except_ENSURE(cgir_tn != (CGIR_TN)0);
  return cgir_tn;
}

#line 1827 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
/*
 * Interface_makeCGIR_OP --	Make the CGIR_OP associated with an Operation.
 */
static CGIR_OP
Interface_makeCGIR_OP(Interface this, const_Operation operation, CGIR_CallBack callback)
{
  InterfaceMapped mapped = HTable_lookup(Interface_LIR2CGIR(this),
                                         (HTableKey)operation, sizeof(InterfaceMapped_));
  CGIR_OP cgir_op = (CGIR_OP)InterfaceMapped_CGIR(mapped);
  //
  if (!Interface_isCGIRValid(this, operation)) {
    Memory memory =  Interface_MEMORY(this);
    Operator operator = Operation_operator(operation);
    int argCount = Operation_argCount(operation), i = 0;
    int resCount = Operation_resCount(operation), j = 0;
    int iteration = Operation_iteration(operation);
    int startDate = Operation_startDate(operation);
    const_Operation orig_operation = Operation_replicated(operation);
    CGIR_TN *arguments = Memory_alloc(memory, sizeof(CGIR_TN)*(argCount + 1));
    CGIR_TN *results = Memory_alloc(memory, sizeof(CGIR_TN)*(resCount + 1));
    CGIR_OP orig_op = (CGIR_OP)0;
    CGIR_WN cgir_wn = NULL;	//TODO!
    unsigned flags = 0;
    if (Operation_isSafeAccess(operation)) flags |= CGIROperationFlags_SafeAccess;
    if (Operation_isHoisted(operation)) flags |= CGIROperationFlags_Hoisted;
    if (Operation_isVolatile(operation)) flags |= CGIROperationFlags_Volatile;
    if (Operation_isPrefetch(operation)) flags |= CGIROperationFlags_Prefetch;
    if (Operation_isPreload(operation)) flags |= CGIROperationFlags_Preload;
    if (Operation_isBarrier(operation)) flags |= CGIROperationFlags_Barrier;
    if (Operation_isSafePerfs(operation)) flags |= CGIROperationFlags_SafePerfs;
    if (Operation_isSpillCode(operation)) flags |= CGIROperationFlags_SpillCode;
    if (orig_operation != NULL) {
      // orig_op not 0 in case orig_operation exists.
      Except_CHECK(orig_operation != operation);
      orig_op = Interface_makeCGIR_OP(this, orig_operation, callback);
    }
    //
#ifndef ECL_NTRACE
    if (O64_OUTPUT) {
      fprintf(O64_OUTPUT, "// update OP: ");
      Operation_pretty(operation, O64_OUTPUT);
    }
#endif//ECL_NTRACE
#ifdef MDS_TARGET_st200
    if (operator == Operator_SKIP) operator = Operator_st200_nop;//HACK!
    if (operator == Operator_COPY) operator = Operator_st200_mov_1general_2general;//HACK!
#endif//MDS_TARGET_st200
#ifdef MDS_TARGET_arm
    if (operator == Operator_SKIP) operator = Operator_arm_nop;//HACK!
    if (operator == Operator_COPY) operator = Operator_arm_moval_reg_1noPC_2general;//HACK!
#endif//MDS_TARGET_arm
    if (!Operator_isWriteList(operator)) resCount = Operator_writeCount(operator);
    if (!Operator_isReadList(operator)) argCount = Operator_readCount(operator);
    Operation_resizeOperands((Operation)operation, resCount, argCount);//HACK! cast.
    Operation_ARGUMENTS_FOREACH_Temporary(operation, temporary) {
      arguments[i++] = Interface_makeCGIR_TN(this, temporary, callback);
    } Operation_ARGUMENTS_ENDEACH_Temporary;
    Except_CHECK(i <= argCount);
    arguments[i] = (CGIR_TN)0;
    Operation_RESULTS_FOREACH_Temporary(operation, temporary) {
      results[j++] = Interface_makeCGIR_TN(this, temporary, callback);
    } Operation_RESULTS_ENDEACH_Temporary;
    Except_CHECK(j <= resCount);
    results[j] = (CGIR_TN)0;
    //
    if (cgir_op == (CGIR_OP)0) {
      // Just created by HTable_lookup.
      cgir_op = (*CGIR_CallBack_OP_make(callback))(cgir_op,
          (Operator)operator, arguments, results, orig_op);
      // Update CGIR -> LAO table
      *(const_Operation *)HTable_lookup(Interface_OPERATIONS(this),
                                        (HTableKey)cgir_op, sizeof(Operation)) = operation;
      InterfaceMapped_Ctor(mapped, (InterfaceCGIR)cgir_op, InterfaceType_Operation);
    } else {
      cgir_op = (*CGIR_CallBack_OP_make(callback))(cgir_op,
          (Operator)operator, arguments, results, orig_op);
      Except_CHECK(InterfaceMapped_TYPE(mapped) == InterfaceType_Operation);
      *InterfaceMapped__CGIR(mapped) = (InterfaceCGIR)cgir_op;
      // Prevent redundant spill code processing.
      flags &= ~CGIROperationFlags_SpillCode;
    }
    (*CGIR_CallBack_OP_more(callback))(cgir_op, iteration, startDate, flags);
    Interface_setCGIRValid(this, operation);
    Memory_free_(memory, results);
    Memory_free_(memory, arguments);
  }
  Except_ENSURE(cgir_op != (CGIR_OP)0);
  return cgir_op;
}

#line 1917 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
/*
 * Interface_makeCGIR_BB --	Make the CGIR_BB associated with a BasicBlock.
 */
static CGIR_BB
Interface_makeCGIR_BB(Interface this, const_BasicBlock basicBlock, CGIR_CallBack callback)
{
  InterfaceMapped mapped = HTable_lookup(Interface_LIR2CGIR(this),
                                         (HTableKey)basicBlock, sizeof(InterfaceMapped_));
  CGIR_BB cgir_bb = (CGIR_BB)InterfaceMapped_CGIR(mapped);
  //
  if (!Interface_isCGIRValid(this, basicBlock)) {
    Memory memory =  Interface_MEMORY(this);
    Procedure procedure = Interface_PROCEDURE(this);
    int controlCount = 0;
    int labelCount = BasicBlock_labelCount(basicBlock), i = 0;
    int operationCount = BasicBlock_countOperations(basicBlock), j = 0;
    CGIR_LAB *cgir_labels = Memory_alloc(memory, sizeof(CGIR_LAB)*(labelCount + 1));
    CGIR_OP *cgir_operations = Memory_alloc(memory, sizeof(CGIR_OP)*(operationCount + 1));
    CGIR_RID cgir_rid = (CGIR_RID)BasicBlock_regionId(basicBlock);
    float frequency = BasicBlock_frequency(basicBlock);
    intptr_t traceId = BasicBlock_traceId(basicBlock);
    int unrolled = BasicBlock_unrolled(basicBlock);
    LoopScope loopScope = BasicBlock_loopScope(basicBlock);
    BasicBlock headerBlock = NULL;
    CGIR_BB loop_bb = (CGIR_BB)0;
    unsigned flags = 0;
    if (BasicBlock_isAllocated(basicBlock)) flags |= CGIRBasicBlockFlags_Allocated;
    if (BasicBlock_isScheduled(basicBlock)) flags |= CGIRBasicBlockFlags_Scheduled;
    if (loopScope != NULL && LoopScope_isSimple(loopScope)) {
      headerBlock = LoopScope_headerBlock(loopScope);
    }
    //
    BasicBlock_FOREACH_Label(basicBlock, label) {
      cgir_labels[i++] = Interface_makeCGIR_LAB(this, label, callback);
    } BasicBlock_ENDEACH_Label;
    cgir_labels[labelCount] = (CGIR_LAB)0;
    Except_CHECK(i == labelCount);
    BasicBlock_FOREACH_Operation(basicBlock, operation) {
      cgir_operations[j++] = Interface_makeCGIR_OP(this, operation, callback);
      if (Operator_isControl(Operation_operator(operation))) ++controlCount;
    } BasicBlock_ENDEACH_Operation;
    cgir_operations[operationCount] = (CGIR_OP)0;
    Except_CHECK(j == operationCount);
    Except_CHECK(controlCount <= 1);
    //
    if (cgir_bb == (CGIR_BB)0) {
      // Just created by HTable_lookup.
      cgir_bb = (*CGIR_CallBack_BB_make(callback))((CGIR_BB)0,
          cgir_labels, cgir_operations, cgir_rid, frequency);
      // Update CGIR -> LAO table
      *(const_BasicBlock *)HTable_lookup(Interface_BASICBLOCKS(this),
                                         (HTableKey)cgir_bb, sizeof(BasicBlock)) = basicBlock;
      InterfaceMapped_Ctor(mapped, (InterfaceCGIR)cgir_bb, InterfaceType_BasicBlock);
    } else {
      cgir_bb = (*CGIR_CallBack_BB_make(callback))(cgir_bb,
          cgir_labels, cgir_operations, cgir_rid, frequency);
      Except_CHECK(InterfaceMapped_TYPE(mapped) == InterfaceType_BasicBlock);
      *InterfaceMapped__CGIR(mapped) = (InterfaceCGIR)cgir_bb;
    }
    if (headerBlock == NULL) loop_bb = (CGIR_BB)0;
    else if (headerBlock == basicBlock) loop_bb = cgir_bb;
    else loop_bb = Interface_makeCGIR_BB(this, headerBlock, callback);
    (*CGIR_CallBack_BB_more(callback))(cgir_bb, loop_bb, traceId, unrolled, flags);
    Interface_setCGIRValid(this, basicBlock);
    Memory_free_(memory, cgir_operations);
    Memory_free_(memory, cgir_labels);
  }
  Except_ENSURE(cgir_bb != (CGIR_BB)0);
  return cgir_bb;
}

#line 1988 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
/*
 * Interface_makeCGIR_LD --	Make the CGIR_LD associated with a LoopScope.
 */
static CGIR_LD
Interface_makeCGIR_LD(Interface this, const_LoopScope loopScope, CGIR_CallBack callback)
{
  InterfaceMapped mapped = HTable_lookup(Interface_LIR2CGIR(this),
                                         (HTableKey)loopScope, sizeof(InterfaceMapped_));
  CGIR_LD cgir_ld = (CGIR_LD)InterfaceMapped_CGIR(mapped);
  //
  if (!Interface_isCGIRValid(this, loopScope)) {
    Temporary tripCount = LoopScope_tripCount(loopScope);
    BasicBlock headerBlock = LoopScope_headerBlock(loopScope);
    CGIR_BB cgir_header_bb = Interface_makeCGIR_BB(this, headerBlock, callback);
    CGIR_TN cgir_trip_count_tn = tripCount != NULL?
        Interface_makeCGIR_TN(this, tripCount, callback): NULL;
    int unrolled = LoopScope_unrolled(loopScope);
    if (cgir_ld == (CGIR_LD)0) {
      // Just created by HTable_lookup.
      cgir_ld = (*CGIR_CallBack_LD_make(callback))((CGIR_LD)0, cgir_header_bb,
                                                   cgir_trip_count_tn, unrolled);
      // Fix for bugs/st200/pro-release-1-9-0-B/4.
      if (cgir_ld == (CGIR_LD)0) return cgir_ld;
      // Update CGIR -> LAO table.
      *(const_LoopScope *)HTable_lookup(Interface_LOOPSCOPES(this),
                                        (HTableKey)cgir_ld, sizeof(LoopScope)) = loopScope;
      InterfaceMapped_Ctor(mapped, (InterfaceCGIR)cgir_ld, InterfaceType_LoopScope);
    } else {
      cgir_ld = (*CGIR_CallBack_LD_make(callback))(cgir_ld, cgir_header_bb,
                                                   cgir_trip_count_tn, unrolled);
      Except_CHECK(InterfaceMapped_TYPE(mapped) == InterfaceType_LoopScope);
      *InterfaceMapped__CGIR(mapped) = (InterfaceCGIR)cgir_ld;
    }
    Interface_setCGIRValid(this, loopScope);
  }
  Except_ENSURE(cgir_ld != (CGIR_LD)0);
  return cgir_ld;
}

#line 2027 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
/*
 * Interface_fillLIR2CGIR --	Construct and fill the LIR2CGIR HTable.
 */
static void
Interface_fillLIR2CGIR(Interface this)
{
  Interface_FOREACH_Label(this, cgir_lab, label) {
    InterfaceMapped mapped = HTable_insert(Interface_LIR2CGIR(this),
                                           (HTableKey)label, sizeof(InterfaceMapped_));
    InterfaceMapped_Ctor(mapped, (InterfaceCGIR)cgir_lab, InterfaceType_Label);
  } Interface_ENDEACH_Label;
  Interface_FOREACH_Symbol(this, cgir_sym, symbol) {
    InterfaceMapped mapped = HTable_insert(Interface_LIR2CGIR(this),
                                           (HTableKey)symbol, sizeof(InterfaceMapped_));
    InterfaceMapped_Ctor(mapped, (InterfaceCGIR)cgir_sym, InterfaceType_Symbol);
  } Interface_ENDEACH_Symbol;
  Interface_FOREACH_Temporary(this, cgir_tn, temporary) {
    InterfaceMapped mapped = HTable_insert(Interface_LIR2CGIR(this),
                                           (HTableKey)temporary,
                                           sizeof(InterfaceMapped_));
    InterfaceMapped_Ctor(mapped, (InterfaceCGIR)cgir_tn, InterfaceType_Temporary);
  } Interface_ENDEACH_Temporary;
  Interface_FOREACH_Operation(this, cgir_op, operation) {
    InterfaceMapped mapped = HTable_insert(Interface_LIR2CGIR(this),
                                           (HTableKey)operation,
                                           sizeof(InterfaceMapped_));
    InterfaceMapped_Ctor(mapped, (InterfaceCGIR)cgir_op, InterfaceType_Operation);
  } Interface_ENDEACH_Operation;
  Interface_FOREACH_BasicBlock(this, cgir_bb, basicBlock) {
    InterfaceMapped mapped = HTable_insert(Interface_LIR2CGIR(this),
                                           (HTableKey)basicBlock,
                                           sizeof(InterfaceMapped_));
    InterfaceMapped_Ctor(mapped, (InterfaceCGIR)cgir_bb, InterfaceType_BasicBlock);
  } Interface_ENDEACH_BasicBlock;
  Interface_FOREACH_LoopScope(this, cgir_ld, loopScope) {
    InterfaceMapped mapped = HTable_insert(Interface_LIR2CGIR(this),
                                           (HTableKey)loopScope, sizeof(InterfaceMapped_));
    InterfaceMapped_Ctor(mapped, (InterfaceCGIR)cgir_ld, InterfaceType_LoopScope);
  } Interface_ENDEACH_LoopScope;
}

#line 2068 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
/*
 * Interface_findCGIR_BB --	Find the CGIR_BB associated with a BasicBlock.
 */
static inline CGIR_BB
Interface_findCGIR_BB(Interface this, BasicBlock basicBlock)
{
  InterfaceMapped mapped = HTable_search(Interface_LIR2CGIR(this), (HTableKey)basicBlock);
  CGIR_BB cgir_bb = (CGIR_BB)InterfaceMapped_CGIR(mapped);
  Except_CHECK(InterfaceMapped_TYPE(mapped) == InterfaceType_BasicBlock);
  return cgir_bb;
}

#line 2086 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
void
Interface_updateCGIR(Interface this, CGIR_CallBack callback)
{
  if (callback != NULL) {
    Procedure procedure = Interface_PROCEDURE(this);
    CGIR_BB first_cgir_bb = NULL, prev_cgir_bb = NULL;
    //
    // Fill the LIR2CGIR table.
    Interface_fillLIR2CGIR(this);
    //
    // For each LIR BasicBlock, update the corresponding BB. This will recursively
    // trigger updates of OPs, TNs, etc. For the BasicBlocks that were created
    // through this Interface, unchain and unlink in the CGIR the corresponding BBs.
#ifndef ECL_NTRACE
    O64_INPUT && fprintf(O64_INPUT, "  Interface_updateCGIR(interface, NULL);\n");
#endif//ECL_NTRACE
    Procedure_FOREACH_BasicBlock(procedure, basicBlock) {
      CGIR_BB cgir_bb = Interface_makeCGIR_BB(this, basicBlock, callback);
      if (Interface_isCGIRImport(this, basicBlock)) {
        (*CGIR_CallBack_BB_unlink(callback))(cgir_bb,	
            !BasicBlock_isEntry(basicBlock), !BasicBlock_isExit(basicBlock));
        if (first_cgir_bb == NULL) first_cgir_bb = cgir_bb;
        else (*CGIR_CallBack_BB_unchain(callback))(cgir_bb);
      }
    } Procedure_ENDEACH_BasicBlock;
    //
    // Traverse the LIR BasicBlocks to update the CGIR_LD and restore the CGIR_BB chains.
    Procedure_FOREACH_BasicBlock(procedure, basicBlock) {
      CGIR_BB cgir_bb = Interface_findCGIR_BB(this, basicBlock);
      LoopScope loopScope = BasicBlock_loopScope(basicBlock);
      if (loopScope != NULL && LoopScope_isSimple(loopScope)) {
        Interface_makeCGIR_LD(this, loopScope, callback);
      }
      if (cgir_bb != first_cgir_bb) {
        (*CGIR_CallBack_BB_chain(callback))(prev_cgir_bb, cgir_bb);
      }
      prev_cgir_bb = cgir_bb;
    } Procedure_ENDEACH_BasicBlock;
    //
    // Restore the CGIR_BB links from the BasicBlockEdge(s).
    Procedure_FOREACH_BasicBlock(procedure, tailBlock) {
      CGIR_BB tail_bb = Interface_findCGIR_BB(this, tailBlock);
      BasicBlock_LEAVE_FOREACH_BasicBlockEdge(tailBlock, edge) {
        BasicBlock destBlock = BasicBlockEdge_destBlock(edge);
        float probability = BasicBlockEdge_probability(edge);
        if (BasicBlock_index(destBlock) != 0) {
          CGIR_BB head_bb = Interface_findCGIR_BB(this, destBlock);
          (*CGIR_CallBack_BB_link(callback))(tail_bb, head_bb, probability);
        } else {
          // FIXME! There should be no CodeRegion rootBlock left here.
        }
      } BasicBlock_LEAVE_ENDEACH_BasicBlockEdge;
    } Procedure_ENDEACH_BasicBlock;
    //
    // Traverse the discarded BasicBlock(s).
    Procedure_DISCARDED_FOREACH_BasicBlock(procedure, basicBlock) {
      if (Interface_isCGIRImport(this, basicBlock)) {
        CGIR_BB cgir_bb = Interface_findCGIR_BB(this, basicBlock);
        if (cgir_bb != NULL) (*CGIR_CallBack_BB_discard(callback))(cgir_bb);
      }
    } Procedure_DISCARDED_ENDEACH_BasicBlock;
  }
}

#line 2159 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
void
Interface_Initialize(void)
{
  O64_Initialize();
}

#line 2168 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
int Interface_Counter = 0;

#line 2176 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
void
Interface_open(Interface this, const char *name, ConfigureItem item, ...)
{
  va_list va;
  int lir2cgir_estimate = 2000;
  int label_estimate = 10;
  int symbol_estimate = 20;
  int temporary_estimate = 1000;
  int operation_estimate = 500;
  int basicBlock_estimate = 20;
  int loopScope_estimate = 10;
  int cgirImport_estimate = 20;
  int cgirValid_estimate = 2000;
  //
  if (GETENV("LAO_PID")) {
    static int dummy = -1;
    if (dummy <= 0) {
      int getpid(void);
      fprintf(stderr, "LAO_PID=%d\n", getpid());
      scanf("%d", &dummy);
    }
  }
  O64_Open();
  program = Program_new(Interface_MEMORY(this));
  *Interface__CONFIGURE(this) = Program_configure(program);
  //
  va_start(va, item);
  Configure_loadVA(Interface_CONFIGURE(this), item, va);
  va_end(va);
  //
  //
#ifndef ECL_NTRACE
  O64_INPUT && !Interface_Counter && fprintf(O64_INPUT, "}\n");
  O64_INPUT && fprintf(O64_INPUT, "\nvoid Interface_%d(void) {\n", ++Interface_Counter);
  O64_INPUT && fprintf(O64_INPUT, "  Interface_open(interface, \"%s\", ", name);
  O64_INPUT && Configure_print(Interface_CONFIGURE(this), O64_INPUT);
  O64_INPUT && fprintf(O64_INPUT, ");\n");
#endif//ECL_NTRACE
  //
  Except_REQUIRE(Interface_PROCEDURE(this) == NULL);
  {
    Symbol symbol = SymbolTable_makeSymbol(Program_symbolTable(program), name);
    Procedure procedure = Program_makeProcedure(program, symbol);
    Selector_Ctor(Interface_SELECTOR(this), Procedure_memory(procedure),
                                            procedure, Processor__UNDEF, false);
  }
  //
  {
    Memory memory = Interface_MEMORY(this);
    HTable_Ctor(Interface_LIR2CGIR(this), memory, lir2cgir_estimate);
    HTable_Ctor(Interface_LABELS(this), memory, label_estimate);
    HTable_Ctor(Interface_SYMBOLS(this), memory, symbol_estimate);
    HTable_Ctor(Interface_TEMPORARIES(this), memory, temporary_estimate);
    HTable_Ctor(Interface_OPERATIONS(this), memory, operation_estimate);
    HTable_Ctor(Interface_BASICBLOCKS(this), memory, basicBlock_estimate);
    HTable_Ctor(Interface_LOOPSCOPES(this), memory, loopScope_estimate);
    HTable_Ctor(Interface_CGIRIMPORT(this), memory, cgirImport_estimate);
    HTable_Ctor(Interface_CGIRVALID(this), memory, cgirValid_estimate);
  }
}

#line 2237 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
static void
dedicatedToAssigned(SSAForm ssaForm, Operation virtualDef);

#line 2240 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
// p_entry and p_virtualDef, if they are set, will contain respectivly
// the entry basic block and the virtual operation inserted in the entry block,
// which defined all dedicated temporaries
static void
explicitDependencies(SSAForm ssaForm, BasicBlock* p_entry,
                     Operation* p_virtualDef) {
  CodeRegion codeRegion = SSAForm_codeRegion(ssaForm);
  Memory memory = SSAForm_memory(ssaForm);
  Procedure procedure = CodeRegion_procedure(codeRegion);
  int32_t i;
  TemporaryTable globalTable =
    CodeRegion_makeGlobalTable(codeRegion, TemporaryFlag_Constant, 0);
  Liveness liveness = Liveness_make(memory, codeRegion, globalTable, false);
  BasicBlock entry = CodeRegion_firstBlock(codeRegion);
  Operation virtualDef =
    BasicBlock_makeOperationPCOPY(entry,
                                  //FIXME: Be sure to place after sp adjust
                                  BasicBlock_firstOperation(entry),
                                  false, Register__COUNT, 1);
  Except_CHECK(BasicBlock_isEntry(entry));

#line 2261 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
  TemporarySet_FOREACH_Temporary(BasicBlock_liveInSet(entry), temp) {
    if(Temporary_isDedicated(temp)) {
      Operation_addtoParCopy(virtualDef, temp, temp);
    }
  } TemporarySet_ENDEACH_Temporary;

#line 2267 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
  dedicatedToAssigned(ssaForm, virtualDef);
  Liveness_kill(liveness);
  if(p_virtualDef != NULL) {
    *p_virtualDef = virtualDef;
  }
  if(p_entry != NULL) {
    *p_entry = entry;
  }
}

#line 2277 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
// Collect all registers temporaries: Produce a dense index of all temporaries
static void
collectVirtualTemporaries(CodeRegion codeRegion, TemporaryTable table) {

#line 2281 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
  CodeRegion_FOREACH_BasicBlock(codeRegion, basicBlock) {
    BasicBlock_FOREACH_Operation(basicBlock, operation) {
      Operation_ARGUMENTS_FOREACH_Temporary(operation, argument) {
        if(Temporary_hasRegFile(argument)) {
          TemporaryTable_insert(table, argument);
        }
      } Operation_ARGUMENTS_ENDEACH_Temporary;
      Operation_RESULTS_FOREACH_Temporary(operation, result) {
        if(Temporary_hasRegFile(result)) {
          TemporaryTable_insert(table, result);
        }
      } Operation_RESULTS_ENDEACH_Temporary;
    } BasicBlock_ENDEACH_Operation;
  } CodeRegion_ENDEACH_BasicBlock;
}

#line 2297 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
static void
updateDefUses(Operation pcopy, int32_t idx, Operation move) {
  Temporary res = Operation_getResult(move, 0);
  Temporary arg = Operation_getArgument(move, 0);
  if(Temporary_isVariable(res)) {
    DefUses defUses = Temporary_defUses(res);
    DefUses_setDef(defUses, pcopy, idx);
  }
  if(Temporary_isVariable(arg)) {
    DefUses defUses = Temporary_defUses(arg);
    DefUses_addUse(defUses, pcopy, idx);
    DefUses_removeUse(defUses, move, 0);
  }
}

#line 2312 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
// simply factorize successive move to or from a dedicated register into a
// parallel copy
static void
factorizeDedicatedMoves(BasicBlock basicBlock) {
  Operation pCopiesRhs[RegFile__COUNT];
  Operation pCopiesLhs[RegFile__COUNT];
  memset(pCopiesRhs, 0, RegFile__COUNT * sizeof(Operation));
  memset(pCopiesLhs, 0, RegFile__COUNT * sizeof(Operation));
  
  BasicBlock_FOREACH_Operation(basicBlock, operation) {
    if(Operator_isSeqCopy(Operation_operator(operation))
       && Temporary_regFile(Operation_getResult(operation, 0))
       == Temporary_regFile(Operation_getArgument(operation, 0))) {
      Temporary res = Operation_getResult(operation, 0);
      Temporary arg = Operation_getArgument(operation, 0);
      // assume all allocated temporaries must take set color
      if(Temporary_hasRegister(res)) {
        int32_t idx;
        if(pCopiesLhs[Temporary_regFile(res)] == NULL) {
          pCopiesLhs[Temporary_regFile(res)] =
            BasicBlock_makeOperationPCOPY(basicBlock, operation, true,
                                          RegFile_highRegister(Temporary_regFile(res))
                                          - RegFile_lowRegister(Temporary_regFile(res)) + 1, 1);
        }
        idx = Operation_addtoParCopy(pCopiesLhs[Temporary_regFile(res)], res, arg);
        pCopiesRhs[Temporary_regFile(res)] = NULL;
        updateDefUses(pCopiesLhs[Temporary_regFile(res)], idx, operation);
        BasicBlock_detachOperation(basicBlock, operation);
      } else if(Temporary_hasRegister(arg)) {
        int32_t idx;
        if(pCopiesRhs[Temporary_regFile(arg)] == NULL) {
          pCopiesRhs[Temporary_regFile(arg)] =
            BasicBlock_makeOperationPCOPY(basicBlock, operation, true,
                                          RegFile_highRegister(Temporary_regFile(arg))
                                          - RegFile_lowRegister(Temporary_regFile(arg)) + 1, 1);
        }
        idx = Operation_addtoParCopy(pCopiesRhs[Temporary_regFile(arg)], res, arg);
        pCopiesLhs[Temporary_regFile(res)] = NULL;
        updateDefUses(pCopiesRhs[Temporary_regFile(res)], idx, operation);
        BasicBlock_detachOperation(basicBlock, operation);
      } else {
        // no interference check, so do it in a dummy way
        pCopiesRhs[Temporary_regFile(res)] = NULL;
        pCopiesLhs[Temporary_regFile(res)] = NULL;
      }
    } else {
      memset(pCopiesRhs, 0, RegFile__COUNT * sizeof(Operation));
      memset(pCopiesLhs, 0, RegFile__COUNT * sizeof(Operation));
    }
  } BasicBlock_ENDEACH_Operation;
}

#line 2364 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
struct PrepareReconstructParam_ {
  //@args SSAReconstruct *reconstructHelpers, IDList reconstructHelpersStorage, SSAForm ssaForm
  SSAReconstruct* RECONSTRUCTHELPERS;
  IDList RECONSTRUCTHELPERSSTORAGE;
  SSAForm SSAFORM;
};
typedef struct PrepareReconstructParam_ PrepareReconstructParam_, *PrepareReconstructParam;
typedef const struct PrepareReconstructParam_ *const_PrepareReconstructParam;
typedef struct PrepareReconstructParam_ * restrict_PrepareReconstructParam;

extern PrepareReconstructParam
PrepareReconstructParam_Ctor(PrepareReconstructParam this, SSAReconstruct *reconstructHelpers, IDList reconstructHelpersStorage, SSAForm ssaForm);

extern PrepareReconstructParam
PrepareReconstructParam_Copy(PrepareReconstructParam this, const_PrepareReconstructParam that);

extern void
PrepareReconstructParam_Dtor(PrepareReconstructParam this);

extern size_t
PrepareReconstructParam_Size(SSAReconstruct *reconstructHelpers, IDList reconstructHelpersStorage, SSAForm ssaForm);

#define PrepareReconstructParam_RECONSTRUCTHELPERS(this) ((this)->RECONSTRUCTHELPERS)
#define PrepareReconstructParam__RECONSTRUCTHELPERS(this) (&(this)->RECONSTRUCTHELPERS)
#define PrepareReconstructParam_RECONSTRUCTHELPERSSTORAGE(this) ((this)->RECONSTRUCTHELPERSSTORAGE)
#define PrepareReconstructParam__RECONSTRUCTHELPERSSTORAGE(this) (&(this)->RECONSTRUCTHELPERSSTORAGE)
#define PrepareReconstructParam_SSAFORM(this) ((this)->SSAFORM)
#define PrepareReconstructParam__SSAFORM(this) (&(this)->SSAFORM)


#line 2372 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
PrepareReconstructParam
PrepareReconstructParam_Ctor(PrepareReconstructParam this,
                             SSAReconstruct *reconstructHelpers,
                             IDList reconstructHelpersStorage,
                             SSAForm ssaForm) {
  *PrepareReconstructParam__RECONSTRUCTHELPERS(this) = reconstructHelpers;
  *PrepareReconstructParam__RECONSTRUCTHELPERSSTORAGE(this) =
    reconstructHelpersStorage;
  *PrepareReconstructParam__SSAFORM(this) = ssaForm;
  return this;
}

#line 2384 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
void
PrepareReconstructParam_Dtor(PrepareReconstructParam this) {
}

#line 2388 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
static void
prepareReconstruct(Temporary liveInTemp, Temporary splitVar, void* param) {
  PrepareReconstructParam reconstParam = (PrepareReconstructParam)param;
  SSAReconstruct* reconstructHelpers =
    PrepareReconstructParam_RECONSTRUCTHELPERS(reconstParam);
  IDList reconstructHelpersStorage =
    PrepareReconstructParam_RECONSTRUCTHELPERSSTORAGE(reconstParam);
  SSAForm ssaForm = PrepareReconstructParam_SSAFORM(reconstParam);
  if(reconstructHelpers[Temporary_index(liveInTemp)] == NULL) {
    SSAReconstruct ssaReconst =
      (SSAReconstruct)IDList_push(reconstructHelpersStorage, sizeof(SSAReconstruct_));
    SSAReconstruct_Ctor(ssaReconst, ssaForm, liveInTemp,
                        IDList_memory(reconstructHelpersStorage));
    SSAReconstruct_addCopy(ssaReconst, DefUses_getDef(Temporary_defUses(liveInTemp)));
    reconstructHelpers[Temporary_index(liveInTemp)] = ssaReconst;
  } else {
    Except_CHECK(SSAReconstruct_VALUE(reconstructHelpers[Temporary_index(liveInTemp)]) == liveInTemp);
  }
  SSAReconstruct_addCopy(reconstructHelpers[Temporary_index(liveInTemp)], DefUses_getDef(Temporary_defUses(splitVar)));
}

#line 2409 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
/*
 * Will contain the def uses chains of all dedicated temporaries to do
 * SSA reconstruction.
 *  __ is the SSA reconstruction support
 * USESLISTS[reg] is the uses of reg color.
 * USESLISTSSTORAGE is here to supply a memory location for elements in USESLISTS.
 * VIRTUALDEF is the initial definition of all dedicated.
 */
struct PrepareReconstructNOperationListParam_ {
  //@args SSAReconstruct *reconstructHelpers, IDList reconstructHelpersStorage,
  //@args SSAForm ssaForm, OperationArgumentList *usesLists, IDList usesListsStorage,
  //@args Operation virtualDef
  PrepareReconstructParam_ __;
  OperationArgumentList* USESLISTS;
  IDList USESLISTSSTORAGE;
  OperationResult_ *VIRTUALDEF;
  //@access MEMORY IDList_memory(PrepareReconstructNOperationListParam_USESLISTSSTORAGE(this))
};
typedef struct PrepareReconstructNOperationListParam_ PrepareReconstructNOperationListParam_, *PrepareReconstructNOperationListParam;
typedef const struct PrepareReconstructNOperationListParam_ *const_PrepareReconstructNOperationListParam;
typedef struct PrepareReconstructNOperationListParam_ * restrict_PrepareReconstructNOperationListParam;

extern PrepareReconstructNOperationListParam
PrepareReconstructNOperationListParam_Ctor(PrepareReconstructNOperationListParam this, SSAReconstruct *reconstructHelpers, IDList reconstructHelpersStorage, SSAForm ssaForm, OperationArgumentList *usesLists, IDList usesListsStorage, Operation virtualDef);

extern PrepareReconstructNOperationListParam
PrepareReconstructNOperationListParam_Copy(PrepareReconstructNOperationListParam this, const_PrepareReconstructNOperationListParam that);

extern void
PrepareReconstructNOperationListParam_Dtor(PrepareReconstructNOperationListParam this);

extern size_t
PrepareReconstructNOperationListParam_Size(SSAReconstruct *reconstructHelpers, IDList reconstructHelpersStorage, SSAForm ssaForm, OperationArgumentList *usesLists, IDList usesListsStorage, Operation virtualDef);

#define PrepareReconstructNOperationListParam___(this) ((this)->__)
#define PrepareReconstructNOperationListParam____(this) (&(this)->__)
#define PrepareReconstructNOperationListParam_USESLISTS(this) ((this)->USESLISTS)
#define PrepareReconstructNOperationListParam__USESLISTS(this) (&(this)->USESLISTS)
#define PrepareReconstructNOperationListParam_USESLISTSSTORAGE(this) ((this)->USESLISTSSTORAGE)
#define PrepareReconstructNOperationListParam__USESLISTSSTORAGE(this) (&(this)->USESLISTSSTORAGE)
#define PrepareReconstructNOperationListParam_VIRTUALDEF(this) ((this)->VIRTUALDEF)
#define PrepareReconstructNOperationListParam__VIRTUALDEF(this) (&(this)->VIRTUALDEF)
#define PrepareReconstructNOperationListParam_MEMORY(this) (IDList_memory(PrepareReconstructNOperationListParam_USESLISTSSTORAGE(this)))


#line 2428 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
PrepareReconstructNOperationListParam
PrepareReconstructNOperationListParam_Ctor(PrepareReconstructNOperationListParam this,
                                           SSAReconstruct *reconstructHelpers,
                                           IDList reconstructHelpersStorage,
                                           SSAForm ssaForm,
                                           OperationArgumentList *usesLists,
                                           IDList usesListsStorage,
                                           Operation virtualDef) {
  BasicBlock entry = CodeRegion_firstBlock(SSAForm_codeRegion(ssaForm));
  Memory memory = IDList_memory(usesListsStorage);
  Except_CHECK(BasicBlock_isEntry(entry));
  PrepareReconstructParam_Ctor(PrepareReconstructNOperationListParam____(this),
                               reconstructHelpers, reconstructHelpersStorage,
                               ssaForm);
  *PrepareReconstructNOperationListParam__USESLISTS(this) = usesLists;
  *PrepareReconstructNOperationListParam__USESLISTSSTORAGE(this) = usesListsStorage;
  *PrepareReconstructNOperationListParam__VIRTUALDEF(this) =
    Memory_alloc(memory, sizeof(OperationResult_) * Register__COUNT);
  memset(PrepareReconstructNOperationListParam_VIRTUALDEF(this), 0,
         sizeof(OperationResult_) * Register__COUNT);
  Except_CHECK(Operator_isParCopy(Operation_operator(virtualDef)));

#line 2450 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
  Operation_RESULTS_FOREACH_Temporary(virtualDef, temporary) {
    Temporary arg = Operation_getArgument(virtualDef, Operation_RESULTS_INDEX);
    Except_CHECK(Temporary_isDedicated(temporary)
                 && temporary == arg);
    OperationResult_Ctor(&PrepareReconstructNOperationListParam_VIRTUALDEF(this)
                         [Temporary_register(temporary)], virtualDef,
                         Operation_RESULTS_INDEX);
  } Operation_RESULTS_ENDEACH_Temporary;

#line 2459 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
  return this;
}

#line 2462 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
void
PrepareReconstructNOperationListParam_Dtor(PrepareReconstructNOperationListParam this) {
  PrepareReconstructParam_Dtor(PrepareReconstructNOperationListParam____(this));
  
  Memory_free(PrepareReconstructNOperationListParam_MEMORY(this),
              PrepareReconstructNOperationListParam_VIRTUALDEF(this));
}

#line 2470 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
static void
prepareReconstructWithDedicated(Temporary liveInTemp, Temporary splitVar,
                                PrepareReconstructNOperationListParam param) {
  PrepareReconstructParam reconstParam =
    PrepareReconstructNOperationListParam____(param);
  SSAReconstruct* reconstructHelpers =
    PrepareReconstructParam_RECONSTRUCTHELPERS(reconstParam);
  IDList reconstructHelpersStorage =
    PrepareReconstructParam_RECONSTRUCTHELPERSSTORAGE(reconstParam);
  SSAForm ssaForm = PrepareReconstructParam_SSAFORM(reconstParam);
  Except_CHECK(Temporary_isDedicated(liveInTemp));
  if(reconstructHelpers[Temporary_register(liveInTemp)] == NULL) {
    SSAReconstruct ssaReconst =
      (SSAReconstruct)IDList_push(reconstructHelpersStorage, sizeof(SSAReconstruct_));
    SSAReconstruct_Ctor(ssaReconst, ssaForm, liveInTemp,
                        IDList_memory(reconstructHelpersStorage));
    if(OperationResult_OPERATION(&PrepareReconstructNOperationListParam_VIRTUALDEF(param)
                                 [Temporary_register(liveInTemp)]) != NULL) {
      SSAReconstruct_addCopy(ssaReconst,
                             &PrepareReconstructNOperationListParam_VIRTUALDEF(param)
                             [Temporary_register(liveInTemp)]);
    }
    reconstructHelpers[Temporary_register(liveInTemp)] = ssaReconst;
  }
  SSAReconstruct_addCopy(reconstructHelpers[Temporary_register(liveInTemp)], DefUses_getDef(Temporary_defUses(splitVar)));
}

#line 2497 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
void
PrepareReconstructNOperationListParam_addUse(PrepareReconstructNOperationListParam param,
                                             Operation operation,
                                             int32_t idx, Temporary temporary) {
  OperationArgumentList* usesLists =
    PrepareReconstructNOperationListParam_USESLISTS(param);
  IDList usesListsStorage =
    PrepareReconstructNOperationListParam_USESLISTSSTORAGE(param);
  Register reg;
  OperationArgument_ opArg[1];
  Except_CHECK(Temporary_isDedicated(temporary));
  reg = Temporary_register(temporary);
  OperationArgument_Ctor(opArg, operation, idx);
  if(usesLists[reg] == NULL) {
    OperationArgumentList uses =
      (OperationArgumentList)IDList_push(usesListsStorage, sizeof(OperationArgumentList_));
    OperationArgumentList_Ctor(uses, IDList_memory(usesListsStorage));
    usesLists[reg] = uses;
  }
  OperationArgumentList_PUSH(usesLists[reg], *opArg);
}

#line 2519 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
static bool
shouldSplitTemporary(Temporary temp) {
  return Temporary_regFile(temp) != RegFile__UNDEF
#ifdef MDS_FAMILY_st200
    // when we split that register file, we need an additional color from GR
    // thus, we are not sure to have it. Fix is: not to split for now.
    && Temporary_regFile(temp) != RegFile_st200_BR
#endif
    // this test is not theorically necessary. Actually, we must set it,
    // because definition of dedicated maybe incomplete and it produces bug.
    // E.g.:
    // stw ... R16
    // R63, [R16] call toto // <- fixup open64 did not see the definition of
    //                            R16, because of complex graph
    // Vx = R16
    // ->
    // Vy split R16
    // stw ... R16
    // R63, [R16] call toto
    // Vx = Vy // <- repair ssa see Vy as the nearest definition of R16.
    //               This is wrong because Vy is not the right R16 and more over,
    //               now, Vy cross the call unlike R16, thus pressure
    //               computation and spill is wrong (anyway it is already wrong)
    && !Temporary_isDedicated(temp) && !Temporary_isAssigned(temp)
    && !Temporary_hasRegister(temp);
}

#line 2546 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
static void
insertPCopyFromTemporarySet(BasicBlock basicBlock, Operation point,
                            bool before, TemporarySet tempSet,
                            bool isSSA, void*actionParam,
                            void (*action)(Temporary, Temporary, void*)) {
  // Create parallel copies.
  // One per regFile
  Operation pCopies[RegFile__COUNT];
  CodeRegion codeRegion = BasicBlock_codeRegion(basicBlock);
  memset(pCopies, 0, RegFile__COUNT * sizeof(Operation));
  TemporarySet_FOREACH_Temporary(tempSet, liveInTemp) {
    if(Temporary_isVariable(liveInTemp)
       // Problem with finding an operation definition. A pseudo def should
       // correct the problem
       && DefUses_getDef(Temporary_defUses(liveInTemp)) != NULL
       && shouldSplitTemporary(liveInTemp)) {
      Temporary splitVar =
        CodeRegion_makeVariableTemporary(codeRegion,
                                         Variable_ORIGIN(Temporary_VARIABLE(liveInTemp)));
      if(pCopies[Temporary_regFile(liveInTemp)] == NULL) {
        pCopies[Temporary_regFile(liveInTemp)] =
          BasicBlock_makeOperationPCOPY(basicBlock, point, before,
                                        TemporarySet_count(tempSet), 1);
      }
      {
        int32_t resIdx =
          Operation_addtoParCopy(pCopies[Temporary_regFile(liveInTemp)],
                                    splitVar, liveInTemp);
        DefUses_setDef(Temporary_defUses(splitVar),
                       pCopies[Temporary_regFile(liveInTemp)], resIdx);
        DefUses_addUse(Temporary_defUses(liveInTemp),
                       pCopies[Temporary_regFile(liveInTemp)], resIdx);
        if(action != NULL) {
          action(liveInTemp, splitVar, actionParam);
        }
      }
    }
  } TemporarySet_ENDEACH_Temporary;
}

#line 2586 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
static bool
Operation_hasDedicatedOrAssignedArgument(Operation operation) {
  Operation_ARGUMENTS_FOREACH_Temporary(operation, temp) {
    if(Temporary_hasRegister(temp)) {
      return true;
    }
  } Operation_ARGUMENTS_ENDEACH_Temporary;
  return false;
}

#line 2596 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
static bool
hasOperandConstraint(Temporary *operands, int32_t countTemp,
                     const OperatorParameter_* parameters, int32_t count) {
  int idx;
  for(idx = 0; idx < countTemp; ++idx) {
    if(idx < count
       && idx + 1 == OperatorParameter_rank(parameters)
       && OperatorParameter_type(parameters) == OperandType_RegClass) {
      RegClass regClass = OperatorParameter_enum(parameters);
      const_RegisterSet regSet = RegClass_registerSet(regClass);
      RegisterSet_ interferenceReg[1];
      RegisterSet_Ctor(interferenceReg);
      RegisterSet_Copy(interferenceReg,
                       RegFile_registerSet(Temporary_regFile(operands[idx])));
      RegisterSet_diff(interferenceReg, regSet);
      if(!RegisterSet_isEmpty(interferenceReg)) {
        return true;
      }
    }
    ++parameters;
  }
  return false;
}

#line 2620 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
static bool
hasWriteConstraint(Operation op, const OperatorParameter_* writeParameters,
                   int32_t count) {
  return hasOperandConstraint(Operation_results(op), Operation_resCount(op),
                              writeParameters, count);
}

#line 2627 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
static bool
hasReadConstraint(Operation op, const OperatorParameter_* readParameters,
                  int32_t count) {
  return hasOperandConstraint(Operation_arguments(op), Operation_argCount(op),
                              readParameters, count);
}

#line 2634 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
static void
insertAllSplitPoint(SSAForm ssaForm) {
#ifndef InsertSplit_POOLED
#   define InsertSplit_POOLED 128
#endif//InsertSplit_POOLED
  CodeRegion codeRegion = SSAForm_codeRegion(ssaForm);
  Procedure procedure = CodeRegion_procedure(codeRegion);
  Memory memory = Memory_new(Procedure_memory(procedure), InsertSplit_POOLED);
  Liveness liveness;
  uint32_t size = IndexedFactory_COUNTER(Temporary_Factory)
    * sizeof(SSAReconstruct);
  SSAReconstruct *reconstructHelpers = Memory_alloc(memory, size);
  IDList_ reconstructHelpersStorage[1];
  TemporaryTable_ temporaries[1];
  PrepareReconstructParam_ param[1];
  bool testNewSplit = getenv("TEST_NEW_SPLIT") != NULL;
  uint32_t done = 0;
  uint32_t count = getenv("COUNT_SPLIT") != NULL? atoi(getenv("COUNT_SPLIT"))
    :UINT_MAX;

#line 2654 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
  TemporaryTable_Ctor(temporaries, memory,
                      IndexedFactory_COUNTER(Temporary_Factory));

#line 2657 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
  IDList_Ctor(reconstructHelpersStorage, memory);
  bzero(reconstructHelpers, size);
  PrepareReconstructParam_Ctor(param, reconstructHelpers,
                               reconstructHelpersStorage, ssaForm);

#line 2662 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
  collectVirtualTemporaries(codeRegion, temporaries);
  liveness = Liveness_make(memory, codeRegion, temporaries, true);
  CodeRegion_FOREACH_BasicBlock(codeRegion, basicBlock) {
    TemporarySet liveInSet = BasicBlock_liveInSet(basicBlock);
    TemporarySet_ curSet[1];
    Operation startPoint = NULL;
    bool before = true;
    bool hasSplit = false;
    if(!testNewSplit && !BasicBlock_isExit(basicBlock)) {
      continue;
    }
    if(!BasicBlock_isExit(basicBlock) && done > count) {
      continue;
    }

#line 2677 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
    TemporarySet_Ctor(curSet, memory, TemporarySet_count(liveInSet));

#line 2679 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
    TemporarySet_union(curSet, BasicBlock_liveOutSet(basicBlock));
    TemporarySet_union(curSet, BasicBlock_phiOutSet(basicBlock));
    before = false;
    BasicBlock_FORBACK_Operation(basicBlock, operation) {
      Operator operator = Operation_operator(operation);
      if((!BasicBlock_isEntry(basicBlock) || !Operator_isSeqCopy(operator)
          || !Operation_hasDedicatedOrAssignedArgument(operation))
         && !Operator_isPhi(operator)) {
        bool hasWriteCstrt = false;
        const_OperatorParameterArray parameterArray =
          Operator_parameterArray(operator);
        const OperatorParameter_* writeParameters =
          OperatorParameterArray_writeParameters(parameterArray);
        const OperatorParameter_* readParameters =
          OperatorParameterArray_readParameters(parameterArray);

#line 2695 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
        startPoint = operation;
        before = true;
        if(!hasSplit && !TemporarySet_isEmpty(curSet)
           && (hasWriteConstraint(operation, writeParameters,
                                  OperatorParameterArray_writeCount(parameterArray)))) {
          hasWriteCstrt = true;
          insertPCopyFromTemporarySet(basicBlock, startPoint, false,
                                      curSet, true, param, prepareReconstruct);
          if(!BasicBlock_isExit(basicBlock)) {
            ++done;
          }
        }
        hasSplit = false;
        Operation_RESULTS_FOREACH_Temporary(operation, temp) {
          TemporarySet_remove(curSet, temp);
        } Operation_RESULTS_ENDEACH_Temporary;
        Operation_ARGUMENTS_FOREACH_Temporary(operation, temp) {
          if(Temporary_isVariable(temp)) {
            TemporarySet_insert(curSet, temp);
          }
        } Operation_ARGUMENTS_ENDEACH_Temporary;
        if(!TemporarySet_isEmpty(curSet)
           // if we have write contraints, relax coloring on crossing variables
           && (hasWriteCstrt
               || (Operation_hasClobber(operation)
                   || hasReadConstraint(operation, readParameters,
                                        OperatorParameterArray_readCount(parameterArray))))) {
          insertPCopyFromTemporarySet(basicBlock, startPoint, true,
                                      curSet, true, param, prepareReconstruct);
          if(!BasicBlock_isExit(basicBlock)) {
            ++done;
          }
          hasSplit = true;
        }
      } else {
        break;
      }
    } BasicBlock_ENDBACK_Operation;
    if(!TemporarySet_isEmpty(curSet)) {
      insertPCopyFromTemporarySet(basicBlock, startPoint, before,
                                  curSet, true, param, prepareReconstruct);
      if(!BasicBlock_isExit(basicBlock)) {
        ++done;
      }
    }
    TemporarySet_Dtor(curSet);
  } CodeRegion_ENDEACH_BasicBlock;
  IDList_FOREACH(reconstructHelpersStorage, SSAReconstruct_, ssaReconst) {
    SSAReconstruct_fixUsers(ssaReconst, SSAReconstruct_VALUE(ssaReconst));
    SSAReconstruct_Dtor(ssaReconst);
  } IDList_ENDEACH;
  Memory_free(memory, reconstructHelpers);
  IDList_Dtor(reconstructHelpersStorage);
  Liveness_kill(liveness);
  TemporaryTable_Dtor(temporaries);
  Memory_delete(memory);
}

#line 2754 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
static bool
temporaryIsDedicated(Temporary temp, Operation operation, int32_t opndIdx,
                     void *param) {
  bool result = Temporary_hasRegFile(temp) && Temporary_isDedicated(temp)
    // temp is a dedicated result
    && opndIdx < Operation_resCount(operation);
  Except_CHECK(Operator_isParCopy(Operation_operator(operation)));

#line 2762 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
  // and related arg may cross (i.e. duplication)
  if(result) {
    result =
      !GRA_colorUsedIn(Operation_results(operation),
                       Operation_getArgument(operation, opndIdx),
                       Operation_resCount(operation));
  }
  return result;
}

#line 2772 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
static void
removeSplitPoint(CodeRegion codeRegion, Memory memory) {
  int32_t regToIdx[RegFile__COUNT][Register__COUNT];
  int32_t idxToReg[RegFile__COUNT][Register__COUNT];
  RegisterSet_ allocatableSet[1];
  int32_t size[RegFile__COUNT], i;
  // we need liveness to expand correctly parallel copy
  Liveness liveness =
    Liveness_make(memory, codeRegion,
                  CodeRegion_makeGlobalTable(codeRegion,
                                             TemporaryFlag_Constant, 0), true);
  RegisterSet_ curSet[1];
  RegisterSet_Ctor(curSet);

#line 2787 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
  for(i = 0; i < RegFile__COUNT; ++i) {
    *allocatableSet =
      Convention_allocatableSet(CodeRegion_convention(codeRegion), i);
    memset(regToIdx[i], -1, sizeof(int32_t) * Register__COUNT);
    memset(idxToReg[i], -1, sizeof(int32_t) * Register__COUNT);
    RpcEvolved_initRegMap(regToIdx[i], idxToReg[i], allocatableSet, i);
    size[i] = RegisterSet_count(allocatableSet);
    RegisterSet_Dtor(allocatableSet);
    GRA_removeCheckedColorFromParCopies(codeRegion, memory, i, NULL,
                                        temporaryIsDedicated);
  }

#line 2799 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
  CodeRegion_FOREACH_BasicBlock(codeRegion, basicBlock) {
    RegisterSet_empty(curSet);
    TemporarySet_FOREACH_Temporary(BasicBlock_phiOutSet(basicBlock), temp) {
      if(Temporary_hasRegister(temp)) {
        RegisterSet_insert(curSet, Temporary_register(temp));
      }
    } TemporarySet_ENDEACH_Temporary;
    TemporarySet_FOREACH_Temporary(BasicBlock_liveOutSet(basicBlock), temp) {
      if(Temporary_hasRegister(temp)) {
        RegisterSet_insert(curSet, Temporary_register(temp));
      }
    } TemporarySet_ENDEACH_Temporary;
    BasicBlock_FORBACK_Operation(basicBlock, operation) {
      Operation_RESULTS_FOREACH_Temporary(operation, res) {
        if(Temporary_hasRegister(res)) {
          RegisterSet_remove(curSet, Temporary_register(res));
        }
      } Operation_RESULTS_ENDEACH_Temporary;
      
      if(Operator_isParCopy(Operation_operator(operation))) {
        if(Operation_resCount(operation) > 0) {
          RpcEvolved_ rpc[1];
          int32_t idx = 0;
          int32_t regFile =
            Temporary_regFile(Operation_getResult(operation, 0));
          RpcEvolved_Ctor(rpc, size[regFile]);
          
          Operation_RESULTS_FOREACH_Temporary(operation, res) {
            Temporary arg = Operation_getArgument(operation, idx);
            int32_t regArg, regRes;
            
            Except_CHECK(Temporary_hasRegFile(arg) && Temporary_hasRegFile(res)
                         && "This rpc interface works only with allocated code");
            regArg = regToIdx[regFile][Temporary_register(arg)];
            regRes = regToIdx[regFile][Temporary_register(res)];
            Except_CHECK(regArg != -1
                         && "A non allocatable variable has been splitted");
            Except_CHECK(regRes != -1
                         && "Split variable assigned to an invalid color");
              
            // Check if there is a duplication, because it is not handle
            // currently
            Except_CHECK(RpcEvolved_TO(rpc)[regArg] == -1);
            Except_CHECK(RpcEvolved_INV(rpc)[regRes] == -1);
            // Arg to Res
            RpcEvolved_TO(rpc)[regArg] = regRes;
            RpcEvolved_INV(rpc)[regRes] = regArg;
            RpcEvolved_BEFORE(rpc)[regArg] = arg;
            RpcEvolved_AFTER(rpc)[regRes] = res;
            ++idx;
          } Operation_RESULTS_ENDEACH_Temporary;
          RegisterSet_FOREACH_Register(curSet, curReg) {
            int32_t regArg;
            if(Register_regFile(curReg) == regFile
               && (regArg = regToIdx[regFile][curReg]) != -1) {
              Except_CHECK(RpcEvolved_TO(rpc)[regArg] == -1);
              Except_CHECK(RpcEvolved_INV(rpc)[regArg] == -1);
              // curReg cross rpc
              RpcEvolved_TO(rpc)[regArg] = regArg;
              RpcEvolved_INV(rpc)[regArg] = regArg;
            }
          } RegisterSet_ENDEACH_Register;
          RpcEvolved_generateRpc(operation, rpc, idxToReg[regFile], true);
          RpcEvolved_Dtor(rpc);
        }
      }

#line 2866 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
      Operation_ARGUMENTS_FOREACH_Temporary(operation, arg) {
        if(Temporary_hasRegister(arg)) {
          RegisterSet_insert(curSet, Temporary_register(arg));
        }
      } Operation_ARGUMENTS_ENDEACH_Temporary;

#line 2872 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
      if(Operator_isParCopy(Operation_operator(operation))) {
        BasicBlock_FORBACK_Operation_SYNC;
        BasicBlock_detachOperation(basicBlock, operation);
      }
    } BasicBlock_ENDBACK_Operation;
  } CodeRegion_ENDEACH_BasicBlock;
  RegisterSet_Dtor(curSet);
  Liveness_kill(liveness);
}

#line 2882 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
static void
InterfGraph_display(CodeRegion codeRegion, const char* message, FILE* file,
                    bool clobbersDoNotInterfer, bool newHandlingOfNegAff,
                    bool addMoveInterference, bool noMoveAffinity, bool isSSA)
{
#ifndef Disp_POOLED
#   define Disp_POOLED 128
#endif//Disp_POOLED
  int regFile;
  Procedure procedure = CodeRegion_procedure(codeRegion);
  Memory memory = Memory_new(Procedure_memory(procedure), Disp_POOLED);
  for (regFile = 0; regFile < RegFile__COUNT; ++regFile) {
    InterfGraphBuilder_ interfGraphBuilder[1];
    InterfGraphBuilder_Ctor(interfGraphBuilder, memory,
                            codeRegion, regFile, clobbersDoNotInterfer,
                            newHandlingOfNegAff, addMoveInterference,
                            noMoveAffinity, isSSA);
    fprintf(file, "------- %s: %s (%s) -------\n", Procedure_name(procedure),
            message, RegFile_name(regFile));
    InterfGraphBuilder_exportGraph(interfGraphBuilder, file, false, false,
                                   getenv("DISP_WITH_CLIQUE") != NULL);
    fprintf(file, "--------------\n");
    fprintf(file, "*** %s: %s (%s) ***\n", Procedure_name(procedure),
            message, RegFile_name(regFile));
    InterfGraphBuilder_displayMapping(interfGraphBuilder, file);
    fprintf(file, "******\n");
    InterfGraphBuilder_Dtor(interfGraphBuilder);
  }
  Memory_delete(memory);
}

#line 2913 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
static void
removeAssigned(CodeRegion codeRegion) {
  Procedure procedure = CodeRegion_procedure(codeRegion);
  CodeRegion_FOREACH_BasicBlock(codeRegion, basicBlock) {
    BasicBlock_FOREACH_Operation(basicBlock, operation) {
      int idx = 0;
      Operation_ARGUMENTS_FOREACH_Temporary(operation, argument) {
        if(Temporary_hasRegister(argument)
           && !Temporary_isDedicated(argument)) {
          Operation_setArgument(operation, idx,
                                Procedure_makeDedicatedTemporary(procedure,
                                                                 Temporary_register(argument)));
        }
        ++idx;
      } Operation_ARGUMENTS_ENDEACH_Temporary;
      idx = 0;
      Operation_RESULTS_FOREACH_Temporary(operation, result) {
        if(Temporary_hasRegister(result)
           && !Temporary_isDedicated(result)) {
          Operation_setResult(operation, idx,
                              Procedure_makeDedicatedTemporary(procedure,
                                                               Temporary_register(result)));
        }
        ++idx;
      } Operation_RESULTS_ENDEACH_Temporary;
    } BasicBlock_ENDEACH_Operation;
  } CodeRegion_ENDEACH_BasicBlock;
}

#line 2942 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
static void
dedicatedToAssigned(SSAForm ssaForm, Operation virtualDef) {
#ifndef DedicatedToAssigned_POOLED
#   define DedicatedToAssigned_POOLED 128
#endif//DedicatedToAssigned_POOLED
  CodeRegion codeRegion = SSAForm_codeRegion(ssaForm);
  Procedure procedure = CodeRegion_procedure(codeRegion);
  Memory memory = Memory_new(Procedure_memory(procedure), DedicatedToAssigned_POOLED);
  uint32_t reconstSize = sizeof(SSAReconstruct) * Register__COUNT;
  SSAReconstruct *reconstructHelpers = Memory_alloc(memory, reconstSize);
  uint32_t usesSize = sizeof(OperationArgumentList) * Register__COUNT;
  OperationArgumentList *usesLists = Memory_alloc(memory, usesSize);
  IDList_ reconstructHelpersStorage[1];
  IDList_ usesListsStorage[1];
  PrepareReconstructNOperationListParam_ param[1];
  uint32_t i;
  RegisterSet_ allocatableSet[RegFile__COUNT][1];
  Convention convention = CodeRegion_convention(codeRegion);
  for(i = 0; i < RegFile__COUNT; ++i) {
    allocatableSet[i][0] = Convention_allocatableSet(convention, i);
  }
  

#line 2965 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
  IDList_Ctor(reconstructHelpersStorage, memory);
  IDList_Ctor(usesListsStorage, memory);
  bzero(reconstructHelpers, reconstSize);
  bzero(usesLists, usesSize);
  PrepareReconstructNOperationListParam_Ctor(param, reconstructHelpers,
                                             reconstructHelpersStorage, ssaForm,
                                             usesLists, usesListsStorage, virtualDef);

#line 2973 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
  CodeRegion_FOREACH_BasicBlock(codeRegion, basicBlock) {
    BasicBlock_FOREACH_Operation(basicBlock, operation) {
      if(operation != virtualDef) {
        Operation_ARGUMENTS_FOREACH_Temporary(operation, temporary) {
          if(Temporary_isDedicated(temporary)
             && RegisterSet_contains(allocatableSet[Temporary_regFile(temporary)],
                                     Temporary_register(temporary))) {
            PrepareReconstructNOperationListParam_addUse(param, operation,
                                                         Operation_ARGUMENTS_INDEX,
                                                         temporary);
          }
        } Operation_ARGUMENTS_ENDEACH_Temporary;
      }
      Operation_RESULTS_FOREACH_Temporary(operation, temporary) {
        if(Temporary_isDedicated(temporary)
           && RegisterSet_contains(allocatableSet[Temporary_regFile(temporary)],
                                   Temporary_register(temporary))) {
          Temporary splitTemp = CodeRegion_makeVariableTemporary(codeRegion, temporary);
          Variable splitVar = Temporary_VARIABLE(splitTemp);
          Temporary_assignRegister(splitTemp, Temporary_register(temporary));
          Variable_setOperationResult(splitVar, operation,
                                      Operation_RESULTS_INDEX);
          prepareReconstructWithDedicated(temporary, splitTemp, param);
        }
      } Operation_RESULTS_ENDEACH_Temporary;
      if(Operator_isSeqCopy(Operation_operator(operation))
         || Operator_isParCopy(Operation_operator(operation))) {
        Operation_RESULTS_FOREACH_Temporary(operation, temporary) {
          Temporary arg =
            Operation_getArgument(operation, Operation_RESULTS_INDEX);
          if(!Temporary_isDedicated(temporary)
             && !Temporary_hasRegister(temporary)
             && Temporary_isDedicated(arg)
             && RegisterSet_contains(allocatableSet[Temporary_regFile(arg)],
                                     Temporary_register(arg))) {
            prepareReconstructWithDedicated(arg, temporary, param);
          }
        } Operation_RESULTS_ENDEACH_Temporary;
      }
    } BasicBlock_ENDEACH_Operation;
  } CodeRegion_ENDEACH_BasicBlock;

#line 3015 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
  for(i = 0; i < Register__COUNT; ++i) {
    if(reconstructHelpers[i] != NULL) {
      if(usesLists[i] != NULL) {
        SSAReconstruct_fixUsersList(reconstructHelpers[i], usesLists[i]);
        OperationArgumentList_Dtor(usesLists[i]);
      }
      SSAReconstruct_Dtor(reconstructHelpers[i]);
    } else if(usesLists[i] != NULL) {
      OperationArgumentList_Dtor(usesLists[i]);
    }
  }

#line 3027 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
  PrepareReconstructNOperationListParam_Dtor(param);
  IDList_Dtor(reconstructHelpersStorage);
  IDList_Dtor(usesListsStorage);
  for(i = 0; i < RegFile__COUNT; ++i) {
    RegisterSet_Dtor(allocatableSet[i]);
  }
  Memory_free(memory, reconstructHelpers);
  Memory_free(memory, usesLists);
  Memory_delete(memory);

#line 3037 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
}

#line 3045 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
unsigned
Interface_optimize(Interface this, OptimizeItem item, ...)
{
  va_list va;
  unsigned optimized = 0;
  OptimizeFlags activation = 0;
  OptimizeFlags conversion = 0;
  OptimizeFlags coalescing = 0;
  OptimizeFlags allocation = 0;
  OptimizeFlags scheduling = 0;
  Procedure procedure = Interface_PROCEDURE(this);
  Memory memory = Procedure_memory(procedure);
  Optimize optimize = Program_optimize(program);
  va_start(va, item);
  Optimize_loadVA(Program_optimize(program), item, va);
  va_end(va);
  if (Interface_DEDICATED > 0) {
    *Optimize__CONVERSION(optimize) |= OptimizeConversion_Dedicated;
  }
  activation = Optimize_ACTIVATION(optimize);
  conversion = Optimize_CONVERSION(optimize);
  coalescing = Optimize_COALESCING(optimize);
  allocation = Optimize_ALLOCATION(optimize);
  scheduling = Optimize_SCHEDULING(optimize);
#ifndef ECL_NTRACE
  O64_INPUT && fprintf(O64_INPUT, "  Interface_optimize(interface, ");
  O64_INPUT && Optimize_print(Program_optimize(program), O64_INPUT);
  O64_INPUT && fprintf(O64_INPUT, ");\n");
#endif//ECL_NTRACE
  Procedure_buildCodeRegions(procedure);
  Procedure_fixupOpen64(procedure, activation);
  if (   (conversion & OptimizeConversion_Dedicated) != 0
      && (activation & (OptimizeActivation_PrePass|OptimizeActivation_RegAlloc)) != 0) {
    Procedure_fixupDedicated(procedure, activation);
  }
  if ((activation & OptimizeActivation_PrePass) != 0) {
    O64_XMLIN && Program_dumpXML(program);
  }
  Procedure_FOREACH_CodeRegion(procedure, codeRegion) {
    LoopForest_delete(LoopForest_new(memory, codeRegion));
    // PrePass OptimizationFlags.
    if ((activation & OptimizeActivation_PrePass) != 0) {
#if !PRO_OPTIMIZE
      Interface_FOREACH_Temporary(this, cgir_tn, temporary) {
        Except_CHECK(!Temporary_isAssigned(temporary));
      } Interface_ENDEACH_Temporary;
#endif//PRO_OPTIMIZE
      // SSA analyses.
      if ((conversion & ~OptimizeConversion_Dedicated) != 0) {
        uint32_t temporaryCounter = IndexedFactory_COUNTER(Temporary_Factory);
        uint32_t operationCounter = IndexedFactory_COUNTER(Operation_Factory);
        SSAForm ssaForm = SSAForm_construct(memory, codeRegion, false);
        PFA_TRACE && fprintf(PFA_TRACE, "*** SSA Conversion=")
                  && OptimizeConversion_prettyFlags(conversion, PFA_TRACE)
                  && fprintf(PFA_TRACE, "\n");
        PFA_TRACE && fprintf(PFA_TRACE, "*** SSA Coalescing=")
                  && OptimizeCoalescing_prettyFlags(coalescing, PFA_TRACE)
                  && fprintf(PFA_TRACE, "\n");
        SSAForm_destruct(ssaForm);
        *IndexedFactory__COUNTER(Operation_Factory) = operationCounter;
        *IndexedFactory__COUNTER(Temporary_Factory) = temporaryCounter;
      }
      // PrePass schedule.
      if (scheduling != 0) {
        int scheduled = 0, bodyCount = 0;
        TemporaryTable globalTable = CodeRegion_makeGlobalTable(codeRegion,
                                                                TemporaryFlag_Constant,
                                                                0);
        Liveness liveness = Liveness_make(memory, codeRegion, globalTable, false);
        RegionFlow regionFlow = RegionFlow_new(memory, codeRegion);
        OptimizeRegionType type = (OptimizeRegionType)Optimize_REGIONTYPE(optimize);
        BlockTraceFlags flags = BlockTraceFlag_PrePass;
        RegionFlowCover regionCover = RegionFlowCover_new(memory, regionFlow,
                                                          type, flags);
        SCD_TRACE && fprintf(SCD_TRACE, "*** BEFORE PRESCHEDULER\n")
                  && CodeRegion_pretty(codeRegion, SCD_TRACE);
        RegionFlowCover_FOREACH_BlockTrace(regionCover, blockTrace) {
          SCD_TRACE && fprintf(SCD_TRACE, "*** SCHEDULING ");
          SCD_TRACE && BlockTrace_pretty(blockTrace, SCD_TRACE);
          if (BlockTrace_isEmpty(blockTrace)) {
            SCD_TRACE && fprintf(SCD_TRACE, "    EMPTY\n");
          } else {
            Scheduler scheduler = Scheduler_new(memory, blockTrace);
            optimized |= Scheduler_schedule(scheduler, regionFlow);
            scheduled += Scheduler_scheduled(scheduler);
            bodyCount += Scheduler_bodyCount(scheduler);
            Scheduler_delete(scheduler);
          }
        } RegionFlowCover_ENDEACH_BlockTrace;
        RegionFlowCover_delete(regionCover);
        RegionFlow_reorderBasicBlocks(regionFlow);
        RegionFlow_finalize(regionFlow);
        RegionFlow_delete(regionFlow);
        Liveness_kill(liveness);
        // There may be some blocks created during scheduling which now also need to be scheduled.
	liveness = Liveness_make(memory, codeRegion, globalTable, false);
	regionFlow = RegionFlow_new(memory, codeRegion);
        CodeRegion_FOREACH_BasicBlock(codeRegion, basicBlock) {
          if (!BasicBlock_isEmpty(basicBlock) && !BasicBlock_isScheduled(basicBlock)) {
            // Create a blockTrace containing just this block, and schedule it.
	    CFGNode cfgNode = BasicBlock_cfgNode(basicBlock);
            BlockTrace blockTrace;
            Scheduler scheduler;
            LoopScope loopScope = BasicBlock_loopScope(basicBlock);
	    if (loopScope == NULL) {
	      loopScope = Procedure_findLoopScope (procedure, NULL);
            }
            blockTrace  = BlockTrace_createSingleton(memory, regionFlow,cfgNode, loopScope,
                                                     type, flags);
            scheduler = Scheduler_new(memory, blockTrace);
            optimized |= Scheduler_schedule(scheduler, regionFlow);
            scheduled += Scheduler_scheduled(scheduler);
            bodyCount += Scheduler_bodyCount(scheduler);
            Scheduler_delete(scheduler);
          }
        } CodeRegion_ENDEACH_BasicBlock;
        RegionFlow_reorderBasicBlocks(regionFlow);
        RegionFlow_finalize(regionFlow);
        RegionFlow_delete(regionFlow);
        scheduled && bodyCount &&
        SCD_TRACE && fprintf(SCD_TRACE, "*** PRESCHEDULED=%d\tBODYCOUNT=%d\tPERCENT=%2.4g\n",
                             scheduled, bodyCount, (float)scheduled*100/(float)bodyCount);
        SCD_TRACE && fprintf(SCD_TRACE, "*** AFTER PRESCHEDULER\n")
                  && CodeRegion_pretty(codeRegion, SCD_TRACE);
        SCD_TRACE && CodeRegion_prettyPressures(codeRegion, SCD_TRACE);
        Liveness_kill(liveness);
      }
    }
    // RegAlloc OptimizationFlags.
    if (   (activation & OptimizeActivation_RegAlloc) != 0
        && (conversion & ~OptimizeConversion_Dedicated) != 0) {
#if !PRO_OPTIMIZE
      Interface_FOREACH_Temporary(this, cgir_tn, temporary) {
        Except_CHECK(!Temporary_isAssigned(temporary));
      } Interface_ENDEACH_Temporary;
#endif//PRO_OPTIMIZE
      // Register allocation.
      if ((allocation & OptimizeAllocation_ELinearScan) != 0) {
        SSAForm ssaForm = SSAForm_construct(memory, codeRegion, false);
        ELinearScan linearScan = ELinearScan_new(memory, ssaForm);
        ELinearScan_allocate(linearScan);
        ELinearScan_delete(linearScan);
        SSAForm_destruct(ssaForm);
      } else
       if ((allocation & OptimizeAllocation_DomTreeScan) != 0) {
        SSAForm ssaForm = SSAForm_construct(memory, codeRegion, false);
        DomTreeScan treeScan = DomTreeScan_new(memory, ssaForm);
        DomTreeScan_allocate(treeScan);
        DomTreeScan_delete(treeScan);
        SSAForm_destruct(ssaForm);
      } else
      if ((allocation & OptimizeAllocation_GraphColoring) != 0) {
        uint32_t temporaryCounter = IndexedFactory_COUNTER(Temporary_Factory);
        uint32_t operationCounter = IndexedFactory_COUNTER(Operation_Factory);
        SSAForm ssaForm = NULL;
        bool doFlorentAlloc;
        BasicBlock entry = NULL;
        Operation virtualDef = NULL;

#line 3204 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
        // Use to ease debugging
        doFlorentAlloc = getenv("USE_FLORENT_ALLOC") != NULL;

#line 3207 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
        ssaForm = SSAForm_construct(memory, codeRegion, false);
        PFA_TRACE && fprintf(PFA_TRACE, "*** SSA Convert=0x%x (", conversion)
	          && OptimizeConversion_prettyFlags(conversion, PFA_TRACE)
	          && fprintf(PFA_TRACE, ") ***\n");
        TemporaryTable_empty(CodeRegion_globalTable(codeRegion));
        SSAForm_fillTemporaryTable(ssaForm, CodeRegion_globalTable(codeRegion));
        CodeRegion_makeConsumers(codeRegion, CodeRegion_globalTable(codeRegion));

#line 3215 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
        // Lower register pressure.
        if(getenv("SPILL_BELADY") != NULL) {
          int regFile;
          TemporaryTable globalTable;
          bool addMoveInterference = getenv("ADD_MOVE_INTERFERENCE") != NULL;
          bool noMoveAffinity = getenv("NO_MOVE_AFFINITY") != NULL;
          explicitDependencies(ssaForm, &entry, &virtualDef);
          // FIXME: Since br registers may create gr register, to be sure
          // liveness will be still valid, we should call this one after each
          // spillBelady
          globalTable = CodeRegion_makeGlobalTable(codeRegion, TemporaryFlag_Constant, 0);
          PFA_TRACE && fprintf(PFA_TRACE, "*** Spill Belady ***\n");
          PFA_TRACE && fprintf(PFA_TRACE, "*** CodeRegion ***\n");
          PFA_TRACE && CodeRegion_pretty(SSAForm_codeRegion(ssaForm), PFA_TRACE);

#line 3230 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
          if(GRA_DISP_INTERFERENCE != NULL) {
            InterfGraph_display(SSAForm_codeRegion(ssaForm), "Before",
                                GRA_DISP_INTERFERENCE, false, false,
                                addMoveInterference, noMoveAffinity, true);
            // InterfGraph_display puts more things in the globalTable, restore
            // the "normal" globalTable
            globalTable = CodeRegion_makeGlobalTable(codeRegion, TemporaryFlag_Constant, 0);
          }

#line 3239 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
          GRA_statisticOnCodeRegion(codeRegion, "Before spill belady", GRA_DISP_COST);

#line 3241 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
          for (regFile = 0; regFile < RegFile__COUNT; ++regFile) {
            int32_t nRegs;
            RegisterSet_ allocatableSet[1];
            Convention convention = CodeRegion_convention(codeRegion);
            if(regFile == RegFile__UNDEF) {
              continue;
            }
            *allocatableSet = Convention_allocatableSet(convention, regFile);
            nRegs = RegisterSet_count(allocatableSet);
            MAXLIVE_TRACE && fprintf(MAXLIVE_TRACE, "%s: Before: Max live(%s): %d/%d\n",
                                 Procedure_name(CodeRegion_procedure(codeRegion)),
                                 RegFile_name_(regFile),
                                 SSASpill_maxLive(ssaForm, regFile), nRegs);
            SSASpill_spillBelady(ssaForm, regFile,
                                 getenv("SPILL_BELADY_RM_PHI_MEM") != NULL);
            MAXLIVE_TRACE && fprintf(MAXLIVE_TRACE, "%s: After: Max live(%s): %d/%d\n",
                                 Procedure_name(CodeRegion_procedure(codeRegion)),
                                 RegFile_name_(regFile),
                                 SSASpill_maxLive(ssaForm, regFile), nRegs);
          }
          GRA_statisticOnCodeRegion(codeRegion, "After spill belady", GRA_DISP_COST);
          PFA_TRACE && fprintf(PFA_TRACE, "*** End Belady ***\n");
          if(GRA_DISP_INTERFERENCE != NULL) {
            InterfGraph_display(SSAForm_codeRegion(ssaForm), "After",
                                GRA_DISP_INTERFERENCE,
                                getenv("CLOBBERS_DO_NOT_INTERFER") != NULL,
                                false, addMoveInterference, noMoveAffinity, true);
            fflush(GRA_DISP_INTERFERENCE);
          }
        }
        {
          bool parallelizeDedicatedMove = getenv("PARALLELIZE_DEDICATED_MOVE") != NULL;
          if(parallelizeDedicatedMove) {
            CodeRegion_FOREACH_BasicBlock(codeRegion, basicBlock) {
              factorizeDedicatedMoves(basicBlock);
            } CodeRegion_ENDEACH_BasicBlock;
          }
        }
        if(getenv("INSERT_SPLIT_POINT") != NULL) {
          insertAllSplitPoint(ssaForm);
        }
        if(virtualDef != NULL) {
          BasicBlock_detachOperation(entry, virtualDef);
          BasicBlock_makeOrderings(entry, 0, 1);
        }

#line 3287 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
        // explicit assigned as dedicated to see them after the allocation
        // (all variables assigned)
        removeAssigned(codeRegion);

#line 3291 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
        // We must have lowered the register pressure to use florent algorithm
        // (no spill)
        if(doFlorentAlloc && getenv("SPILL_BELADY") != NULL) {
          GRA_statisticOnCodeRegion(codeRegion, "Before florent alloc", GRA_DISP_COST);
          optimized |= Florent_allocCodeRegion(ssaForm);
          GRA_statisticOnCodeRegion(codeRegion, "After florent alloc", GRA_DISP_COST);
        } else {
          if(getenv("GRA_SSA") == NULL) {
            SSAForm_destruct(ssaForm);
            ssaForm = NULL;
          }
          {
            TemporaryTable globalTable = CodeRegion_makeGlobalTable(codeRegion,
                                                                    TemporaryFlag_Constant,
                                                                    0);
            Liveness liveness = Liveness_make(memory, codeRegion, globalTable, true);
            Liveness_multiplex(liveness);
            GRA_TRACE && fprintf(GRA_TRACE, "*** BEFORE ALLOCATOR\n")
              && CodeRegion_pretty(codeRegion, GRA_TRACE);
            GRA_statisticOnCodeRegion(codeRegion, "Before cedric alloc", GRA_DISP_COST);
            optimized |= GRA_allocateCodeRegion(codeRegion, ssaForm);
            GRA_statisticOnCodeRegion(codeRegion, "After cedric alloc", GRA_DISP_COST);
            GRA_TRACE && fprintf(GRA_TRACE, "*** AFTER ALLOCATOR\n")
              && CodeRegion_pretty(codeRegion, GRA_TRACE);
            Liveness_kill(liveness);
          }
        }
        // Relax constraints
        if(getenv("REMOVE_SPLIT_POINT") != NULL) {
          removeSplitPoint(codeRegion, memory);
        }
        
        if (ssaForm != NULL) {
          GRA_statisticOnCodeRegion(codeRegion, "Before ssa destruct", GRA_DISP_COST);
          SSAForm_destruct(ssaForm);
          GRA_statisticOnCodeRegion(codeRegion, "After ssa destruct", GRA_DISP_COST);
        }
        *IndexedFactory__COUNTER(Operation_Factory) = operationCounter;
        *IndexedFactory__COUNTER(Temporary_Factory) = temporaryCounter;
      }
    }
    // PostPass OptimizationFlags.
    if ((activation & OptimizeActivation_PostPass) != 0) {
#if !PRO_OPTIMIZE
      Interface_FOREACH_Temporary(this, cgir_tn, temporary) {
        if (Temporary_isVariable(temporary)) {
          Except_CHECK(Temporary_hasRegister(temporary));
        }
      } Interface_ENDEACH_Temporary;
#endif//PRO_OPTIMIZE
      // PostPass schedule.
      if (scheduling != 0) {
        TemporaryTable globalTable = CodeRegion_makeGlobalTable(codeRegion,
                                                                TemporaryFlag_Constant,
                                                                0);
        Liveness liveness = Liveness_make(memory, codeRegion, globalTable, false);
        RegionFlow regionFlow = RegionFlow_new(memory, codeRegion);
        OptimizeRegionType type = (OptimizeRegionType)Optimize_REGIONTYPE(optimize);
        RegionFlowCover regionCover = RegionFlowCover_new(memory, regionFlow, type, 0);
        SCD_TRACE && fprintf(SCD_TRACE, "*** BEFORE POSTSCHEDULER\n")
                  && CodeRegion_pretty(codeRegion, SCD_TRACE);
        RegionFlowCover_FOREACH_BlockTrace(regionCover, blockTrace) {
          SCD_TRACE && fprintf(SCD_TRACE, "*** SCHEDULING ");
          SCD_TRACE && BlockTrace_pretty(blockTrace, SCD_TRACE);
          if (BlockTrace_isEmpty(blockTrace)) {
            SCD_TRACE && fprintf(SCD_TRACE, "    EMPTY\n");
          } else {
            Scheduler scheduler = Scheduler_new(memory, blockTrace);
            optimized |= Scheduler_schedule(scheduler, regionFlow);
            Scheduler_delete(scheduler);
          }
        } RegionFlowCover_ENDEACH_BlockTrace;
        RegionFlowCover_delete(regionCover);
        RegionFlow_reorderBasicBlocks(regionFlow);
        RegionFlow_finalize(regionFlow);
        RegionFlow_delete(regionFlow);
        SCD_TRACE && fprintf(SCD_TRACE, "*** AFTER POSTSCHEDULER\n")
                  && CodeRegion_pretty(codeRegion, SCD_TRACE);
        SCD_TRACE && CodeRegion_prettyPressures(codeRegion, SCD_TRACE);
        Liveness_kill(liveness);
      }
    }
    // Encode OptimizationFlags.
    if ((activation & OptimizeActivation_Encode) != 0) {
      int32_t blockCount = CodeRegion_blockCount(codeRegion);
      NativeStream nativeStream = NativeStream_new(memory, blockCount);
      CodeRegion_addtoNativeStream(codeRegion, nativeStream);
      // Scoreboarder scheduling.
      if (Optimize_SCOREBOARDING(optimize) != 0) {
        SCD_TRACE && fprintf(SCD_TRACE, "*** BEFORE SCOREBOARDER\n")
                  && CodeRegion_pretty(codeRegion, SCD_TRACE);
        Scoreboarder_delete(Scoreboarder_new(memory, codeRegion));
        SCD_TRACE && fprintf(SCD_TRACE, "*** AFTER SCOREBOARDER\n")
                  && CodeRegion_pretty(codeRegion, SCD_TRACE);
        NativeStream_assumeScheduled(nativeStream);
      } else {
        NativeStream_assumeUnscheduled(nativeStream);
      }
      {
        size_t codeSize = NativeStream_getCodeSize(nativeStream, 0);
        void *codeBuffer = Memory_alloc(memory, codeSize);
        NativeStream_encode(nativeStream, 0, codeBuffer,
                            RegionFlow_InstructionRelocateFixup, NULL, NULL);
        LIR_TRACE && NativeStream_pretty(nativeStream, LIR_TRACE);
        Memory_free_(memory, codeBuffer);
      }
      NativeStream_delete(nativeStream);
    }
  } Procedure_ENDEACH_CodeRegion;
  O64_XMLOUT && Program_dumpXML(program);
  return optimized;
}

#line 3410 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
void
RegionFlow_InstructionRelocateFixup(Instruction instruction,
                                    PlatformUInt nativePC,
                                    void* user_data)
{
  Constant constant = Instruction_relocatableConstant(instruction);
  Relocation relocation = Instruction_relocatableRelocation(instruction);
  if (Relocation_isRelativePC(relocation)) Constant_setValue(constant, nativePC);
}

#line 3426 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
void
Interface_close(Interface this)
{
#ifndef PRO_NDTOR
  HTable_Dtor(Interface_CGIRVALID(this));
  HTable_Dtor(Interface_CGIRIMPORT(this));
  HTable_Dtor(Interface_LOOPSCOPES(this));
  HTable_Dtor(Interface_BASICBLOCKS(this));
  HTable_Dtor(Interface_OPERATIONS(this));
  HTable_Dtor(Interface_TEMPORARIES(this));
  HTable_Dtor(Interface_SYMBOLS(this));
  HTable_Dtor(Interface_LABELS(this));
  HTable_Dtor(Interface_LIR2CGIR(this));
#endif//PRO_NDTOR
  //
  Selector_Dtor(Interface_SELECTOR(this));
  memset(Interface_SELECTOR(this), 0, sizeof(Selector_));
  //
#ifndef ECL_NTRACE
  O64_INPUT && fprintf(O64_INPUT, "  Interface_close(interface);\n");
  O64_INPUT && fprintf(O64_INPUT, "}\n\n");
#endif//ECL_NTRACE
  //
  program = Program_delete(program);
  *Interface__CONFIGURE(this) = NULL;
  O64_Close();
}

#line 3460 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
void
Interface_Finalize(void)
{
  O64_Finalize();
}

#line 3466 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 3474 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
void
Interface_INIT(void)
{
  Memory memory = Memory_new(Memory_Root, 0);
  // Get environment
#ifndef Interface_DEDICATED
  if (GETENV("Interface_DEDICATED")) {
    sscanf(GETENV("Interface_DEDICATED"), "%d", &Interface_DEDICATED);
    fprintf(stderr, "*** Interface_DEDICATED=%d\n", Interface_DEDICATED);
  }
#endif
  Interface_Ctor(interface, memory);
}

#line 3494 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
void
Interface_FINI(void)
{
  Memory memory = Interface_MEMORY(interface);
  Interface_Dtor(interface);
  Memory_delete(memory);
}

#line 3502 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
#if XCC__C
void
Interface_TEST(void)
{
#include "O64/Interface_.c"
}

#line 3509 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/PRO/O64/Interface.xcc"
int
main(int argc, char **argv)
{
  O64_Test(Interface_TEST);
  return 0;
}
#endif


#endif//Interface_c_INCLUDED
