#ifndef SCD__h_INCLUDED
#define SCD__h_INCLUDED

//
#include "SCD/SCD.h"

//
#include "SCD/FastList_.h"
#include "SCD/GrahamList_.h"
#include "SCD/Relaxation_.h"
#include "SCD/Scheduler_.h"
#include "SCD/Insertion_.h"
#include "SCD/CycleBased_.h"
#include "SCD/Unwinding_.h"
#include "SCD/Iterative_.h"
#include "SCD/Acyclic_.h"
#include "SCD/Formulation_.h"
#include "SCD/Construction_.h"
#include "SCD/RCMS_.h"

/*
 * SCD_Test --	Setup and execute a SCD test.
 */
void
SCD_Test(void (*test)(void));


#endif//SCD__h_INCLUDED
