#ifndef BSL__h_INCLUDED
#define BSL__h_INCLUDED

//
#include "BSL/BSL.h"

/*
 * Include all the shared BSL headers.
 */
#include "BSL/Except_.h"
#include "BSL/Hacker_.h"
#include "BSL/Memory_.h"
#include "BSL/BBTree_.h"
#include "BSL/String_.h"
#include "BSL/Buffer_.h"
#include "BSL/REScan_.h"
#include "BSL/ETable_.h"
#include "BSL/Escape_.h"
#include "BSL/XMLCan_.h"
#include "BSL/XMLGen_.h"
#include "BSL/XMLScan_.h"
#include "BSL/XMLAuto_.h"

/*
 * BSL_Test --	Setup and execute a BSL test.
 */
void
BSL_Test(void (*test)(void));


#endif//BSL__h_INCLUDED
