#ifndef Instance__h_INCLUDED
#define Instance__h_INCLUDED

//
#include "MDS/Instance.h"

//
typedef enum {
#define Instance(NAME, SCHEDULING, ENCODING, OPCODES, OPERANDS, \
                 INCREMENT, MNEMONIC, SYNTAX, ACTIONARRAY, OPERATOR) \
  Instance_##NAME,
  Instance_,
#include /*MDS*/"Instance.enum"
  Instance__
#undef Instance
} enum_Instance;

/*
 * Instance_INIT --	Initialize the Instance module.
 */
void
Instance_INIT(void);

/*
 * Instance_FINI --	Finalize the Instance module.
 */
#define Instance_FINI()


#endif//Instance__h_INCLUDED
