#ifndef MDS__h_INCLUDED
#define MDS__h_INCLUDED

//
#include "MDS/MDS.h"

//
#include "MDS/Platform_.h"
#include "MDS/Resource_.h"
#include "MDS/Processor_.h"
#include "MDS/Encoding_.h"
#include "MDS/NativeType_.h"
#include "MDS/Storage_.h"
#include "MDS/Register_.h"
#include "MDS/RegFile_.h"
#include "MDS/RegClass_.h"
#include "MDS/RegMask_.h"
#include "MDS/Modifier_.h"
#include "MDS/Relocation_.h"
#include "MDS/Immediate_.h"
#include "MDS/Operand_.h"
#include "MDS/Format_.h"
#include "MDS/Syntax_.h"
#include "MDS/Instance_.h"
#include "MDS/Operator_.h"
#include "MDS/Bundling_.h"
#include "MDS/Template_.h"
#include "MDS/Bundle_.h"
#include "MDS/Reservation_.h"
#include "MDS/Scheduling_.h"
#include "MDS/Convention_.h"
#include "MDS/Decode_.h"

/*
 * MDS_Test --	Setup and execute a MDS test.
 */
void
MDS_Test(void (*test)(void));

//
//#define MDS_FAMILY "st200"
//#define MDS_FAMILY_st200
#define MDS_CORE_st220
#define MDS_CORE_st231
#define MDS_CORE_st240


#endif//MDS__h_INCLUDED
