#ifndef Modifier_h_INCLUDED
#define Modifier_h_INCLUDED

/*
 * !!!!	Modifier.xcc
 *
 * Benoit Dupont de Dinechin (Benoit.Dupont-de-Dinechin@st.com).
 * Stefan Freudenberger (Stefan.Freudenberger@st.com)
 *
 * Copyright 2002 - 2007 STMicroelectronics.
 * Copyright 1995 - 1998 Commissariat a l'Energie Atomique.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of either (at your option): the GNU
 * General Public License (GPL) version 2; the GNU Lesser General
 * Public License (LGPL) version 2.1; any later version of these
 * licences as published by the Free Software Foundation.
 */

/*
 * Modifier_name_ --	Names for the Modifier enumeration.
 */
extern const char *
Modifier_name_(Modifier this);

/*
 * Modifier_memberNames --	The member names of this Modifier.
 */
const char **
Modifier_memberNames(Modifier this);

/*
 * ModifierMember_name_ --	Names for the ModifierMember enumeration.
 */
extern const char *
ModifierMember_name_(ModifierMember this);

/*
 * ModifierMember_complement --	Complement the condition of this ModifierMember.
 */
ModifierMember
ModifierMember_complement(ModifierMember this);

/*
 * !!!!	st200-Modifier.xcc
 *
 * Benoit Dupont de Dinechin (Benoit.Dupont-de-Dinechin@st.com).
 *
 * Copyright 2002 - 2007 STMicroelectronics.
 * Copyright 1995 - 1998 Commissariat a l'Energie Atomique.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of either (at your option): the GNU
 * General Public License (GPL) version 2; the GNU Lesser General
 * Public License (LGPL) version 2.1; any later version of these
 * licences as published by the Free Software Foundation.
 */


#endif//Modifier_h_INCLUDED
