#ifndef RegClass__h_INCLUDED
#define RegClass__h_INCLUDED

//
#include "MDS/RegClass.h"

//
typedef enum {
#define RegClass(NAME, REGFILE, REGISTERS, ENCODE, DECODE, MINREADSTAGES) \
  RegClass_##NAME,
  RegClass_,
#include /*MDS*/"RegClass.enum"
  RegClass__
#undef RegClass
} enum_RegClass;

/*
 * RegClassEncode functions.
 */
#define ENCODE(e) e
#define RegClass(NAME, REGFILE, REGISTERS, ENCODE, DECODE, MINREADSTAGES) \
static inline OperandEncoded \
RegClassEncode_##NAME(OperandDecoded decoded) \
{ \
  OperandEncoded VALUE = decoded - Register__BIAS; \
  ENCODE; \
  return VALUE; \
}
#include "RegClass.enum"
#undef ENCODE

/*
 * RegClass_INIT --	Initialize the RegClass module.
 */
void
RegClass_INIT(void);

/*
 * RegClass_FINI --	Finalize the RegClass module.
 */
#define RegClass_FINI()


#endif//RegClass__h_INCLUDED
