#ifndef O64__h_INCLUDED
#define O64__h_INCLUDED

//
#include "O64/O64.h"

//
#include "O64/CGIR_.h"
#include "O64/Interface_.h"

/*
 * O64_INPUT --	File handle used to trace the O64 INPUT.
 */
extern FILE *O64_INPUT;
#ifdef ECL_NTRACE
#define O64_INPUT NULL
#endif//ECL_NTRACE

/*
 * O64_OUTPUT --	File handle used to trace the O64 OUTPUT
 */
extern FILE *O64_OUTPUT;
#ifdef ECL_NTRACE
#define O64_OUTPUT NULL
#endif//ECL_NTRACE

/*
 * O64_TRACE --	File handle used to trace the O64.
 */
extern FILE *O64_TRACE;
#ifdef ECL_NTRACE
#define O64_TRACE NULL
#endif//ECL_NTRACE

/*
 * O64_Test --	Setup and execute a O64 test.
 */
void
O64_Test(void (*test)(void));


#endif//O64__h_INCLUDED
