#ifndef Decoalescer_h_INCLUDED
#define Decoalescer_h_INCLUDED

/*
 * !!!!	Decoalescer.xcc
 *
 * Francois de Ferriere (Francois.de-Ferriere@st.com).
 * Benoit Dupont de Dinechin (Benoit.Dupont-de-Dinechin@st.com).
 * Fabrice Rastello (Fabrice.Rastello@ens-lyon.fr).
 *
 * Copyright 2002 - 2007 STMicroelectronics.
 * Copyright 1995 - 1998 Commissariat a l'Energie Atomique.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of either (at your option): the GNU
 * General Public License (GPL) version 2; the GNU Lesser General
 * Public License (LGPL) version 2.1; any later version of these
 * licences as published by the Free Software Foundation.
 */

//
struct Decoalescer_;
typedef struct Decoalescer_ Decoalescer_, *Decoalescer;
typedef const struct Decoalescer_ *const_Decoalescer;
typedef struct Decoalescer_ * restrict_Decoalescer;

//
Decoalescer
Decoalescer_new(Memory parent, CodeRegion codeRegion, SSAForm ssaForm);

//
Decoalescer
Decoalescer_delete(Decoalescer this);


#endif//Decoalescer_h_INCLUDED
