#ifndef Sreedhar_h_INCLUDED
#define Sreedhar_h_INCLUDED

/*
 * !!!! Sreedhar.xcc
 *
 * Benoit Dupont de Dinechin (Benoit.Dupont-de-Dinechin@st.com).
 * Nikola Puzovic (Nikola.Puzovic@st.com).
 * Christophe Guillon (Christophe.Guillon@st.com).
 * Fabrice Rastello (Fabrice.Rastello@ens-lyon.fr).
 *
 * Copyright 2002 - 2007 STMicroelectronics.
 * Copyright 1995 - 1998 Commissariat a l'Energie Atomique.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of either (at your option): the GNU
 * General Public License (GPL) version 2; the GNU Lesser General
 * Public License (LGPL) version 2.1; any later version of these
 * licences as published by the Free Software Foundation.
 */

/*
 * Sreedhar --	SSA Form destruction using Sreedhar et al. algorithms.
 */
struct Sreedhar_;
typedef struct Sreedhar_ Sreedhar_, *Sreedhar;
typedef const struct Sreedhar_ *const_Sreedhar;
typedef struct Sreedhar_ * restrict_Sreedhar;

//
Sreedhar
Sreedhar_new(Memory parent, CodeRegion codeRegion, SSAForm ssaForm);

//
Sreedhar
Sreedhar_delete(Sreedhar this);


#endif//Sreedhar_h_INCLUDED
