#ifndef RegionFlow__h_INCLUDED
#define RegionFlow__h_INCLUDED

//
#include "XFA/RegionFlow.h"

/*
 * RegionFlow_rerouteCFGArc --	Reroute a CFGArc through an unconditional GOTO operation.
 */
bool
RegionFlow_rerouteCFGArc(RegionFlow this, CFGArc arc);

/*
 * RegionFlow_fixBasicBlockGoTo --	Fix the goto operation betwen the two BasicBlocks.
 */
void
RegionFlow_fixBasicBlockGoTo(RegionFlow this,
                              BasicBlock prev_block, BasicBlock curr_block);

/*
 * RegionFlow_INIT --	Initialize the RegionFlow module.
 */
#define RegionFlow_INIT()

/*
 * RegionFlow_FINI --	Finalize the RegionFlow module.
 */
#define RegionFlow_FINI()


#endif//RegionFlow__h_INCLUDED
