#ifndef BSL_c_INCLUDED
#define BSL_c_INCLUDED

#line 13 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/BSL.xcc"
#include "BSL/BSL_.h"

#line 21 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/BSL.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 82 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/BSL.xcc"
#undef BSL_TRACE 
FILE *BSL_TRACE = NULL;

#line 91 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/BSL.xcc"
int32_t BSL_MEMORY_STATS;
int32_t FORCE_POOLED;

#line 100 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/BSL.xcc"
static int BSL_Initialized = 0;

#line 102 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/BSL.xcc"
void
BSL_INIT(void)
{
  if (BSL_Initialized++ == 0) {
    if (GETENV("BSL_TRACE")) {
      int file = 0;
      sscanf(GETENV("BSL_TRACE"), "%d", &file);
      if (file == 1) BSL_TRACE = stdout;
      else if (file == 2) BSL_TRACE = stderr;
    }
    BSL_MEMORY_STATS = CDT_MEMORY_STATS;
    if (GETENV("BSL_MEMORY_STATS")) {
      sscanf(GETENV("BSL_MEMORY_STATS"), "%d", &BSL_MEMORY_STATS);
      fprintf(stderr, "*** BSL_MEMORY_STATS=%d\n", BSL_MEMORY_STATS);
    }
    FORCE_POOLED = -1;
    if (GETENV("FORCE_POOLED")) {
      sscanf(GETENV("FORCE_POOLED"), "%d", &FORCE_POOLED);
      fprintf(stderr, "*** FORCE_POOLED=%d\n", FORCE_POOLED);
    }
    if (BSL_TRACE) fprintf(BSL_TRACE, "*** BSL INIT\n");
    Except_INIT();
    Hacker_INIT();
    Memory_INIT();
    BBTree_INIT();
    String_INIT();
    Buffer_INIT();
    REScan_INIT();
    ETable_INIT();
    Escape_INIT();
    XMLCan_INIT();
    XMLGen_INIT();
    XMLScan_INIT();
    XMLAuto_INIT();
  }
}

#line 145 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/BSL.xcc"
void
BSL_FINI(void)
{
  if (--BSL_Initialized == 0) {
    if (BSL_TRACE) fprintf(BSL_TRACE, "*** BSL FINI\n");
    XMLAuto_FINI();
    XMLScan_FINI();
    XMLGen_FINI();
    XMLCan_FINI();
    Escape_FINI();
    ETable_FINI();
    REScan_FINI();
    Buffer_FINI();
    String_FINI();
    BBTree_FINI();
    Memory_FINI();
    Hacker_FINI();
    Except_FINI();
  }
}

#line 172 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/BSL.xcc"
void
BSL_Test(void (*test)(void))
{
  BSL_INIT();
  (*test)();
  BSL_FINI();
}

#line 180 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/BSL.xcc"
#if XCC__C
static void
BSL_TEST(void)
{
#include "BSL/BSL_.c"
}

#line 187 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/BSL.xcc"
int
main(int argc, char **argv)
{
  BSL_Test(BSL_TEST);
  return 0;
}
#endif


#endif//BSL_c_INCLUDED
