#ifndef ETable__c_INCLUDED
#define ETable__c_INCLUDED

#line 34 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/ETable.xcc"
//
{
  printf("sizeof(ETableEntry_) = %d\n", sizeof(ETableEntry_));
}

#line 123 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/ETable.xcc"
//
{
  printf("sizeof(ETable_) = %d\n", sizeof(ETable_));
}

#line 317 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/ETable.xcc"
//
{
  typedef enum {
    Enum_Foo = 3,
    Enum_Bar = 8,
    Enum_Baz = 1,
    Enum_Bah = 0,
    Enum_A = 65,
    Enum_B,
    Enum_C,
    Enum_D,
    Enum_E,
    Enum_F,
  } Emum;
  ETableEntry_ Enum_Entries[] = {
    ETableENTRY(Enum, Foo),
    ETableENTRY(Enum, Bar),
    ETableENTRY(Enum, Baz),
    ETableENTRY(Enum, Bah),
    ETableENTRY(Enum, A),
    ETableENTRY(Enum, B),
    ETableENTRY(Enum, C),
    ETableENTRY(Enum, D),
    ETableENTRY(Enum, E),
    ETableENTRY(Enum, F),
    ETableENTRY_NULL,
  };
  ETable_ etable[1];
  ETable_Ctor(etable, Memory_Root, Enum_Entries);
  Except_ALWAYS(ETable_COUNT(etable) + 1 == ETableEntry_COUNT(Enum_Entries));
  ETable_FOREACH_ETableEntry(etable, entry) {
    ETableEntry link = ETableEntry_LINK(entry);
    printf("NAME=%s\t", ETableEntry_NAME(entry));
    printf("VALUE=%d\t", ETableEntry_VALUE(entry));
    printf("HASH=%d\t", ETableEntry_HASH(entry));
    printf("LINK=(%s)\n", link ? ETableEntry_NAME(link) : "null");
  } ETable_ENDEACH_ETableEntry;
  ETable_FOREACH_ETableEntry(etable, entry) {
    const char *NAME = ETableEntry_NAME(entry);
    int32_t VALUE = ETableEntry_VALUE(entry);
    const char *name = ETable_name(etable, VALUE);
    int32_t value = ETable_value(etable, NAME);
    printf("NAME=%s\tvalue=%d\t", NAME, value);
    printf("VALUE=%d\tname=%s\n", VALUE, name);
  } ETable_ENDEACH_ETableEntry;
  ETable_Dtor(etable);
}


#endif//ETable__c_INCLUDED
