#ifndef Hacker_c_INCLUDED
#define Hacker_c_INCLUDED

#line 16 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Hacker.xcc"
#include "BSL/BSL_.h"

#line 40 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Hacker.xcc"
#if XCC__C
static unsigned args[] = {
  0, 1, 2, 3, 4, 5, 6, 7, 8, 9,
  15, 16, 17,
  31, 32, 33,
  63, 64, 65,
  127, 128, 129,
  255, 256, 257,
  511, 512, 513,
  1023, 1024, 1025,
  2047, 2048, 2049,
  4095, 4096, 4097,
  8191, 8192, 8193,
};
#endif

#line 79 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Hacker.xcc"
#if 0
static inline int
HackerU32_popc(uint32_t word)
{
  uint32_t v = word;
  uint32_t w = v - ((v >> 1) & 0x55555555);
  uint32_t x = (w & 0x33333333) + ((w >> 2) & 0x33333333);
  uint32_t y = (x + (x >> 4)) & 0x0F0F0F0F;
  uint32_t z = y + (y << 8);
  uint32_t t = z + (z << 16);
  return t >> 24;
}
#endif

#line 203 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Hacker.xcc"
uint32_t
Hacker_hashELF(const char *name)
{
  const uint8_t *bytes = (const uint8_t *)name;
  uint32_t h = 0, g;
  while (*bytes) {
    h = (h << 4) + *bytes++;
    if ((g = h & 0xf0000000)) {
      h ^= g >> 24;
    }
    h &= ~g;
  }
  return h;
}

#line 228 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Hacker.xcc"
uint32_t
Hacker_hashFNV32(const char *name)
{
  const uint8_t *bytes = (const uint8_t *)name;
  uint32_t hash = Hacker_hashFNV32_OFFSET;
  while (*bytes) {
    hash *= Hacker_hashFNV32_PRIME;
    hash ^= *bytes++;
  }
  return hash;
}

#line 322 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Hacker.xcc"
uint32_t
Hacker_hashJenkins(const uint8_t *key, uint32_t length, uint32_t initval)
{
  register uint32_t a,b,c,len;
  /* set up the internal state */
  len = length;
  a = b = 0x9e3779b9;  /* the golden ratio; an arbitrary value */
  c = initval;         /* the previous hash value */
  /*---------------------------------------- handle most of the key */
  while (len >= 12)
  {
    a += (key[0] +((uint32_t)key[1]<<8) +((uint32_t)key[2]<<16) +((uint32_t)key[3]<<24));
    b += (key[4] +((uint32_t)key[5]<<8) +((uint32_t)key[6]<<16) +((uint32_t)key[7]<<24));
    c += (key[8] +((uint32_t)key[9]<<8) +((uint32_t)key[10]<<16)+((uint32_t)key[11]<<24));
    Hacker_mixJenkins(a,b,c);
    key += 12; len -= 12;
  }
  /*------------------------------------- handle the last 11 bytes */
  c += length;
  switch(len)          /* all the case statements fall through */
  {
  case 11: c+=((uint32_t)key[10]<<24);
  case 10: c+=((uint32_t)key[9]<<16);
  case 9 : c+=((uint32_t)key[8]<<8);
    /* the first byte of c is reserved for the length */
  case 8 : b+=((uint32_t)key[7]<<24);
  case 7 : b+=((uint32_t)key[6]<<16);
  case 6 : b+=((uint32_t)key[5]<<8);
  case 5 : b+=key[4];
  case 4 : a+=((uint32_t)key[3]<<24);
  case 3 : a+=((uint32_t)key[2]<<16);
  case 2 : a+=((uint32_t)key[1]<<8);
  case 1 : a+=key[0];
    /* case 0: nothing left to add */
  }
  Hacker_mixJenkins(a,b,c);
  /*-------------------------------------------- report the result */
  return c;
}

#line 373 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Hacker.xcc"
void
HackerPtr_Sort(HackerPtr array[], int32_t first, int32_t last, HackerPtrCompare cmp)
{
  int32_t count = last - first + 1;
  int32_t mid = (first + last) >> 1;
  int32_t idx1 = first, idx2 = mid + 1, i;
  if (idx1 < mid) HackerPtr_Sort(array, idx1, mid, cmp);
  if (idx2 < last) HackerPtr_Sort(array, idx2, last, cmp);
  // Merge step.
  if (count > 1) {
    HackerPtr *tempArray = alloca(sizeof(HackerPtr)*count);
    for (i = 0; i < count; i++) {
      if (idx1 > mid) {
        tempArray[i] = array[idx2++];
      } else if (idx2 > last) {
        tempArray[i] = array[idx1++];
      } else if ((*cmp)(array[idx1], array[idx2]) <= 0) {
        tempArray[i] = array[idx1++];
      } else {
        tempArray[i] = array[idx2++];
      }
    }
    for (i = 0; i < count; i++) {
      array[first + i] = tempArray[i];
    }
  }
}

#line 428 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Hacker.xcc"
#if XCC__C
static int
HackerPtr_compare(const_HackerPtr a, const_HackerPtr b)
{
  return (a > b) - (a < b);
}
#endif

#line 436 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Hacker.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 448 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Hacker.xcc"
#if XCC__C
static void
Hacker_TEST(void)
{
#include "BSL/Hacker_.c"
}

#line 455 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/Hacker.xcc"
int
main(int argc, char **argv)
{
  BSL_Test(Hacker_TEST);
  return 0;
}
#endif


#endif//Hacker_c_INCLUDED
