#ifndef XMLGen_c_INCLUDED
#define XMLGen_c_INCLUDED

#line 16 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
#include "BSL/BSL_.h"

#line 21 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
/////////////////////////////////////////////////////////////////////////////////////////

#line 156 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
static int isXMLChar(int c)
{
  if (c < 0)
    return 0;
  else
    return (c <= 0x10ffff);
}

#line 170 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
int NextUnicodeChar(const_UTF8 *sp)
{
  const unsigned char *s = (const unsigned char *) *sp;
  int c;
  if (*s == 0)
    return -1;
  if (*s < 0x80)
    c = *s++;
  else if (*s < 0xc2)
    goto malformed;
  else if (*s < 0xe0)
  {
    c = (*s++ & 0x1f) << 6;
      if (*s < 0x80 || *s > 0xbf)
      goto malformed;
    c |= *s++ & 0x3f;
  }
  else if (*s < 0xf0)
  {
    int b0 = *s;
    c = (*s++ & 0x0f) << 12;
    if ((b0 == 0xe0 && (*s < 0xa0 || *s > 0xbf)) ||(b0 <  0xed && (*s < 0x80 || *s > 0xbf)) ||(b0 == 0xed && (*s < 0x80 || *s > 0x9f)) ||(b0  > 0xed && (*s < 0x80 || *s > 0xbf)))
      goto malformed;
    c |= (*s++ & 0x3f) << 6;
    if (*s < 0x80 || *s > 0xbf)
      goto malformed;
    c |= *s++ & 0x3f;
  }
  else if (*s < 0xf5)
  {
    int b0 = *s;
    c = (*s++ & 0x07) << 18;
    if ((b0 == 0xf0 && (*s < 0x90 || *s > 0xbf)) ||(b0 <  0xf4 && (*s < 0x80 || *s > 0xbf)) ||(b0 >= 0xf4 && (*s < 0x80 || *s > 0x8f)))
      goto malformed;
    c |= (*s++ & 0x3f) << 12;
    if (*s < 0x80 || *s > 0xbf)
      goto malformed;
    c |= (*s++ & 0x3f) << 6;
    if (*s < 0x80 || *s > 0xbf)
      goto malformed;
    c |= *s++ & 0x3f;
  }
  else
    goto malformed;
  *sp = s;
  return c;
malformed:
  if (*s) ++s;
  *sp = s;
  return -1;
}

#line 228 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
static XMLGenStatus checkNCName(const_UTF8 name)
{
  int c;

#line 232 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  if (name == NULL || *name == 0)
    return XMLGenStatus_Error;

#line 235 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  c = NextUnicodeChar(&name);
  if (!isLetter(c) && c != ':' && c != '_')
    return XMLGenStatus_Error;

#line 239 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  while (*name)
  {
    c = NextUnicodeChar(&name);
    if (c == -1)
      return XMLGenStatus_BadUTF8;
    if (!isNameChar(c))
      return XMLGenStatus_NonXML;
  }
  return XMLGenStatus_OK;
}

#line 256 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
XMLGenStatus checkText( const_UTF8 s)
{

#line 259 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  while (*s)
  {
    int c = NextUnicodeChar(&s);
    if (c == -1)
      return XMLGenStatus_BadUTF8;
    if (!isXMLChar(c))
      return XMLGenStatus_NonXML;
   }
  return XMLGenStatus_OK;
}

#line 358 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
static XMLGenStatus initPlist(XMLGenWriter_rec w, plist * pl)
{
  pl->writer = w;
  pl->count = 0;
  pl->space = 20;
  pl->pointers = (void * *) allocate(w, pl->space * sizeof(void *));
  if (pl->pointers == NULL)
    return XMLGenStatus_AllocFailed;
  return XMLGenStatus_OK;
}

#line 375 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
static XMLGenStatus initElemList(XMLGenWriter_rec w, plist * pl)
{
  pl->count = 0;
  pl->space = 20;
  pl->pointers = NULL;
  return XMLGenStatus_OK;
}

#line 384 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
XMLGen
XMLGen_Ctor(XMLGen this, Memory memory, struct XMLGenWriter_rec *XMLGenWriter)
{
  *XMLGen__MEMORY(this) = memory;
  *XMLGen__XMLGENWRITER(this) = XMLGenWriter;
   return this;
}

#line 392 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
void
XMLGen_Dtor(XMLGen this)
{
  memset(this, -1, sizeof(XMLGen_));
}

#line 398 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
size_t
XMLGen_Size(Memory memory, struct XMLGenWriter_rec *XMLGenWriter)
{
  return sizeof(XMLGen_);
}

#line 415 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
#ifndef XMLGen_POOLED
#define XMLGen_POOLED 128
#endif//XMLGen_POOLED

#line 419 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
XMLGen
XMLGen_new(Memory parent)
{
  struct XMLGenWriter_rec *writer = NULL;
  void *userData;
  int bytes;
  void *data;
  plist * liste;
  Memory memory = Memory_new(parent, XMLGen_POOLED);

#line 429 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  void *(*alloc)(void *userData,int bytes ) = (void *(*)(void *, int))Memory_alloc;
  void (*dealloc)(void *userData,void *data ) = (void (*)(void *, void *))Memory_free;
    
  writer = malloc(sizeof(struct XMLGenWriter_rec_)); 
  if (writer == NULL) return NULL;
  else {
    size_t size = XMLGen_Size(memory, writer);
    void *new = Memory_alloc(memory, size);
    return XMLGen_Ctor(new, memory, writer);
  }
}

#line 446 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
void XMLGen_dispose(XMLGenWriter_rec_ *writer){

#line 448 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  int i;
  XMLGenElement * ee = (XMLGenElement *) writer->elements.pointers;
  XMLGenAttribute * aa = (XMLGenAttribute *) writer->attributes.pointers;
  XMLGenElement * ss = (XMLGenElement *) writer->stackElems.pointers;

#line 453 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  for (i = 1; i <= writer->elements.count; i++)
  {
    deallocate(writer, (void *)((struct XMLGenElement_rec *)ee[i])->type);
    deallocate(writer, ee[i]);
  }
  for (i = 1; i <= writer->attributes.count; i++)
  {
    deallocate(writer, (void *)((struct XMLGenAttribute_rec_ *)aa[i])->name);
    deallocate(writer, (void *)((struct XMLGenAttribute_rec_ *)aa[i])->value.buf);
    deallocate(writer, aa[i]);
  }
  for (i = 1; i <= writer->stackElems.count; i++)
  {
    deallocate(writer, (void *)((struct XMLGenElement_rec *)ss[i])->type);
    deallocate(writer, ss[i]);
  }
  deallocate(writer, writer->elements.pointers);
  deallocate(writer, writer->attributes.pointers);
  deallocate(writer, writer->stackElems.pointers);
  deallocate(writer, writer);
  return;
}

#line 482 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
XMLGen
XMLGen_delete(XMLGen this)
{
  if (this != NULL) {
    Memory memory = XMLGen_MEMORY(this);
    XMLGenWriter_rec_ *writer = (XMLGenWriter_rec_ *)XMLGen_XMLGENWRITER(this);
    XMLGen_dispose(writer);
#ifndef CDT_NDTOR
    XMLGen_Dtor(this);
    Memory_free_(memory, this);
#endif//CDT_NDTOR
    Memory_delete(memory);
  }
  return NULL;
}

#line 531 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
static UTF8 copy(XMLGenWriter_rec w, const_UTF8 from)
{
  UTF8 temp;

#line 535 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  if ((temp = allocate(w, strlen((const char *) from) + 1)) == NULL)
    return NULL;
  strcpy((char *) temp, (const char *) from);
  return temp;
}

#line 546 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
static int checkExpand(plist * pl)
{
  void * * newlist;
  int i;

#line 551 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  if (pl->count < pl->space)
    return 0;

#line 554 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  pl->space *= 2;
  newlist = (void * *) allocate(pl->writer, pl->space * sizeof(void *));
  if (newlist == NULL)
    return -1;
  for (i = 1; i <= pl->count; i++)
    newlist[i] = pl->pointers[i];
  deallocate(pl->writer, pl->pointers);
  pl->pointers = newlist;

#line 563 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  return 0;
}

#line 571 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
static XMLGenStatus listAppend(plist * pl, void * pointer)
{
  if (checkExpand(pl)!=0)
    return XMLGenStatus_AllocFailed;
  pl->count++;
  pl->pointers[pl->count] = pointer;

#line 578 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  return XMLGenStatus_OK;
}

#line 587 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
static int findElement(plist * pl, const_UTF8 type)
{
  int i;
  for (i = 1; i <= pl->count; i++)
    {
      if (strcmp((const char *) type,
		 (const char *) ((struct XMLGenElement_rec *)pl->pointers[i])->type) == 0)
	{
	  return i;
	}
    }
  return -1;
}

#line 607 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
static int findAttribute(plist * pl, const_UTF8 name)
{
  int i;
  for (i = 1; i <= pl->count; i++)
    {
      if ((const char *) ((struct XMLGenAttribute_rec_ *)pl->pointers[i])->name!=NULL)
	if (strcmp((const char *) name,
		   (const char *) ((struct XMLGenAttribute_rec_ *)pl->pointers[i])->name) == 0)
	  {
	    return i;
	  }
    }
  return -1;
}

#line 629 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
XMLGenElement
XMLGen_declareElement(XMLGen this, const_UTF8 type)
{
  struct XMLGenElement_rec *elem= malloc(sizeof(struct XMLGenElement_rec));
  //memcpy(&elem->type,&type,sizeof(const_UTF8));

#line 635 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  XMLGenElement ee = malloc(sizeof(struct XMLGenElement_));
  int old=0;
  XMLGenStatus status = 0;
  XMLGenWriter_rec_ * writer = (XMLGenWriter_rec_ *)XMLGen_XMLGENWRITER(this);
  
   if ((writer->status = checkNCName(type)) != XMLGenStatus_OK)
  {
    return NULL;
  }

#line 645 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
   
  /* already declared? */
  old = findElement(&writer->elements, type);
  if (old != -1){
    ee = ((&writer->elements)->pointers[old]);
    return ee;
  }

#line 653 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  if (((XMLGenElement) allocate(writer, sizeof(struct XMLGenElement_))) == NULL)
  {
    writer->status = XMLGenStatus_Error;
    return NULL;
  }

#line 659 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  if ((elem->type = copy(writer, type)) == NULL)
  {
    writer->status = XMLGenStatus_Error;
    return NULL;
  }
  {
  plist *list = &writer->elements;
  if (list->pointers == NULL){
    initPlist(writer,list);
  }
  }
  if ((writer->status = listAppend(&writer->elements, elem)) == XMLGenStatus_AllocFailed)
    {
      return NULL;
    }
  return ee;
}

#line 684 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
XMLGenAttribute
XMLGen_declareAttribute(XMLGen this, const_UTF8 name)
{

#line 688 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  Memory memory = XMLGen_MEMORY(this);
  //  XMLGenAttribute attribute = Memory_alloc(memory, sizeof(XMLGenAttribute_));
  int old=0;
  struct XMLGenAttribute_rec_ *attr = malloc(sizeof(struct XMLGenAttribute_rec_));
  XMLGenAttribute aa = malloc(sizeof(struct XMLGenAttribute_));
  XMLGenWriter_rec_ * writer;
  memcpy(&attr->name,&name,sizeof(const_UTF8));
  attr->provided=0;
  aa = (XMLGenAttribute)attr;
  
  writer = (XMLGenWriter_rec_ *)XMLGen_XMLGENWRITER(this);

#line 700 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  if ((writer->status = checkNCName(name)) != XMLGenStatus_OK)
  {
    return NULL;
  }

#line 705 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  /* already declared? */
  old = findAttribute(&writer->attributes, name);

#line 708 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  if (old != -1){
    aa = ((&writer->attributes)->pointers[old]);
    return aa;
  }

#line 713 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  if (((XMLGenAttribute) allocate(writer, sizeof(struct XMLGenAttribute_))) == NULL)
  {
    writer->status = XMLGenStatus_AllocFailed;
    return NULL;
  }

#line 719 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  if ((attr->name = copy(writer, name)) == NULL)
  {
    writer->status = XMLGenStatus_AllocFailed;
    return NULL;
  }
  {
  plist *list = &writer->attributes;
  if (list->pointers == NULL){
    initPlist(writer,list);
  }
  }
  if ((writer->status = listAppend(&writer->attributes, attr)) == XMLGenStatus_AllocFailed)
    {
      return NULL;
    }
  return aa;
}

#line 743 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
XMLGenStatus
XMLGen_addAttribute(XMLGen this, XMLGenAttribute attribute, const_UTF8 value)
{

#line 747 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  UTF8 lastv = (UTF8) value;
  XMLGenWriter_rec_ * writer = (XMLGenWriter_rec_ *)XMLGen_XMLGENWRITER(this);
  struct XMLGenAttribute_rec_ *a = malloc (sizeof(struct XMLGenAttribute_rec_ *));
  //a = (struct XMLGenAttribute_rec_ *)attribute;
  struct XMLGenElement_rec *elem = malloc (sizeof(struct XMLGenElement_rec_ *));
  UTF8 comp = malloc(5*sizeof(char));
  int num,i,j= 1;
  char cmp[4];
  char *trad =malloc (10*sizeof(char));
  char *tmp =malloc (10*sizeof(char));
  UTF8 breaker, next;
  
  initCollector(writer, &a->value);
  if (writer->sequence != SEQUENCE_START_TAG &&
      writer->sequence != SEQUENCE_ATTRIBUTES)
    return writer->status = XMLGenStatus_SeqError;
  writer->sequence = SEQUENCE_ATTRIBUTES;

#line 765 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  if (value)
    {
      startCollect(&a->value);
      while (*value)
	{
	  int c = NextUnicodeChar(&value);
	  if (c == -1)
	    return writer->status = XMLGenStatus_BadUTF8;
	  if (!isXMLChar(c))
	    return writer->status = XMLGenStatus_NonXML;
	 
	  switch(c)
	    {
	    case 9:
	      collectPiece(writer, &a->value, "&#x9;", 5);
	      break;
	    case 0xa:
	      collectPiece(writer, &a->value, "&#xA;", 5);
	      break;
	    case 0xd:
	      collectPiece(writer, &a->value, "&#xD;", 5);
	      break;
	    case '"':
	      collectPiece(writer, &a->value, "&quot;", 6);
	      break;
	    case '<':
	      collectPiece(writer, &a->value, "&lt;", 4);
	      break;
	    case '&':
	      collectPiece(writer, &a->value, "&amp;", 5);
	      break;
	    case '\'':
	      collectPiece(writer, &a->value, "&apos;", 6);
	      break;
	    case '>':
	      collectPiece(writer, &a->value, "&gt;", 4);
	      break;
	    case '0':
	      /*if Escape option, we have to escape the Unicode characters */
	      strncpy(comp,(UTF8)value,5*sizeof(char));
/* 	      sprintf(trad,""); */
/* 	      sprintf(tmp,""); */
	      for (i=0;i<4;i++)
		cmp[i]=(char)"";
	      //////////////// ESCAPE ENTITY XML //////////////////
	      if (comp[0]=='x'){
		comp++;
		for (i=0;i<4;i++){
		  if (!(((comp[i]=='0' && i!=3) && i!=2) || (comp[i]=='1')
			|| (comp[i]=='2') || (comp[i]=='3')
			|| (comp[i]=='4') || (comp[i]=='5')
			|| (comp[i]=='6') || (comp[i]=='7')
			|| (comp[i]=='8') || (comp[i]=='9')
			|| (comp[i]=='A') || (comp[i]=='B')
			|| (comp[i]=='C') || (comp[i]=='D')
			|| (comp[i]=='E') || (comp[i]=='F')
			|| (comp[i]=='a') || (comp[i]=='b')
			|| (comp[i]=='c') || (comp[i]=='d')
			|| (comp[i]=='e') || (comp[i]=='f')))
		    {
		      strncpy(cmp,comp,(i)*sizeof(char));
		      break;
		    }
		  else{
		    strncpy(cmp,comp,(i+1)*sizeof(char));
		  }
		}
	      }
	      else{
		collectPiece(writer, &a->value, (const char *) lastv, value - lastv);
		break;
	      }
	      for (j=0;j<=i;j++){
		value++;
	      }
	      num = atoi((const char*)cmp); 
	      sprintf(trad,"0x%s",cmp);
	      	      
	      if (num>0 || trad!=NULL){
	
		if (escape){
		  tmp = Escape_putXMLChar(num);
		  
		  if (tmp!=NULL){
		    sprintf(trad,"&%s;",tmp);
		    collectPiece(writer, &a->value, (const char *) trad, strlen(trad));
		    break;
		  }
		}
		//////////////// ESCAPE ENTITY HTML //////////////////
		/* make UTF8 representation of character */
		breaker=next=trad;
		
		sscanf(trad, "%X", &num);
		if (num < 0x80)
		  *next++ = num;
		else if (num < 0x800)
		  {
		    *next++ = 0xc0 | (num >> 6);
		    *next++ = 0x80 | (num & 0x3f);
		  }
		else if (num < 0x10000)
		  {
		    *next++ = 0xe0 | (num >> 12);
		    *next++ = 0x80 | ((num & 0xfc0) >> 6);
		    *next++ = 0x80 | (num & 0x3f);
		  }
		else
		  {
		    *next++ = 0xf0 | (num >> 18);
		    *next++ = 0x80 | ((num & 0x3f000) >> 12);
		    *next++ = 0x80 | ((num & 0xfc0) >> 6);
		    *next++ = 0x80 | (num & 0x3f);
		  }
		*next = 0;
		
		memcpy(trad,breaker,(next-breaker)*(sizeof(const_UTF8)));
		collectPiece(writer, &a->value, (const char *) trad, strlen(trad));
		break;
	      }
	      else{
		collectPiece(writer, &a->value, (const char *) lastv, value - lastv);
	      }
	      break;
	    default:
	      collectPiece(writer, &a->value, (const char *) lastv, value - lastv);
	      break;
	    }
	  lastv = (UTF8) value;
	}
      endCollect(&a->value);
    }
  a->provided = 1;
  free(trad);
  free(tmp);
  return XMLGenStatus_OK;
}

#line 909 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
XMLGenStatus XMLGen_PI(XMLGen this, const_UTF8 target, const_UTF8 text)
{

#line 912 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  XMLGenWriter_rec_ * writer = (XMLGenWriter_rec_ *)XMLGen_XMLGENWRITER(this);
  int i;

#line 915 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  if (writer->sequence == SEQUENCE_NO_DOC)
    return writer->status = XMLGenStatus_SeqError;

#line 918 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  if ((writer->status = checkText(target)) != XMLGenStatus_OK)
    return writer->status;
  
  if ((strlen((const char *) target) >= 3) &&
      (target[0] == 'x' || target[0] == 'X') &&
      (target[1] == 'm' || target[1] == 'M') &&
      (target[2] == 'l' || target[2] == 'L') ){
    return writer->status = XMLGenStatus_PIError;
  }
  if ((writer->status = checkText(text)) != XMLGenStatus_OK)
    return writer->status;

#line 930 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  /* no ?> within */
  for (i = 1; text[i]; i++)
    if (text[i] == '>' && text[i - 1] == '?')
      return writer->status = XMLGenStatus_PIError;

#line 935 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  if (writer->sequence == SEQUENCE_START_TAG ||
      writer->sequence == SEQUENCE_ATTRIBUTES)
  {
    if ((writer->status = writeTag((this),1)) !=  XMLGenStatus_OK)
      return writer->status;
    writer->sequence = SEQUENCE_CONTENT;
  }

#line 943 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  else if (writer->sequence == SEQUENCE_POST_DOC)
    if ((Buffer_appendS(writer->buffer, "\n")) == 0)
      return XMLGenStatus_Error;
    if ((Buffer_appendS(writer->buffer, "<?")) == 0)
      return XMLGenStatus_Error;
    if ((Buffer_appendS(writer->buffer, target)) == 0)
      return XMLGenStatus_Error;

#line 951 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  if (text[0])
  {
    if ((Buffer_appendS(writer->buffer, " ")) == 0)
      return XMLGenStatus_Error;
    if ((Buffer_appendS(writer->buffer, text)) == 0)
      return XMLGenStatus_Error;
    if ((Buffer_appendS(writer->buffer, "?>")) == 0)
      return XMLGenStatus_Error;

#line 960 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
    if (writer->sequence == SEQUENCE_PRE_DOC)
      if ((Buffer_appendS(writer->buffer, "\n")) == 0)
	return XMLGenStatus_Error;
  }
  return XMLGenStatus_OK;
}

#line 974 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
XMLGenStatus
XMLGen_startDocFile(XMLGen this, int escapeOpt)
{
  XMLGenWriter_rec_ * writer = (XMLGenWriter_rec_ *)XMLGen_XMLGENWRITER(this);
  if (escapeOpt)
    escape = 1;
  else
    escape = 0;
  // write on the buffer
  {
  Buffer_ buffer[1];
  Buffer_Ctor(buffer, Memory_Root, 4);
  writer->buffer = malloc(sizeof(Buffer_));
  memcpy(writer->buffer,buffer,sizeof(Buffer_));
  initElemList(writer, &writer->elements);
  initElemList(writer, &writer->attributes);
  initElemList(writer, &writer->stackElems);
  writer->alloc=NULL;
  writer->dealloc=NULL;
  {
  XMLGenStatus status = XMLGenStatus_OK;
  if (writer->sequence != SEQUENCE_NO_DOC)
    return writer->status = XMLGenStatus_SeqError;
  writer->sequence = SEQUENCE_PRE_DOC;
  return status;
  }
  }
}

#line 1010 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
XMLGenStatus
XMLGen_endDocument(XMLGen this, FILE *file)
{
  XMLGenWriter_rec_ *writer = (XMLGenWriter_rec_ *) XMLGen_XMLGENWRITER(this);
  writer->attributes.count = 0;
  writer->elements.count = 0;
  if (writer->sequence != SEQUENCE_POST_DOC)
    return writer->status = XMLGenStatus_SeqError;
  writer->sequence = SEQUENCE_NO_DOC;
  if (writer->status == XMLGenStatus_OK){
    Buffer_fwrite(writer->buffer, file);
    fclose(file);
  }
  Buffer_Dtor(writer->buffer);
  return XMLGenStatus_OK;
}

#line 1033 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
XMLGenStatus
XMLGen_startElement(XMLGen this, XMLGenElement element)
{
  int i=0;
  XMLGenElement e = malloc (sizeof(struct XMLGenElement_));
  XMLGenWriter_rec_ *writer = (XMLGenWriter_rec_ *) XMLGen_XMLGENWRITER(this);
  struct XMLGenElement_rec *elem = malloc(sizeof(struct XMLGenElement_rec_ *));

#line 1041 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  elem = (struct XMLGenElement_rec *)element;
  e = XMLGen_declareElement(this, elem->type);
  if (e == NULL || writer->status != XMLGenStatus_OK)
    return writer->status;
  elem = (struct XMLGenElement_rec *)e;

#line 1047 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  switch (writer->sequence)
  {
  case SEQUENCE_NO_DOC:
  case SEQUENCE_POST_DOC:
    return writer->status = XMLGenStatus_SeqError;
  case SEQUENCE_START_TAG:
    if ((writer->status = writeTag((this),0)) != XMLGenStatus_OK)
      return writer->status;
    Buffer_appendS(writer->buffer, "\n");
    break;
  case SEQUENCE_ATTRIBUTES:
    if ((writer->status = writeTag((this),0)) != XMLGenStatus_OK)
      return writer->status;
    Buffer_appendS(writer->buffer, "\n");
    break;
  case SEQUENCE_PRE_DOC:
    break;
  case SEQUENCE_CONTENT:
    break;
  }

#line 1068 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  writer->sequence = SEQUENCE_START_TAG;
  {
  plist *list = &writer->stackElems;
  if (list->pointers == NULL){
    initPlist(writer,list);
  }
  }
  if ((writer->status = listAppend(&writer->stackElems, elem)) == XMLGenStatus_AllocFailed)
    {
      return XMLGenStatus_AllocFailed;
    }

#line 1080 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  /* clear provided attributes */
  for (i = 1; i <=  writer->attributes.count; i++)
    ((struct XMLGenAttribute_rec_ *) writer->attributes.pointers[i])->provided = 0;

#line 1084 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  return XMLGenStatus_OK;
}

#line 1093 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
XMLGenStatus
XMLGen_startElementLiteral(XMLGen this, const_UTF8 type)
{
  XMLGenElement e;
  XMLGenWriter_rec_ *writer = (XMLGenWriter_rec_ *) XMLGen_XMLGENWRITER(this);
  struct XMLGenElement_rec *elem = malloc(sizeof(struct XMLGenElement_rec_ *));

#line 1100 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  e = XMLGen_declareElement(this, type);
  if (e == NULL || writer->status != XMLGenStatus_OK)
    return writer->status;
  elem = (struct XMLGenElement_rec *)e;

#line 1106 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  switch (writer->sequence)
  {
  case SEQUENCE_NO_DOC:
  case SEQUENCE_POST_DOC:
    return writer->status = XMLGenStatus_SeqError;
  case SEQUENCE_START_TAG:
    break;
  case SEQUENCE_ATTRIBUTES:
    if ((writer->status = writeTag((this),0)) != XMLGenStatus_OK)
      return writer->status;
    break;
  case SEQUENCE_PRE_DOC:
  case SEQUENCE_CONTENT:
    break;
  }

#line 1122 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  writer->sequence = SEQUENCE_START_TAG;

#line 1125 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  ////////////////////////
  {
  plist *list = &writer->stackElems;
  if (list->pointers == NULL){
    initPlist(writer,list);
  }
  }
  if ((writer->status = listAppend(&writer->stackElems, elem)) == XMLGenStatus_AllocFailed)
    {
      return XMLGenStatus_AllocFailed;
    }
  //////////////////////

#line 1138 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  return XMLGenStatus_OK;
}

#line 1147 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
XMLGenStatus
XMLGen_addAttributeLiteral(XMLGen this, const_UTF8 name, const_UTF8 value)
{
  XMLGenWriter_rec_ *writer =(XMLGenWriter_rec_ *) XMLGen_XMLGENWRITER(this);
  XMLGenAttribute a;

#line 1153 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  a = XMLGen_declareAttribute(this, name);
  if (a == NULL || writer->status != XMLGenStatus_OK)
    return writer->status;
  return XMLGen_addAttribute(this, a, value);
}

#line 1165 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
XMLGenStatus
XMLGen_addText(XMLGen this, const_UTF8 start)
{
  XMLGenWriter_rec_ *writer =(XMLGenWriter_rec_ *) XMLGen_XMLGENWRITER(this);

#line 1170 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  if (writer->sequence == SEQUENCE_START_TAG ||
      writer->sequence == SEQUENCE_ATTRIBUTES)
  {
    if ((writer->status = writeTag((this),1)) != XMLGenStatus_OK)
      return writer->status;
    writer->sequence = SEQUENCE_CONTENT;
  }

#line 1178 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  if (writer->sequence != SEQUENCE_CONTENT)
    return writer->status = XMLGenStatus_SeqError;

#line 1181 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  // check character entities...
    while (*start)
      {
	int c = NextUnicodeChar(&start);
	if (c == -1)
	  writer->status = XMLGenStatus_BadUTF8;
	if (!isXMLChar(c))
	  writer->status = XMLGenStatus_NonXML;
	if (!addEscape(this,c)){
	  Buffer_appendC(writer->buffer, c);
	}
      }
    writer->status = XMLGenStatus_OK;
    return writer->status;
}

#line 1204 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
XMLGenStatus
XMLGen_comment(XMLGen this, const_UTF8 text)
{
  XMLGenWriter_rec_ *writer =(XMLGenWriter_rec_ *) XMLGen_XMLGENWRITER(this);
  int i;

#line 1210 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  if (writer->sequence == SEQUENCE_NO_DOC)
    return writer->status = XMLGenStatus_SeqError;

#line 1213 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  if ((writer->status = checkText(text)) != XMLGenStatus_OK)
    return writer->status;
  /* no leading '-', no trailing '-', no '--' */
  if (text[0] == '-')
    return writer->status = XMLGenStatus_CommentError;
  for (i = 0; text[i]; i++)
    if (text[i] == '-' && (text[i + 1] == '-' || text[i + 1] == 0))
      return writer->status = XMLGenStatus_CommentError;

#line 1222 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  if (writer->sequence == SEQUENCE_START_TAG ||
      writer->sequence == SEQUENCE_ATTRIBUTES)
  {
    if ((writer->status = writeTag((this),1)) != XMLGenStatus_OK)
      return writer->status;
    writer->sequence = SEQUENCE_CONTENT;
  }

#line 1230 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  else if (writer->sequence == SEQUENCE_POST_DOC)
    if ((Buffer_appendS(writer->buffer, "\n")) == 0)
      return XMLGenStatus_Error;
  if ((Buffer_appendS(writer->buffer, "<!--")) == 0)
    return XMLGenStatus_Error;
  if ((Buffer_appendS(writer->buffer, text)) == 0)
    return XMLGenStatus_Error;
  if ((Buffer_appendS(writer->buffer, "-->")) == 0)
    return XMLGenStatus_Error;
  if (writer->sequence == SEQUENCE_PRE_DOC)
    if ((Buffer_appendS(writer->buffer, "\n")) == 0)
      return XMLGenStatus_Error;

#line 1243 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  return XMLGenStatus_OK;

#line 1245 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
}

#line 1252 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
static int addEscape(XMLGen this, int c)
{
  XMLGenWriter_rec_ *writer =(XMLGenWriter_rec_ *) XMLGen_XMLGENWRITER(this);

#line 1256 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  if (c == -1)
    return XMLGenStatus_Error;

#line 1259 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  if (!isXMLChar(c))
    return XMLGenStatus_NonXML;
  switch(c)
  {
  case 0xd:
    Buffer_appendS(writer->buffer, "&#xD;");
    break;
  case '<':
    Buffer_appendS(writer->buffer, "&lt;");
  break;
  case '&':
    Buffer_appendS(writer->buffer, "&amp;");
    break;
  case '>':
    Buffer_appendS(writer->buffer, "&gt;");
    break;
  case '\'':
    Buffer_appendS(writer->buffer, "&apos;");
    break;
  case '"':
    Buffer_appendS(writer->buffer, "&quot;");
    break;
  default:
    return 0;
    break;
  }
  return 1;
}

#line 1295 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
XMLGenStatus
XMLGen_addCharacter(XMLGen this, int c)
{
  XMLGenWriter_rec_ *writer =(XMLGenWriter_rec_ *) XMLGen_XMLGENWRITER(this);
  unsigned char cUTF8[10];
  UTF8 breaker, next;
  int char_escape = 0;

#line 1303 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  if (writer->sequence == SEQUENCE_START_TAG ||
      writer->sequence == SEQUENCE_ATTRIBUTES)
  {
    if ((writer->status = writeTag((this),1)) != XMLGenStatus_OK)
      return writer->status;
    writer->sequence = SEQUENCE_CONTENT;
  }

#line 1311 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  if (writer->sequence != SEQUENCE_CONTENT)
    return writer->status = XMLGenStatus_SeqError;
  if (!isXMLChar(c)){
    
    return writer->status = XMLGenStatus_NonXML;
  }
  
  /* make UTF8 representation of character */
  breaker = next = cUTF8;
  
  if (c < 0x80)
    *next++ = c;
  else if (c < 0x800)
    {
      *next++ = 0xc0 | (c >> 6);
      *next++ = 0x80 | (c & 0x3f);
    }
  else if (c < 0x10000)
    {
      *next++ = 0xe0 | (c >> 12);
      *next++ = 0x80 | ((c & 0xfc0) >> 6);
      *next++ = 0x80 | (c & 0x3f);
    }
  else
    {
      *next++ = 0xf0 | (c >> 18);
      *next++ = 0x80 | ((c & 0x3f000) >> 12);
      *next++ = 0x80 | ((c & 0xfc0) >> 6);
      *next++ = 0x80 | (c & 0x3f);
    }
  *next = 0;

#line 1343 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  if (escape){
    char *trad=malloc (20*sizeof(char));
    if ((trad =(char *) Escape_putXMLChar(c)) != NULL){
       Buffer_appendS(writer->buffer, "&");
      Buffer_appendS(writer->buffer, trad);
      Buffer_appendS(writer->buffer, ";");
      char_escape = 1;
    }
  }
  if (!char_escape){
      if (!addEscape(this, c)){
	memcpy(cUTF8,breaker,(next-breaker)*(sizeof(const_UTF8)));
	Buffer_appendS(writer->buffer, cUTF8);
      }
  }
  return XMLGenStatus_OK;
}

#line 1367 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
XMLGenStatus writeTag (XMLGen this, int empty){

#line 1369 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  int i=0;
  XMLGenWriter_rec_ *writer =(XMLGenWriter_rec_ *) XMLGen_XMLGENWRITER(this);
  struct XMLGenElement_rec *elem;
  XMLGenAttribute * aa = (XMLGenAttribute *) (&writer->attributes)->pointers;
  elem = (struct XMLGenElement_rec *)(&writer->stackElems)->pointers[(&writer->stackElems)->count];
  for (i=writer->stackElems.count;i>1;i--){
    Buffer_appendS(writer->buffer,"\t");
  }
  Buffer_appendS(writer->buffer, "<");
  Buffer_appendS(writer->buffer, elem->type);

#line 1381 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  for (i = 1; i <= writer->attributes.count; i++)
  {
    if (((struct XMLGenAttribute_rec_ *)aa[i])->provided)
    {
      Buffer_appendS(writer->buffer, " ");
      Buffer_appendS(writer->buffer, ((struct XMLGenAttribute_rec_ *)aa[i])->name);
      Buffer_appendS(writer->buffer, "=\"");
      Buffer_appendS(writer->buffer, ((struct XMLGenAttribute_rec_ *)aa[i])->value.buf);
      Buffer_appendS(writer->buffer, "\"");
    }
  }
  /* clear provided attributes */
  for (i = 1; i <= writer->attributes.count; i++)
    ((struct XMLGenAttribute_rec_ *) writer->attributes.pointers[i])->provided = 0;
  if (empty)
    Buffer_appendS(writer->buffer, "/>");
  else
    Buffer_appendS(writer->buffer, ">");
  return XMLGenStatus_OK;
}

#line 1409 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
XMLGenStatus
XMLGen_endEmptyElement(XMLGen this)
{
  int i=0;
  XMLGenWriter_rec_ *writer =(XMLGenWriter_rec_ *) XMLGen_XMLGENWRITER(this);
  
  switch (writer->sequence)
  {
  case SEQUENCE_NO_DOC:
  case SEQUENCE_PRE_DOC:
  case SEQUENCE_POST_DOC:
    return writer->status = XMLGenStatus_SeqError;
  case SEQUENCE_START_TAG:
  case SEQUENCE_ATTRIBUTES:
    if ((writer->status = writeTag((this),1)) != XMLGenStatus_OK)
      return writer->status;
    break;
  case SEQUENCE_CONTENT:
    break;
  }
  Buffer_appendS(writer->buffer,"\n");
  writer->stackElems.count--;
  
  /* pop the NULL */
  if (writer->stackElems.count < 0)
    return writer->status = XMLGenStatus_Error;
  if (writer->stackElems.count == 0)
    writer->sequence = SEQUENCE_POST_DOC;
  else
    writer->sequence = SEQUENCE_CONTENT;
  return XMLGenStatus_OK;
}

#line 1448 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
XMLGenStatus
XMLGen_endElement(XMLGen this)
{
  int i=0;
  XMLGenWriter_rec_ *writer =(XMLGenWriter_rec_ *) XMLGen_XMLGENWRITER(this);

#line 1454 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  switch (writer->sequence)
  {
  case SEQUENCE_NO_DOC:
  case SEQUENCE_PRE_DOC:
  case SEQUENCE_POST_DOC:
    return writer->status = XMLGenStatus_SeqError;
  case SEQUENCE_START_TAG:
  case SEQUENCE_ATTRIBUTES:
    if ((writer->status = writeTag((this),1)) != XMLGenStatus_OK)
      return writer->status;
    break;
  case SEQUENCE_CONTENT:
    break;
  }
  Buffer_appendS(writer->buffer,"\n");
  for (i=writer->stackElems.count;i>1;i--){
    Buffer_appendS(writer->buffer,"\t");
  }
  Buffer_appendS(writer->buffer, "</");
  Buffer_appendS(writer->buffer, ((struct XMLGenElement_rec *)(&writer->stackElems)->pointers[(&writer->stackElems)->count])->type);
  Buffer_appendS(writer->buffer, ">\n");

#line 1476 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  writer->stackElems.count--;

#line 1478 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  /* pop the NULL */
  if (writer->stackElems.count < 0)
    return writer->status = XMLGenStatus_Error;
  if (writer->stackElems.count == 0)
    writer->sequence = SEQUENCE_POST_DOC;
  else
    writer->sequence = SEQUENCE_CONTENT;

#line 1486 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
  return XMLGenStatus_OK;
}

#line 1489 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1494 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
/*   char year_value[100], month_value[100]; */
/*   XMLGen gen = XMLGen_new(Memory_Root); */
/*   XMLGenStatus status;  */
/*   status = XMLGen_startDocFile(gen);  */
/*   XMLGenElement dates = XMLGen_declareElement(gen, "dates"); */
/*   XMLGenElement date = XMLGen_declareElement(gen, "date"); */
/*   XMLGenAttribute yyyy = XMLGen_declareAttribute(gen, "yyyy"); */
/*   XMLGenAttribute atr2 = XMLGen_declareAttribute(gen, "id"); */
/*   /\*  status = XMLGen_startElement(gen, dates); *\/ */
/*   /\*   status = XMLGen_startElementLiteral(gen, "lazy");  *\/ */
/*     sprintf(year_value, "%d", 1900 + 3); */
/*     sprintf(month_value, "%02d", 1 + 5); */
/*   /\*   XMLGen_addText(gen, "\n  "); *\/ */
/*   status = XMLGen_startElement(gen, date);     */
/*   XMLGen_addAttribute(gen, yyyy, year_value); */
/*   XMLGen_addAttribute(gen, atr2, month_value); */
/*   XMLGen_addText(gen, "aaabbbccccdddeee");  */
/*   status = XMLGen_startElement(gen, dates);     */
/*   XMLGen_addAttribute(gen, yyyy, year_value); */
/*   /\*   XMLGen_endElement(gen); *\/ */
/*   /\*   XMLGen_endElement(gen); *\/ */
/*   XMLGen_endElement(gen); */
/*   XMLGen_endElement(gen); */
/*   XMLGen_endDocument(gen); */
/*   XMLGen_delete(gen); */
/*   printf("\n");  */
/* } */

#line 1565 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1576 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
#if XCC__C
static void
XMLGen_TEST(void)
{
#include "BSL/XMLGen_.c"
}

#line 1583 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLGen.xcc"
int
main(int argc, char **argv)
{
  BSL_Test(XMLGen_TEST);
  return 0;
}
#endif


#endif//XMLGen_c_INCLUDED
