#ifndef XMLScan_c_INCLUDED
#define XMLScan_c_INCLUDED

#line 17 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLScan.xcc"
#include "BSL/BSL_.h"

#line 22 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLScan.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 43 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLScan.xcc"
XMLScan
XMLScan_Ctor(XMLScan this, Memory memory, FILE *file)
{
  *XMLScan__MEMORY(this) = memory;
  *XMLScan__INPUT(this) = file;
  *XMLScan__TOKEN(this) = NULL;
  *XMLScan__LIMIT(this) = NULL;
  *XMLScan__MARKER(this) = NULL;
  *XMLScan__CURSOR(this) = NULL;
  *XMLScan__BASE(this) = NULL;
  *XMLScan__PAST(this) = NULL;
  *XMLScan__END(this) = NULL;
  *XMLScan__LINE(this) = 1;
  *XMLScan__STATE(this) = -1;
  return this;
}

#line 60 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLScan.xcc"
void
XMLScan_Dtor(XMLScan this)
{
  Memory memory = XMLScan_MEMORY(this);
  Memory_free(memory, XMLScan_BASE(this));
}

#line 72 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLScan.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 78 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLScan.xcc"
byte *
XMLScan_fill(XMLScan this, size_t bsize)
{
    if (XMLScan_END(this) == NULL) {
    byte *token = XMLScan_TOKEN(this);
    byte *limit = XMLScan_LIMIT(this);
    byte *marker = XMLScan_MARKER(this);
    byte *cursor = XMLScan_CURSOR(this);
    byte *base = XMLScan_BASE(this);
    byte *past = XMLScan_PAST(this);
    size_t count = token - base;
    bsize = MAX(bsize, 1024);
    if (count != 0) {
      // Move data to BASE.
      token = memmove(base, token, limit - token);
      limit -= count;
      marker -= count;
      cursor -= count;
      // Update fields.
      *XMLScan__TOKEN(this) = token;
      *XMLScan__LIMIT(this) = limit;
      *XMLScan__MARKER(this) = marker;
      *XMLScan__CURSOR(this) = cursor;
    }
    if (past - limit < bsize) {
      // Extend buffer.
      Memory memory = XMLScan_MEMORY(this);
      size_t size = (limit - base) + bsize;
      byte *alloc = Memory_alloc(memory, size);
      token = memcpy(alloc, token, limit - token);
      limit = alloc + (limit - base);
      marker = alloc + (marker - base);
      cursor = alloc + (cursor - base);
      // Update fields.
      *XMLScan__TOKEN(this) = token;
      *XMLScan__LIMIT(this) = limit;
      *XMLScan__MARKER(this) = marker;
      *XMLScan__CURSOR(this) = cursor;
      *XMLScan__BASE(this) = alloc;
      *XMLScan__PAST(this) = alloc + size;
      Memory_free(memory, base);
    }
    // Read more input.
    count = fread(limit, sizeof(byte), bsize, XMLScan_INPUT(this));
    if (count == 0) {
      // No more input.
      byte *end = limit;
      *end++ = '\000';
      *XMLScan__END(this) = end;
    }
    *XMLScan__LIMIT(this) = limit + count;
  }
  return XMLScan_CURSOR(this);
}

#line 147 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLScan.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 149 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLScan.xcc"
#if XCC__C
int
XMLScan_getToken(XMLScan this);
#endif//XCC__C

#line 154 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLScan.xcc"
#if XCC__C
size_t
expandEntities(char *text, size_t size);
#endif//XCC__C

#line 159 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLScan.xcc"
#if XCC__C
int
expandEntity (char *text, char *stop);
#endif//XCC__C

#line 164 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLScan.xcc"
#if XCC__C
int
lookupEntity(const char *name, size_t size);
#endif//XCC__C

#line 169 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLScan.xcc"
#if XCC__C
int
entityEscape(const char *name);
#endif//XCC__C

#line 174 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLScan.xcc"
#if XCC__C
int
normalizeWhiteSpace(char *text, size_t size);
#endif//XCC__C

#line 179 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLScan.xcc"
#if XCC__C
int
scanElement (XMLScan rescan);

#line 183 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLScan.xcc"
int
scanTemporary (XMLScan rescan);

#line 186 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLScan.xcc"
char *
scanAtt (const char *nameAtt, XMLScan rescan);

#line 189 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLScan.xcc"
int
scanOperation (XMLScan rescan);

#line 192 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLScan.xcc"
int 
scanBasicBlock (XMLScan rescan);

#line 195 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLScan.xcc"
int 
scanLabel (XMLScan rescan);

#line 198 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLScan.xcc"
int
scanLoopScope (XMLScan rescan);

#line 201 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLScan.xcc"
int
scanProgram (XMLScan rescan);

#line 204 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLScan.xcc"
int
scanDependence (XMLScan rescan);
#endif//XCC__C

#line 1378 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLScan.xcc"
#if XCC__C
#include "XMLScan_.re.c"
#endif//#if XCC__C

#line 1522 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLScan.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1534 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLScan.xcc"
#if XCC__C
static void
XMLScan_TEST(void)
{
#include "BSL/XMLScan_.c"
}

#line 1541 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO-rvex/CDT/BSL/XMLScan.xcc"
int
main(int argc, char **argv)
{
  BSL_Test(XMLScan_TEST);
  return 0;
}
#endif


#endif//XMLScan_c_INCLUDED
