#ifndef DGraph__c_INCLUDED
#define DGraph__c_INCLUDED

#line 345 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/DGraph.xcc"
//
{
  printf("sizeof(DGraphArcCell_) = %d\n", sizeof(DGraphArcCell_));
  Except_ALWAYS(CDT_ALIGNED(sizeof(DGraphArcCell_)));
}

#line 381 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/DGraph.xcc"
//
{
  printf("sizeof(DGraphNodeCell_) = %d\n", sizeof(DGraphNodeCell_));
  Except_ALWAYS(CDT_ALIGNED(sizeof(DGraphNodeCell_)));
}

#line 421 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/DGraph.xcc"
//
{
  printf("sizeof(DGraph_) = %d\n", sizeof(DGraph_));
}

#line 694 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/DGraph.xcc"
//
{
  DGraphArc arc = NULL;
  DGraph_ dgraph_;
  DGraph dgraph = DGraph_Ctor(&dgraph_, Memory_Root, 10);
  DGraphNode node_0 = DGraph_makeNode(dgraph, sizeof(char));
  DGraphNode node_1 = DGraph_makeNode(dgraph, sizeof(char));
  DGraphNode node_2 = DGraph_makeNode(dgraph, sizeof(char));
  DGraphNode node_3 = DGraph_makeNode(dgraph, sizeof(char));
  DGraphNode node_4 = DGraph_makeNode(dgraph, sizeof(char));
  DGraphNode node_5 = DGraph_makeNode(dgraph, sizeof(char));
  DGraphNode node_6 = DGraph_makeNode(dgraph, sizeof(char));
  DGraphNode node_7 = DGraph_makeNode(dgraph, sizeof(char));
  *(char *)node_0 = 'a'; *(char *)node_1 = 'b';
  *(char *)node_2 = 'c'; *(char *)node_3 = 'd';
  *(char *)node_4 = 'e'; *(char *)node_5 = 'f';
  *(char *)node_6 = 'g'; *(char *)node_7 = 'h';
  DGraph_makeArc(dgraph, node_0, node_1, 0);	// a -> b
  DGraph_makeArc(dgraph, node_1, node_2, 0);	// b -> c
  DGraph_makeArc(dgraph, node_1, node_4, 0);	// b -> e
  DGraph_makeArc(dgraph, node_1, node_5, 0);	// b -> f
  DGraph_makeArc(dgraph, node_2, node_3, 0);	// c -> d
  DGraph_makeArc(dgraph, node_2, node_6, 0);	// c -> g
  DGraph_makeArc(dgraph, node_3, node_2, 0);	// d -> c
  DGraph_makeArc(dgraph, node_3, node_7, 0);	// d -> h
  DGraph_makeArc(dgraph, node_4, node_0, 0);	// e -> a
  DGraph_makeArc(dgraph, node_4, node_5, 0);	// e -> f
  DGraph_makeArc(dgraph, node_5, node_6, 0);	// f -> g
  DGraph_makeArc(dgraph, node_6, node_5, 0);	// g -> f
  DGraph_makeArc(dgraph, node_6, node_7, 0);	// g -> h
  DGraph_makeArc(dgraph, node_7, node_7, 0);	// h -> h
  printf("dgraph 1:\n");
  DGraph_print(dgraph);
  printf("dgraph 1 SCCs:\n");
  DGraph_visit(dgraph);
  arc = DGraph_getArc(dgraph, node_4, node_5, 0);	// e -> f
  printf("del %c -> %c\n", *(char *)DGraphArc_TAILNODE(arc), *(char *)DGraphArc_HEADNODE(arc));
  DGraph_removeArc(dgraph, arc);
  arc = DGraph_makeArc(dgraph, node_5, node_4, 0);	// f -> e
  printf("new %c -> %c\n", *(char *)DGraphArc_TAILNODE(arc), *(char *)DGraphArc_HEADNODE(arc));
  printf("dgraph 2:\n");
  DGraph_print(dgraph);
  printf("dgraph 2 SCCs:\n");
  DGraph_visit(dgraph);
  DGraph_Dtor(dgraph);
}


#endif//DGraph__c_INCLUDED
