#ifndef Dominators__c_INCLUDED
#define Dominators__c_INCLUDED

#line 176 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Dominators.xcc"
//
{
  printf("sizeof(Dominators_) = %d\n", sizeof(Dominators_));
}

#line 720 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Dominators.xcc"
//
// Test forward Dominators_makeFrontiers.
{
  DGraph_ dgraph_;
  DGraph dgraph = DGraph_Ctor(&dgraph_, Memory_Root, 20);
  // Example taken from "Computing Dominators and Dominators Frontiers" by
  // Preston Briggs and Tim Harvey, Technical Report, June 1994.
  DGraphNode node_0 = DGraph_makeNode(dgraph, 0);
  DGraphNode node_1 = DGraph_makeNode(dgraph, 0);
  DGraphNode node_2 = DGraph_makeNode(dgraph, 0);
  DGraphNode node_3 = DGraph_makeNode(dgraph, 0);
  DGraphNode node_4 = DGraph_makeNode(dgraph, 0);
  DGraphNode node_5 = DGraph_makeNode(dgraph, 0);
  DGraphNode node_6 = DGraph_makeNode(dgraph, 0);
  DGraphNode node_7 = DGraph_makeNode(dgraph, 0);
  DGraphNode node_8 = DGraph_makeNode(dgraph, 0);
  DGraphNode node_9 = DGraph_makeNode(dgraph, 0);
  DGraphNode node_10 = DGraph_makeNode(dgraph, 0);
  DGraphNode node_11 = DGraph_makeNode(dgraph, 0);
  DGraphNode node_12 = DGraph_makeNode(dgraph, 0);
  DGraphNode node_13 = DGraph_makeNode(dgraph, 0);
  DGraph_makeArc(dgraph, node_0, node_1, 0);
  DGraph_makeArc(dgraph, node_1, node_11, 0);
  DGraph_makeArc(dgraph, node_1, node_8, 0);
  DGraph_makeArc(dgraph, node_1, node_2, 0);
  DGraph_makeArc(dgraph, node_2, node_6, 0);
  DGraph_makeArc(dgraph, node_2, node_3, 0);
  DGraph_makeArc(dgraph, node_3, node_4, 0);
  DGraph_makeArc(dgraph, node_4, node_5, 0);
  DGraph_makeArc(dgraph, node_5, node_4, 0);
  DGraph_makeArc(dgraph, node_5, node_1, 0);
  DGraph_makeArc(dgraph, node_6, node_7, 0);
  DGraph_makeArc(dgraph, node_6, node_4, 0);
  DGraph_makeArc(dgraph, node_7, node_4, 0);
  DGraph_makeArc(dgraph, node_8, node_12, 0);
  DGraph_makeArc(dgraph, node_8, node_11, 0);
  DGraph_makeArc(dgraph, node_8, node_9, 0);
  DGraph_makeArc(dgraph, node_9, node_10, 0);
  DGraph_makeArc(dgraph, node_10, node_9, 0);
  DGraph_makeArc(dgraph, node_10, node_5, 0);
  DGraph_makeArc(dgraph, node_11, node_12, 0);
  DGraph_makeArc(dgraph, node_12, node_13, 0);
  DGraph_makeArc(dgraph, node_13, node_10, 0);
  printf("Dominators Forward:\n");
  {
    Dominators_ dominance[1];
    Dominators_Ctor(dominance, Memory_Root, dgraph, node_0, NULL);
    Dominators_makeFrontiers(dominance);
    Dominators_pretty(dominance, stdout);
    Dominators_Dtor(dominance);
  }
  DGraph_Dtor(dgraph);
}

#line 774 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Dominators.xcc"
//
// Test backward Dominators_makeFrontiers.
{
  DGraph_ dgraph_;
  DGraph dgraph = DGraph_Ctor(&dgraph_, Memory_Root, 20);
  // Example taken from "Computing Dominators and Dominators Frontiers" by
  // Preston Briggs and Tim Harvey, Technical Report, June 1994.
  DGraphNode node_0 = DGraph_makeNode(dgraph, 0);
  DGraphNode node_1 = DGraph_makeNode(dgraph, 0);
  DGraphNode node_2 = DGraph_makeNode(dgraph, 0);
  DGraphNode node_3 = DGraph_makeNode(dgraph, 0);
  DGraphNode node_4 = DGraph_makeNode(dgraph, 0);
  DGraphNode node_5 = DGraph_makeNode(dgraph, 0);
  DGraphNode node_6 = DGraph_makeNode(dgraph, 0);
  DGraph_makeArc(dgraph, node_1, node_6, 0);
  DGraph_makeArc(dgraph, node_1, node_2, 0);
  DGraph_makeArc(dgraph, node_2, node_4, 0);
  DGraph_makeArc(dgraph, node_2, node_3, 0);
  DGraph_makeArc(dgraph, node_3, node_5, 0);
  DGraph_makeArc(dgraph, node_4, node_5, 0);
  DGraph_makeArc(dgraph, node_5, node_6, 0);
  DGraph_makeArc(dgraph, node_6, node_0, 0);
  printf("Dominators Backward:\n");
  {
    Dominators_ dominance[1];
    Dominators_Ctor(dominance, Memory_Root, dgraph, NULL, node_0);
    Dominators_makeFrontiers(dominance);
    Dominators_pretty(dominance, stdout);
    Dominators_Dtor(dominance);
  }
  DGraph_Dtor(dgraph);
}


#endif//Dominators__c_INCLUDED
