#ifndef Hierarchy__c_INCLUDED
#define Hierarchy__c_INCLUDED

#line 59 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Hierarchy.xcc"
//
{
  printf("sizeof(HierarchyComponent_) = %d\n", sizeof(HierarchyComponent_));
}

#line 211 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Hierarchy.xcc"
//
{
  printf("sizeof(Hierarchy_) = %d\n", sizeof(Hierarchy_));
}

#line 456 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Hierarchy.xcc"
//
// Test DGraph_makeNSCC.
{
  DGraph_ dgraph[1];
  DGraph_Ctor(dgraph, Memory_Root, 100);
  {
    // Example taken from F. Bourdoncle's PhD thesis ``Semantique des langages
    // imperatifs d'ordre superieur et interpretation abstraite'', 1992, Figure
    // 3.6 at page 39.
    Hierarchy_ hierarchy[1];
    DGraphNode node_1 = DGraph_makeNode(dgraph, 0);
    DGraphNode node_2 = DGraph_makeNode(dgraph, 0);
    DGraphNode node_3 = DGraph_makeNode(dgraph, 0);
    DGraphNode node_4 = DGraph_makeNode(dgraph, 0);
    DGraph_makeArc(dgraph, node_1, node_3, 0);
    DGraph_makeArc(dgraph, node_1, node_2, 0);
    DGraph_makeArc(dgraph, node_2, node_4, 0);
    DGraph_makeArc(dgraph, node_2, node_3, 0);
    DGraph_makeArc(dgraph, node_3, node_4, 0);
    DGraph_makeArc(dgraph, node_3, node_2, 0);
    Hierarchy_Ctor(hierarchy, Memory_Root, dgraph, node_1);
    printf("Irreducible:\n");
    printf("SCC:\t");
    Hierarchy_makeSCC(hierarchy);
    Hierarchy_pretty(hierarchy, stdout, NULL);
    printf("NSCC:\t");
    Hierarchy_makeNSCC(hierarchy);
    Hierarchy_pretty(hierarchy, stdout, NULL);
    Hierarchy_Dtor(hierarchy);
  }
  DGraph_Dtor(dgraph);
}

#line 489 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Hierarchy.xcc"
//
// Test DGraph_makeNSCC.
{
  DGraph_ dgraph[1];
  DGraph_Ctor(dgraph, Memory_Root, 100);
  {
    // Example taken from F. Bourdoncle's PhD thesis ``Semantique des langages
    // imperatifs d'ordre superieur et interpretation abstraite'', 1992, Figure
    // 3.5 at page 39.
    Hierarchy_ hierarchy[1];
    DGraphNode node_1 = DGraph_makeNode(dgraph, 0);
    DGraphNode node_2 = DGraph_makeNode(dgraph, 0);
    DGraphNode node_3 = DGraph_makeNode(dgraph, 0);
    DGraphNode node_4 = DGraph_makeNode(dgraph, 0);
    DGraphNode node_5 = DGraph_makeNode(dgraph, 0);
    DGraphNode node_6 = DGraph_makeNode(dgraph, 0);
    DGraphNode node_7 = DGraph_makeNode(dgraph, 0);
    DGraphNode node_8 = DGraph_makeNode(dgraph, 0);
    DGraphNode node_9 = DGraph_makeNode(dgraph, 0);
    DGraph_makeArc(dgraph, node_1, node_5, 0);
    DGraph_makeArc(dgraph, node_1, node_4, 0);
    DGraph_makeArc(dgraph, node_1, node_2, 0);
    DGraph_makeArc(dgraph, node_2, node_4, 0);
    DGraph_makeArc(dgraph, node_2, node_3, 0);
    DGraph_makeArc(dgraph, node_4, node_4, 0);
    DGraph_makeArc(dgraph, node_5, node_6, 0);
    DGraph_makeArc(dgraph, node_6, node_7, 0);
    DGraph_makeArc(dgraph, node_7, node_9, 0);
    DGraph_makeArc(dgraph, node_7, node_8, 0);
    DGraph_makeArc(dgraph, node_7, node_6, 0);
    DGraph_makeArc(dgraph, node_8, node_8, 0);
    DGraph_makeArc(dgraph, node_9, node_7, 0);
    DGraph_makeArc(dgraph, node_9, node_5, 0);
    Hierarchy_Ctor(hierarchy, Memory_Root, dgraph, node_1);
    printf("Bourdoncle figure 3.5:\n");
    printf("SCC:\t");
    Hierarchy_makeSCC(hierarchy);
    Hierarchy_pretty(hierarchy, stdout, NULL);
    printf("NSCC:\t");
    Hierarchy_makeNSCC(hierarchy);
    Hierarchy_pretty(hierarchy, stdout, NULL);
    Hierarchy_Dtor(hierarchy);
  }
  DGraph_Dtor(dgraph);
}

#line 535 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Hierarchy.xcc"
//
// Test DGraph_makeNSCC.
{
  DGraph_ dgraph[1];
  DGraph_Ctor(dgraph, Memory_Root, 100);
  {
    // Example taken from F. Bourdoncle's paper ``Efficient Chaotic Iteration
    // Strategies with Widenings'', Figure 2.
    Hierarchy_ hierarchy[1];
    DGraphNode node_1 = DGraph_makeNode(dgraph, 0);
    DGraphNode node_2 = DGraph_makeNode(dgraph, 0);
    DGraphNode node_3 = DGraph_makeNode(dgraph, 0);
    DGraphNode node_4 = DGraph_makeNode(dgraph, 0);
    DGraph_makeArc(dgraph, node_1, node_2, 0);
    DGraph_makeArc(dgraph, node_1, node_4, 0);
    DGraph_makeArc(dgraph, node_2, node_3, 0);
    DGraph_makeArc(dgraph, node_3, node_1, 0);
    DGraph_makeArc(dgraph, node_4, node_3, 0);
    Hierarchy_Ctor(hierarchy, Memory_Root, dgraph, node_1);
    printf("Bourdoncle figure 2:\n");
    printf("SCC:\t");
    Hierarchy_makeSCC(hierarchy);
    Hierarchy_pretty(hierarchy, stdout, NULL);
    printf("NSCC:\t");
    Hierarchy_makeNSCC(hierarchy);
    Hierarchy_pretty(hierarchy, stdout, NULL);
    Hierarchy_Dtor(hierarchy);
  }
  DGraph_Dtor(dgraph);
}

#line 566 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Hierarchy.xcc"
//
// Test DGraph_makeNSCC.
{
  DGraph_ dgraph[1];
  DGraph_Ctor(dgraph, Memory_Root, 100);
  {
    Hierarchy_ hierarchy[1];
    // Example taken from F. Bourdoncle's paper ``Efficient Chaotic Iteration
    // Strategies with Widenings'', Figure 5.
    DGraphNode node_1 = DGraph_makeNode(dgraph, 0);
    DGraphNode node_2 = DGraph_makeNode(dgraph, 0);
    DGraphNode node_3 = DGraph_makeNode(dgraph, 0);
    DGraphNode node_4 = DGraph_makeNode(dgraph, 0);
    DGraphNode node_5 = DGraph_makeNode(dgraph, 0);
    DGraphNode node_6 = DGraph_makeNode(dgraph, 0);
    DGraphNode node_7 = DGraph_makeNode(dgraph, 0);
    DGraphNode node_8 = DGraph_makeNode(dgraph, 0);
    DGraphNode node_9 = DGraph_makeNode(dgraph, 0);
    DGraphNode node_10 = DGraph_makeNode(dgraph, 0);
    DGraphNode node_11 = DGraph_makeNode(dgraph, 0);
    DGraphNode node_12 = DGraph_makeNode(dgraph, 0);
    DGraphNode node_13 = DGraph_makeNode(dgraph, 0);
    DGraphNode node_14 = DGraph_makeNode(dgraph, 0);
    DGraphNode node_15 = DGraph_makeNode(dgraph, 0);
    DGraphNode node_16 = DGraph_makeNode(dgraph, 0);
    DGraph_makeArc(dgraph, node_1, node_4, 0);
    DGraph_makeArc(dgraph, node_1, node_2, 0);
    DGraph_makeArc(dgraph, node_2, node_3, 0);
    DGraph_makeArc(dgraph, node_3, node_6, 0);
    DGraph_makeArc(dgraph, node_4, node_11, 0);
    DGraph_makeArc(dgraph, node_5, node_6, 0);
    DGraph_makeArc(dgraph, node_6, node_15, 0);
    DGraph_makeArc(dgraph, node_11, node_14, 0);
    DGraph_makeArc(dgraph, node_14, node_1, 0);
    DGraph_makeArc(dgraph, node_11, node_12, 0);
    DGraph_makeArc(dgraph, node_12, node_13, 0);
    DGraph_makeArc(dgraph, node_13, node_16, 0);
    DGraph_makeArc(dgraph, node_16, node_5, 0);
    DGraph_makeArc(dgraph, node_15, node_16, 0);
    Hierarchy_Ctor(hierarchy, Memory_Root, dgraph, node_1);
    printf("Bourdoncle figure 5:\n");
    printf("SCC:\t");
    Hierarchy_makeSCC(hierarchy);
    Hierarchy_pretty(hierarchy, stdout, NULL);
    printf("NSCC:\t");
    Hierarchy_makeNSCC(hierarchy);
    Hierarchy_pretty(hierarchy, stdout, NULL);
    Hierarchy_Dtor(hierarchy);
  }
  DGraph_Dtor(dgraph);
}

#line 618 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Hierarchy.xcc"
//
// Test DGraph_makeNSCC.
{
  DGraph_ dgraph[1];
  DGraph_Ctor(dgraph, Memory_Root, 100);
  {
    Hierarchy_ hierarchy[1];
    // Example taken from G. Ramalingam's report ``On Loops, Dominators, and
    // Dominance Frontiers'', figure 1.
    DGraphNode node_1 = DGraph_makeNode(dgraph, 0);
    DGraphNode node_2 = DGraph_makeNode(dgraph, 0);
    DGraphNode node_3 = DGraph_makeNode(dgraph, 0);
    DGraphNode node_4 = DGraph_makeNode(dgraph, 0);
    DGraphNode node_5 = DGraph_makeNode(dgraph, 0);
    DGraphNode node_6 = DGraph_makeNode(dgraph, 0);
    DGraph_makeArc(dgraph, node_1, node_3, 0);
    DGraph_makeArc(dgraph, node_1, node_2, 0);
    DGraph_makeArc(dgraph, node_2, node_4, 0);
    DGraph_makeArc(dgraph, node_3, node_5, 0);
    DGraph_makeArc(dgraph, node_4, node_6, 0);
    DGraph_makeArc(dgraph, node_4, node_5, 0);
    DGraph_makeArc(dgraph, node_4, node_2, 0);
    DGraph_makeArc(dgraph, node_5, node_6, 0);
    DGraph_makeArc(dgraph, node_5, node_4, 0);
    DGraph_makeArc(dgraph, node_5, node_3, 0);
    Hierarchy_Ctor(hierarchy, Memory_Root, dgraph, node_1);
    printf("Ramalingam figure 1:\n");
    printf("SCC:\t");
    Hierarchy_makeSCC(hierarchy);
    Hierarchy_pretty(hierarchy, stdout, NULL);
    printf("NSCC:\t");
    Hierarchy_makeNSCC(hierarchy);
    Hierarchy_pretty(hierarchy, stdout, NULL);
    Hierarchy_Dtor(hierarchy);
  }
  DGraph_Dtor(dgraph);
}

#line 656 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/Hierarchy.xcc"
//
// Test DGraph_makeNSCC.
{
  DGraph_ dgraph[1];
  DGraph_Ctor(dgraph, Memory_Root, 100);
  {
    Hierarchy_ hierarchy[1];
    DGraphNode node_1 = DGraph_makeNode(dgraph, 0);
    DGraphNode node_2 = DGraph_makeNode(dgraph, 0);
    DGraphNode node_3 = DGraph_makeNode(dgraph, 0);
    DGraphNode node_4 = DGraph_makeNode(dgraph, 0);
    DGraphNode node_5 = DGraph_makeNode(dgraph, 0);
    DGraphNode node_6 = DGraph_makeNode(dgraph, 0);
    DGraphNode node_7 = DGraph_makeNode(dgraph, 0);
    DGraphNode node_8 = DGraph_makeNode(dgraph, 0);
    DGraphNode node_9 = DGraph_makeNode(dgraph, 0);
    DGraphNode node_10 = DGraph_makeNode(dgraph, 0);
    DGraph_makeArc(dgraph, node_1, node_2, 0);
    DGraph_makeArc(dgraph, node_2, node_6, 0);
    DGraph_makeArc(dgraph, node_2, node_5, 0);
    DGraph_makeArc(dgraph, node_2, node_3, 0);
    DGraph_makeArc(dgraph, node_3, node_5, 0);
    DGraph_makeArc(dgraph, node_3, node_4, 0);
    DGraph_makeArc(dgraph, node_5, node_5, 0);
    DGraph_makeArc(dgraph, node_6, node_7, 0);
    DGraph_makeArc(dgraph, node_7, node_8, 0);
    DGraph_makeArc(dgraph, node_8, node_10, 0);
    DGraph_makeArc(dgraph, node_8, node_9, 0);
    DGraph_makeArc(dgraph, node_8, node_7, 0);
    DGraph_makeArc(dgraph, node_9, node_9, 0);
    DGraph_makeArc(dgraph, node_10, node_8, 0);
    DGraph_makeArc(dgraph, node_10, node_6, 0);
    Hierarchy_Ctor(hierarchy, Memory_Root, dgraph, node_1);
    printf("Quicksort:\n");
    printf("SCC:\t");
    Hierarchy_makeSCC(hierarchy);
    Hierarchy_pretty(hierarchy, stdout, NULL);
    printf("NSCC:\t");
    Hierarchy_makeNSCC(hierarchy);
    Hierarchy_pretty(hierarchy, stdout, NULL);
    Hierarchy_Dtor(hierarchy);
  }
  DGraph_Dtor(dgraph);
}


#endif//Hierarchy__c_INCLUDED
