#ifndef LProgram_c_INCLUDED
#define LProgram_c_INCLUDED

#line 1 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
/*XCC.h
 * !!	LProgram.xcc
 *
 * Benoit Dupont de Dinechin (Benoit.Dupont-de-Dinechin@st.com).
 * Florent Blachot (Florent.Blachot@st.com)
 *
 * Copyright 2002 - 2007 STMicroelectronics.
 * Copyright 1995 - 1998 Commissariat a l'Energie Atomique.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of either (at your option): the GNU
 * General Public License (GPL) version 2; the GNU Lesser General
 * Public License (LGPL) version 2.1; any later version of these
 * licences as published by the Free Software Foundation.
 */

#line 17 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
#include "CAL/CAL_.h"

#line 35 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 83 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
LProgramVariable
LProgramVariable_Ctor(LProgramVariable this,
                      LProgramVariableType type, const char *name)
{
  *LProgramVariable__TYPE(this) = type;
  *LProgramVariable__FLAGS(this) = 0;
  *LProgramVariable__NAME(this) = name;
  *LProgramVariable__LOWER(this) = (type==LProgramVariableType_Binary)?
                                 (LProgramValue)0: LProgramValue_MIN;
  *LProgramVariable__UPPER(this) = (type==LProgramVariableType_Binary)?
                                 (LProgramValue)1: LProgramValue_MAX;
  *LProgramVariable__VALUE(this) = (LProgramValue)0;
  *LProgramVariable__WEIGHT(this) = (LProgramValue)0;
  *LProgramVariable__INDEX(this) = 0;
  return this;
}

#line 100 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
#define LProgramVariable_Dtor 0

#line 102 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
size_t
LProgramVariable_Size(LProgramVariableType type, const char *name)
{
  return sizeof(LProgramVariable_);
}

#line 129 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
static inline char
LProgramVariable_typeCPLEX(const_LProgramVariable this)
{
  LProgramVariableType type = LProgramVariable_TYPE(this);
#if CPLEX_ENABLED
  if (type == LProgramVariableType_Continuous) return CPX_CONTINUOUS;
  if (type == LProgramVariableType_Integer) return CPX_INTEGER;
  if (type == LProgramVariableType_Binary) return CPX_BINARY;
  Except_NEVER(true);
#endif//CPLEX_ENABLED
  return ' ';
}

#line 142 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
static inline int
LProgramVariable_typeGLPK(const_LProgramVariable this)
{
  LProgramVariableType type = LProgramVariable_TYPE(this);
#if GLPK_ENABLED
  if (type == LProgramVariableType_Continuous) return GLP_CV;
  if (type == LProgramVariableType_Integer) return GLP_IV;
  if (type == LProgramVariableType_Binary) return GLP_BV;
  Except_NEVER(true);
#endif//GLPK_ENABLED
  return -1;
}

#line 256 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
#if !defined(CDT_NTRACE) || defined(XCC__C)
bool
LProgramVariable_pretty(const_LProgramVariable this, FILE *file)
{
  if (file == NULL) file = stderr;
  switch (LProgramVariable_TYPE(this)) {
  case LProgramVariableType_Continuous:
    fprintf(file, "  Continuous");
    if (LProgramVariable_hasLower(this)) {
      fprintf(file, "\t%g <=", LProgramVariable_LOWER(this));
    }
    fprintf(file, "\t%s", LProgramVariable_NAME(this));
    if (LProgramVariable_hasUpper(this)) {
      fprintf(file, "\t<= %g", LProgramVariable_UPPER(this));
    }
    break;
  case LProgramVariableType_Integer:
    fprintf(file, "  Integer");
    if (LProgramVariable_hasLower(this)) {
      fprintf(file, "\t%g <=", LProgramVariable_LOWER(this));
    }
    fprintf(file, "\t%s", LProgramVariable_NAME(this));
    if (LProgramVariable_hasUpper(this)) {
      fprintf(file, "\t<= %g", LProgramVariable_UPPER(this));
    }
    break;
  case LProgramVariableType_Binary:
    fprintf(file, "  Binary \t%s", LProgramVariable_NAME(this));
    break;
  default:
    fprintf(file, "?? %s", LProgramVariable_NAME(this));
    break;
  }
  if (LProgramVariable_hasValue(this)) {
    fprintf(file, "\tValue\t%g", LProgramVariable_VALUE(this));
  }
  fprintf(file, "\n");
  return true;
}
#endif//CDT_NTRACE

#line 297 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 308 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
LProgramTerm
LProgramTerm_Ctor(LProgramTerm this,
                  LProgramVariable variable, LProgramValue factor)
{
  *LProgramTerm__VARIABLE(this) = variable;
  *LProgramTerm__FACTOR(this) = factor;
  return this;
}

#line 317 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
size_t
LProgramTerm_Size(LProgramVariable variable, LProgramValue factor)
{
  return sizeof(LProgramTerm_);
}

#line 346 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 377 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
LProgramConstraint
LProgramConstraint_Ctor(LProgramConstraint this,
                        Memory memory, int32_t count, LProgramConstraintType type,
                        LProgramValue bound, const char *name)
{
  IStack_Ctor(LProgramConstraint_TERMS(this),
              memory, sizeof(LProgramTerm_), count);
  *LProgramConstraint__TYPE(this) = type;
  *LProgramConstraint__BOUND(this) = bound;
  *LProgramConstraint__NAME(this) = name;
  return this;
}

#line 390 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
void
LProgramConstraint_Dtor(LProgramConstraint this)
{
  IStack_Dtor(LProgramConstraint_TERMS(this));
}

#line 396 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
size_t
LProgramConstraint_Size(Memory memory, int32_t count, LProgramConstraintType type,
                        LProgramValue bound, const char *name)
{
	return sizeof(LProgramConstraint_);
}

#line 414 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
const_IStack
LProgramConstraint_terms(const_LProgramConstraint this)
{
  return LProgramConstraint_TERMS(this);
}

#line 424 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
int32_t
LProgramConstraint_termCount(const_LProgramConstraint this)
{
  return LProgramConstraint_TERMCOUNT(this);
}

#line 434 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
LProgramValue
LProgramConstraint_bound(const_LProgramConstraint this)
{
  return LProgramConstraint_BOUND(this);
}

#line 444 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
LProgramConstraintType
LProgramConstraint_type(const_LProgramConstraint this)
{
  return LProgramConstraint_TYPE(this);
}

#line 450 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
static inline char
LProgramConstraint_typeCPLEX(const_LProgramConstraint this)
{
  LProgramConstraintType type = LProgramConstraint_TYPE(this);
#if CPLEX_ENABLED
  if (type == LProgramConstraintType_LE) return 'L';
  if (type == LProgramConstraintType_GE) return 'G';
  if (type == LProgramConstraintType_EQ) return 'E';
  Except_NEVER(true);
#endif//CPLEX_ENABLED
  return ' ';
}

#line 475 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
#if !defined(CDT_NTRACE) || defined(XCC__C)
bool
LProgramConstraint_pretty(const_LProgramConstraint this, FILE *file)
{
  if (file == NULL) file = stderr;
  if (LProgramConstraint_NAME(this) != NULL) {
    fprintf(file, " %s:", LProgramConstraint_NAME(this));
  }
  LProgramConstraint_FOREACH_LProgramTerm(this, term) {
    LProgramVariable variable = LProgramTerm_VARIABLE(term);
    fprintf(file, "\t%+g %s",
            LProgramTerm_FACTOR(term),
            LProgramVariable_NAME(variable));
  } LProgramConstraint_ENDEACH_LProgramTerm;
  switch (LProgramConstraint_TYPE(this)) {
  case LProgramConstraintType_LE:
    fprintf(file, "\t<=\t"); break;
  case LProgramConstraintType_GE:
    fprintf(file, "\t>=\t"); break;
  case LProgramConstraintType_EQ:
    fprintf(file, "\t=\t"); break;
  default:
    fprintf(file, "\t??\t"); break;
  }
  fprintf(file, "%g\n", LProgramConstraint_BOUND(this));
  return true;
}
#endif//CDT_NTRACE

#line 510 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
const char *
LProgramConstraint_name(const_LProgramConstraint this)
{
  return LProgramConstraint_NAME(this);
}

#line 522 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
void
LProgramConstraint_setBound(LProgramConstraint this, LProgramValue bound)
{
  *LProgramConstraint__BOUND(this) = bound;
}

#line 535 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
LProgramTerm
LProgramConstraint_accessTerm(const_LProgramConstraint this,
                              const_LProgramVariable variable)
{
  LProgramConstraint_FOREACH_LProgramTerm(this, term) {
    if (LProgramTerm_VARIABLE(term) == variable) return term;
  } LProgramConstraint_ENDEACH_LProgramTerm;
  return NULL;
}

#line 553 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
void
LProgramConstraint_addTerm(LProgramConstraint this,
                           LProgramVariable variable,
                           LProgramValue factor)
{
  LProgramTerm term = LProgramConstraint_accessTerm(this, variable);
  if (term == NULL) {
    term = (LProgramTerm)IStack_push2(LProgramConstraint_TERMS(this));
    LProgramTerm_Ctor(term, variable, factor);
  } else {
    *LProgramTerm__FACTOR(term) += factor;
  }
}

#line 567 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 582 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
#if !defined(CDT_NTRACE) || defined(XCC__C)
bool
LProgramType_pretty(LProgramType this, FILE *file)
{
  if (file == NULL) file = stderr;
  switch (this) {
  case LProgramType_Feasibility: fprintf(file, "Feasibility"); break;
  case LProgramType_Minimize: fprintf(file, "Minimize"); break;
  case LProgramType_Maximize: fprintf(file, "Maximize"); break;
  default: fprintf(file, "Type?");  
  }
  return true;
}
#endif//CDT_NTRACE

#line 613 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
#if !defined(CDT_NTRACE) || defined(XCC__C)
bool
LProgramStatus_pretty(LProgramStatus this, FILE *file)
{
  if (file == NULL) file = stderr;
  switch (this) {
  case LProgramStatus_Initial: fprintf(file, "Initial"); break;
  case LProgramStatus_Solved: fprintf(file, "Solved"); break;
  case LProgramStatus_Feasible: fprintf(file, "Feasible"); break;
  case LProgramStatus_Infeasible: fprintf(file, "Infeasible"); break;
  case LProgramStatus_TimedOut: fprintf(file, "TimedOut"); break;
  case LProgramStatus_Error: fprintf(file, "Error"); break;
  default: fprintf(file, "Status?");  
  }
  return true;
}
#endif//CDT_NTRACE

#line 666 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
LProgram
LProgram_Ctor(LProgram this,
              Memory memory, LProgramType type, double timeOut)
{
  HTable_Ctor(LProgram_VARIABLEMAP(this), memory, 512);
  IDList_Ctor(LProgram_VARIABLES(this), memory);
  IDList_Ctor(LProgram_CONSTRAINTS(this), memory);
  *LProgram__TIMEOUT(this) = timeOut;
  *LProgram__TIMESPENT(this) = 0.0;
  *LProgram__SOLUTION(this) = 0.0;
  *LProgram__TYPE(this) = type;
  *LProgram__STATUS(this) = LProgramStatus_Initial;
#if CPLEX_ENABLED
  *LProgram__CPXENV(this) = NULL;
  *LProgram__CPXLP(this) = NULL;
#else//!CPLEX_ENABLED
#if GLPK_ENABLED
  *LProgram__GLP(this) = NULL;
#endif//GLPK_ENABLED
#endif//CPLEX_ENABLED
  return this;
}

#line 689 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
void
LProgram_Dtor(LProgram this)
{
  HTable_Dtor(LProgram_VARIABLEMAP(this));
  IDList_empty(LProgram_VARIABLES(this),
               (IDListItemRelease)LProgramVariable_Dtor);
  IDList_Dtor(LProgram_VARIABLES(this));
  IDList_empty(LProgram_CONSTRAINTS(this),
               (void (*)(IDListItem))LProgramConstraint_Dtor);
  IDList_Dtor(LProgram_CONSTRAINTS(this));
}

#line 701 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
size_t
LProgram_Size(Memory memory, LProgramType type, double timeOut)
{
  return sizeof(LProgram_);
}

#line 716 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
#ifndef LProgram_POOLED
#define LProgram_POOLED 128
#endif//LProgram_POOLED

#line 720 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
LProgram
LProgram_new(Memory parent, LProgramType type, double timeOut)
{
  Memory memory = Memory_new(parent, LProgram_POOLED);
  size_t size = LProgram_Size(memory, type, timeOut);
  LProgram this = Memory_alloc(memory, size);
  return LProgram_Ctor(this, memory, type, timeOut);
}

#line 733 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
LProgram
LProgram_delete(LProgram this)
{
  if (this != NULL) {
    Memory memory = LProgram_MEMORY(this);
#ifndef CDT_NDTOR
    LProgram_Dtor(this);
    Memory_free_(memory, this);
#endif//CDT_NDTOR
    Memory_delete(memory);
  }
  return NULL;
}

#line 753 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
LProgramType
LProgram_type(const_LProgram this)
{
  return LProgram_TYPE(this);
}

#line 763 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
LProgramStatus
LProgram_status(const_LProgram this)
{
  return LProgram_STATUS(this);
}

#line 773 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
double
LProgram_timeOut(const_LProgram this)
{
  return LProgram_TIMEOUT(this);
}

#line 783 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
void
LProgram_setTimeLimit(LProgram this, double time)
{
  *LProgram__TIMEOUT(this) = time;
}

#line 793 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
double
LProgram_timeSpent(const_LProgram this)
{
  return LProgram_TIMESPENT(this);
}

#line 803 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
void
LProgram_setTimeSpent(LProgram this, double time)
{
  *LProgram__TIMESPENT(this) = time;
}

#line 815 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
const_IDList
LProgram_variables(const_LProgram this)
{
  return LProgram_VARIABLES(this);
}

#line 827 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
int32_t
LProgram_variableCount(const_LProgram this)
{
  return LProgram_VARIABLECOUNT(this);
}

#line 847 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
const_IDList
LProgram_constraints(const_LProgram this)
{
  return LProgram_CONSTRAINTS(this);
}

#line 857 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
int32_t
LProgram_constraintCount(const_LProgram this)
{
  return LProgram_CONSTRAINTCOUNT(this);
}

#line 876 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
LProgramValue
LProgram_solution(const_LProgram this)
{
  return LProgram_SOLUTION(this);
}

#line 886 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
#if !defined(CDT_NTRACE) || defined(XCC__C)
bool
LProgram_prettyObjective(const_LProgram this, FILE *file)
{
  LProgramStatus type = LProgram_TYPE(this);
  if (type == LProgramType_Feasibility) fprintf(file, "Feasibility problem\n");
  else {
    LProgramType_pretty(type, file);
    fprintf(file, "\n");
    LProgram_FOREACH_LProgramVariable(this, variable) {
      fprintf(file, "\t%+g %s",
              LProgramVariable_WEIGHT(variable),
              LProgramVariable_NAME(variable));
    } LProgram_ENDEACH_LProgramVariable;
    fprintf(file, "\n");
  }
  return true;
}
#endif//CDT_NTRACE

#line 910 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
#if !defined(CDT_NTRACE) || defined(XCC__C)
bool
LProgram_pretty(const_LProgram this, FILE *file)
{
  LProgramStatus status = LProgram_STATUS(this);
  if (file == NULL) file = stderr;
  fprintf(file, "\\ Status: ");
  LProgramStatus_pretty(status, file);
  fprintf(file, "\n");
  LProgram_prettyObjective(this, file);
  fprintf(file, "Subject To\n");
  LProgram_FOREACH_LProgramConstraint(this, constraint) {
    LProgramConstraint_pretty(constraint, file);
  } LProgram_ENDEACH_LProgramConstraint;
  fprintf(file, "Bounds\n");
  LProgram_FOREACH_LProgramVariable(this, variable) {
    LProgramVariable_pretty(variable, file);
  } LProgram_ENDEACH_LProgramVariable;
  fprintf(file, "End\n\n");
  fflush(file);
  return true;
}
#endif//CDT_NTRACE

#line 946 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
LProgramVariable
LProgram_makeVariable(LProgram this, LProgramVariableType type, const char *name)
{
  size_t size = LProgramVariable_Size(type, name);
  LProgramVariable variable = IDList_push(LProgram_VARIABLES(this), size);
  return LProgramVariable_Ctor(variable, type, name);
}

#line 967 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
LProgramConstraint
LProgram_makeConstraint(LProgram this, LProgramConstraintType type,
                             LProgramValue bound, const char *name)
{
  int32_t count = 128;
  Memory memory = LProgram_MEMORY(this);
  size_t size = LProgramConstraint_Size(memory, count, type, bound, name);
  LProgramConstraint constraint = IDList_push(LProgram_CONSTRAINTS(this), size);
  return LProgramConstraint_Ctor(constraint, memory, count, type, bound, name);
}

#line 984 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
void
LProgram_killConstraint(LProgram this, LProgramConstraint constraint)
{
#ifndef CDT_NDTOR
  IDList_remove(LProgram_CONSTRAINTS(this), constraint,
                (void (*)(IDListItem))LProgramConstraint_Dtor);
#else//!CDT_NDTOR
  IDList_remove_(LProgram_CONSTRAINTS(this), constraint);
#endif//CDT_NDTOR
}

#line 1001 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
LProgramVariable
LProgram_enterVariable(LProgram this, LProgramVariable variable, const void *key)
{
  HTable variableMap = LProgram_VARIABLEMAP(this);
  LProgramVariable *_variable = HTable_insert(variableMap, key,
                                              sizeof(LProgramVariable));
  if (_variable != NULL) {
    return *_variable = variable;
  }
  return NULL;
}

#line 1019 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
LProgramVariable
LProgram_accessVariable(LProgram this, const void *key)
{
  HTable variableMap = LProgram_VARIABLEMAP(this);
  LProgramVariable *_variable = HTable_search(variableMap, key);
  if (_variable != NULL) {
    return *_variable;
  }
  return NULL;
}

#line 1030 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1036 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
void
LProgram_open(LProgram this, const char *name)
{
#if CPLEX_ENABLED
  int cpx_error = 0;
  struct cpxenv *cpxenv = CPXopenCPLEX(&cpx_error);
  if (cpxenv != NULL) {
    struct cpxlp *cpxlp = CPXcreateprob(cpxenv, &cpx_error, name);
    if (cpxlp != NULL) {
      *LProgram__CPXENV(this) = cpxenv;
      *LProgram__CPXLP(this) = cpxlp;
    } else {
      fprintf(stderr, "CPXcreateprob failed: error %d.\n", cpx_error);
    }
  } else {
    char errorstring[CPX_STR_PARAM_MAX];
    CPXgeterrorstring(cpxenv, cpx_error, errorstring);
    fprintf(stderr, "CPXopenCPLEX failed: %s\n", errorstring);
  }
#else//!CPLEX_ENABLED
#if GLPK_ENABLED
  glp_prob *glp = glp_create_prob();
  *LProgram__GLP(this) = glp;
  glp_set_prob_name(glp, name);
  if (!CAL_TRACE) {
    int msg_lev = 0;
    //msg_lev = GLP_MSG_OFF;
    msg_lev = GLP_MSG_ERR;
    //msg_lev = GLP_MSG_ON;
    //msg_lev = GLP_MSG_ALL;
    lpx_set_int_parm(glp, LPX_K_MSGLEV, msg_lev);
  }
#endif//GLPK_ENABLED
#endif//CPLEX_ENABLED
}

#line 1076 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
void
LProgram_close(LProgram this)
{
#if CPLEX_ENABLED
  int cpx_error = 0;
  struct cpxenv *cpxenv = LProgram_CPXENV(this);
  struct cpxlp *cpxlp = LProgram_CPXLP(this);
  if (cpxlp != NULL) {
    cpx_error = CPXfreeprob(cpxenv, &cpxlp);
    if (cpx_error != 0) {
      fprintf(stderr, "CPXfreeprob failed: error %d.\n", cpx_error);
    }
  }
  if (cpxenv != NULL) {
    cpx_error = CPXcloseCPLEX (&cpxenv);
    if (cpx_error != 0) {
      char errorstring[CPX_STR_PARAM_MAX];
      CPXgeterrorstring(cpxenv, cpx_error, errorstring);
      fprintf(stderr, "CPXcloseCPLEX failed: %s", errorstring);
    }
  }
  *LProgram__CPXENV(this) = NULL;
  *LProgram__CPXLP(this) = NULL;
#else//!CPLEX_ENABLED
#if GLPK_ENABLED
  glp_prob *glp = LProgram_GLP(this);
  glp_delete_prob(glp);
  *LProgram__GLP(this) = NULL;
#endif//GLPK_ENABLED
#endif//CPLEX_ENABLED
}

#line 1112 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
bool
LProgram_enterVariables(LProgram this)
{
  bool success = false;
#if CPLEX_ENABLED
  int cpx_error = 0;
  struct cpxenv *cpxenv = LProgram_CPXENV(this);
  struct cpxlp *cpxlp = LProgram_CPXLP(this);
  int32_t variableCount = LProgram_VARIABLECOUNT(this);
  double *lower = malloc(variableCount*sizeof(double));
  double *upper = malloc(variableCount*sizeof(double));
  char *type = malloc(variableCount*sizeof(char));
  double *coeff = malloc(variableCount*sizeof(double));
  const char **name = malloc(variableCount*sizeof(char*));
  double sign = LProgram_isMaximize(this)? -1.0: 1.0;
  int32_t variable_index = 0;
  // Fill the above arrays in continuous variable_index order.
  LProgram_FOREACH_LProgramVariable(this, variable) {
    lower[variable_index] = LProgramVariable_lower(variable);
    upper[variable_index] = LProgramVariable_upper(variable);
    type[variable_index] = LProgramVariable_typeCPLEX(variable);
    coeff[variable_index] = LProgramVariable_weight(variable)*sign;
    name[variable_index] = LProgramVariable_name(variable);
    *LProgramVariable__INDEX(variable) = variable_index++;
  } LProgram_ENDEACH_LProgramVariable;
  Except_CHECK(variable_index == variableCount);
  // Enter the column into CPLEX.
  cpx_error = CPXnewcols(cpxenv, cpxlp, variableCount,
                         coeff, lower, upper, type, (char **)name);
  free(name); free(coeff); free(type); free(upper); free(lower);
  if (cpx_error != 0) {
    fprintf(stderr, "CPXnewcols failed: error %d.\n", cpx_error);
  }
  success = cpx_error == 0;
#else//!CPLEX_ENABLED
#if GLPK_ENABLED
  int32_t variableCount = LProgram_VARIABLECOUNT(this);
  int32_t variable_index = 0;
  glp_prob *glp = LProgram_GLP(this);
  if (LProgram_isMinimize(this)) {
    glp_set_obj_dir(glp, GLP_MIN);
  } else
  if (LProgram_isMaximize(this)) {
    glp_set_obj_dir(glp, GLP_MAX);
  } else Except_CHECK(false);
  glp_add_cols(glp, variableCount);
  LProgram_FOREACH_LProgramVariable(this, variable) {
    LProgramValue weight = LProgramVariable_WEIGHT(variable);
    LProgramValue lower = 0.0, upper = 0.0;
    int type = GLP_FR;
    if (LProgramVariable_hasLower(variable)) {
      lower = LProgramVariable_LOWER(variable);
      type = GLP_LO;
      if (LProgramVariable_hasUpper(variable)) {
        upper = LProgramVariable_UPPER(variable);
        type = GLP_DB;
      }
    } else {
      if (LProgramVariable_hasUpper(variable)) {
        upper = LProgramVariable_UPPER(variable);
        type = GLP_UP;
      }
    }
    if (LProgramVariable_NAME(variable) != NULL) {
      const char *name = LProgramVariable_NAME(variable);
      glp_set_col_name(glp, 1+variable_index, name);
    }
    glp_set_col_bnds(glp, 1+variable_index, type, lower, upper);
    glp_set_obj_coef(glp, 1+variable_index, weight);
    glp_set_col_kind(glp, 1+variable_index,
                     LProgramVariable_typeGLPK(variable));
    *LProgramVariable__INDEX(variable) = variable_index++;
  } LProgram_ENDEACH_LProgramVariable;
  Except_CHECK(variable_index == variableCount);
  success = true;
#endif//GLPK_ENABLED
#endif//CPLEX_ENABLED
  return success;
}

#line 1196 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
bool
LProgram_enterConstraints(LProgram this)
{
  bool success = false;
#if CPLEX_ENABLED
  int cpx_error = 0;
  struct cpxenv *cpxenv = LProgram_CPXENV(this);
  struct cpxlp *cpxlp = LProgram_CPXLP(this);
  LProgram_FOREACH_LProgramConstraint(this, constraint) {
    int zero = 0;
    double bound = LProgramConstraint_BOUND(constraint);
    char sense = LProgramConstraint_typeCPLEX(constraint);
    int termCount = LProgramConstraint_termCount(constraint);
    int *indices = malloc(termCount*sizeof(int));
    double *values = malloc(termCount*sizeof(double));
    const char *name = LProgramConstraint_name(constraint);
    int32_t term_index = 0;
    LProgramConstraint_FOREACH_LProgramTerm(constraint, term) {
      LProgramVariable variable = LProgramTerm_variable(term);
      indices[term_index] = LProgramVariable_INDEX(variable);
      values[term_index] = LProgramTerm_factor(term);
      term_index++;
    } LProgramConstraint_ENDEACH_LProgramTerm;
    Except_CHECK(term_index == termCount);
    // Enter the row into CPLEX.
    cpx_error = CPXaddrows(cpxenv, cpxlp, 0, 1, termCount,
                       &bound, &sense, &zero, indices, values, NULL, (char **)&name);
    free(values); free(indices);
    if (cpx_error != 0) {
      fprintf(stderr, "CPXaddrows failed: error %d.\n", cpx_error);
      break;
    }
  } LProgram_ENDEACH_LProgramConstraint;
  success = cpx_error == 0;
#else//!CPLEX_ENABLED
#if GLPK_ENABLED
  glp_prob *glp = LProgram_GLP(this);
  int32_t constraintCount = LProgram_constraintCount(this);
  int32_t entry_count = 0, constraint_index = 0;
  glp_add_rows(glp, constraintCount);
  LProgram_FOREACH_LProgramConstraint(this, constraint) {
    LProgramValue bound = LProgramConstraint_BOUND(constraint);
    LProgramConstraint_FOREACH_LProgramTerm(constraint, term) {
      entry_count++;
    } LProgramConstraint_ENDEACH_LProgramTerm;
    if (LProgramConstraint_NAME(constraint) != NULL) {
      const char *name = LProgramConstraint_NAME(constraint);
      glp_set_row_name(glp, 1+constraint_index, name);
    }
    if (LProgramConstraint_isLE(constraint)) {
      glp_set_row_bnds(glp, 1+constraint_index, GLP_UP, 0.0, bound);
    } else
    if (LProgramConstraint_isGE(constraint)) {
      glp_set_row_bnds(glp, 1+constraint_index, GLP_LO, bound, 0.0);
    } else
    if (LProgramConstraint_isEQ(constraint)) {
      glp_set_row_bnds(glp, 1+constraint_index, GLP_FX, bound, bound);
    } else Except_CHECK(false);
    constraint_index++;
  } LProgram_ENDEACH_LProgramConstraint;
  Except_CHECK(constraint_index == constraintCount);
  if (entry_count > 0) {
    int32_t *ia = malloc((1+entry_count)*sizeof(int32_t));
    int32_t *ja = malloc((1+entry_count)*sizeof(int32_t));
    double *ar = malloc((1+entry_count)*sizeof(double));
    int32_t entry_index = 0, constraint_index = 0;
    LProgram_FOREACH_LProgramConstraint(this, constraint) {
      LProgramConstraint_FOREACH_LProgramTerm(constraint, term) {
        LProgramVariable variable = LProgramTerm_VARIABLE(term);
        int32_t variable_index = LProgramVariable_INDEX(variable);
        LProgramValue factor = LProgramTerm_FACTOR(term);
        ia[1+entry_index] = 1+constraint_index;
        ja[1+entry_index] = 1+variable_index;
        ar[1+entry_index] = factor;
        entry_index++;
      } LProgramConstraint_ENDEACH_LProgramTerm;
      constraint_index++;
    } LProgram_ENDEACH_LProgramConstraint;
    Except_CHECK(constraint_index == constraintCount);
    Except_CHECK(entry_index == entry_count);
    glp_load_matrix(glp, entry_count, ia, ja, ar);
    free(ar); free(ja); free(ia);
  }
  success = true;
#endif//GLPK_ENABLED
#endif//CPLEX_ENABLED
  return success;
}

#line 1289 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
void
LProgram_setStatusCPLEX(LProgram this) 
{
#if CPLEX_ENABLED
  struct cpxenv *cpxenv = LProgram_CPXENV(this);
  struct cpxlp *cpxlp = LProgram_CPXLP(this);
  LProgramStatus status = LProgramStatus__;
  int lpstat = CPXgetstat(cpxenv, cpxlp);
  switch(lpstat) {
  case CPX_STAT_OPTIMAL: 
  case CPXMIP_OPTIMAL:
  case CPXMIP_OPTIMAL_TOL:
    status = LProgramStatus_Solved; break;
  case CPXMIP_TIME_LIM_FEAS:
  case CPXMIP_ABORT_FEAS:
    status = LProgramStatus_Feasible; break;
  case CPX_STAT_ABORT_TIME_LIM:
  case CPXMIP_TIME_LIM_INFEAS:
    status = LProgramStatus_TimedOut; break;
  case CPX_STAT_INFEASIBLE:
  case CPX_STAT_INForUNBD:
  case CPXMIP_INFEASIBLE:
  case CPXMIP_INForUNBD:
    status = LProgramStatus_Infeasible; break;
  default:
    status = LProgramStatus_Error; break;
  }
  *LProgram__STATUS(this) = status;
#endif//CPLEX_ENABLED
}

#line 1324 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
void
LProgram_optimize(LProgram this, bool mip)
{
  time_t start = time(NULL), stop = 0;
#if CPLEX_ENABLED
  int cpx_error = -1;
  struct cpxenv *cpxenv = LProgram_CPXENV(this);
  struct cpxlp *cpxlp = LProgram_CPXLP(this);
  double timeOut = LProgram_TIMEOUT(this);
  *LProgram__STATUS(this) = LProgramStatus_Error;
  if (timeOut > 0.0) {
    if (CPXsetdblparam(cpxenv, CPX_PARAM_TILIM, timeOut)) return;
  }
  if (   LProgram_enterVariables(this)
      && LProgram_enterConstraints(this)) {
    if (mip) {
      if (CPXchgprobtype(cpxenv, cpxlp, CPXPROB_MILP)) return;
      if (CPXsetintparam(cpxenv, CPX_PARAM_MIPEMPHASIS,
                         CPX_MIPEMPHASIS_FEASIBILITY)) return;
      cpx_error = CPXmipopt(cpxenv, cpxlp);
      LProgram_setStatusCPLEX(this);
      if (!cpx_error) {
        double solution = 0;
        int count = CPXgetnumcols(cpxenv, cpxlp);
        double *values = malloc(count*sizeof(double));
        cpx_error |= CPXgetmipobjval(cpxenv, cpxlp, &solution);
        cpx_error |= CPXgetmipx(cpxenv, cpxlp, values, 0, count-1);
        if (!cpx_error) {
          *LProgram__SOLUTION(this) = solution;
          LProgram_FOREACH_LProgramVariable(this, variable) {
            int32_t variable_index = LProgramVariable_INDEX(variable);
            LProgramVariable_setValue(variable, values[variable_index]);
          } LProgram_ENDEACH_LProgramVariable;
        }
        free(values);
      }
    } else {
      if (CPXchgprobtype(cpxenv, cpxlp, CPXPROB_LP)) return;
      cpx_error = CPXlpopt(cpxenv, cpxlp);
      LProgram_setStatusCPLEX(this);
      if (!cpx_error) {
        double solution = 0;
        int count = CPXgetnumcols(cpxenv, cpxlp);
        double *values = malloc(count*sizeof(double));
        cpx_error |= CPXgetobjval(cpxenv, cpxlp, &solution);
        cpx_error |= CPXgetx(cpxenv, cpxlp, values, 0, count-1);
        if (!cpx_error) {
          *LProgram__SOLUTION(this) = solution;
          LProgram_FOREACH_LProgramVariable(this, variable) {
            int32_t variable_index = LProgramVariable_INDEX(variable);
            LProgramVariable_setValue(variable, values[variable_index]);
          } LProgram_ENDEACH_LProgramVariable;
        }
        free(values);
      }
    }
  }
#else//!CPLEX_ENABLED
#if GLPK_ENABLED
  glp_prob *glp = LProgram_GLP(this);
  double timeOut = LProgram_TIMEOUT(this);
  if (timeOut > 0.0) {
    lpx_set_real_parm(glp, LPX_K_TMLIM, timeOut);
  }
  if (   LProgram_enterVariables(this)
      && LProgram_enterConstraints(this)) {
    //lpx_write_cpxlp(glp, "check.cpxlp");
    if (mip) {
      int lpx_exit = lpx_intopt(glp);
      if (lpx_exit == LPX_E_OK) {
        int glp_status = glp_mip_status(glp);
        *LProgram__SOLUTION(this) = glp_mip_obj_val(glp);
        LProgram_FOREACH_LProgramVariable(this, variable) {
          int32_t variable_index = LProgramVariable_INDEX(variable);
          LProgramValue value = glp_mip_col_val(glp, 1+variable_index);
          LProgramVariable_setValue(variable, value);
        } LProgram_ENDEACH_LProgramVariable;
        switch (glp_status) {
          case GLP_OPT:
            *LProgram__STATUS(this) = LProgramStatus_Solved; break;
          case GLP_FEAS:
            *LProgram__STATUS(this) = LProgramStatus_Feasible; break;
          default:
            *LProgram__STATUS(this) = LProgramStatus_Infeasible;
        }
      } else if (lpx_exit == LPX_E_TMLIM) {
        *LProgram__STATUS(this) = LProgramStatus_TimedOut;
      } else {
        *LProgram__STATUS(this) = LProgramStatus_Error;
      }
    } else {
      int glp_error = glp_simplex(glp, NULL);
      if (!glp_error) {
        int glp_status = glp_get_status(glp);
        *LProgram__SOLUTION(this) = glp_get_obj_val(glp);
        LProgram_FOREACH_LProgramVariable(this, variable) {
          int32_t variable_index = LProgramVariable_INDEX(variable);
          LProgramValue value = glp_get_col_prim(glp, 1+variable_index);
          LProgramVariable_setValue(variable, value);
        } LProgram_ENDEACH_LProgramVariable;
        switch (glp_status) {
          case GLP_OPT:
            *LProgram__STATUS(this) = LProgramStatus_Solved; break;
          case GLP_FEAS:
            *LProgram__STATUS(this) = LProgramStatus_Feasible; break;
          default:
            *LProgram__STATUS(this) = LProgramStatus_Infeasible;
        }
      } else if (glp_error == GLP_EITLIM) {
        *LProgram__STATUS(this) = LProgramStatus_TimedOut;
      } else {
        *LProgram__STATUS(this) = LProgramStatus_Error;
      }
    }
  }
#else//GLPK_ENABLED
  Except_NEVER("No linear programming solver (need CPLEX or GLPK)");
#endif//GLPK_ENABLED
#endif//CPLEX_ENABLED
  stop = time(NULL);
  //  fprintf(stdout, "CPLEX time\t%e seconds\n", difftime(stop, start));
  *LProgram__TIMESPENT(this) = difftime(stop, start);
}

#line 1448 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1482 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1494 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
#if XCC__C
static void
LProgram_TEST(void)
{
#include "CAL/LProgram_.c"
}

#line 1501 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CAL/LProgram.xcc"
int
main(int argc, char **argv)
{
  CAL_Test(LProgram_TEST);
  return 0;
}
#endif


#endif//LProgram_c_INCLUDED
