#ifndef BitSet__c_INCLUDED
#define BitSet__c_INCLUDED

#line 57 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/BitSet.xcc"
//
{
  printf("sizeof(BitSet_) = %d\n", sizeof(BitSet_));
}

#line 342 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/BitSet.xcc"
//
{
  int max = 100, i;
  BitSet_ sieve[1];
  BitSet_ primes[1];
  BitSet_Ctor(sieve, Memory_Root, max);
  BitSet_Ctor(primes, Memory_Root, max);
  for (i = 2; i < max/2; i++) BitSet_insert(sieve, (BitSetMember)i);
  for (i = max - 1; i >= max/2; i--) BitSet_insert(sieve, (BitSetMember)i);
  while (!BitSet_isEmpty(sieve)) {
    int j = BitSet_choose(sieve);
    printf("prime %d\n", j);
    BitSet_insert(primes, (BitSetMember)j);
    for (i = j + j; i < max; i += j) BitSet_remove(sieve, (BitSetMember)i);
    printf("sieve: ");
    BitSet_FOREACH(sieve, iter) {
      printf("%d ", iter);
    } BitSet_ENDEACH;
    printf("\n");
  }
  printf("primes: ");
  BitSet_FOREACH(primes, iter) {
    printf("%d ", iter);
  } BitSet_ENDEACH;
  printf("\n");
  printf("primes2: ");
  i = (BitSetMember)-1;
  while ((i = BitSet_nextMember(primes, i)) >= 0) {
    printf("%d ", i);
  }
  printf("\n");
  BitSet_Dtor(primes);
  BitSet_Dtor(sieve);
}


#endif//BitSet__c_INCLUDED
