#ifndef IBList_c_INCLUDED
#define IBList_c_INCLUDED

#line 18 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IBList.xcc"
#include "CCL/CCL_.h"

#line 23 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IBList.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 47 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IBList.xcc"
IBList
IBList_Ctor(IBList this, Memory memory, size_t itemSize, int32_t blocking)
{
  *IBList__BLOCKING(this) = blocking;
  Except_REQUIRE(blocking > 0);
  *IBList__ITEMSIZE(this) = itemSize;
  Except_REQUIRE(itemSize > 0);
  *IBList__FIRSTITEM(this) = NULL;
  *IBList__PAST(this) = NULL;
  IDList_Ctor(IBList_BLOCKLIST(this), memory);
  return this;
}

#line 60 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IBList.xcc"
void
IBList_Dtor(IBList this)
{
  IBList_empty(this, NULL);
}

#line 77 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IBList.xcc"
void
IBList_empty(IBList this, IBListItemRelease release)
{
  Memory memory = IBList_MEMORY(this);
  if (release != NULL) {
    IBListBlock IBList_FIRSTBLOCK = IBList_firstBlock(this);
    IBListBlock IBList_PAST = IBList_past(this);
    int32_t IBList_BLOCKING = IBList_blocking(this);
    size_t IBList_ITEMSIZE = IBList_itemSize(this);
    while (IBList_FIRSTBLOCK != NULL) {
      IBListBlock IBList_NEXTBLOCK = IDListItem_NEXT(IBList_FIRSTBLOCK);
      char *IBList_BASE = (char *)IBList_FIRSTBLOCK;
      char *IBList_OVERITEM = IBList_NEXTBLOCK != NULL?
                              IBList_BASE + IBList_BLOCKING*IBList_ITEMSIZE:
                              (char *)IBList_PAST;
      char *IBList_ITERITEM = IBList_BASE;
      for (; IBList_ITERITEM < IBList_OVERITEM; IBList_ITERITEM += IBList_ITEMSIZE) {
        (*release)((IBListItem)IBList_ITERITEM);
      }
      if (IBList_ITERITEM < IBList_OVERITEM) break;
      IBList_FIRSTBLOCK = IBList_NEXTBLOCK;
    }
  }
  IDList_empty(IBList_BLOCKLIST(this), NULL);
  *IBList__FIRSTITEM(this) = NULL;
  *IBList__PAST(this) = NULL;
  Except_CHECK(IBList_isEmpty(this));
}

#line 106 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IBList.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 270 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IBList.xcc"
bool
IBList_debug(IBList this)
{
  int blockCount = 0, itemCount = 0;
  int blocking = IBList_blocking(this);
  size_t itemSize = IBList_itemSize(this);
  IDList blockList = IBList_BLOCKLIST(this);
  IDList_FOREACH(blockList, void, block) {
    ++blockCount;
    if (IDList_NEXT == NULL) {
      itemCount += ((char *)IBList_past(this) - (char *)block)/itemSize;
    } else {
      itemCount += blocking;
    }
  } IDList_ENDEACH;
  Except_ALWAYS(blockCount == IDList_count(blockList));
  Except_ALWAYS(itemCount == IBList_count(this));
  return true;
}

#line 358 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IBList.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 360 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IBList.xcc"
#if XCC__C
typedef struct Pair_ { int a, b; int dummy; } Pair_, *Pair;
static void Pair_Dtor(Pair this)
{
  printf("Pair_Dtor(%d,%d)\n", this->a, this->b);
}
#endif//XCC__C

#line 424 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IBList.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 436 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IBList.xcc"
#if XCC__C
static void
IBList_TEST(void)
{
#include "CCL/IBList_.c"
}

#line 443 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IBList.xcc"
int
main(int argc, char **argv)
{
  CCL_Test(IBList_TEST);
  return 0;
}
#endif


#endif//IBList_c_INCLUDED
