#ifndef IDList_c_INCLUDED
#define IDList_c_INCLUDED

#line 21 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IDList.xcc"
#include "CCL/CCL_.h"

#line 26 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IDList.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 46 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IDList.xcc"
#define IDListItem__NEXT(this) IDListItemCell__NEXT(IDListItem_CELL(this))

#line 53 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IDList.xcc"
#define IDListItem__PREV(this) IDListItemCell__PREV(IDListItem_CELL(this))

#line 67 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IDList.xcc"
IDListItemCell
IDListItemCell_Ctor(IDListItemCell this, size_t itemSize)
{
  *IDListItemCell__NEXT(this) = NULL;
  *IDListItemCell__PREV(this) = NULL;
  return this;
}

#line 81 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IDList.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 92 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IDList.xcc"
IDList
IDList_Ctor(IDList this, Memory memory)
{
  *IDList__MEMORY(this) = memory;
  *IDList__FIRSTITEM(this) = NULL;
  *IDList__LASTITEM(this) = NULL;
  *IDList__COUNT(this) = 0;
  return this;
}

#line 102 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IDList.xcc"
void
IDList_Dtor(IDList this)
{
  IDList_empty(this, NULL);
}

#line 119 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IDList.xcc"
void
IDList_empty(IDList this, IDListItemRelease release)
{
  Memory memory = IDList_MEMORY(this);
  IDListItem firstItem = IDList_FIRSTITEM(this);
  IDListItem item = firstItem;
  if (release != NULL) {
    while (item != NULL) {
      IDListItemCell cell = IDListItem_CELL(item);
      IDListItem next = IDListItemCell_NEXT(cell);
      (*release)(item);
      Memory_free_(memory, cell);
      item = next;
    }
  } else {
    while (item != NULL) {
      IDListItemCell cell = IDListItem_CELL(item);
      IDListItem next = IDListItemCell_NEXT(cell);
      Memory_free_(memory, cell);
      item = next;
    }
  }
  *IDList__FIRSTITEM(this) = NULL;
  *IDList__LASTITEM(this) = NULL;
  *IDList__COUNT(this) = 0;
  Except_CHECK(IDList_isEmpty(this));
}

#line 151 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IDList.xcc"
bool
IDList_check(const_IDList this, const_IDListItem item)
{
  int count = IDList_COUNT(this);
  const_IDListItem firstItem = IDList_FIRSTITEM(this);
  const_IDListItem lastItem = IDList_LASTITEM(this);
  if (firstItem ==  NULL) {
    Except_ALWAYS(lastItem == NULL);
    Except_ALWAYS(item == NULL);
    Except_ALWAYS(count == 0);
  } else {
    int found = 0;
    const_IDListItem curr = firstItem, prev = NULL;
    while (curr != NULL) {
      if (curr == item) found++;
      Except_ALWAYS(IDListItem_PREV(curr) == prev);
      --count, prev = curr;
      curr = IDListItem_NEXT(curr);
    }
    if (item != NULL) Except_ALWAYS(found == 1);
    Except_ALWAYS(prev == lastItem);
    Except_ALWAYS(count == 0);
  }
  return true;
}

#line 177 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IDList.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 275 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IDList.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 328 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IDList.xcc"
IDListItem
IDList_push(IDList this, size_t itemSize)
{
  IDList_NEWCELL(this, itemSize, cell);
  return IDList_push_(this, IDListItemCell_ITEM(cell));
}

#line 373 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IDList.xcc"
IDListItem
IDList_put(IDList this, size_t itemSize)
{
  IDList_NEWCELL(this, itemSize, cell);
  return IDList_put_(this, IDListItemCell_ITEM(cell));
}

#line 424 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IDList.xcc"
IDListItem
IDList_insert(IDList this, IDListItem before, size_t itemSize)
{
  IDList_NEWCELL(this, itemSize, cell);
  return IDList_insert_(this, before, IDListItemCell_ITEM(cell));
}

#line 469 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IDList.xcc"
IDListItem
IDList_append(IDList this, IDListItem after, size_t itemSize)
{
  IDList_NEWCELL(this, itemSize, cell);
  return IDList_append_(this, after, IDListItemCell_ITEM(cell));
}

#line 513 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IDList.xcc"
void
IDList_pop(IDList this, IDListItemRelease release)
{
  Memory memory = IDList_MEMORY(this);
  IDListItem lastItem = IDList_LASTITEM(this);
  IDListItemCell last_cell = IDListItem_CELL(lastItem);
  IDList_pop_(this);
  if (release != NULL) {
    (*release)(lastItem);
  }
  Memory_free_(memory, last_cell);
}

#line 563 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IDList.xcc"
void
IDList_drop(IDList this, IDListItemRelease release)
{
  Memory memory = IDList_MEMORY(this);
  IDListItem firstItem = IDList_FIRSTITEM(this);
  IDListItemCell first_cell = IDListItem_CELL(firstItem);
  IDList_drop_(this);
  if (release != NULL) {
    (*release)(firstItem);
  }
  Memory_free_(memory, first_cell);
}

#line 576 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IDList.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 622 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IDList.xcc"
void
IDList_rotate(IDList this, int32_t index)
{
  if (IDList_count(this) <= 1) return;
  while (index > 0) {
    IDListItem item = IDList_FIRSTITEM(this);
    IDListItemCell cell = IDListItem_CELL(item);
    IDListItem lastItem = IDList_LASTITEM(this);
    IDListItemCell last_cell = IDListItem_CELL(lastItem);
    IDListItem next = IDListItemCell_NEXT(cell);
    IDListItemCell next_cell = IDListItem_CELL(next);
    *IDList__FIRSTITEM(this) = next;
    *IDListItemCell__PREV(next_cell) = NULL;
    *IDListItemCell__NEXT(last_cell) = item;
    *IDListItemCell__PREV(cell) = lastItem;
    *IDListItemCell__NEXT(cell) = NULL;
    *IDList__LASTITEM(this) = item;
    //Except_DEBUG(IDList_check(this, NULL));
    --index;
  }
  while (index < 0) {
    IDListItem item = IDList_LASTITEM(this);
    IDListItemCell cell = IDListItem_CELL(item);
    IDListItem firstItem = IDList_FIRSTITEM(this);
    IDListItemCell first_cell = IDListItem_CELL(firstItem);
    IDListItem prev = IDListItemCell_PREV(cell);
    IDListItemCell prev_cell = IDListItem_CELL(prev);
    *IDList__LASTITEM(this) = prev;
    *IDListItemCell__NEXT(prev_cell) = NULL;
    *IDListItemCell__PREV(first_cell) = item;
    *IDListItemCell__NEXT(cell) = firstItem;
    *IDListItemCell__PREV(cell) = NULL;
    *IDList__FIRSTITEM(this) = item;
    //Except_DEBUG(IDList_check(this, NULL));
    ++index;
  }
  Except_DEBUG(IDList_check(this, NULL));
}

#line 661 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IDList.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 669 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IDList.xcc"
bool
IDList_contains(const_IDList this, IDListItem item)
{
  bool result = false;
  IDList_FOREACH(this, void, iter) {
    if (iter == item) {
      result = true;
      break;
    }
  } IDList_ENDEACH;
  return result;
}

#line 691 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IDList.xcc"
IDListItem
IDList_containsSame(const_IDList this, int (*compare)(IDListItem, IDListItem),
                    IDListItem object)
{
  IDList_FOREACH(this, void, iter) {
    if (!(*compare)(iter, object)) return iter;
  } IDList_ENDEACH;
  return NULL;
}

#line 710 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IDList.xcc"
int
IDList_grep(IDList this, IDList that, bool (*keep)(IDListItem, va_list), ...)
{
  int result = 0;
  va_list va;
  va_start(va, keep);
  Except_REQUIRE(IDList_MEMORY(this) == IDList_MEMORY(that));
  IDList_FOREACH(this, void, iter) {
    if (!(*keep)(iter, va)) {
      IDList_remove_(this, iter);
      IDList_push_(that, iter);
      ++result;
    }
  } IDList_ENDEACH;
  Except_DEBUG(IDList_check(this, NULL));
  va_end(va);
  return result;
}

#line 735 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IDList.xcc"
void
IDList_transfer(IDList this, IDList that)
{
  Except_REQUIRE(IDList_MEMORY(this) == IDList_MEMORY(that));
  if (IDList_COUNT(that) == 0) {
    *IDList__FIRSTITEM(that) = IDList_FIRSTITEM(this);
    *IDList__LASTITEM(that) = IDList_LASTITEM(this);
    *IDList__COUNT(that) = IDList_COUNT(this);
  } else if (IDList_COUNT(this) != 0) {
    IDListItem this_firstItem = IDList_FIRSTITEM(this);
    IDListItem this_lastItem = IDList_LASTITEM(this);
    IDListItem that_lastItem = IDList_LASTITEM(that);
    *IDListItemCell__PREV(IDListItem_CELL(this_firstItem)) = that_lastItem;
    *IDListItemCell__NEXT(IDListItem_CELL(that_lastItem)) = this_firstItem;
    *IDList__LASTITEM(that) = this_lastItem;
    *IDList__COUNT(that) += IDList_COUNT(this);
  }
  *IDList__FIRSTITEM(this) = NULL;
  *IDList__LASTITEM(this) = NULL;
  *IDList__COUNT(this) = 0;
}

#line 757 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IDList.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 759 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IDList.xcc"
/*
 * IDList_Meld -- Auxiliary merge-sort function used by IDList_sort.
 */
static IDListItem
IDList_Meld(IDListItemCompare compare, IDListItem item1, IDListItem item2)
{
#ifdef IDList_RECURSIVE_MELD
  if (item1 == NULL) return item2;
  if (item2 == NULL) return item1;
  if ((*compare)(item1, item2) <= 0) {
    *IDListItem__NEXT(item1) = IDList_Meld(compare, IDListItem_NEXT(item1), item2);
    return item1;
  } else {
    *IDListItem__NEXT(item2) = IDList_Meld(compare, item1, IDListItem_NEXT(item2));
    return item2;
  }
#else
  IDListItemCell_ meld_cell[1];
  IDListItem meld = IDListItemCell_ITEM(meld_cell);
  while (item1 != NULL && item2 != NULL) {
    if ((*compare)(item1, item2) <= 0) {
      *IDListItem__NEXT(meld) = item1;
      item1 = IDListItem_NEXT((meld = item1));
    } else {
      *IDListItem__NEXT(meld) = item2;
      item2 = IDListItem_NEXT((meld = item2));
    }
  }
  if (item1 != NULL) {
    *IDListItem__NEXT(meld) = item1;
  }
  if (item2 != NULL) {
    *IDListItem__NEXT(meld) = item2;
  }
  return IDListItemCell_NEXT(meld_cell);
#endif
}

#line 804 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IDList.xcc"
bool
IDList_sort(IDList this, IDListItemCompare compare)
{
  int32_t count = IDList_count(this);
  if (count > 1) {
    Memory memory = IDList_MEMORY(this);
    IDListItem prev = IDList_FIRSTITEM(this);
    IDListItem item = IDListItem_NEXT(prev);
    IQueue_ iqueue[1];
    IQueue_Ctor(iqueue, memory, sizeof(IDListItem), count);
    // Split this IDList into sorted chains.
    IQueue_PUT(iqueue, IDListItem, prev);
    while (item != NULL) {
      if ((*compare)(prev, item) > 0) {
        IQueue_PUT(iqueue, IDListItem, item);
        *IDListItem__PREV(item) = NULL;
        *IDListItem__NEXT(prev) = NULL;
      }
      item = IDListItem_NEXT((prev = item));
    }
    if (IQueue_isSingle(iqueue)) {
      IQueue_Dtor(iqueue);
      return false;
    }
    // Merge the sorted chains together.
    do {
      IDListItem item1 = NULL, item2 = NULL;
      IQueue_POP(iqueue, IDListItem, item1);
      IQueue_POP(iqueue, IDListItem, item2);
      IQueue_PUT(iqueue, IDListItem, IDList_Meld(compare, item1, item2));
    } while (!IQueue_isSingle(iqueue));
    // Restore this IDList invariants.
    *IDList__FIRSTITEM(this) = IQueue_TOP(iqueue, IDListItem);
    item = IDList_firstItem(this), prev = NULL;
    while (item != NULL) {
      *IDListItem__PREV(item) = prev;
      item = IDListItem_NEXT((prev = item));
    }
    *IDList__LASTITEM(this) = prev;
    Except_DEBUG(IDList_check(this, NULL));
    IQueue_Dtor(iqueue);
    return true;
  }
  return false;
}

#line 850 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IDList.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 852 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IDList.xcc"
#if XCC__C
typedef struct Pair_ { int a, b; int dummy; } Pair_, *Pair;
static void Pair_Dtor(Pair this)
{
  printf("Pair_Dtor(%d,%d)\n", this->a, this->b);
}
#endif//XCC__C

#line 974 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IDList.xcc"
#if XCC__C
static int
int_compare(const_IDListItem a, const_IDListItem b)
{
  int inta = *(int *)a;
  int intb = *(int *)b;
  int compare = (inta > intb) - (inta < intb);
  return compare;
}

#line 984 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IDList.xcc"
static bool
not_multiple(IDListItem a, va_list va)
{
  int inta = *(int *)a;
  int factor = (int)va_arg(va, int);
  if (inta == 0 || factor == 0) return true;
  return (inta/factor)*factor != inta;
}
#endif

#line 994 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IDList.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1006 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IDList.xcc"
#if XCC__C
static void
IDList_TEST(void)
{
#include "CCL/IDList_.c"
}

#line 1013 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/IDList.xcc"
int
main(int argc, char **argv)
{
  CCL_Test(IDList_TEST);
  return 0;
}
#endif


#endif//IDList_c_INCLUDED
