#ifndef PQueue__c_INCLUDED
#define PQueue__c_INCLUDED

#line 74 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PQueue.xcc"
//
{
  printf("sizeof(PQueue_) = %d\n", sizeof(PQueue_));
}

#line 410 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PQueue.xcc"
//
{
  PQueue_ queue[1];
  PQueuePriority e1 = 1, e2 = 2, e3 = 3, e4 = 4, e5 = 5, e6 = 6, e7 = 7, e8 = 8;
  PQueue_Ctor(queue, Memory_Root, 8);
  PQueue_addEntry(queue, &e7, 7);
  printf("Inserting 7, pqueue=[ ");PQueue_pretty(queue, stdout);printf("]\n");
  PQueue_addEntry(queue, &e4, 4);
  printf("Inserting 4, pqueue=[ ");PQueue_pretty(queue, stdout);printf("]\n");
  PQueue_addEntry(queue, &e5, 5);
  printf("Inserting 5, pqueue=[ ");PQueue_pretty(queue, stdout);printf("]\n");
  PQueue_addEntry(queue, &e3, 3);
  printf("Inserting 3, pqueue=[ ");PQueue_pretty(queue, stdout);printf("]\n");
  PQueue_makeHeap(queue);
  PQueue_insert(queue, &e6, 6);
  printf("Inserting 6, pqueue=[ ");PQueue_pretty(queue, stdout);printf("]\n");
  PQueue_insert(queue, &e2, 2);
  printf("Inserting 2, pqueue=[ ");PQueue_pretty(queue, stdout);printf("]\n");
  PQueue_insert(queue, &e1, 1);
  printf("Inserting 1, pqueue=[ ");PQueue_pretty(queue, stdout);printf("]\n");
  printf("\n\n");
  while (!PQueue_isEmpty(queue)) {
    int32_t *current = (int32_t*)PQueue_extractMin(queue);
    printf("Getting %d, pqueue=[ ", *current);
    PQueue_pretty(queue, stdout);
    printf("]\n");
  }
  PQueue_Dtor(queue);
}

#line 440 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PQueue.xcc"
//
{
  int i;
  PQueue_ queue[1];
  PQueuePriority array[51];
  PQueue_Ctor(queue, Memory_Root, 50);
  for (i = 50; i > 0; i--) {
    array[i] = i;
    PQueue_insert(queue, &array[i], i);
  }
  printf("\n\nAfter inserting 50 elements: pqueue=[");
  PQueue_pretty(queue, stdout);
  printf("\n\nExtracted elements: \n");
  while (!PQueue_isEmpty(queue)) {
    int32_t *current = (int32_t*)PQueue_extractMin(queue);
    printf("%d ", *current);
  }
  printf("\n"); 
  PQueue_Dtor(queue);
}

#line 461 "/data/STLinux/boeiend/toolchain/open64/stm/6.0/stlinux23-cross-open64lao-6.0.0.B.20091214-10.src/LAO/CDT/CCL/PQueue.xcc"
//
{
  int i;
  PQueue_ queue[1];
  PQueuePriority priorities[51];
  PQueue_Ctor(queue, Memory_Root, 50);
  for (i = 50; i > 0; i--) {
    priorities[i] = i;
    PQueue_insert(queue, (PQueueMember)i, priorities[i]);
  }
  printf("\n\nAfter inserting 50 elements: pqueue=[");
  PQueue_pretty(queue, stdout);
  printf("]");
  for (i = 0; i < 25; i++) {
    PQueue_FOREACH(queue, int, member) {
      if (member == i) {
        PQueuePriority priority = PQueueEntry_PRIORITY(PQueue_ENTRY);
        *PQueueEntry__MEMBER(PQueue_ENTRY) = (PQueueMember)(priority + 25);
        PQueue_update(queue, PQueue_ENTRY, priority + 25);
        break;
      }
    } PQueue_ENDEACH;
  }
  printf("\n\nAfter updating 50 elements: pqueue=[");
  PQueue_pretty(queue, stdout);
  printf("]");
  printf("\n\nExtracted elements: \n");
  for (i = 0; i < 50; i++) {
    int32_t current = (int32_t)PQueue_extractMin(queue);
    printf("%d ", current);
  }
  printf("\n"); 
  PQueue_Dtor(queue);
}


#endif//PQueue__c_INCLUDED
