	.file	"IETree.c"
	.text
	.p2align 4,,15
.globl IETreeNode_Ctor
	.type	IETreeNode_Ctor, @function
IETreeNode_Ctor:
	pushl	%ebp
	movl	%esp, %ebp
	movl	8(%ebp), %eax
	movl	12(%ebp), %edx
	movl	$0, 8(%eax)
	movl	%edx, (%eax)
	movl	16(%ebp), %edx
	movl	$0, 12(%eax)
	movl	%edx, 4(%eax)
	popl	%ebp
	ret
	.size	IETreeNode_Ctor, .-IETreeNode_Ctor
	.p2align 4,,15
.globl IETreeNode_Dtor
	.type	IETreeNode_Dtor, @function
IETreeNode_Dtor:
	pushl	%ebp
	movl	%esp, %ebp
	movl	8(%ebp), %eax
	movl	$0, 8(%eax)
	movl	$0, 12(%eax)
	popl	%ebp
	ret
	.size	IETreeNode_Dtor, .-IETreeNode_Dtor
	.p2align 4,,15
	.type	IETree_killNode, @function
IETree_killNode:
	pushl	%ebp
	movl	%esp, %ebp
	subl	$56, %esp
	movl	%ebx, -12(%ebp)
	movl	%esi, -8(%ebp)
	movl	%edx, %esi
	movl	%edi, -4(%ebp)
	movl	8(%edx), %edx
	movl	%eax, %edi
	movl	(%eax), %eax
	call	__i686.get_pc_thunk.bx
	addl	$_GLOBAL_OFFSET_TABLE_, %ebx
	movl	12(%esi), %ecx
	testl	%edx, %edx
	movl	%eax, -28(%ebp)
	je	.L4
	movl	%edi, %eax
	movl	%ecx, -32(%ebp)
	call	IETree_killNode
	movl	-32(%ebp), %ecx
.L4:
	testl	%ecx, %ecx
	je	.L5
	movl	%ecx, %edx
	movl	%edi, %eax
	call	IETree_killNode
.L5:
	movl	%esi, (%esp)
	call	IETreeNode_Dtor@PLT
	movl	-28(%ebp), %eax
	movl	%esi, 4(%esp)
	movl	%eax, (%esp)
	call	Memory_free_@PLT
	movl	-12(%ebp), %ebx
	movl	-8(%ebp), %esi
	movl	-4(%ebp), %edi
	movl	%ebp, %esp
	popl	%ebp
	ret
	.size	IETree_killNode, .-IETree_killNode
	.p2align 4,,15
.globl IETree_Ctor
	.type	IETree_Ctor, @function
IETree_Ctor:
	pushl	%ebp
	movl	%esp, %ebp
	movl	8(%ebp), %eax
	movl	12(%ebp), %edx
	movl	$0, 4(%eax)
	movl	%edx, (%eax)
	movl	$0, 8(%eax)
	movl	$0, 12(%eax)
	movl	$0, 16(%eax)
	movl	$0, 20(%eax)
	popl	%ebp
	ret
	.size	IETree_Ctor, .-IETree_Ctor
	.p2align 4,,15
.globl IETree_Dtor
	.type	IETree_Dtor, @function
IETree_Dtor:
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%esi
	subl	$4, %esp
	movl	8(%ebp), %esi
	movl	4(%esi), %edx
	testl	%edx, %edx
	je	.L9
	movl	%esi, %eax
	call	IETree_killNode
.L9:
	movl	$0, 4(%esi)
	movl	$0, 8(%esi)
	movl	$0, 12(%esi)
	movl	$0, 16(%esi)
	movl	$0, 20(%esi)
	addl	$4, %esp
	popl	%esi
	popl	%ebp
	ret
	.size	IETree_Dtor, .-IETree_Dtor
	.p2align 4,,15
.globl IETree_splitMin
	.type	IETree_splitMin, @function
IETree_splitMin:
	pushl	%ebp
	xorl	%ecx, %ecx
	movl	%esp, %ebp
	pushl	%edi
	pushl	%esi
	pushl	%ebx
	subl	$44, %esp
	movl	12(%ebp), %eax
	call	__i686.get_pc_thunk.bx
	addl	$_GLOBAL_OFFSET_TABLE_, %ebx
	movl	8(%ebp), %edi
	movl	%eax, %esi
	jmp	.L11
	.p2align 4,,7
	.p2align 3
.L14:
	movl	%esi, %ecx
	movl	%edx, %esi
.L11:
	movl	8(%esi), %edx
	testl	%edx, %edx
	jne	.L14
	testl	%ecx, %ecx
	je	.L12
	movl	12(%esi), %edx
	movl	%edx, 8(%ecx)
.L13:
	movl	(%esi), %edx
	movl	%edx, 8(%edi)
	movl	4(%esi), %edx
	subl	$1, 20(%edi)
	movl	%edx, 12(%edi)
	movl	%eax, -28(%ebp)
	movl	%esi, (%esp)
	call	IETreeNode_Dtor@PLT
	movl	%esi, 4(%esp)
	movl	(%edi), %edx
	movl	%edx, (%esp)
	call	Memory_free_@PLT
	movl	-28(%ebp), %eax
	addl	$44, %esp
	popl	%ebx
	popl	%esi
	popl	%edi
	popl	%ebp
	ret
	.p2align 4,,7
	.p2align 3
.L12:
	movl	12(%esi), %eax
	jmp	.L13
	.size	IETree_splitMin, .-IETree_splitMin
	.p2align 4,,15
.globl IETree_splitMax
	.type	IETree_splitMax, @function
IETree_splitMax:
	pushl	%ebp
	xorl	%ecx, %ecx
	movl	%esp, %ebp
	pushl	%edi
	pushl	%esi
	pushl	%ebx
	subl	$44, %esp
	movl	12(%ebp), %eax
	call	__i686.get_pc_thunk.bx
	addl	$_GLOBAL_OFFSET_TABLE_, %ebx
	movl	8(%ebp), %edi
	movl	%eax, %esi
	jmp	.L16
	.p2align 4,,7
	.p2align 3
.L19:
	movl	%esi, %ecx
	movl	%edx, %esi
.L16:
	movl	12(%esi), %edx
	testl	%edx, %edx
	jne	.L19
	testl	%ecx, %ecx
	je	.L17
	movl	8(%esi), %edx
	movl	%edx, 12(%ecx)
.L18:
	movl	(%esi), %edx
	movl	%edx, 8(%edi)
	movl	4(%esi), %edx
	subl	$1, 20(%edi)
	movl	%edx, 12(%edi)
	movl	%eax, -28(%ebp)
	movl	%esi, (%esp)
	call	IETreeNode_Dtor@PLT
	movl	%esi, 4(%esp)
	movl	(%edi), %edx
	movl	%edx, (%esp)
	call	Memory_free_@PLT
	movl	-28(%ebp), %eax
	addl	$44, %esp
	popl	%ebx
	popl	%esi
	popl	%edi
	popl	%ebp
	ret
	.p2align 4,,7
	.p2align 3
.L17:
	movl	8(%esi), %eax
	jmp	.L18
	.size	IETree_splitMax, .-IETree_splitMax
	.p2align 4,,15
.globl IETree_mergeNode
	.type	IETree_mergeNode, @function
IETree_mergeNode:
	pushl	%ebp
	movl	%esp, %ebp
	subl	$56, %esp
	movl	%esi, -8(%ebp)
	movl	12(%ebp), %esi
	movl	%ebx, -12(%ebp)
	movl	%edi, -4(%ebp)
	movl	8(%ebp), %edi
	call	__i686.get_pc_thunk.bx
	addl	$_GLOBAL_OFFSET_TABLE_, %ebx
	movl	8(%esi), %edx
	movl	12(%esi), %eax
	testl	%edx, %edx
	je	.L24
	testl	%eax, %eax
	je	.L25
	movl	%edx, 4(%esp)
	movl	%edi, (%esp)
	call	IETree_splitMax@PLT
	movl	8(%edi), %edx
	movl	%edx, (%esi)
	movl	12(%edi), %edx
	movl	%eax, 8(%esi)
	movl	%esi, %eax
	movl	%edx, 4(%esi)
.L22:
	movl	-12(%ebp), %ebx
	movl	-8(%ebp), %esi
	movl	-4(%ebp), %edi
	movl	%ebp, %esp
	popl	%ebp
	ret
	.p2align 4,,7
	.p2align 3
.L25:
	subl	$1, 20(%edi)
	movl	%edx, -28(%ebp)
	movl	%esi, (%esp)
	call	IETreeNode_Dtor@PLT
	movl	%esi, 4(%esp)
	movl	(%edi), %eax
	movl	%eax, (%esp)
	call	Memory_free_@PLT
	movl	-28(%ebp), %edx
	movl	%edx, %eax
	jmp	.L22
	.p2align 4,,7
	.p2align 3
.L24:
	subl	$1, 20(%edi)
	movl	%eax, -28(%ebp)
	movl	%esi, (%esp)
	call	IETreeNode_Dtor@PLT
	movl	%esi, 4(%esp)
	movl	(%edi), %edx
	movl	%edx, (%esp)
	call	Memory_free_@PLT
	movl	-28(%ebp), %eax
	jmp	.L22
	.size	IETree_mergeNode, .-IETree_mergeNode
	.p2align 4,,15
.globl IETree_choose
	.type	IETree_choose, @function
IETree_choose:
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%edi
	pushl	%esi
	xorl	%esi, %esi
	pushl	%ebx
	subl	$44, %esp
	movl	8(%ebp), %edx
	call	__i686.get_pc_thunk.bx
	addl	$_GLOBAL_OFFSET_TABLE_, %ebx
	movl	4(%edx), %eax
	jmp	.L27
	.p2align 4,,7
	.p2align 3
.L31:
	movl	%eax, %esi
	movl	%ecx, %eax
.L27:
	movl	8(%eax), %ecx
	testl	%ecx, %ecx
	jne	.L31
	movl	(%eax), %edi
	cmpl	4(%eax), %edi
	je	.L32
	leal	1(%edi), %edx
	movl	%edx, (%eax)
.L30:
	addl	$44, %esp
	movl	%edi, %eax
	popl	%ebx
	popl	%esi
	popl	%edi
	popl	%ebp
	ret
	.p2align 4,,7
	.p2align 3
.L32:
	testl	%esi, %esi
	je	.L33
	movl	%eax, 4(%esp)
	movl	%edx, (%esp)
	call	IETree_mergeNode@PLT
	movl	%eax, 8(%esi)
	addl	$44, %esp
	movl	%edi, %eax
	popl	%ebx
	popl	%esi
	popl	%edi
	popl	%ebp
	ret
.L33:
	movl	%edx, (%esp)
	movl	%edx, -28(%ebp)
	movl	%eax, 4(%esp)
	call	IETree_mergeNode@PLT
	movl	-28(%ebp), %edx
	movl	%eax, 4(%edx)
	jmp	.L30
	.size	IETree_choose, .-IETree_choose
	.p2align 4,,15
.globl IETree_contains
	.type	IETree_contains, @function
IETree_contains:
	pushl	%ebp
	movl	%esp, %ebp
	movl	8(%ebp), %eax
	popl	%ebp
	movl	4(%eax), %eax
	testl	%eax, %eax
	setne	%al
	ret
	.size	IETree_contains, .-IETree_contains
	.p2align 4,,15
.globl IETree_insert
	.type	IETree_insert, @function
IETree_insert:
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%edi
	pushl	%esi
	pushl	%ebx
	subl	$44, %esp
	movl	8(%ebp), %eax
	call	__i686.get_pc_thunk.bx
	addl	$_GLOBAL_OFFSET_TABLE_, %ebx
	movl	12(%ebp), %edi
	movl	4(%eax), %esi
	testl	%esi, %esi
	je	.L56
	movl	(%esi), %eax
	leal	-1(%edi), %edx
	movl	%edx, -28(%ebp)
	leal	1(%edi), %ecx
	movl	4(%esi), %edx
	cmpl	%eax, %edi
	jge	.L39
	.p2align 4,,7
	.p2align 3
.L59:
	cmpl	%eax, %ecx
	je	.L57
	movl	8(%esi), %eax
	testl	%eax, %eax
	je	.L58
.L53:
	movl	%eax, %esi
	movl	(%esi), %eax
	movl	4(%esi), %edx
	cmpl	%eax, %edi
	jl	.L59
.L39:
	cmpl	%edx, %edi
	jle	.L49
	cmpl	%edx, -28(%ebp)
	je	.L60
	movl	12(%esi), %eax
	testl	%eax, %eax
	jne	.L53
	movl	8(%ebp), %edx
	movl	$16, 4(%esp)
	movl	(%edx), %eax
	movl	%eax, (%esp)
	call	Memory_alloc_@PLT
	movl	%edi, 8(%esp)
	movl	%edi, 4(%esp)
	movl	%eax, (%esp)
	movl	%eax, -32(%ebp)
	call	IETreeNode_Ctor@PLT
	movl	8(%ebp), %eax
	addl	$1, 20(%eax)
	movl	-32(%ebp), %edx
	movl	%edx, 12(%esi)
	movl	$1, %edx
	addl	$44, %esp
	movl	%edx, %eax
	popl	%ebx
	popl	%esi
	popl	%edi
	popl	%ebp
	ret
	.p2align 4,,7
	.p2align 3
.L58:
	movl	8(%ebp), %edx
	movl	$16, 4(%esp)
	movl	(%edx), %eax
	movl	%eax, (%esp)
	call	Memory_alloc_@PLT
	movl	%edi, 8(%esp)
	movl	%edi, 4(%esp)
	movl	%eax, (%esp)
	movl	%eax, -32(%ebp)
	call	IETreeNode_Ctor@PLT
	movl	8(%ebp), %eax
	addl	$1, 20(%eax)
	movl	-32(%ebp), %edx
	movl	%edx, 8(%esi)
	movl	$1, %edx
.L38:
	addl	$44, %esp
	movl	%edx, %eax
	popl	%ebx
	popl	%esi
	popl	%edi
	popl	%ebp
	ret
	.p2align 4,,7
	.p2align 3
.L57:
	movl	8(%esi), %ecx
	movl	$1, %edx
	movl	%edi, (%esi)
	testl	%ecx, %ecx
	movl	%ecx, %eax
	jne	.L41
	jmp	.L38
	.p2align 4,,7
	.p2align 3
.L46:
	movl	%edx, %eax
.L41:
	movl	12(%eax), %edx
	testl	%edx, %edx
	jne	.L46
	subl	$1, %edi
	movl	$1, %edx
	cmpl	%edi, 4(%eax)
	jne	.L38
	movl	(%eax), %eax
	movl	%eax, (%esi)
	movl	8(%ebp), %eax
	movb	%dl, -32(%ebp)
	movl	%ecx, 4(%esp)
	movl	%eax, (%esp)
	call	IETree_splitMax@PLT
	movl	%eax, 8(%esi)
	movzbl	-32(%ebp), %edx
	jmp	.L38
	.p2align 4,,7
	.p2align 3
.L49:
	xorl	%edx, %edx
	addl	$44, %esp
	movl	%edx, %eax
	popl	%ebx
	popl	%esi
	popl	%edi
	popl	%ebp
	ret
	.p2align 4,,7
	.p2align 3
.L60:
	movl	12(%esi), %ecx
	movl	$1, %edx
	movl	%edi, 4(%esi)
	testl	%ecx, %ecx
	movl	%ecx, %eax
	jne	.L44
	jmp	.L38
	.p2align 4,,7
	.p2align 3
.L51:
	movl	%edx, %eax
.L44:
	movl	8(%eax), %edx
	testl	%edx, %edx
	jne	.L51
	addl	$1, %edi
	movl	$1, %edx
	cmpl	%edi, (%eax)
	jne	.L38
	movl	4(%eax), %eax
	movl	%eax, 4(%esi)
	movl	8(%ebp), %eax
	movb	%dl, -32(%ebp)
	movl	%ecx, 4(%esp)
	movl	%eax, (%esp)
	call	IETree_splitMin@PLT
	movl	%eax, 12(%esi)
	movzbl	-32(%ebp), %edx
	jmp	.L38
.L56:
	movl	$16, 4(%esp)
	movl	(%eax), %eax
	movl	%eax, (%esp)
	call	Memory_alloc_@PLT
	movl	%edi, 8(%esp)
	movl	%edi, 4(%esp)
	movl	%eax, %esi
	movl	%eax, (%esp)
	call	IETreeNode_Ctor@PLT
	movl	8(%ebp), %eax
	movl	$1, %edx
	addl	$1, 20(%eax)
	movl	%esi, 4(%eax)
	jmp	.L38
	.size	IETree_insert, .-IETree_insert
	.p2align 4,,15
.globl IETree_remove
	.type	IETree_remove, @function
IETree_remove:
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%edi
	pushl	%esi
	pushl	%ebx
	subl	$44, %esp
	movl	8(%ebp), %eax
	call	__i686.get_pc_thunk.bx
	addl	$_GLOBAL_OFFSET_TABLE_, %ebx
	movl	12(%ebp), %edi
	movl	4(%eax), %esi
	testl	%esi, %esi
	je	.L73
	xorl	%ecx, %ecx
	jmp	.L72
	.p2align 4,,7
	.p2align 3
.L75:
	movl	8(%esi), %eax
	testl	%eax, %eax
	je	.L62
.L74:
	movl	%esi, %ecx
	movl	%eax, %esi
.L72:
	movl	(%esi), %eax
	movl	4(%esi), %edx
	cmpl	%edi, %eax
	jg	.L75
	cmpl	%edi, %edx
	jge	.L65
	movl	12(%esi), %eax
	testl	%eax, %eax
	jne	.L74
.L62:
	addl	$44, %esp
	popl	%ebx
	popl	%esi
	popl	%edi
	popl	%ebp
	ret
	.p2align 4,,7
	.p2align 3
.L65:
	cmpl	%edx, %eax
	je	.L76
	cmpl	%eax, %edi
	je	.L77
	cmpl	%edx, %edi
	.p2align 4,,5
	jne	.L71
	subl	$1, %edi
	movl	$1, %eax
	movl	%edi, 4(%esi)
	jmp	.L62
.L71:
	movl	8(%ebp), %ecx
	movl	$16, 4(%esp)
	movl	(%ecx), %eax
	movl	%edx, -28(%ebp)
	movl	%eax, (%esp)
	call	Memory_alloc_@PLT
	movl	-28(%ebp), %edx
	movl	%edx, 8(%esp)
	movl	%eax, %ecx
	leal	1(%edi), %eax
	subl	$1, %edi
	movl	%ecx, (%esp)
	movl	%ecx, -28(%ebp)
	movl	%eax, 4(%esp)
	call	IETreeNode_Ctor@PLT
	movl	8(%ebp), %eax
	addl	$1, 20(%eax)
	movl	12(%esi), %eax
	movl	-28(%ebp), %ecx
	movl	%eax, 12(%ecx)
	movl	$1, %eax
	movl	%edi, 4(%esi)
	movl	%ecx, 12(%esi)
	jmp	.L62
.L76:
	testl	%ecx, %ecx
	je	.L78
	cmpl	%esi, 8(%ecx)
	je	.L79
	cmpl	%esi, 12(%ecx)
	.p2align 4,,3
	jne	.L69
	movl	8(%ebp), %edx
	movl	%ecx, -28(%ebp)
	movl	%esi, 4(%esp)
	movl	%edx, (%esp)
	call	IETree_mergeNode@PLT
	movl	-28(%ebp), %ecx
	movl	%eax, 12(%ecx)
	movl	$1, %eax
	jmp	.L62
.L77:
	addl	$1, %edi
	movl	$1, %eax
	movl	%edi, (%esi)
	jmp	.L62
.L73:
	xorl	%eax, %eax
	jmp	.L62
.L79:
	movl	8(%ebp), %eax
	movl	%ecx, -28(%ebp)
	movl	%esi, 4(%esp)
	movl	%eax, (%esp)
	call	IETree_mergeNode@PLT
	movl	-28(%ebp), %ecx
	movl	%eax, 8(%ecx)
	movl	$1, %eax
	jmp	.L62
.L78:
	movl	8(%ebp), %edx
	movl	%esi, 4(%esp)
	movl	%edx, (%esp)
	call	IETree_mergeNode@PLT
	movl	8(%ebp), %ecx
	movl	%eax, 4(%ecx)
	movl	$1, %eax
	jmp	.L62
.L69:
	call	abort@PLT
	.size	IETree_remove, .-IETree_remove
	.comm	escape,4,4
	.section	.text.__i686.get_pc_thunk.bx,"axG",@progbits,__i686.get_pc_thunk.bx,comdat
.globl __i686.get_pc_thunk.bx
	.hidden	__i686.get_pc_thunk.bx
	.type	__i686.get_pc_thunk.bx, @function
__i686.get_pc_thunk.bx:
	movl	(%esp), %ebx
	ret
	.ident	"GCC: (SUSE Linux) 4.5.1 20101208 [gcc-4_5-branch revision 167585]"
	.section	.comment.SUSE.OPTs,"MS",@progbits,1
	.string	"OspWg"
	.section	.note.GNU-stack,"",@progbits
