#ifndef AIR__h_INCLUDED
#define AIR__h_INCLUDED

//
#include "AIR/AIR.h"

/*
 * Include all the shared AIR headers.
 */
#include "AIR/Label_.h"
#include "AIR/Symbol_.h"
#include "AIR/Constant_.h"
#include "AIR/Literal_.h"
#include "AIR/Instruction_.h"
#include "AIR/Pipeline_.h"
#include "AIR/Scoreboard_.h"
#include "AIR/NativeBlock_.h"
#include "AIR/NativeStream_.h"
#include "AIR/InterBlock_.h"
#include "AIR/Trampoline_.h"

/*
  AIR_Test -- Setup and execute a AIR test.
 */
void
AIR_Test(void (*test)(void));


#endif//AIR__h_INCLUDED
