#ifndef Constant_c_INCLUDED
#define Constant_c_INCLUDED

#line 15 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Constant.xcc"
#include "AIR/AIR_.h"

#line 20 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Constant.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 81 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Constant.xcc"
Constant
Constant_Ctor(Constant this, ConstantType type, void *handle,
              ImmediateValue value, ImmediateValue offset)
{
  ImmediateConstant_Ctor(Constant____(this), value);
  *Constant__OFFSET(this) = offset;
  *Constant__HANDLE(this) = handle;
  *Constant__NEXT(this) = NULL;
  *Constant__TYPE(this) = type;
  return this;
}

#line 93 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Constant.xcc"
void
Constant_Dtor(Constant this)
{
  *Constant__OFFSET(this) = 0;
  *Constant__TYPE(this) = ConstantType__;
}

#line 100 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Constant.xcc"
size_t
Constant_Size(ConstantType type, void *handle,
              ImmediateValue value, ImmediateValue offset)
{
	return sizeof(Constant_);
}

#line 112 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Constant.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 181 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Constant.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 192 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Constant.xcc"
ConstantTable
ConstantTable_Ctor(ConstantTable this,
                   Memory memory, int32_t estimate)
{
  HTable_Ctor(ConstantTable_HTABLE(this), memory, estimate);
  return this;
}

#line 200 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Constant.xcc"
void
ConstantTable_Dtor(ConstantTable this)
{
  HTable_Dtor(ConstantTable_HTABLE(this));
}

#line 267 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Constant.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 280 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Constant.xcc"
ConstantList
ConstantList_Ctor(ConstantList this,
                  Memory memory) {
  *ConstantList__MEMORY(this) = memory;
  *ConstantList__FIRST(this) = NULL;
  *ConstantList__LAST(this) = NULL;
  *ConstantList__COUNT(this) = 0;
  return this;
}

#line 290 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Constant.xcc"
void
ConstantList_Dtor(ConstantList this)
{
  Memory memory = ConstantList_MEMORY(this);
  Constant first = ConstantList_FIRST(this);
  Constant item = first;
  while (item != NULL) {
    Constant next = Constant_NEXT(item);
    Memory_free_(memory, item);
    item = next;
  }
  *ConstantList__FIRST(this) = NULL;
  *ConstantList__LAST(this) = NULL;
  *ConstantList__COUNT(this) = 0;
}

#line 311 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Constant.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 401 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Constant.xcc"
Constant
ConstantList_push(ConstantList this, ConstantType type, void *handle,
                  ImmediateValue value, ImmediateValue offset)
{
  Memory memory = ConstantList_MEMORY(this);
  size_t size = Constant_Size(type, handle, value, offset);
  Constant constant = Memory_alloc(memory, size);
  Constant_Ctor(constant, type, handle, value, offset);
  return ConstantList_itemPush(this, constant);
}

#line 429 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Constant.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 441 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Constant.xcc"
#if XCC__C
static void
Constant_TEST(void)
{
#include "AIR/Constant_.c"
}

#line 448 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Constant.xcc"
int
main(int argc, char **argv)
{
  AIR_Test(Constant_TEST);
  return 0;
}
#endif


#endif//Constant_c_INCLUDED
