#ifndef Symbol_c_INCLUDED
#define Symbol_c_INCLUDED

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Symbol.xcc"
#include "AIR/AIR_.h"

#line 26 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Symbol.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 46 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Symbol.xcc"
#ifndef ECL_NTRACE
ETableEntry_ SymbolClassEntries[] = {
  ETableENTRY(SymbolClass, _UNDEF),
  ETableENTRY(SymbolClass, VAR),
  ETableENTRY(SymbolClass, FUNC),
  ETableENTRY(SymbolClass, CONST),
  ETableENTRY(SymbolClass, PREG),
  ETableENTRY(SymbolClass, BLOCK),
  ETableENTRY_NULL
};
ETable_ SymbolClass_Table[1];
#endif//ECL_NTRACE

#line 83 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Symbol.xcc"
#ifndef ECL_NTRACE
ETableEntry_ SymbolStoreEntries[] = {
  ETableENTRY(SymbolStore, _UNDEF),
  ETableENTRY(SymbolStore, AUTO),
  ETableENTRY(SymbolStore, FORMAL),
  ETableENTRY(SymbolStore, FORMAL_REF),
  ETableENTRY(SymbolStore, PSTATIC),
  ETableENTRY(SymbolStore, FSTATIC),
  ETableENTRY(SymbolStore, COMMON),
  ETableENTRY(SymbolStore, EXTERN),
  ETableENTRY(SymbolStore, UGLOBAL),
  ETableENTRY(SymbolStore, DGLOBAL),
  ETableENTRY(SymbolStore, TEXT),
  ETableENTRY(SymbolStore, REG),
  ETableENTRY_NULL
};
ETable_ SymbolStore_Table[1];
#endif//ECL_NTRACE

#line 126 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Symbol.xcc"
#ifndef ECL_NTRACE
ETableEntry_ SymbolExportEntries[] = {
  ETableENTRY(SymbolExport, _UNDEF),
  ETableENTRY(SymbolExport, LOCAL),
  ETableENTRY(SymbolExport, LOCAL_INTERNAL),
  ETableENTRY(SymbolExport, GLOBAL_INTERNAL),
  ETableENTRY(SymbolExport, GLOBAL_HIDDEN),
  ETableENTRY(SymbolExport, GLOBAL_PROTECTED),
  ETableENTRY(SymbolExport, GLOBAL_PREEMPTIBLE),
  ETableENTRY_NULL
};
ETable_ SymbolExport_Table[1];
#endif//ECL_NTRACE

#line 148 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Symbol.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 197 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Symbol.xcc"
Symbol
Symbol_Ctor(Symbol this,
            uint32_t index, String name)
{
  Indexed_Ctor(Symbol____(this), Symbol_Factory);
  *Symbol__INDEX(this) = index;
  *Symbol__VALUE(this) = 0;
  *Symbol__NAME(this) = name;
  *Symbol__POINTER(this) = NULL;
  *Symbol__CLASS(this) = SymbolClass__UNDEF;
  *Symbol__STORE(this) = SymbolStore__UNDEF;
  *Symbol__EXPORT(this) = SymbolExport__UNDEF;
  *Symbol__FLAGS(this) = 0;
  *Symbol__SIZE(this) = 0;
  *Symbol__BASEOFFSET(this) = 0;
  *Symbol__BASEINDEX(this) = Symbol_INDEX(this);
  *Symbol__NATIVETYPE(this) = NativeType__UNDEF;
  return this;
}

#line 217 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Symbol.xcc"
size_t
Symbol_Size(uint32_t index, String name)
{
  return sizeof(Symbol_);
}

#line 228 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Symbol.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 521 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Symbol.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 537 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Symbol.xcc"
SymbolTable
SymbolTable_Ctor(SymbolTable this,
                 Memory memory, int32_t estimate)
{
  StringStore_Ctor(SymbolTable_STRINGS(this), memory);
  HTable_Ctor(SymbolTable_HTABLE(this), memory, estimate);
  *SymbolTable__INDEXGEN(this) = 0;
  *SymbolTable__PREFIX(this) = "";
  return this;
}

#line 548 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Symbol.xcc"
void
SymbolTable_Dtor(SymbolTable this)
{
  StringStore_Dtor(SymbolTable_STRINGS(this));
  HTable_Dtor(SymbolTable_HTABLE(this));
}

#line 555 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Symbol.xcc"
size_t
SymbolTable_Size(Memory memory, int32_t estimate)
{
  return sizeof(SymbolTable_);
}

#line 570 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Symbol.xcc"
#ifndef SymbolTable_POOLED
#define SymbolTable_POOLED 128
#endif//SymbolTable_POOLED

#line 574 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Symbol.xcc"
SymbolTable
SymbolTable_new(Memory parent, int32_t estimate)
{
  Memory memory = Memory_new(parent, SymbolTable_POOLED);
  size_t size = SymbolTable_Size(memory, estimate);
  SymbolTable this = Memory_alloc(memory, size);
  return SymbolTable_Ctor(this, memory, estimate);
}

#line 587 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Symbol.xcc"
SymbolTable
SymbolTable_delete(SymbolTable this)
{
  if (this != NULL) {
    Memory memory = SymbolTable_MEMORY(this);
#ifndef ECL_NDTOR
    SymbolTable_Dtor(this);
    Memory_free_(memory, this);
#endif//ECL_NDTOR
    Memory_delete(memory);
  }
  return NULL;
}

#line 647 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Symbol.xcc"
/*
 * SymbolTable_FOREACH_Symbol --	Iterate over this SymbolTable.
 */
#define SymbolTable_FOREACH_Symbol(this, symbol) { \
  HTable SymbolTable_HTABLE = SymbolTable_htable(this); \
  HTable_FOREACH(SymbolTable_HTABLE, HTable_KEY, Symbol_, symbol) {
#define SymbolTable_ENDEACH_Symbol \
  } HTable_ENDEACH \
}

#line 675 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Symbol.xcc"
Symbol
SymbolTable_insert(SymbolTable this, uint32_t index, const char *name)
{
  HTableKey key = (HTableKey)index;
  size_t size = Symbol_Size(index, name);
  HTable htable = SymbolTable_HTABLE(this);
  Symbol symbol = HTable_insert(htable, key, size);
  if (symbol != NULL) {
    StringStore strings = SymbolTable_STRINGS(this);
    String nameString = StringStore_S(strings, name);
    Symbol_Ctor(symbol, index, nameString);
  }
  return symbol;
}

#line 696 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Symbol.xcc"
Symbol
SymbolTable_lookup(SymbolTable this, uint32_t index, const char *name)
{
  HTableKey key = (HTableKey)index;
  HTable htable = SymbolTable_HTABLE(this);
  int32_t count = HTable_count(htable);
  size_t size = Symbol_Size(index, name);
  Symbol symbol = HTable_lookup_(htable, key, size);
  if (count != HTable_count(htable)) {
    StringStore strings = SymbolTable_STRINGS(this);
    String nameString = StringStore_S(strings, name);
    Symbol_Ctor(symbol, index, nameString);
  }
  return symbol;
}

#line 721 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Symbol.xcc"
Symbol
SymbolTable_makeSymbol(SymbolTable this, const char *name)
{
  int32_t index = (*SymbolTable__INDEXGEN(this) -= 256);
  return SymbolTable_insert(this, index, name);
}

#line 761 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Symbol.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 769 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Symbol.xcc"
IndexedFactory_ Symbol_Factory[1];

#line 771 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Symbol.xcc"
void
Symbol_INIT(void)
{
  IndexedFactory_Ctor(Symbol_Factory);
#ifndef ECL_NTRACE
  ETable_Ctor(SymbolClass_Table, Memory_Root, SymbolClassEntries);
  ETable_Ctor(SymbolStore_Table, Memory_Root, SymbolStoreEntries);
  ETable_Ctor(SymbolExport_Table, Memory_Root, SymbolExportEntries);
#endif//ECL_NTRACE
}

#line 792 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Symbol.xcc"
#ifndef ECL_NTRACE
void
Symbol_FINI(void)
{
  ETable_Dtor(SymbolExport_Table);
  ETable_Dtor(SymbolStore_Table);
  ETable_Dtor(SymbolClass_Table);
}
#endif//ECL_NTRACE

#line 802 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Symbol.xcc"
#if XCC__C
static void
Symbol_TEST(void)
{
#include "AIR/Symbol_.c"
}

#line 809 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/AIR/Symbol.xcc"
int
main(int argc, char **argv)
{
  AIR_Test(Symbol_TEST);
  return 0;
}
#endif


#endif//Symbol_c_INCLUDED
