#ifndef Pipeliner_c_INCLUDED
#define Pipeliner_c_INCLUDED

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Pipeliner.xcc"
#include "CGO/CGO_.h"

#line 21 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Pipeliner.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 32 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Pipeliner.xcc"
Pipeliner
Pipeliner_Ctor(Pipeliner this,
               Memory memory, CodeRegion codeRegion)
{
  *Pipeliner__MEMORY(this) = memory;
  *Pipeliner__CODEREGION(this) = codeRegion;
  return this;
}

#line 41 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Pipeliner.xcc"
void
Pipeliner_Dtor(Pipeliner this)
{
}

#line 46 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Pipeliner.xcc"
size_t
Pipeliner_Size(Memory memory, CodeRegion codeRegion)
{
  return sizeof(Pipeliner_);
}

#line 61 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Pipeliner.xcc"
#ifndef Pipeliner_POOLED
#define Pipeliner_POOLED 128
#endif//Pipeliner_POOLED

#line 65 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Pipeliner.xcc"
Pipeliner
Pipeliner_new(Memory parent, CodeRegion codeRegion)
{
  Memory memory = Memory_new(parent, Pipeliner_POOLED);
  size_t size = Pipeliner_Size(memory, codeRegion);
  Pipeliner this = Memory_alloc(memory, size);
  return Pipeliner_Ctor(this, memory, codeRegion);
}

#line 78 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Pipeliner.xcc"
Pipeliner
Pipeliner_delete(Pipeliner this)
{
  if (this != NULL) {
    Memory memory = Pipeliner_MEMORY(this);
#ifndef ECL_NDTOR
    Pipeliner_Dtor(this);
    Memory_free_(memory, this);
#endif//ECL_NDTOR
    Memory_delete(memory);
  }
  return NULL;
}

#line 92 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Pipeliner.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 100 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Pipeliner.xcc"
Memory
Pipeliner_memory(Pipeliner this)
{
  return Pipeliner_MEMORY(this);
}

#line 112 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Pipeliner.xcc"
CodeRegion
Pipeliner_codeRegion(Pipeliner this)
{
  return Pipeliner_CODEREGION(this);
}

#line 124 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Pipeliner.xcc"
#ifndef ECL_NTRACE
bool
Pipeliner_pretty(Pipeliner this, FILE *file)
{
  if (file == NULL) file = stderr;
  return true;
}
#endif//ECL_NTRACE

#line 133 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Pipeliner.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 145 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Pipeliner.xcc"
#if XCC__C
static void
Pipeliner_TEST(void)
{
#include "CGO/Pipeliner_.c"
}

#line 152 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/Pipeliner.xcc"
int
main(int argc, char **argv)
{
  CGO_Test(Pipeliner_TEST);
  return 0;
}
#endif


#endif//Pipeliner_c_INCLUDED
