#ifndef SSASpill__c_INCLUDED
#define SSASpill__c_INCLUDED

#line 3013 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/CGO/SSASpill.xcc"
//
if(0) {
  // Test of SSAForm_display.
  Program programTmp = Program_new(Memory_Root);
  Memory memory = Program_memory(programTmp);
  SymbolTable symbolTable = Program_symbolTable(programTmp);
  Symbol symbol = SymbolTable_lookup(symbolTable, 1, "lost-copy");
  Procedure procedure = Program_makeProcedure(programTmp, symbol);
  LabelTable labelTable = Program_labelTable(program);
  Label L1 = LabelTable_lookup(labelTable, 1, "L1");
  Label L2 = LabelTable_lookup(labelTable, 2, "L2");
  Label L3 = LabelTable_lookup(labelTable, 3, "L3");
  BasicBlock block_l1 = Procedure_makeBasicBlock(procedure, 0, 0, 1.0);
  BasicBlock block_l2 = Procedure_makeBasicBlock(procedure, 0, 0, 3.0);
  BasicBlock block_l3 = Procedure_makeBasicBlock(procedure, 0, 0, 1.0);
  BasicBlock_addLabels(block_l1, 1, &L1);
  BasicBlock_addLabels(block_l2, 1, &L2);
  BasicBlock_addLabels(block_l3, 1, &L3);
  BasicBlock_makeEdge(block_l1, block_l2, 1.0);
  BasicBlock_makeEdge(block_l2, block_l2, 2.0);
  BasicBlock_makeEdge(block_l2, block_l3, 1.0);
  Procedure_buildCodeRegions(procedure);
  {
    CodeRegion codeRegion = Procedure_findCodeRegion(procedure, 0);
    SSAForm ssaForm = SSAForm_construct(Memory_Root, codeRegion, true);
    TemporaryTable globalTable =CodeRegion_globalTable(codeRegion);
    Temporary temporary_x = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_y = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_z = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_res = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_t = Procedure_makeVirtualTemporary(procedure, 0);
    Temporary temporary_a1 = Procedure_makeAbsoluteTemporary(procedure, 1, Relocation__UNDEF);
    Temporary temporary_a2 = Procedure_makeAbsoluteTemporary(procedure, 2, Relocation__UNDEF);
    Temporary temporary_x1 = CodeRegion_makeVariableTemporary(codeRegion, temporary_x);
    Temporary temporary_x2 = CodeRegion_makeVariableTemporary(codeRegion, temporary_x);
    Temporary temporary_x3 = CodeRegion_makeVariableTemporary(codeRegion, temporary_x);
    Temporary temporary_y1 = CodeRegion_makeVariableTemporary(codeRegion, temporary_y);
    Temporary temporary_y2 = CodeRegion_makeVariableTemporary(codeRegion, temporary_y);
    Temporary temporary_y3 = CodeRegion_makeVariableTemporary(codeRegion, temporary_y);
    Temporary temporary_z1 = CodeRegion_makeVariableTemporary(codeRegion, temporary_z);
    Temporary temporary_res1 = CodeRegion_makeVariableTemporary(codeRegion, temporary_res);
    Temporary temporary_res2 = CodeRegion_makeVariableTemporary(codeRegion, temporary_res);
    Temporary temporary_res3 = CodeRegion_makeVariableTemporary(codeRegion, temporary_res);
    Temporary temporary_res4 = CodeRegion_makeVariableTemporary(codeRegion, temporary_res);
    Temporary temporary_res5 = CodeRegion_makeVariableTemporary(codeRegion, temporary_res);
    Temporary temporary_res6 = CodeRegion_makeVariableTemporary(codeRegion, temporary_res);
    Temporary temporary_res7 = CodeRegion_makeVariableTemporary(codeRegion, temporary_res);
    Temporary temporary_res8 = CodeRegion_makeVariableTemporary(codeRegion, temporary_res);
    Temporary temporary_res9 = CodeRegion_makeVariableTemporary(codeRegion, temporary_res);
    Temporary temporary_t1 = CodeRegion_makeVariableTemporary(codeRegion, temporary_t);
    Temporary temporary_t2 = CodeRegion_makeVariableTemporary(codeRegion, temporary_t);
    Temporary temporary_t3 = CodeRegion_makeVariableTemporary(codeRegion, temporary_t);
    Temporary temporary_t4 = CodeRegion_makeVariableTemporary(codeRegion, temporary_t);
    Temporary temporary_t5 = CodeRegion_makeVariableTemporary(codeRegion, temporary_t);
    Temporary temporary_t6 = CodeRegion_makeVariableTemporary(codeRegion, temporary_t);
    Temporary temporary_t7 = CodeRegion_makeVariableTemporary(codeRegion, temporary_t);
    TemporarySet set1 = TemporarySet_make(memory, 6);
    TemporarySet set2 = TemporarySet_make(memory, 19);
    Operation phiOperation_x = BasicBlock_makeOperationPHI(block_l2, NULL);
    Operation phiOperation_y = BasicBlock_makeOperationPHI(block_l2, NULL);
    DefUses defUsesX1 = Temporary_defUses(temporary_x1);
    DefUses defUsesX2 = Temporary_defUses(temporary_x2);
    DefUses defUsesX3 = Temporary_defUses(temporary_x3);
    DefUses defUsesY1 = Temporary_defUses(temporary_y1);
    DefUses defUsesY2 = Temporary_defUses(temporary_y2);
    DefUses defUsesY3 = Temporary_defUses(temporary_y3);
    DefUses defUsesZ1 = Temporary_defUses(temporary_z1);
    DefUses defUsesRES1 = Temporary_defUses(temporary_res1);
    DefUses defUsesRES2 = Temporary_defUses(temporary_res2);
    DefUses defUsesRES3 = Temporary_defUses(temporary_res3);
    DefUses defUsesRES4 = Temporary_defUses(temporary_res4);
    DefUses defUsesRES5 = Temporary_defUses(temporary_res5);
    DefUses defUsesRES6 = Temporary_defUses(temporary_res6);
    DefUses defUsesRES7 = Temporary_defUses(temporary_res7);
    DefUses defUsesRES8 = Temporary_defUses(temporary_res8);
    DefUses defUsesRES9 = Temporary_defUses(temporary_res9);
    DefUses defUsesT1 = Temporary_defUses(temporary_t1);
    DefUses defUsesT2 = Temporary_defUses(temporary_t2);
    DefUses defUsesT3 = Temporary_defUses(temporary_t3);
    DefUses defUsesT4 = Temporary_defUses(temporary_t4);
    DefUses defUsesT5 = Temporary_defUses(temporary_t5);
    DefUses defUsesT6 = Temporary_defUses(temporary_t6);
    DefUses defUsesT7 = Temporary_defUses(temporary_t7);
    Operation tmp = NULL;
    DefUses_Ctor(defUsesX1, memory);
    DefUses_Ctor(defUsesX2, memory);
    DefUses_Ctor(defUsesX3, memory);
    DefUses_Ctor(defUsesY1, memory);
    DefUses_Ctor(defUsesY2, memory);
    DefUses_Ctor(defUsesY3, memory);
    DefUses_Ctor(defUsesZ1, memory);
    DefUses_Ctor(defUsesRES1, memory);
    DefUses_Ctor(defUsesRES2, memory);
    DefUses_Ctor(defUsesRES3, memory);
    DefUses_Ctor(defUsesRES4, memory);
    DefUses_Ctor(defUsesRES5, memory);
    DefUses_Ctor(defUsesRES6, memory);
    DefUses_Ctor(defUsesRES7, memory);
    DefUses_Ctor(defUsesRES8, memory);
    DefUses_Ctor(defUsesRES9, memory);
    DefUses_Ctor(defUsesT1, memory);
    DefUses_Ctor(defUsesT2, memory);
    DefUses_Ctor(defUsesT3, memory);
    DefUses_Ctor(defUsesT4, memory);
    DefUses_Ctor(defUsesT5, memory);
    DefUses_Ctor(defUsesT6, memory);
    DefUses_Ctor(defUsesT7, memory);
    Operation_setResult(phiOperation_x, 0, temporary_x2);
    DefUses_setDef(defUsesX2, phiOperation_x, 0);
    Operation_setArgument(phiOperation_x, 0, temporary_x1);
    DefUses_addUse(defUsesX1, phiOperation_x, 0);
    Operation_setArgument(phiOperation_x, 1, temporary_x3);
    DefUses_addUse(defUsesX3, phiOperation_x, 1);
    Operation_setResult(phiOperation_y, 0, temporary_y2);
    DefUses_setDef(defUsesY2, phiOperation_y, 0);
    Operation_setArgument(phiOperation_y, 0, temporary_y1);
    DefUses_addUse(defUsesY1, phiOperation_y, 0);
    Operation_setArgument(phiOperation_y, 1, temporary_y3);
    DefUses_addUse(defUsesY3, phiOperation_y, 1);
    TemporarySet_insert(set2, temporary_t1);
    TemporarySet_insert(set2, temporary_t2);
    TemporarySet_insert(set2, temporary_t3);
    TemporarySet_insert(set2, temporary_t4);
    TemporarySet_insert(set2, temporary_t5);
    TemporarySet_insert(set2, temporary_t6);
    TemporarySet_insert(set2, temporary_t7);
    TemporarySet_insert(set2, temporary_res2);
    TemporarySet_insert(set2, temporary_res3);
    TemporarySet_insert(set2, temporary_res4);
    TemporarySet_insert(set2, temporary_res5);
    TemporarySet_insert(set2, temporary_res6);
    TemporarySet_insert(set2, temporary_res7);
    TemporarySet_insert(set2, temporary_res8);
    TemporarySet_insert(set2, temporary_res9);
    CodeRegion_setLiveSets(codeRegion, 1, set1, set2, NULL, NULL);
    //BB1
    tmp = Selector_makeOperation_1_1(BasicBlock_selector(block_l1),
                                     Operator_APPLY, temporary_x1, temporary_a1);
    DefUses_setDef(defUsesX1, tmp, 0);
    tmp = Selector_makeOperation_1_1(BasicBlock_selector(block_l1),
                                     Operator_APPLY, temporary_y1, temporary_a2);
    DefUses_setDef(defUsesY1, tmp, 0);
    tmp = Selector_makeOperation_1_1(BasicBlock_selector(block_l1),
                                     Operator_APPLY, temporary_t1, temporary_a2);
    DefUses_setDef(defUsesT1, tmp, 0);
    tmp = Selector_makeOperation_1_1(BasicBlock_selector(block_l1),
                                     Operator_APPLY, temporary_t2, temporary_a2);
    DefUses_setDef(defUsesT2, tmp, 0);
    tmp = Selector_makeOperation_1_1(BasicBlock_selector(block_l1),
                                     Operator_APPLY, temporary_t3, temporary_a2);
    DefUses_setDef(defUsesT3, tmp, 0);
    tmp = Selector_makeOperation_1_1(BasicBlock_selector(block_l1),
                                     Operator_APPLY, temporary_t4, temporary_a2);
    DefUses_setDef(defUsesT4, tmp, 0);
    tmp = Selector_makeOperation_1_1(BasicBlock_selector(block_l1),
                                     Operator_APPLY, temporary_t5, temporary_a2);
    DefUses_setDef(defUsesT5, tmp, 0);
    tmp = Selector_makeOperation_1_1(BasicBlock_selector(block_l1),
                                     Operator_APPLY, temporary_t6, temporary_a2);
    DefUses_setDef(defUsesT6, tmp, 0);
    tmp = Selector_makeOperation_1_1(BasicBlock_selector(block_l1),
                                     Operator_APPLY, temporary_t7, temporary_a2);
    DefUses_setDef(defUsesT7, tmp, 0);
    //BB2
    tmp = Selector_makeOperation_1_1(BasicBlock_selector(block_l2),
                                     Operator_APPLY, temporary_z1, temporary_x2);
    DefUses_setDef(defUsesZ1, tmp, 0);
    DefUses_addUse(defUsesX2, tmp, 0);
    tmp = Selector_makeOperation_1_1(BasicBlock_selector(block_l2),
                                     Operator_APPLY, temporary_x3, temporary_y2);
    DefUses_setDef(defUsesX3, tmp, 0);
    DefUses_addUse(defUsesY2, tmp, 0);
    tmp = Selector_makeOperation_1_1(BasicBlock_selector(block_l2),
                                     Operator_APPLY, temporary_y3, temporary_z1);
    DefUses_setDef(defUsesY3, tmp, 0);
    DefUses_addUse(defUsesZ1, tmp, 0);
    //BB3
    tmp = Selector_makeOperation_1_1(BasicBlock_selector(block_l3),
                                     Operator_APPLY, temporary_res1, temporary_y3);
    DefUses_setDef(defUsesRES1, tmp, 0);
    DefUses_addUse(defUsesY3, tmp, 0);
    tmp = Selector_makeOperation_1_1(BasicBlock_selector(block_l3),
                                     Operator_APPLY, temporary_res2, temporary_x3);
    DefUses_setDef(defUsesRES2, tmp, 0);
    DefUses_addUse(defUsesX3, tmp, 0);
    tmp = Selector_makeOperation_1_1(BasicBlock_selector(block_l3),
                                     Operator_APPLY, temporary_res3, temporary_t1);
    DefUses_setDef(defUsesRES3, tmp, 0);
    DefUses_addUse(defUsesT1, tmp, 0);
    tmp = Selector_makeOperation_1_1(BasicBlock_selector(block_l3),
                                     Operator_APPLY, temporary_res4, temporary_t2);
    DefUses_setDef(defUsesRES4, tmp, 0);
    DefUses_addUse(defUsesT2, tmp, 0);
    tmp = Selector_makeOperation_1_1(BasicBlock_selector(block_l3),
                                     Operator_APPLY, temporary_res5, temporary_t3);
    DefUses_setDef(defUsesRES5, tmp, 0);
    DefUses_addUse(defUsesT3, tmp, 0);
    tmp = Selector_makeOperation_1_1(BasicBlock_selector(block_l3),
                                     Operator_APPLY, temporary_res6, temporary_t4);
    DefUses_setDef(defUsesRES6, tmp, 0);
    DefUses_addUse(defUsesT4, tmp, 0);
    tmp = Selector_makeOperation_1_1(BasicBlock_selector(block_l3),
                                     Operator_APPLY, temporary_res7, temporary_t5);
    DefUses_setDef(defUsesRES7, tmp, 0);
    DefUses_addUse(defUsesT5, tmp, 0);
    tmp = Selector_makeOperation_1_1(BasicBlock_selector(block_l3),
                                     Operator_APPLY, temporary_res8, temporary_t6);
    DefUses_setDef(defUsesRES8, tmp, 0);
    DefUses_addUse(defUsesT6, tmp, 0);
    tmp = Selector_makeOperation_1_1(BasicBlock_selector(block_l3),
                                     Operator_APPLY, temporary_res9, temporary_t7);
    DefUses_setDef(defUsesRES9, tmp, 0);
    DefUses_addUse(defUsesT7, tmp, 0);
    // we must fill the globalTable with all variables to get a valid liveness
    // information
    TemporaryTable_empty(globalTable);
    SSAForm_FOREACH_Variable(ssaForm, var) {
      Temporary temporary = Variable_TEMPORARY(var);
      TemporaryTable_insert(globalTable, temporary);
    } SSAForm_ENDEACH_Variable;
    fprintf(stdout, "Max live: %d\n",
            SSASpill_maxLive(ssaForm, Temporary_regFile(temporary_x1)));
    SSASpill_spillBelady(ssaForm, Temporary_regFile(temporary_x1), false);
    SSAForm_display(ssaForm, stdout, "Swap Problem");
    CodeRegion_pretty(SSAForm_codeRegion(ssaForm), stdout);
    fprintf(stdout, "Max live: %d\n",
            SSASpill_maxLive(ssaForm, Temporary_regFile(temporary_x1)));
  }
}


#endif//SSASpill__c_INCLUDED
