#ifndef BasicBlock_c_INCLUDED
#define BasicBlock_c_INCLUDED

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
#include "LIR/LIR_.h"

#line 27 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 51 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
BasicBlockEdge
BasicBlockEdge_Ctor(BasicBlockEdge this,
                    struct BasicBlock_ *origBlock, struct BasicBlock_ *destBlock, float probability)
{
  *BasicBlockEdge__ORIGBLOCK(this) = origBlock;
  *BasicBlockEdge__DESTBLOCK(this) = destBlock;
  *BasicBlockEdge__ENTERNEXT(this) = NULL;
  *BasicBlockEdge__PROBABILITY(this) = probability;
  *BasicBlockEdge__INDEX(this) = -1;
  *BasicBlockEdge__ISLOOP(this) = false;
  *BasicBlockEdge__ISJOIN(this) = false;
  *BasicBlockEdge__ISBACK(this) = false;
  *BasicBlockEdge__ELAPSED(this) = -1;
  *BasicBlockEdge__ARGINDEX(this) = -1;
  *BasicBlockEdge__RESINDEX(this) = -1;
  return this;
}

#line 69 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
size_t
BasicBlockEdge_Size(struct BasicBlock_ *origBlock, struct BasicBlock_ *destBlock, float probability)
{
  return sizeof(BasicBlockEdge_);
}

#line 91 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 120 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 140 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
#ifndef ECL_NTRACE
ETableEntry_ BasicBlockFlagEntries[] = {
  ETableENTRY(BasicBlockFlag, Entry),
  ETableENTRY(BasicBlockFlag, Exit),
  ETableENTRY(BasicBlockFlag, Start),
  ETableENTRY(BasicBlockFlag, GNUASM),
  ETableENTRY(BasicBlockFlag, Natural),
  ETableENTRY(BasicBlockFlag, Widening),
  ETableENTRY(BasicBlockFlag, Scheduled),
  ETableENTRY(BasicBlockFlag, Allocated),
  ETableENTRY_NULL
};
ETable_ BasicBlockFlag_Table[1];
#endif//ECL_NTRACE

#line 155 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 242 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
BasicBlock
BasicBlock_Ctor(BasicBlock this,
                Memory memory, void *procedure, Processor processor,
                struct CodeRegion_ *codeRegion, float frequency)
{
  Indexed_Ctor(BasicBlock____(this), BasicBlock_Factory);
  Selector_Ctor(BasicBlock_SELECTOR(this), memory,
                procedure, processor, true);
  IDList_Ctor(BasicBlock_LEAVEEDGES(this), memory);
  *BasicBlock__ENTERFIRST(this) = NULL;
  *BasicBlock__ENTERCOUNT(this) = 0;
  *BasicBlock__FIRSTORDERING(this) = 0;
  *BasicBlock__EARLYORDERING(this) = 0;
  *BasicBlock__LATEORDERING(this) = 0;
  *BasicBlock__LASTORDERING(this) = 0;
  *BasicBlock__CODEREGION(this) = codeRegion;
  *BasicBlock__LOOPSCOPE(this) = NULL;
  *BasicBlock__TRACEID(this) = 0;
  *BasicBlock__FREQUENCY(this) = frequency;
  *BasicBlock__POINTER(this) = NULL;
  *BasicBlock__UNROLLED(this) = 0;
  *BasicBlock__FLAGS(this) = 0;
  *BasicBlock__MARK(this) = 0;
  *BasicBlock__PADDING(this) = 0;
  *BasicBlock__LABELCOUNT(this) = 0;
  BasicBlock_LABELVARIANT(this)->LABEL = NULL;
  *BasicBlock__LITERALSLABEL(this) = NULL;
  IDList_Ctor(BasicBlock_LITERALS(this), memory);
  return this;
}

#line 273 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
void
BasicBlock_Dtor(BasicBlock this)
{
  Selector_Dtor(BasicBlock_SELECTOR(this));
  IDList_Dtor(BasicBlock_LEAVEEDGES(this));
  if (BasicBlock_LABELCOUNT(this) > 1) {
    Memory memory = BasicBlock_MEMORY(this);
    LabelVariant labelVariant = BasicBlock_LABELVARIANT(this);
    Memory_free_(memory, labelVariant->LABELS);
  }
  IDList_Dtor(BasicBlock_LITERALS(this));
}

#line 286 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
size_t
BasicBlock_Size(Memory memory, void *procedure, Processor processor,
                struct CodeRegion_ *codeRegion, float frequency)
{
  return sizeof(BasicBlock_);
}

#line 298 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 478 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
intptr_t
BasicBlock_regionId(const_BasicBlock this)
{
  CodeRegion codeRegion = BasicBlock_CODEREGION(this);
  return CodeRegion_REGIONID(codeRegion);
}

#line 575 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 586 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
BasicBlockEdge
BasicBlock_makeEdge(BasicBlock this, BasicBlock that, float probability)
{
  IDList leaveEdges = BasicBlock_LEAVEEDGES(this);
  size_t size = BasicBlockEdge_Size(this, that, probability);
  BasicBlockEdge edge = that == BasicBlock_next(this)?
                        IDList_put(leaveEdges, size):
                        IDList_push(leaveEdges, size);
  BasicBlockEdge_Ctor(edge, this, that, probability);
  *BasicBlockEdge__ENTERNEXT(edge) = BasicBlock_ENTERFIRST(that);
  *BasicBlock__ENTERFIRST(that) = edge;
  ++*BasicBlock__ENTERCOUNT(that);
  return edge;
}

#line 607 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
void
BasicBlock_killEdge(BasicBlock this, BasicBlockEdge edge)
{
  IDList leaveEdges = BasicBlock_LEAVEEDGES(this);
  BasicBlock that = BasicBlockEdge_DESTBLOCK(edge);
  BasicBlockEdge next_edge = BasicBlockEdge_ENTERNEXT(edge);
  BasicBlockEdge that_edge = BasicBlock_ENTERFIRST(that);
  BasicBlockEdge prev_edge = NULL;
  while (that_edge != edge) {
    Except_CHECK(that_edge != NULL);
    prev_edge = that_edge;
    that_edge = BasicBlockEdge_ENTERNEXT(that_edge);
  }
  if (prev_edge != NULL) {
    *BasicBlockEdge__ENTERNEXT(prev_edge) = next_edge;
  } else {
    *BasicBlock__ENTERFIRST(that) = next_edge;
  }
  --*BasicBlock__ENTERCOUNT(that);
#ifndef ECL_NDTOR
  IDList_remove(leaveEdges, edge, NULL);
#else//!ECL_NDTOR
  IDList_remove_(leaveEdges, edge);
#endif//ECL_NDTOR
}

#line 641 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
BasicBlockEdge
BasicBlock_getTargetEdge(const_BasicBlock this)
{
  Operation operation = BasicBlock_lastOperation(this);
  if (operation != NULL) {
    Label label = Operation_getTargetLabel(operation);
    if (label != NULL) {
      BasicBlock_LEAVE_FOREACH_BasicBlockEdge(this, edge) {
        if (BasicBlock_hasLabel(BasicBlockEdge_DESTBLOCK(edge), label)) return edge;
      } BasicBlock_LEAVE_ENDEACH_BasicBlockEdge;
    }
  }
  return NULL;
}

#line 664 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
BasicBlockEdge
BasicBlock_getDefaultEdge(const_BasicBlock this)
{
  const_IDList leaveEdges = BasicBlock_LEAVEEDGES(this);
  int32_t leaveCount = IDList_count(leaveEdges);
  BasicBlockEdge edge = IDList_firstItem(leaveEdges);
  if (leaveCount > 0 && leaveCount <= 2) {
    BasicBlock block = BasicBlockEdge_DESTBLOCK(edge);
    if (leaveCount == 1)
      return edge;
    else {
      Operation last_operation = BasicBlock_lastOperation(this);
      Label label = Operation_getTargetLabel(last_operation);
      if (!BasicBlock_hasLabel(BasicBlockEdge_DESTBLOCK(edge), label)) return edge;
      return IDList_lastItem(leaveEdges);
    }
  }
  return NULL;
}

#line 692 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
BasicBlockEdge
BasicBlock_getFallEdge(const_BasicBlock this)
{
  const_IDList leaveEdges = BasicBlock_LEAVEEDGES(this);
  int32_t leaveCount = IDList_count(leaveEdges);
  BasicBlockEdge edge = IDList_firstItem(leaveEdges);
  if (leaveCount > 0 && leaveCount <= 2) {
    BasicBlock block = BasicBlockEdge_DESTBLOCK(edge);
    if (leaveCount == 1) {
      Operation last_operation = BasicBlock_lastOperation(this);
      if (last_operation != NULL &&
          Operator_isBranch(Operation_OPERATOR(last_operation))) return NULL;
    }
    if (BasicBlock_next(this) == block) return edge;
  }
  return NULL;
}

#line 718 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
void
BasicBlock_makeEnterEdges(BasicBlock this, Memory memory, bool sort)
{
  int32_t enterCount = BasicBlock_ENTERCOUNT(this);
  *BasicBlock__ENTEREDGES(this) = NULL;
  if (enterCount > 0) {
    int32_t argIndex = 0;
    size_t enterEdgesSize = enterCount*sizeof(BasicBlockEdge);
    BasicBlockEdge *enterEdges = Memory_alloc(memory, enterEdgesSize);
    BasicBlock_ENTER_FOREACH_BasicBlockEdge(this, edge) {
      *BasicBlockEdge__ARGINDEX(edge) = argIndex;
      enterEdges[argIndex] = edge;
      argIndex++;
    } BasicBlock_ENTER_ENDEACH_BasicBlockEdge;
    Except_CHECK(argIndex == enterCount);
    *BasicBlock__ENTEREDGES(this) = enterEdges;
    if (sort) {
      BasicBlockEdge next_edge = NULL;
      BasicBlock_sortEnterEdges(this);
      for (argIndex = enterCount - 1; argIndex >= 0; argIndex--) {
        BasicBlockEdge edge = enterEdges[argIndex];
        *BasicBlockEdge__ARGINDEX(edge) = argIndex;
        *BasicBlockEdge__ENTERNEXT(edge) = next_edge;
        Except_CHECK(!next_edge || BasicBlockEdge_gt(next_edge, edge));
        next_edge = edge;
      }
      *BasicBlock__ENTERFIRST(this) = next_edge;
    }
  }
}

#line 757 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
void
BasicBlock_sortEnterEdges(BasicBlock this)
{
  int32_t count = BasicBlock_ENTERCOUNT(this);
  BasicBlockEdge *base = BasicBlock_ENTEREDGES(this);
  int32_t n = count, i = count/2;
  while (true) {
    int32_t parent, child;
    BasicBlockEdge temp;
    if (i > 0) {
      temp = base[--i];
    } else if (n > 1) {
      temp = base[--n];
      base[n] = base[0];
    } else return;
    parent = i, child = i*2 + 1;
    while (child < n) {
      if (   child + 1 < n
          && BasicBlockEdge_gt(base[child + 1], base[child])) {
        child = child + 1;
      }
      if (BasicBlockEdge_gt(base[child], temp)) {
        base[parent] = base[child];
        parent = child;
        child = child*2 + 1;
      } else break;
    }
    base[parent] = temp;
  }
}

#line 813 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 823 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
TemporarySet
BasicBlock_liveInSet(const_BasicBlock this)
{
  CodeRegion codeRegion = BasicBlock_CODEREGION(this);
  TemporarySet_ *liveInSets = CodeRegion_LIVEINSETS(codeRegion);
  int32_t liveCount = CodeRegion_LIVECOUNT(codeRegion);
  int32_t index = BasicBlock_INDEX(this);
  if (liveInSets != NULL && index < liveCount) {
    return liveInSets + index;
  }
  return NULL;
}

#line 844 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
TemporarySet
BasicBlock_phiInSet(const_BasicBlock this)
{
  CodeRegion codeRegion = BasicBlock_CODEREGION(this);
  TemporarySet_ *phiInSets = CodeRegion_PHIINSETS(codeRegion);
  int32_t liveCount = CodeRegion_LIVECOUNT(codeRegion);
  int32_t index = BasicBlock_INDEX(this);
  if (phiInSets != NULL && index < liveCount) {
    return phiInSets + index;
  }
  return NULL;
}

#line 865 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
TemporarySet
BasicBlock_liveOutSet(const_BasicBlock this)
{
  CodeRegion codeRegion = BasicBlock_CODEREGION(this);
  TemporarySet_ *liveOutSets = CodeRegion_LIVEOUTSETS(codeRegion);
  int32_t liveCount = CodeRegion_LIVECOUNT(codeRegion);
  int32_t index = BasicBlock_INDEX(this);
  if (liveOutSets != NULL && index < liveCount) {
    return liveOutSets + index;
  }
  return NULL;
}

#line 886 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
TemporarySet
BasicBlock_phiOutSet(const_BasicBlock this)
{
  CodeRegion codeRegion = BasicBlock_CODEREGION(this);
  TemporarySet_ *phiOutSets = CodeRegion_PHIOUTSETS(codeRegion);
  int32_t liveCount = CodeRegion_LIVECOUNT(codeRegion);
  int32_t index = BasicBlock_INDEX(this);
  if (phiOutSets != NULL && index < liveCount) {
    return phiOutSets + index;
  }
  return NULL;
}

#line 982 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1024 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
Label
BasicBlock_makeLabel(BasicBlock this)
{
  int labelCount = BasicBlock_LABELCOUNT(this);
  Procedure procedure = BasicBlock_PROCEDURE(this);
  Program program = Procedure_PROGRAM(procedure);
  LabelTable labelTable = Program_LABELTABLE(program);
  LabelVariant labelVariant = BasicBlock_LABELVARIANT(this);
  if (labelCount == 0) {
    labelVariant->LABEL = LabelTable_makeLabel(labelTable);
    *BasicBlock__LABELCOUNT(this) = 1;
    return labelVariant->LABEL;
  }
  if (labelCount == 1) {
    return labelVariant->LABEL;
  }
  Except_CHECK(labelCount > 1);
  return labelVariant->LABELS[0];
}

#line 1048 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
void
BasicBlock_addLabels(BasicBlock this, int labelCount, Label *labels)
{
  int old_labelCount = BasicBlock_LABELCOUNT(this);
  int new_labelCount = old_labelCount + labelCount, i = 0;
  LabelVariant labelVariant = BasicBlock_LABELVARIANT(this);
  if (old_labelCount == 0) {
    if (labelCount == 1) {
      labelVariant->LABEL = *labels;
    } else
    if (labelCount > 1) {
      Memory memory = BasicBlock_MEMORY(this);
      Label *alloc_labels = Memory_alloc(memory, labelCount*sizeof(Label));
      for (; i < labelCount; i++) alloc_labels[i] = labels[i];
      labelVariant->LABELS = alloc_labels;
    }
  } else if (labelCount > 0) {
    Memory memory = BasicBlock_MEMORY(this);
    Label *alloc_labels = Memory_alloc(memory, new_labelCount*sizeof(Label));
    BasicBlock_FOREACH_Label(this, label) {
      alloc_labels[i++] = label;
    } BasicBlock_ENDEACH_Label;
    Except_CHECK(i == old_labelCount);
    for (; i < new_labelCount; i++) alloc_labels[i] = labels[i];
#ifndef ECL_NDTOR
    if (old_labelCount > 1) {
      Memory_free_(memory, labelVariant->LABELS);
    }
#endif//ECL_NDTOR
    labelVariant->LABELS = alloc_labels;
  }
  *BasicBlock__LABELCOUNT(this) = new_labelCount;
}

#line 1088 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
bool
BasicBlock_hasLabel(const_BasicBlock this, Label label)
{
  BasicBlock_FOREACH_Label(this, LABEL) {
    if (LABEL == label) return true;
  } BasicBlock_ENDEACH_Label;
  return false;
}

#line 1115 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
float
BasicBlock_contributed(const_BasicBlock this)
{
  if (BasicBlock_isScheduled(this) && !BasicBlock_isEmpty(this)) {
    int padding = BasicBlock_PADDING(this);
    int firstDate = Operation_STARTDATE(BasicBlock_firstOperation(this));
    int lastDate = Operation_STARTDATE(BasicBlock_lastOperation(this));
    return BasicBlock_FREQUENCY(this)*(lastDate - firstDate + 1 + padding);
  }
  return 0.0;
}

#line 1127 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1135 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
#ifndef ECL_NTRACE
bool
BasicBlock_pretty(const_BasicBlock this, FILE *file)
{
  LoopScope loopScope = BasicBlock_LOOPSCOPE(this);
  BasicBlock headerBlock = loopScope != NULL?
                           LoopScope_HEADERBLOCK(loopScope): NULL;
  if (file == NULL) file = stderr;
  fprintf(file, "%4d:Block_%d\n", BasicBlock_identity(this), BasicBlock_INDEX(this));
  if (BasicBlock_FLAGS(this) != 0) {
    BasicBlockFlags flags = BasicBlock_FLAGS(this);
    fprintf(file, "\t");
    ETable_prettyFlags(BasicBlockFlag_Table, flags, "+", file);
    fprintf(file, "\n");
  }
  fprintf(file, "\tfrequency=%g", BasicBlock_FREQUENCY(this));
  fprintf(file, "\tregionId=0x%x", BasicBlock_regionId(this));
  fprintf(file, "\ttraceId=%d", BasicBlock_TRACEID(this));
  if (headerBlock != NULL) {
    fprintf(file, "\theaderBlock=%d:Block", BasicBlock_IDENTITY(headerBlock));
  }
  if (BasicBlock_UNROLLED(this) != 0) {
    fprintf(file, "\tunrolled=%d", BasicBlock_UNROLLED(this));
  }
  fprintf(file, "\n\tpredecessors:\t");
  BasicBlock_ENTER_FOREACH_BasicBlockEdge(this, edge) {
    BasicBlock origBlock = BasicBlockEdge_origBlock(edge);
    fprintf(file, "%d:Block_%d(%s%s%+d)\t",
            BasicBlock_identity(origBlock), BasicBlock_INDEX(origBlock),
            BasicBlockEdge_ISLOOP(edge)? "Loop,": "",
            BasicBlockEdge_ISJOIN(edge)? "Join,": "",
            BasicBlockEdge_ELAPSED(edge));
  } BasicBlock_ENTER_ENDEACH_BasicBlockEdge;
  fprintf(file, "\n\tsuccessors:\t");
  BasicBlock_LEAVE_FOREACH_BasicBlockEdge(this, edge) {
    BasicBlock destBlock = BasicBlockEdge_destBlock(edge);
    fprintf(file, "%d:Block_%d(%2.0f%%)\t",
            BasicBlock_identity(destBlock), BasicBlock_INDEX(destBlock),
            100.0*BasicBlockEdge_PROBABILITY(edge));
  } BasicBlock_LEAVE_ENDEACH_BasicBlockEdge;
  fprintf(file, "\n");
  if (BasicBlock_liveInSet(this) != NULL) {
    fprintf(file, "\tlive-in:\t");
    TemporarySet_pretty(BasicBlock_liveInSet(this), file);
    fprintf(file, "\n");
  }
  if (BasicBlock_phiInSet(this) != NULL) {
    fprintf(file, "\tphi-in:\t");
    TemporarySet_pretty(BasicBlock_phiInSet(this), file);
    fprintf(file, "\n");
  }
  if (BasicBlock_LABELCOUNT(this) != 0) {
    const char *sep = "\t";
    BasicBlock_FOREACH_Label(this, label) {
      fprintf(file, "%s%s", sep, Label_NAME(label));
      sep = " ";
    } BasicBlock_ENDEACH_Label;
    fprintf(file, ":\n");
  }
  BasicBlock_FOREACH_Operation(this, operation) {
    Except_CHECK(Operation_BASICBLOCK(operation) == this);
    fprintf(file, "\t"), Operation_pretty(operation, file);
  } BasicBlock_ENDEACH_Operation;
  if (BasicBlock_liveOutSet(this) != NULL) {
    fprintf(file, "\tlive-out:\t");
    TemporarySet_pretty(BasicBlock_liveOutSet(this), file);
    fprintf(file, "\n");
  }
  if (BasicBlock_phiOutSet(this) != NULL) {
    fprintf(file, "\tphi-out:\t");
    TemporarySet_pretty(BasicBlock_phiOutSet(this), file);
    fprintf(file, "\n");
  }
  if (BasicBlock_LITERALSCOUNT(this) > 0) {
    ImmediateValue offset = 0;
    fprintf(file, "\tliterals:\n");
    fprintf(file, "\t%s:\n", Label_NAME(BasicBlock_LITERALSLABEL(this)));
    BasicBlock_FOREACH_BasicBlockLiteral(this, literal) {
      Temporary temporary = BasicBlockLiteral_TEMPORARY(literal);
      NativeType nativeType = BasicBlockLiteral_NATIVETYPE(literal);
      fprintf(file, "\t\t%+lld:\t%s\t", offset, NativeType_name_(nativeType));
      Temporary_pretty(temporary, file);
      fprintf(file, "\n");
      offset += NativeType_sizeOf(nativeType);
    } BasicBlock_ENDEACH_BasicBlockLiteral;
  }
  fprintf(file, "\n");
  return true;
}
#endif//ECL_NTRACE

#line 1232 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
bool
BasicBlock_hasDedicatedEffects(const_BasicBlock this)
{
  BasicBlock_FORBACK_Operation(this, OPERATION) {
    if (Operation_hasDedicatedArgument(OPERATION, false)) return true;
    if (Operation_hasDedicatedResult(OPERATION, false)) return true;
  } BasicBlock_ENDBACK_Operation;
  return false;
}

#line 1326 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1334 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
Operation
BasicBlock_makeOperationPHI(BasicBlock this, Temporary temporary)
{
  Selector selector = BasicBlock_SELECTOR(this);
  int32_t enterCount = BasicBlock_ENTERCOUNT(this), i;
  Operation operation = Selector_makeOperation_(selector,
                                                Operator_PHI, 1, enterCount, NULL);
  Temporary *array = Operation_OPERANDS(operation);
  for (i = 0; i <= enterCount; i++) array[i] = temporary;
  Selector_moveOperationFirst(selector, operation);
  *Operation__ORDERING(operation) = BasicBlock_FIRSTORDERING(this);
  Selector_incrementPhiCount(selector);
  return operation;
}

#line 1355 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
Operation
BasicBlock_makeOperationSIGMA(BasicBlock this, Temporary temporary) {
  Selector selector = BasicBlock_SELECTOR(this);
  int leaveCount = BasicBlock_LEAVECOUNT(this), i;
  Operation operation = Selector_makeOperation_(selector,
                                                Operator_SIGMA, leaveCount, 1, NULL);
  Temporary *array = Operation_OPERANDS(operation);
  for (i = 0; i <= leaveCount; i++) array[i] = temporary;
  *Operation__ORDERING(operation) = BasicBlock_LASTORDERING(this);
  return operation;
}

#line 1375 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
Operation
BasicBlock_earlyOperation(const_BasicBlock this)
{
  BasicBlock_FOREACH_Operation(this, operation) {
    Operator operator = Operation_OPERATOR(operation);
    if (!Operator_isPhi(operator) && !Operator_isLabel(operator)) {
      return operation;
    }
  } BasicBlock_ENDEACH_Operation;
  return NULL;
}

#line 1395 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
void
BasicBlock_moveOperationEarly(BasicBlock this, Operation operation)
{
  Operation before_operation = NULL;
  IDList operations = BasicBlock_OPERATIONS(this);
  int32_t earlyOrdering = BasicBlock_EARLYORDERING(this);
  Except_REQUIRE(Operation_BASICBLOCK(operation) == this);
  IDList_remove_(operations, operation);
  before_operation = BasicBlock_earlyOperation(this);
  if (before_operation != NULL) {
    IDList_insert_(operations, before_operation, operation);
  } else {
    // There are only PHI or LABEL or no Operations in this BasicBlock.
    IDList_push_(operations, operation);
  }
  *Operation__ORDERING(operation) = *BasicBlock__EARLYORDERING(this)
                                  = earlyOrdering - 1;
}

#line 1422 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
Operation
BasicBlock_lateOperation(const_BasicBlock this)
{
  BasicBlock_FORBACK_Operation(this, operation) {
    Operator operator = Operation_OPERATOR(operation);
    if (!Operator_isSigma(operator) && !Operator_isControl(operator)) {
      return operation;
    }
  } BasicBlock_ENDBACK_Operation;
  return NULL;
}

#line 1442 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
void
BasicBlock_moveOperationLate(BasicBlock this, Operation operation)
{
  Operation after_operation = NULL;
  IDList operations = BasicBlock_OPERATIONS(this);
  int32_t lateOrdering = BasicBlock_LATEORDERING(this);
  Except_REQUIRE(Operation_BASICBLOCK(operation) == this);
  IDList_remove_(operations, operation);
  after_operation = BasicBlock_lateOperation(this);
  if (after_operation != NULL) {
    IDList_append_(operations, after_operation, operation);
  } else {
    // There are only SIGMA or Control or no Operations in this BasicBlock.
    IDList_put_(operations, operation);
  }
  *Operation__ORDERING(operation) = *BasicBlock__LATEORDERING(this)
                                  = lateOrdering + 1;
}

#line 1468 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
Operation
BasicBlock_makeOperationPCOPY(BasicBlock this, Operation point, bool before,
                              int32_t maxCount, int32_t increment) {
  Operation pcopy_operation = NULL;
  Selector selector = BasicBlock_SELECTOR(this);

#line 1474 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
  pcopy_operation = Selector_makeOperationParCopy(selector, Operator_PCOPY, maxCount, false);
  if(point != NULL) {
    if (before == true) {
      Selector_moveOperationBefore(selector, point, pcopy_operation);
    } else {
      Selector_moveOperationAfter(selector, point, pcopy_operation);
    }
  } else {
    if(before == true) {
      Selector_moveOperationFirst(selector, pcopy_operation);
    } else {
      // Inserts the operation last in selector, do nothing.
      // Selector_moveOperationLast(selector, pcopy_operation);
    }
  }
  if(increment > 0) {
    BasicBlock_makeOrderings(this, 0, increment);
  }
  return pcopy_operation;
}

#line 1501 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
Operation
BasicBlock_makeEarlyOperationCOPY(BasicBlock this, Temporary result, Temporary argument)
{
  Selector selector = BasicBlock_selector(this);
  Operation copy_operation = Selector_makeOperationCOPY(selector, result, argument);
  BasicBlock_moveOperationEarly(this, copy_operation);
  return copy_operation;
}

#line 1516 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
Operation
BasicBlock_makeOperationECOPY(BasicBlock this)
{
  Operation pcopy_operation = NULL;
  int32_t earlyArity = BasicBlock_PHICOUNT(this);
  if (earlyArity > 0) {
    Operation after_operation = NULL;
    Selector selector = BasicBlock_SELECTOR(this);
    int32_t earlyOrdering = BasicBlock_EARLYORDERING(this);
    BasicBlock_FOREACH_Operation(this, operation) {
      Operator operator = Operation_OPERATOR(operation);
      if (Operator_isPhi(operator));
      else if (Operator_isLabel(operator));
      else if (Operator_isECopy(operator)) return operation;
      else break;
      after_operation = operation;
    } BasicBlock_ENDEACH_Operation;
    pcopy_operation = Selector_makeOperationParCopy(selector, Operator_ECOPY, earlyArity, false);
    if (after_operation != NULL) {
      Selector_moveOperationAfter(selector, after_operation, pcopy_operation);
    }
    *Operation__ORDERING(pcopy_operation) = *BasicBlock__EARLYORDERING(this)
                                          = earlyOrdering - 1;
    Except_CHECK(pcopy_operation == BasicBlock_earlyOperation(this));
  }
  return pcopy_operation;
}

#line 1550 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
Operation
BasicBlock_makeLateOperationCOPY(BasicBlock this, Temporary result, Temporary argument)
{
  Selector selector = BasicBlock_selector(this);
  Operation copy_operation = Selector_makeOperationCOPY(selector, result, argument);
  BasicBlock_moveOperationLate(this, copy_operation);
  return copy_operation;
}

#line 1565 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
Operation
BasicBlock_makeOperationLCOPY(BasicBlock this)
{
  Operation pcopy_operation = NULL;
  int32_t lateArity = 0;
  BasicBlock_LEAVE_FOREACH_BasicBlockEdge(this, edge) {
    BasicBlock destBlock = BasicBlockEdge_DESTBLOCK(edge);
    lateArity += BasicBlock_PHICOUNT(destBlock);
  } BasicBlock_LEAVE_ENDEACH_BasicBlockEdge;
  if (lateArity > 0) {
    Operation before_operation = NULL;
    Selector selector = BasicBlock_SELECTOR(this);
    int32_t lateOrdering = BasicBlock_LATEORDERING(this);
    BasicBlock_FORBACK_Operation(this, operation) {
      Operator operator = Operation_OPERATOR(operation);
      if (Operator_isControl(operator));
      else if (Operator_isSigma(operator));
      else if (Operator_isLCopy(operator)) return operation;
      else break;
      before_operation = operation;
    } BasicBlock_ENDBACK_Operation;
    pcopy_operation = Selector_makeOperationParCopy(selector, Operator_LCOPY, lateArity, false);
    if (before_operation != NULL) {
      Selector_moveOperationBefore(selector, before_operation, pcopy_operation);
    }
    *Operation__ORDERING(pcopy_operation) = *BasicBlock__LATEORDERING(this)
                                          = lateOrdering + 1;
    Except_CHECK(pcopy_operation == BasicBlock_lateOperation(this));
  }
  return pcopy_operation;
}

#line 1597 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1605 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
void
BasicBlock_detachOperation(BasicBlock this, Operation operation)
{
  Selector selector = BasicBlock_SELECTOR(this);
  if (Operator_isPhi(Operation_OPERATOR(operation))) {
    Selector_decrementPhiCount(selector);
  }
  Selector_detachOperation(selector, operation);
}

#line 1621 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
void
BasicBlock_putSelector(BasicBlock this, Selector selector)
{
  while (!Selector_isEmpty(selector)) {
    Operation operation = Selector_lastOperation(selector);
    IDList_pop_(Selector_OPERATIONS(selector));
    IDList_put_(BasicBlock_OPERATIONS(this), operation);
    *Operation__BASICBLOCK(operation) = this;
  }
}

#line 1638 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
void
BasicBlock_pushSelector(BasicBlock this, Selector selector)
{
  while (!Selector_isEmpty(selector)) {
    Operation operation = Selector_firstOperation(selector);
    IDList_drop_(Selector_OPERATIONS(selector));
    IDList_push_(BasicBlock_OPERATIONS(this), operation);
    *Operation__BASICBLOCK(operation) = this;
  }
}

#line 1655 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
void
BasicBlock_insertSelector(BasicBlock this, Operation before, Selector selector)
{
  while (!Selector_isEmpty(selector)) {
    Operation operation = Selector_firstOperation(selector);
    IDList_drop_(Selector_OPERATIONS(selector));
    IDList_insert_(BasicBlock_OPERATIONS(this), before, operation);
    *Operation__BASICBLOCK(operation) = this;
  }
}

#line 1672 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
void
BasicBlock_appendSelector(BasicBlock this, Operation after, Selector selector)
{
  while (!Selector_isEmpty(selector)) {
    Operation operation = Selector_lastOperation(selector);
    IDList_pop_(Selector_OPERATIONS(selector));
    IDList_append_(BasicBlock_OPERATIONS(this), after, operation);
    *Operation__BASICBLOCK(operation) = this;
  }
}

#line 1683 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1696 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
void
BasicBlock_flagEntryCode(BasicBlock this, Convention convention)
{
  Operation stack_operation = NULL;
  Register stackRegister = Convention_stackRegister(convention);
  Register frameRegister = Convention_frameRegister(convention);
  Except_REQUIRE(BasicBlock_isEntry(this));
  BasicBlock_FOREACH_Operation(this, operation) {
    Operator operator = Operation_OPERATOR(operation);
    if (Operation_isExitCode(operation)) break;
    // Any copy from a dedicated register that is not constant.
    if (Operator_isSeqCopy(operator)) {
      Temporary argument = Operation_getArgument(operation, 0);
      Except_CHECK(Operation_argCount(operation) == 1);
      if (   Temporary_isDedicated(argument)
          && !Temporary_isConstant(argument)) {
        *Operation__FLAGS(operation) |= OperationFlag_EntryCode;
        LIR_TRACE && fprintf(LIR_TRACE, "*** EntryCode")
                  && Operation_pretty(operation, LIR_TRACE);
        continue;
      }
    }
    if (Operation_resCount(operation) == 1) {
      Temporary result = Operation_getResult(operation, 0);
      if (Temporary_isDedicated(result)) {
        Register registre = Temporary_REGISTER(result);
        // Move or adjust that defines the frame pointer.
        if (registre == frameRegister) {
          *Operation__FLAGS(operation) |= OperationFlag_EntryCode;
          LIR_TRACE && fprintf(LIR_TRACE, "*** EntryCode")
                    && Operation_pretty(operation, LIR_TRACE);
          continue;
        }
        // First copy or adjust that defines the stack pointer.
        if (registre == stackRegister && stack_operation == NULL) {
          *Operation__FLAGS(operation) |= OperationFlag_EntryCode;
          stack_operation = operation;
          LIR_TRACE && fprintf(LIR_TRACE, "*** EntryCode")
                    && Operation_pretty(operation, LIR_TRACE);
          continue;
        }
      }
    }
    break;
  } BasicBlock_ENDEACH_Operation;
}

#line 1754 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
void
BasicBlock_flagExitCode(BasicBlock this, Convention convention)
{
  Register stackRegister = Convention_stackRegister(convention);
  Operation control_operation = NULL;
  Operation stack_operation = NULL;
  Except_REQUIRE(BasicBlock_isExit(this));
  BasicBlock_FORBACK_Operation(this, operation) {
    Operator operator = Operation_OPERATOR(operation);
    if (Operation_isEntryCode(operation)) break;
    // Last control operation.
    if (Operator_isControl(operator) &&
        control_operation == NULL && (control_operation = operation)) {
      *Operation__FLAGS(operation) |= OperationFlag_ExitCode;
      LIR_TRACE && fprintf(LIR_TRACE, "*** ExitCode")
                && Operation_pretty(operation, LIR_TRACE);
      continue;
    }
    // Any copy to a dedicated register.
    if (Operator_isSeqCopy(operator)) {
      Temporary result = Operation_getResult(operation, 0);
      Except_CHECK(Operation_argCount(operation) == 1);
      if (Temporary_isDedicated(result)) {
        *Operation__FLAGS(operation) |= OperationFlag_ExitCode;
        LIR_TRACE && fprintf(LIR_TRACE, "*** ExitCode")
                  && Operation_pretty(operation, LIR_TRACE);
        continue;
      }
    }
    // Last copy or adjust of stack pointer.
    if (Operation_resCount(operation) == 1) {
      Temporary result = Operation_getResult(operation, 0);
      if (Temporary_isDedicated(result)) {
        Register registre = Temporary_REGISTER(result);
        if (registre == stackRegister && stack_operation == NULL) {
          *Operation__FLAGS(operation) |= OperationFlag_ExitCode;
          stack_operation = operation;
          LIR_TRACE && fprintf(LIR_TRACE, "*** ExitCode")
                    && Operation_pretty(operation, LIR_TRACE);
          continue;
        }
      }
    }
    break;
  } BasicBlock_ENDBACK_Operation;
}

#line 1801 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1812 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
int32_t
BasicBlock_makeOrderings(BasicBlock this, int32_t ordering, int32_t increment)
{
  int32_t firstOrdering = ordering + increment;
  int32_t earlyArity = BasicBlock_PHICOUNT(this), lateArity = 0;
  int32_t earlyOrdering, lateOrdering, lastOrdering;
  Except_REQUIRE(firstOrdering > 0 && increment > 0);
  BasicBlock_LEAVE_FOREACH_BasicBlockEdge(this, edge) {
    BasicBlock destBlock = BasicBlockEdge_DESTBLOCK(edge);
    lateArity += BasicBlock_PHICOUNT(destBlock);
  } BasicBlock_LEAVE_ENDEACH_BasicBlockEdge;
  earlyOrdering = firstOrdering + increment + earlyArity;
  lateOrdering = earlyOrdering + increment;
  lastOrdering = lateOrdering + increment + lateArity;
  BasicBlock_FOREACH_Operation(this, operation) {
    Operator operator = Operation_OPERATOR(operation);
    if (   Operator_isPhi(operator)
        || Operator_isLabel(operator)) {
      ordering = firstOrdering;
    } else
    if (   Operator_isControl(operator)
        || Operator_isSigma(operator)) {
      ordering = lastOrdering;
    } else {
      ordering = lateOrdering;
      lateOrdering += increment;
      lastOrdering += increment;
    }
    *Operation__ORDERING(operation) = ordering;
  } BasicBlock_ENDEACH_Operation;
  *BasicBlock__FIRSTORDERING(this) = firstOrdering;
  *BasicBlock__EARLYORDERING(this) = earlyOrdering;
  *BasicBlock__LATEORDERING(this) = lateOrdering;
  *BasicBlock__LASTORDERING(this) = lastOrdering;
  return lastOrdering;
}

#line 1883 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
bool
BasicBlock_checkOrderings(const_BasicBlock this)
{
  int32_t firstOrdering = BasicBlock_FIRSTORDERING(this);
  int32_t lastOrdering = BasicBlock_LASTORDERING(this);
  int32_t previous_ordering = firstOrdering;
  BasicBlock_FOREACH_Operation(this, operation) {
    int32_t ordering = Operation_ORDERING(operation);
    Operator operator = Operation_OPERATOR(operation);
    if (   Operator_isPhi(operator)
        || Operator_isLabel(operator)) {
      Except_CHECK(ordering == firstOrdering);
      if (ordering != firstOrdering) return false;
    } else
    if (   Operator_isControl(operator)
        || Operator_isSigma(operator)) {
      Except_CHECK(ordering == lastOrdering);
      if (ordering != lastOrdering) return false;
      Except_CHECK(lastOrdering > previous_ordering);
      if (lastOrdering <= previous_ordering) return false;
    } else {
      Except_CHECK(ordering > previous_ordering);
      if (ordering <= previous_ordering) return false;
    }
    previous_ordering = ordering;
  } BasicBlock_ENDEACH_Operation;
  return true;
}

#line 1912 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1920 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
bool
BasicBlock_frequencyLT(const_BasicBlock this, const_BasicBlock that)
{
  // HACK! uint32_t order is same as float order for non-negative float(s).
  uint32_t this_frequency = *(uint32_t *)BasicBlock__FREQUENCY(this);
  uint32_t that_frequency = *(uint32_t *)BasicBlock__FREQUENCY(that);
  if (this_frequency == that_frequency) {
    return BasicBlock_index(this) > BasicBlock_index(that);
  }
  return this_frequency < that_frequency;
}

#line 1932 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 1959 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
BasicBlockLiteral
BasicBlockLiteral_Ctor(BasicBlockLiteral this,
                       Temporary temporary, NativeType nativeType)
{
  *BasicBlockLiteral__TEMPORARY(this) = temporary;
  *BasicBlockLiteral__NATIVETYPE(this) = nativeType;
  return this;
}

#line 1968 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
size_t
BasicBlockLiteral_Size(Temporary temporary, NativeType nativeType)
{
  return sizeof(BasicBlockLiteral_);
}

#line 2055 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 2075 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
BasicBlockStack
BasicBlockStack_Ctor(BasicBlockStack this,
                     Memory memory, int maxCount)
{
  PtrSeq_Ctor(BasicBlockStack____(this), memory, maxCount);
  return this;
}

#line 2083 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
void
BasicBlockStack_Dtor(BasicBlockStack this)
{
  PtrSeq_Dtor(BasicBlockStack____(this));
}

#line 2157 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
void
BasicBlockStack_sort(BasicBlockStack this, BasicBlockLT lt)
{
  BasicBlock *base = BasicBlockStack_base_(this);
  int32_t count = BasicBlockStack_count(this);
  BasicBlock *past = base + count;
  int32_t n = count, i = count/2;
  while (true) {
    int32_t parent, child;
    BasicBlock temp;
    if (i > 0) {
      temp = base[--i];
    } else if (n > 1) {
      temp = base[--n];
      base[n] = base[0];
    } else return;
    parent = i, child = i*2 + 1;
    while (child < n) {
      if (   child + 1 < n
          && (lt)(base[child + 1], base[child])) {
        child = child + 1;
      }
      if ((lt)(base[child], temp)) {
        base[parent] = base[child];
        parent = child;
        child = child*2 + 1;
      } else break;
    }
    base[parent] = temp;
  }
}

#line 2189 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 2212 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
BasicBlockTable
BasicBlockTable_Ctor(BasicBlockTable this,
                     Memory memory, int32_t estimate)
{
  IndexedTable_Ctor(BasicBlockTable____(this), memory, estimate);
  return this;
}

#line 2220 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
void
BasicBlockTable_Dtor(BasicBlockTable this)
{
  IndexedTable_Dtor(BasicBlockTable____(this));
}

#line 2269 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
#ifndef ECL_NTRACE
bool
BasicBlockTable_pretty(const_BasicBlockTable this, FILE *file)
{
  if (file == NULL) file = stderr;
  fprintf(file, "{");
  BasicBlockTable_FOREACH_BasicBlock(this, basicBlock) {
    fprintf(file, " [%d]", BasicBlock_INDEX(basicBlock));
  } BasicBlockTable_ENDEACH_BasicBlock;
  fprintf(file, " }");
  return true;
}
#endif//ECL_NTRACE

#line 2283 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 2291 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
bool
BasicBlockEdge_isBack(BasicBlockEdge edge)
{
  BasicBlock destBB = BasicBlockEdge_destBlock(edge);
  BasicBlock origBB = BasicBlockEdge_origBlock(edge);
  LoopScope loopscope = BasicBlock_loopScope(destBB);
  return loopscope != NULL
      && LoopScope_headerBlock(loopscope) == destBB
      && BasicBlock_loopScope(origBB) == loopscope;
}

#line 2309 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
bool
BasicBlockEdge_isFalse(BasicBlockEdge this, float *weight)
{
  BasicBlock bbA = BasicBlockEdge_origBlock(this);
  BasicBlock bbB = BasicBlockEdge_destBlock(this);
  if(weight != NULL) {
    *weight = BasicBlock_frequency(bbA) * BasicBlockEdge_probability(this);
  }
  return BasicBlock_next(bbA) == bbB;
}

#line 2328 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
bool
BasicBlockEdge_isSweetBottom(BasicBlockEdge this, float *weight)
{
  BasicBlock B=BasicBlockEdge_destBlock(this);
  BasicBlock_ENTER_FOREACH_BasicBlockEdge(B, edge) {
    if (edge!=this) return false;
  } BasicBlock_ENTER_ENDEACH_BasicBlockEdge;
  if(weight != NULL) {
    *weight=BasicBlock_frequency(B);
  }
  return true;
}

#line 2348 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
bool
BasicBlockEdge_isSweetTop(BasicBlockEdge this, float *weight)
{
  BasicBlock A=BasicBlockEdge_origBlock(this);
  BasicBlock_LEAVE_FOREACH_BasicBlockEdge(A, edge) {
    if (edge!=this) return false;
  } BasicBlock_LEAVE_ENDEACH_BasicBlockEdge;
  if(weight != NULL) {
    *weight=BasicBlock_frequency(A);
  }
  return true;
}

#line 2369 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
bool
BasicBlockEdge_isWeakBottom(BasicBlockEdge this, float *weight)
{
  BasicBlock B;
  if(weight != NULL) {
    *weight=0;
  }
  if (!BasicBlockEdge_isCritical(this)) return false;
  B = BasicBlockEdge_destBlock(this);
  BasicBlock_ENTER_FOREACH_BasicBlockEdge(B, edge) {
    if (edge == this) {
     if(weight != NULL) {
       *weight += BasicBlock_frequency(B);
     }
    } else {
      float arcweight;
      if (   !BasicBlockEdge_isSweetTop(edge,&arcweight)
          && !BasicBlockEdge_isFalse(edge,&arcweight)) return false;
      if(weight != NULL) {
        *weight += arcweight;
      }
    }
  } BasicBlock_ENTER_ENDEACH_BasicBlockEdge;
  return true;
}

#line 2403 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
bool
BasicBlockEdge_isWeakTop (BasicBlockEdge this, float *weight)
{
  BasicBlock A;
  if(weight != NULL) {
    *weight=0;
  }
  if (!BasicBlockEdge_isCritical(this)) return false;
  A = BasicBlockEdge_origBlock(this);
  BasicBlock_LEAVE_FOREACH_BasicBlockEdge(A, edge) {
    if (edge == this) {
      if(weight != NULL) {
        *weight += BasicBlock_frequency(A);
      }
    } else {
      float arcweight;
      if (   !BasicBlockEdge_isSweetBottom(edge,&arcweight)
          && !BasicBlockEdge_isFalse(edge,&arcweight)) return false;
      if(weight != NULL) {
        *weight += arcweight;
      }
    }
  } BasicBlock_LEAVE_ENDEACH_BasicBlockEdge;
  return true;
}

#line 2437 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
bool
BasicBlockEdge_isCritical (BasicBlockEdge this)
{
  float devnull;
  return (!BasicBlockEdge_isSweetBottom(this,&devnull) &&
          !BasicBlockEdge_isSweetTop(this,&devnull));
}

#line 2451 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
bool
BasicBlockEdge_isStrong (BasicBlockEdge this)
{
  float devnull;
  return BasicBlockEdge_isCritical(this)
      && !BasicBlockEdge_isFalse(this,&devnull)
      && !BasicBlockEdge_isWeakBottom(this,&devnull)
      && !BasicBlockEdge_isWeakTop(this,&devnull);
}

#line 2467 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
bool
BasicBlockEdge_isConditional(BasicBlockEdge E)
{
  BasicBlock orig = BasicBlockEdge_origBlock(E);
  Operation goto_operation =  BasicBlock_getControlOperation(orig);
  return goto_operation != NULL
      && Operation_isConditional(goto_operation);
}

#line 2476 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
static void
BasicBlock_reflectEnterEdgesOrder(BasicBlock this)
{
  int32_t argIndex;
  Except_CHECK(BasicBlock_ENTERCOUNT(this) > 0);
  if(BasicBlock_ENTERCOUNT(this) > 1) {
    for(argIndex = 0; argIndex < BasicBlock_ENTERCOUNT(this) - 1; ++argIndex) {
      BasicBlockEdge edge = BasicBlock_ENTEREDGES(this)[argIndex];
      *BasicBlockEdge__ENTERNEXT(edge) = BasicBlock_ENTEREDGES(this)[argIndex + 1];
    }
    *BasicBlockEdge__ENTERNEXT(BasicBlock_ENTEREDGES(this)[argIndex]) = NULL;
    *BasicBlock__ENTERFIRST(this) = BasicBlock_ENTEREDGES(this)[0];
  }
}

#line 2497 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
BasicBlock
BasicBlockEdge_splitFalse(struct CodeRegion_* codeRegion, BasicBlockEdge this)
{
  float probAB = BasicBlockEdge_probability(this);
  BasicBlock bbA = BasicBlockEdge_origBlock(this);
  BasicBlock bbB = BasicBlockEdge_destBlock(this);
  float freqC = probAB * BasicBlock_frequency(bbA);
  // Create the new basic block on the critical edge
  BasicBlock bbC = CodeRegion_makeBasicBlock(codeRegion, freqC);
  int32_t enterIdx = BasicBlockEdge_ARGINDEX(this);
  BasicBlockEdge edgeBC;
  Except_CHECK(enterIdx >= 0);
  Except_CHECK(BasicBlock_ENTEREDGES(bbB)[enterIdx] == this);
  Except_CHECK(BasicBlockEdge_isFalse(this, NULL));
  BasicBlock_makeLabel(bbC); // Add a label to the basic block
  // Inserted new block between A and B
  Procedure_chainBasicBlocks(CodeRegion_procedure(codeRegion), bbA, bbC);
  //
  BasicBlock_killEdge(bbA, this);
  BasicBlock_makeEdge(bbA, bbC, probAB);
  edgeBC = BasicBlock_makeEdge(bbC, bbB, 1.0);
  // Update basic block edge information
  // TODO MERGE: It seems that this function discard the
  // codeRegion field of basic block. Is it ok to call it??
  if (CodeRegion_ssaForm(codeRegion) != NULL)
    BasicBlock_makeEnterEdges(bbC, SSAForm_memory(CodeRegion_ssaForm(codeRegion)), 0);
  // update enter edges. Be careful to not break the list order, since we use it in PHI
  //BasicBlock_makeEnterEdges(bbB, Procedure_memory(CodeRegion_procedure(codeRegion)), 0);
  if(enterIdx != -1) {
    BasicBlock_ENTEREDGES(bbB)[enterIdx] = edgeBC;
  } else {
    Except_CHECK(BasicBlock_ENTEREDGES(bbB) == NULL);
    Except_CHECK(BasicBlock_ENTERFIRST(bbB) == edgeBC);
  }
  *BasicBlockEdge__ARGINDEX(edgeBC) = enterIdx;
  // To have a display that keeps PHI arguments order
  BasicBlock_reflectEnterEdgesOrder(bbB);
  return bbC;
}

#line 2543 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
BasicBlock
BasicBlockEdge_splitCritical(struct CodeRegion_* codeRegion, BasicBlockEdge this)
{
  Operation branch;
  BasicBlock bbA = BasicBlockEdge_origBlock(this);
  BasicBlock bbB = BasicBlockEdge_destBlock(this);
  float probAB = BasicBlockEdge_probability(this);
  float freqC = probAB * BasicBlock_frequency(bbA);
  int32_t enterIdx = BasicBlockEdge_ARGINDEX(this);
  BasicBlockEdge edgeBC;
  //
  // Create the new basic block on the critical edge.
  // The basic block will be inserted last in the linear block list.
  BasicBlock bbC = CodeRegion_makeBasicBlock(codeRegion, freqC);
  Label labelC = BasicBlock_makeLabel(bbC);
  //
  // Insert a branch from bbC to bbB
  Label labelB = BasicBlock_makeLabel(bbB);
  Except_CHECK(enterIdx >= 0);
  Except_CHECK(BasicBlock_ENTEREDGES(bbB)[enterIdx] == this);
  //
  Selector_selectGOTO(BasicBlock_selector(bbC), labelB);
  //
  // Reroute bbA branch to bbC
  branch = BasicBlock_getControlOperation(bbA);
  Except_CHECK(branch != NULL);
  Except_CHECK(!BasicBlockEdge_isFalse(this, NULL) && "no target to update");
  Procedure_updateTargetedOperation(CodeRegion_procedure(codeRegion), branch, labelC);
    //
  BasicBlock_killEdge(bbA, this);
  BasicBlock_makeEdge(bbA, bbC, probAB);
  edgeBC = BasicBlock_makeEdge(bbC, bbB, 1.0);
  //
  // Update basic block edge information
  // TODO MERGE: It seems that this function discard the
  // codeRegion field of basic block. Is it ok to call it??
  BasicBlock_makeEnterEdges(bbC, Procedure_memory(CodeRegion_procedure(codeRegion)), 0);
  //BasicBlock_makeEnterEdges(bbB, Procedure_memory(CodeRegion_procedure(codeRegion)), 0);
  if(enterIdx != -1) {
    BasicBlock_ENTEREDGES(bbB)[enterIdx] = edgeBC;
  } else {
    Except_CHECK(BasicBlock_ENTEREDGES(bbB) == NULL);
    Except_CHECK(BasicBlock_ENTERFIRST(bbB) == edgeBC);
  }
  *BasicBlockEdge__ARGINDEX(edgeBC) = enterIdx;
  // To have a display that keeps PHI arguments order
  BasicBlock_reflectEnterEdgesOrder(bbB);
  //
  return bbC;
}

#line 2615 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
BasicBlock
BasicBlockEdge_splitAndAction(BasicBlockEdge edge, bool canReuseBB, 
                              Operation *point, void* structParam,
                              void (*action)(BasicBlock, Operation, void*)) {
  BasicBlock destinationBlock = BasicBlockEdge_destBlock(edge);
  // NULL means begin of the basic block
  Operation pointForInsertionAfter = NULL;
  if(canReuseBB && (!BasicBlockEdge_isFalse(edge, NULL)
                    || BasicBlock_getControlOperation(BasicBlockEdge_origBlock(edge)) == NULL)
     && BasicBlock_leaveCount(BasicBlockEdge_origBlock(edge)) == 1
     && BasicBlock_enterCount(destinationBlock) != 1) {
    // edge is not false || no control operation -> control operation is not call
    // orig's leave count == 1 && dest's enter count != 1 ->
    // control operation is a goto. So it is stupid to split the edge whereas
    // we can put code in orig block with a gain on scheduling
    destinationBlock = BasicBlockEdge_origBlock(edge);
    pointForInsertionAfter = BasicBlock_lastOperation(destinationBlock);
    if(pointForInsertionAfter != NULL
       && Operator_isControl(Operation_operator(pointForInsertionAfter))) {
      pointForInsertionAfter = Operation_prev(pointForInsertionAfter);
    }
  } else {
    if(BasicBlock_enterCount(destinationBlock) != 1 || !canReuseBB) {
      // Create a new basic block between them.
      // Update jump origin (done be split call)
      // Create jump to destination in new basic block (done be split call)
      if(BasicBlockEdge_isFalse(edge, NULL)) {
        destinationBlock =
          BasicBlockEdge_splitFalse(BasicBlock_codeRegion(destinationBlock), edge);
      } else {
        destinationBlock =
          BasicBlockEdge_splitCritical(BasicBlock_codeRegion(destinationBlock),
                                       edge);
      }
    }
  }
  if(action != NULL) {
    action(destinationBlock, pointForInsertionAfter, structParam);
  }
  if(point != NULL) {
    *point = pointForInsertionAfter;
  }
  return destinationBlock;
}

#line 2666 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
void
BasicBlockEdge_split(BasicBlockEdge edge)
{
  BasicBlock destinationBlock = BasicBlockEdge_destBlock(edge);
  CodeRegion codeRegion = BasicBlock_codeRegion(destinationBlock);
  if(BasicBlock_enterCount(destinationBlock) != 1) {
    if(BasicBlockEdge_isFalse(edge, NULL)) {
      destinationBlock = BasicBlockEdge_splitFalse(codeRegion, edge);
    } else {
      destinationBlock = BasicBlockEdge_splitCritical(codeRegion, edge);
    }
  }
}

#line 2688 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
void
BasicBlock_splitLeaveEdgeAndAction(BasicBlock block, bool canReuseBB,
                                   void* structParam,
                                   void (*action)(BasicBlock, Operation, void*))
{
  BasicBlock_LEAVE_FOREACH_BasicBlockEdge(block, edge) {
    BasicBlockEdge_splitAndAction(edge, canReuseBB, NULL, structParam, action);
  } BasicBlock_LEAVE_ENDEACH_BasicBlockEdge;
}

#line 2699 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 2705 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
#ifndef ECL_NTRACE
bool
BasicBlock_DTD(FILE *file)
{
  fputs(
        "<!ENTITY % Operations 'IDREFS' >"
        "<!ENTITY % Processor 'IDREF' >"
        "<!ENTITY % Labels 'IDREFS' >"
        "<!ENTITY % Edges 'IDREFS' >"
        "<!ELEMENT BasicBlock EMPTY >"
        "<!ATTLIST BasicBlock"
        "	  ID ID #REQUIRED"
        "	  HeaderBlock %BasicBlock; #IMPLIED"
        "	  Frequency %float; #IMPLIED"
        "	  Processor %Processor; #IMPLIED"
        "	  Unrolled %uint16_t; #IMPLIED"
        "	  LabelCount %int16_t; #IMPLIED"
        "	  Labels %Labels; #IMPLIED"
        "	  OperationCount %int16_t; #IMPLIED"
        "	  Operations %Operations; #IMPLIED"
        "	  RegionId %int16_t; #IMPLIED"
        "	  TraceId %int16_t; #IMPLIED"
        "	  Flags NMTOKENS #IMPLIED"
        "	  Predecessors %Edges; #IMPLIED"
        "	  Successors %Edges; #IMPLIED"
	"	  ProbabilitySucc NMTOKENS #IMPLIED"
        ">"
       , file);
  return true;
}
#endif//ECL_NTRACE

#line 2752 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
#ifndef ECL_NTRACE
bool
BasicBlock_dumpXML(BasicBlock this,  XMLGen gen)
{
  char attval[1024]="";
  char attLabel[1024]="";
  int oper=0;
  Processor processor = BasicBlock_processor(this);
  LoopScope loopScope = BasicBlock_LOOPSCOPE(this);
  BasicBlock headerBlock = loopScope != NULL?
    LoopScope_HEADERBLOCK(loopScope): NULL;
  BasicBlock_FOREACH_Label(this, label){
    Label_dumpXML(label, gen);
    sprintf(attLabel, "%s Label_%d ", attLabel, Label_IDENTITY(label));
  }BasicBlock_ENDEACH_Label; 
  BasicBlock_FOREACH_Operation(this, operation){
    Operation_dumpXML(operation, gen);
  }BasicBlock_ENDEACH_Operation;
  {
    XMLGenElement elemBasic = XMLGen_declareElement(gen, "BasicBlock");
    XMLGenAttribute attID = XMLGen_declareAttribute(gen, "ID");
    XMLGenAttribute attHeader = XMLGen_declareAttribute(gen, "HeaderBlock");
    XMLGenAttribute attFreq = XMLGen_declareAttribute(gen, "Frequency");
    XMLGenAttribute attRegion = XMLGen_declareAttribute(gen, "RegionId");
    XMLGenAttribute attTrace = XMLGen_declareAttribute(gen, "TraceId");
    XMLGenAttribute attProcessor = XMLGen_declareAttribute(gen, "Processor");
    XMLGenAttribute attOper = XMLGen_declareAttribute(gen, "Operations");
    XMLGenAttribute attLabels = XMLGen_declareAttribute(gen, "Labels");
    XMLGenAttribute attPred = XMLGen_declareAttribute(gen, "Predecessors");
    XMLGenAttribute attSuc = XMLGen_declareAttribute(gen, "Successors"); 
    XMLGenAttribute attProbSucc = XMLGen_declareAttribute(gen, "ProbabilitySucc"); 
    XMLGenAttribute attFlags = XMLGen_declareAttribute(gen, "Flags");  
    XMLGen_startElement(gen, elemBasic);
    sprintf(attval, "BasicBlock_%d",BasicBlock_IDENTITY(this));
    XMLGen_addAttribute(gen, attID, attval);
    if (headerBlock != NULL) {
      sprintf(attval, "BasicBlock_%d", BasicBlock_IDENTITY(headerBlock));
      XMLGen_addAttribute(gen, attHeader, attval);
    }
    sprintf(attval, "%g", BasicBlock_FREQUENCY(this));
    XMLGen_addAttribute(gen, attFreq, attval);
    sprintf(attval, "%x",BasicBlock_regionId(this));
    XMLGen_addAttribute(gen, attRegion, attval);
    sprintf(attval, "%d",BasicBlock_TRACEID(this));
    XMLGen_addAttribute(gen, attTrace, attval);
    sprintf(attval, "Processor_%s",Processor_name_(processor));
    XMLGen_addAttribute(gen, attProcessor, attval);
    attval[0]='\0';
    if (BasicBlock_isEntry(this))
      sprintf(attval, "%s Entry ", attval);
    if (BasicBlock_isExit(this))
      sprintf(attval, "%s Exit ", attval);
    if (BasicBlock_isStart(this))
      sprintf(attval, "%s Start ", attval);
    if (BasicBlock_isNatural(this))
      sprintf(attval, "%s Natural ", attval);
    if (BasicBlock_isWidening(this))
      sprintf(attval, "%s Widening ", attval);
    if (BasicBlock_isScheduled(this))
      sprintf(attval, "%s Scheduled ", attval);
    if (BasicBlock_isAllocated(this))
      sprintf(attval, "%s Allocated ", attval);
    if (BasicBlock_hasGNUASM(this))
      sprintf(attval, "%s GNUASM ", attval);
    if (strcmp(attval,"\0"))
      XMLGen_addAttribute(gen, attFlags, attval);
    attval[0]='\0';
    BasicBlock_FOREACH_Operation(this, operation){
      oper=1;
      sprintf(attval, "%s Operation_%d ", attval, Operation_IDENTITY(operation));
    }BasicBlock_ENDEACH_Operation;
    if (oper)
      XMLGen_addAttribute(gen, attOper, attval);
    if (BasicBlock_LABELCOUNT(this)>0)
     XMLGen_addAttribute(gen, attLabels, attLabel);
    attval[0]='\0';
    BasicBlock_ENTER_FOREACH_BasicBlockEdge(this, edge){
      BasicBlock origBlock = BasicBlockEdge_origBlock(edge);
      sprintf(attval, "%s BasicBlock_%d ", attval,
              BasicBlock_identity(origBlock));
    }BasicBlock_ENTER_ENDEACH_BasicBlockEdge;
    XMLGen_addAttribute(gen, attPred, attval);
    attLabel[0]='\0';
    attval[0]='\0';
    BasicBlock_LEAVE_FOREACH_BasicBlockEdge(this, edge){
      BasicBlock destBlock = BasicBlockEdge_destBlock(edge);
      sprintf(attval, "%s BasicBlock_%d ", attval,
              BasicBlock_identity(destBlock));
      sprintf(attLabel, "%s %f ", attLabel,
	      BasicBlockEdge_probability(edge));
    }BasicBlock_LEAVE_ENDEACH_BasicBlockEdge;
    XMLGen_addAttribute(gen, attSuc, attval);
    XMLGen_addAttribute(gen, attProbSucc, attLabel);
    XMLGen_endEmptyElement(gen);
  }
  return true;
}
#endif//ECL_NTRACE

#line 2852 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 2860 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
IndexedFactory_ BasicBlock_Factory[1];

#line 2862 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
void
BasicBlock_INIT(void)
{
  IndexedFactory_Ctor(BasicBlock_Factory);
#ifndef ECL_NTRACE
  ETable_Ctor(BasicBlockFlag_Table, Memory_Root, BasicBlockFlagEntries);
#endif//ECL_NTRACE
}

#line 2881 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
#ifndef ECL_NTRACE
void
BasicBlock_FINI(void)
{
  ETable_Dtor(BasicBlockFlag_Table);
}
#endif//ECL_NTRACE

#line 2889 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
#if XCC__C
static void
BasicBlock_TEST(void)
{
#include "LIR/BasicBlock_.c"
}

#line 2896 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/LIR/BasicBlock.xcc"
int
main(int argc, char **argv)
{
  LIR_Test(BasicBlock_TEST);
  return 0;
}
#endif


#endif//BasicBlock_c_INCLUDED
