#ifndef Decode_c_INCLUDED
#define Decode_c_INCLUDED

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Decode.xcc"
#include "MDS/MDS_.h"

#line 21 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Decode.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 33 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Decode.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 50 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Decode.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 69 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Decode.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 86 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Decode.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 104 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Decode.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 106 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Decode.xcc"
/*
 * Decode_Operand functions.
 */
#define WORDTYPE(type) type
#define DECODE(e) e
#define METHOD(type, name) Decode_##type##_##name(VALUE, result)
#define Operand(NAME, METHOD, WORDTYPE, ENCODE, DECODE) \
void \
Decode_Operand_##NAME(const void *opcodes, void *restrict result) \
{ \
  const WORDTYPE *restrict WORDS = opcodes; \
  OperandEncoded VALUE = 0; \
  DECODE; \
  METHOD; \
}
#include "Operand.enum"
#undef METHOD
#undef DECODE
#undef WORDTYPE

#line 126 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Decode.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 135 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Decode.xcc"
/*
 * Decode_Operands functions.
 */
#ifndef NDECODE
#define DECODE(e) e
#define Operands(NAME, OPERANDS, RELOCATABLE, ENCODE, DECODE) \
void \
Decode_Operands_##NAME(const void *opcodes, OperandsBuffer buffer) \
{ \
  DECODE; \
}
#include "Operand.enum"
#undef DECODE
void
Decode_Operands_(const void *restrict opcodes, OperandsBuffer buffer)
{
}
#endif//NDECODE

#line 154 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Decode.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 166 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Decode.xcc"
#if XCC__C
static void
Decode_TEST(void)
{
#include "MDS/Decode_.c"
}

#line 173 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Decode.xcc"
int
main(int argc, char **argv)
{
  MDS_Test(Decode_TEST);
  return 0;
}
#endif

#line 7 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/st200/Decode.xcc"
#ifndef NDECODE
Instance
Decode_Encoding_st220_ANY(const void *buffer)
{
  uint32_t opcode = *(const uint32_t *)buffer;
  switch ((opcode >> 26) & 0x0000001f) {
  case 0x00000000:
    switch ((opcode >> 18) & 0x000000ff) {
    case 0x00000000:
      switch ((opcode >> 0) & 0x0000003f) {
      case 0x00000000:
        switch ((opcode >> 6) & 0x00000fff) {
        case 0x00000000:
          return Instance_st220_nop;
        default:
          return Instance_st220_mov_dest_src2;
          break;
        }
        return Instance__UNDEF;
      default:
        return Instance_st220_add_dest_src1_src2;
        break;
      }
      return Instance__UNDEF;
    case 0x00000008:
      return Instance_st220_sub_dest_src2_src1;
    case 0x00000010:
      return Instance_st220_shl_dest_src1_src2;
    case 0x00000018:
      return Instance_st220_shr_dest_src1_src2;
    case 0x00000020:
      return Instance_st220_shru_dest_src1_src2;
    case 0x00000028:
      return Instance_st220_sh1add_dest_src1_src2;
    case 0x00000030:
      return Instance_st220_sh2add_dest_src1_src2;
    case 0x00000038:
      return Instance_st220_sh3add_dest_src1_src2;
    case 0x00000040:
      return Instance_st220_sh4add_dest_src1_src2;
    case 0x00000048:
      return Instance_st220_and_dest_src1_src2;
    case 0x00000050:
      return Instance_st220_andc_dest_src1_src2;
    case 0x00000058:
      return Instance_st220_or_dest_src1_src2;
    case 0x00000060:
      return Instance_st220_orc_dest_src1_src2;
    case 0x00000068:
      return Instance_st220_xor_dest_src1_src2;
    case 0x00000078:
      return Instance_st220_mullhus_nldest_src1_src2;
    case 0x00000080:
      return Instance_st220_max_dest_src1_src2;
    case 0x00000088:
      return Instance_st220_maxu_dest_src1_src2;
    case 0x00000090:
      return Instance_st220_min_dest_src1_src2;
    case 0x00000098:
      return Instance_st220_minu_dest_src1_src2;
    case 0x000000a0:
      return Instance_st220_mulhhs_nldest_src1_src2;
    case 0x000000a8:
      return Instance_st220_mull_nldest_src1_src2;
    case 0x000000b0:
      return Instance_st220_mullu_nldest_src1_src2;
    case 0x000000b8:
      return Instance_st220_mulh_nldest_src1_src2;
    case 0x000000c0:
      return Instance_st220_mulhu_nldest_src1_src2;
    case 0x000000c8:
      return Instance_st220_mulll_nldest_src1_src2;
    case 0x000000d0:
      return Instance_st220_mulllu_nldest_src1_src2;
    case 0x000000d8:
      return Instance_st220_mullh_nldest_src1_src2;
    case 0x000000e0:
      return Instance_st220_mullhu_nldest_src1_src2;
    case 0x000000e8:
      return Instance_st220_mulhh_nldest_src1_src2;
    case 0x000000f0:
      return Instance_st220_mulhhu_nldest_src1_src2;
    case 0x000000f8:
      return Instance_st220_mulhs_nldest_src1_src2;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x00000001:
    switch ((opcode >> 21) & 0x0000001f) {
    case 0x00000000:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_cmpeq_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000001:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_cmpne_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000002:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_cmpge_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000003:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_cmpgeu_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000004:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_cmpgt_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000005:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_cmpgtu_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000006:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_cmple_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000007:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_cmpleu_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000008:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_cmplt_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000009:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_cmpltu_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000000a:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_andl_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000000b:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_nandl_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000000c:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_orl_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000000d:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_norl_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000010:
      switch ((opcode >> 12) & 0x0000003f) {
      case 0x00000000:
        return Instance_st220_cmpeq_bdest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000011:
      switch ((opcode >> 12) & 0x0000003f) {
      case 0x00000000:
        return Instance_st220_cmpne_bdest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000012:
      switch ((opcode >> 12) & 0x0000003f) {
      case 0x00000000:
        return Instance_st220_cmpge_bdest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000013:
      switch ((opcode >> 12) & 0x0000003f) {
      case 0x00000000:
        return Instance_st220_cmpgeu_bdest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000014:
      switch ((opcode >> 12) & 0x0000003f) {
      case 0x00000000:
        return Instance_st220_cmpgt_bdest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000015:
      switch ((opcode >> 12) & 0x0000003f) {
      case 0x00000000:
        return Instance_st220_cmpgtu_bdest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000016:
      switch ((opcode >> 12) & 0x0000003f) {
      case 0x00000000:
        return Instance_st220_cmple_bdest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000017:
      switch ((opcode >> 12) & 0x0000003f) {
      case 0x00000000:
        return Instance_st220_cmpleu_bdest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000018:
      switch ((opcode >> 12) & 0x0000003f) {
      case 0x00000000:
        return Instance_st220_cmplt_bdest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000019:
      switch ((opcode >> 12) & 0x0000003f) {
      case 0x00000000:
        return Instance_st220_cmpltu_bdest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000001a:
      switch ((opcode >> 12) & 0x0000003f) {
      case 0x00000000:
        return Instance_st220_andl_bdest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000001b:
      switch ((opcode >> 12) & 0x0000003f) {
      case 0x00000000:
        return Instance_st220_nandl_bdest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000001c:
      switch ((opcode >> 12) & 0x0000003f) {
      case 0x00000000:
        switch ((opcode >> 6) & 0x0000003f) {
        case 0x00000000:
          return Instance_st220_convib_bdest_src1;
        default:
          return Instance_st220_orl_bdest_src1_src2;
          break;
        }
        return Instance__UNDEF;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000001d:
      switch ((opcode >> 12) & 0x0000003f) {
      case 0x00000000:
        return Instance_st220_norl_bdest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x00000002:
    switch ((opcode >> 21) & 0x0000001f) {
    case 0x00000000:
      switch ((opcode >> 0) & 0x0000003f) {
      case 0x00000000:
        return Instance_st220_mov_idest_isrc2;
      default:
        return Instance_st220_add_idest_src1_isrc2;
        break;
      }
      return Instance__UNDEF;
    case 0x00000001:
      return Instance_st220_sub_idest_isrc2_src1;
    case 0x00000002:
      return Instance_st220_shl_idest_src1_isrc2;
    case 0x00000003:
      return Instance_st220_shr_idest_src1_isrc2;
    case 0x00000004:
      return Instance_st220_shru_idest_src1_isrc2;
    case 0x00000005:
      return Instance_st220_sh1add_idest_src1_isrc2;
    case 0x00000006:
      return Instance_st220_sh2add_idest_src1_isrc2;
    case 0x00000007:
      return Instance_st220_sh3add_idest_src1_isrc2;
    case 0x00000008:
      return Instance_st220_sh4add_idest_src1_isrc2;
    case 0x00000009:
      switch ((opcode >> 12) & 0x000001ff) {
      case 0x000000ff:
        return Instance_st220_zxtb_idest_src1;
      default:
        return Instance_st220_and_idest_src1_isrc2;
        break;
      }
      return Instance__UNDEF;
    case 0x0000000a:
      return Instance_st220_andc_idest_src1_isrc2;
    case 0x0000000b:
      return Instance_st220_or_idest_src1_isrc2;
    case 0x0000000c:
      return Instance_st220_orc_idest_src1_isrc2;
    case 0x0000000d:
      return Instance_st220_xor_idest_src1_isrc2;
    case 0x0000000e:
      switch ((opcode >> 12) & 0x000001ff) {
      case 0x00000000:
        return Instance_st220_sxtb_idest_src1;
      case 0x00000001:
        return Instance_st220_sxth_idest_src1;
      case 0x00000002:
        return Instance_st220_bswap_idest_src1;
      case 0x00000003:
        return Instance_st220_zxth_idest_src1;
      case 0x00000004:
        return Instance_st220_clz_idest_src1;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000000f:
      return Instance_st220_mullhus_nlidest_src1_isrc2;
    case 0x00000010:
      return Instance_st220_max_idest_src1_isrc2;
    case 0x00000011:
      return Instance_st220_maxu_idest_src1_isrc2;
    case 0x00000012:
      return Instance_st220_min_idest_src1_isrc2;
    case 0x00000013:
      return Instance_st220_minu_idest_src1_isrc2;
    case 0x00000014:
      return Instance_st220_mulhhs_nlidest_src1_isrc2;
    case 0x00000015:
      return Instance_st220_mull_nlidest_src1_isrc2;
    case 0x00000016:
      return Instance_st220_mullu_nlidest_src1_isrc2;
    case 0x00000017:
      return Instance_st220_mulh_nlidest_src1_isrc2;
    case 0x00000018:
      return Instance_st220_mulhu_nlidest_src1_isrc2;
    case 0x00000019:
      return Instance_st220_mulll_nlidest_src1_isrc2;
    case 0x0000001a:
      return Instance_st220_mulllu_nlidest_src1_isrc2;
    case 0x0000001b:
      return Instance_st220_mullh_nlidest_src1_isrc2;
    case 0x0000001c:
      return Instance_st220_mullhu_nlidest_src1_isrc2;
    case 0x0000001d:
      return Instance_st220_mulhh_nlidest_src1_isrc2;
    case 0x0000001e:
      return Instance_st220_mulhhu_nlidest_src1_isrc2;
    case 0x0000001f:
      return Instance_st220_mulhs_nlidest_src1_isrc2;
      break;
    }
    return Instance__UNDEF;
  case 0x00000003:
    switch ((opcode >> 21) & 0x0000001f) {
    case 0x00000000:
      return Instance_st220_cmpeq_idest_src1_isrc2;
    case 0x00000001:
      return Instance_st220_cmpne_idest_src1_isrc2;
    case 0x00000002:
      return Instance_st220_cmpge_idest_src1_isrc2;
    case 0x00000003:
      return Instance_st220_cmpgeu_idest_src1_isrc2;
    case 0x00000004:
      return Instance_st220_cmpgt_idest_src1_isrc2;
    case 0x00000005:
      return Instance_st220_cmpgtu_idest_src1_isrc2;
    case 0x00000006:
      return Instance_st220_cmple_idest_src1_isrc2;
    case 0x00000007:
      return Instance_st220_cmpleu_idest_src1_isrc2;
    case 0x00000008:
      return Instance_st220_cmplt_idest_src1_isrc2;
    case 0x00000009:
      return Instance_st220_cmpltu_idest_src1_isrc2;
    case 0x0000000a:
      return Instance_st220_andl_idest_src1_isrc2;
    case 0x0000000b:
      return Instance_st220_nandl_idest_src1_isrc2;
    case 0x0000000c:
      return Instance_st220_orl_idest_src1_isrc2;
    case 0x0000000d:
      return Instance_st220_norl_idest_src1_isrc2;
    case 0x00000010:
      switch ((opcode >> 9) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_cmpeq_ibdest_src1_isrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000011:
      switch ((opcode >> 9) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_cmpne_ibdest_src1_isrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000012:
      switch ((opcode >> 9) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_cmpge_ibdest_src1_isrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000013:
      switch ((opcode >> 9) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_cmpgeu_ibdest_src1_isrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000014:
      switch ((opcode >> 9) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_cmpgt_ibdest_src1_isrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000015:
      switch ((opcode >> 9) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_cmpgtu_ibdest_src1_isrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000016:
      switch ((opcode >> 9) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_cmple_ibdest_src1_isrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000017:
      switch ((opcode >> 9) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_cmpleu_ibdest_src1_isrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000018:
      switch ((opcode >> 9) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_cmplt_ibdest_src1_isrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000019:
      switch ((opcode >> 9) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_cmpltu_ibdest_src1_isrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000001a:
      switch ((opcode >> 9) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_andl_ibdest_src1_isrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000001b:
      switch ((opcode >> 9) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_nandl_ibdest_src1_isrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000001c:
      switch ((opcode >> 9) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_orl_ibdest_src1_isrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000001d:
      switch ((opcode >> 9) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_norl_ibdest_src1_isrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x00000004:
    switch ((opcode >> 24) & 0x00000003) {
    case 0x00000000:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_slct_dest_scond_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000001:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_slctf_dest_scond_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000002:
      return Instance_st220_addcg_dest_bdest_src1_src2_scond;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x00000005:
    switch ((opcode >> 24) & 0x00000003) {
    case 0x00000000:
      return Instance_st220_divs_dest_bdest_src1_src2_scond;
    case 0x00000001:
      switch ((opcode >> 23) & 0x00000001) {
      case 0x00000000:
        return Instance_st220_imml_imm;
      case 0x00000001:
        return Instance_st220_immr_imm;
        break;
      }
      return Instance__UNDEF;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x00000006:
    switch ((opcode >> 24) & 0x00000003) {
    case 0x00000000:
      return Instance_st220_slct_idest_scond_src1_isrc2;
    case 0x00000001:
      switch ((opcode >> 12) & 0x000001ff) {
      case 0x00000001:
        switch ((opcode >> 0) & 0x0000003f) {
        case 0x00000000:
          return Instance_st220_convbi_idest_scond;
        default:
          return Instance_st220_slctf_idest_scond_src1_isrc2;
          break;
        }
        return Instance__UNDEF;
      default:
        return Instance_st220_slctf_idest_scond_src1_isrc2;
        break;
      }
      return Instance__UNDEF;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x00000007:
    switch ((opcode >> 21) & 0x0000001f) {
    case 0x0000001c:
      switch ((opcode >> 0) & 0x001fffff) {
      case 0x00000000:
        return Instance_st220_prgins;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000001d:
      switch ((opcode >> 31) & 0x00000001) {
      case 0x00000001:
        return Instance_st220_sbrk_sbrknum;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000001e:
      return Instance_st220_syscall_sbrknum;
    case 0x0000001f:
      switch ((opcode >> 0) & 0x001fffff) {
      case 0x00000000:
        return Instance_st220_break;
      default:
        break;
      }
      return Instance__UNDEF;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x00000008:
    switch ((opcode >> 21) & 0x0000001f) {
    case 0x00000000:
      return Instance_st220_ldw_idest_isrc2_src1;
    case 0x00000004:
      return Instance_st220_ldw_d_idest_isrc2_src1;
    case 0x00000008:
      return Instance_st220_ldh_nlidest_isrc2_src1;
    case 0x0000000c:
      return Instance_st220_ldh_d_nlidest_isrc2_src1;
    case 0x00000010:
      return Instance_st220_ldhu_nlidest_isrc2_src1;
    case 0x00000014:
      return Instance_st220_ldhu_d_nlidest_isrc2_src1;
    case 0x00000018:
      return Instance_st220_ldb_nlidest_isrc2_src1;
    case 0x0000001c:
      return Instance_st220_ldb_d_nlidest_isrc2_src1;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x00000009:
    switch ((opcode >> 21) & 0x0000001f) {
    case 0x00000000:
      return Instance_st220_ldbu_nlidest_isrc2_src1;
    case 0x00000004:
      return Instance_st220_ldbu_d_nlidest_isrc2_src1;
    case 0x00000008:
      return Instance_st220_stw_isrc2_src1_src2;
    case 0x0000000c:
      return Instance_st220_sth_isrc2_src1_src2;
    case 0x00000010:
      return Instance_st220_stb_isrc2_src1_src2;
    case 0x00000014:
      switch ((opcode >> 6) & 0x0000003f) {
      case 0x00000000:
        return Instance_st220_pft_isrc2_src1;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000018:
      switch ((opcode >> 6) & 0x0000003f) {
      case 0x00000000:
        return Instance_st220_prgadd_isrc2_src1;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000001c:
      switch ((opcode >> 6) & 0x0000003f) {
      case 0x00000000:
        return Instance_st220_prgset_isrc2_src1;
      default:
        break;
      }
      return Instance__UNDEF;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x0000000a:
    switch ((opcode >> 0) & 0x03ffffff) {
    case 0x00000000:
      return Instance_st220_sync;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x0000000b:
    switch ((opcode >> 21) & 0x0000001f) {
    case 0x00000000:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_asm_0_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000001:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_asm_1_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000002:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_asm_2_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000003:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_asm_3_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000004:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_asm_4_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000005:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_asm_5_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000006:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_asm_6_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000007:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_asm_7_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000008:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_asm_8_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000009:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_asm_9_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000000a:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_asm_10_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000000b:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_asm_11_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000000c:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_asm_12_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000000d:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_asm_13_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000000e:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_asm_14_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000000f:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_asm_15_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000010:
      return Instance_st220_asm_16_idest_src1_isrc2;
    case 0x00000011:
      return Instance_st220_asm_17_idest_src1_isrc2;
    case 0x00000012:
      return Instance_st220_asm_18_idest_src1_isrc2;
    case 0x00000013:
      return Instance_st220_asm_19_idest_src1_isrc2;
    case 0x00000014:
      return Instance_st220_asm_20_idest_src1_isrc2;
    case 0x00000015:
      return Instance_st220_asm_21_idest_src1_isrc2;
    case 0x00000016:
      return Instance_st220_asm_22_idest_src1_isrc2;
    case 0x00000017:
      return Instance_st220_asm_23_idest_src1_isrc2;
    case 0x00000018:
      return Instance_st220_asm_24_idest_src1_isrc2;
    case 0x00000019:
      return Instance_st220_asm_25_idest_src1_isrc2;
    case 0x0000001a:
      return Instance_st220_asm_26_idest_src1_isrc2;
    case 0x0000001b:
      return Instance_st220_asm_27_idest_src1_isrc2;
    case 0x0000001c:
      return Instance_st220_asm_28_idest_src1_isrc2;
    case 0x0000001d:
      return Instance_st220_asm_29_idest_src1_isrc2;
    case 0x0000001e:
      return Instance_st220_asm_30_idest_src1_isrc2;
    case 0x0000001f:
      return Instance_st220_asm_31_idest_src1_isrc2;
      break;
    }
    return Instance__UNDEF;
  case 0x0000000c:
    switch ((opcode >> 23) & 0x00000007) {
    case 0x00000000:
      return Instance_st220_call_btarg;
    case 0x00000001:
      switch ((opcode >> 0) & 0x007fffff) {
      case 0x00000000:
        return Instance_st220_icall;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000002:
      switch ((opcode >> 0) & 0x007fffff) {
      case 0x00000001:
        return Instance_st220_syncins;
      default:
        return Instance_st220_goto_btarg;
        break;
      }
      return Instance__UNDEF;
    case 0x00000003:
      switch ((opcode >> 0) & 0x007fffff) {
      case 0x00000000:
        return Instance_st220_igoto;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000004:
      switch ((opcode >> 0) & 0x007fffff) {
      case 0x00000000:
        return Instance_st220_rfi;
      default:
        break;
      }
      return Instance__UNDEF;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x0000000e:
    return Instance_st220_br_bcond_btarg;
  case 0x0000000f:
    return Instance_st220_brf_bcond_btarg;
  default:
    break;
  }
  return Instance__UNDEF;
}
#endif//NDECODE

#line 965 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/st200/Decode.xcc"
#ifndef NDECODE
Instance
Decode_Encoding_st220_ANYX(const void *buffer)
{
  uint32_t opcode = *(const uint32_t *)buffer;
  switch ((opcode >> 24) & 0x0000007f) {
  case 0x00000008:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      switch ((opcode >> 0) & 0x0000003f) {
      case 0x00000000:
        return Instance_st220_mov_idest_xsrc2;
      default:
        return Instance_st220_add_idest_src1_xsrc2;
        break;
      }
      return Instance__UNDEF;
    case 0x00000001:
      return Instance_st220_sub_idest_xsrc2_src1;
    case 0x00000002:
      return Instance_st220_shl_idest_src1_xsrc2;
    case 0x00000003:
      return Instance_st220_shr_idest_src1_xsrc2;
    case 0x00000004:
      return Instance_st220_shru_idest_src1_xsrc2;
    case 0x00000005:
      return Instance_st220_sh1add_idest_src1_xsrc2;
    case 0x00000006:
      return Instance_st220_sh2add_idest_src1_xsrc2;
    case 0x00000007:
      return Instance_st220_sh3add_idest_src1_xsrc2;
      break;
    }
    return Instance__UNDEF;
  case 0x00000009:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      return Instance_st220_sh4add_idest_src1_xsrc2;
    case 0x00000001:
      return Instance_st220_and_idest_src1_xsrc2;
    case 0x00000002:
      return Instance_st220_andc_idest_src1_xsrc2;
    case 0x00000003:
      return Instance_st220_or_idest_src1_xsrc2;
    case 0x00000004:
      return Instance_st220_orc_idest_src1_xsrc2;
    case 0x00000005:
      return Instance_st220_xor_idest_src1_xsrc2;
    case 0x00000007:
      return Instance_st220_mullhus_nlidest_src1_xsrc2;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x0000000a:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      return Instance_st220_max_idest_src1_xsrc2;
    case 0x00000001:
      return Instance_st220_maxu_idest_src1_xsrc2;
    case 0x00000002:
      return Instance_st220_min_idest_src1_xsrc2;
    case 0x00000003:
      return Instance_st220_minu_idest_src1_xsrc2;
    case 0x00000004:
      return Instance_st220_mulhhs_nlidest_src1_xsrc2;
    case 0x00000005:
      return Instance_st220_mull_nlidest_src1_xsrc2;
    case 0x00000006:
      return Instance_st220_mullu_nlidest_src1_xsrc2;
    case 0x00000007:
      return Instance_st220_mulh_nlidest_src1_xsrc2;
      break;
    }
    return Instance__UNDEF;
  case 0x0000000b:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      return Instance_st220_mulhu_nlidest_src1_xsrc2;
    case 0x00000001:
      return Instance_st220_mulll_nlidest_src1_xsrc2;
    case 0x00000002:
      return Instance_st220_mulllu_nlidest_src1_xsrc2;
    case 0x00000003:
      return Instance_st220_mullh_nlidest_src1_xsrc2;
    case 0x00000004:
      return Instance_st220_mullhu_nlidest_src1_xsrc2;
    case 0x00000005:
      return Instance_st220_mulhh_nlidest_src1_xsrc2;
    case 0x00000006:
      return Instance_st220_mulhhu_nlidest_src1_xsrc2;
    case 0x00000007:
      return Instance_st220_mulhs_nlidest_src1_xsrc2;
      break;
    }
    return Instance__UNDEF;
  case 0x0000000c:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      return Instance_st220_cmpeq_idest_src1_xsrc2;
    case 0x00000001:
      return Instance_st220_cmpne_idest_src1_xsrc2;
    case 0x00000002:
      return Instance_st220_cmpge_idest_src1_xsrc2;
    case 0x00000003:
      return Instance_st220_cmpgeu_idest_src1_xsrc2;
    case 0x00000004:
      return Instance_st220_cmpgt_idest_src1_xsrc2;
    case 0x00000005:
      return Instance_st220_cmpgtu_idest_src1_xsrc2;
    case 0x00000006:
      return Instance_st220_cmple_idest_src1_xsrc2;
    case 0x00000007:
      return Instance_st220_cmpleu_idest_src1_xsrc2;
      break;
    }
    return Instance__UNDEF;
  case 0x0000000d:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      return Instance_st220_cmplt_idest_src1_xsrc2;
    case 0x00000001:
      return Instance_st220_cmpltu_idest_src1_xsrc2;
    case 0x00000002:
      return Instance_st220_andl_idest_src1_xsrc2;
    case 0x00000003:
      return Instance_st220_nandl_idest_src1_xsrc2;
    case 0x00000004:
      return Instance_st220_orl_idest_src1_xsrc2;
    case 0x00000005:
      return Instance_st220_norl_idest_src1_xsrc2;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x0000000e:
    switch ((opcode >> 9) & 0x00000007) {
    case 0x00000000:
      switch ((opcode >> 21) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_cmpeq_ibdest_src1_xsrc2;
      case 0x00000001:
        return Instance_st220_cmpne_ibdest_src1_xsrc2;
      case 0x00000002:
        return Instance_st220_cmpge_ibdest_src1_xsrc2;
      case 0x00000003:
        return Instance_st220_cmpgeu_ibdest_src1_xsrc2;
      case 0x00000004:
        return Instance_st220_cmpgt_ibdest_src1_xsrc2;
      case 0x00000005:
        return Instance_st220_cmpgtu_ibdest_src1_xsrc2;
      case 0x00000006:
        return Instance_st220_cmple_ibdest_src1_xsrc2;
      case 0x00000007:
        return Instance_st220_cmpleu_ibdest_src1_xsrc2;
        break;
      }
      return Instance__UNDEF;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x0000000f:
    switch ((opcode >> 9) & 0x00000007) {
    case 0x00000000:
      switch ((opcode >> 21) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_cmplt_ibdest_src1_xsrc2;
      case 0x00000001:
        return Instance_st220_cmpltu_ibdest_src1_xsrc2;
      case 0x00000002:
        return Instance_st220_andl_ibdest_src1_xsrc2;
      case 0x00000003:
        return Instance_st220_nandl_ibdest_src1_xsrc2;
      case 0x00000004:
        return Instance_st220_orl_ibdest_src1_xsrc2;
      case 0x00000005:
        return Instance_st220_norl_ibdest_src1_xsrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x00000018:
    return Instance_st220_slct_idest_scond_src1_xsrc2;
  case 0x00000019:
    return Instance_st220_slctf_idest_scond_src1_xsrc2;
  case 0x00000020:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      return Instance_st220_ldw_idest_xsrc2_src1;
    case 0x00000004:
      return Instance_st220_ldw_d_idest_xsrc2_src1;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x00000021:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      return Instance_st220_ldh_nlidest_xsrc2_src1;
    case 0x00000004:
      return Instance_st220_ldh_d_nlidest_xsrc2_src1;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x00000022:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      return Instance_st220_ldhu_nlidest_xsrc2_src1;
    case 0x00000004:
      return Instance_st220_ldhu_d_nlidest_xsrc2_src1;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x00000023:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      return Instance_st220_ldb_nlidest_xsrc2_src1;
    case 0x00000004:
      return Instance_st220_ldb_d_nlidest_xsrc2_src1;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x00000024:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      return Instance_st220_ldbu_nlidest_xsrc2_src1;
    case 0x00000004:
      return Instance_st220_ldbu_d_nlidest_xsrc2_src1;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x00000025:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      return Instance_st220_stw_xsrc2_src1_src2;
    case 0x00000004:
      return Instance_st220_sth_xsrc2_src1_src2;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x00000026:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      return Instance_st220_stb_xsrc2_src1_src2;
    case 0x00000004:
      switch ((opcode >> 6) & 0x0000003f) {
      case 0x00000000:
        return Instance_st220_pft_xsrc2_src1;
      default:
        break;
      }
      return Instance__UNDEF;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x00000027:
    switch ((opcode >> 6) & 0x0000003f) {
    case 0x00000000:
      switch ((opcode >> 21) & 0x00000007) {
      case 0x00000000:
        return Instance_st220_prgadd_xsrc2_src1;
      case 0x00000004:
        return Instance_st220_prgset_xsrc2_src1;
      default:
        break;
      }
      return Instance__UNDEF;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x0000002e:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      return Instance_st220_asm_16_idest_src1_xsrc2;
    case 0x00000001:
      return Instance_st220_asm_17_idest_src1_xsrc2;
    case 0x00000002:
      return Instance_st220_asm_18_idest_src1_xsrc2;
    case 0x00000003:
      return Instance_st220_asm_19_idest_src1_xsrc2;
    case 0x00000004:
      return Instance_st220_asm_20_idest_src1_xsrc2;
    case 0x00000005:
      return Instance_st220_asm_21_idest_src1_xsrc2;
    case 0x00000006:
      return Instance_st220_asm_22_idest_src1_xsrc2;
    case 0x00000007:
      return Instance_st220_asm_23_idest_src1_xsrc2;
      break;
    }
    return Instance__UNDEF;
  case 0x0000002f:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      return Instance_st220_asm_24_idest_src1_xsrc2;
    case 0x00000001:
      return Instance_st220_asm_25_idest_src1_xsrc2;
    case 0x00000002:
      return Instance_st220_asm_26_idest_src1_xsrc2;
    case 0x00000003:
      return Instance_st220_asm_27_idest_src1_xsrc2;
    case 0x00000004:
      return Instance_st220_asm_28_idest_src1_xsrc2;
    case 0x00000005:
      return Instance_st220_asm_29_idest_src1_xsrc2;
    case 0x00000006:
      return Instance_st220_asm_30_idest_src1_xsrc2;
    case 0x00000007:
      return Instance_st220_asm_31_idest_src1_xsrc2;
      break;
    }
    return Instance__UNDEF;
  default:
    break;
  }
  return Instance__UNDEF;
}
#endif//NDECODE

#line 1302 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/st200/Decode.xcc"
#ifndef NDECODE
Instance
Decode_Encoding_st231_ANY(const void *buffer)
{
  uint32_t opcode = *(const uint32_t *)buffer;
  switch ((opcode >> 26) & 0x0000001f) {
  case 0x00000000:
    switch ((opcode >> 18) & 0x000000ff) {
    case 0x00000000:
      switch ((opcode >> 0) & 0x0000003f) {
      case 0x00000000:
        switch ((opcode >> 6) & 0x00000fff) {
        case 0x00000000:
          return Instance_st231_nop;
        default:
          return Instance_st231_mov_dest_src2;
          break;
        }
        return Instance__UNDEF;
      default:
        return Instance_st231_add_dest_src1_src2;
        break;
      }
      return Instance__UNDEF;
    case 0x00000008:
      return Instance_st231_sub_dest_src2_src1;
    case 0x00000010:
      return Instance_st231_shl_dest_src1_src2;
    case 0x00000018:
      return Instance_st231_shr_dest_src1_src2;
    case 0x00000020:
      return Instance_st231_shru_dest_src1_src2;
    case 0x00000028:
      return Instance_st231_sh1add_dest_src1_src2;
    case 0x00000030:
      return Instance_st231_sh2add_dest_src1_src2;
    case 0x00000038:
      return Instance_st231_sh3add_dest_src1_src2;
    case 0x00000040:
      return Instance_st231_sh4add_dest_src1_src2;
    case 0x00000048:
      return Instance_st231_and_dest_src1_src2;
    case 0x00000050:
      return Instance_st231_andc_dest_src1_src2;
    case 0x00000058:
      return Instance_st231_or_dest_src1_src2;
    case 0x00000060:
      return Instance_st231_orc_dest_src1_src2;
    case 0x00000068:
      return Instance_st231_xor_dest_src1_src2;
    case 0x00000078:
      return Instance_st231_mullhus_nldest_src1_src2;
    case 0x00000080:
      return Instance_st231_max_dest_src1_src2;
    case 0x00000088:
      return Instance_st231_maxu_dest_src1_src2;
    case 0x00000090:
      return Instance_st231_min_dest_src1_src2;
    case 0x00000098:
      return Instance_st231_minu_dest_src1_src2;
    case 0x000000a0:
      return Instance_st231_mulhhs_nldest_src1_src2;
    case 0x000000a8:
      return Instance_st231_mull_nldest_src1_src2;
    case 0x000000b0:
      return Instance_st231_mullu_nldest_src1_src2;
    case 0x000000b8:
      return Instance_st231_mulh_nldest_src1_src2;
    case 0x000000c0:
      return Instance_st231_mulhu_nldest_src1_src2;
    case 0x000000c8:
      return Instance_st231_mulll_nldest_src1_src2;
    case 0x000000d0:
      return Instance_st231_mulllu_nldest_src1_src2;
    case 0x000000d8:
      return Instance_st231_mullh_nldest_src1_src2;
    case 0x000000e0:
      return Instance_st231_mullhu_nldest_src1_src2;
    case 0x000000e8:
      return Instance_st231_mulhh_nldest_src1_src2;
    case 0x000000f0:
      return Instance_st231_mulhhu_nldest_src1_src2;
    case 0x000000f8:
      return Instance_st231_mulhs_nldest_src1_src2;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x00000001:
    switch ((opcode >> 21) & 0x0000001f) {
    case 0x00000000:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_cmpeq_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000001:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_cmpne_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000002:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_cmpge_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000003:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_cmpgeu_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000004:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_cmpgt_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000005:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_cmpgtu_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000006:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_cmple_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000007:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_cmpleu_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000008:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_cmplt_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000009:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_cmpltu_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000000a:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_andl_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000000b:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_nandl_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000000c:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_orl_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000000d:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_norl_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000000e:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_mul32_nldest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000000f:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_mul64h_nldest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000010:
      switch ((opcode >> 12) & 0x0000003f) {
      case 0x00000000:
        return Instance_st231_cmpeq_bdest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000011:
      switch ((opcode >> 12) & 0x0000003f) {
      case 0x00000000:
        return Instance_st231_cmpne_bdest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000012:
      switch ((opcode >> 12) & 0x0000003f) {
      case 0x00000000:
        return Instance_st231_cmpge_bdest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000013:
      switch ((opcode >> 12) & 0x0000003f) {
      case 0x00000000:
        return Instance_st231_cmpgeu_bdest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000014:
      switch ((opcode >> 12) & 0x0000003f) {
      case 0x00000000:
        return Instance_st231_cmpgt_bdest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000015:
      switch ((opcode >> 12) & 0x0000003f) {
      case 0x00000000:
        return Instance_st231_cmpgtu_bdest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000016:
      switch ((opcode >> 12) & 0x0000003f) {
      case 0x00000000:
        return Instance_st231_cmple_bdest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000017:
      switch ((opcode >> 12) & 0x0000003f) {
      case 0x00000000:
        return Instance_st231_cmpleu_bdest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000018:
      switch ((opcode >> 12) & 0x0000003f) {
      case 0x00000000:
        return Instance_st231_cmplt_bdest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000019:
      switch ((opcode >> 12) & 0x0000003f) {
      case 0x00000000:
        return Instance_st231_cmpltu_bdest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000001a:
      switch ((opcode >> 12) & 0x0000003f) {
      case 0x00000000:
        return Instance_st231_andl_bdest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000001b:
      switch ((opcode >> 12) & 0x0000003f) {
      case 0x00000000:
        return Instance_st231_nandl_bdest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000001c:
      switch ((opcode >> 12) & 0x0000003f) {
      case 0x00000000:
        switch ((opcode >> 6) & 0x0000003f) {
        case 0x00000000:
          return Instance_st231_convib_bdest_src1;
        default:
          return Instance_st231_orl_bdest_src1_src2;
          break;
        }
        return Instance__UNDEF;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000001d:
      switch ((opcode >> 12) & 0x0000003f) {
      case 0x00000000:
        return Instance_st231_norl_bdest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000001e:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_mul64hu_nldest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000001f:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_mulfrac_nldest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
      break;
    }
    return Instance__UNDEF;
  case 0x00000002:
    switch ((opcode >> 21) & 0x0000001f) {
    case 0x00000000:
      switch ((opcode >> 0) & 0x0000003f) {
      case 0x00000000:
        return Instance_st231_mov_idest_isrc2;
      default:
        return Instance_st231_add_idest_src1_isrc2;
        break;
      }
      return Instance__UNDEF;
    case 0x00000001:
      return Instance_st231_sub_idest_isrc2_src1;
    case 0x00000002:
      return Instance_st231_shl_idest_src1_isrc2;
    case 0x00000003:
      return Instance_st231_shr_idest_src1_isrc2;
    case 0x00000004:
      return Instance_st231_shru_idest_src1_isrc2;
    case 0x00000005:
      return Instance_st231_sh1add_idest_src1_isrc2;
    case 0x00000006:
      return Instance_st231_sh2add_idest_src1_isrc2;
    case 0x00000007:
      return Instance_st231_sh3add_idest_src1_isrc2;
    case 0x00000008:
      return Instance_st231_sh4add_idest_src1_isrc2;
    case 0x00000009:
      switch ((opcode >> 12) & 0x000001ff) {
      case 0x000000ff:
        return Instance_st231_zxtb_idest_src1;
      default:
        return Instance_st231_and_idest_src1_isrc2;
        break;
      }
      return Instance__UNDEF;
    case 0x0000000a:
      return Instance_st231_andc_idest_src1_isrc2;
    case 0x0000000b:
      return Instance_st231_or_idest_src1_isrc2;
    case 0x0000000c:
      return Instance_st231_orc_idest_src1_isrc2;
    case 0x0000000d:
      return Instance_st231_xor_idest_src1_isrc2;
    case 0x0000000e:
      switch ((opcode >> 12) & 0x000001ff) {
      case 0x00000000:
        return Instance_st231_sxtb_idest_src1;
      case 0x00000001:
        return Instance_st231_sxth_idest_src1;
      case 0x00000002:
        return Instance_st231_bswap_idest_src1;
      case 0x00000003:
        return Instance_st231_zxth_idest_src1;
      case 0x00000004:
        return Instance_st231_clz_idest_src1;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000000f:
      return Instance_st231_mullhus_nlidest_src1_isrc2;
    case 0x00000010:
      return Instance_st231_max_idest_src1_isrc2;
    case 0x00000011:
      return Instance_st231_maxu_idest_src1_isrc2;
    case 0x00000012:
      return Instance_st231_min_idest_src1_isrc2;
    case 0x00000013:
      return Instance_st231_minu_idest_src1_isrc2;
    case 0x00000014:
      return Instance_st231_mulhhs_nlidest_src1_isrc2;
    case 0x00000015:
      return Instance_st231_mull_nlidest_src1_isrc2;
    case 0x00000016:
      return Instance_st231_mullu_nlidest_src1_isrc2;
    case 0x00000017:
      return Instance_st231_mulh_nlidest_src1_isrc2;
    case 0x00000018:
      return Instance_st231_mulhu_nlidest_src1_isrc2;
    case 0x00000019:
      return Instance_st231_mulll_nlidest_src1_isrc2;
    case 0x0000001a:
      return Instance_st231_mulllu_nlidest_src1_isrc2;
    case 0x0000001b:
      return Instance_st231_mullh_nlidest_src1_isrc2;
    case 0x0000001c:
      return Instance_st231_mullhu_nlidest_src1_isrc2;
    case 0x0000001d:
      return Instance_st231_mulhh_nlidest_src1_isrc2;
    case 0x0000001e:
      return Instance_st231_mulhhu_nlidest_src1_isrc2;
    case 0x0000001f:
      return Instance_st231_mulhs_nlidest_src1_isrc2;
      break;
    }
    return Instance__UNDEF;
  case 0x00000003:
    switch ((opcode >> 21) & 0x0000001f) {
    case 0x00000000:
      return Instance_st231_cmpeq_idest_src1_isrc2;
    case 0x00000001:
      return Instance_st231_cmpne_idest_src1_isrc2;
    case 0x00000002:
      return Instance_st231_cmpge_idest_src1_isrc2;
    case 0x00000003:
      return Instance_st231_cmpgeu_idest_src1_isrc2;
    case 0x00000004:
      return Instance_st231_cmpgt_idest_src1_isrc2;
    case 0x00000005:
      return Instance_st231_cmpgtu_idest_src1_isrc2;
    case 0x00000006:
      return Instance_st231_cmple_idest_src1_isrc2;
    case 0x00000007:
      return Instance_st231_cmpleu_idest_src1_isrc2;
    case 0x00000008:
      return Instance_st231_cmplt_idest_src1_isrc2;
    case 0x00000009:
      return Instance_st231_cmpltu_idest_src1_isrc2;
    case 0x0000000a:
      return Instance_st231_andl_idest_src1_isrc2;
    case 0x0000000b:
      return Instance_st231_nandl_idest_src1_isrc2;
    case 0x0000000c:
      return Instance_st231_orl_idest_src1_isrc2;
    case 0x0000000d:
      return Instance_st231_norl_idest_src1_isrc2;
    case 0x0000000e:
      return Instance_st231_mul32_nlidest_src1_isrc2;
    case 0x0000000f:
      return Instance_st231_mul64h_nlidest_src1_isrc2;
    case 0x00000010:
      switch ((opcode >> 9) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_cmpeq_ibdest_src1_isrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000011:
      switch ((opcode >> 9) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_cmpne_ibdest_src1_isrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000012:
      switch ((opcode >> 9) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_cmpge_ibdest_src1_isrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000013:
      switch ((opcode >> 9) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_cmpgeu_ibdest_src1_isrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000014:
      switch ((opcode >> 9) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_cmpgt_ibdest_src1_isrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000015:
      switch ((opcode >> 9) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_cmpgtu_ibdest_src1_isrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000016:
      switch ((opcode >> 9) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_cmple_ibdest_src1_isrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000017:
      switch ((opcode >> 9) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_cmpleu_ibdest_src1_isrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000018:
      switch ((opcode >> 9) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_cmplt_ibdest_src1_isrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000019:
      switch ((opcode >> 9) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_cmpltu_ibdest_src1_isrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000001a:
      switch ((opcode >> 9) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_andl_ibdest_src1_isrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000001b:
      switch ((opcode >> 9) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_nandl_ibdest_src1_isrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000001c:
      switch ((opcode >> 9) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_orl_ibdest_src1_isrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000001d:
      switch ((opcode >> 9) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_norl_ibdest_src1_isrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000001e:
      return Instance_st231_mul64hu_nlidest_src1_isrc2;
    case 0x0000001f:
      return Instance_st231_mulfrac_nlidest_src1_isrc2;
      break;
    }
    return Instance__UNDEF;
  case 0x00000004:
    switch ((opcode >> 24) & 0x00000003) {
    case 0x00000000:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_slct_dest_scond_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000001:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_slctf_dest_scond_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000002:
      return Instance_st231_addcg_dest_bdest_src1_src2_scond;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x00000005:
    switch ((opcode >> 24) & 0x00000003) {
    case 0x00000000:
      return Instance_st231_divs_dest_bdest_src1_src2_scond;
    case 0x00000001:
      switch ((opcode >> 23) & 0x00000001) {
      case 0x00000000:
        return Instance_st231_imml_imm;
      case 0x00000001:
        return Instance_st231_immr_imm;
        break;
      }
      return Instance__UNDEF;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x00000006:
    switch ((opcode >> 24) & 0x00000003) {
    case 0x00000000:
      return Instance_st231_slct_idest_scond_src1_isrc2;
    case 0x00000001:
      switch ((opcode >> 12) & 0x000001ff) {
      case 0x00000001:
        switch ((opcode >> 0) & 0x0000003f) {
        case 0x00000000:
          return Instance_st231_convbi_idest_scond;
        default:
          return Instance_st231_slctf_idest_scond_src1_isrc2;
          break;
        }
        return Instance__UNDEF;
      default:
        return Instance_st231_slctf_idest_scond_src1_isrc2;
        break;
      }
      return Instance__UNDEF;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x00000007:
    switch ((opcode >> 21) & 0x0000001f) {
    case 0x0000001c:
      switch ((opcode >> 0) & 0x001fffff) {
      case 0x00000000:
        return Instance_st231_prgins;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000001d:
      switch ((opcode >> 31) & 0x00000001) {
      case 0x00000001:
        return Instance_st231_sbrk_sbrknum;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000001e:
      return Instance_st231_syscall_sbrknum;
    case 0x0000001f:
      switch ((opcode >> 0) & 0x001fffff) {
      case 0x00000000:
        return Instance_st231_break;
      default:
        break;
      }
      return Instance__UNDEF;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x00000008:
    switch ((opcode >> 21) & 0x0000001f) {
    case 0x00000000:
      return Instance_st231_ldw_idest_isrc2_src1;
    case 0x00000004:
      return Instance_st231_ldw_d_idest_isrc2_src1;
    case 0x00000008:
      return Instance_st231_ldh_nlidest_isrc2_src1;
    case 0x0000000c:
      return Instance_st231_ldh_d_nlidest_isrc2_src1;
    case 0x00000010:
      return Instance_st231_ldhu_nlidest_isrc2_src1;
    case 0x00000014:
      return Instance_st231_ldhu_d_nlidest_isrc2_src1;
    case 0x00000018:
      return Instance_st231_ldb_nlidest_isrc2_src1;
    case 0x0000001c:
      return Instance_st231_ldb_d_nlidest_isrc2_src1;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x00000009:
    switch ((opcode >> 21) & 0x0000001f) {
    case 0x00000000:
      return Instance_st231_ldbu_nlidest_isrc2_src1;
    case 0x00000004:
      return Instance_st231_ldbu_d_nlidest_isrc2_src1;
    case 0x00000008:
      return Instance_st231_stw_isrc2_src1_src2;
    case 0x0000000c:
      return Instance_st231_sth_isrc2_src1_src2;
    case 0x00000010:
      return Instance_st231_stb_isrc2_src1_src2;
    case 0x00000014:
      switch ((opcode >> 6) & 0x0000003f) {
      case 0x00000000:
        return Instance_st231_pft_isrc2_src1;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000018:
      switch ((opcode >> 6) & 0x0000003f) {
      case 0x00000000:
        return Instance_st231_prgadd_isrc2_src1;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000001c:
      switch ((opcode >> 6) & 0x0000003f) {
      case 0x00000000:
        return Instance_st231_prgset_isrc2_src1;
      default:
        break;
      }
      return Instance__UNDEF;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x0000000a:
    switch ((opcode >> 21) & 0x0000001f) {
    case 0x00000000:
      switch ((opcode >> 0) & 0x001fffff) {
      case 0x00000000:
        return Instance_st231_sync;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000004:
      switch ((opcode >> 6) & 0x0000003f) {
      case 0x00000000:
        return Instance_st231_prginspg_isrc2_src1;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000008:
      switch ((opcode >> 12) & 0x000001ff) {
      case 0x00000000:
        switch ((opcode >> 0) & 0x0000003f) {
        case 0x00000000:
          switch ((opcode >> 6) & 0x0000003f) {
          case 0x00000000:
            return Instance_st231_syncins;
          default:
            return Instance_st231_pswset_src2;
            break;
          }
          return Instance__UNDEF;
        default:
          break;
        }
        return Instance__UNDEF;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000000c:
      switch ((opcode >> 12) & 0x000001ff) {
      case 0x00000000:
        switch ((opcode >> 0) & 0x0000003f) {
        case 0x00000000:
          return Instance_st231_pswclr_src2;
        default:
          break;
        }
        return Instance__UNDEF;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000001f:
      return Instance_st231_asm_31_idest_src1_isrc2;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x0000000b:
    switch ((opcode >> 21) & 0x0000001f) {
    case 0x00000000:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_asm_0_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000001:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_asm_1_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000002:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_asm_2_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000003:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_asm_3_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000004:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_asm_4_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000005:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_asm_5_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000006:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_asm_6_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000007:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_asm_7_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000008:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_asm_8_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000009:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_asm_9_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000000a:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_asm_10_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000000b:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_asm_11_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000000c:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_asm_12_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000000d:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_asm_13_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000000e:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_asm_14_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000000f:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_asm_15_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000010:
      return Instance_st231_asm_16_idest_src1_isrc2;
    case 0x00000011:
      return Instance_st231_asm_17_idest_src1_isrc2;
    case 0x00000012:
      return Instance_st231_asm_18_idest_src1_isrc2;
    case 0x00000013:
      return Instance_st231_asm_19_idest_src1_isrc2;
    case 0x00000014:
      return Instance_st231_asm_20_idest_src1_isrc2;
    case 0x00000015:
      return Instance_st231_asm_21_idest_src1_isrc2;
    case 0x00000016:
      return Instance_st231_asm_22_idest_src1_isrc2;
    case 0x00000017:
      return Instance_st231_asm_23_idest_src1_isrc2;
    case 0x00000018:
      return Instance_st231_asm_24_idest_src1_isrc2;
    case 0x00000019:
      return Instance_st231_asm_25_idest_src1_isrc2;
    case 0x0000001a:
      return Instance_st231_asm_26_idest_src1_isrc2;
    case 0x0000001b:
      return Instance_st231_asm_27_idest_src1_isrc2;
    case 0x0000001c:
      return Instance_st231_asm_28_idest_src1_isrc2;
    case 0x0000001d:
      return Instance_st231_asm_29_idest_src1_isrc2;
    case 0x0000001e:
      return Instance_st231_asm_30_idest_src1_isrc2;
    case 0x0000001f:
      switch ((opcode >> 15) & 0x0000003f) {
      case 0x00000000:
        switch ((opcode >> 12) & 0x00000007) {
        case 0x00000003:
          switch ((opcode >> 0) & 0x00000fff) {
          case 0x00000000:
            return Instance_st231_wmb;
          default:
            break;
          }
          return Instance__UNDEF;
        case 0x00000005:
          return Instance_st231_ldwl_idest_src1;
        default:
          break;
        }
        return Instance__UNDEF;
      case 0x00000020:
        return Instance_st231_stwl_bdest2_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
      break;
    }
    return Instance__UNDEF;
  case 0x0000000c:
    switch ((opcode >> 23) & 0x00000007) {
    case 0x00000000:
      return Instance_st231_call_btarg;
    case 0x00000001:
      switch ((opcode >> 0) & 0x007fffff) {
      case 0x00000000:
        return Instance_st231_icall;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000002:
      switch ((opcode >> 0) & 0x007fffff) {
      case 0x00000000:
        return Instance_st231_idle;
      default:
        return Instance_st231_goto_btarg;
        break;
      }
      return Instance__UNDEF;
    case 0x00000003:
      switch ((opcode >> 0) & 0x007fffff) {
      case 0x00000000:
        return Instance_st231_igoto;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000004:
      switch ((opcode >> 0) & 0x007fffff) {
      case 0x00000000:
        return Instance_st231_rfi;
      default:
        break;
      }
      return Instance__UNDEF;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x0000000e:
    return Instance_st231_br_bcond_btarg;
  case 0x0000000f:
    return Instance_st231_brf_bcond_btarg;
  default:
    break;
  }
  return Instance__UNDEF;
}
#endif//NDECODE

#line 2371 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/st200/Decode.xcc"
#ifndef NDECODE
Instance
Decode_Encoding_st231_ANYX(const void *buffer)
{
  uint32_t opcode = *(const uint32_t *)buffer;
  switch ((opcode >> 24) & 0x0000007f) {
  case 0x00000008:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      switch ((opcode >> 0) & 0x0000003f) {
      case 0x00000000:
        return Instance_st231_mov_idest_xsrc2;
      default:
        return Instance_st231_add_idest_src1_xsrc2;
        break;
      }
      return Instance__UNDEF;
    case 0x00000001:
      return Instance_st231_sub_idest_xsrc2_src1;
    case 0x00000002:
      return Instance_st231_shl_idest_src1_xsrc2;
    case 0x00000003:
      return Instance_st231_shr_idest_src1_xsrc2;
    case 0x00000004:
      return Instance_st231_shru_idest_src1_xsrc2;
    case 0x00000005:
      return Instance_st231_sh1add_idest_src1_xsrc2;
    case 0x00000006:
      return Instance_st231_sh2add_idest_src1_xsrc2;
    case 0x00000007:
      return Instance_st231_sh3add_idest_src1_xsrc2;
      break;
    }
    return Instance__UNDEF;
  case 0x00000009:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      return Instance_st231_sh4add_idest_src1_xsrc2;
    case 0x00000001:
      return Instance_st231_and_idest_src1_xsrc2;
    case 0x00000002:
      return Instance_st231_andc_idest_src1_xsrc2;
    case 0x00000003:
      return Instance_st231_or_idest_src1_xsrc2;
    case 0x00000004:
      return Instance_st231_orc_idest_src1_xsrc2;
    case 0x00000005:
      return Instance_st231_xor_idest_src1_xsrc2;
    case 0x00000007:
      return Instance_st231_mullhus_nlidest_src1_xsrc2;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x0000000a:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      return Instance_st231_max_idest_src1_xsrc2;
    case 0x00000001:
      return Instance_st231_maxu_idest_src1_xsrc2;
    case 0x00000002:
      return Instance_st231_min_idest_src1_xsrc2;
    case 0x00000003:
      return Instance_st231_minu_idest_src1_xsrc2;
    case 0x00000004:
      return Instance_st231_mulhhs_nlidest_src1_xsrc2;
    case 0x00000005:
      return Instance_st231_mull_nlidest_src1_xsrc2;
    case 0x00000006:
      return Instance_st231_mullu_nlidest_src1_xsrc2;
    case 0x00000007:
      return Instance_st231_mulh_nlidest_src1_xsrc2;
      break;
    }
    return Instance__UNDEF;
  case 0x0000000b:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      return Instance_st231_mulhu_nlidest_src1_xsrc2;
    case 0x00000001:
      return Instance_st231_mulll_nlidest_src1_xsrc2;
    case 0x00000002:
      return Instance_st231_mulllu_nlidest_src1_xsrc2;
    case 0x00000003:
      return Instance_st231_mullh_nlidest_src1_xsrc2;
    case 0x00000004:
      return Instance_st231_mullhu_nlidest_src1_xsrc2;
    case 0x00000005:
      return Instance_st231_mulhh_nlidest_src1_xsrc2;
    case 0x00000006:
      return Instance_st231_mulhhu_nlidest_src1_xsrc2;
    case 0x00000007:
      return Instance_st231_mulhs_nlidest_src1_xsrc2;
      break;
    }
    return Instance__UNDEF;
  case 0x0000000c:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      return Instance_st231_cmpeq_idest_src1_xsrc2;
    case 0x00000001:
      return Instance_st231_cmpne_idest_src1_xsrc2;
    case 0x00000002:
      return Instance_st231_cmpge_idest_src1_xsrc2;
    case 0x00000003:
      return Instance_st231_cmpgeu_idest_src1_xsrc2;
    case 0x00000004:
      return Instance_st231_cmpgt_idest_src1_xsrc2;
    case 0x00000005:
      return Instance_st231_cmpgtu_idest_src1_xsrc2;
    case 0x00000006:
      return Instance_st231_cmple_idest_src1_xsrc2;
    case 0x00000007:
      return Instance_st231_cmpleu_idest_src1_xsrc2;
      break;
    }
    return Instance__UNDEF;
  case 0x0000000d:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      return Instance_st231_cmplt_idest_src1_xsrc2;
    case 0x00000001:
      return Instance_st231_cmpltu_idest_src1_xsrc2;
    case 0x00000002:
      return Instance_st231_andl_idest_src1_xsrc2;
    case 0x00000003:
      return Instance_st231_nandl_idest_src1_xsrc2;
    case 0x00000004:
      return Instance_st231_orl_idest_src1_xsrc2;
    case 0x00000005:
      return Instance_st231_norl_idest_src1_xsrc2;
    case 0x00000006:
      return Instance_st231_mul32_nlidest_src1_xsrc2;
    case 0x00000007:
      return Instance_st231_mul64h_nlidest_src1_xsrc2;
      break;
    }
    return Instance__UNDEF;
  case 0x0000000e:
    switch ((opcode >> 9) & 0x00000007) {
    case 0x00000000:
      switch ((opcode >> 21) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_cmpeq_ibdest_src1_xsrc2;
      case 0x00000001:
        return Instance_st231_cmpne_ibdest_src1_xsrc2;
      case 0x00000002:
        return Instance_st231_cmpge_ibdest_src1_xsrc2;
      case 0x00000003:
        return Instance_st231_cmpgeu_ibdest_src1_xsrc2;
      case 0x00000004:
        return Instance_st231_cmpgt_ibdest_src1_xsrc2;
      case 0x00000005:
        return Instance_st231_cmpgtu_ibdest_src1_xsrc2;
      case 0x00000006:
        return Instance_st231_cmple_ibdest_src1_xsrc2;
      case 0x00000007:
        return Instance_st231_cmpleu_ibdest_src1_xsrc2;
        break;
      }
      return Instance__UNDEF;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x0000000f:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      switch ((opcode >> 9) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_cmplt_ibdest_src1_xsrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000001:
      switch ((opcode >> 9) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_cmpltu_ibdest_src1_xsrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000002:
      switch ((opcode >> 9) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_andl_ibdest_src1_xsrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000003:
      switch ((opcode >> 9) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_nandl_ibdest_src1_xsrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000004:
      switch ((opcode >> 9) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_orl_ibdest_src1_xsrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000005:
      switch ((opcode >> 9) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_norl_ibdest_src1_xsrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000006:
      return Instance_st231_mul64hu_nlidest_src1_xsrc2;
    case 0x00000007:
      return Instance_st231_mulfrac_nlidest_src1_xsrc2;
      break;
    }
    return Instance__UNDEF;
  case 0x00000018:
    return Instance_st231_slct_idest_scond_src1_xsrc2;
  case 0x00000019:
    return Instance_st231_slctf_idest_scond_src1_xsrc2;
  case 0x00000020:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      return Instance_st231_ldw_idest_xsrc2_src1;
    case 0x00000004:
      return Instance_st231_ldw_d_idest_xsrc2_src1;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x00000021:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      return Instance_st231_ldh_nlidest_xsrc2_src1;
    case 0x00000004:
      return Instance_st231_ldh_d_nlidest_xsrc2_src1;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x00000022:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      return Instance_st231_ldhu_nlidest_xsrc2_src1;
    case 0x00000004:
      return Instance_st231_ldhu_d_nlidest_xsrc2_src1;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x00000023:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      return Instance_st231_ldb_nlidest_xsrc2_src1;
    case 0x00000004:
      return Instance_st231_ldb_d_nlidest_xsrc2_src1;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x00000024:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      return Instance_st231_ldbu_nlidest_xsrc2_src1;
    case 0x00000004:
      return Instance_st231_ldbu_d_nlidest_xsrc2_src1;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x00000025:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      return Instance_st231_stw_xsrc2_src1_src2;
    case 0x00000004:
      return Instance_st231_sth_xsrc2_src1_src2;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x00000026:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      return Instance_st231_stb_xsrc2_src1_src2;
    case 0x00000004:
      switch ((opcode >> 6) & 0x0000003f) {
      case 0x00000000:
        return Instance_st231_pft_xsrc2_src1;
      default:
        break;
      }
      return Instance__UNDEF;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x00000027:
    switch ((opcode >> 6) & 0x0000003f) {
    case 0x00000000:
      switch ((opcode >> 21) & 0x00000007) {
      case 0x00000000:
        return Instance_st231_prgadd_xsrc2_src1;
      case 0x00000004:
        return Instance_st231_prgset_xsrc2_src1;
      default:
        break;
      }
      return Instance__UNDEF;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x00000028:
    switch ((opcode >> 6) & 0x0000003f) {
    case 0x00000000:
      switch ((opcode >> 21) & 0x00000007) {
      case 0x00000004:
        return Instance_st231_prginspg_xsrc2_src1;
      default:
        break;
      }
      return Instance__UNDEF;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x0000002b:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000007:
      return Instance_st231_asm_31_idest_src1_xsrc2;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x0000002e:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      return Instance_st231_asm_16_idest_src1_xsrc2;
    case 0x00000001:
      return Instance_st231_asm_17_idest_src1_xsrc2;
    case 0x00000002:
      return Instance_st231_asm_18_idest_src1_xsrc2;
    case 0x00000003:
      return Instance_st231_asm_19_idest_src1_xsrc2;
    case 0x00000004:
      return Instance_st231_asm_20_idest_src1_xsrc2;
    case 0x00000005:
      return Instance_st231_asm_21_idest_src1_xsrc2;
    case 0x00000006:
      return Instance_st231_asm_22_idest_src1_xsrc2;
    case 0x00000007:
      return Instance_st231_asm_23_idest_src1_xsrc2;
      break;
    }
    return Instance__UNDEF;
  case 0x0000002f:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      return Instance_st231_asm_24_idest_src1_xsrc2;
    case 0x00000001:
      return Instance_st231_asm_25_idest_src1_xsrc2;
    case 0x00000002:
      return Instance_st231_asm_26_idest_src1_xsrc2;
    case 0x00000003:
      return Instance_st231_asm_27_idest_src1_xsrc2;
    case 0x00000004:
      return Instance_st231_asm_28_idest_src1_xsrc2;
    case 0x00000005:
      return Instance_st231_asm_29_idest_src1_xsrc2;
    case 0x00000006:
      return Instance_st231_asm_30_idest_src1_xsrc2;
    default:
      break;
    }
    return Instance__UNDEF;
  default:
    break;
  }
  return Instance__UNDEF;
}
#endif//NDECODE

#line 2765 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/st200/Decode.xcc"
#ifndef NDECODE
Instance
Decode_Encoding_st240_ANY(const void *buffer)
{
  uint32_t opcode = *(const uint32_t *)buffer;
  switch ((opcode >> 26) & 0x0000001f) {
  case 0x00000000:
    switch ((opcode >> 18) & 0x000000ff) {
    case 0x00000000:
      switch ((opcode >> 0) & 0x0000003f) {
      case 0x00000000:
        switch ((opcode >> 6) & 0x00000fff) {
        case 0x00000000:
          return Instance_st240_nop;
        default:
          return Instance_st240_mov_dest_src2;
          break;
        }
        return Instance__UNDEF;
      default:
        return Instance_st240_add_dest_src1_src2;
        break;
      }
      return Instance__UNDEF;
    case 0x00000008:
      return Instance_st240_sub_dest_src2_src1;
    case 0x00000010:
      return Instance_st240_shl_dest_src1_src2;
    case 0x00000018:
      return Instance_st240_shr_dest_src1_src2;
    case 0x00000020:
      return Instance_st240_shru_dest_src1_src2;
    case 0x00000028:
      return Instance_st240_sh1add_dest_src1_src2;
    case 0x00000030:
      return Instance_st240_sh2add_dest_src1_src2;
    case 0x00000038:
      return Instance_st240_sh3add_dest_src1_src2;
    case 0x00000048:
      return Instance_st240_and_dest_src1_src2;
    case 0x00000050:
      return Instance_st240_andc_dest_src1_src2;
    case 0x00000058:
      return Instance_st240_or_dest_src1_src2;
    case 0x00000060:
      return Instance_st240_orc_dest_src1_src2;
    case 0x00000068:
      return Instance_st240_xor_dest_src1_src2;
    case 0x00000078:
      return Instance_st240_mul64h_nldest_src1_src2;
    case 0x00000080:
      return Instance_st240_max_dest_src1_src2;
    case 0x00000082:
      return Instance_st240_addf_n_nldest_src1_src2;
    case 0x00000084:
      return Instance_st240_adds_dest_src1_src2;
    case 0x00000088:
      return Instance_st240_maxu_dest_src1_src2;
    case 0x0000008a:
      return Instance_st240_subf_n_nldest_src1_src2;
    case 0x0000008c:
      return Instance_st240_subs_dest_src2_src1;
    case 0x00000090:
      return Instance_st240_min_dest_src1_src2;
    case 0x00000092:
      return Instance_st240_mulf_n_nldest_src1_src2;
    case 0x00000094:
      return Instance_st240_sh1adds_dest_src2_src1;
    case 0x00000098:
      return Instance_st240_minu_dest_src1_src2;
    case 0x0000009a:
      switch ((opcode >> 6) & 0x0000003f) {
      case 0x00000000:
        return Instance_st240_convif_n_nldest_src1;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000009c:
      return Instance_st240_sh1subs_dest_src2_src1;
    case 0x000000a0:
      return Instance_st240_mul64hu_nldest_src1_src2;
    case 0x000000a2:
      switch ((opcode >> 6) & 0x0000003f) {
      case 0x00000000:
        return Instance_st240_convfi_n_nldest_src1;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x000000a4:
      switch ((opcode >> 6) & 0x0000003f) {
      case 0x00000000:
        return Instance_st240_sats_dest_src1;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x000000a8:
      return Instance_st240_mull_nldest_src1_src2;
    case 0x000000ac:
      return Instance_st240_adds_ph_dest_src1_src2;
    case 0x000000b0:
      return Instance_st240_mul32_nldest_src1_src2;
    case 0x000000b4:
      return Instance_st240_subs_ph_dest_src2_src1;
    case 0x000000b8:
      return Instance_st240_mulh_nldest_src1_src2;
    case 0x000000c2:
      return Instance_st240_div_nldest_src1_src2;
    case 0x000000c4:
      return Instance_st240_addso_dest_src1_src2;
    case 0x000000c8:
      return Instance_st240_mulll_nldest_src1_src2;
    case 0x000000ca:
      return Instance_st240_rem_nldest_src1_src2;
    case 0x000000cc:
      return Instance_st240_subso_dest_src2_src1;
    case 0x000000d0:
      return Instance_st240_mulllu_nldest_src1_src2;
    case 0x000000d2:
      return Instance_st240_divu_nldest_src1_src2;
    case 0x000000d4:
      return Instance_st240_sh1addso_dest_src2_src1;
    case 0x000000d8:
      return Instance_st240_mullh_nldest_src1_src2;
    case 0x000000da:
      return Instance_st240_remu_nldest_src1_src2;
    case 0x000000dc:
      return Instance_st240_sh1subso_dest_src2_src1;
    case 0x000000e0:
      return Instance_st240_mullhu_nldest_src1_src2;
    case 0x000000e4:
      switch ((opcode >> 6) & 0x0000003f) {
      case 0x00000000:
        return Instance_st240_satso_dest_src1;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x000000e8:
      return Instance_st240_mulhh_nldest_src1_src2;
    case 0x000000f0:
      return Instance_st240_mulhhu_nldest_src1_src2;
    case 0x000000f8:
      return Instance_st240_mulfrac_nldest_src1_src2;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x00000001:
    switch ((opcode >> 18) & 0x000000ff) {
    case 0x00000000:
      return Instance_st240_cmpeq_dest_src1_src2;
    case 0x00000001:
      return Instance_st240_cmpeq_pb_dest_src1_src2;
    case 0x00000008:
      return Instance_st240_cmpne_dest_src1_src2;
    case 0x00000010:
      return Instance_st240_cmpgef_n_dest_src1_src2;
    case 0x00000011:
      return Instance_st240_cmpgtu_pb_dest_src1_src2;
    case 0x00000018:
      return Instance_st240_cmpeqf_n_dest_src1_src2;
    case 0x00000020:
      return Instance_st240_cmpgtf_n_dest_src1_src2;
    case 0x00000030:
      return Instance_st240_cmple_dest_src1_src2;
    case 0x00000038:
      return Instance_st240_cmpleu_dest_src1_src2;
    case 0x00000040:
      return Instance_st240_cmplt_dest_src1_src2;
    case 0x00000041:
      return Instance_st240_cmpeq_ph_dest_src1_src2;
    case 0x00000048:
      return Instance_st240_cmpltu_dest_src1_src2;
    case 0x00000049:
      return Instance_st240_cmpgt_ph_dest_src1_src2;
    case 0x00000050:
      return Instance_st240_andl_dest_src1_src2;
    case 0x00000058:
      return Instance_st240_nandl_dest_src1_src2;
    case 0x00000060:
      return Instance_st240_orl_dest_src1_src2;
    case 0x00000068:
      return Instance_st240_norl_dest_src1_src2;
    case 0x00000080:
      switch ((opcode >> 15) & 0x00000007) {
      case 0x00000000:
        return Instance_st240_cmpeq_bdest2_src1_src2;
      case 0x00000001:
        switch ((opcode >> 3) & 0x00000007) {
        case 0x00000000:
          switch ((opcode >> 9) & 0x00000007) {
          case 0x00000000:
            return Instance_st240_andl_bdest_bdest2_bsrc1_bsrc2;
          default:
            break;
          }
          return Instance__UNDEF;
        default:
          break;
        }
        return Instance__UNDEF;
      case 0x00000002:
        switch ((opcode >> 3) & 0x000001ff) {
        case 0x00000000:
          return Instance_st240_mov_bsrc_bdest_bdest2_bsrc1;
        default:
          break;
        }
        return Instance__UNDEF;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000081:
      switch ((opcode >> 15) & 0x00000007) {
      case 0x00000000:
        return Instance_st240_cmpeq_pb_bdest_bdest2_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000088:
      switch ((opcode >> 15) & 0x00000007) {
      case 0x00000000:
        return Instance_st240_cmpne_bdest2_src1_src2;
      case 0x00000001:
        switch ((opcode >> 3) & 0x00000007) {
        case 0x00000000:
          switch ((opcode >> 9) & 0x00000007) {
          case 0x00000000:
            return Instance_st240_nandl_bdest_bdest2_bsrc1_bsrc2;
          default:
            break;
          }
          return Instance__UNDEF;
        default:
          break;
        }
        return Instance__UNDEF;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000089:
      switch ((opcode >> 15) & 0x00000007) {
      case 0x00000000:
        return Instance_st240_cmpgtu_pb_bdest_bdest2_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000090:
      switch ((opcode >> 15) & 0x00000007) {
      case 0x00000000:
        return Instance_st240_cmpgef_n_bdest2_src1_src2;
      case 0x00000001:
        switch ((opcode >> 3) & 0x00000007) {
        case 0x00000000:
          switch ((opcode >> 9) & 0x00000007) {
          case 0x00000000:
            return Instance_st240_orl_bdest_bdest2_bsrc1_bsrc2;
          default:
            break;
          }
          return Instance__UNDEF;
        default:
          break;
        }
        return Instance__UNDEF;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000098:
      switch ((opcode >> 15) & 0x00000007) {
      case 0x00000000:
        return Instance_st240_cmpeqf_n_bdest2_src1_src2;
      case 0x00000001:
        switch ((opcode >> 3) & 0x00000007) {
        case 0x00000000:
          switch ((opcode >> 9) & 0x00000007) {
          case 0x00000000:
            return Instance_st240_norl_bdest_bdest2_bsrc1_bsrc2;
          default:
            break;
          }
          return Instance__UNDEF;
        default:
          break;
        }
        return Instance__UNDEF;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x000000a0:
      switch ((opcode >> 15) & 0x00000007) {
      case 0x00000000:
        return Instance_st240_cmpgtf_n_bdest2_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x000000b0:
      switch ((opcode >> 15) & 0x00000007) {
      case 0x00000000:
        return Instance_st240_cmple_bdest2_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x000000b8:
      switch ((opcode >> 15) & 0x00000007) {
      case 0x00000000:
        return Instance_st240_cmpleu_bdest2_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x000000c0:
      switch ((opcode >> 15) & 0x00000007) {
      case 0x00000000:
        return Instance_st240_cmplt_bdest2_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x000000c1:
      switch ((opcode >> 15) & 0x00000007) {
      case 0x00000000:
        return Instance_st240_cmpeq_ph_bdest_bdest2_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x000000c8:
      switch ((opcode >> 15) & 0x00000007) {
      case 0x00000000:
        return Instance_st240_cmpltu_bdest2_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x000000c9:
      switch ((opcode >> 15) & 0x00000007) {
      case 0x00000000:
        return Instance_st240_cmpgt_ph_bdest_bdest2_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x000000d0:
      switch ((opcode >> 15) & 0x00000007) {
      case 0x00000000:
        return Instance_st240_andl_bdest2_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x000000d8:
      switch ((opcode >> 15) & 0x00000007) {
      case 0x00000000:
        return Instance_st240_nandl_bdest2_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x000000e0:
      switch ((opcode >> 15) & 0x00000007) {
      case 0x00000000:
        switch ((opcode >> 6) & 0x0000003f) {
        case 0x00000000:
          return Instance_st240_convib_bdest2_src1;
        default:
          return Instance_st240_orl_bdest2_src1_src2;
          break;
        }
        return Instance__UNDEF;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x000000e8:
      switch ((opcode >> 15) & 0x00000007) {
      case 0x00000000:
        return Instance_st240_norl_bdest2_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x000000f0:
      switch ((opcode >> 6) & 0x0000003f) {
      case 0x00000000:
        switch ((opcode >> 15) & 0x00000007) {
        case 0x00000000:
          return Instance_st240_mov_bdest_bdest2_src1;
        default:
          break;
        }
        return Instance__UNDEF;
      default:
        break;
      }
      return Instance__UNDEF;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x00000002:
    switch ((opcode >> 21) & 0x0000001f) {
    case 0x00000000:
      switch ((opcode >> 0) & 0x0000003f) {
      case 0x00000000:
        return Instance_st240_mov_idest_isrc2;
      default:
        return Instance_st240_add_idest_src1_isrc2;
        break;
      }
      return Instance__UNDEF;
    case 0x00000001:
      return Instance_st240_sub_idest_isrc2_src1;
    case 0x00000002:
      return Instance_st240_shl_idest_src1_isrc2;
    case 0x00000003:
      return Instance_st240_shr_idest_src1_isrc2;
    case 0x00000004:
      return Instance_st240_shru_idest_src1_isrc2;
    case 0x00000005:
      return Instance_st240_sh1add_idest_src1_isrc2;
    case 0x00000006:
      return Instance_st240_sh2add_idest_src1_isrc2;
    case 0x00000007:
      return Instance_st240_sh3add_idest_src1_isrc2;
    case 0x00000008:
      switch ((opcode >> 0) & 0x0000003f) {
      case 0x00000000:
        return Instance_st240_addpc_idest_isrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000009:
      switch ((opcode >> 12) & 0x000001ff) {
      case 0x000000ff:
        return Instance_st240_zxtb_idest_src1;
      default:
        return Instance_st240_and_idest_src1_isrc2;
        break;
      }
      return Instance__UNDEF;
    case 0x0000000a:
      return Instance_st240_andc_idest_src1_isrc2;
    case 0x0000000b:
      return Instance_st240_or_idest_src1_isrc2;
    case 0x0000000d:
      return Instance_st240_xor_idest_src1_isrc2;
    case 0x0000000e:
      switch ((opcode >> 12) & 0x000001ff) {
      case 0x00000004:
        return Instance_st240_clz_idest_src1;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x0000000f:
      return Instance_st240_mul64h_nlidest_src1_isrc2;
    case 0x00000010:
      return Instance_st240_max_idest_src1_isrc2;
    case 0x00000011:
      return Instance_st240_maxu_idest_src1_isrc2;
    case 0x00000012:
      return Instance_st240_min_idest_src1_isrc2;
    case 0x00000013:
      return Instance_st240_minu_idest_src1_isrc2;
    case 0x00000014:
      return Instance_st240_mul64hu_nlidest_src1_isrc2;
    case 0x00000016:
      return Instance_st240_mul32_nlidest_src1_isrc2;
    case 0x00000019:
      return Instance_st240_mulll_nlidest_src1_isrc2;
    case 0x0000001a:
      return Instance_st240_mulllu_nlidest_src1_isrc2;
    case 0x0000001f:
      return Instance_st240_mulfrac_nlidest_src1_isrc2;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x00000003:
    switch ((opcode >> 21) & 0x0000001f) {
    case 0x00000000:
      return Instance_st240_cmpeq_idest_src1_isrc2;
    case 0x00000001:
      return Instance_st240_cmpne_idest_src1_isrc2;
    case 0x00000002:
      return Instance_st240_cmpge_idest_src1_isrc2;
    case 0x00000003:
      return Instance_st240_cmpgeu_idest_src1_isrc2;
    case 0x00000004:
      return Instance_st240_cmpgt_idest_src1_isrc2;
    case 0x00000005:
      return Instance_st240_cmpgtu_idest_src1_isrc2;
    case 0x00000006:
      return Instance_st240_cmple_idest_src1_isrc2;
    case 0x00000007:
      return Instance_st240_cmpleu_idest_src1_isrc2;
    case 0x00000008:
      return Instance_st240_cmplt_idest_src1_isrc2;
    case 0x00000009:
      return Instance_st240_cmpltu_idest_src1_isrc2;
    case 0x00000010:
      switch ((opcode >> 9) & 0x00000007) {
      case 0x00000000:
        return Instance_st240_cmpeq_ibdest_src1_isrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000011:
      switch ((opcode >> 9) & 0x00000007) {
      case 0x00000000:
        return Instance_st240_cmpne_ibdest_src1_isrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000012:
      switch ((opcode >> 9) & 0x00000007) {
      case 0x00000000:
        return Instance_st240_cmpge_ibdest_src1_isrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000013:
      switch ((opcode >> 9) & 0x00000007) {
      case 0x00000000:
        return Instance_st240_cmpgeu_ibdest_src1_isrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000014:
      switch ((opcode >> 9) & 0x00000007) {
      case 0x00000000:
        return Instance_st240_cmpgt_ibdest_src1_isrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000015:
      switch ((opcode >> 9) & 0x00000007) {
      case 0x00000000:
        return Instance_st240_cmpgtu_ibdest_src1_isrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000016:
      switch ((opcode >> 9) & 0x00000007) {
      case 0x00000000:
        return Instance_st240_cmple_ibdest_src1_isrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000017:
      switch ((opcode >> 9) & 0x00000007) {
      case 0x00000000:
        return Instance_st240_cmpleu_ibdest_src1_isrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000018:
      switch ((opcode >> 9) & 0x00000007) {
      case 0x00000000:
        return Instance_st240_cmplt_ibdest_src1_isrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000019:
      switch ((opcode >> 9) & 0x00000007) {
      case 0x00000000:
        return Instance_st240_cmpltu_ibdest_src1_isrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x00000004:
    switch ((opcode >> 18) & 0x000000ff) {
    case 0x00000000:
      return Instance_st240_shls_nldest_src1_src2;
    case 0x00000008:
      return Instance_st240_shlso_nldest_src1_src2;
    case 0x00000028:
      return Instance_st240_sxt_dest_src1_src2;
    case 0x00000030:
      return Instance_st240_zxt_dest_src1_src2;
    case 0x00000038:
      return Instance_st240_rotl_dest_src1_src2;
    case 0x00000080:
      return Instance_st240_perm_pb_dest_src1_src2;
    case 0x00000081:
      switch ((opcode >> 6) & 0x0000003f) {
      case 0x00000000:
        return Instance_st240_unpacku_pbh_dest_src1;
      default:
        return Instance_st240_shuff_pbh_dest_src1_src2;
        break;
      }
      return Instance__UNDEF;
    case 0x00000082:
      return Instance_st240_sadu_pb_nldest_src1_src2;
    case 0x00000089:
      switch ((opcode >> 6) & 0x0000003f) {
      case 0x00000000:
        return Instance_st240_unpacku_pbl_dest_src1;
      default:
        return Instance_st240_shuff_pbl_dest_src1_src2;
        break;
      }
      return Instance__UNDEF;
    case 0x0000008a:
      return Instance_st240_absubu_pb_dest_src1_src2;
    case 0x00000091:
      return Instance_st240_shuffodd_pb_dest_src1_src2;
    case 0x00000092:
      return Instance_st240_muladdus_pb_nldest_src1_src2;
    case 0x00000099:
      return Instance_st240_shuffeve_pb_dest_src1_src2;
    case 0x0000009a:
      return Instance_st240_pack_pb_dest_src1_src2;
    case 0x000000a1:
      return Instance_st240_ext1_pb_dest_src1_src2;
    case 0x000000a9:
      return Instance_st240_ext2_pb_dest_src1_src2;
    case 0x000000b1:
      return Instance_st240_ext3_pb_dest_src1_src2;
    case 0x000000b9:
      return Instance_st240_packsu_pb_dest_src1_src2;
    case 0x000000c0:
      return Instance_st240_shl_ph_dest_src1_src2;
    case 0x000000c1:
      return Instance_st240_add_ph_dest_src1_src2;
    case 0x000000c2:
      return Instance_st240_shuff_phh_dest_src1_src2;
    case 0x000000c8:
      return Instance_st240_shls_ph_nldest_src1_src2;
    case 0x000000c9:
      switch ((opcode >> 6) & 0x0000003f) {
      case 0x00000000:
        return Instance_st240_abss_ph_dest_src1;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x000000ca:
      return Instance_st240_shuff_phl_dest_src1_src2;
    case 0x000000d0:
      return Instance_st240_shr_ph_dest_src1_src2;
    case 0x000000d1:
      return Instance_st240_max_ph_dest_src1_src2;
    case 0x000000d2:
      return Instance_st240_sub_ph_dest_src2_src1;
    case 0x000000d8:
      return Instance_st240_shrrnp_ph_nldest_src1_src2;
    case 0x000000d9:
      return Instance_st240_min_ph_dest_src1_src2;
    case 0x000000da:
      return Instance_st240_mulfracadds_ph_nldest_src1_src2;
    case 0x000000e0:
      return Instance_st240_shrrne_ph_nldest_src1_src2;
    case 0x000000e1:
      return Instance_st240_mul_ph_nldest_src1_src2;
    case 0x000000e9:
      return Instance_st240_muladd_ph_nldest_src1_src2;
    case 0x000000f1:
      return Instance_st240_mulfracrm_ph_nldest_src1_src2;
    case 0x000000f2:
      return Instance_st240_packrnp_phh_dest_src1_src2;
    case 0x000000f9:
      return Instance_st240_mulfracrne_ph_nldest_src1_src2;
    case 0x000000fa:
      return Instance_st240_packs_ph_dest_src1_src2;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x00000005:
    switch ((opcode >> 24) & 0x00000003) {
    case 0x00000000:
      return Instance_st240_addcg_dest_bdest_src1_src2_scond;
    case 0x00000001:
      switch ((opcode >> 23) & 0x00000001) {
      case 0x00000000:
        return Instance_st240_imml_imm;
      case 0x00000001:
        return Instance_st240_immr_imm;
        break;
      }
      return Instance__UNDEF;
    case 0x00000002:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st240_slct_pb_dest_scond_src1_src2;
      case 0x00000001:
        return Instance_st240_slct_rsrc_dest_scond_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000003:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000001:
        switch ((opcode >> 0) & 0x00000fff) {
        case 0x00000000:
          return Instance_st240_mov_bsrc_dest_scond;
        default:
          break;
        }
        return Instance__UNDEF;
      case 0x00000002:
        return Instance_st240_extl_pb_dest_scond_src1_src2;
      case 0x00000003:
        return Instance_st240_extr_pb_dest_scond_src1_src2;
      case 0x00000004:
        return Instance_st240_avgu_pb_dest_scond_src1_src2;
      case 0x00000005:
        return Instance_st240_avg4u_pb_nldest_scond_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
      break;
    }
    return Instance__UNDEF;
  case 0x00000006:
    switch ((opcode >> 21) & 0x0000001f) {
    case 0x00000000:
      return Instance_st240_shls_nlidest_src1_isrc2;
    case 0x00000001:
      return Instance_st240_shlso_nlidest_src1_isrc2;
    case 0x00000002:
      return Instance_st240_shrrnp_nlidest_src1_isrc2;
    case 0x00000003:
      return Instance_st240_extract_idest_src1_isrc2;
    case 0x00000004:
      return Instance_st240_extractu_idest_src1_isrc2;
    case 0x00000005:
      switch ((opcode >> 12) & 0x000001ff) {
      case 0x00000008:
        return Instance_st240_sxtb_idest_src1;
      case 0x00000010:
        return Instance_st240_sxth_idest_src1;
      default:
        return Instance_st240_sxt_idest_src1_isrc2;
        break;
      }
      return Instance__UNDEF;
    case 0x00000006:
      switch ((opcode >> 12) & 0x000001ff) {
      case 0x00000010:
        return Instance_st240_zxth_idest_src1;
      default:
        return Instance_st240_zxt_idest_src1_isrc2;
        break;
      }
      return Instance__UNDEF;
    case 0x00000007:
      return Instance_st240_rotl_idest_src1_isrc2;
    case 0x0000000b:
      return Instance_st240_extractl_idest_src1_isrc2;
    case 0x0000000c:
      return Instance_st240_extractlu_idest_src1_isrc2;
    case 0x00000010:
      switch ((opcode >> 12) & 0x000001ff) {
      case 0x0000001b:
        return Instance_st240_bswap_idest_src1;
      default:
        return Instance_st240_perm_pb_idest_src1_isrc2;
        break;
      }
      return Instance__UNDEF;
    case 0x00000018:
      return Instance_st240_shl_ph_idest_src1_isrc2;
    case 0x00000019:
      return Instance_st240_shls_ph_nlidest_src1_isrc2;
    case 0x0000001a:
      return Instance_st240_shr_ph_idest_src1_isrc2;
    case 0x0000001b:
      return Instance_st240_shrrnp_ph_nlidest_src1_isrc2;
    case 0x0000001c:
      return Instance_st240_shrrne_ph_nlidest_src1_isrc2;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x00000007:
    switch ((opcode >> 24) & 0x00000003) {
    case 0x00000000:
      return Instance_st240_slct_idest_scond_src1_isrc2;
    case 0x00000001:
      switch ((opcode >> 12) & 0x000001ff) {
      case 0x00000001:
        switch ((opcode >> 0) & 0x0000003f) {
        case 0x00000000:
          return Instance_st240_convbi_idest_scond;
        default:
          return Instance_st240_slctf_idest_scond_src1_isrc2;
          break;
        }
        return Instance__UNDEF;
      default:
        return Instance_st240_slctf_idest_scond_src1_isrc2;
        break;
      }
      return Instance__UNDEF;
    case 0x00000002:
      switch ((opcode >> 18) & 0x00000007) {
      case 0x00000000:
        return Instance_st240_slct_pb_idest_scond_src1_isrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000003:
      return Instance_st240_slctf_pb_idest_scond_src1_isrc2;
      break;
    }
    return Instance__UNDEF;
  case 0x00000008:
    switch ((opcode >> 24) & 0x00000003) {
    case 0x00000000:
      switch ((opcode >> 6) & 0x0000003f) {
      case 0x00000000:
        switch ((opcode >> 21) & 0x00000007) {
        case 0x00000000:
          return Instance_st240_pft_isrc2_src1;
        default:
          return Instance_st240_pftc_pcond_isrc2_src1;
          break;
        }
        return Instance__UNDEF;
      default:
        switch ((opcode >> 21) & 0x00000007) {
        case 0x00000000:
          return Instance_st240_ldl_idestp_isrc2_src1;
        default:
          return Instance_st240_ldlc_idestp_pcond_isrc2_src1;
          break;
        }
        return Instance__UNDEF;
        break;
      }
      return Instance__UNDEF;
    case 0x00000001:
      switch ((opcode >> 21) & 0x00000007) {
      case 0x00000000:
        return Instance_st240_ldw_idest_isrc2_src1;
      default:
        return Instance_st240_ldwc_idest_pcond_isrc2_src1;
        break;
      }
      return Instance__UNDEF;
    case 0x00000002:
      switch ((opcode >> 21) & 0x00000007) {
      case 0x00000000:
        return Instance_st240_ldh_nlidest_isrc2_src1;
      default:
        return Instance_st240_ldhc_nlidest_pcond_isrc2_src1;
        break;
      }
      return Instance__UNDEF;
    case 0x00000003:
      switch ((opcode >> 21) & 0x00000007) {
      case 0x00000000:
        return Instance_st240_ldhu_nlidest_isrc2_src1;
      default:
        return Instance_st240_ldhuc_nlidest_pcond_isrc2_src1;
        break;
      }
      return Instance__UNDEF;
      break;
    }
    return Instance__UNDEF;
  case 0x00000009:
    switch ((opcode >> 24) & 0x00000003) {
    case 0x00000000:
      switch ((opcode >> 21) & 0x00000007) {
      case 0x00000000:
        return Instance_st240_ldb_nlidest_isrc2_src1;
      default:
        return Instance_st240_ldbc_nlidest_pcond_isrc2_src1;
        break;
      }
      return Instance__UNDEF;
    case 0x00000001:
      switch ((opcode >> 21) & 0x00000007) {
      case 0x00000000:
        return Instance_st240_ldbu_nlidest_isrc2_src1;
      default:
        return Instance_st240_ldbuc_nlidest_pcond_isrc2_src1;
        break;
      }
      return Instance__UNDEF;
    case 0x00000002:
      switch ((opcode >> 18) & 0x0000003f) {
      case 0x00000000:
        return Instance_st240_asm_0_dest_src1_src2;
      case 0x00000008:
        return Instance_st240_asm_1_dest_src1_src2;
      case 0x00000010:
        return Instance_st240_asm_2_dest_src1_src2;
      case 0x00000018:
        return Instance_st240_asm_3_dest_src1_src2;
      case 0x00000020:
        return Instance_st240_asm_4_dest_src1_src2;
      case 0x00000028:
        return Instance_st240_asm_5_dest_src1_src2;
      case 0x00000030:
        return Instance_st240_asm_6_dest_src1_src2;
      case 0x00000038:
        return Instance_st240_asm_7_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000003:
      switch ((opcode >> 18) & 0x0000003f) {
      case 0x00000000:
        return Instance_st240_asm_8_dest_src1_src2;
      case 0x00000008:
        return Instance_st240_asm_9_dest_src1_src2;
      case 0x00000010:
        return Instance_st240_asm_10_dest_src1_src2;
      case 0x00000018:
        return Instance_st240_asm_11_dest_src1_src2;
      case 0x00000020:
        return Instance_st240_asm_12_dest_src1_src2;
      case 0x00000028:
        return Instance_st240_asm_13_dest_src1_src2;
      case 0x00000030:
        return Instance_st240_asm_14_dest_src1_src2;
      case 0x00000038:
        return Instance_st240_asm_15_dest_src1_src2;
      default:
        break;
      }
      return Instance__UNDEF;
      break;
    }
    return Instance__UNDEF;
  case 0x0000000a:
    switch ((opcode >> 24) & 0x00000003) {
    case 0x00000000:
      switch ((opcode >> 21) & 0x00000007) {
      case 0x00000000:
        return Instance_st240_stl_isrc2_src1_src2p;
      default:
        return Instance_st240_stlc_isrc2_src1_pcond_src2p;
        break;
      }
      return Instance__UNDEF;
    case 0x00000001:
      switch ((opcode >> 21) & 0x00000007) {
      case 0x00000000:
        return Instance_st240_stw_isrc2_src1_src2;
      default:
        return Instance_st240_stwc_isrc2_src1_pcond_src2;
        break;
      }
      return Instance__UNDEF;
    case 0x00000002:
      switch ((opcode >> 21) & 0x00000007) {
      case 0x00000000:
        return Instance_st240_sth_isrc2_src1_src2;
      default:
        return Instance_st240_sthc_isrc2_src1_pcond_src2;
        break;
      }
      return Instance__UNDEF;
    case 0x00000003:
      switch ((opcode >> 21) & 0x00000007) {
      case 0x00000000:
        return Instance_st240_asm_16_idest_src1_isrc2;
      case 0x00000001:
        return Instance_st240_asm_17_idest_src1_isrc2;
      case 0x00000002:
        return Instance_st240_asm_18_idest_src1_isrc2;
      case 0x00000003:
        return Instance_st240_asm_19_idest_src1_isrc2;
      case 0x00000004:
        return Instance_st240_asm_20_idest_src1_isrc2;
      case 0x00000005:
        return Instance_st240_asm_21_idest_src1_isrc2;
      case 0x00000006:
        return Instance_st240_asm_22_idest_src1_isrc2;
      case 0x00000007:
        return Instance_st240_asm_23_idest_src1_isrc2;
        break;
      }
      return Instance__UNDEF;
      break;
    }
    return Instance__UNDEF;
  case 0x0000000b:
    switch ((opcode >> 24) & 0x00000003) {
    case 0x00000000:
      switch ((opcode >> 21) & 0x00000007) {
      case 0x00000000:
        return Instance_st240_stb_isrc2_src1_src2;
      default:
        return Instance_st240_stbc_isrc2_src1_pcond_src2;
        break;
      }
      return Instance__UNDEF;
    case 0x00000001:
      switch ((opcode >> 21) & 0x00000007) {
      case 0x00000000:
        return Instance_st240_asm_24_idest_src1_isrc2;
      case 0x00000001:
        return Instance_st240_asm_25_idest_src1_isrc2;
      case 0x00000002:
        return Instance_st240_asm_26_idest_src1_isrc2;
      case 0x00000003:
        return Instance_st240_asm_27_idest_src1_isrc2;
      case 0x00000004:
        return Instance_st240_asm_28_idest_src1_isrc2;
      case 0x00000005:
        return Instance_st240_asm_29_idest_src1_isrc2;
      case 0x00000006:
        return Instance_st240_asm_30_idest_src1_isrc2;
      case 0x00000007:
        return Instance_st240_asm_31_idest_src1_isrc2;
        break;
      }
      return Instance__UNDEF;
    case 0x00000003:
      switch ((opcode >> 21) & 0x00000007) {
      case 0x00000000:
        switch ((opcode >> 6) & 0x0000003f) {
        case 0x00000000:
          return Instance_st240_prgadd_isrc2_src1;
        case 0x00000001:
          return Instance_st240_prgadd_l1_isrc2_src1;
        default:
          break;
        }
        return Instance__UNDEF;
      case 0x00000001:
        switch ((opcode >> 6) & 0x0000003f) {
        case 0x00000000:
          return Instance_st240_prgset_isrc2_src1;
        case 0x00000001:
          return Instance_st240_prgset_l1_isrc2_src1;
        default:
          break;
        }
        return Instance__UNDEF;
      case 0x00000002:
        switch ((opcode >> 6) & 0x0000003f) {
        case 0x00000000:
          return Instance_st240_prginsadd_isrc2_src1;
        case 0x00000001:
          return Instance_st240_prginsadd_l1_isrc2_src1;
        default:
          break;
        }
        return Instance__UNDEF;
      case 0x00000003:
        switch ((opcode >> 6) & 0x0000003f) {
        case 0x00000000:
          return Instance_st240_prginsset_isrc2_src1;
        case 0x00000001:
          return Instance_st240_prginsset_l1_isrc2_src1;
        default:
          break;
        }
        return Instance__UNDEF;
      case 0x00000004:
        switch ((opcode >> 6) & 0x0000003f) {
        case 0x00000000:
          return Instance_st240_flushadd_isrc2_src1;
        case 0x00000001:
          return Instance_st240_flushadd_l1_isrc2_src1;
        default:
          break;
        }
        return Instance__UNDEF;
      case 0x00000005:
        return Instance_st240_pswmask_nlidest_src1_isrc2;
      case 0x00000006:
        switch ((opcode >> 6) & 0x0000003f) {
        case 0x00000000:
          return Instance_st240_invadd_isrc2_src1;
        case 0x00000001:
          return Instance_st240_invadd_l1_isrc2_src1;
        default:
          break;
        }
        return Instance__UNDEF;
      case 0x00000007:
        switch ((opcode >> 15) & 0x0000003f) {
        case 0x00000000:
          switch ((opcode >> 12) & 0x00000007) {
          case 0x00000000:
            switch ((opcode >> 0) & 0x00000fff) {
            case 0x00000000:
              return Instance_st240_syncins;
            default:
              break;
            }
            return Instance__UNDEF;
          case 0x00000002:
            switch ((opcode >> 0) & 0x00000fff) {
            case 0x00000000:
              return Instance_st240_sync;
            default:
              break;
            }
            return Instance__UNDEF;
          case 0x00000003:
            switch ((opcode >> 0) & 0x00000fff) {
            case 0x00000000:
              return Instance_st240_wmb;
            default:
              break;
            }
            return Instance__UNDEF;
          case 0x00000004:
            switch ((opcode >> 0) & 0x00000fff) {
            case 0x00000000:
              return Instance_st240_waitl;
            default:
              break;
            }
            return Instance__UNDEF;
          case 0x00000005:
            return Instance_st240_ldwl_idest_src1;
          case 0x00000006:
            switch ((opcode >> 0) & 0x00000fff) {
            case 0x00000000:
              return Instance_st240_dib;
            default:
              break;
            }
            return Instance__UNDEF;
          default:
            break;
          }
          return Instance__UNDEF;
        case 0x00000001:
          switch ((opcode >> 12) & 0x00000007) {
          case 0x00000000:
            switch ((opcode >> 31) & 0x00000001) {
            case 0x00000001:
              return Instance_st240_dbgsbrk_brknum;
            default:
              break;
            }
            return Instance__UNDEF;
          case 0x00000001:
            switch ((opcode >> 31) & 0x00000001) {
            case 0x00000001:
              return Instance_st240_sbrk_brknum;
            default:
              break;
            }
            return Instance__UNDEF;
          case 0x00000002:
            return Instance_st240_syscall_brknum;
          case 0x00000003:
            switch ((opcode >> 0) & 0x00000fff) {
            case 0x00000000:
              return Instance_st240_break;
            default:
              break;
            }
            return Instance__UNDEF;
          case 0x00000004:
            switch ((opcode >> 0) & 0x00000fff) {
            case 0x00000000:
              switch ((opcode >> 31) & 0x00000001) {
              case 0x00000001:
                return Instance_st240_retention;
              default:
                break;
              }
              return Instance__UNDEF;
            default:
              break;
            }
            return Instance__UNDEF;
          default:
            break;
          }
          return Instance__UNDEF;
        case 0x00000020:
          return Instance_st240_stwl_bdest2_src1_src2;
        default:
          break;
        }
        return Instance__UNDEF;
        break;
      }
      return Instance__UNDEF;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x0000000c:
    switch ((opcode >> 23) & 0x00000007) {
    case 0x00000000:
      return Instance_st240_call_btarg;
    case 0x00000001:
      switch ((opcode >> 0) & 0x007fffff) {
      case 0x00000000:
        return Instance_st240_icall;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000002:
      switch ((opcode >> 0) & 0x007fffff) {
      case 0x00000000:
        return Instance_st240_idle;
      default:
        return Instance_st240_goto_btarg;
        break;
      }
      return Instance__UNDEF;
    case 0x00000003:
      switch ((opcode >> 0) & 0x007fffff) {
      case 0x00000000:
        return Instance_st240_igoto;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000004:
      switch ((opcode >> 0) & 0x007fffff) {
      case 0x00000000:
        return Instance_st240_rfi;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000007:
      switch ((opcode >> 0) & 0x007fffff) {
      case 0x00000000:
        return Instance_st240_return;
      default:
        break;
      }
      return Instance__UNDEF;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x0000000e:
    return Instance_st240_br_bcond_btarg;
  case 0x0000000f:
    return Instance_st240_brf_bcond_btarg;
  default:
    break;
  }
  return Instance__UNDEF;
}
#endif//NDECODE

#line 4050 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/st200/Decode.xcc"
#ifndef NDECODE
Instance
Decode_Encoding_st240_ANYX(const void *buffer)
{
  uint32_t opcode = *(const uint32_t *)buffer;
  switch ((opcode >> 24) & 0x0000007f) {
  case 0x00000008:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      switch ((opcode >> 0) & 0x0000003f) {
      case 0x00000000:
        return Instance_st240_mov_idest_xsrc2;
      default:
        return Instance_st240_add_idest_src1_xsrc2;
        break;
      }
      return Instance__UNDEF;
    case 0x00000001:
      return Instance_st240_sub_idest_xsrc2_src1;
    case 0x00000002:
      return Instance_st240_shl_idest_src1_xsrc2;
    case 0x00000003:
      return Instance_st240_shr_idest_src1_xsrc2;
    case 0x00000004:
      return Instance_st240_shru_idest_src1_xsrc2;
    case 0x00000005:
      return Instance_st240_sh1add_idest_src1_xsrc2;
    case 0x00000006:
      return Instance_st240_sh2add_idest_src1_xsrc2;
    case 0x00000007:
      return Instance_st240_sh3add_idest_src1_xsrc2;
      break;
    }
    return Instance__UNDEF;
  case 0x00000009:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      switch ((opcode >> 0) & 0x0000003f) {
      case 0x00000000:
        return Instance_st240_addpc_idest_xsrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000001:
      return Instance_st240_and_idest_src1_xsrc2;
    case 0x00000002:
      return Instance_st240_andc_idest_src1_xsrc2;
    case 0x00000003:
      return Instance_st240_or_idest_src1_xsrc2;
    case 0x00000005:
      return Instance_st240_xor_idest_src1_xsrc2;
    case 0x00000007:
      return Instance_st240_mul64h_nlidest_src1_xsrc2;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x0000000a:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      return Instance_st240_max_idest_src1_xsrc2;
    case 0x00000001:
      return Instance_st240_maxu_idest_src1_xsrc2;
    case 0x00000002:
      return Instance_st240_min_idest_src1_xsrc2;
    case 0x00000003:
      return Instance_st240_minu_idest_src1_xsrc2;
    case 0x00000004:
      return Instance_st240_mul64hu_nlidest_src1_xsrc2;
    case 0x00000006:
      return Instance_st240_mul32_nlidest_src1_xsrc2;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x0000000b:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000001:
      return Instance_st240_mulll_nlidest_src1_xsrc2;
    case 0x00000002:
      return Instance_st240_mulllu_nlidest_src1_xsrc2;
    case 0x00000007:
      return Instance_st240_mulfrac_nlidest_src1_xsrc2;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x0000000c:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      return Instance_st240_cmpeq_idest_src1_xsrc2;
    case 0x00000001:
      return Instance_st240_cmpne_idest_src1_xsrc2;
    case 0x00000002:
      return Instance_st240_cmpge_idest_src1_xsrc2;
    case 0x00000003:
      return Instance_st240_cmpgeu_idest_src1_xsrc2;
    case 0x00000004:
      return Instance_st240_cmpgt_idest_src1_xsrc2;
    case 0x00000005:
      return Instance_st240_cmpgtu_idest_src1_xsrc2;
    case 0x00000006:
      return Instance_st240_cmple_idest_src1_xsrc2;
    case 0x00000007:
      return Instance_st240_cmpleu_idest_src1_xsrc2;
      break;
    }
    return Instance__UNDEF;
  case 0x0000000d:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      return Instance_st240_cmplt_idest_src1_xsrc2;
    case 0x00000001:
      return Instance_st240_cmpltu_idest_src1_xsrc2;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x0000000e:
    switch ((opcode >> 9) & 0x00000007) {
    case 0x00000000:
      switch ((opcode >> 21) & 0x00000007) {
      case 0x00000000:
        return Instance_st240_cmpeq_ibdest_src1_xsrc2;
      case 0x00000001:
        return Instance_st240_cmpne_ibdest_src1_xsrc2;
      case 0x00000002:
        return Instance_st240_cmpge_ibdest_src1_xsrc2;
      case 0x00000003:
        return Instance_st240_cmpgeu_ibdest_src1_xsrc2;
      case 0x00000004:
        return Instance_st240_cmpgt_ibdest_src1_xsrc2;
      case 0x00000005:
        return Instance_st240_cmpgtu_ibdest_src1_xsrc2;
      case 0x00000006:
        return Instance_st240_cmple_ibdest_src1_xsrc2;
      case 0x00000007:
        return Instance_st240_cmpleu_ibdest_src1_xsrc2;
        break;
      }
      return Instance__UNDEF;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x0000000f:
    switch ((opcode >> 9) & 0x00000007) {
    case 0x00000000:
      switch ((opcode >> 21) & 0x00000007) {
      case 0x00000000:
        return Instance_st240_cmplt_ibdest_src1_xsrc2;
      case 0x00000001:
        return Instance_st240_cmpltu_ibdest_src1_xsrc2;
      default:
        break;
      }
      return Instance__UNDEF;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x00000018:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      return Instance_st240_shls_nlidest_src1_xsrc2;
    case 0x00000001:
      return Instance_st240_shlso_nlidest_src1_xsrc2;
    case 0x00000002:
      return Instance_st240_shrrnp_nlidest_src1_xsrc2;
    case 0x00000003:
      return Instance_st240_extract_idest_src1_xsrc2;
    case 0x00000004:
      return Instance_st240_extractu_idest_src1_xsrc2;
    case 0x00000005:
      return Instance_st240_sxt_idest_src1_xsrc2;
    case 0x00000006:
      return Instance_st240_zxt_idest_src1_xsrc2;
    case 0x00000007:
      return Instance_st240_rotl_idest_src1_xsrc2;
      break;
    }
    return Instance__UNDEF;
  case 0x00000019:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000003:
      return Instance_st240_extractl_idest_src1_xsrc2;
    case 0x00000004:
      return Instance_st240_extractlu_idest_src1_xsrc2;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x0000001a:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      return Instance_st240_perm_pb_idest_src1_xsrc2;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x0000001b:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      return Instance_st240_shl_ph_idest_src1_xsrc2;
    case 0x00000001:
      return Instance_st240_shls_ph_nlidest_src1_xsrc2;
    case 0x00000002:
      return Instance_st240_shr_ph_idest_src1_xsrc2;
    case 0x00000003:
      return Instance_st240_shrrnp_ph_nlidest_src1_xsrc2;
    case 0x00000004:
      return Instance_st240_shrrne_ph_nlidest_src1_xsrc2;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x0000001c:
    return Instance_st240_slct_idest_scond_src1_xsrc2;
  case 0x0000001d:
    return Instance_st240_slctf_idest_scond_src1_xsrc2;
  case 0x0000001e:
    switch ((opcode >> 18) & 0x00000007) {
    case 0x00000000:
      return Instance_st240_slct_pb_idest_scond_src1_xsrc2;
    default:
      break;
    }
    return Instance__UNDEF;
  case 0x0000001f:
    return Instance_st240_slctf_pb_idest_scond_src1_xsrc2;
  case 0x00000020:
    switch ((opcode >> 6) & 0x0000003f) {
    case 0x00000000:
      switch ((opcode >> 21) & 0x00000007) {
      case 0x00000000:
        return Instance_st240_pft_xsrc2_src1;
      default:
        return Instance_st240_pftc_pcond_xsrc2_src1;
        break;
      }
      return Instance__UNDEF;
    default:
      switch ((opcode >> 21) & 0x00000007) {
      case 0x00000000:
        return Instance_st240_ldl_idestp_xsrc2_src1;
      default:
        return Instance_st240_ldlc_idestp_pcond_xsrc2_src1;
        break;
      }
      return Instance__UNDEF;
      break;
    }
    return Instance__UNDEF;
  case 0x00000021:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      return Instance_st240_ldw_idest_xsrc2_src1;
    default:
      return Instance_st240_ldwc_idest_pcond_xsrc2_src1;
      break;
    }
    return Instance__UNDEF;
  case 0x00000022:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      return Instance_st240_ldh_nlidest_xsrc2_src1;
    default:
      return Instance_st240_ldhc_nlidest_pcond_xsrc2_src1;
      break;
    }
    return Instance__UNDEF;
  case 0x00000023:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      return Instance_st240_ldhu_nlidest_xsrc2_src1;
    default:
      return Instance_st240_ldhuc_nlidest_pcond_xsrc2_src1;
      break;
    }
    return Instance__UNDEF;
  case 0x00000024:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      return Instance_st240_ldb_nlidest_xsrc2_src1;
    default:
      return Instance_st240_ldbc_nlidest_pcond_xsrc2_src1;
      break;
    }
    return Instance__UNDEF;
  case 0x00000025:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      return Instance_st240_ldbu_nlidest_xsrc2_src1;
    default:
      return Instance_st240_ldbuc_nlidest_pcond_xsrc2_src1;
      break;
    }
    return Instance__UNDEF;
  case 0x00000028:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      return Instance_st240_stl_xsrc2_src1_src2p;
    default:
      return Instance_st240_stlc_xsrc2_src1_pcond_src2p;
      break;
    }
    return Instance__UNDEF;
  case 0x00000029:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      return Instance_st240_stw_xsrc2_src1_src2;
    default:
      return Instance_st240_stwc_xsrc2_src1_pcond_src2;
      break;
    }
    return Instance__UNDEF;
  case 0x0000002a:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      return Instance_st240_sth_xsrc2_src1_src2;
    default:
      return Instance_st240_sthc_xsrc2_src1_pcond_src2;
      break;
    }
    return Instance__UNDEF;
  case 0x0000002b:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      return Instance_st240_asm_16_idest_src1_xsrc2;
    case 0x00000001:
      return Instance_st240_asm_17_idest_src1_xsrc2;
    case 0x00000002:
      return Instance_st240_asm_18_idest_src1_xsrc2;
    case 0x00000003:
      return Instance_st240_asm_19_idest_src1_xsrc2;
    case 0x00000004:
      return Instance_st240_asm_20_idest_src1_xsrc2;
    case 0x00000005:
      return Instance_st240_asm_21_idest_src1_xsrc2;
    case 0x00000006:
      return Instance_st240_asm_22_idest_src1_xsrc2;
    case 0x00000007:
      return Instance_st240_asm_23_idest_src1_xsrc2;
      break;
    }
    return Instance__UNDEF;
  case 0x0000002c:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      return Instance_st240_stb_xsrc2_src1_src2;
    default:
      return Instance_st240_stbc_xsrc2_src1_pcond_src2;
      break;
    }
    return Instance__UNDEF;
  case 0x0000002d:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      return Instance_st240_asm_24_idest_src1_xsrc2;
    case 0x00000001:
      return Instance_st240_asm_25_idest_src1_xsrc2;
    case 0x00000002:
      return Instance_st240_asm_26_idest_src1_xsrc2;
    case 0x00000003:
      return Instance_st240_asm_27_idest_src1_xsrc2;
    case 0x00000004:
      return Instance_st240_asm_28_idest_src1_xsrc2;
    case 0x00000005:
      return Instance_st240_asm_29_idest_src1_xsrc2;
    case 0x00000006:
      return Instance_st240_asm_30_idest_src1_xsrc2;
    case 0x00000007:
      return Instance_st240_asm_31_idest_src1_xsrc2;
      break;
    }
    return Instance__UNDEF;
  case 0x0000002f:
    switch ((opcode >> 21) & 0x00000007) {
    case 0x00000000:
      switch ((opcode >> 6) & 0x0000003f) {
      case 0x00000000:
        return Instance_st240_prgadd_xsrc2_src1;
      case 0x00000001:
        return Instance_st240_prgadd_l1_xsrc2_src1;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000001:
      switch ((opcode >> 6) & 0x0000003f) {
      case 0x00000000:
        return Instance_st240_prgset_xsrc2_src1;
      case 0x00000001:
        return Instance_st240_prgset_l1_xsrc2_src1;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000002:
      switch ((opcode >> 6) & 0x0000003f) {
      case 0x00000000:
        return Instance_st240_prginsadd_xsrc2_src1;
      case 0x00000001:
        return Instance_st240_prginsadd_l1_xsrc2_src1;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000003:
      switch ((opcode >> 6) & 0x0000003f) {
      case 0x00000000:
        return Instance_st240_prginsset_xsrc2_src1;
      case 0x00000001:
        return Instance_st240_prginsset_l1_xsrc2_src1;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000004:
      switch ((opcode >> 6) & 0x0000003f) {
      case 0x00000000:
        return Instance_st240_flushadd_xsrc2_src1;
      case 0x00000001:
        return Instance_st240_flushadd_l1_xsrc2_src1;
      default:
        break;
      }
      return Instance__UNDEF;
    case 0x00000005:
      return Instance_st240_pswmask_nlidest_src1_xsrc2;
    case 0x00000006:
      switch ((opcode >> 6) & 0x0000003f) {
      case 0x00000000:
        return Instance_st240_invadd_xsrc2_src1;
      case 0x00000001:
        return Instance_st240_invadd_l1_xsrc2_src1;
      default:
        break;
      }
      return Instance__UNDEF;
    default:
      break;
    }
    return Instance__UNDEF;
  default:
    break;
  }
  return Instance__UNDEF;
}
#endif//NDECODE


#endif//Decode_c_INCLUDED
