#ifndef Encoding_c_INCLUDED
#define Encoding_c_INCLUDED

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Encoding.xcc"
#include "MDS/MDS_.h"

#line 37 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Encoding.xcc"
const int Encoding__COUNT = Encoding__;

#line 39 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Encoding.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 47 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Encoding.xcc"
#ifndef ECL_NTRACE
const char *
Encoding_name_(Encoding this)
{
  static const char *_[] = {
#define Encoding(NAME, PROCESSOR, WORDTYPE, WORDCOUNT) \
    #NAME,
    "_UNDEF",
#include "Encoding.enum"
  };
  Except_REQUIRE((unsigned)this < Encoding__);
  return _[this];
}
#endif//ECL_NTRACE

#line 70 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Encoding.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 78 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Encoding.xcc"
extern const Processor
Encoding_Processor[];
Processor
Encoding_processor(Encoding this)
{
  Except_REQUIRE((unsigned)this < Encoding__);
  return (Processor)Encoding_Processor[this];
}

#line 87 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Encoding.xcc"
const Processor
Encoding_Processor[] = {
#define PROCESSOR(NAME) Processor_##NAME
#define Encoding(NAME, PROCESSOR, WORDTYPE, WORDCOUNT) \
  PROCESSOR,
  PROCESSOR(_UNDEF),
#include "Encoding.enum"
};

#line 105 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Encoding.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 127 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Encoding.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 135 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Encoding.xcc"
extern const uint8_t
Encoding_WordCount[];
uint8_t
Encoding_wordCount(Encoding this)
{
  Except_REQUIRE((unsigned)this < Encoding__);
  return Encoding_WordCount[this];
}

#line 144 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Encoding.xcc"
const uint8_t
Encoding_WordCount[] = {
#define WORDCOUNT(d) d
#define Encoding(NAME, PROCESSOR, WORDTYPE, WORDCOUNT) \
  WORDCOUNT,
  WORDCOUNT(0),
#include "Encoding.enum"
};

#line 162 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Encoding.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 170 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Encoding.xcc"
extern const uint8_t
Encoding_WordSize[];
uint8_t
Encoding_wordSize(Encoding this)
{
  Except_REQUIRE((unsigned)this < Encoding__);
  return Encoding_WordSize[this];
}

#line 179 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Encoding.xcc"
const uint8_t
Encoding_WordSize[] = {
#define WORDTYPE(d) sizeof(d)
#define Encoding(NAME, PROCESSOR, WORDTYPE, WORDCOUNT) \
  WORDTYPE,
  0,
#include "Encoding.enum"
};

#line 197 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Encoding.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 206 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Encoding.xcc"
#ifndef NDECODE
extern const EncodingDecode
Encoding_Decode[];
EncodingDecode
Encoding_decode(Encoding this)
{
  Except_REQUIRE((unsigned)this < Encoding__);
  return Encoding_Decode[this];
}
#endif//NDECODE

#line 217 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Encoding.xcc"
#ifndef NDECODE
const EncodingDecode
Encoding_Decode[] = {
#define Encoding(NAME, PROCESSOR, WORDTYPE, WORDCOUNT) \
  Decode_Encoding_##NAME,
  NULL,
#include "Encoding.enum"
};
#endif//NDECODE

#line 227 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Encoding.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 239 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Encoding.xcc"
#if XCC__C
static void
Encoding_TEST(void)
{
#include "MDS/Encoding_.c"
}

#line 246 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Encoding.xcc"
int
main(int argc, char **argv)
{
  MDS_Test(Encoding_TEST);
  return 0;
}
#endif


#endif//Encoding_c_INCLUDED
