#ifndef Instance_c_INCLUDED
#define Instance_c_INCLUDED

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
#include "MDS/MDS_.h"

#line 32 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
const int Instance__COUNT = Instance__;

#line 34 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 36 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
RegisterAction_
Instance_Actions[] = {
#define REGISTER(name) Register_##name
#define REGCLASS(name) RegClass_##name
#define XXXINDEX(d) d
#define RANK(d) d
#define STAGE(d) d
#define ACTION(register, regClass, xxxIndex, rank, stage) \
  { register, regClass, xxxIndex, rank, stage },
#define ACTIONS(actions) actions
#define InstanceActions(INDEX, ACTIONS) \
  ACTIONS
  // No dummy entry because only used as Instance_Actions + actionsIndex.
#include "Instance.enum"
#undef ACTIONS
};

#line 58 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 66 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
#ifndef ECL_NTRACE
const char *
Instance_name_(Instance this)
{
  static const char *_[] = {
#define Instance(NAME, SCHEDULING, ENCODING, OPCODES, OPERANDS, \
                 INCREMENT, MNEMONIC, SYNTAX, ACTIONARRAY, OPERATOR) \
    #NAME,
    "_UNDEF",
#include "Instance.enum"
  };
  Except_REQUIRE((unsigned)this < Instance__);
  return _[this];
}
#endif//ECL_NTRACE

#line 90 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 98 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
extern const Scheduling
Instance_Scheduling[];
Scheduling
Instance_scheduling(Instance this)
{
  Except_REQUIRE((unsigned)this < Instance__);
  return (Scheduling)Instance_Scheduling[this];
}

#line 107 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
const Scheduling
Instance_Scheduling[] = {
#define SCHEDULING(NAME) Scheduling_##NAME
#define Instance(NAME, SCHEDULING, ENCODING, OPCODES, OPERANDS, \
                 INCREMENT, MNEMONIC, SYNTAX, ACTIONARRAY, OPERATOR) \
  SCHEDULING,
  SCHEDULING(_UNDEF),
#include "Instance.enum"
};

#line 128 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 136 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
extern const Encoding
Instance_Encoding[];
Encoding
Instance_encoding(Instance this)
{
  Except_REQUIRE((unsigned)this < Instance__);
  return (Encoding)Instance_Encoding[this];
}

#line 145 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
const Encoding
Instance_Encoding[] = {
#define ENCODING(NAME) Encoding_##NAME
#define Instance(NAME, SCHEDULING, ENCODING, OPCODES, OPERANDS, \
                 INCREMENT, MNEMONIC, SYNTAX, ACTIONARRAY, OPERATOR) \
  ENCODING,
  ENCODING(_UNDEF),
#include "Instance.enum"
};

#line 166 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 174 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
InstanceOpcodes
InstanceOpcodes_Ctor(InstanceOpcodes this)
{
  InstanceOpcodes_WORDS(this)[0] = 0;
  InstanceOpcodes_WORDS(this)[1] = 0;
  return this;
}

#line 188 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
extern const InstanceOpcodes_
Instance_Opcodes[];
const_InstanceOpcodes Instance_opcodes(Instance this)
{
  Except_REQUIRE((unsigned)this < Instance__);
  return &Instance_Opcodes[this];
}

#line 196 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
const InstanceOpcodes_
Instance_Opcodes[] = {
#define OPCODE(opcode) opcode,
#define OPCODES(count, items) { { items } },
#define Instance(NAME, SCHEDULING, ENCODING, OPCODES, OPERANDS, \
                 INCREMENT, MNEMONIC, SYNTAX, ACTIONARRAY, OPERATOR) \
  OPCODES
  OPCODES(1, OPCODE(0))
#include "Instance.enum"
};

#line 228 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 236 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
extern const Operands
Instance_Operands[];
Operands
Instance_operands(Instance this)
{
  Except_REQUIRE((unsigned)this < Instance__);
  return (Operands)Instance_Operands[this];
}

#line 245 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
const Operands
Instance_Operands[] = {
#define OPERANDS(NAME) Operands_##NAME
#define Instance(NAME, SCHEDULING, ENCODING, OPCODES, OPERANDS, \
                 INCREMENT, MNEMONIC, SYNTAX, ACTIONARRAY, OPERATOR) \
  OPERANDS,
  OPERANDS(_UNDEF),
#include "Instance.enum"
};

#line 266 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 274 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
#if !Bundle_ISSUE_MAX
extern const int8_t
Instance_Increment[];
int
Instance_increment(Instance this)
{
  Except_REQUIRE((unsigned)this < Instance__);
  return Instance_Increment[this];
}
#endif//!Bundle_ISSUE_MAX

#line 285 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
#if !Bundle_ISSUE_MAX
const int8_t
Instance_Increment[] = {
#define INCREMENT(d) d
#define Instance(NAME, SCHEDULING, ENCODING, OPCODES, OPERANDS, \
                 INCREMENT, MNEMONIC, SYNTAX, ACTIONARRAY, OPERATOR) \
  INCREMENT,
  INCREMENT(0),
#include "Instance.enum"
};
#endif//!Bundle_ISSUE_MAX

#line 310 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 318 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
#ifndef ECL_NTRACE
const char *
Instance_Mnemonic[] = {
#define MNEMONIC(mnemonic) mnemonic
#define Instance(NAME, SCHEDULING, ENCODING, OPCODES, OPERANDS, \
                 INCREMENT, MNEMONIC, SYNTAX, ACTIONARRAY, OPERATOR) \
  MNEMONIC,
  NULL,
#include "Instance.enum"
};
#endif//ECL_NTRACE

#line 330 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
#ifndef ECL_NTRACE
const char *
Instance_mnemonic(Instance this)
{
  Except_REQUIRE((unsigned)this < Instance__);
  return Instance_Mnemonic[this];
}
#endif//ECL_NTRACE

#line 349 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 357 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
#ifndef ECL_NTRACE
const char *
Instance_Syntax[] = {
#define SYNTAX(syntax) syntax
#define Instance(NAME, SCHEDULING, ENCODING, OPCODES, OPERANDS, \
                 INCREMENT, MNEMONIC, SYNTAX, ACTIONARRAY, OPERATOR) \
  SYNTAX,
  NULL,
#include "Instance.enum"
};
#endif//ECL_NTRACE

#line 369 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
#ifndef ECL_NTRACE
const char *
Instance_syntax(Instance this)
{
  Except_REQUIRE((unsigned)this < Instance__);
  return Instance_Syntax[this];
}
#endif//ECL_NTRACE

#line 388 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 396 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
/*
  Default spill cost values.
  TODO: Should be defined by architecture.
  The cost is compute as:
  cost = latency+issue/max_issue.
  The default costs are for a machine with:
  issue of remat: 1/4
  issue of load or store: 1/1
  latency of load: 3
  latency of store: 0
  This is the ST200 model.
 */
int
Instance_unitCost(Instance this)
{
  // FIXME! Use scheduling classes for this computation.
  int scheduling = Instance_scheduling(this);
  int processor = Scheduling_processor(scheduling);
  int maxIssue = Resource_availability(Resource__ISSUE, processor);
  if (Instance_isControl(this)) return (maxIssue*1)/1;
  if (Instance_isMemoryWrite(this)) return (maxIssue*1)/1;
  if (Instance_isMemoryRead(this)) return (maxIssue*(1+3))/1;
  return 1;	// (maxIssue*1)/maxIssue;
}

#line 421 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 429 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
extern /*const*/ RegisterActionArray_
Instance_ActionArray[];
const_RegisterActionArray
Instance_actionArray(Instance this)
{
  Except_REQUIRE((unsigned)this < Instance__);
  return Instance_ActionArray + this;
}

#line 438 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
/*const*/ RegisterActionArray_
Instance_ActionArray[] = {
#define READCOUNT(d) d
#define READSTART(d) d
#define WRITECOUNT(d) d
#define WRITESTART(d) d
#define ACTIONSINDEX(index) index
#define ACTIONARRAY(readCount, readStart, writeCount, writeStart, actionsIndex) \
  { readCount, readStart, writeCount, writeStart, Instance_Actions + actionsIndex }
#define Instance(NAME, SCHEDULING, ENCODING, OPCODES, OPERANDS, \
                 INCREMENT, MNEMONIC, SYNTAX, ACTIONARRAY, OPERATOR) \
  ACTIONARRAY,
  { 0 },
#include "Instance.enum"
};

#line 487 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 495 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
extern const Operator
Instance_Operator[];
Operator
Instance_operator(Instance this)
{
  Except_REQUIRE((unsigned)this < Instance__);
  return (Operator)Instance_Operator[this];
}

#line 504 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
const Operator
Instance_Operator[] = {
#define OPERATOR(NAME) Operator_##NAME
#define Instance(NAME, SCHEDULING, ENCODING, OPCODES, OPERANDS, \
                 INCREMENT, MNEMONIC, SYNTAX, ACTIONARRAY, OPERATOR) \
  OPERATOR,
  OPERATOR(_UNDEF),
#include "Instance.enum"
};

#line 525 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 535 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
RegisterAction_ *
Instance_makeRegisterActionItems(Instance this, Memory memory)
{
  RegisterActionArray actionArray = Instance_ActionArray + this;
  RegisterAction_ *old_items = RegisterActionArray_ITEMS(actionArray);
  int Instance_Actions_count = sizeof(Instance_Actions)/sizeof(Instance_Actions[0]);
  if (   old_items >= Instance_Actions
      && old_items < Instance_Actions + Instance_Actions_count) {
    size_t size = sizeof(RegisterAction_)*RegisterActionArray_count(actionArray);
    RegisterAction_ *new_items = Memory_alloc(memory, size);
    *RegisterActionArray__ITEMS(actionArray) = new_items;
    return memcpy(new_items, old_items, size);
  }
  return old_items;
}

#line 551 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 578 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
extern /*const*/ InstanceAttributes
Instance_Attributes[];
InstanceAttributes
Instance_attributes(Instance this)
{
  Except_REQUIRE((unsigned)this < Instance__);
  return Instance_Attributes[this];
}

#line 587 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
/*const*/ InstanceAttributes
Instance_Attributes[Instance__];

#line 606 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 612 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
unsigned
Instance_fixupRAW(Instance this, Instance that)
{
  unsigned attributes;
  Except_CHECK((unsigned)this < Instance__);
  attributes = Instance_Attributes[this] | Instance_Attributes[that];
  return attributes & (1<<InstanceAttribute_FixRegisterRAW);
}

#line 625 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 633 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
void
Instance_INIT(void)
{
  int operator = 0;
  int processor = 0;
  InstanceAttributes *attributes = Instance_Attributes;
  for (; operator < Operator__; operator++) {
    for (processor = 1; processor < Processor__; processor++) {
      int instance = Operator_instance(operator, processor);
      if (instance != Instance_) {
        if (Operator_isControl(operator)) {
          attributes[instance] |= 1<<InstanceAttribute_Control;
        }
        if (Operator_isMemoryRead(operator) || Operator_isMemoryBarrier(operator)) {
          attributes[instance] |= 1<<InstanceAttribute_MemoryRead;
        }
        if (Operator_isMemoryWrite(operator) || Operator_isMemoryBarrier(operator)) {
          attributes[instance] |= 1<<InstanceAttribute_MemoryWrite;
        }
        if (Operator_isFixRegisterRAW(operator)) {
          attributes[instance] |= 1<<InstanceAttribute_FixRegisterRAW;
        }
      }
    }
  }
}

#line 665 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
#if XCC__C
static void
Instance_TEST(void)
{
#include "MDS/Instance_.c"
}

#line 672 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Instance.xcc"
int
main(int argc, char **argv)
{
  MDS_Test(Instance_TEST);
  return 0;
}
#endif

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/st200-Instance.xcc"
int
Instance_latencyRAW(Instance this, Instance that, StorageCell cell)
{
  if (cell == StorageCell_st200_GR63) {
    if (!Instance_isFixRegisterRAW(this) &&
        !Instance_isMemoryRead(this)) {
      // This is neither igoto|call|icall|return nor Load.
      // Assume this is arithmetic.
      if (Instance_isFixRegisterRAW(that)) {
        // That is igoto|call|icall|return.
        return 1;
      }
    }
  }
  return 0;
}


#endif//Instance_c_INCLUDED
