#ifndef Operand_c_INCLUDED
#define Operand_c_INCLUDED

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
#include "MDS/MDS_.h"

#line 35 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
const int Operand__COUNT = Operand__;

#line 47 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
const int Operands__COUNT = Operands__;

#line 49 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 57 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
#ifndef ECL_NTRACE
const char *
Operand_name_(Operand this)
{
  static const char *_[] = {
#define Operand(NAME, METHOD, WORDTYPE, ENCODE, DECODE) \
    #NAME,
    "_UNDEF",
#include "Operand.enum"
  };
  Except_REQUIRE((unsigned)this < Operand__);
  return _[this];
}
#endif//ECL_NTRACE

#line 80 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 96 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
#ifndef ECL_NTRACE
const char *
OperandType_name_(OperandType this)
{
  static const char *_[] = {
    "_UNDEF",
    "Register",
    "RegClass",
    "Immediate",
    "Modifier",
    "RegMask",
  };
  Except_REQUIRE((unsigned)this < OperandType__);
  return _[this];
}
#endif//ECL_NTRACE

#line 119 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
extern const OperandType
Operand_Type[];
OperandType
Operand_type(Operand this)
{
  Except_REQUIRE((unsigned)this < Operand__);
  return (OperandType)Operand_Type[this];
}

#line 128 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
const OperandType
Operand_Type[] = {
#define METHOD(type, name) OperandType_##type
#define Operand(NAME, METHOD, WORDTYPE, ENCODE, DECODE) \
  METHOD,
  OperandType_,
#include "Operand.enum"
#undef METHOD
};

#line 148 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 156 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
extern const int8_t
Operand_Enum[];
int
Operand_enum(Operand this)
{
  Except_REQUIRE((unsigned)this < Operand__);
  return Operand_Enum[this];
}

#line 165 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
const int8_t
Operand_Enum[] = {
#define METHOD(type, name) type##_##name
#define Operand(NAME, METHOD, WORDTYPE, ENCODE, DECODE) \
  METHOD,
  OperandType_,
#include "Operand.enum"
#undef METHOD
};

#line 175 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 183 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
Modifier
Operand_modifier(Operand this)
{
  if (Operand_type(this) == OperandType_Modifier) {
    return (Modifier)Operand_Enum[this];
  }
  return Modifier_;
}

#line 202 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 210 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
Immediate
Operand_immediate(Operand this)
{
  if (Operand_type(this) == OperandType_Immediate) {
    return (Immediate)Operand_Enum[this];
  }
  return Immediate_;
}

#line 229 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 237 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
RegClass
Operand_regClass(Operand this)
{
  if (Operand_type(this) == OperandType_RegClass) {
    return (RegClass)Operand_Enum[this];
  }
  return RegClass_;
}

#line 256 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 264 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
RegMask
Operand_regMask(Operand this)
{
  if (Operand_type(this) == OperandType_RegMask) {
    return (RegMask)Operand_Enum[this];
  }
  return RegMask_;
}

#line 283 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 292 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
extern const OperandEncode
Operand_Encode[];
OperandEncode
Operand_encode(Operand this)
{
  Except_REQUIRE((unsigned)this < Operand__);
  return Operand_Encode[this];
}

#line 301 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
#define METHOD(type, name) type##Encode_##name(decoded)
#define WORDTYPE(type) type
#define ENCODE(e) e
#define Operand(NAME, METHOD, WORDTYPE, ENCODE, DECODE) \
static void \
OperandEncode_##NAME(OperandDecoded decoded, void *restrict opcodes) \
{ \
  OperandEncoded VALUE = METHOD; \
  WORDTYPE *restrict WORDS = opcodes; \
  ENCODE; \
}
#include "Operand.enum"
#undef ENCODE
#undef WORDTYPE
#undef METHOD

#line 317 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
static void
OperandEncode_(OperandDecoded decoded, void *restrict opcodes)
{
}

#line 322 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
const OperandEncode
Operand_Encode[] = {
#define Operand(NAME, METHOD, WORDTYPE, ENCODE, DECODE) \
  OperandEncode_##NAME,
  OperandEncode_,
#include "Operand.enum"
};

#line 330 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 363 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 372 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
extern const OperandDecode
Operand_Decode[];
OperandDecode
Operand_decode(Operand this)
{
  Except_REQUIRE((unsigned)this < Operand__);
  return Operand_Decode[this];
}

#line 389 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
const OperandDecode
Operand_Decode[] = {
#define Operand(NAME, METHOD, WORDTYPE, ENCODE, DECODE) \
  Decode_Operand_##NAME,
  NULL,
#include "Operand.enum"
};

#line 403 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 457 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 512 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 520 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
#ifndef ECL_NTRACE
const char *
Operands_name_(Operands this)
{
  static const char *_[] = {
#define Operands(NAME, OPERANDS, RELOCATABLE, ENCODE, DECODE) \
    #NAME,
    MDS_FAMILY "_",
#include "Operand.enum"
  };
  Except_REQUIRE((unsigned)this < Operands__);
  return _[this];
}
#endif//ECL_NTRACE

#line 543 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 551 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
extern const OperandList_
Operands_OperandList[];
const_OperandList
Operands_operandList(Operands this)
{
  Except_REQUIRE((unsigned)this < Operands__);
  return &Operands_OperandList[this];
}

#line 560 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
const OperandList_
Operands_OperandList[] = {
#define OPERAND(NAME) Operand_##NAME,
#define OPERANDS(count, items) count, { items }
#define Operands(NAME, OPERANDS, RELOCATABLE, ENCODE, DECODE) \
  { OPERANDS },
  { OPERANDS(0, /**/) },
#include "Operand.enum"
#undef OPERAND
};

#line 593 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 601 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
int
Operands_count(Operands this)
{
  Except_REQUIRE((unsigned)this < Operands__);
  return OperandList_count(&Operands_OperandList[this]);
}

#line 614 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
Operand
Operands_access(Operands this, int index)
{
  Except_REQUIRE((unsigned)this < Operands__);
  return OperandList_access(&Operands_OperandList[this], index);
}

#line 621 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 637 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
OperandsBuffer
OperandsBuffer_Ctor(OperandsBuffer this) {
  int i;
#if (Operands_IMMEDIATE_COUNT_MAX > 0)
  for (i = 0; i < Operands_IMMEDIATE_COUNT_MAX; i++) {
    ImmediateConstant_Ctor(&OperandsBuffer_CONSTANTS(this)[i], 0);
  }
#endif//Operands_IMMEDIATE_COUNT_MAX
#if (Operands_REGMASK_COUNT_MAX > 0)
  for (i = 0; i < Operands_REGMASK_COUNT_MAX; i++) {
    RegisterSet_Ctor(&OperandsBuffer_REGISTERSETS(this)[i]);
  }
#endif//Operands_REGMASK_COUNT_MAX
  return this;
}

#line 666 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
extern const OperandsEncode
Operands_Encode[];
OperandsEncode
Operands_encode(Operands this)
{
  Except_REQUIRE((unsigned)this < Operands__);
  return Operands_Encode[this];
}

#line 685 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
#define ENCODE(e) e
#define Operands(NAME, OPERANDS, RELOCATABLE, ENCODE, DECODE) \
void \
OperandsEncode_##NAME(const_OperandsBuffer buffer, void *restrict opcodes) \
{ \
  const OperandDecoded *decoded = OperandsBuffer_DECODED(buffer); \
  ENCODE; \
}
#include "Operand.enum"
#undef ENCODE
void
OperandsEncode_(const_OperandsBuffer buffer, void *restrict opcodes)
{
}

#line 700 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
const OperandsEncode
Operands_Encode[] = {
#define Operands(NAME, OPERANDS, RELOCATABLE, ENCODE, DECODE) \
  OperandsEncode_##NAME,
  OperandsEncode_,
#include "Operand.enum"
};

#line 708 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 716 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
extern int8_t
Operands_RelocatableRank[];
int
Operands_relocatableRank(Operands this)
{
  Except_REQUIRE((unsigned)this < Operands__);
  return Operands_RelocatableRank[this];
}

#line 725 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
int8_t
Operands_RelocatableRank[] = {
#define RANK(d) d
#define RELOCATABLE(rank, operand, immediate) rank
#define Operands(NAME, OPERANDS, RELOCATABLE, ENCODE, DECODE) \
  RELOCATABLE,
  RELOCATABLE(RANK(0), OPERAND(_UNDEF), IMMEDIATE(_UNDEF)),
#include "Operand.enum"
#undef RELOCATABLE
#undef RANK
};

#line 748 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 756 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
extern const Operand
Operands_RelocatableOperand[];
Operand
Operands_relocatableOperand(Operands this)
{
  Except_REQUIRE((unsigned)this < Operands__);
  return (Operand)Operands_RelocatableOperand[this];
}

#line 765 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
const Operand
Operands_RelocatableOperand[] = {
#define OPERAND(name) Operand_##name
#define RELOCATABLE(rank, operand, immediate) operand
#define Operands(NAME, OPERANDS, RELOCATABLE, ENCODE, DECODE) \
  RELOCATABLE,
  RELOCATABLE(RANK(0), OPERAND(_UNDEF), IMMEDIATE(_UNDEF)),
#include "Operand.enum"
#undef RELOCATABLE
#undef OPERAND
};

#line 787 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 795 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
extern const Immediate
Operands_RelocatableImmediate[];
Immediate
Operands_relocatableImmediate(Operands this)
{
  Except_REQUIRE((unsigned)this < Operands__);
  return (Immediate)Operands_RelocatableImmediate[this];
}

#line 804 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
const Immediate
Operands_RelocatableImmediate[] = {
#define IMMEDIATE(name) Immediate_##name
#define RELOCATABLE(rank, operand, immediate) immediate
#define Operands(NAME, OPERANDS, RELOCATABLE, ENCODE, DECODE) \
  RELOCATABLE,
  RELOCATABLE(RANK(0), OPERAND(_UNDEF), IMMEDIATE(_UNDEF)),
#include "Operand.enum"
#undef RELOCATABLE
#undef IMMEDIATE
};

#line 826 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 842 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
#ifndef NDECODE
extern OperandsDecode
Operands_Decode[];
OperandsDecode
Operands_decode(Operands this)
{
  Except_REQUIRE((unsigned)this < Operands__);
  return Operands_Decode[this];
}
#endif//NDECODE

#line 870 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
#ifndef NDECODE
OperandsDecode
Operands_Decode[] = {
#define Operands(NAME, OPERANDS, RELOCATABLE, ENCODE, DECODE) \
  Decode_Operands_##NAME,
  Decode_Operands_,
#include "Operand.enum"
};
#endif//NDECODE

#line 880 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 892 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
#if XCC__C
static void
Operand_TEST(void)
{
#include "MDS/Operand_.c"
}

#line 899 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Operand.xcc"
int
main(int argc, char **argv)
{
  MDS_Test(Operand_TEST);
  return 0;
}
#endif


#endif//Operand_c_INCLUDED
