#ifndef Processor__c_INCLUDED
#define Processor__c_INCLUDED

#line 56 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Processor.xcc"
//
{
  int processor = 0;
  for (; processor < Processor__; processor++) {
    printf("Processor_%s\t%d\n", Processor_name_(processor), processor);
  }
}

#line 173 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Processor.xcc"
//
{
  int processor, resource;
  printf("Resource\t");
  for (resource = 0; resource < Resource__; resource++) {
    printf("\t%s", Resource_name_(resource));
  }
  printf("\n");
  for (processor = 0; processor < Processor__; processor++) {
    printf("Availability(%s)", Processor_name_(processor));
    for (resource = 0; resource < Resource__; resource++) {
      int available = ResourceVector_UNITS(Processor_Availability + processor)[resource];
      printf("\t\t%d", available);
    }
    printf("\n");
  }
}

#line 263 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Processor.xcc"
//
{
#ifndef ECL_NTRACE
  FILE *dtd = fopen("Processor.dtd", "w");
  FILE *xml = fopen("Processor.xml", "w");
  dtd && Processor_DTD(dtd);
  xml && Processor_XML(xml);
  dtd && fclose(dtd);
  xml && fclose(xml);
#endif//ECL_NTRACE
}


#endif//Processor__c_INCLUDED
