#ifndef RegClass_c_INCLUDED
#define RegClass_c_INCLUDED

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/RegClass.xcc"
#include "MDS/MDS_.h"

#line 31 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/RegClass.xcc"
const int RegClass__COUNT = RegClass__;

#line 33 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/RegClass.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 41 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/RegClass.xcc"
#ifndef ECL_NTRACE
const char *
RegClass_name_(RegClass this)
{
  const char *_[] = {
#define RegClass(NAME, REGFILE, REGISTERS, ENCODE, DECODE, MINREADSTAGES) \
    #NAME,
    "_UNDEF",
#include "RegClass.enum"
  };
  Except_REQUIRE((unsigned)this < RegClass__);
  return _[this];
}
#endif//ECL_NTRACE

#line 64 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/RegClass.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 72 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/RegClass.xcc"
extern const RegFile
RegClass_RegFile[];
RegFile
RegClass_regFile(RegClass this)
{
  Except_REQUIRE((unsigned)this < RegClass__);
  return (RegFile)RegClass_RegFile[this];
}

#line 81 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/RegClass.xcc"
const RegFile
RegClass_RegFile[] = {
#define REGFILE(NAME) RegFile_##NAME
#define RegClass(NAME, REGFILE, REGISTERS, ENCODE, DECODE, MINREADSTAGES) \
  REGFILE,
  REGFILE(_UNDEF),
#include "RegClass.enum"
};

#line 100 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/RegClass.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 110 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/RegClass.xcc"
extern const RegisterList_
RegClass_RegisterList[];
const_RegisterList
RegClass_registerList(RegClass this)
{
  Except_REQUIRE((unsigned)this < RegClass__);
  return &RegClass_RegisterList[this];
}

#line 119 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/RegClass.xcc"
const RegisterList_
RegClass_RegisterList[] = {
#define REGISTER(NAME) Register_##NAME,
#define REGISTERS(count, items) count, { items }
#define RegClass(NAME, REGFILE, REGISTERS, ENCODE, DECODE, MINREADSTAGES) \
  { REGISTERS },
  { REGISTERS(0, /**/) },
#include "RegClass.enum"
};

#line 142 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/RegClass.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 159 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/RegClass.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 167 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/RegClass.xcc"
extern RegisterSet_
RegClass_RegisterSet[];
const_RegisterSet
RegClass_registerSet(RegClass this)
{
  Except_REQUIRE((unsigned)this < RegClass__);
  return &RegClass_RegisterSet[this];
}

#line 176 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/RegClass.xcc"
RegisterSet_
RegClass_RegisterSet[RegClass__];

#line 192 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/RegClass.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 200 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/RegClass.xcc"
extern const uint8_t
RegClass_MinReadStages[][Processor__];
int
RegClass_minReadStage(RegClass this, Processor processor)
{
  Except_REQUIRE((unsigned)this < RegClass__);
  Except_REQUIRE((unsigned)processor < Processor__);
  return RegClass_MinReadStages[this][processor];
}

#line 210 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/RegClass.xcc"
const uint8_t
RegClass_MinReadStages[][Processor__] = {
#define MINREADSTAGE(processor, stage) (uint8_t)(stage),
#define MINREADSTAGES(items) { 0/*Processor_*/, items }
#define RegClass(NAME, REGFILE, REGISTERS, ENCODE, DECODE, MINREADSTAGES) \
  MINREADSTAGES,
  MINREADSTAGES(/**/),
#include "RegClass.enum"
#undef MINREADSTAGES
};

#line 240 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/RegClass.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 248 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/RegClass.xcc"
void
RegClass_INIT(void)
{
  int regClass = 0;
  RegisterSet registerSet = NULL;
  for (; regClass < RegClass__; regClass++) {
    registerSet = RegisterSet_Ctor(&RegClass_RegisterSet[regClass]);
    RegisterList_FOREACH_Register(RegClass_registerList(regClass), registre) {
      RegisterSet_insert(&RegClass_RegisterSet[regClass], registre);
    } RegisterList_ENDEACH_Register;
  }
}

#line 266 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/RegClass.xcc"
#if XCC__C
static void
RegClass_TEST(void)
{
#include "MDS/RegClass_.c"
}

#line 273 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/RegClass.xcc"
int
main(int argc, char **argv)
{
  MDS_Test(RegClass_TEST);
  return 0;
}
#endif


#endif//RegClass_c_INCLUDED
