#ifndef Register__c_INCLUDED
#define Register__c_INCLUDED

#line 64 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
//
{
  int registre = 0;
  for (; registre < Register__; registre++) {
    printf("Register_%s\t%d\n", Register_name_(registre), registre);
  }
}

#line 125 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
//
{
  int registre = 0;
  for (; registre < Register__; registre++) {
    printf("Register_regFile(%s)\t%s\n", Register_name_(registre), RegFile_name_(Register_regFile(registre)));
  }
  printf("sizeof(Register_RegFile)\t%d\n", sizeof(Register_RegFile));
}

#line 160 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
//
{
  int registre = 0;
  for (; registre < Register__; registre++) {
    if (Register_isWired(registre)) {
      printf("Register_isWired(%s)\n", Register_name_(registre));
    }
  }
  printf("sizeof(Register_Wired)\t%d\n", sizeof(Register_Wired));
}

#line 249 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
//
{
  int registre = 0;
  for (; registre < Register__; registre++) {
    const_RegisterStorageCells storageCells = Register_storageCells(registre);
    printf("Register_storageCells(%s)", Register_name_(registre));
    RegisterStorageCells_FOREACH_StorageCell(storageCells, cell) {
      printf("\t%s", StorageCell_name_(cell));
    } RegisterStorageCells_ENDEACH_StorageCell;
    printf("\n");
  }
  printf("sizeof(Register_StorageCells)\t%d\n", sizeof(Register_StorageCells));
}

#line 292 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
//
{
  int registre;
  int processor;
  printf("\t\t\t");
  for (processor = 0; processor < Processor__; processor++) {
    printf("\t%s", Processor_name_(processor));
  }
  printf("\n");
  for (registre = 0; registre < Register__; registre++) {
    printf("MinReadStages(%s)", Register_name_(registre));
    for (processor = 0; processor < Processor__; processor++) {
      int stage = Register_minReadStage(registre, processor);
      printf("\t\t%d", stage);
    }
    printf("\n");
  }
}

#line 322 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
//
{
  printf("sizeof(RegisterList_)\t%d\n", sizeof(RegisterList_));
}

#line 419 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
//
{
  printf("RegisterSet_WORDCOUNT\t%d\n", (RegisterSet_WORDCOUNT));
}

#line 457 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
//
{
  printf("sizeof(RegisterSet_)\t%d\n", sizeof(RegisterSet_));
}

#line 898 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
//
{
  int registre;
  RegisterSet_ registerSet[1];
  RegisterSet_Ctor(registerSet);
  for (registre = 0; registre < Register__; registre++) {
    RegisterSet_insert(registerSet, registre);
  }
  while (!RegisterSet_isEmpty(registerSet)) {
    registre = RegisterSet_choose(registerSet);
    printf("choose: %s\n", Register_name_(registre));
  }
}

#line 925 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
//
{
  printf("sizeof(RegisterAction_)\t%d\n", sizeof(RegisterAction_));
}

#line 1153 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Register.xcc"
//
{
#ifndef ECL_NTRACE
  FILE *dtd = fopen("Register.dtd", "w");
  FILE *xml = fopen("Register.xml", "w");
  dtd && Register_DTD(dtd);
  xml && Register_XML(xml);
  dtd && fclose(dtd);
  xml && fclose(xml);
#endif//ECL_NTRACE
}


#endif//Register__c_INCLUDED
