#ifndef Reservation__c_INCLUDED
#define Reservation__c_INCLUDED

#line 91 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Reservation.xcc"
//
{
  int reservation = 0;
  for (; reservation < Reservation__; reservation++) {
    printf("Reservation_%s\t%d\n", Reservation_name_(reservation), reservation);
  }
}

#line 157 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Reservation.xcc"
//
{
  int resource, reservation;
  printf("\nRequirements\t");
  for (resource = 0; resource < Resource__; resource++) {
    printf("\t%s", Resource_name_(resource));
  }
  printf("\n");
  for (reservation = 0; reservation < Reservation__; reservation++) {
    const_ResourceVector requirements = Reservation_requirements(reservation);
    printf("Reservation(%s)", Reservation_name_(reservation));
    for (resource = 0; resource < Resource__; resource++) {
      printf("\t\t%d", ResourceVector_UNITS(requirements)[resource]);
    }
    printf("\n");
  }
}

#line 204 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Reservation.xcc"
//
{
  int processor, this, that;
  for (processor = 0; processor < Processor__; processor++) {
    printf("\nProcessor_%s:\n", Processor_name_(processor));
    for (that = 0; that < Reservation__; that++) {
      printf("\t%s", Reservation_name_(that));
    }
    for (this = 0; this < Reservation__; this++) {
      printf("\n%s", Reservation_name_(this));
      for (that = 0; that < Reservation__; that++) {
        printf("\t%2d", Reservation_odot(this, that, processor));
      }
    }
    printf("\n");
  }
}

#line 287 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Reservation.xcc"
//
{
#ifndef ECL_NTRACE
  FILE *dtd = fopen("Reservation.dtd", "w");
  FILE *xml = fopen("Reservation.xml", "w");
  dtd && Reservation_DTD(dtd);
  xml && Reservation_XML(xml);
  dtd && fclose(dtd);
  xml && fclose(xml);
#endif//ECL_NTRACE
}


#endif//Reservation__c_INCLUDED
