#ifndef Scheduling_c_INCLUDED
#define Scheduling_c_INCLUDED

#line 16 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Scheduling.xcc"
#include "MDS/MDS_.h"

#line 31 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Scheduling.xcc"
const int Scheduling__COUNT = Scheduling__;

#line 33 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Scheduling.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 43 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Scheduling.xcc"
#ifndef ECL_NTRACE
const char *
Scheduling_name_(Scheduling this)
{
  static const char *_[] = {
#define Scheduling(NAME, PROCESSOR, BUNDLING, RESERVATION) \
    #NAME,
    "_UNDEF",
#include "Scheduling.enum"
  };
  Except_REQUIRE((unsigned)this < Scheduling__);
  return _[this];
}
const char *
Scheduling_name(Scheduling this)
{
  return this? Scheduling_name_(this) + sizeof(MDS_FAMILY): "_UNDEF";
}
#endif//ECL_NTRACE

#line 71 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Scheduling.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 79 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Scheduling.xcc"
extern const Processor
Scheduling_Processor[];
Processor
Scheduling_processor(Scheduling this)
{
  Except_REQUIRE((unsigned)this < Scheduling__);
  return (Processor)Scheduling_Processor[this];
}

#line 88 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Scheduling.xcc"
const Processor
Scheduling_Processor[] = {
#define PROCESSOR(NAME) Processor_##NAME
#define Scheduling(NAME, PROCESSOR, BUNDLING, RESERVATION) \
  PROCESSOR,
  PROCESSOR(_UNDEF),
#include "Scheduling.enum"
};

#line 107 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Scheduling.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 115 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Scheduling.xcc"
extern const Bundling
Scheduling_Bundling[];
Bundling
Scheduling_bundling(Scheduling this)
{
  Except_REQUIRE((unsigned)this < Scheduling__);
  return (Bundling)Scheduling_Bundling[this];
}

#line 124 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Scheduling.xcc"
const Bundling
Scheduling_Bundling[] = {
#define BUNDLING(NAME) Bundling_##NAME
#define Scheduling(NAME, PROCESSOR, BUNDLING, RESERVATION) \
  BUNDLING,
  BUNDLING(_UNDEF),
#include "Scheduling.enum"
};

#line 143 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Scheduling.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 151 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Scheduling.xcc"
extern const Reservation
Scheduling_Reservation[];
Reservation
Scheduling_reservation(Scheduling this)
{
  Except_REQUIRE((unsigned)this < Scheduling__);
  return (Reservation)Scheduling_Reservation[this];
}

#line 160 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Scheduling.xcc"
const Reservation
Scheduling_Reservation[] = {
#define RESERVATION(NAME) Reservation_##NAME
#define Scheduling(NAME, PROCESSOR, BUNDLING, RESERVATION) \
  RESERVATION,
  RESERVATION(_UNDEF),
#include "Scheduling.enum"
};

#line 180 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Scheduling.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 186 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Scheduling.xcc"
#ifndef ECL_NTRACE
bool
Scheduling_DTD(FILE *file)
{
  fputs(
        "<!ELEMENT Scheduling EMPTY >"
        "<!ATTLIST Scheduling"
        "  ID ID #REQUIRED"
        ">"
       , file);
  return true;
}
#endif//ECL_NTRACE

#line 204 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Scheduling.xcc"
#ifndef ECL_NTRACE
bool
Scheduling_XML(FILE *file)
{
  int scheduling;
  for (scheduling = 0; scheduling < Scheduling__; scheduling++) {
    fprintf(file, "<Scheduling ID=\"Scheduling_%s\" />\n", Scheduling_name_(scheduling));
  }
  return true;
}
#endif//ECL_NTRACE

#line 228 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Scheduling.xcc"
//////////////////////////////////////////////////////////////////////////////////////////

#line 240 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Scheduling.xcc"
#if XCC__C
static void
Scheduling_TEST(void)
{
#include "MDS/Scheduling_.c"
}

#line 247 "/shares/group/ce-rvex/tools/LAO/LAO-rvex/ECL/MDS/Scheduling.xcc"
int
main(int argc, char **argv)
{
  MDS_Test(Scheduling_TEST);
  return 0;
}
#endif


#endif//Scheduling_c_INCLUDED
