	.file	"Pipeline.c"
	.text
	.p2align 4,,15
.globl PipelineEffect_Ctor
	.type	PipelineEffect_Ctor, @function
PipelineEffect_Ctor:
	pushl	%ebp
	movl	%esp, %ebp
	movl	8(%ebp), %eax
	movl	20(%ebp), %ecx
	movl	12(%ebp), %edx
	movb	%cl, (%eax)
	movzwl	(%edx), %ecx
	movl	%edx, 4(%eax)
	movl	16(%ebp), %edx
	movl	$0, 12(%eax)
	movl	$0, 16(%eax)
	movw	%cx, 2(%eax)
	movl	%edx, 8(%eax)
	movl	$0, 20(%eax)
	popl	%ebp
	ret
	.size	PipelineEffect_Ctor, .-PipelineEffect_Ctor
	.p2align 4,,15
.globl PipelineEffect_Size
	.type	PipelineEffect_Size, @function
PipelineEffect_Size:
	pushl	%ebp
	movl	$24, %eax
	movl	%esp, %ebp
	popl	%ebp
	ret
	.size	PipelineEffect_Size, .-PipelineEffect_Size
	.p2align 4,,15
.globl PipelineEffect_latencyRAW
	.type	PipelineEffect_latencyRAW, @function
PipelineEffect_latencyRAW:
	pushl	%ebp
	movl	%esp, %ebp
	subl	$56, %esp
	movl	8(%ebp), %ecx
	movl	%ebx, -12(%ebp)
	movl	12(%ebp), %edx
	movl	%esi, -8(%ebp)
	movl	%edi, -4(%ebp)
	movl	8(%ecx), %eax
	call	__i686.get_pc_thunk.bx
	addl	$_GLOBAL_OFFSET_TABLE_, %ebx
	movzwl	2(%ecx), %edi
	movl	(%eax), %esi
	movl	%esi, -28(%ebp)
	movsbl	4(%eax), %esi
	movsbl	5(%eax), %eax
	addl	%eax, %esi
	movl	8(%edx), %eax
	movzwl	2(%edx), %edx
	movsbl	4(%eax), %eax
	movl	%edx, 4(%esp)
	movl	%edx, -32(%ebp)
	movl	%edi, (%esp)
	subl	%eax, %esi
	call	Instance_fixupRAW@PLT
	movl	-32(%ebp), %edx
	testl	%eax, %eax
	je	.L4
	movzbl	-28(%ebp), %eax
	movl	%edx, 4(%esp)
	movl	%edi, (%esp)
	movl	%eax, 8(%esp)
	call	Instance_latencyRAW@PLT
	addl	%eax, %esi
.L4:
	movl	%esi, %eax
	movl	-12(%ebp), %ebx
	movl	-8(%ebp), %esi
	movl	-4(%ebp), %edi
	movl	%ebp, %esp
	popl	%ebp
	ret
	.size	PipelineEffect_latencyRAW, .-PipelineEffect_latencyRAW
	.p2align 4,,15
.globl PipelineEffect_latencyWAR
	.type	PipelineEffect_latencyWAR, @function
PipelineEffect_latencyWAR:
	pushl	%ebp
	movl	%esp, %ebp
	movl	8(%ebp), %eax
	popl	%ebp
	movl	8(%eax), %eax
	movsbl	6(%eax), %eax
	ret
	.size	PipelineEffect_latencyWAR, .-PipelineEffect_latencyWAR
	.p2align 4,,15
.globl PipelineEffect_latencyWAW
	.type	PipelineEffect_latencyWAW, @function
PipelineEffect_latencyWAW:
	pushl	%ebp
	movl	%esp, %ebp
	movl	8(%ebp), %eax
	movl	12(%ebp), %ecx
	movl	8(%eax), %edx
	movl	8(%ecx), %ecx
	movsbl	4(%edx), %eax
	movsbl	4(%ecx), %ecx
	movsbl	7(%edx), %edx
	subl	%ecx, %eax
	cmpl	%edx, %eax
	jge	.L8
	movl	%edx, %eax
.L8:
	popl	%ebp
	ret
	.size	PipelineEffect_latencyWAW, .-PipelineEffect_latencyWAW
	.p2align 4,,15
.globl PipelineEffectList_Ctor
	.type	PipelineEffectList_Ctor, @function
PipelineEffectList_Ctor:
	pushl	%ebp
	movl	%esp, %ebp
	movl	8(%ebp), %eax
	movl	$0, (%eax)
	movl	$0, 4(%eax)
	popl	%ebp
	ret
	.size	PipelineEffectList_Ctor, .-PipelineEffectList_Ctor
	.p2align 4,,15
.globl PipelineEffectList_isEmpty
	.type	PipelineEffectList_isEmpty, @function
PipelineEffectList_isEmpty:
	pushl	%ebp
	movl	%esp, %ebp
	movl	8(%ebp), %eax
	popl	%ebp
	movl	(%eax), %eax
	testl	%eax, %eax
	sete	%al
	ret
	.size	PipelineEffectList_isEmpty, .-PipelineEffectList_isEmpty
	.p2align 4,,15
.globl PipelineEffectList_first
	.type	PipelineEffectList_first, @function
PipelineEffectList_first:
	pushl	%ebp
	movl	%esp, %ebp
	movl	8(%ebp), %eax
	popl	%ebp
	movl	(%eax), %eax
	ret
	.size	PipelineEffectList_first, .-PipelineEffectList_first
	.p2align 4,,15
.globl PipelineEffectList_push_
	.type	PipelineEffectList_push_, @function
PipelineEffectList_push_:
	pushl	%ebp
	movl	%esp, %ebp
	movl	8(%ebp), %edx
	movl	12(%ebp), %eax
	cmpl	$0, (%edx)
	movl	4(%edx), %ecx
	je	.L15
.L13:
	testl	%ecx, %ecx
	je	.L14
	movl	%eax, 12(%ecx)
.L14:
	movl	%eax, 4(%edx)
	popl	%ebp
	ret
	.p2align 4,,7
	.p2align 3
.L15:
	movl	%eax, (%edx)
	jmp	.L13
	.size	PipelineEffectList_push_, .-PipelineEffectList_push_
	.p2align 4,,15
.globl PipelineADL_Dtor
	.type	PipelineADL_Dtor, @function
PipelineADL_Dtor:
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%ebx
	subl	$20, %esp
	movl	8(%ebp), %eax
	call	__i686.get_pc_thunk.bx
	addl	$_GLOBAL_OFFSET_TABLE_, %ebx
	movl	8(%eax), %edx
	movl	%edx, 4(%esp)
	movl	(%eax), %eax
	movl	%eax, (%esp)
	call	Memory_free_@PLT
	addl	$20, %esp
	popl	%ebx
	popl	%ebp
	ret
	.size	PipelineADL_Dtor, .-PipelineADL_Dtor
	.p2align 4,,15
.globl PipelineADL_lists
	.type	PipelineADL_lists, @function
PipelineADL_lists:
	pushl	%ebp
	movl	%esp, %ebp
	movl	8(%ebp), %eax
	popl	%ebp
	movl	8(%eax), %eax
	ret
	.size	PipelineADL_lists, .-PipelineADL_lists
	.p2align 4,,15
.globl PipelineADL_linkEffects
	.type	PipelineADL_linkEffects, @function
PipelineADL_linkEffects:
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%edi
	pushl	%esi
	pushl	%ebx
	call	__i686.get_pc_thunk.bx
	addl	$_GLOBAL_OFFSET_TABLE_, %ebx
	subl	$44, %esp
	movl	8(%ebp), %eax
	movl	%eax, (%esp)
	call	PipelineADL_lists@PLT
	movl	StorageCell__COUNT@GOT(%ebx), %edx
	movl	(%edx), %edx
	testl	%edx, %edx
	movl	%edx, -28(%ebp)
	jle	.L18
	movl	%eax, %edi
	xorl	%esi, %esi
	.p2align 4,,7
	.p2align 3
.L24:
	movl	%edi, (%esp)
	call	PipelineEffectList_first@PLT
	testl	%eax, %eax
	je	.L20
	xorl	%edx, %edx
	.p2align 4,,7
	.p2align 3
.L23:
	testb	$1, (%eax)
	movl	12(%eax), %ecx
	movl	%edx, 16(%eax)
	je	.L21
	testl	%edx, %edx
	je	.L25
	.p2align 4,,7
	.p2align 3
.L22:
	movl	%eax, 20(%edx)
	movl	12(%edx), %edx
	cmpl	%eax, %edx
	jne	.L22
.L21:
	testl	%ecx, %ecx
	je	.L29
	movl	%ecx, %eax
	jmp	.L23
	.p2align 4,,7
	.p2align 3
.L29:
	movl	StorageCell__COUNT@GOT(%ebx), %eax
	movl	(%eax), %eax
	movl	%eax, -28(%ebp)
.L20:
	addl	$1, %esi
	addl	$8, %edi
	cmpl	-28(%ebp), %esi
	jl	.L24
.L18:
	addl	$44, %esp
	popl	%ebx
	popl	%esi
	popl	%edi
	popl	%ebp
	ret
	.p2align 4,,7
	.p2align 3
.L25:
	movl	%eax, %edx
	jmp	.L21
	.size	PipelineADL_linkEffects, .-PipelineADL_linkEffects
	.p2align 4,,15
.globl PipelineADL_Ctor
	.type	PipelineADL_Ctor, @function
PipelineADL_Ctor:
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%edi
	pushl	%esi
	pushl	%ebx
	call	__i686.get_pc_thunk.bx
	addl	$_GLOBAL_OFFSET_TABLE_, %ebx
	subl	$76, %esp
	movl	$0, -36(%ebp)
	movl	StorageCell__COUNT@GOT(%ebx), %eax
	movl	(%eax), %eax
	movl	%eax, -32(%ebp)
	sall	$3, %eax
	testl	%eax, %eax
	je	.L31
	movl	%eax, 4(%esp)
	movl	12(%ebp), %eax
	movl	%eax, (%esp)
	call	Memory_alloc_@PLT
	movl	%eax, -36(%ebp)
.L31:
	movl	-32(%ebp), %edx
	testl	%edx, %edx
	jle	.L32
	movl	-36(%ebp), %edi
	xorl	%esi, %esi
	.p2align 4,,7
	.p2align 3
.L33:
	movl	%edi, (%esp)
	addl	$1, %esi
	addl	$8, %edi
	call	PipelineEffectList_Ctor@PLT
	cmpl	%esi, -32(%ebp)
	jg	.L33
.L32:
	movl	8(%ebp), %edx
	movl	12(%ebp), %ecx
	movl	16(%ebp), %eax
	movl	%ecx, (%edx)
	movl	-36(%ebp), %ecx
	movl	%eax, 4(%edx)
	movl	%ecx, 8(%edx)
	movl	%eax, %edx
	movl	8(%eax), %eax
	movl	12(%edx), %ecx
	cmpl	%ecx, %eax
	movl	%ecx, -60(%ebp)
	jae	.L34
	movl	%eax, -52(%ebp)
	.p2align 4,,7
	.p2align 3
.L40:
	movl	-52(%ebp), %eax
	movl	(%eax), %eax
	movl	$0, -48(%ebp)
	movswl	24(%eax), %ecx
	movl	52(%eax), %edx
	movl	%eax, -32(%ebp)
	movswl	26(%eax), %eax
	movl	%ecx, -40(%ebp)
	movl	%edx, -56(%ebp)
	addl	%ecx, %eax
	movl	%eax, -44(%ebp)
	leal	(%eax,%eax,2), %eax
	sall	$3, %eax
	testl	%eax, %eax
	je	.L35
	movl	%eax, 4(%esp)
	movl	12(%ebp), %eax
	movl	%eax, (%esp)
	call	Memory_alloc_@PLT
	movl	%eax, -48(%ebp)
.L35:
	movl	-44(%ebp), %edx
	cmpl	%edx, -40(%ebp)
	jge	.L36
	movl	-40(%ebp), %ecx
	movl	-56(%ebp), %eax
	movl	-40(%ebp), %edx
	leal	(%eax,%ecx,8), %esi
	leal	(%ecx,%ecx,2), %eax
	movl	-48(%ebp), %ecx
	addl	$1, %edx
	leal	(%ecx,%eax,8), %edi
	movl	%edi, %eax
	movl	%edx, %edi
	movl	%eax, %edx
	.p2align 4,,7
	.p2align 3
.L37:
	movzbl	(%esi), %eax
	addl	$1, %edi
	movl	-32(%ebp), %ecx
	movl	%edx, (%esp)
	movl	%edx, -64(%ebp)
	movl	%esi, 8(%esp)
	addl	$8, %esi
	movl	%ecx, 4(%esp)
	movb	%al, -25(%ebp)
	movl	$0, 12(%esp)
	call	PipelineEffect_Ctor@PLT
	movl	-36(%ebp), %ecx
	movl	%eax, 4(%esp)
	movzbl	-25(%ebp), %eax
	leal	(%ecx,%eax,8), %eax
	movl	%eax, (%esp)
	call	PipelineEffectList_push_@PLT
	movl	-64(%ebp), %edx
	leal	-1(%edi), %eax
	addl	$24, %edx
	cmpl	%eax, -44(%ebp)
	jg	.L37
.L36:
	movl	-40(%ebp), %eax
	testl	%eax, %eax
	jle	.L38
	movl	-56(%ebp), %esi
	xorl	%edi, %edi
	movl	-48(%ebp), %edx
	.p2align 4,,7
	.p2align 3
.L39:
	movzbl	(%esi), %eax
	addl	$1, %edi
	movl	-32(%ebp), %ecx
	movl	%edx, (%esp)
	movl	%edx, -64(%ebp)
	movl	%esi, 8(%esp)
	addl	$8, %esi
	movl	%ecx, 4(%esp)
	movb	%al, -25(%ebp)
	movl	$1, 12(%esp)
	call	PipelineEffect_Ctor@PLT
	movl	-36(%ebp), %ecx
	movl	%eax, 4(%esp)
	movzbl	-25(%ebp), %eax
	leal	(%ecx,%eax,8), %eax
	movl	%eax, (%esp)
	call	PipelineEffectList_push_@PLT
	movl	-64(%ebp), %edx
	addl	$24, %edx
	cmpl	%edi, -40(%ebp)
	jg	.L39
.L38:
	movl	-48(%ebp), %edx
	movl	-32(%ebp), %eax
	addl	$4, -52(%ebp)
	movl	-60(%ebp), %ecx
	cmpl	%ecx, -52(%ebp)
	movl	%edx, 28(%eax)
	jb	.L40
.L34:
	movl	8(%ebp), %eax
	movl	%eax, (%esp)
	call	PipelineADL_linkEffects@PLT
	movl	8(%ebp), %eax
	addl	$76, %esp
	popl	%ebx
	popl	%esi
	popl	%edi
	popl	%ebp
	ret
	.size	PipelineADL_Ctor, .-PipelineADL_Ctor
	.section	.rodata.str1.1,"aMS",@progbits,1
.LC0:
	.string	"*** PipelineADL:\n"
.LC1:
	.string	"    %s:\n"
.LC2:
	.string	"\tWrite\t"
.LC3:
	.string	"\tRead\t"
.LC4:
	.string	"\tWAW(%d)"
.LC5:
	.string	"\tRAW(%d)"
.LC6:
	.string	"\tWAR(%d)"
	.text
	.p2align 4,,15
.globl PipelineADL_pretty
	.type	PipelineADL_pretty, @function
PipelineADL_pretty:
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%edi
	pushl	%esi
	pushl	%ebx
	subl	$76, %esp
	movl	12(%ebp), %eax
	call	__i686.get_pc_thunk.bx
	addl	$_GLOBAL_OFFSET_TABLE_, %ebx
	testl	%eax, %eax
	je	.L68
.L48:
	movl	12(%ebp), %eax
	movl	$17, 8(%esp)
	movl	$1, 4(%esp)
	movl	%eax, 12(%esp)
	leal	.LC0@GOTOFF(%ebx), %eax
	movl	%eax, (%esp)
	call	fwrite@PLT
	movl	8(%ebp), %eax
	movl	%eax, (%esp)
	call	PipelineADL_lists@PLT
	movl	StorageCell__COUNT@GOT(%ebx), %edx
	movl	(%edx), %edi
	testl	%edi, %edi
	jle	.L49
	leal	.LC2@GOTOFF(%ebx), %edx
	movl	%eax, -56(%ebp)
	leal	.LC1@GOTOFF(%ebx), %eax
	movl	%eax, -68(%ebp)
	leal	.LC3@GOTOFF(%ebx), %eax
	movl	%edx, -60(%ebp)
	leal	.LC5@GOTOFF(%ebx), %edx
	movl	$0, -52(%ebp)
	movl	%eax, -64(%ebp)
	movl	%edx, -40(%ebp)
	jmp	.L63
	.p2align 4,,7
	.p2align 3
.L50:
	movl	StorageCell__COUNT@GOT(%ebx), %eax
	addl	$1, -52(%ebp)
	movl	-52(%ebp), %edx
	addl	$8, -56(%ebp)
	cmpl	%edx, (%eax)
	jle	.L49
.L63:
	movl	-56(%ebp), %eax
	movl	%eax, (%esp)
	call	PipelineEffectList_isEmpty@PLT
	testb	%al, %al
	jne	.L50
	movzbl	-52(%ebp), %eax
	movl	%eax, (%esp)
	call	StorageCell_name@PLT
	movl	-68(%ebp), %edx
	movl	%edx, 4(%esp)
	movl	%eax, 8(%esp)
	movl	12(%ebp), %eax
	movl	%eax, (%esp)
	call	fprintf@PLT
	movl	-56(%ebp), %edx
	movl	%edx, (%esp)
	call	PipelineEffectList_first@PLT
	testl	%eax, %eax
	movl	%eax, %edi
	je	.L50
	leal	.LC4@GOTOFF(%ebx), %eax
	movl	%eax, -32(%ebp)
.L67:
	movl	12(%edi), %edx
	movl	20(%edi), %eax
	testb	$1, (%edi)
	movl	4(%edi), %esi
	movl	%edx, -36(%ebp)
	movl	%eax, -28(%ebp)
	je	.L51
	movl	12(%ebp), %edx
	movl	-60(%ebp), %eax
	movl	$7, 8(%esp)
	movl	$1, 4(%esp)
	movl	%edx, 12(%esp)
	movl	%eax, (%esp)
	call	fwrite@PLT
.L52:
	movl	12(%ebp), %edx
	movl	$0, 8(%esp)
	movl	%esi, (%esp)
	movl	%edx, 4(%esp)
	call	Instruction_pretty@PLT
	testb	$1, (%edi)
	jne	.L53
	movl	-36(%ebp), %esi
	testl	%esi, %esi
	je	.L55
	leal	.LC6@GOTOFF(%ebx), %eax
	movl	-36(%ebp), %esi
	movl	%edi, -48(%ebp)
	movl	-28(%ebp), %edi
	movl	%eax, -44(%ebp)
	jmp	.L61
	.p2align 4,,7
	.p2align 3
.L60:
	cmpl	%edi, %esi
	je	.L58
.L69:
	movl	12(%esi), %esi
	testl	%esi, %esi
	je	.L58
.L61:
	testb	$1, (%esi)
	je	.L60
	movl	-48(%ebp), %edx
	movl	%esi, 4(%esp)
	movl	%edx, (%esp)
	call	PipelineEffect_latencyWAR@PLT
	movl	12(%ebp), %edx
	movl	%edx, (%esp)
	movl	%eax, 8(%esp)
	movl	-44(%ebp), %eax
	movl	%eax, 4(%esp)
	call	fprintf@PLT
	cmpl	%edi, %esi
	jne	.L69
	.p2align 4,,7
	.p2align 3
.L58:
	movl	12(%ebp), %eax
	movl	$10, (%esp)
	movl	%eax, 4(%esp)
	call	fputc@PLT
	movl	-36(%ebp), %edi
	jmp	.L67
	.p2align 4,,7
	.p2align 3
.L53:
	movl	-36(%ebp), %ecx
	testl	%ecx, %ecx
	je	.L55
	movl	-36(%ebp), %esi
	jmp	.L59
	.p2align 4,,7
	.p2align 3
.L70:
	movl	%esi, 4(%esp)
	movl	%edi, (%esp)
	call	PipelineEffect_latencyWAW@PLT
	movl	12(%ebp), %edx
	movl	%edx, (%esp)
	movl	%eax, 8(%esp)
	movl	-32(%ebp), %eax
	movl	%eax, 4(%esp)
	call	fprintf@PLT
.L57:
	cmpl	-28(%ebp), %esi
	je	.L58
	movl	12(%esi), %esi
	testl	%esi, %esi
	je	.L58
.L59:
	testb	$1, (%esi)
	jne	.L70
	movl	%esi, 4(%esp)
	movl	%edi, (%esp)
	call	PipelineEffect_latencyRAW@PLT
	movl	12(%ebp), %edx
	movl	%edx, (%esp)
	movl	%eax, 8(%esp)
	movl	-40(%ebp), %eax
	movl	%eax, 4(%esp)
	call	fprintf@PLT
	jmp	.L57
	.p2align 4,,7
	.p2align 3
.L51:
	movl	12(%ebp), %edx
	movl	-64(%ebp), %eax
	movl	$6, 8(%esp)
	movl	$1, 4(%esp)
	movl	%edx, 12(%esp)
	movl	%eax, (%esp)
	call	fwrite@PLT
	jmp	.L52
.L55:
	movl	12(%ebp), %edx
	movl	$10, (%esp)
	movl	%edx, 4(%esp)
	call	fputc@PLT
	jmp	.L50
.L49:
	addl	$76, %esp
	movl	$1, %eax
	popl	%ebx
	popl	%esi
	popl	%edi
	popl	%ebp
	ret
.L68:
	movl	stderr@GOT(%ebx), %eax
	movl	(%eax), %eax
	movl	%eax, 12(%ebp)
	jmp	.L48
	.size	PipelineADL_pretty, .-PipelineADL_pretty
	.p2align 4,,15
.globl Pipeline_Ctor
	.type	Pipeline_Ctor, @function
Pipeline_Ctor:
	pushl	%ebp
	movl	%esp, %ebp
	subl	$56, %esp
	movl	%ebx, -12(%ebp)
	movl	20(%ebp), %edx
	call	__i686.get_pc_thunk.bx
	addl	$_GLOBAL_OFFSET_TABLE_, %ebx
	movzbl	16(%ebp), %eax
	movl	%edi, -4(%ebp)
	movl	8(%ebp), %edi
	movl	%esi, -8(%ebp)
	movl	%edx, -32(%ebp)
	movl	%eax, -28(%ebp)
	movl	$0, 4(%esp)
	movl	%eax, (%esp)
	call	ResourceTable_Size@PLT
	xorl	%ecx, %ecx
	movl	-32(%ebp), %edx
	testl	%eax, %eax
	je	.L72
	addl	$3, %eax
	andl	$-4, %eax
	movl	%eax, 4(%esp)
	movl	12(%ebp), %eax
	movl	%eax, (%esp)
	call	Memory_alloc_@PLT
	movl	-32(%ebp), %edx
	movl	%eax, %ecx
.L72:
	movl	12(%ebp), %eax
	movl	12(%edx), %esi
	subl	8(%edx), %esi
	movl	%edx, 8(%esp)
	movl	%ecx, -32(%ebp)
	movl	%edi, (%esp)
	sarl	$2, %esi
	movl	%eax, 4(%esp)
	call	PipelineADL_Ctor@PLT
	movl	12(%ebp), %eax
	movl	%esi, 8(%esp)
	movl	%eax, 4(%esp)
	leal	28(%edi), %eax
	movl	%eax, (%esp)
	call	PQueue_Ctor@PLT
	movl	-28(%ebp), %eax
	movl	-32(%ebp), %ecx
	movl	$0, 8(%esp)
	movl	%eax, 4(%esp)
	movl	%ecx, (%esp)
	call	ResourceTable_Ctor@PLT
	movl	%eax, 44(%edi)
	movl	%edi, %eax
	movl	-12(%ebp), %ebx
	movl	-8(%ebp), %esi
	movl	-4(%ebp), %edi
	movl	%ebp, %esp
	popl	%ebp
	ret
	.size	Pipeline_Ctor, .-Pipeline_Ctor
	.p2align 4,,15
.globl Pipeline_Dtor
	.type	Pipeline_Dtor, @function
Pipeline_Dtor:
	pushl	%ebp
	movl	%esp, %ebp
	subl	$40, %esp
	movl	%ebx, -12(%ebp)
	call	__i686.get_pc_thunk.bx
	addl	$_GLOBAL_OFFSET_TABLE_, %ebx
	movl	%esi, -8(%ebp)
	movl	8(%ebp), %esi
	movl	%edi, -4(%ebp)
	movl	(%esi), %edi
	movl	%esi, (%esp)
	call	PipelineADL_Dtor@PLT
	leal	28(%esi), %eax
	movl	%eax, (%esp)
	call	PQueue_Dtor@PLT
	movl	44(%esi), %eax
	movl	%edi, (%esp)
	movl	%eax, 4(%esp)
	call	Memory_free_@PLT
	movl	-12(%ebp), %ebx
	movl	-8(%ebp), %esi
	movl	-4(%ebp), %edi
	movl	%ebp, %esp
	popl	%ebp
	ret
	.size	Pipeline_Dtor, .-Pipeline_Dtor
	.p2align 4,,15
.globl Pipeline_instructions
	.type	Pipeline_instructions, @function
Pipeline_instructions:
	pushl	%ebp
	movl	%esp, %ebp
	movl	8(%ebp), %eax
	popl	%ebp
	movl	4(%eax), %eax
	ret
	.size	Pipeline_instructions, .-Pipeline_instructions
	.p2align 4,,15
.globl Pipeline_makeCritical
	.type	Pipeline_makeCritical, @function
Pipeline_makeCritical:
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%edi
	pushl	%esi
	pushl	%ebx
	call	__i686.get_pc_thunk.bx
	addl	$_GLOBAL_OFFSET_TABLE_, %ebx
	subl	$76, %esp
	movl	8(%ebp), %eax
	movl	%eax, (%esp)
	call	Pipeline_instructions@PLT
	movl	8(%eax), %edx
	movl	12(%eax), %eax
	movl	%edx, -64(%ebp)
	subl	$4, %eax
	cmpl	%edx, %eax
	movl	%eax, -56(%ebp)
	jb	.L76
.L93:
	movl	-56(%ebp), %eax
	movl	(%eax), %eax
	movswl	20(%eax), %edx
	movl	%eax, -40(%ebp)
	movl	28(%eax), %eax
	movl	%edx, -32(%ebp)
	movl	-40(%ebp), %edx
	movl	%eax, -60(%ebp)
	movl	-40(%ebp), %eax
	movswl	24(%edx), %edx
	movswl	26(%eax), %eax
	testl	%edx, %edx
	movl	%edx, -48(%ebp)
	movl	%eax, -52(%ebp)
	jle	.L78
	movl	-60(%ebp), %edx
	movl	$0, -44(%ebp)
	movl	%edx, -28(%ebp)
	.p2align 4,,7
	.p2align 3
.L85:
	movl	-28(%ebp), %eax
	movl	-28(%ebp), %edx
	movl	20(%eax), %eax
	movl	%eax, -36(%ebp)
	movl	12(%edx), %esi
	testl	%esi, %esi
	jne	.L95
	jmp	.L79
	.p2align 4,,7
	.p2align 3
.L102:
	movl	-28(%ebp), %eax
	movl	%esi, 4(%esp)
	movl	%eax, (%esp)
	call	PipelineEffect_latencyWAW@PLT
.L82:
	movswl	20(%edi), %edx
	leal	(%eax,%edx), %edx
	cmpl	%edx, -32(%ebp)
	jge	.L83
	movl	%edx, -32(%ebp)
.L83:
	addw	$1, 22(%edi)
.L80:
	cmpl	-36(%ebp), %esi
	je	.L79
	movl	12(%esi), %esi
	testl	%esi, %esi
	je	.L79
.L95:
	movl	4(%esi), %edi
	cmpl	-40(%ebp), %edi
	je	.L80
	testb	$1, (%esi)
	jne	.L102
	movl	-28(%ebp), %edx
	movl	%esi, 4(%esp)
	movl	%edx, (%esp)
	call	PipelineEffect_latencyRAW@PLT
	jmp	.L82
	.p2align 4,,7
	.p2align 3
.L79:
	addl	$1, -44(%ebp)
	movl	-44(%ebp), %eax
	addl	$24, -28(%ebp)
	cmpl	%eax, -48(%ebp)
	jg	.L85
.L78:
	movl	-52(%ebp), %edx
	addl	-48(%ebp), %edx
	cmpl	%edx, -48(%ebp)
	movl	%edx, -52(%ebp)
	jge	.L86
	movl	-48(%ebp), %eax
	movl	-48(%ebp), %edx
	movl	-40(%ebp), %ecx
	addl	$1, %eax
	movl	%eax, -44(%ebp)
	leal	(%edx,%edx,2), %eax
	movl	-60(%ebp), %edx
	leal	(%edx,%eax,8), %eax
	movl	%eax, -28(%ebp)
	.p2align 4,,7
	.p2align 3
.L91:
	movl	-28(%ebp), %eax
	movl	12(%eax), %esi
	movl	20(%eax), %edx
	testl	%esi, %esi
	jne	.L94
	jmp	.L87
	.p2align 4,,7
	.p2align 3
.L88:
	cmpl	%edx, %esi
	je	.L87
.L103:
	movl	12(%esi), %esi
	testl	%esi, %esi
	.p2align 4,,4
	je	.L87
.L94:
	movl	4(%esi), %edi
	cmpl	%ecx, %edi
	je	.L88
	testb	$1, (%esi)
	je	.L88
	movl	-28(%ebp), %eax
	movl	%edx, -72(%ebp)
	movl	%ecx, -68(%ebp)
	movl	%esi, 4(%esp)
	movl	%eax, (%esp)
	call	PipelineEffect_latencyWAR@PLT
	movl	-72(%ebp), %edx
	movl	-68(%ebp), %ecx
	movl	%eax, -36(%ebp)
	movswl	20(%edi), %eax
	addl	-36(%ebp), %eax
	cmpl	%eax, -32(%ebp)
	jge	.L89
	movl	%eax, -32(%ebp)
.L89:
	addw	$1, 22(%edi)
	cmpl	%edx, %esi
	jne	.L103
	.p2align 4,,7
	.p2align 3
.L87:
	addl	$1, -44(%ebp)
	movl	-44(%ebp), %eax
	addl	$24, -28(%ebp)
	subl	$1, %eax
	cmpl	%eax, -52(%ebp)
	jg	.L91
.L86:
	movl	-40(%ebp), %edx
	movzwl	-32(%ebp), %eax
	subl	$4, -56(%ebp)
	movw	%ax, 20(%edx)
	movl	-64(%ebp), %edx
	cmpl	%edx, -56(%ebp)
	jae	.L93
.L76:
	addl	$76, %esp
	popl	%ebx
	popl	%esi
	popl	%edi
	popl	%ebp
	ret
	.size	Pipeline_makeCritical, .-Pipeline_makeCritical
	.section	.rodata.str1.4,"aMS",@progbits,1
	.align 4
.LC7:
	.string	"*** Pipeline schedule %d Instructions\n"
	.section	.rodata.str1.1
.LC8:
	.string	"    time=%d\t"
.LC9:
	.string	"scheduled\t"
.LC10:
	.string	"delayed \t"
	.text
	.p2align 4,,15
.globl Pipeline_schedule
	.type	Pipeline_schedule, @function
Pipeline_schedule:
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%edi
	pushl	%esi
	pushl	%ebx
	subl	$92, %esp
	movl	8(%ebp), %edx
	call	__i686.get_pc_thunk.bx
	addl	$_GLOBAL_OFFSET_TABLE_, %ebx
	movl	8(%ebp), %eax
	movl	8(%ebp), %ecx
	movl	44(%edx), %edx
	addl	$28, %eax
	movl	%eax, -48(%ebp)
	movl	%ecx, (%esp)
	movl	%edx, -64(%ebp)
	call	Pipeline_instructions@PLT
	movl	8(%eax), %esi
	movl	12(%eax), %edi
	cmpl	%edi, %esi
	jb	.L107
	jmp	.L105
	.p2align 4,,7
	.p2align 3
.L106:
	addl	$4, %esi
	cmpl	%edi, %esi
	jae	.L105
.L107:
	movl	(%esi), %eax
	cmpw	$0, 22(%eax)
	jne	.L106
	movswl	20(%eax), %edx
	addl	$4, %esi
	movswl	18(%eax), %ecx
	movl	%eax, 4(%esp)
	movl	-48(%ebp), %eax
	negl	%edx
	sall	$16, %ecx
	andl	$65535, %edx
	orl	%ecx, %edx
	movl	%edx, 8(%esp)
	movl	%eax, (%esp)
	call	PQueue_addEntry@PLT
	cmpl	%edi, %esi
	jb	.L107
.L105:
	movl	-48(%ebp), %edx
	movl	%edx, (%esp)
	call	PQueue_makeHeap@PLT
	movl	AIR_TRACE@GOT(%ebx), %ecx
	movl	(%ecx), %edx
	testl	%edx, %edx
	je	.L133
	movl	8(%ebp), %eax
	movl	4(%eax), %ecx
	movl	12(%ecx), %eax
	subl	8(%ecx), %eax
	movl	%edx, (%esp)
	sarl	$2, %eax
	movl	%eax, 8(%esp)
	leal	.LC7@GOTOFF(%ebx), %eax
	movl	%eax, 4(%esp)
	call	fprintf@PLT
.L133:
	leal	.LC8@GOTOFF(%ebx), %ecx
	leal	.LC10@GOTOFF(%ebx), %eax
	leal	.LC9@GOTOFF(%ebx), %edx
	movl	%ecx, -68(%ebp)
	movl	%eax, -76(%ebp)
	movl	%edx, -72(%ebp)
	.p2align 4,,7
	.p2align 3
.L142:
	movl	8(%ebp), %ecx
	movl	36(%ecx), %edx
	testl	%edx, %edx
	je	.L143
	movl	-48(%ebp), %edx
	movl	%edx, (%esp)
	call	PQueue_extractMin@PLT
	movl	AIR_TRACE@GOT(%ebx), %edx
	movzwl	18(%eax), %ecx
	movl	%eax, -28(%ebp)
	movzbl	9(%eax), %esi
	movswl	%cx, %eax
	movl	%eax, -40(%ebp)
	movl	(%edx), %eax
	movw	%cx, -58(%ebp)
	testl	%eax, %eax
	je	.L110
	movl	-40(%ebp), %ecx
	movl	-68(%ebp), %edx
	movl	%eax, (%esp)
	movl	%ecx, 8(%esp)
	movl	%edx, 4(%esp)
	call	fprintf@PLT
.L110:
	movl	-40(%ebp), %ecx
	andl	$255, %esi
	movl	-64(%ebp), %eax
	movl	%ecx, 4(%esp)
	movl	%eax, (%esp)
	call	ResourceTable_advance@PLT
	movl	-40(%ebp), %edx
	movl	-64(%ebp), %ecx
	movl	%esi, 4(%esp)
	movl	%edx, 8(%esp)
	movl	%ecx, (%esp)
	call	ResourceTable_fitReservation@PLT
	testb	%al, %al
	je	.L111
	movl	-28(%ebp), %eax
	movl	-28(%ebp), %edx
	movl	-28(%ebp), %ecx
	movl	28(%eax), %eax
	movswl	24(%edx), %edx
	movl	%eax, -36(%ebp)
	movswl	26(%ecx), %eax
	movl	%edx, -52(%ebp)
	addl	%edx, %eax
	cmpl	%eax, %edx
	movl	%eax, -56(%ebp)
	jge	.L112
	addl	$1, %edx
	movl	-36(%ebp), %ecx
	movl	%edx, -44(%ebp)
	movl	-52(%ebp), %edx
	leal	(%edx,%edx,2), %eax
	leal	(%ecx,%eax,8), %eax
	movl	%eax, -32(%ebp)
	.p2align 4,,7
	.p2align 3
.L117:
	movl	-32(%ebp), %eax
	movl	12(%eax), %esi
	movl	20(%eax), %edx
	testl	%esi, %esi
	jne	.L135
	jmp	.L113
	.p2align 4,,7
	.p2align 3
.L114:
	cmpl	%edx, %esi
	je	.L113
.L144:
	movl	12(%esi), %esi
	testl	%esi, %esi
	.p2align 4,,4
	je	.L113
.L135:
	movl	4(%esi), %edi
	cmpl	-28(%ebp), %edi
	je	.L114
	testb	$1, (%esi)
	je	.L114
	movl	-32(%ebp), %ecx
	movl	%edx, -80(%ebp)
	movl	%esi, 4(%esp)
	movl	%ecx, (%esp)
	call	PipelineEffect_latencyWAR@PLT
	movswl	18(%edi), %ecx
	movl	-80(%ebp), %edx
	addl	-40(%ebp), %eax
	cmpl	%ecx, %eax
	jge	.L115
	movl	%ecx, %eax
.L115:
	movzwl	22(%edi), %ecx
	movw	%ax, 18(%edi)
	subl	$1, %ecx
	testw	%cx, %cx
	movw	%cx, 22(%edi)
	jne	.L114
	movswl	20(%edi), %ecx
	sall	$16, %eax
	movl	%edx, -80(%ebp)
	movl	%edi, 4(%esp)
	negl	%ecx
	andl	$65535, %ecx
	orl	%ecx, %eax
	movl	%eax, 8(%esp)
	movl	-48(%ebp), %eax
	movl	%eax, (%esp)
	call	PQueue_insert@PLT
	movl	-80(%ebp), %edx
	cmpl	%edx, %esi
	jne	.L144
	.p2align 4,,7
	.p2align 3
.L113:
	addl	$1, -44(%ebp)
	movl	-44(%ebp), %eax
	addl	$24, -32(%ebp)
	subl	$1, %eax
	cmpl	%eax, -56(%ebp)
	jg	.L117
.L112:
	movl	-52(%ebp), %ecx
	testl	%ecx, %ecx
	jle	.L118
	movl	$0, -44(%ebp)
	.p2align 4,,7
	.p2align 3
.L125:
	movl	-36(%ebp), %edx
	movl	-36(%ebp), %ecx
	movl	20(%edx), %edx
	movl	%edx, -32(%ebp)
	movl	12(%ecx), %esi
	testl	%esi, %esi
	jne	.L134
	jmp	.L119
	.p2align 4,,7
	.p2align 3
.L146:
	movl	-36(%ebp), %eax
	movl	%esi, 4(%esp)
	movl	%eax, (%esp)
	call	PipelineEffect_latencyWAW@PLT
.L122:
	movswl	18(%edi), %edx
	addl	-40(%ebp), %eax
	cmpl	%edx, %eax
	jge	.L123
	movl	%edx, %eax
.L123:
	movzwl	22(%edi), %edx
	movw	%ax, 18(%edi)
	subl	$1, %edx
	testw	%dx, %dx
	movw	%dx, 22(%edi)
	je	.L145
.L120:
	cmpl	-32(%ebp), %esi
	je	.L119
.L147:
	movl	12(%esi), %esi
	testl	%esi, %esi
	je	.L119
.L134:
	movl	4(%esi), %edi
	cmpl	-28(%ebp), %edi
	je	.L120
	testb	$1, (%esi)
	jne	.L146
	movl	-36(%ebp), %edx
	movl	%esi, 4(%esp)
	movl	%edx, (%esp)
	call	PipelineEffect_latencyRAW@PLT
	jmp	.L122
	.p2align 4,,7
	.p2align 3
.L145:
	movswl	20(%edi), %edx
	sall	$16, %eax
	movl	-48(%ebp), %ecx
	movl	%edi, 4(%esp)
	negl	%edx
	andl	$65535, %edx
	orl	%edx, %eax
	movl	%eax, 8(%esp)
	movl	%ecx, (%esp)
	call	PQueue_insert@PLT
	cmpl	-32(%ebp), %esi
	jne	.L147
	.p2align 4,,7
	.p2align 3
.L119:
	addl	$1, -44(%ebp)
	movl	-44(%ebp), %eax
	addl	$24, -36(%ebp)
	cmpl	%eax, -52(%ebp)
	jg	.L125
.L118:
	movl	-28(%ebp), %edx
	movzwl	-58(%ebp), %ecx
	movw	%cx, 16(%edx)
	movl	AIR_TRACE@GOT(%ebx), %edx
	movl	(%edx), %eax
	testl	%eax, %eax
	je	.L142
	movl	-72(%ebp), %ecx
	movl	%eax, 12(%esp)
	movl	$10, 8(%esp)
	movl	$1, 4(%esp)
	movl	%ecx, (%esp)
	call	fwrite@PLT
.L127:
	movl	AIR_TRACE@GOT(%ebx), %edx
	movl	(%edx), %eax
	testl	%eax, %eax
	je	.L142
	movl	-28(%ebp), %ecx
	movl	$0, 8(%esp)
	movl	%eax, 4(%esp)
	movl	%ecx, (%esp)
	call	Instruction_pretty@PLT
	testb	%al, %al
	je	.L142
	movl	AIR_TRACE@GOT(%ebx), %edx
	movl	(%edx), %eax
	movl	$10, (%esp)
	movl	%eax, 4(%esp)
	call	fputc@PLT
	jmp	.L142
	.p2align 4,,7
	.p2align 3
.L111:
	movl	-28(%ebp), %ecx
	movl	-40(%ebp), %esi
	movswl	20(%ecx), %edx
	addl	$1, %esi
	movl	%esi, %eax
	sall	$16, %eax
	negl	%edx
	andl	$65535, %edx
	orl	%edx, %eax
	movl	%eax, 8(%esp)
	movl	-48(%ebp), %eax
	movl	%ecx, 4(%esp)
	movl	%eax, (%esp)
	call	PQueue_insert@PLT
	movl	AIR_TRACE@GOT(%ebx), %ecx
	movl	-28(%ebp), %edx
	movl	(%ecx), %eax
	movw	%si, 18(%edx)
	testl	%eax, %eax
	je	.L142
	movl	%eax, 12(%esp)
	movl	-76(%ebp), %eax
	movl	$9, 8(%esp)
	movl	$1, 4(%esp)
	movl	%eax, (%esp)
	call	fwrite@PLT
	jmp	.L127
.L143:
	addl	$92, %esp
	popl	%ebx
	popl	%esi
	popl	%edi
	popl	%ebp
	ret
	.size	Pipeline_schedule, .-Pipeline_schedule
	.section	.rodata.str1.1
.LC11:
	.string	"Pipeline:\n"
.LC12:
	.string	"    critical=%d\tpredcount=%d\t"
	.text
	.p2align 4,,15
.globl Pipeline_pretty
	.type	Pipeline_pretty, @function
Pipeline_pretty:
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%edi
	pushl	%esi
	pushl	%ebx
	subl	$44, %esp
	movl	12(%ebp), %esi
	call	__i686.get_pc_thunk.bx
	addl	$_GLOBAL_OFFSET_TABLE_, %ebx
	testl	%esi, %esi
	je	.L153
.L149:
	movl	12(%ebp), %eax
	movl	$10, 8(%esp)
	movl	$1, 4(%esp)
	movl	%eax, 12(%esp)
	leal	.LC11@GOTOFF(%ebx), %eax
	movl	%eax, (%esp)
	call	fwrite@PLT
	movl	8(%ebp), %eax
	movl	%eax, (%esp)
	call	Pipeline_instructions@PLT
	movl	8(%eax), %esi
	movl	12(%eax), %eax
	cmpl	%eax, %esi
	movl	%eax, -28(%ebp)
	jae	.L150
	leal	.LC12@GOTOFF(%ebx), %eax
	movl	%eax, -32(%ebp)
	.p2align 4,,7
	.p2align 3
.L151:
	movl	(%esi), %edi
	addl	$4, %esi
	movswl	22(%edi), %eax
	movl	%eax, 12(%esp)
	movswl	20(%edi), %eax
	movl	%eax, 8(%esp)
	movl	-32(%ebp), %eax
	movl	%eax, 4(%esp)
	movl	12(%ebp), %eax
	movl	%eax, (%esp)
	call	fprintf@PLT
	movl	12(%ebp), %eax
	movl	$0, 8(%esp)
	movl	%edi, (%esp)
	movl	%eax, 4(%esp)
	call	Instruction_pretty@PLT
	movl	12(%ebp), %eax
	movl	$10, (%esp)
	movl	%eax, 4(%esp)
	call	fputc@PLT
	cmpl	-28(%ebp), %esi
	jb	.L151
.L150:
	addl	$44, %esp
	movl	$1, %eax
	popl	%ebx
	popl	%esi
	popl	%edi
	popl	%ebp
	ret
	.p2align 4,,7
	.p2align 3
.L153:
	movl	stderr@GOT(%ebx), %eax
	movl	(%eax), %eax
	movl	%eax, 12(%ebp)
	jmp	.L149
	.size	Pipeline_pretty, .-Pipeline_pretty
	.comm	escape,4,4
	.section	.text.__i686.get_pc_thunk.bx,"axG",@progbits,__i686.get_pc_thunk.bx,comdat
.globl __i686.get_pc_thunk.bx
	.hidden	__i686.get_pc_thunk.bx
	.type	__i686.get_pc_thunk.bx, @function
__i686.get_pc_thunk.bx:
	movl	(%esp), %ebx
	ret
	.ident	"GCC: (SUSE Linux) 4.5.1 20101208 [gcc-4_5-branch revision 167585]"
	.section	.comment.SUSE.OPTs,"MS",@progbits,1
	.string	"OspWg"
	.section	.note.GNU-stack,"",@progbits
