#ifndef PRO_INCLUDED
#define PRO_INCLUDED

/*
 * Set PRO_OPTIMIZE according to __OPTIMIZE__ (defined by gcc and icc) and NDEBUG.
 */
#ifdef __OPTIMIZE__
# ifndef PRO_OPTIMIZE
#  ifdef NDEBUG
#    define PRO_OPTIMIZE 3
#  else//!NDEBUG
#    define PRO_OPTIMIZE 2
#  endif//NDEBUG
# endif//PRO_OPTIMIZE
#else//!__OPTIMIZE__
# ifndef PRO_OPTIMIZE
#  ifdef NDEBUG
#    define PRO_OPTIMIZE 1
#  else//!NDEBUG
#    define PRO_OPTIMIZE 0
#  endif//NDEBUG
# endif//PRO_OPTIMIZE
#endif//__OPTIMIZE__

#endif//PRO_INCLUDED

