#ifndef Memory__h_INCLUDED
#define Memory__h_INCLUDED

//
#include "BSL/Memory.h"

/*
 * MemoryTable_insert --	Insert a MemoryTableEntry into this MemoryTable.
 */
void
MemoryTable_insert(MemoryTable this, MemoryTableEntry entry);

/*
 * Memory_INIT --	Initialize the Memory module.
 */
void
Memory_INIT(void);

/*
 * Memory_FINI --	Finalize the Memory module.
 */
void
Memory_FINI(void);


#endif//Memory__h_INCLUDED
