#ifndef IETree__h_INCLUDED
#define IETree__h_INCLUDED

//
#include "CCL/IETree.h"

/*
 * IETree_splitMin --	Remove the minimum interval under node.
 */
IETreeNode
IETree_splitMin(IETree this, IETreeNode node);

/*
 * IETree_splitMax --	Remove the maximum interval under node.
 */
IETreeNode
IETree_splitMax(IETree this, IETreeNode node);

/*
 * IETree_mergeNode --	Merge the LEFT and RIGHT subtrees of node.
 */
IETreeNode
IETree_mergeNode(IETree this, IETreeNode node);

/*
 * IETree_INIT --	Initialize the IETree module.
 */
#define IETree_INIT()

/*
 * IETree_FINI --	Finalize the IETree module.
 */
#define IETree_FINI()


#endif//IETree__h_INCLUDED
