#ifndef LIR__h_INCLUDED
#define LIR__h_INCLUDED

//
#include "LIR/LIR.h"

//
#include "LIR/Optimize_.h"
#include "LIR/Configure_.h"
#include "LIR/Temporary_.h"
#include "LIR/Operation_.h"
#include "LIR/Variable_.h"
#include "LIR/Selector_.h"
#include "LIR/BasicBlock_.h"
#include "LIR/Dependence_.h"
#include "LIR/LoopScope_.h"
#include "LIR/CodeRegion_.h"
#include "LIR/Procedure_.h"
#include "LIR/Program_.h"

/*
 * LIR_Test --	Setup and execute a LIR test.
 */
void
LIR_Test(void (*test)(void));


#endif//LIR__h_INCLUDED
