#ifndef Convention__h_INCLUDED
#define Convention__h_INCLUDED

//
#include "MDS/Convention.h"

//
typedef enum {
#define Convention(NAME, RESERVED, ARGUMENT, RESULT, STRUCT, CALLER, CALLEE, PROGRAM, \
                   RETURN, STACK, STATIC, FRAME, GLOBAL, LOCAL, WIRED, ZERO, ONE, \
                   ALIGNTEXT, ALIGNDATA, ALIGNHEAP, ALIGNSTACK, \
                   NATIVEINT, NATIVEUINT, NATIVEFLOAT, NATIVEPTR) \
  Convention_##NAME,
  Convention_,
#include /*MDS*/"Convention.enum"
  Convention__
#undef Convention
} enum_Convention;

//
// DEPRECATED! This array entries are oudated when register sets are dynamically adjusted.
extern const RegisterList_
Convention_RoleRegisterLists[Convention__][ConventionRole__];
#define Convention_argumentRegisterList(this) \
  (&Convention_RoleRegisterLists[this][ConventionRole_Argument])
#define Convention_resultRegisterList(this) \
  (&Convention_RoleRegisterLists[this][ConventionRole_Result])

/*
 * Convention_setRole --	Set a Register ConventionRole for this Convention.
 */
void
Convention_setRole(Convention this, ConventionRole role, Register registre);

/*
 * Convention_INIT --	Initialize the Convention module.
 */
void
Convention_INIT(void);

/*
 * Convention_FINI --	Finalize the Convention module.
 */
#define Convention_FINI()


#endif//Convention__h_INCLUDED
