#ifndef Immediate__h_INCLUDED
#define Immediate__h_INCLUDED

//
#include "MDS/Immediate.h"

//
typedef enum {
#define Immediate(NAME, MINVALUE, MAXVALUE, SIGNED, RELOCATIONS, ENCODE, DECODE) \
  Immediate_##NAME,
  Immediate_,
#include /*MDS*/"Immediate.enum"
  Immediate__
#undef Immediate
} enum_Immediate;

/*
 * ImmediateEncode functions.
 */
#define ENCODE(e) e
#define Immediate(NAME, MINVALUE, MAXVALUE, SIGNED, RELOCATIONS, ENCODE, DECODE) \
static inline OperandEncoded \
ImmediateEncode_##NAME(OperandDecoded decoded) \
{ \
  ImmediateConstant __constant = (ImmediateConstant)decoded; \
  ImmediateValue VALUE = ImmediateConstant_VALUE(__constant); \
  { ENCODE; } \
  return (OperandEncoded)VALUE; \
}
#include "Immediate.enum"
#undef ENCODE

/*
 * Immediate_INIT --	Initialize the Immediate module.
 */
#define Immediate_INIT()

/*
 * Immediate_FINI --	Finalize the Immediate module.
 */
#define Immediate_FINI()


#endif//Immediate__h_INCLUDED
